package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.lang.ref.Reference;
import java.lang.ref.SoftReference;

import java.lang.reflect.Array;
import java.net.URL;
import java.util.*;
import java.lang.reflect.Method;
import java.util.List;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.TreePath;
import static charite.christo.ChConstants.*;
import static java.awt.event.KeyEvent.*;
import static java.awt.event.MouseEvent.*;
import static java.lang.Boolean.TRUE;
import static java.lang.Boolean.FALSE;
import static java.lang.System.*;
/**
   Static utility methods.
   @author Christoph Gille
*/
public final class ChUtils implements ChRunnable, ChProcessEvent {
    private final static Object KEY_ORIG_FONT_SIZE="CUs$$_25", SYNC_BA=new Object(), SYNC_FASTEST_P=new Object();
    final static Object
    KEY_EVENT_SOURCE=new Object(),
        KEY_TOGGLE_COLLAPSE[]={new Object(),new Object()};
    public final static String
    USER_DOT_HOME="user.home",
        KEY_MENU_ITEM_TARGET="CU$11",  KEY_DRAG="CUs$$_26",
        SCROLLABLE_TRACKS_VIEWPORT_WIDTH="CUs$$_19",
        SCROLLABLE_TRACKS_VIEWPORT_HEIGHT="CUs$$_20",
        KEY_JUST_WRITING_PNG="CUs$$_27",
        PROP_NMR_ONLY_FIRST_MODEL="NMR_ONLY_FIRST_MODEL",
        STRAP_PACKAGES[]={_CC,_CCP,_CCS,_CCSSC,_CCSE,_CC+"hotswap.",_CC+"interfaces.",_CCS+"hotswap.",_CCS+"interfaces.",_CC+"metannogen."},
        TRUSTED_PLUGINS[]={"http://www.bioinformatics.org/strap/plugins/"},
        COMPRESS_SUFFIX[]={".gz",".z",".GZ",".Z",".bz2"},
        JPG_PNG_GIF_BMP[]={".jpeg",".jpg",".png",".gif",".bmp",".JPEG",".JPG",".PNG",".GIF",".BMP"},
        NO_STRING[]={},
        ERROR_STRING=new String();
    protected final static String
    SOME_HTML_TAGS[]={"</span>","</div>","<br>","<hr>","<h1>","<h2>","<h3>","<pre>","<li>","<b>","<del>","<u>","<i>","<center>","<sup>","<sub>","</font>","</a>","</pre>","<img src=\"","<head>"},
        SOME_CLOSING_HTML_TAGS[]={"</h1>","</h2>","</h3>","</li>","</b>","</u>","</i>","</pre>","</center>","</sup>","</sub>","</head>"};
    public final static Object
    NO_OBJECT[]={}, ERROR_OBJECT="CUs$$ERROR_OBJECT",
        KEY_CONTEXT_OBJECTS[]=new Object[3],
        SYNC_CPY=new Object();
    public final static int
    SYSP_OS_ARCH=1,
        SYSP_OS_NAME=2,
        SYSP_OS_VERSION=3,
        SYSP_JAVA_VERSION=4,
        SYSP_JAVA_HOME=5,
        SYSP_JAVA_CLASS_PATH=6,
        SYSP_USER_NAME=7,
        SYSP_USER_HOME=8,
        SYSP_USER_DIR=9,
        SYSP_PATH_SEPARATOR=10,
        SYSP_ICON_FILE_BROWSER=11,
        SYSP_NAME_FILE_BROWSER=12,
        SYSP_BIN_JAVA=13,

        IS_WINDOWS=20,
        IS_LINUX=21,
        IS_MAC=22,
        IS_86=23,
        IS_LINUX386=24,
        IS_WINDOWS_95_FAMILY=25,
        IS_WEBSTARTED=26,
        IS_OPENJDK=27;
    private final static int IS_SYSTP_COUNT=28,  SYSP_COUNT=14;
    public final static Component[] NO_COMPONENT={};
    public final static Class[] NO_CLASS={};
    public final static Map[] NO_MAP={};
    public final static Map.Entry[] NO_MAP_ENTRY={};
    public final static URL NO_URL[]={}, ERROR_URL;
    static { URL u=null; try { u=new URL("http://www.sun.com");} catch(Exception e){assert false;} ERROR_URL=u; }
    public final static byte[] NO_BYTE={}, NO_BYTE_ARRAY[]={};
    public final static int[] NO_INT={};
    public final static long[] NO_LONG={};

  public final static boolean[] NO_BOOLEAN={}, ERR_BOOLEAN={},  CAN_BE_STOPPED={}, FALSE_TRUE={false,true};
    public final static float[] NO_FLOAT={};
    public final static File NO_FILE[]={}, ERROR_FILE=new File("___");
    public final static Map.Entry[] NO_Entry={};
    public final static ClassLoader CLASSLOADER=ChUtils.class.getClassLoader();
    public final static List<Class> NOT_AVAILABLE_CLASSES=new ArrayList();
    public final static WeakHashMap<Icon,String> vMaliciousIcons=new WeakHashMap();
    public final static int SB_TIP=1, SB_TOSTRG=2, SB_DEC_FORMAT=3, SB_FLOAT_FORMAT=4, SB_REND_COMP=5;
    private final static int  SB_TIP_PROVIDER=6;
    private final static StringBuffer[] strBuf=new StringBuffer[10];
    public static StringBuffer strBuf(int i) {
        if (strBuf[i]==null) strBuf[i]=new StringBuffer();
        strBuf[i].setLength(0);
        return strBuf[i];
    }
    private static ByteArray[] _byteArr;
    public static ByteArray byteArr(int i) {
        if (_byteArr==null) _byteArr=new ByteArray[10];
        if (_byteArr[i]==null) _byteArr[i]=new ByteArray(99);
        return _byteArr[i].setEnd(0);
    }
    private ChUtils() {}
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Msg  >>> */
    private final static Set vErrorAlreadyReported=new HashSet();
    public final static void logMsg(ChRunnable log,  Object o) {
        if (log!=null && o!=null) log.run(ChRunnable.APPEND, o);
    }
    public final static void logMsg(ChRunnable log,  Object...oo) {
        if (log!=null && sze(oo)>0) log.run(ChRunnable.APPEND, oo);
    }
    public static void error(long frameOpt, CharSequence s) {
        if (isGraphicsAvailable()) ChMsg.showError(frameOpt,s, (JComponent)null);
        else putln(RED_ERROR,s);
    }
    public static void error(CharSequence s) { error(0L,s); }
    public static void errorAC(CharSequence s) { error(ChFrame.AT_CLICK,s); }
    public static void error(long frameOpt, String s,JComponent jc) { ChMsg.showError(frameOpt,s,jc);}
    public static void error(long frameOpt, Throwable err,String msg) {
        if (isGraphicsAvailable()) {
            if (err instanceof OutOfMemoryError) {
                System.gc();
                System.gc();
                error("Caught OutOfMemoryError <br>"+
                      "Increase memory of the Java Runtime Environment and try again.<br><br>DETAILS:<br>"+msg+"<br><br>"+
                      stackTrceAsStrg(err)
                      );
            }
        }
        else putln(RED_ERROR,msg,"\n",err);
    }
    /* <<< Msg <<< */
    /* ---------------------------------------- */
    /* >>> Debug >>> */
    public final static long TIME_AT_START=currentTimeMillis();
    public static String dateOfCompilation() {
        final String date=toStrg(readStrg(rscAsStream(_CC,"dateOfCompilation.rsc")));
        return date!=null ?date : "?????";
    }
    private static Boolean isMyComputer;
    public static boolean isMyComputer() {
        if (isMyComputer==null) {
            try {
                isMyComputer=new File("/tmp/meine_IP_Nummer.txt").exists() ? TRUE : FALSE;
            } catch(Throwable ex) {isMyComputer=FALSE;}
        }
        return isMyComputer==TRUE;
    }
    public static boolean debug(Object msg) {
        if (msg==TRUE) isMyComputer=TRUE;
        if (isMyComputer()) { puts(msg); return true; } return false;
    }
    public static boolean debugTime(CharSequence msg, long time) {
        if (debug("debugTime ")) {
            puts(msg);
            out.print(' ');
            out.println(currentTimeMillis()-time);
            return true;
        }
        return false;
    }

    public static void stckTrc() {
        stckTrc(new Exception("My stack trace"));
    }
    public static void stckTrc(Throwable e) { stckTrc(e,System.out);}
    public static void stckTrcErr(Throwable e) { stckTrc(e,System.err);}
    public static void stckTrc(Throwable e, PrintStream stream) {

        final ChDelay current=deref(Thread.currentThread(), ChDelay.class);
        final String stckTrc=current==null?null:current.stckTrc;
        if (stckTrc!=null) {
            putln(ANSI_GREEN,stckTrc,ANSI_RESET);
        }

        if (e!=null) {
            stream.println("\n\nCaught stckTrc "+e+"\n");
            e.printStackTrace(stream);
            try{
                stckTrc(e.getCause(), stream);
            } catch(Exception ex){}
            stream.print("\n");
        }
    }
    public static String stackTrceAsStrg(Throwable t) {
        ByteArrayOutputStream os=new  ByteArrayOutputStream();
        if (t==null) t=new Throwable();
        t.printStackTrace(new PrintStream(os));
        return os.toString();
    }
    private static boolean logFinalize;
    public static void logFinalize(String txt,Object o){
        if (txt=="TRUE") logFinalize=true;
        if (!logFinalize) return;
        out.print(txt);
        out.print(ANSI_RESET);
        if (o!=null) { puts(" "); puts(o instanceof Class ? shrtClasNam((Class)o) : o); puts(" "); }
    }
    /* <<< Debug <<< */
    /* ---------------------------------------- */
    /* >>> Properties >>> */
    private final static String[] systProprty=new String[SYSP_COUNT];
    public static String sysGetProp(String key) {
        ChClassLoader.setSecurityPolicy();
        try {
            String s=System.getProperty(key);
            return s!=null ? s.intern() : "";
        } catch(Throwable e){ putln(e);}
        return "";
    }
    public static boolean isWindows() { return isSystProprty(IS_WINDOWS);}
    public static boolean isMacintosh() { return isSystProprty(IS_MAC);}
    public static String systProprty(int i) {
        String p=systProprty[i];
        if (p==null) {
            switch(i){
            case SYSP_OS_ARCH: p=sysGetProp("os.arch"); break;
            case SYSP_OS_NAME: p=sysGetProp("os.name"); break;
            case SYSP_OS_VERSION: p=sysGetProp("os.version"); break;
            case SYSP_JAVA_VERSION: p=sysGetProp("java.version"); break;
            case SYSP_JAVA_HOME: p=sysGetProp("java.home"); break;
            case SYSP_BIN_JAVA: p=sysGetProp("java.home")+"/bin/java"+(isWindows() ? ".exe":""); break;
            case SYSP_JAVA_CLASS_PATH: p=sysGetProp("java.class.path"); break;
            case SYSP_USER_NAME: p=sysGetProp("user.name"); break;
            case SYSP_USER_HOME:
                synchronized(USER_DOT_HOME) {
                    p=sysGetProp(USER_DOT_HOME);
                    if (sze(p)==0 || p.indexOf('%')>=0) {
                        p=ChMsg.askUserHome(p);
                        if (p==null) System.exit(99);
                        mkdrs(new File(toStrgTrim(p)));
                    }
                }
                break;
            case SYSP_USER_DIR: p=sysGetProp("user.dir"); break;
            case SYSP_PATH_SEPARATOR: p=sysGetProp("path.separator"); break;
            case SYSP_ICON_FILE_BROWSER: p=isMacintosh() ? IC_MAC_FINDER : IC_DIRECTORY; break;
            case SYSP_NAME_FILE_BROWSER: p=isMacintosh() ? "Finder" : isWindows() ? "Explorer" : "native file browser"; break;
            }
            systProprty[i]=p;
        }
        return p!=null ? p : "";
    }
    public static String urlOfBinariesForThisOS() {
        final String dir=isSystProprty(IS_LINUX386) ? "linux386" : isWindows() ? "windows" :   isMacintosh() ? (isSystProprty(IS_86) ? "macIntel" : "mac") : null;
        return dir!=null ? URL_STRAP+"/Binaries/"+dir+"/" : null;
    }
    public static String dirJavaws() { return sysGetProp("java.home")+File.separatorChar+(javaVsn()==14 ? "javaws" : "bin")+File.separatorChar;  }
    public static String jControl() { return (isWindows() ? (javaVsn()==14 ? "javaws.exe" : "javacpl.exe") : (javaVsn()==14 ? "javaws" : "ControlPanel"));}
    public static String fileJcontrol() { return dirJavaws()+jControl(); }
    public static String msgJcontrol() {
        return
            "The tool "+fileJcontrol()+" in "+dirJavaws()+" is used for three important settings:  \n"+
            "1. The Web-proxy controls how STRAP connects to the Internet. A wrong setting may be the reason why STRAP cannot download files. \n"+
            "2. The console can be opened. It shows the standard output (stdout). \n"+
            "3. Javaws can use different Java verions, 1.4, 1.5 or 1.6, which can be selected.\n"+
            "A wrong setting can be the reason why still 1.4 is used though 1.6 is also installed.\n";
    }
    private static byte[] isSystProprty=new byte[IS_SYSTP_COUNT];
    public static boolean isSystProprty(int i) {
        int is=isSystProprty[i];
        if (is==0) {
            final boolean b;
            switch(i) {
            case IS_WINDOWS: b=systProprty(SYSP_OS_NAME).toLowerCase().indexOf("windows")>=0; break;
            case IS_LINUX: b=systProprty(SYSP_OS_NAME).toLowerCase().indexOf("linux")>=0; break;
            case IS_MAC: b=systProprty(SYSP_OS_NAME).toLowerCase().indexOf("mac")>=0; break;
            case IS_86: b=systProprty(SYSP_OS_ARCH).indexOf("86")>=0 || systProprty(SYSP_OS_ARCH).toLowerCase().indexOf("amd64")>=0; break;
            case IS_LINUX386: b=isSystProprty(IS_LINUX) && isSystProprty(IS_86); break;
            case IS_WINDOWS_95_FAMILY:
                final String v=isWindows() ? systProprty(SYSP_OS_VERSION) : "";
                b=v.indexOf("95")>=0 || v.indexOf("98")>=0 || v.indexOf("ME")>=0; break;
            case IS_WEBSTARTED: b=CLASSLOADER.toString().indexOf("JNLP")>=0; break;
            case IS_OPENJDK: b=equls(STRSTR_IC, "OpenJDK", System.getProperty("java.vm.name")); break;
            default: b=false;
            }
            is=isSystProprty[i]=(byte)(b?'t':'f');
        }
        return 't'==is;
    }
    public static String winDotExe() { return isWindows() ? ".exe" : ""; }
    private static int _javaVsn=-1;
    public static int javaVsn() {
        if (_javaVsn<0) {
            final String s=systProprty(SYSP_JAVA_VERSION);
            final int dot=s!=null ? s.indexOf('.') : 0;
            if (dot>0) _javaVsn=10*atoi(s)+chrAt(dot+1,s)-'0';
            if (_javaVsn<14) {
                _javaVsn=15;
                assert false;
            }
        }
        return _javaVsn;
    }
    private static ChRunnable[] runIfHigher=new ChRunnable[99];
    public static ChRunnable forJavaVersionHigher(int version) {
        ChRunnable r=runIfHigher[16];
        if (r==null) {
            int compileMe=RunIf16orHigher.COMPILE_ME;
            if (javaVsn()>15) {
                final Class c=name2class(_CC+"RunIf"+version+"orHigher");
                if (c!=null) try { r=(ChRunnable)c.newInstance(); } catch(Exception e){}
                assertNotNull(r);
            }
            if (r==null) r=instance(0);
            runIfHigher[version]=r;
        }
        return r;
    }
    private static URL[] _cpAtStart;
    public static URL[] classPathAtStart() {
        if (_cpAtStart==null) {
            final List<URL> v=new ArrayList();
            //if (IS_JAVA1_6) {    //_classpathsV.add(URL_THIS_JAR_FILE);     }
            final StringTokenizer st=new StringTokenizer(systProprty(SYSP_JAVA_CLASS_PATH),systProprty(SYSP_PATH_SEPARATOR));
            while(st.hasMoreTokens()) adUniq(url(file(st.nextToken())),v);
            adUniq(url(dirPlugins()),v);
            adUniq(url(dirSettings()),v);
            _cpAtStart=toArry(v,URL.class);
        }
        return _cpAtStart;
    }

    /* <<< Properties <<< */
    /* ---------------------------------------- */
    /* >>> Object pools >>> */
    private static Reference<Map<String,Map<Thread,ByteArray>>> refMapByteArray;
    public static ByteArray getByteArray(String id, long size_) {
        final int size=(int)size_;
        Thread t=Thread.currentThread();
        synchronized(SYNC_BA) {
            Map<String,Map<Thread,ByteArray>>  map=(Map)deref(refMapByteArray);
            if (map==null) refMapByteArray=new SoftReference(map=new WeakHashMap());
            Map<Thread,ByteArray> m=map.get(id);
            if (m==null) map.put(id,m=new WeakHashMap());
            ByteArray ba=m.get(t);
            if (ba==null) m.put(t,ba=new ByteArray(size));
            else {
                final byte[] bb=ba.getBytes();
                if (size> sze(bb)) ba.set(new byte[size],0,0);
            }
            return ba;
        }
    }
    /* --- Pool of Dimension objects --- */
    private final static int DIM=100, dimX[]=new int[DIM], dimY[]=new int[DIM];
    private final static Dimension[] dim=new Dimension[DIM];
    private static int dimCount;
    public static Dimension dim(final int x, final int y) {
        final int count, xx[]=dimX, yy[]=dimY;
        {
            final int c=dimCount;
            count=c<DIM ? c:0;
        }
        Dimension d=null;
        for(int i=count; --i>=0;) {
            if (x==xx[i] && y==yy[i]) {
                d=dim[i];
                if (d!=null) {
                    assert d.width==x && d.height==y;
                    d.setSize(x,y);
                    return d;
                }
            }
        }
        if (d==null) {
            d=new Dimension(x,y);
            dim[count]=d;
            xx[count]=x;
            yy[count]=y;
            dimCount=count+1;
        }
        return d;
    }
    /* --- Pool of Colors --- */
    private final static int COLORS=100, colorRGBA[]=new int[COLORS];
    private final static Color[] colors=new Color[COLORS];
    private static int colorCount;
    public static Color C(final int rgb, int a) { return C_(rgb|(a<<24)); }
    public static Color C(final int rgb) { return C_(rgb|(255<<24)); }
    private static Color C_(final int rgba ) {

        final int count, rgbas[]=colorRGBA;
        {
            final int c=colorCount;
            count=c<COLORS ? c:0;
        }
        Color c=null;
        for(int i=count; --i>=0;) {
            if (rgba==rgbas[i]) {
                c=colors[i];
                assertNotNull(c);
                if (c!=null)  return c;
            }
        }
        if (c==null) {
            c=colors[count]=new Color(rgba,true);
            rgbas[count]=rgba;
            colorCount=count+1;
        }
        return c;
    }
    /* --- pool of Integer --- */
    private static Integer[] _INTEGER=new Integer[333];
    public static Object intObjct(int i) {
        if (i>=0 && i<_INTEGER.length) {
            if (_INTEGER[i]==null) return _INTEGER[i]=new Integer(i);
            return _INTEGER[i];
        }
        return new Integer(i);
    }
    public static Object boolObjct(boolean b) { return b?TRUE:FALSE;}
    public static Object longObjct(long i) { return new Long(i);}
    private static Character charObjct[]=new Character[256];
    public static Object charObjct(char i) {
        if (i<charObjct.length) {
            if (charObjct[i]==null) charObjct[i]=new Character(i);
            return charObjct[i];
        }
        return new Character(i);
    }
    /* <<< Object pools <<< */
    /* ---------------------------------------- */
    /* >>> JMenu >>> */

    public static JComponent findMenuItem(String label, JMenu menu) {
        for(int j=menu==null?0:menu.getItemCount();--j>=0;) {
            final JMenuItem item=menu.getItem(j);
            if (item!=null && label.equalsIgnoreCase(item.getText())) return item;
        }
        return null;
    }
    public static JMenuBar menuBar2j(MenuBar mb, String[][] rplcMenuItems) {
        if (mb==null) return null;
        final JMenuBar jmb=new JMenuBar();
        for(int i=0;i<mb.getMenuCount(); i++) jmb.add(new ChJMenu().setAwtMenu(mb.getMenu(i),rplcMenuItems));
        return jmb;
    }
    public static void setHeavy(Component c) {
        final JPopupMenu pop=c instanceof JPopupMenu ? (JPopupMenu)c : null;
        if (pop!=null) pop.setLightWeightPopupEnabled(false);
        else if (c instanceof JMenu) {
            final JMenu jm=(JMenu)c;
            for(int i=jm.getItemCount(); --i>=0;) {
                final JMenuItem item=jm.getItem(i);
                if (item instanceof JMenu) setHeavy(item);
            }
            setHeavy( ((JMenu)c).getPopupMenu());
        }
        else if (c instanceof JMenuBar) {
            final JMenuBar mb=(JMenuBar)c;
            for(int i=mb.getMenuCount(); --i>=0;) setHeavy(mb.getMenu(i));
        } else for(Component child : childs(c)) setHeavy(child);
    }
    public static void removeMenuItems(String[] menus, String items[], JMenuBar menubar) {
        if (menubar==null) return;
        for(String menu : menus) {
            final JMenu m=child(menubar,JMenu.class,menu);
            for(String item : items) {
                final JComponent mi=findMenuItem(item,m);
                if (mi!=null) m.remove(mi);
            }
        }
    }
    private final static List vAllMenuitems=new ArrayList(100);
    public static AbstractButton getEquivalentMenuButton(Object buttonOrString,Object menuID) {
        final AbstractButton b=buttonOrString instanceof AbstractButton ? ((AbstractButton)buttonOrString) :null;
        final String txt=b!=null ? b.getText() : toStrg(buttonOrString);
        if (txt==null) return null;
        for(int i=sze(vAllMenuitems); --i>=0;) {
            final AbstractButton  mi=get(i,vAllMenuitems,AbstractButton.class);
            if (mi==null || !txt.equals(mi.getText())) continue;
            if (b!=null && gcp(KEY_MENU_ID,b)!=gcp(KEY_MENU_ID,mi)) continue;
            if (menuID!=null && menuID!=gcp(KEY_MENU_ID,mi)) continue;
            return mi;
        }
        return null;
    }
    public static void setDefaultPopupListener(ChProcessEvent li) { defaultPopupListener=new ChEventAdapter(li);}
    private static MouseListener defaultPopupListener;
    public static void installPopupListener(Component c) { if (defaultPopupListener!=null) c.addMouseListener(defaultPopupListener);}
    private static ChButton togIconsInMenus;
    public static boolean isIconsInMenus() { return cbIconsInMenus().s();}
    public static ChButton cbIconsInMenus() {
        if (togIconsInMenus==null) togIconsInMenus=toggl("Icons in menus").s(true).save(ChUtils.class,"iconsInMenus");
        return togIconsInMenus;
    }
    public static JMenu jMenu(Object oo[],String parent) {
        JMenu jMenu=new ChJMenu();
        addMomoli(MOMOLI_DRAG_MENU_ITEM,jMenu);
        addToMenu(jMenu,null, oo,parent);
        jMenu.addMenuListener(chEvLi());
        addMoli(0,jMenu);
        return jMenu;
    }
    private static KeyStroke parseKeyStrk(String s) {
        if (chrAt(0,s)!='&') return null;
        if (s.indexOf(' ')>0) return KeyStroke.getKeyStroke(s.substring(1));
        final int shiftCtrlMeta=
            (s.indexOf('c',2)>0 ? shortCutMask():0) |
            (s.indexOf('C',2)>0 ? CTRL_MASK:0) |
            (s.indexOf('m',2)>0 ? META_MASK:0) |
            (s.indexOf('s',2)>0 ? SHIFT_MASK:0 );
        return KeyStroke.getKeyStroke(s.charAt(1),shiftCtrlMeta);
    }
    private static void addToMenu(JMenu jMenu, JPopupMenu jPopup, Object oo[],String parent_) {
        int startAt=0;
        final JComponent m=jMenu!=null ? jMenu : jPopup;
        if (sze(oo)==0) return;
        final StringBuffer sbParent=new StringBuffer(99).append(parent_);
        if (jMenu!=null) {
            Icon icon=null;
            String label=null, tip=null;
            for(int k=0; k<oo.length; k++) {
                final Object o=oo[k];
                if (icon==null && o instanceof Icon) {
                    jMenu.setIcon(icon=((Icon) o));
                    startAt=k+1;
                }
                if (icon==null && o=="i" && k+1<oo.length) {
                    k++;
                    if (jMenu instanceof ChJMenu) ((ChJMenu)jMenu).i(oo[k]);
                    else jMenu.setIcon(icon=iicon(toStrg(oo[k])));
                    startAt=k+1;
                } else if (o instanceof CharSequence)  {
                    final String s=toStrg(o);
                    if (tip==null && chrAt(0,s)=='?') { jMenu.setToolTipText(tip=s.substring(1)); startAt=k+1;}
                    else if (label==null) {
                        final char MENU_SEP='\u0000';
                        sbParent.append(MENU_SEP).append(s);
                        jMenu.setText(UserProfile.interpretLabelText(label=s,jMenu));
                        startAt=k+1;
                    }
                }
            }
        }
        KeyStroke accelerator=null;
        String toolTip=null;
        Object icon=null;
        boolean waitForIcon=false, isHelp=false;
        for(int j=startAt; j<oo.length; j++) {
            final Object o=oo[j];
            final String stg=o instanceof String ? (String)o : null;
            final char c0=chrAt(0,stg);
            if (o instanceof ImageIcon || waitForIcon) { icon= o; waitForIcon=false;}
            else if (o=="h") isHelp=true;
            else if (o=="i") waitForIcon=true;
            else if (c0=='?') toolTip=addHtmlTagsAsStrg(stg.substring(1));
            else if (c0=='&')  accelerator=parseKeyStrk(stg);
            else if (!toContainr(m, o, (String)null)) {
                final JComponent c;
                if (isHelp) {
                    isHelp=false;
                    final Object ic=TabItemTipIcon.iconOrStrg(o);
                    c=helpBut(o).i(ic!=null ? ic : "32x10").mi(TabItemTipIcon.item(o));
                } else if (o instanceof Object[]) {
                    final JMenu jm=jMenu((Object[])o,toStrg(sbParent));
                    if (jm.getIcon()==null) jm.setIcon(iicon(IC_BLANK));
                    c=jm;
                } else c=o instanceof JComponent ?  (JComponent) o : null;
                if (c!=null) {
                    if (toolTip!=null) c.setToolTipText(toolTip);
                    if (icon!=null) {
                        if (c instanceof ChButton) ((ChButton)c).i(icon);
                        // else if (c instanceof AbstractButton) ((AbstractButton) c).setIcon(icon instanceof Icon ? (Icon)icon : iicon(toStrg(icon)));
                    }
                    final AbstractButton mi=c instanceof ChButton ? ((ChButton)c).mi((String)null) : null;
                    if (mi!=null) {
                        vAllMenuitems.add(weakRef(mi));
                        pcp(JMenu.class,jMenu,c);
                        if (mi instanceof JMenuItem && accelerator!=null) {
                            ((JMenuItem)mi).setAccelerator(accelerator);
                            pcp(KEY_ACCELERATOR, accelerator, gcp(KEY_CLONED_FROM,mi));
                        }
                    }
                    m.add(mi!=null ? mi : c);
                    accelerator=null;
                    toolTip=null;
                    icon=null;
                }
            }
        }
    }
    public static String[] getMenuPaths(String txt,Object menuID) {
        final AbstractButton menuItem=getEquivalentMenuButton(txt,menuID);
        final List<String> vMenus=new ArrayList();
        if (menuItem!=null) {
            for(Object o : getAncestors(menuItem)) {
                if (o instanceof JMenuBar) vMenus.add("Menu-bar");
                if (o instanceof JMenu) {
                    final String s=((JMenu)o).getText();
                    if ("help".equalsIgnoreCase(s)) return NO_STRING;
                    vMenus.add(s);
                }
                if (o instanceof JPopupMenu) vMenus.add(((JPopupMenu)o).getLabel());
            }
        }
        return toArry(vMenus,String.class);
    }
    /* Rescue Menubar */
    private final static Object KEY_RESCUE_MENUB=new Object();
    public static void setUpdateMenubarOnce(JMenuBar mb) {
        if (isSystProprty(IS_LINUX)) {
            final Reference ref=weakRef(mb);
            for(Component c : mb.getComponents()) {
                addMoli(MOLI_RESCUE_MENUBAR,c);
                pcp(KEY_RESCUE_MENUB,ref,c);
            }
        }
    }

    private static void rescueMenuBar(JMenuBar mb) {
        /*
          final Window pw=parentWndw(mb);
          if (pw instanceof JFrame && gcp(KEY_RESCUE_MENUB,mb)==null) {
          final JMenuBar mb=new JMenuBar();
          for(Component c : menubarRescue.getComponents()) mb.add(c);
          ((JFrame)pw).setJMenuBar(mb);
          mb.revalidate();
          debug("menubarRescue ");
          pcp(KEY_RESCUE_MENUB,"",mb);
          }
        */
    }

    /* <<< Menu <<< */
    /* ---------------------------------------- */
    /* >>> Undockable Menu Items >>> */
    private static List<Reference> vHotlistL=new ArrayList();
    private static ChJList[] _hotlistL;
    private static ChJList[] listsUndock() { return _hotlistL==null ?  _hotlistL=new ChJList[2] : _hotlistL; }
    private static JFrame hotlistW;
    public static void setMenuItemTarget(ChJList L) { adUniq(weakRef(listsUndock()[1]=L),vHotlistL);}
    public static ChJList newMenuItemTarget(ChJList L) {
        ChJList target=new ChJList(new Vector(),ChJTable.DEFAULT_RENDERER|ChJTable.ICON_ROW_HEIGHT|ChJTable.DRAG_ENABLED);
        pcp(KEY_MENU_ITEM_TARGET,weakRef(target),L);
        pcp(KEY_CONTEXT_OBJECTS,weakRef(L),L);
        pcp(KEY_CONTEXT_OBJECTS,weakRef(L),target);
        addMoli(0,target);
        addMoli(0,L);
        return target;
    }
    public static void enableDisableMenuItemTargets(ChJList target0) {
        final ChJList target=target0!=null ? target0 : listsUndock()[0];
        if (target!=null) {
            KEY_CONTEXT_OBJECTS[0]=gcp(KEY_CONTEXT_OBJECTS,target);
            final List items=target.getList();
            for(int j=sze(items); --j>=0;) {
                final AbstractButton b=get(j,items,AbstractButton.class);
                if (b!=null) b.setEnabled(b.isEnabled());
            }
            target.repaint();
        }
    }
    private static void saveUndocked() {
        final ChJList jL=listsUndock()[0];
        final List v=jL!=null ? jL.getList() : null;
        final int L=sze(v);
        final File f=file("~/@/tmp/undockedItems.txt");
        if (L>0) {
            ByteArray sb=null;
            for(int i=0; i<L; i++) {
                final String s=getTxt(v.get(i));
                if (s!=null) (sb==null ? sb=new ByteArray(999) : sb).append(s).append('\n');
            }
            if (sb!=null) wrte(f,sb);
        } else delFile(f);
    }
    private static String undockItms[];
    public static void undockItms(Object oo[]) {
        String[] ss=undockItms;
        if (undockItms==null) ss=undockItms=readLines(file("~/@/tmp/undockedItems.txt"));
        if (sze(ss)>0) {
            for(Object o: oo) {
                if (o instanceof Object[]) undockItms((Object[])o);
                else if (o instanceof JComponent && !(o instanceof JMenu)) {
                    final String s= toStrg(invokeMthd("getText",o));
                    final int i=s!=null ?  idxOfStrg(s,ss) : -1;
                    if (i>=0) {
                        ss[i]=null;
                        undockItm( (JComponent)o, (AWTEvent)null, (ChJList)null);
                    }
                }
            }
        }
    }
    public static void undockItm(Container button, AWTEvent ev, ChJList jList) {
        if (button instanceof JMenu) return;
        final ChJList lst;
        if (jList==null) {
            if (listsUndock()[0]==null) {
                listsUndock()[0]=lst=new ChJList(new Vector(), ChJTable.DEFAULT_RENDERER|ChJTable.ICON_ROW_HEIGHT);
                hotlistW=new JFrame();
                hotlistW.getRootPane().setWindowDecorationStyle(JRootPane.NONE);
                hotlistW.setUndecorated(true);
                setDragMovesWindow(lst,hotlistW);
                hotlistW.getContentPane().add(lst);
                lst.addKeyListener(listener(0));
                vHotlistL.add(weakRef(lst));
                addMoli(0,lst);
                addMomoli(0,lst);
            } else lst=listsUndock()[0];
        } else lst=jList;
        final List v=lst.getList();
        final Component bFather=gcp(KEY_CLONED_FROM, button,AbstractButton.class);
        final Component bAdd0=bFather!=null ? bFather : button, bAdd;
        Point r=null;  try { r=button.getLocationOnScreen();} catch(Exception ex){ }
        if (bAdd0 instanceof ChButton) {
            final ChButton chBut=(ChButton)bAdd0;
            final String MI="CU$$KEY_MI";
            final AbstractButton prevBut=gcp(MI,bAdd0,AbstractButton.class);
            // bAdd=prevBut!=null ? prevBut : chBut.isToggle() ? chBut.mi(null) : chBut.cln();
            bAdd=prevBut!=null ? prevBut : chBut.mi(getTxt(button));
            pcp(MI,bAdd, bAdd0);
        } else bAdd=bAdd0;
        final int dx= r==null||ev==null ? 0 : x(ev)<lastMouseMovedX ? -r.x: r.x+button.getWidth();
        final int dy= r==null||ev==null ? 0 : y(ev)<lastMouseMovedY ? -r.y: r.y+ICON_HEIGHT;
        v.remove(bAdd);
        if (dy<0) v.add(bAdd); else v.add(0,bAdd);
        final int h=sze(lst)*ICON_HEIGHT;
        lst.setFixedCellHeight(32);
        if (lst==listsUndock()[0]) {
            hotlistW.setSize(222,h);
            if (ev!=null) hotlistW.setLocation( maxi(0,dx<0? -dx-222 :dx), dy<0 ?-dy-h+ICON_HEIGHT:dy-ICON_HEIGHT);
            if (javaVsn()>14) hotlistW.setAlwaysOnTop(true);
            setWndwState('T',hotlistW);
            hotlistW.show();
        }
        lst.setPreferredSize(dim(666,h));
        lst.revalidate();
        lst.repaint();
    }
    /* <<< Undockable Menu Items <<< */
    /* ---------------------------------------- */
    /* >>> Undock Entire Panels (setq standard-indent 4) >>> */
    private static Boolean undockEnabled;
    private static JComponent undockEnabled_pnl;
    final static Object KEY_dock_frame=new Object(), KEY_dock_parent=new Object();
    public final static Object KEY_dock_component=new Object(), KEY_UNDOCK_MESSAGE=new Object();
    public static Boolean undockEnabld() { return undockEnabled;}
    public final static Thread thread_panelUndock(Object component, int xScreen, int yScreen) {
        final Object arg[]={component, intObjct(xScreen),intObjct(yScreen)};
        return threadM("panelUndock",ChUtils.class, arg);
    }
    public final static void panelUndock(Object component, int xScreen, int yScreen) {
        final Component panel=getPnl(component);
        if (panel!=null && gcp(KEY_dock_component,parentWndw(panel))==null) {
            final Object
                tp=gcp(ChTabPane.class,panel),
                tl=gcp(ChTableLayout.class,panel);
            final Object parent=
                tp!=null ? tp:
                tl!=null ? tl:
                panel.getParent();
            pcp(KEY_dock_parent, weakRef(parent), panel);
            if (parent==null)  { error("ButOwnWindow: p==null"); return;}
            if (undockEnabled==null) {
                if (undockEnabled_pnl==null) {
                    final Object
                        msg=
                        pnl("Un-docked panels appear in a separate frame and can be moved around and even moved on another monitor.<br>"+
                            "They snap back to the original container by clicking the close button."),
                        dnd=pnl("Drag-n' Drop of objects like proteins work different. See ", WATCH_MOVIE+MOVIE_Export_Proteins),
                        pNorth=hB(
                                  toggl().actionCollapse(false,msg).actionPack(),"Explain        ","#",
                                  enlargeFont(toggl().actionCollapse(false,dnd).actionPack(),0.7),
                                  "<sub>Or do you want to export objects by mouse drag?</sub>"),
                        pSouth=pnl(toggl("E_UNDOCK").li(listener(0)).t("Enable undocking of panels").cb());
                    undockEnabled_pnl=newCNSEW(vB(msg,"-",dnd),pNorth,pSouth,null,null);
                }
                ChFrame f=ChFrame.frame("Undocking?",undockEnabled_pnl,ChFrame.PACK).shw(ChFrame.ALWAYS_ON_TOP|ChFrame.AT_CLICK);
                addActLi(listener(0), f);

            }
            if (undockEnabled!=TRUE) {
                pcp("R", thread_panelUndock(component, xScreen,yScreen), undockEnabled_pnl);
                return;
            }

            rmFromParent(component);
            final ChFrame frame=new ChFrame(TabItemTipIcon.item(component)).size(EM*80,EX*30);
            pcp(KEY_dock_component,weakRef(component),frame);
            pcp(KEY_dock_frame,frame, component);
            addActLi(listener(0), frame);
            Object title=getNam(component);
            if (title==null) title=ChTableLayout.getTitleForObject(component);
            if (title!=null) frame.setTitle(title.toString());
            JMenuBar mb=deref(invokeMthd("getMenuBar",component), JMenuBar.class);
            if (mb==null) mb=gcp(KEY_GET_MENUBAR,component,JMenuBar.class);
            if (mb!=null) { ChUtils.setHeavy(mb);  frame.setJMenuBar(mb); }
            frame.ad(component).shw(0).i(TabItemTipIcon.imageIcon(component));
            final JComponent jc=component instanceof JComponent ? (JComponent)component : null;
            if (xScreen>=0 && yScreen>=0) frame.setLocation(xScreen,yScreen);
            if (jc!=null) {
                frame.size(jc.getWidth(), jc.getHeight());
            }
        }
    }

    public static void panelDock(Object component) {
        if (component==null) return;
        final ChFrame frame=gcpClear(KEY_dock_frame, component, ChFrame.class);
        if (frame!=null) frame.setVisible(false);
        final Object  parent=gcp(KEY_dock_parent, component);
        final Component panel=getPnl(component);
        if (panel!=null) {
            if (parent instanceof JTabbedPane) adTabTITI(panel,component,(JTabbedPane)parent);
            else if (parent instanceof ChTabPane) ((ChTabPane)parent).addTab((JComponent)panel);
            else if (parent instanceof ChTableLayout)  ((ChTableLayout)parent).addColumn(panel);
        }
    }

    /* <<< Undock Big <<< */
    /* ---------------------------------------- */
    /* >>> HTML >>> */
    public static String shortcutAsHtml(String keySequence) { return "<font size=\"-2\" color=\"8866FF\">"+keySequence+"</font>"; }

    public static String rgbHex(int rgb) { return rgbHex(rgb, new StringBuffer()).toString();}
    public static StringBuffer rgbHex(int rgb, StringBuffer sb) {
        for(int j=4*6; (j-=4)>=0;) {
            int hex=  (rgb>>j)&15;
            sb.append( (char)((hex<10?'0':'A'-10)+hex ));
        }
        return sb;
    }
    public static ByteArray rgbHex(int rgb, ByteArray sb) {
        for(int j=4*6; (j-=4)>=0;) {
            int hex=  (rgb>>j)&15;
            sb.append( (char)((hex<10?'0':'A'-10)+hex ));
        }
        return sb;
    }
    public static StringBuffer removeHtmlHeadBody(CharSequence s) {
        if (s==null) return null;
        final StringBuffer sb=toStringBuffer(s);
        rplcSb(0L,"<html>","",sb);
        rplcSb(0L,"<head>","",sb);
        rplcSb(0L,"<body>","",sb);
        rplcSb(0L,"</html>","",sb);
        rplcSb(0L,"</head>","",sb);
        rplcSb(0L,"</body>","",sb);
        return sb;
    }
    public static String xmlAttribute(String id, byte T[], int B,int E) {
        for(int pos=B; (pos=strstr(STRSTR_AFTER,id,T,pos,E))>0; ) {
            if (!is(LETTR_DIGT_US,T,pos-id.length()-1) && get(pos,T)=='=' && get(pos+1,T)=='"') {
                final int endQuote=strchr('"', T,pos+2,E);
                if (endQuote>0) return new String(T,pos+2,  endQuote-(pos+2));
            }
        }
        return null;
    }
    public static String toStrg(byte[] T, int from, int to, String[] stringList, byte[][] stringListBB) {
        if (T==null || from<0 || to>T.length || from>=to) return "";
        if (stringList!=null && stringListBB!=null) {
            final byte c0=T[from];
            for(int i=stringList.length; --i>=0;) {
                final byte[] sl=stringListBB[i];
                if (sl.length==0 || c0!=sl[0]) continue;
                if (equls(sl,T,from)) return stringList[i];
            }
        }
        return new String(T,from,to-from);
    }
    public static String xmlAttribute(String id, byte T[], int B,int E,String[] stringList, byte[][] stringListBB) {
        for(int pos=B; (pos=strstr(STRSTR_AFTER,id,T,pos,E))>0; ) {
            if (!is(LETTR_DIGT_US,T,pos-id.length()-1) && get(pos,T)=='=' && get(pos+1,T)=='"') {
                final int endQuote=strchr('"', T,pos+2,E);
                if (endQuote>0) {
                    return toStrg(T,pos+2,  endQuote, stringList, stringListBB);

                }
            }
        }
        return null;
    }
    public static String addHtmlTagsAsStrg(Object cs) {
        if (cs instanceof String) {
            final String s=(String)cs;
            if ( s.indexOf('<')<0 || s.indexOf('>')<0 ||s.startsWith("<html>")) return s;
        }
        return cs==null ? null : toStrg(addHtmlTags(toStringBuffer(cs)));
    }
    public static void insertIntoHtmlHeader(String s,StringBuffer sb) {
        addHtmlTags(sb);
        int iHead=sb.indexOf("<head>");
        if (iHead<0) iHead=sb.indexOf("<HEAD>");
        if (iHead<0) { iHead=sb.indexOf("<head>");}
        if (iHead>0) sb.insert(iHead+6,s);
    }
    public static CharSequence addHtmlTags(CharSequence cs) {
        final int L=sze(cs);
        boolean added=false;
        for(int i=L; --i>=0;) {
            if (cs.charAt(i)!='<') continue;
            int to=-1;
            for(int j=i; j<i+10 && j<L; j++) if (cs.charAt(j)=='>') { to=j+1; break;}
            if (to>0) {
                for(String tag :  SOME_HTML_TAGS) {
                    if (tag.length()==to-i && equls(STRSTR_IC, tag,cs,i)) {
                        added=true;
                        break;
                    }
                }
            }
        }
        if (added) {
            final StringBuffer sb=toStringBuffer(cs);
            ckHtml(cs);
            if (sb.indexOf("<html>")<0) sb.insert(0,"<html>\n<body>\n").append("\n</body>\n</html>\n");
            final int sHead=sb.indexOf("<head>",sb.indexOf("<html>")),sBody=sb.indexOf("<body>");
            if (sBody>0 && (sHead<0 || sHead>sBody)) sb.insert(sBody,"\n<head></head>\n");
            return sb;
        }
        return cs;
    }
    public static void setCheckHtml(boolean onOff) {
        if (onOff) { if (debugHtml==null) debugHtml=new HashSet(); }
        else debugHtml=null;
    }
    private static void htmlTidy() {
        setCheckHtml(true);
        if (debugHtml!=null) {
            final File f=file(dirLog()+"/ckHtml.html");
            final StringBuffer sb=new StringBuffer(99999);
            for(Object o : debugHtml.toArray()) {
                sb.append(o).append('\n');
            }
            wrte(f,sb);
            putln("\nSize="+sze(f));
            putln(ANSI_GREEN+"tidy ",f," > /dev/null"+ANSI_RESET);
        }
    }
    public static String ckHtml(Object txt) {
        final String s=toStrg(txt);
        if (debugHtml!=null) debugHtml.add(s);
        return s;
    }
    private static Set<CharSequence> debugHtml;
    public static void htmlTidy(Object fOrTxt) {
        if (debugHtml==null) return;
        final ByteArray ba=
            fOrTxt instanceof File ? readBytes((File)fOrTxt) :
            fOrTxt instanceof ByteArray ? new ByteArray(((ByteArray)fOrTxt).newByteArray(0,((ByteArray)fOrTxt).getEnd()+3333), 0, ((ByteArray)fOrTxt).getEnd())  :
            fOrTxt instanceof CharSequence ? new ByteArray((CharSequence)fOrTxt) :
            null;
        if (ba==null) return;
        ba.replace("<body","<DIV class=\"body\" ");
        ba.replace("</body>","</DIV>");
        ba.replace("<html","<DIV class=\"html\" ");
        ba.replace("</html>","</DIV>");
        ba.replace("<head","<DIV class=\"head\" ");
        ba.replace("</head>","</DIV>");
        ba.replace("<!DOCTYPE","<br  ");
        ba.replace("<title>","");
        ba.replace("</title>","");
        ba.replace(0,0,"<!DOCTYPE HTML>\n<html><head><title>T</title></head><body>\n");
        ba.append("\n\n</body></html>");
        final File f=file(dirLog()+"/ckHtml_rplc.html");
        wrte(f,ba);
        ChExec ex=new ChExec(ChExec.STDERR).setCommandLineV("tidy",f);
        ex.run();
        ba.append('\n').append('\n',50).append('\n').append(ex.getStderr());
        new AsciiView(ba).showInFrame("html",0);
    }

    public static String[] hrefsInHtml(ByteArray ba) {
        if (ba==null) return NO_STRING;
        final byte[] T=ba.getBytes();
        final int E=ba.getEnd();
        List<String> v=null;
        for(int i=ba.getBegin(); (i=strstr(STRSTR_AFTER,"href=\"",T,i,E))>0;) {
            final int e=strchr('\"',T,i,E);
            if (e>0) adUniq(ba.newString(i,e),  v==null ? v=new ArrayList() : v);
        }
        return toStrgArry(v);
    }
    /* <<< HTML <<< */
    /* ---------------------------------------- */
    /* >>> Font >>> */
    public static String cssH1H2H3(double scale) {
        return
            "body {font: normal "+(int)(100*scale)+"% Helvetica, Arial, sans-serif;}"+
            "li   {font: normal "+(int)(100*scale)+"% Helvetica, Arial, sans-serif;}"+
            "h3   {font: normal "+(int)(120*scale)+"% Helvetica, Arial, sans-serif; }"+
            "h2   {font: normal "+(int)(140*scale)+"% Helvetica, Arial, sans-serif; }"+
            "h1   {font: normal "+(int)(160*scale)+"% Helvetica, Arial, sans-serif; }\n";
    }
    public static JComponent monospc(Object c_) {
        if (c_==null) return null;
        else if (c_ instanceof JComponent) {
            final JComponent c=(JComponent)c_;
            final Font f=c.getFont();
            if (f==null) return c;
            c.setFont(getFnt(f.getSize(),true,f.getStyle()));
            return c;
        }
        else {
            String s=c_.toString();
            if (s==null) return null;
            if (c_ instanceof File) s= " "+rplcToStrg(" ","%20",(isWindows() ? ((File)c_).getAbsolutePath() : filepathUnixStyle(c_)))+" ";
            if (looks(LIKE_EXTURL,s)) s=" "+s+" ";
            final CharSequence html=addHtmlTags(s);
            final javax.swing.text.JTextComponent tf=s.indexOf('\n')>0 ? new ChTextArea(html) :  new ChTextField(html);
            tf.setEditable(false);
            tf.setMaximumSize(tf.getPreferredSize());
            ChTextComponents.tools(tf).underlineRefs(0);
            return tf;
        }
    }
    final static Reference<Font>[][] FONTS=new Reference[8][];
    public static Font getFnt(int size0, boolean monospace, int style) {
        final int size=maxi(size0,1);
        final int type=
            ( (style&Font.BOLD)!=0 ? 1:0) |
            ( (style&Font.ITALIC)!=0 ? 2:0) |
            ( monospace ? 4:0);
        if (sze(FONTS[type])<=size) FONTS[type]=chSze(FONTS[type],size+10,Reference.class);
        Font f=(Font)deref(FONTS[type][size]);
        if (f==null) FONTS[type][size]=new SoftReference(f=new Font(monospace ? "Monospaced" :"", style, size));
        return f;
    }
    public static JComponent enlargeFont(CharSequence c,double k) { return enlargeFont(pnl(c),k);}
    private final static Map<String,Font> mapEnlargeFont=new HashMap();
    public static JComponent enlargeFont(JComponent c,final double k) {
        final Font f=c.getFont();
        if (f!=null) {
            final int style=f.getStyle();
            Object oSize=gcp(KEY_ORIG_FONT_SIZE,c,Integer.class);
            if (oSize==null) pcp(KEY_ORIG_FONT_SIZE,oSize=intObjct(f.getSize()),c);
            final int size=maxi(1,(int)(k*atoi(oSize)));
            final String key=f.getName()+" "+style+" "+size;
            Font newFont=mapEnlargeFont.get(key);
            if (newFont==null) mapEnlargeFont.put(key,newFont=new Font(f.getName(),style,size));
            c.setFont(newFont);
            if (c instanceof HyperTextPane) {
                final javax.swing.text.Document doc=((HyperTextPane)c).getDocument();
                if (doc instanceof javax.swing.text.html.HTMLDocument) ((javax.swing.text.html.HTMLDocument)doc).getStyleSheet().addRule(cssH1H2H3(k));
            }
        }
        for(Component co:c.getComponents()) {
            if (co instanceof JComponent)
                enlargeFont(((JComponent)co),k);
        }
        return c;
    }
    public static int strgWidth(Object o, CharSequence s) {
        if (o==null || sze(s)==0) return 0;
        final FontMetrics fm=fntMet(o);
        return fm!=null ?  fm.stringWidth(toStrg(s)) : 0;
    }
    public static int charA(Object o) {
        final FontMetrics fm=fntMet(o);
        return fm!=null ? fm.getAscent() : 0;
    }
    public static int charW(Object o) {
        final FontMetrics fm=fntMet(o);
        return fm!=null ? fm.charWidth('H') : 0;
    }
    public static int charH(Object o) {
        final FontMetrics fm=fntMet(o);
        return fm!=null ? fm.getAscent()+fm.getDescent() : 0;
    }
    private static FontMetrics fntMet(Object o) {
        if (o instanceof FontMetrics) return (FontMetrics)o;
        final Font f= o instanceof Font ? (Font)o : o instanceof Graphics ? ((Graphics)o).getFont() : o instanceof Component ? ((Component)o).getFont() : null;
        assertNotNull(f);
        return f!=null ? Toolkit.getDefaultToolkit().getFontMetrics(f) : null;
    }

    private static Boolean isGEA;
    public static boolean isGraphicsAvailable() {
        if (isGEA==null) {
            try {
                GraphicsEnvironment.getLocalGraphicsEnvironment();
                isGEA=!GraphicsEnvironment.getLocalGraphicsEnvironment().isHeadless() ? TRUE : FALSE;
            } catch(Error ex) {isGEA=FALSE;}
        }
        return isGEA==TRUE;
    }

    private static Toolkit dTK;
    public static Toolkit getDefaultTK() {
        if (!isGraphicsAvailable()) return null;
        if (dTK==null) dTK=Toolkit.getDefaultToolkit();
        return dTK;
    }

    public static Rectangle charBounds(Font f) { return ChFontMetrics.getCharBounds(f);}
    public static String[] getAllFonts() {
        final List<String> v=new ArrayList();
        final String SKIP[]={"Webdings","Wingdings","Symbol","MS Outlook","StarMath","StarBats","Standard Symbol"};
    nextFont:
        for(Font f:GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts()){
            final String n=f.getName();
            for(String not:SKIP) if (n.startsWith(not)) continue nextFont;
            v.add(n);
        }
        return toStrgArry(v);
    }
    /* <<< Font <<< */
    /* ---------------------------------------- */
    /* >>> AWT >>> */
    public static Cursor getCursr(int d) {
        final int t=
            d=='W' ? Cursor.WAIT_CURSOR:
            d=='M' ? Cursor.MOVE_CURSOR:
            d=='T' ? Cursor.TEXT_CURSOR:
            d=='H' ? Cursor.HAND_CURSOR:
            d=='n' ? Cursor.N_RESIZE_CURSOR:
            d=='s' ? Cursor.S_RESIZE_CURSOR:
            d=='e' ? Cursor.E_RESIZE_CURSOR:
            d=='w' ? Cursor.W_RESIZE_CURSOR:
            d=='n'+'w' ? Cursor.NW_RESIZE_CURSOR:
            d=='n'+'e' ? Cursor.NE_RESIZE_CURSOR:
            d=='s'+'w' ? Cursor.SW_RESIZE_CURSOR:
            d=='s'+'e' ? Cursor.SE_RESIZE_CURSOR :
            Cursor.DEFAULT_CURSOR;
        return Cursor.getPredefinedCursor(t);
    }
    private static Insets[] INSETS0;
    public static Insets insets0(boolean vert) {
        if (INSETS0==null) INSETS0=new Insets[]{new Insets(0,0,0,0), new Insets(0,2,0,2)};
        //INSETS0.left=INSETS0.right=INSETS0.top=INSETS0.bottom=0;
        return INSETS0[vert?1:0];
    }
    public static JComponent emptyBordr(int l, int r, int o, int u, JComponent c) {
        if (c!=null) c.setBorder(new EmptyBorder(o,l,u,r));
        return c;
    }
    public static boolean isContained(Component parent,Object comp) {
        if (parent==comp || parent.getClass()==comp) return true;
        try {
            for(Component c:((Container)parent).getComponents())
                if (isContained(c,comp)) return true;
        } catch(Exception e){}
        return false;
    }
    /* ---------------------------------------- */
    public static void pushDivider(Component c,double pos) {
        if (c==null) return;
        final JSplitPane sp=parnt(c,JSplitPane.class);
        if (sp!=null) {
            final int
                max=sp.getMaximumDividerLocation(),
                div=sp.getDividerLocation();
            if (sp.getBottomComponent()==c && div> (int)(max*(1-pos))) { sp.setDividerLocation(1-pos); sp.revalidate(); }
            if (sp.getTopComponent()==c && div< (int)(max*pos)) { sp.setDividerLocation(pos); sp.revalidate();}
        }
    }
    public static Object[] getClones(Component c) {
        synchronized(vClones) {
            getClones(c,vClones,0);
            final Object oo[]= toArry(vClones,Object.class);
            vClones.clear();
            return oo;
        }
    }
    private final static List vClones=new ArrayList();
    private static void getClones(Object c, List v, int recursion) {
        synchronized(vClones) {
            final Reference rr[]=gcp(KEY_CLONES,c, Reference[].class);
            if (rr!=null) {
                for(Reference r : rr) {
                    final Object o=r!=null ? r.get() : null;
                    if (o!=null) {
                        v.add(o);
                        if (recursion<4) getClones(o,v,recursion+1);
                    }
                }
            }
        }
    }
    public static void setDefaultBG(Component c) {
        if (c!=null) {
            final Color bg=UIManager.getDefaults().getColor("Button.background");
            if (bg!=null) c.setBackground(bg);
        }
    }
    public static Component fg(Color c, Component jc) { if (jc!=null) jc.setForeground(c); return jc;}
    public static void recursiveWhiteOnBlack(Component c) {
        c.setForeground(Color.WHITE);
        c.setBackground(Color.BLACK);
        for(Component child : childs(c)) recursiveWhiteOnBlack(child);
    }

    public static void setNFC(JComponent c, JComponent next) { if (c!=null) c.setNextFocusableComponent(next);}
    public static void toClipbd(CharSequence txt) {
        final String s=toStrg(txt);
        if (s!=null) {
            final java.awt.datatransfer.StringSelection sel=new java.awt.datatransfer.StringSelection(s);
            try{ Toolkit.getDefaultToolkit().getSystemClipboard().setContents(sel,null);}catch(Throwable ex){}
            try{ Toolkit.getDefaultToolkit().getSystemSelection().setContents(sel,null);}catch(Throwable ex){}
        }
    }
    public static JComponent noMargn(JComponent c) {
        if (c instanceof AbstractButton) ((AbstractButton)c).setMargin(insets0(false));
        return c;
    }
    public static JComponent noInsets(JComponent c) {
        Insets i=c!=null ? c.getInsets() : null;
        if (i!=null)  i.top=i.bottom=i.left=i.left=i.right=0;
        return c;
    }
    public static boolean isSelctd(Object o) { return o instanceof AbstractButton ? ((AbstractButton)o).isSelected() : false; }
    /* <<< AWT <<< */
    /* ---------------------------------------- */
    /* >>> Shape >>> */
    public static boolean setBnds(int x,int y, int w, int h, Rectangle r) {
        if (r!=null && !(r.x==x&&r.y==y&&r.width==w&&r.height==h)) {
            r.setBounds(x,y,w,h);
            return true;
        }
        return false;
    }
    /*<<< Shape <<< */
    /* ---------------------------------------- */
    /* >>> ToolTipManager >>> */
    public static void assertInstAllowed(){}
    public static void assertEDT() { assert isEDT();}
    public static boolean isEDT() { return SwingUtilities.isEventDispatchThread();}
    public static boolean notEDT() { return isGraphicsAvailable() && !SwingUtilities.isEventDispatchThread();}
    public static void inEDT(Runnable r) {
        if (r==null) return;
        if (!isGraphicsAvailable() || isEDT()) r.run();
        else try { SwingUtilities.invokeAndWait(r); } catch(Exception e){}
    }
    public static Thread newThrd(Runnable ...rr) {  return ChDelay.newThread(instance(0),"runnable",rr); }
    public static JComponent setTT(CharSequence t, JComponent c) {
        if (c!=null && isGraphicsAvailable()) c.setToolTipText(addHtmlTagsAsStrg(t));
        return c;
    }
    /*<<< Thread <<< */
    /* ---------------------------------------- */
    /* >>> ToolTipManager  JComponent >>> */
    private static int  initialDelay, reshowDelay;
    public static void setTipTiming(int initial, int reshow) {
        if (initialDelay==0) {
            initialDelay=ToolTipManager.sharedInstance().getInitialDelay();
            reshowDelay=ToolTipManager.sharedInstance().getReshowDelay();
        }
        if (initial<0) {
            ToolTipManager.sharedInstance().setInitialDelay(initialDelay);
            ToolTipManager.sharedInstance().setReshowDelay(reshowDelay);
        } else {
            ToolTipManager.sharedInstance().setInitialDelay(initial);
            ToolTipManager.sharedInstance().setReshowDelay(reshow);
        }
    }
    public static JComponent rtt(JComponent c) {
        if (c!=null) {
            ToolTipManager.sharedInstance().registerComponent(c);
            ToolTipManager.sharedInstance().setEnabled(true);
        }
        return c;
    }
    /* <<< ToolTipManager <<< */
    /* ---------------------------------------- */
    /* >>> JTabbedPane  BasicTabbedPaneUI  >>> */
    {
        final Insets ins=UIManager.getInsets("TabbedPane.tabInsets");
        if (ins!=null) { ins.left=2; ins.right=1; }
    }
    private final static Object KEY_tabComponent=new Object(), KEY_JTabbedPane=new Object(), KEY_undockableComponent=new Object();
    public static void adMainTab(Component comp, JTabbedPane tp, Class c0) {
        if (comp==null || tp==null) return;
        Class c=c0!=null ? c0 : tp.getClass();
        if (tp instanceof Disposable) pcp(KEY_DISPOSABLE,weakRef(tp), comp);
        final Component tabComp=adTab(TabItemTipIcon.tab(c), TabItemTipIcon.imageIcon(c),comp, "", tp);
        if (gcp(KEY_UNDOCKABLE,tp)!=null) setTabUndocksPanel(tabComp,tp);
    }
    public static JComponent adTab(String title, Component component, JTabbedPane tp) { return adTab(title, (Icon)null, component, "",tp);}
    public static JComponent adTab(String title0, Icon icon, Component component, String tip0, JTabbedPane tp) {
        assertEDT();
        JComponent tabComp=null;
        if (tp!=null && component!=null) {
            final String title=addHtmlTagsAsStrg(title0), tip=addHtmlTagsAsStrg(tip0);
            final int n=tp.getTabCount();
            tp.addTab(title,icon,component,tip=="" ?null :tip);
            tp.setSelectedIndex(n);
            pcp(KEY_NEEDS_REVALIDATE, "",tp);
            if (javaVsn()>15) {
                final ChLabel lab=new ChLabel(title).i(icon).tt(tip);
                lab.setBorder(null);
                pcp(ChLabel.KEY_JTabbedPane, tp, lab);
                tabComp=lab;
                invokeMthd("setTabComponentAt",tp,new Object[]{intObjct(n),lab},  INVOKE_MTHD_PRINT_EXCEPTIONS);
                pcp(KEY_tabComponent,weakRef(component),lab);
                pcp(KEY_JTabbedPane,weakRef(tp), tabComp);
                lab.addMouseListener(listener(MOLI_TAB));

                if (gcp(KEY_UNDOCKABLE,component)!=null) setTabUndocksPanel(lab,component);
                lab.setPreferredSize(dim(lab.getPreferredSize().width,ICON_HEIGHT));
                if (hasDisposabl(component)) ChRenderer.setSmallButtonXc( -EM, lab);
                lab.setHorizontalAlignment(JLabel.RIGHT);
                noInsets(lab);
            }
            //revalidate_whenMouseEnter1(true, component);
            ChDelay.revalidate(component,99);
        }

        return tabComp;
    }
    public static void setTtleAt(Component comp, String title, JTabbedPane tp) {
        final int i=tp!=null ? tp.indexOfComponent(comp):-1;
        if (i<0) return;
        final String t=addHtmlTagsAsStrg(title);
        tp.setTitleAt(i,t);
        final JLabel lab=deref(gcp(KEY_tabComponent,comp),JLabel.class);
        if (lab!=null) lab.setText(t);
    }

    public static void setTabUndocksPanel(Component tab, Component panel) {
        if (tab!=null && panel!=null) {
            tab.addMouseMotionListener(listener(MOMOLI_PANEL_UNDOCK));
            pcp(KEY_undockableComponent,weakRef(panel), tab);
        }
    }

    public static void adTabTITI(Component comp,Object titi,JTabbedPane tp) {
        //try{o=((Class)o).newInstance();}catch(Exception e){}
        final Icon i=TabItemTipIcon.icn(titi);
        final String t=TabItemTipIcon.tab(titi);
        adTab(sze(t)>0 ? t : shrtClasNam(titi) ,i,comp, TabItemTipIcon.tip(titi), tp);
    }
    /* <<< JTabbedPane <<< */
    /* ---------------------------------------- */
    /* >>> Parents  >>> */
    public static <T extends Object> T parnt(Object o, Class<T> clas) {
        Object par=o instanceof Component ? ((Component)o).getParent() : null;
        return  par!=null && clas.isAssignableFrom(par.getClass()) ? (T)par : null;
    }
    public static Window parentWndw(Object c) {  //  static Window | getWindowAncestor(Component c)
        if (c instanceof Window) return (Window)c;
        if (c instanceof Component) {
            return  parnt(SwingUtilities.getRootPane((Component)c),Window.class);
        } else return null;
    }
    public static JComponent findParent(JComponent comp,Class  c) {
        while(true) {
            if ( comp==null  || c.isAssignableFrom(comp.getClass())) return comp;
            comp=parnt(comp,JComponent.class);
        }
    }
    public static void rmFromParent(Object obj){
        if (obj instanceof Object[]) for(Object o : (Object[])obj) rmFromParent(o);
        final Component c=getPnl(obj);
        if (c==null) return;
        if (c instanceof JComponent) {
            final Object tp=gcpa(ChTabPane.class,c);
            if (tp instanceof ChTabPane) {
                ((ChTabPane)tp).removeTab((JComponent)c);
                return;
            }
        }
        {
            final Object tl=gcpa(ChTableLayout.class,c);
            if (tl instanceof ChTableLayout) {
                ((ChTableLayout)tl).removeColumn(obj);
                return;
            }
        }
        final Container con=c.getParent();
        if (con!=null) {
            final Window parentW=parentWndw(c);
            if (parentW instanceof JFrame && ((JFrame)parentW).getContentPane()==c) {
                /*if (gcp(KEY_dock_component,parentW)!=null) */ parentW.setVisible(false);
            }
            try { con.remove(c);} catch(Exception e) {}
            try {
                con.repaint();
                ChDelay.revalidate(con,99,(long[])null);
            } catch(Exception e) {}
        }
    }
    public static Component[] getAncestors(Component c) {
        final List<Component> v=new ArrayList();
        getAncestors(c,v);
        return toArry(v,Component.class);
    }
    private static void getAncestors(Component c,List<Component> v) {
        Object parent=gcp(JMenu.class,c);
        if (parent==null) parent=c.getParent();
        if (parent==null && c instanceof JPopupMenu) { parent=((JPopupMenu)c).getInvoker();}
        if (parent instanceof Component) {
            getAncestors((Component)parent,v);
            v.add((Component)parent);
        }
    }
    /*<<< Parents  <<< */
    /* ---------------------------------------- */
    /* >>>Children  >>> */
    private static List vChilds;
    public static Component[] childs(Component c) {
        Component cc[]=
            c instanceof ChTabPane ? ((ChTabPane)c).getTabComponents() :
            c instanceof Container ? ((Container)c).getComponents() :
            null;
        return cc!=null ? cc : NO_COMPONENT;
    }
    public static <T extends Object> T[] childs(Component comp,Class<T> clas) {
        final List v;
        if (isEDT()) {
            if (vChilds==null) vChilds=new ArrayList(); else vChilds.clear();
            v=vChilds;
        } else  v=new ArrayList();
        getChildsV(comp,clas,v);
        return (T[])v.toArray((Object[])Array.newInstance(clas,v.size()));
    }
    public static void getChildsV(Component comp,Class clas,Collection v) {
        if (comp==null) return;
        if (isInstncOf(clas,comp)) { v.add(comp); }
        if (comp instanceof JMenu) {
            final JMenu m=(JMenu)comp;
            for(int i=0;i<m.getItemCount();i++) getChildsV(m.getItem(i),clas,v);
        } else {
            final Component cc[]=childs(comp);
            for(int i=sze(cc); --i>=0;) getChildsV(cc[i],clas,v);
        }
    }
    public static <T extends Object> T child(Component comp,Class<T> clas) { return child(comp,clas,null); }

    public static <T extends Object> T child(Component comp,Class<T> clas, String label) {
        if (comp==null) return null;
        if (isInstncOf(clas,comp)) {
            final String txt= label!=null && comp instanceof AbstractButton ? ((AbstractButton)comp).getText() : null;
            if (txt==null || txt.equalsIgnoreCase(label) ||
                label!=null && label.endsWith(".*") && equls(label,0,label.length()-2,txt,0)
                ) return (T)comp;
        }
        for(Component c : childs(comp) ) {
            final Object ret=child(c,clas,label);
            if (ret!=null) return (T)ret;
        }
        return null;
    }
    /* ---------------------------------------- */
    public static void recursivelyInvalidateChildren(Component comp) {
        for(Component c : childs(comp)) recursivelyInvalidateChildren(c);
        comp.invalidate();
    }
    public static void setEnabld(Component c,boolean b) {
        if (c!=null && c.isEnabled()!=b) {
            if (!isEDT()) ChDelay.setEnabled(c,b,1);
            else if (c.isEnabled()!=b) {
                c.setEnabled(b);
                for(Object cln : getClones(c)) {
                    if (cln instanceof Component) ((Component)cln).repaint();
                }
                if (c instanceof JComponent && c.isVisible() && gcp(KEY_PREF_SIZE_IF_DISABLED, c)!=null) ((JComponent)c).revalidate();
                c.repaint();
                ((JComponent)c).revalidate();
            }
        }
    }
    public static void setEnabledIncludingChildren(Container parent,boolean b) {
        if (parent==null) return;
        for(Component c:parent.getComponents())
            if (c instanceof Container)
                setEnabledIncludingChildren((Container)c,b);
        ((Component)parent).setEnabled(b);
    }
    public static void rmAllChilds(Component parent) {
        if (!isEDT()) {
            ChDelay.invokeAndWait(instance(0),"removeAllChilds",parent);
            return;
        }
        if (parent==null) return;
        if (parent instanceof JComponent) removeAllListeners((JComponent)parent);
        if (parent instanceof Container) {
            Container cont=(Container)parent;
            Component cc[]=cont.getComponents();
            if (cont instanceof JTabbedPane) {
                final JTabbedPane tabbed=(JTabbedPane)cont;
                final int nT=tabbed.getTabCount();
                cc=new Component[nT];
                for(int i=nT;--i>=0;) cc[i]=tabbed.getComponentAt(i);
            }
            for(Component c:cc) rmAllChilds(c);
            try { cont.removeAll(); } catch(Throwable ex) {}
        }
    }

    public static void disposeChildren(Container parent) {
        final Component cc[]=parent.getComponents();
        for(Component c:cc)  if (c instanceof Container) disposeChildren((Container)c);
        for(Component c:cc) dispos(0L,c);
    }
    public static Disposable[] disposabls(Object refObj) {
        final List<Disposable> v=new ArrayList();
        disposabls(refObj,v);
        return toArry(v,Disposable.class);
    }

    public static void disposabls(Object refObj, List<Disposable>v) {
        final Object obj=deref(refObj);
        if (obj==null) return;
        adUniq(deref(obj,Disposable.class),v);
        disposabls(gcp(KEY_DISPOSABLE,obj),v);
        if (obj instanceof Object[]) {
            for(Object o : (Object[])obj) disposabls(o,v);
        }
    }
    public static boolean hasDisposabl(final Object obj) {
        if (isAssignblFrm(Disposable.class, obj)) return true;
        final Object val=gcp(KEY_DISPOSABLE,obj);
        if (isAssignblFrm(Disposable.class, val)) return true;
        if (val instanceof Object[]) {
            for(Object v : ((Object[])val)) {
                if (isAssignblFrm(Disposable.class, deref(v))) return true;
            }
        }
        return false;
    }

    public final static long OPTION_DISPOSE_RM_CHILDS=1<<1, OPTION_DISPOSE_ASK_CTRL=1<<2;
    public static boolean dispos(long options, Object objects) {
        boolean success=false;
        final Object oo[]=oo(objects);
        final String msg="Really close this component? <br><br><sub>Note: You can avoid this confirmation dialog by holding ctrl.</sub>";
        if (countNotNull(oo)==0 || (options&OPTION_DISPOSE_ASK_CTRL)!=0 && !ChMsg.yesNo(msg)) return false;
        for(Object object : oo) {
            if (object==null) continue;
            if (object instanceof Frame) {
                ((Frame)object).dispose();
                success=true;
            } else if (object instanceof Disposable) {
                ((Disposable)object).dispose();
                success=true;
            }
            final Component container=getPnl(object);
            if (container!=null) {
                if ( (options&OPTION_DISPOSE_RM_CHILDS)!=0) rmAllChilds(container);
                try {
                    final Container par=container.getParent();
                    rmFromParent(object);
                    if (par instanceof JComponent) ((JComponent)par).revalidate();
                } catch(Exception e){putln("caught ChUtils#dispos() ",e);}
            }
        }
        return success;
    }
    /*<<< Children <<< */
    /* ---------------------------------------- */
    /* >>> JScrollPane >>> */
    private final static Map<ListSelectionModel,Reference<Component>>  mapLisSelModel2Comp=new WeakHashMap();

    public static void adSelectLisener(Component jc) {
        final ListSelectionModel lsm=
            jc instanceof JList ? ((JList)jc).getSelectionModel() :
            jc instanceof JTable ? ((JTable)jc).getSelectionModel() : null;

        if (lsm!=null) {
            lsm.removeListSelectionListener(chEvLi());
            lsm.addListSelectionListener(chEvLi());
            mapLisSelModel2Comp.put(lsm,weakRef(jc));
        }
        if (jc instanceof JTree) {
            ((JTree)jc).removeTreeSelectionListener(chEvLi());
            ((JTree)jc).addTreeSelectionListener(chEvLi());
        }
    }

    public final static long SCRLLPN_SEARCH_BUTTON=1<<0, SCRLLPN_ETCHED_BORDER=1<<1, SCRLLPN_INHERIT_PREF_SIZE=1<<2;
    public static JScrollPane scrllpn(long options, Component c) { return scrllpn(options, c,null);}
    public static JScrollPane scrllpn(long options, Component c, Dimension d) {
        if (c==null) return null;
        final JScrollPane sp;
        final ChTextComponents tools=ChTextComponents.tools(c);
        if (tools!=null) sp=tools.scrollPane();
        else {
            sp=new JScrollPane(c) { @Override public void validateTree(){ try{ super.validateTree();} catch(Exception e){} } };
            final ChScrollBar vsb=new ChScrollBar(JScrollBar.VERTICAL), hsb=new ChScrollBar(JScrollBar.HORIZONTAL);
            sp.setVerticalScrollBar(vsb);
            sp.setHorizontalScrollBar(hsb);
            adSelectLisener(c);
            sp.getViewport().setBackground(c.getBackground());
        }
        final int scrIncr=atoi(gcp(KEY_SCROLL_INCR_V,c));
        sp.getVerticalScrollBar().setUnitIncrement(scrIncr>0? scrIncr:EX);
        if (d!=null) sp.setPreferredSize(d);
        if (0!=(options&SCRLLPN_ETCHED_BORDER)) sp.setBorder(new EtchedBorder());
        if (0!=(options&SCRLLPN_SEARCH_BUTTON)) {
            final ChButton b=new DialogStringMatch(options,c, "").button(null).t(null)
                .i(IC_SEARCH+"16x16").tt("Highlight rows with string pattern");
            try {
            sp.setCorner(JScrollPane.UPPER_TRAILING_CORNER,b);
            } catch(IllegalArgumentException ex){} // IllegalArgumentException: invalid corner key
        }
        if (0!=(options&SCRLLPN_INHERIT_PREF_SIZE)) {
            final Dimension dim=c.getPreferredSize();
            if (dim!=null) sp.setPreferredSize(dim(dim.width+EX,dim.height+EX));
        }
        return sp;
    }
    public static JScrollPane getJScrollPane(Container c) {
        Container parent=c;
        while( parent!=null && (parent=parent.getParent())!=null) {
            if (parent instanceof JScrollPane)  return (JScrollPane)parent;
        }
        return null;
    }
    public static JScrollBar getScrollBar(Container c, char VorH) {
        final JScrollPane sp=getJScrollPane(c);
        return sp==null ? null : VorH=='H' ? sp.getHorizontalScrollBar() : sp.getVerticalScrollBar();
    }
    public static void setDragScrolls(JComponent c,JScrollPane sp) {
        final int id=gcp(instance(MOMOLI_DRAG_false),c)==null ? MOMOLI_DRAG_true : MOMOLI_DRAG_false;
        addMomoli(id, c);
        pcp(instance(id),sp,c);
    }
    /* <<< JScrollPane <<< */
    /* ---------------------------------------- */
    /* >>> JTable JList >>> */

    public static int[] selIndices(Object oo[], ListModel m) {
        boolean bb[]=null;
        for(int i=m==null ? 0 : m.getSize(); --i>=0;) {
            if (cntains(m.getElementAt(i),oo)) {
                if (bb==null) bb=new boolean[i+1];
                bb[i]=true;
            }
        }
        final int N=countTrue(bb);
        if (N>0) {
            final int ii[]=new int[N];
            int count=0;
            for(int i=0;i<bb.length;i++) {
                if (bb[i]) ii[count++]=i;
            }
            return ii;
        }
        return NO_INT;
    }

    public static void revalidateIfModified(JComponent c, int mc) {
        if (c!=null && atoi(gcp(KEY_MODI_COUNT,c))!=mc) {
            pcp(KEY_MODI_COUNT, intObjct(mc),c);
            c.revalidate();
            c.repaint();
        }
    }
    public static void selectAllItems(Object list) {
        if (list instanceof JList) {
            JList jl=(JList)list;
            final int L=jl.getModel().getSize();
            if (L>0) jl.getSelectionModel().setSelectionInterval(0,L-1);
        }
    }
    private static void selectionChanged(EventObject ev) {
        final Object q=ev.getSource();
        final Reference refTable=mapLisSelModel2Comp.get(q);
        final JComponent jC=(JComponent)(q instanceof JComponent ? q: deref(refTable));
        if (gcp(KEY_NOT_YET_PAINTED,jC)==null && gcp(KEY_IGNORE_SELECTION_EVT,jC)==null) {
            final Object cmd=gcp(KEY_ACTION_COMMAND,jC);
            handleActEvt(jC,cmd!=null ? cmd.toString() : ACTION_SELECTION_CHANGED,0);
        }
        final JScrollBar sbV=getScrollBar(jC,'V');
        if (sbV instanceof ChScrollBar) {
            final ChScrollBar vsb=(ChScrollBar)sbV;
            if (!vsb.isVisible() || vsb.getWidth()<5 || vsb.getHeight()<22) return;
            int[] yy=null;
            if (jC instanceof JList) {
                final JList jl=(JList)jC;
                final int fixed=jl.getFixedCellHeight();
                final int ii[]=jl.getSelectedIndices();
                if (ii!=null) {
                    yy=new int[ii.length];
                    for(int i=ii.length; --i>=0;)  yy[i]=fixed>0 ? fixed*ii[i]+fixed/2 : jl.indexToLocation(ii[i]).y;
                }
            } else if (jC instanceof JTable) {
                final JTable jl=(JTable)jC;
                final int ii[]=jl.getSelectedRows();
                final int fixed=jl.getRowHeight();
                if (ii!=null) {
                    yy=new int[ii.length];
                    for(int i=ii.length; --i>=0;)
                        yy[i]=fixed*ii[i]+fixed/2;
                }
            } else if (jC instanceof JTree) {
                final JTree jl=(JTree)jC;
                final TreePath ii[]=jl.getSelectionPaths();
                if (ii!=null) {
                    yy=new int[ii.length];
                    for(int i=ii.length; --i>=0;) {
                        final Rectangle r=jl.getPathBounds(ii[i]);
                        if (r!=null) yy[i]=r.y+r.height/2;
                    }
                }
            }
            vsb.setSelectedY(yy,1,(Color[])null);
        }
    }

    public static Object[] getSelValues(Object o) {
        if (o instanceof JList) return ((JList)o).getSelectedValues();
        if (o instanceof JComboBox) return new Object[]{((JComboBox)o).getSelectedItem()};
        if (o instanceof Object[]) return (Object[])o;
        if (o instanceof Collection) return ((Collection)o).toArray();
        if (o instanceof JTree) {
            final TreePath pp[]=((JTree)o).getSelectionPaths();
            if (sze(pp)==0) return NO_OBJECT;
            final Set v=new HashSet(pp.length);
            for(int i=sze(pp); --i>=0;) v.add(pp[i].getLastPathComponent());
            return v.toArray();
        }
        return NO_OBJECT;
    }

    public static boolean isCellEditbl(int row, int col, JTable t) {
        final javax.swing.table.TableModel tm=t!=null ? t.getModel() : null;
        return tm!=null && !tm.isCellEditable(row,col);
    }
    private static Reference<Collection<TreePath>> vTP_ref;
    public static void selectObjectsIE(Collection v, JTree c) {
        final Object save=gcp(KEY_PREF_SIZE_IF_DISABLED,c);
        pcp(KEY_IGNORE_SELECTION_EVT,"",c);
        selectObjectsT(v,c);
        pcp(KEY_IGNORE_SELECTION_EVT, save, c);
    }
    private static void selectObjectsT(Collection v,JTree jTree) {
        Collection <TreePath> vTP=vTP_ref!=null ? vTP_ref.get() : null;
        if (vTP==null) vTP_ref=new SoftReference(vTP=new HashSet()); else vTP.clear();
        for(int i=jTree.getRowCount(); --i>=0;) {
            final TreePath tp=jTree.getPathForRow(i);
            final Object o=tp.getLastPathComponent();
            if (v.contains(o)) vTP.add(tp);
        }

        jTree.setSelectionPaths(toArry(vTP,TreePath.class));
    }
    public static void scrollToVis(Object o, Component c) {
        if (o==null) return;
        if (c instanceof JTree) {
            final JTree t=(JTree)c;
            final TreePath tp=getTreePath(o, t);
            if (tp!=null) t.scrollPathToVisible(tp);
        }
    }

    /* <<< JTable JList <<< */
    /* ---------------------------------------- */
    /* >>> JTree >>> */
    public static TreePath getTreePath(Object o, JTree jTree) {
        for(int i=jTree.getRowCount();--i>=0;) {
            final TreePath tp=jTree.getPathForRow(i);
            if (tp!=null && tp.getLastPathComponent()==o) return tp;
        }
        return null;
    }

    /* <<< JTree <<< */
    /* ---------------------------------------- */
    /* >>> JPopupMenu >>> */
    public static boolean shwPopupMenu(Object invoker, JPopupMenu pop) {

        int dx=0, dy=EX;
        Component c=deref(invoker,Component.class);
        if (c==null || pop==null) return false;

        if (!c.isShowing()) {
            dx+=c.getX();
            dy+=c.getY();
            c=c.getParent();
        }

        pop.show(c!=null ? c : ChFrame.getMainFrame(), dx, dy);
        return true;
    }

    public static Object objectAt(AWTEvent mev) {
        final Object q=mev!=null ? mev.getSource() : null;
        return q instanceof Component && mev instanceof MouseEvent  ? objectAt(((MouseEvent)mev).getPoint(), (Component)q) : null;
    }
    public static Object objectAt(Point p, Object q) {
        if (p==null||q==null) return null;
        if (q instanceof JTree) {
            final TreePath tp= ((JTree)q).getPathForLocation(p.x, p.y);
            return tp!=null ? tp.getLastPathComponent() : null;
        }
        if (q instanceof JList) return get(((JList)q).locationToIndex(p),q);
        if (q instanceof JTable) {
            final JTable t=(JTable)q;
            try { return t.getValueAt( t.rowAtPoint(p),t.columnAtPoint(p)); } catch(Exception e){}
        }
        return null;
    }
    public static Object[] contextObjectsAt(MouseEvent mev) {
        final Object q=mev!=null ? mev.getSource() : null;
        return q instanceof Component ? contextObjectsAt(mev.getPoint(), q) : NO_OBJECT;
    }
    public static Object[] contextObjectsAt(Point p, Object q) {
        return contextObjects(objectAt(p,q), getSelValues(q));
    }

    public static Object[] contextObjects(Object oMouse, Object oo[]) {
        if (oMouse==null) return NO_OBJECT;
        final int i=idxOf(oMouse,oo);
        if (i<0) return new Object[]{oMouse};
        if (oo[0]==oMouse) return oo;
        final Object ooReorder[]=oo.clone();
        ooReorder[0]=oMouse;
        ooReorder[i]=oo[0];
        return ooReorder;
    }
    public final static String KEY_DND_NOT_ITSELF="CU$$DND_NI";
    public static boolean jListDoDnD(AWTEvent mev) {
        if (mev.getID()==MouseEvent.MOUSE_DRAGGED) {
            final JComponent comp=deref(mev.getSource(), JComponent.class);
            if (comp==null) return false;
            final List dndFile=getDndFilesV(comp);
            dndFile.clear();
            for(Object o: ChUtils.contextObjectsAt(point(mev),comp))  {
                if (gcp(KEY_DND_NOT_ITSELF,o)==null) adUniq(o,dndFile);
                for(Object f : oo(o instanceof HasDndFiles ? ((HasDndFiles)o).getDndFiles() : null))
                    if (f!=null && !dndFile.contains(f)) dndFile.add(f);
            }
            if (sze(dndFile)>0 ) exportDrg(comp, mev, TransferHandler.COPY);
        }
        return false;
    }

    public static JPopupMenu jPopupMenu(String parent, Object...oo) {
        final JPopupMenu m=new JPopupMenu(parent);
        m.addPopupMenuListener(chEvLi());
        addToMenu(null,m,oo,parent);
        m.addPopupMenuListener(chEvLi());
        return m;
    }
    /* <<< JPopupMenu <<< */
    /* ---------------------------------------- */
    /* >>> Own GUI elements >>> */
    public static void parseRect(String s, Rectangle r) {
        final String ss[]=splitTokns(0L, s," +xX");
        if (ss.length>0) r.x=atoi(ss[0]);
        if (ss.length>1) r.y=atoi(ss[1]);
        if (ss.length>2) r.width=atoi(ss[2]);
        if (ss.length>3) r.height=atoi(ss[3]);
    }

    public static void radioGrpSet(int idx,Object[] radioGrp) {
        for(int i=sze(radioGrp); --i>=0;) {
            final AbstractButton b=deref(radioGrp[i],AbstractButton.class);
            b.setSelected(i==idx);
        }
    }
    public static int radioGrpIdx(Object evtSource, Object[] radioGrp) {
        if (radioGrp!=null && evtSource!=null) {
            for(Object r : radioGrp) {
                if (evtSource==r || evtSource==gcp(KEY_CLONED_FROM,r)) return radioGrpIdx(evtSource);
            }
        }
        return -1;
    }

    public static int radioGrpIdx(Object o) {
        if (o==null) return -1;
        if (o instanceof Object[]) {
            for(int i=sze(o); --i>=0;)
                if (isSelctd(get(i,o))) return i;
        }
        return radioGrpIdx(gcp(instance(ALI_RADIO),o));
    }
    public static AbstractButton[] radioGrp(String[] ss, int idx, ActionListener ali) {
        final AbstractButton bb[]=new AbstractButton[ss.length];
        final Reference[] rr=new Reference[ss.length];
        for(int i=bb.length; --i>=0;) {
            final ChButton t=toggl(ss[i]).li(ali).s(idx==i);
            t.addActionListener(listener(ALI_RADIO));
            pcp(instance(ALI_RADIO),rr,t);
            rr[i]=weakRef(t);
            bb[i]=t.radio();
        }
        return bb;
    }

    public static void radioGrp(int idx, AbstractButton...bb) {
        final Reference[] rr=new Reference[bb.length];
        for(int i=bb.length; --i>=0;) {
            final AbstractButton b=bb[i];
            if (b==null) continue;
            if (i==idx) b.setSelected(true);
            b.addActionListener(listener(ALI_RADIO));
            pcp(instance(ALI_RADIO),rr,b);
            rr[i]=weakRef(b);
        }
    }

    public static ChButton toggl(String butLabel, long options) { return new ChButton('T',butLabel).options(options);}
    public static ChButton toggl(String butLabel) { return new ChButton('T',butLabel); }
    public static ChButton toggl() { return new ChButton('T',null); }
    public static AbstractButton cbox(boolean selected,String butLabel, String tip) {
        AbstractButton but=new JCheckBox(butLabel);
        but.setToolTipText(addHtmlTagsAsStrg(tip));
        but.setSelected(selected);
        return but;
    }
    public static AbstractButton cbox(String butLabel) { return cbox(false,butLabel,null); }
    private static JLabel blankLabel;
    public static JComponent blankLabel() {
        if (blankLabel==null) blankLabel=new JLabel();
        return blankLabel;
    }
    /* <<< Own GUI elements <<< */
    /* ---------------------------------------- */
    private static Border emptyBorder() {
        Border b=new EmptyBorder(EM,EM,EM,EM);
        return b;
    }
    /* >>> Containers >>> */
    public static boolean toContainr(Container c, Object o, String where) {
        if (c==null || o==null) return false;
        final JMenu jMenu=c instanceof JMenu ? (JMenu)c:null;
        final JPopupMenu jPopup=c instanceof JPopupMenu ? (JPopupMenu)c:null;
        if (jMenu==null && jPopup==null && o instanceof Object[] ) {
            for(Object o1 : (Object[])o) toContainr(c,o1,where);
            return true;
        }
        final String stg=o instanceof String ? (String)o : null;
        final char c0=chrAt(0,stg);

        if (c instanceof JComponent) {
            final JComponent jc=(JComponent)c;
            final Border b=
                o instanceof Border ? (Border)o : c0!='#' ? null :
                stg.startsWith("#TB ") ? new TitledBorder(new EtchedBorder(), stg.substring(4), TitledBorder.LEADING, TitledBorder.DEFAULT_POSITION, null, null) :
                stg.startsWith("#TBem ") ? new CompoundBorder(emptyBorder(),new TitledBorder(stg.substring(6))) :
                o=="#ETB" ? new EtchedBorder() :
                o=="#RBB" ? new BevelBorder(BevelBorder.RAISED) :
                o=="#LBB" ? new BevelBorder(BevelBorder.LOWERED) :
                o=="#ETBem" ? new CompoundBorder(emptyBorder(), new EtchedBorder()) :
                o=="#EBem" ? emptyBorder() :
                null;
            if (b!=null)  { jc.setBorder(b); return true; }
            if (o==OPAQUE_FALSE) { jc.setOpaque(false); return true;}
            if (o instanceof Dimension) { jc.setPreferredSize((Dimension)o); return true;}
        }
        if (o instanceof Color) { c.setBackground((Color)o);  return true;}
        if (o instanceof LayoutManager) { c.setLayout((LayoutManager)o); return true; }
        if (equls(WATCH_MOVIE+"MOVIE:",stg)) {
            final String ss[]=splitTokns(0L, stg);
            JComponent jc=ss.length>1 ? pnl() : null;
            for(String s0 : ss) {
                String s=delPfx(WATCH_MOVIE,s0);
                final ChButton b=ChButton.actionOpenURL(s).t("Watch Movie "+ delPfx("MOVIE:",delSfx("*", s)).replace('_',' '));
                noMargn(b.tt("Watch movie").i(IC_MOVIE));
                if (jc!=null) jc.add(b); else jc=b;
            }
            if (jc!=null) c.add(jc,where);
            return true;
        }
        if (o instanceof File || o instanceof URL ||
            stg!=null && (looks(LIKE_EXTURL,stg) || looks(LIKE_FILEPATH_EVALVAR,stg)  || stg.startsWith("WIKI:") || stg.startsWith("?:/"))) {
            c.add(rtt(monospc(o)),where);
            return true;
        }
        if (stg!=null) {
            if (o=="#") { c.add(Box.createHorizontalGlue());return true;}
            if (o=="##") { c.add(Box.createVerticalGlue()); return true;}
            if (o=="#JS")  { c.add(new JSeparator(),where); return true;}
            if (o==SCROLLABLE_TRACKS_VIEWPORT_WIDTH || o==SCROLLABLE_TRACKS_VIEWPORT_HEIGHT) { pcp(o,"",c); return true;}
        }
        if (jMenu==null && jPopup==null) {
            final Component comp=
                o instanceof CharSequence ? new JLabel(rmTrailingImport(addHtmlTagsAsStrg(o))) :
                o instanceof Icon ? new JLabel((Icon)o) :
                o instanceof Component ? (Component)o :
                null;
            if (comp!=null) {
                if ((where=="p" || where=="b") && !(comp instanceof JPanel)) c.add(where=="p" ? pnl(comp) : hBL(comp));
                else c.add(comp,where);
                return true;
            }
        } else {
            if (jMenu!=null) {
                if (o=="-") { jMenu.addSeparator(); return true; }
                if (o instanceof JMenu) { jMenu.add((JMenu)o); return true; }
            } else if (jPopup!=null) {
                if (o=="-") { jPopup.addSeparator(); return true; }
            }
            if (stg!=null && !stg.startsWith(_CC)) { c.add(enlargeFont(new ChLabel(stg).fg(C(0x6464ff)),0.85)); return true; }
        }
        return false;
    }
    private static String rmTrailingImport(String s) {
        final int i=s.indexOf("<i>"+HtmlDoc.PACKAGE);
        return i>0 ? s.substring(0,i) : s;
    }
    private static JComponent hB() {
        ChPanel pan=new ChPanel();
        pan.setLayout(new BoxLayout(pan,BoxLayout.X_AXIS));
        return pan;
    }
    public static <T extends Object> JComponent hBL(T... oo) { JComponent b=hB(oo); b.add(Box.createHorizontalGlue());  return b;  }
    public static <T extends Object> JComponent hB(T... oo) { JComponent b=hB();  toContainr(b,oo,""); return b;  }
    public static <T extends Object> JComponent vB(T... oo) {
        final ChPanel b=new ChPanel();
        b.setLayout(new BoxLayout(b,BoxLayout.Y_AXIS));
        toContainr(b,oo,"");
        return b;
    }

    public static <T extends Object> JComponent vBpnl(T... oo) {
        ChPanel b=new ChPanel();
        b.setLayout(new BoxLayout(b,BoxLayout.Y_AXIS));
        toContainr(b,oo,"p");
        return b;
    }
    public static <T extends Object> JComponent vBhB(T... oo) {
        ChPanel b=new ChPanel();
        b.setLayout(new BoxLayout(b,BoxLayout.Y_AXIS));
        toContainr(b,oo,"b");
        return b;
    }
    public static <T extends Object> JComponent pnl(T... oo) {ChPanel p=new ChPanel(); toContainr(p,oo,""); return p; }
    public static JComponent cnsew(Container p,Object center,Object north, Object south,Object east, final Object west) {
        if (p!=null) {
            p.setLayout(new BorderLayout());
            toContainr(p,center,BorderLayout.CENTER);
            toContainr(p,west,BorderLayout.WEST);
            toContainr(p,east,BorderLayout.EAST);
            toContainr(p,north,BorderLayout.NORTH);
            toContainr(p,south,BorderLayout.SOUTH);
        }
        return (JComponent)p;
    }
    public static JComponent newCNSEW(Object center,Object north, Object south,Object east, Object west) {
        return (ChPanel)cnsew(new ChPanel(),center,north,south,east,west);
    }
    public static Component getPnl(Object o) {
        final Component gcp=gcp(KEY_PANEL,o,Component.class);
        try {
            return
                gcp!=null ? gcp :
                o instanceof JPanel || o instanceof JScrollPane ? (Component)o :
                isInstncOf(HasPanel.class,o) ? ((HasPanel)o).getPanel(0) :
                o instanceof Component ? (Component)o :
                null;
        } catch(Exception e){return null;}
    }
    /* <<< Containers <<< */
    /* ---------------------------------------- */
    /* >>> PrgParas >>> */
    public static Container getSharedCtrlPan(Object objectOrClass, boolean createOne) {
        final Object o= instanceFromClassOrCombo(objectOrClass);
        final HasSharedControlPanel hasSC=deref(o,HasSharedControlPanel.class);
        final HasPrgParas hasPP=deref(o,HasPrgParas.class);
        Container pan=hasSC!=null ? hasSC.getSharedControlPanel() : null;
        if (pan==null && hasPP!=null) {
            final PrgParas paras=hasPP.getPrgParas();
            final PrgParasGUI gui=paras!=null ? paras.getGUI(createOne) : null;
            pan=gui!=null ? gui.getPanel() : null;
        }
        if (pan==null && isAssignblFrm(HasNativeExec.class,o)) pan=getSharedCtrlPan( ((HasNativeExec)o).getNativeExec(), createOne);
        return pan;
    }
    private static Map<Object,Object> mapInst=new WeakHashMap();
    private static Object instanceFromClassOrCombo(Object o) {
        if (o==null) return null;
        Object inst=o;
        if (o instanceof Class || o instanceof charite.christo.hotswap.ProxyClass)  {
            inst=mapInst.get(o);
            if (inst==null) mapInst.put(o,inst=HotswapUtil.instance(o));
        } else if (o instanceof ChCombo) inst=((ChCombo)o).instanceOfSelectedClass(null);
        return inst;
    }

    public static boolean hasSharedControlPanel(Object objectOrClass) {
        if (isAssignblFrm(HasSharedControlPanel.class,objectOrClass)) return true;
        final Object o=instanceFromClassOrCombo(objectOrClass);
        final HasPrgParas hasPP=deref(o,HasPrgParas.class);
        if (hasPP!=null && hasPP.getPrgParas()!=null && hasPP.getPrgParas().hasGUI()) return true;
        if (isAssignblFrm(HasNativeExec.class, o)) return hasSharedControlPanel( ((HasNativeExec)o).getNativeExec());
        return false;
    }
    public static void setSharedParas(Object shared, Object inst) {

        if (inst!=null && shared!=null) {
            if (isAssignblFrm(NeedsSharedInstance.class, inst)) ((NeedsSharedInstance)inst).setSharedInstance(shared);
            if (isAssignblFrm(HasPrgParas.class, inst) && isAssignblFrm(HasPrgParas.class, shared) ) {
                final PrgParasGUI gui=((HasPrgParas)shared).getPrgParas().getGUI(false);
                ((HasPrgParas)inst).getPrgParas().setGUI(gui);
            }
            if (isAssignblFrm(HasNativeExec.class, inst) && isAssignblFrm(HasNativeExec.class, shared) ) {
                setSharedParas(((HasNativeExec)shared).getNativeExec(), ((HasNativeExec)inst).getNativeExec());
            }
        }

    }
    public final static Class[] CLASS_MAY_HAVE_CTRL_PANEL={HasControlPanel.class, AbstractExecutable.class, HasNativeExec.class};
    public static Container getCtrlPanel(Object o) {
        if (o==null) return null;
        Container pan=null;
        if (isAssignblFrm(HasControlPanel.class, o)) pan=((HasControlPanel)o).getControlPanel();
        if (isAssignblFrm(AbstractExecutable.class,o)) pan=getCtrlPanel(((AbstractExecutable)o).exec());
        if (pan==null && isAssignblFrm(HasNativeExec.class, o)) pan=getCtrlPanel(((HasNativeExec)o).getNativeExec());
        return pan;
    }

    /* <<< PrgParas <<< */
    /* ---------------------------------------- */
    /* >>> EventListener >>> */
    private final static int
    MOMOLI_DRAG_WITH_ALT=3,
        MOMOLI_DRAG_MENU_ITEM=4, MOMOLI_AUTO_SCROLL=6, MOMOLI_DRAG_false=7, MOMOLI_DRAG_true=8, MOMOLI_DRAG_WIN=9, MOMOLI_PANEL_UNDOCK=10,
        ALI_RADIO=22, ALI_REPAINT_UNDOCKED=23,
        MOLI_LEFT_TO_MIDDLE=31, MOLI_REFRESH_TIP=32, MOLI_REPAINT_ON_ENTER_AND_EXIT=33, MOLI_OVER_PRINT=34, MOLI_ACTION_LISTENER=35, MOLI_updateUI=36,
        MOLI_RESCUE_MENUBAR=37, MOLI_TAB=38, MOLI_REVALIDATE1=39,
        KLI_CTRLW_DISPOSE=41, KLI_SHIFT_TIP=44,
        WLI_SCROLL=50,
        MOLI_TIP_DELAY=51;

    private ChEventAdapter _listener;
    public ChEventAdapter listener() { if (_listener==null) _listener=new ChEventAdapter(this); return _listener; }
    private static ChEventAdapter listener(int id) { return instance(id).listener();}

    private final static ChUtils[] instance=new ChUtils[100];
    private static ChUtils instance(int id) { if (instance[id]==null) instance[id]=new ChUtils(); return instance[id];}

    private final static void addMoli(int id, Component c) {
        final MouseListener li=listener(id);
        if (c!=null) { c.removeMouseListener(li); c.addMouseListener(li); }
    }
    private final static MouseMotionListener addMomoli(int id, Component c) {
        final MouseMotionListener li=listener(id);
        if (c!=null) {  c.removeMouseMotionListener(li); c.addMouseMotionListener(li);}
        return li;
    }
    public static Component setUndockble(JComponent c) {
        addMomoli(MOMOLI_DRAG_MENU_ITEM,c);
        if (c instanceof AbstractButton) ((AbstractButton)c).addActionListener(listener(ALI_REPAINT_UNDOCKED));
        return c;
    }

    public static MouseMotionListener dragWithAltKey(JComponent c) { return addMomoli(MOMOLI_DRAG_WITH_ALT,c); }
    public static void actionEventWhenClicked(JComponent c, ActionListener al) { addMoli(MOLI_ACTION_LISTENER,c); pcp(instance(MOLI_ACTION_LISTENER),new java.lang.ref.WeakReference(al),c);}
    public static void addMoliRefreshTip(Component c) { addMoli(MOLI_REFRESH_TIP, c);}
    public static void generateMiddleForLeftButton(JComponent c) { addMoli(MOLI_LEFT_TO_MIDDLE,c);}
    public static void repaintOnMouseEnterAndExit(Component c) { addMoli(MOLI_REPAINT_ON_ENTER_AND_EXIT,c); }
    public static void setAutoscr(JComponent c) { addMomoli(MOMOLI_AUTO_SCROLL, c); c.setAutoscrolls(true);}
    public static void setDragMovesWindow(Component c,Window w) { addMomoli(MOMOLI_DRAG_WIN, c); pcp(instance(MOMOLI_DRAG_WIN),w,c); }
    public static void setTipDelay(JComponent c, int delayMS) { addMoli(MOLI_TIP_DELAY,c);  pcp(instance(MOLI_TIP_DELAY),intObjct(delayMS),c); }
    public static void shiftTooltip(JComponent c) {addMoli(KLI_SHIFT_TIP,c); addMomoli(KLI_SHIFT_TIP,c); }
    public static void updateUI_whenMouseEnter(JComponent c) { addMoli(MOLI_updateUI,c); };
    public static void revalidate_whenMouseEnter1(boolean childs, Component c) {
        if (childs && c instanceof Container) {
            for(Component child : ((Container)c).getComponents()) {
                revalidate_whenMouseEnter1(true, child);
            }
        }
        if (!(c instanceof JPanel)) addMoli(MOLI_REVALIDATE1,c);
    }

    public static void scrollByWheel(Component c) {
        final MouseWheelListener li=listener(WLI_SCROLL);
        if (c!=null) { c.removeMouseWheelListener(li); c.addMouseWheelListener(li); }
    }
    private static boolean isPopupShown;
    private static EvLi chEvLi;
    private static EvLi chEvLi() { if (chEvLi==null) chEvLi=new EvLi(); return chEvLi; }
    private static class EvLi implements ListSelectionListener, TreeSelectionListener, PopupMenuListener, MenuListener {
        public void valueChanged(ListSelectionEvent ev) { ChUtils.selectionChanged(ev);}
        public void popupMenuCanceled(PopupMenuEvent e) { ChUtils.isPopupShown=false; }
        public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {ChUtils.isPopupShown=false; }
        public void popupMenuWillBecomeVisible(PopupMenuEvent e) { ChUtils.isPopupShown=true; ChUtils.callSetEnabled(e); }
        public void valueChanged(TreeSelectionEvent ev) { ChUtils.selectionChanged(ev);}
        public void menuSelected(MenuEvent e){
            ChUtils.handleActEvt(e.getSource(), ACTION_MENU_SELECTED, 0);
            ChUtils.callSetEnabled(e);

        }
        public void menuDeselected(MenuEvent e){}
        public void menuCanceled(MenuEvent e){}

    }

    private static void callSetEnabled(EventObject e) {
        final Object q=e.getSource();
        final Component[] cc=q instanceof JMenu ? ((JMenu)q).getMenuComponents() : q instanceof JComponent ? ((JComponent)q).getComponents() : null;
        if (cc!=null)  for(Component c:cc) c.setEnabled(c.isEnabled());
    }

    /* <<< EventListener <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    public static int buttn(AWTEvent ev) {
        return ev instanceof MouseEvent ? ((MouseEvent)ev).getButton() : -1;
    }

    public static int modifiers(Object event) {
        if (event instanceof AWTEvent) setEventLocationOnScreen(event);
        return
            event instanceof InputEvent ? ((InputEvent)event).getModifiers() :
            event instanceof ActionEvent ? ((ActionEvent)event).getModifiers() :
            0;
    }
    public static int wheelRotation(Object event) { return event instanceof MouseWheelEvent ? ((MouseWheelEvent)event).getWheelRotation() : 0; }
    public static String actionCommand(Object event) {
        if (!(event instanceof ActionEvent)) return null;
        final String cmd=((ActionEvent)event).getActionCommand();
        assert ((ActionEvent)event).getID()==ActionEvent.ACTION_PERFORMED;
        return cmd!=null ? cmd :"";
    }
    public static char keyChar(Object event) { return event instanceof KeyEvent ? ((KeyEvent)event).getKeyChar():0;}

    public static int keyCode(Object event) {
        if (event instanceof KeyEvent) {
            final char c=((KeyEvent)event).getKeyChar();
            return c=='+' ? VK_PLUS : c=='-' ? VK_MINUS :  c=='*' ? VK_ASTERISK : ((KeyEvent)event).getKeyCode();
        }
        return 0;
    }
    public static int x(AWTEvent ev) { return ev instanceof MouseEvent ? ((MouseEvent)ev).getX() : 0;}
    public static int y(AWTEvent ev) { return ev instanceof MouseEvent ? ((MouseEvent)ev).getY() : 0;}
    public static Point point(AWTEvent ev) { return ev instanceof MouseEvent ? ((MouseEvent)ev).getPoint() : null;}
    public static int clckCount(AWTEvent ev) { return ev instanceof MouseEvent ? ((MouseEvent)ev).getClickCount() : 0;}

    private final static Point pointTmp=new Point();
    private static synchronized Point pointScreen(AWTEvent ev) {
        if (ev instanceof MouseEvent) {
            pointTmp.x=x(ev);
            pointTmp.y=y(ev);
            SwingUtilities.convertPointToScreen(pointTmp, (Component)ev.getSource());
        } else pointTmp.x=pointTmp.y=0;
        return pointTmp;
    }
    public static int xScreen(AWTEvent ev) { synchronized(pointTmp) { return pointScreen(ev).x; } }
    public static int yScreen(AWTEvent ev) { synchronized(pointTmp) { return pointScreen(ev).y; } }

    public static int shortCutMask() { return isMacintosh() ? Toolkit.getDefaultToolkit().getMenuShortcutKeyMask():CTRL_MASK; }
    public static boolean isCtrl(Object ev) { return (modifiers(ev)& (shortCutMask()|CTRL_MASK))!=0;}
    public static boolean isShift(Object ev) { return (modifiers(ev)&SHIFT_MASK)!=0;}
    public static boolean isAlt(Object ev) { return (modifiers(ev)&ALT_MASK)!=0;}
    public static int scaleUpDown(Object ev) {
        if (!isCtrl(ev)) return 0;
        final int rotation=wheelRotation(ev);
        if (rotation!=0) return rotation<0 ?-1:1;
        final int c=keyCode(ev);
        return  c==VK_ADD || c==VK_PLUS  ? 1 : c==VK_MINUS ? -1 : 0;
    }
    private static int lastMouseMovedX,lastMouseMovedY;
    private static AWTEvent lastMouseMoveEvt;
    public static AWTEvent getLastEvt(int type) {
        return type==MOUSE_MOVED ? lastMouseMoveEvt :
            null;
    }
    // getLastAWTEvt
    private static boolean isDragged;
    private Point draggedFrom;
    protected static int[] EVT_LAST_XY={0,0};
    public static void setEventLocationOnScreen(Object evtOrComponent) {
        EVT_LAST_XY[0]=EVT_LAST_XY[1]=300;
        final AWTEvent ev=evtOrComponent instanceof AWTEvent ? (AWTEvent)evtOrComponent : null;
        final Component c=deref(ev!=null ? ev.getSource() : evtOrComponent, Component.class);
        if (c!=null && c.isShowing()) {
            try {
                final Point
                    p=c.getLocationOnScreen(),
                    pM= ev instanceof MouseEvent ?  ((MouseEvent)ev).getPoint() : null;
                EVT_LAST_XY[0]= (pM!=null?pM.x:0) + (p!=null?p.x:0);
                EVT_LAST_XY[1]= (pM!=null?pM.y:0) + (p!=null?p.y:0);
            } catch(Exception e){putln("setEventLocationOnScreen caught: ",e," ",clazz(c));}
        }
    }
    private static Component lastMouseMovedComponent, focusedComponent;
    private static Rectangle rect;

    public AWTEvent processEvent(JComponent jcomponent, java.awt.AWTEvent ev) {
        final int ID=ev.getID();
        final Object q=ev.getSource();
        final MouseEvent mev= ev instanceof MouseEvent ? (MouseEvent)ev:null;
        final int kc=keyCode(ev);
        final int x=mev!=null? mev.getX() : 0;
        final int y=mev!=null? mev.getY() : 0;
        final int modi=modifiers(ev);
        final boolean ctrl=isCtrl(ev), isSelctd=isSelctd(q);
        final JComponent jc= q instanceof JComponent ? (JComponent)q:null;
        final int w=jc!=null ? jc.getWidth() : 0, h=jc!=null ? jc.getHeight() : 0;
        final int inst=idxOf(this,instance);
        if (inst==MOLI_TAB) {
            if (ID==MOUSE_CLICKED) {
                final JComponent comp=gcp(KEY_tabComponent,q,JComponent.class);
                if (y<EM && x>w-EM) {
                    for(Disposable d : disposabls(comp)) {
                        dispos((modi&MouseEvent.CTRL_MASK)==0 ? OPTION_DISPOSE_ASK_CTRL : 0L, d);
                    }
                } else {
                    final JTabbedPane tp=gcp(KEY_JTabbedPane,jc,JTabbedPane.class);
                    if (tp!=null) {
                        tp.setSelectedComponent(comp);
                        if (null!=gcp(KEY_NEEDS_REVALIDATE,tp)) ChDelay.revalidate(tp,99);
                    }
                }
            }
        }
        if (inst==MOMOLI_PANEL_UNDOCK) {
            final Object undockable=gcp(KEY_undockableComponent,q);
            if (ID==MOUSE_DRAGGED && (x<0 || y<0 || x>w || y>h) && undockable!=null) {
                panelUndock(undockable,xScreen(ev)-EM,yScreen(ev)-EM);
            }
        }
        if (ID==MOUSE_ENTERED||ID==MOUSE_EXITED) {
            if (inst==MOLI_REFRESH_TIP) { rtt(jc); ToolTipManager.sharedInstance().setEnabled(true); }
            if (inst==MOLI_REPAINT_ON_ENTER_AND_EXIT && jc!=null) jc.repaint();
            if (inst==KLI_SHIFT_TIP) {
                Component f=focusedComponent=KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
                if (f!=null) {
                    f.removeKeyListener(listener(KLI_SHIFT_TIP));
                    if (ID==MOUSE_ENTERED) f.addKeyListener(listener(KLI_SHIFT_TIP));
                }
            }
            if (inst==MOLI_OVER_PRINT) {
                final Object[] para=gcp(this,q,Object[].class);
                final Object strg=para[0];
                final int dx=atoi(para[1]);
                final Component comp=(Component)deref(para[3]);
                if (comp!=null && strg!=null) {
                    final Point p=SwingUtilities.convertPoint(jc,  x,  y, comp);
                    if (p.y>=0 && p.y<=comp.getHeight()) {
                        final Graphics g=comp.getGraphics();
                        final int compW=comp.getWidth();
                        final Font f=(Font)para[4];
                        if (g!=null) {
                            if (f!=null) g.setFont(f);
                            int dy=atoi(para[2]);
                            for(Object o:oo(strg)) {
                                final String s=toStrg(o);
                                if (s==null) continue;
                                final int sw=strgWidth(g,toStrg(s));
                                final int X=dx+ (dx<0?compW-sw:0);
                                g.setColor(Color.WHITE);
                                g.fillRect(X,dy,sw,charH(g));
                                g.setColor(Color.BLUE);
                                g.drawString(s, X,   charA(g)+dy);
                                dy+=charH(g);
                            }
                        }
                    } else comp.repaint();
                }
            }
            if (inst==MOLI_TIP_DELAY) setTipTiming(ID==MOUSE_EXITED ? -1:atoi(gcp(this,q)),0);
        }
        if (ID==MOUSE_ENTERED) {
            if (inst==MOLI_RESCUE_MENUBAR) rescueMenuBar((JMenuBar)gcp(KEY_RESCUE_MENUB,q));
            if (inst==MOLI_updateUI || inst==MOLI_REVALIDATE1) {
                jc.removeMouseListener(listener());
                if (inst==MOLI_updateUI)  jc.updateUI();
                if (inst==MOLI_REVALIDATE1) jc.revalidate();
            }
        }
        if (ID==MOUSE_CLICKED) {
            if  ( (inst==KLI_CTRLW_DISPOSE) && q instanceof Component) ((Component)q).requestFocus();
            final ActionListener al=(ActionListener)gcp(instance(MOLI_ACTION_LISTENER),q);
            if (al!=null) {
                final int n=mev.getClickCount();
                final Object[] para={al,new ActionEvent(q,ActionEvent.ACTION_PERFORMED, n>1 ? ACTION_CLICKED2 : ACTION_CLICKED)};
                ChDelay.runAfterMS(EDT,ChDelay.newThread(this,"actionPerformed",para),111);
            }
        }
        if (q instanceof ChJList && mev!=null && !ChUtils.isPopupShown && (gcp(KEY_CONTEXT_OBJECTS,q)!=null || q==listsUndock()[0])) {
            final ChJList lst=(ChJList)q;
            setEventLocationOnScreen(ev);
            if (ID!=MOUSE_EXITED) {
                final Object co=gcp(KEY_CONTEXT_OBJECTS,q);
                if (co!=null) {
                    KEY_CONTEXT_OBJECTS[0]=co;
                }
            }
            final Object lastBut=gcp("L",lst);
            final int row=y/ICON_HEIGHT;
            final AbstractButton but=get(row,lst,AbstractButton.class);
            for(int iL=sze(vHotlistL); --iL>=0;) {
                final ChJList jList=get(iL,vHotlistL,ChJList.class);
                final List v=jList!=null ? jList.getList() : null;
                for(int i=sze(v); --i>=0;) {
                    ChRenderer.setSmallButtonXc( MIN_INT, v.get(i));
                }
            }
            if (but!=null) {
                if (ID==MOUSE_CLICKED) {
                    if (x>w-EM && 1+y%ICON_HEIGHT<EM) {
                        final List v=lst.getList();
                        if (v!=null) v.remove(but);
                        final int height=sze(lst)*ICON_HEIGHT;
                        if (lst==listsUndock()[0]) {
                            if (sze(lst)==0) hotlistW.setVisible(false); else hotlistW.setSize(222,height);
                        } else lst.revalidate();
                        lst.setPreferredSize(dim(666,height));
                        lst.repaint();
                    } else but.doClick();
                }
                if (ID==MOUSE_MOVED && but!=lastBut) {
                    pcp("L",but,lst);
                    final String tt,btt=but.getToolTipText(), t0=but.getText();
                    if (btt==null) tt=t0;
                    else {
                        final StringBuffer sb=new StringBuffer(btt);
                        if (sb.indexOf("<body>")<0) sb.append("</body></html>").insert(0,"<html><body>");
                        if (t0!=null) {
                            String t=t0.indexOf("<body>")>0?t0.substring(t0.indexOf("<body>")+6) : t0;
                            if (t.indexOf("</body>")>0) t=t.substring(0,t.indexOf("</body>"));
                            sb.insert(sb.indexOf("<body>")+6,t);
                        }
                        tt=sb.toString();
                    }
                    lst.setToolTipText(tt);
                    rtt(lst);
                    lst.setCursor(getCursr('D'));
                    // but.setSelected(false); ???
                    lst.clearSelection();
                    lst.repaint();
                }
            }
            final int cb=ID==MOUSE_EXITED ? 0 : ID==MOUSE_MOVED || ID==MOUSE_ENTERED ? w-EM-3 : MIN_INT;
            if (ChRenderer.setSmallButtonXc( cb, but))  lst.repaint();

            // if (cb!=gcp(ChRenderer.KEY_TINY_CLOSE_BUT,but)) { pcp(ChRenderer.KEY_TINY_CLOSE_BUT, cb,but); lst.repaint(); }
            if (ID==MOUSE_ENTERED || ID==MOUSE_RELEASED) {
                final ChJList
                    target=gcp(KEY_MENU_ITEM_TARGET,q,ChJList.class),
                    items=target!=null ? target:lst;
                if (items!=null) enableDisableMenuItemTargets(items);
            }
        }
        if (inst==MOLI_LEFT_TO_MIDDLE && ID==MOUSE_PRESSED && (modi & BUTTON1_MASK)!=0) {
            processEvt(new MouseEvent(jc,ID, mev.getWhen(), 0, x,  y, 1,false,BUTTON2),q);
        }
        if (ID==MOUSE_PRESSED && parnt(jc,JMenuBar.class)!=null) setMenuItemTarget(null);
        if (ID==MOUSE_MOVED) {
            if (jc!=null) {
                draggedFrom=null;
                if (inst==KLI_SHIFT_TIP) pcp(this,mev,focusedComponent);
                Point lp=gcp(KEY_DRAG,jc,Point.class);
                if (lp==null) pcp(KEY_DRAG,lp=new Point(),jc);
                lp.x=x;
                lp.y=y;
                SwingUtilities.convertPointToScreen(lp,jc);
                isDragged=false;
            }
            if (ID==MOUSE_MOVED) {
                lastMouseMovedComponent=(Component)ev.getSource();
                lastMouseMovedX=x;
                lastMouseMovedY=y;
                lastMouseMoveEvt=ev;
            }
        }
        if (ID==KEY_PRESSED) {
            final boolean hitCtrlW= kc==VK_W && ctrl || kc==VK_F4 &&  modi==ALT_MASK;
            if (inst==KLI_CTRLW_DISPOSE) {
                final Object[] pp=(Object[]) gcpa(this, q);
                final long options=atol(pp[0]);
                for(int i=1; i<pp.length; i++) {
                    final Object toBeClosed=get(i,pp);
                    if (toBeClosed==null) continue;
                    if (hitCtrlW      && (options&DISPOSE_ON_CtrlW)!=0 ||
                        kc==VK_ESCAPE && (options&DISPOSE_ON_ESC)!=0) {
                        dispos(0L,toBeClosed);
                    }
                    if (hitCtrlW      && (options&CLOSE_ON_CtrlW)!=0 ||
                        kc==VK_ESCAPE && (options&CLOSE_ON_ESC)!=0) {
                        invokeMthd("close",toBeClosed);
                        invokeMthd("setVisible",toBeClosed,new Object[]{FALSE}, 0L);
                    }
                    if (hitCtrlW  && (options&RM_TAB_ON_CtrlW)!=0) {
                        Component component=(Component)toBeClosed;
                        Container parent=component!=null ? component.getParent() : null;
                        while(parent!=null) {
                            final Object ctp=gcp(ChTabPane.class, component);
                            if (ctp instanceof ChTabPane) {
                                ((ChTabPane)ctp).removeTab((JComponent)component);
                                break;
                            }
                            if (parent instanceof JTabbedPane) {
                                parent.remove(component);
                                break;
                            }
                            component=parent;
                            parent=parent.getParent();
                        }
                    }
                }
            }
            if (inst==KLI_SHIFT_TIP) {
                final MouseEvent mEvt=gcp(this,q,MouseEvent.class);
                final Object underMouse=mEvt!=null ? mEvt.getSource() : null;
                if (kc==VK_SHIFT && underMouse!=null) {
                    ToolTipManager.sharedInstance()
                        .mouseMoved(new MouseEvent((Component)underMouse,MOUSE_MOVED,currentTimeMillis(),SHIFT_MASK,mEvt.getX()-1,mEvt.getY(),0,false));
                }
            }
        }
        if (ID==MOUSE_DRAGGED) {
            if (rect==null) rect=new Rectangle();
            final Container container=q instanceof Container ? (Container)q : null;
            final boolean alt=isAlt(ev);
            if (inst==MOMOLI_AUTO_SCROLL && jc!=null) {
                rect.x=x; rect.y=y; rect.width=rect.height=1;
                jc.scrollRectToVisible(rect);
            }
            if (inst==MOMOLI_DRAG_WIN && container!=null) {
                final Window wind=gcp(this,q,Window.class);
                if (wind!=null) {
                    final Point np=new Point(x,y);
                    if (!isDragged) pcp(SYNC_CPY,SwingUtilities.convertPoint(container, np, wind),container);
                    else { //Window
                        final Point point0=gcp(SYNC_CPY,container,Point.class);
                        if (point0!=null) {
                            SwingUtilities.convertPointToScreen(np,container);
                            wind.setBounds(np.x-point0.x, np.y-point0.y, wind.getWidth(), wind.getHeight());
                        }
                    }
                }
            }
            if (inst==MOMOLI_DRAG_WITH_ALT || inst==MOMOLI_DRAG_true || inst==MOMOLI_DRAG_false) {
                JScrollPane sp=gcp(this,q,JScrollPane.class);
                if (sp==null) sp=getJScrollPane(container);
                if (( alt || inst==MOMOLI_DRAG_true || inst==MOMOLI_DRAG_false) && sp!=null) {
                    final Point lp=gcp(KEY_DRAG,container,Point.class);
                    final Point np=new Point(x,y);
                    pcp(KEY_DRAG,np,container);
                    SwingUtilities.convertPointToScreen(np,container);
                    if (draggedFrom==null) { draggedFrom=np; }
                    for(boolean isX : FALSE_TRUE) {
                        final JScrollBar sb=isX ? sp.getHorizontalScrollBar() : sp.getVerticalScrollBar();
                        if (sb==null || (!sb.isVisible()&&gcp(KEY_SCROLL_EVEN_IF_INVISIBLE,sb)==null)) continue;
                        if (draggedFrom==np) pcp(this,intObjct(sb.getValue()),sb);
                        if( lp!=null) {
                            final int d=isX ? draggedFrom.x-np.x : draggedFrom.y-np.y;
                            sb.setValue( maxi(0,mini(sb.getMaximum(),atoi(gcp(this,sb))+ d)));
                        }
                    }
                }
            }
            if (inst==MOMOLI_DRAG_MENU_ITEM && isDragged && equls(_CC,clazzName(container),0) && lastMouseMovedComponent==container)
                undockItm(container, ev, listsUndock()[1]);
            isDragged=true;
        }
        if (ID==MouseWheelEvent.MOUSE_WHEEL) {
            final int rotation=wheelRotation(ev);
            if (rotation!=0 && !ctrl) {
                if (inst==WLI_SCROLL) {
                    final JComponent jComp=deref(q,JComponent.class);
                    final JScrollPane sp= parnt(parnt(jComp,JComponent.class),JScrollPane.class);
                    if (sp!=null) {
                        final JScrollBar sV=sp.getVerticalScrollBar(), sH=sp.getHorizontalScrollBar(), sb=!isShift(ev) && sV!=null && sV.isVisible() ? sV : sH!=null ? sH : sV;
                        if (sb!=null) {
                            final int charH=charBounds(jComp.getFont()).height;
                            sb.setValue(sb.getValue() + (rotation<0 ? -charH : charH));
                        }
                    }
                }
            }
        }
        if (ID==ActionEvent.ACTION_PERFORMED && q!=null) {
            final String cmd=actionCommand(ev);
            if (q==togAntialiasing) setAntiAlias(isSelctd?'t':'f');
            if (q==cbCache) CacheResult.setEnabled(cbCache.s());
            if (cmd==ACTION_WINDOW_CLOSING && undockEnabled==null && q==parentWndw(undockEnabled_pnl)) undockEnabled=FALSE;
            if (cmd=="E_UNDOCK") {
                undockEnabled=isSelctd ? TRUE : FALSE;
                final Runnable r=gcpClear("R",undockEnabled_pnl, Runnable.class);
                if (isSelctd && r!=null) r.run();
                final Frame f=(Frame)parentWndw(undockEnabled_pnl);
                if (f!=null) f.dispose();
            }
            if (cmd=="FTP") setEdtFTP(isSelctd);
            if (cmd=="TEST_PROXY") {
                if (taProxy==null) {
                    taProxy=new ChTextArea("").ro();
                    final Object panSouth=
                        vB(
                           pnl("Modify list of test URLs ",Customize.newButton(Customize.testProxySelector).i(null)),
                           " ",
                           hBL("Command-line parameters which would be used for .../bin/java"),
                           monospc(joinLines(commandLineParametersForProxy())),
                           " ",
                           hB("The following may solve FTP problems:"),
                           hBL(toggl("FTP").t("Use edtFTPj for addresses starting with \"ftp://\"").li(listener()).cb(),smallHelpBut(AnonymousFTPPROXY.class))
                           ),
                        title="<h2>Test proxy settings</h2>"+
                        "For some example addresses the Web proxy is shown that would be used by Java. Click addresses to test the Internet access.";
                    pnlProxy=newCNSEW(taProxy, newCNSEW(title,null,null,smallHelpBut(Web.class),null),panSouth,null,null);
                    addActLi(listener(),Customize.customize(Customize.testProxySelector));
                }
                taProxy.t(testProxySelector()).tools().underlineRefs(0);
                ChFrame.frame("Result testing Web proxy",pnlProxy, ChFrame.STAGGER|ChFrame.ALWAYS_ON_TOP|ChFrame.PACK).shw(0);
            }
            if (q==Customize.customize(Customize.testProxySelector) && taProxy!=null) taProxy.t(testProxySelector());
            if (inst==ALI_RADIO) {
                final Object o=gcp(this,q);
                for(int i=sze(o); --i>=0;) {
                    final AbstractButton but=get(i,o,AbstractButton.class);
                    if (but!=null && but!=q) but.setSelected(false);
                }
            }
            if (inst==ALI_REPAINT_UNDOCKED) {
                for(ChJList l : listsUndock()) if (l!=null) l.repaint();
            }
            if (cmd==ACTION_WINDOW_CLOSING) {
                panelDock(gcp(KEY_dock_component,q));
            }
        }
        if (ID==MOUSE_ENTERED) {
            for(ChJList l : listsUndock()) {
                List v=l!=null ? l.getList() : null;
                for(int i=sze(v); --i>=0;) {
                    final Object depends=gcpa(KEY_DEPENDS_ON, get(i,v));
                    if (depends instanceof Object[] && get(0,depends)==null) {
                        v.remove(i);
                        l.revalidate();
                    }
                }
            }
        }
        return ev;
    }
    public static void closeOnKeystroke(Component evtSrc, Object toBeClosed[], long option) {
        if (evtSrc==null  || countNotNull(toBeClosed)==0) return;
        final ChEventAdapter li=listener(KLI_CTRLW_DISPOSE);
        final Object key=instance(KLI_CTRLW_DISPOSE), refs[]=new Object[toBeClosed.length+1];
        for(int i=toBeClosed.length; --i>=0;) refs[i+1]=weakRef(toBeClosed[i]);
        refs[0]=longObjct(option);
        pcp(key, refs,evtSrc);
        evtSrc.removeKeyListener(li);
        addMoli(KLI_CTRLW_DISPOSE,evtSrc);
        evtSrc.addKeyListener(li);
    }
    public static void recursiveRemoveAllListeners(JComponent c0) {
        if (c0==null) return;
        for(Component c: c0.getComponents()) {
            if (c instanceof JComponent)
                recursiveRemoveAllListeners((JComponent)c);
        }
        removeAllListeners(c0);
    }
    public static JComponent removeAllListeners(JComponent c) {
        pcp(KEY_DISABLE_EVENTS,"",c);
        if (c instanceof JTable || c instanceof JList) c.setEnabled(false);
        for(Class listenerType : new Class[]{MouseListener.class,MouseMotionListener.class,ActionListener.class, ChangeListener.class}) {
            for(EventListener l : c.getListeners(listenerType)) {
                final String method="remove"+shrtClasNam(listenerType);
                invokeMthd(method,c,new Object[]{l},0L);
            }
        }
        return c;
    }
    public static boolean isPopupTrigger(AWTEvent ev) {
        if (!(ev instanceof MouseEvent)) return false;
        final int id=ev.getID();
        final MouseEvent mev=(MouseEvent)ev;
        if (mev.getClickCount()>1) return false;
        if ((toStrg(UIManager.getLookAndFeel()).indexOf("etal.")>0)) {
            if (isCtrl(ev) && !isShift(ev) && isSystProprty(IS_MAC)) {
                final String msg="<h2>Mouse behaviour is Windows/Unix like and not like Macintosh</h2>"+
                    "<ul>"+
                    "<li>Opening Context menu: Right mouse button. Alternatively  ctrl-alt-left-click."+
                    "Mac users may be used to ctrl-left-click for opening context menus which will not work in STRAP. "+
                    "On Macintosh sometimes the right mouse button is deactivated. It can be activated in the Settings/Einstellungen of the Mac. </li>"+
                    "<li>Selecting list items: In lists and browsable trees, more than one item can be selected with shift-left-click (Select an intervall) or ctrl-left-click (Toggle single selected/deselected, Ctrl-key instead of command-key).</i>"+
                    "</ul>";

                ChMsg.savedMsg(msg,"MacMouse");
            }

            return id==MOUSE_CLICKED && ( (modifiers(ev)&BUTTON3_MASK)!=0  || ( isAlt(ev) && isCtrl(ev) ) );
        }
        return mev.isPopupTrigger();
    }
    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> Icon >>> */
    public final static long REQUEST_IMAGE_PACK=1<<1,REQUEST_IMAGE_REMOVE_TEXT=1<<2;
    public final static String KEY_REQUEST_IMAGE_MAX_WIDTH="CU$$RIMW";
    public final static String KEY_REQUEST_IMAGE_OPTIONS="CU$$RIO";
    private static int countImageDownloads;
    private final static List<String> vImageDownloadsFailed=new Vector();
    private static List<Object[]> vNeededImages;
    private static Map<String,Reference<Image>> mapImages=new WeakHashMap();
    public static void requestImage(String fileOrURL, ChRunnable target) {
        //putln("requestImage "+fileOrURL);
        if (sze(fileOrURL)==0) return;
        if (vImageDownloadsFailed.contains(fileOrURL)) return;
        synchronized(mapImages) {
            final Image im=getV(fileOrURL,mapImages,Image.class);
            if (im!=null) target.run(ChRunnable.SET_ICON_IMAGE,im);
            else {
                if (vNeededImages==null) {
                    vNeededImages=new Vector();
                    ChThread.callEvery( 222,ChDelay.newThread(instance(0),"START_DOWNLOAD_IMAGE",null) ,"START_DOWNLOAD_IMAGE",0);
                }
                vNeededImages.add(new Object[]{fileOrURL,target});
            }
        }
    }

    /* ---------------------------------------- */
    /* >>> ChRunnable >>> */
    private static long imageDownloadStarted;
    public Object run(String id,Object arg) {
        final Object argv[]=arg instanceof Object[] ? (Object[])arg:null;
        if (id=="WAIT_MS") sleep(atoi(arg));
        if (id=="INVOKE_MTHD") {
            final Method m=(Method)argv[0];
            final Object instOrClass=argv[1];
            final Object para[]=(Object[])argv[2];
            final Object ret[]=(Object[])argv[3];
            final long options=argv.length>4 ? atol(argv[4]) : INVOKE_MTHD_PRINT_EXCEPTIONS;
            Object r=invokeMthd(m,instOrClass,para,options);
            if (ret!=null) ret[0]=r;
        }
        if (id=="START_DOWNLOAD_IMAGE") {
            if (currentTimeMillis()-imageDownloadStarted> 1000*60) imageDownloadStarted=countImageDownloads=0;
            if (countImageDownloads==0) {
                synchronized(mapImages) {
                    final Object oo[]=get(0,vNeededImages, Object[].class);
                    if (oo!=null) {
                        vNeededImages.remove(0);
                        ChDelay.newThread(this,"DOWNLOAD_IMAGE",oo).start();
                    }
                }
            }
        }
        if (id=="DOWNLOAD_IMAGE") {
            final String fileOrURL=(String)argv[0];
            final ChRunnable target=(ChRunnable)argv[1];
            final File f=file(fileOrURL);
            downloadAndDecompress(fileOrURL,f, target, (IsEnabled)null);
            if (target!=null) target.run(ChRunnable.APPEND, "fsdadfasfasdasdfafsdasdfasdf ");
            if (sze(f)==0) vImageDownloadsFailed.add(fileOrURL);
            else {
                imageDownloadStarted=currentTimeMillis();
                countImageDownloads++;

                Image im=null;
                synchronized(mapImages) { im=getV(fileOrURL,mapImages,Image.class); }
                if (im==null) {
                    try {
                        im=javax.imageio.ImageIO.read(f);
                        synchronized(mapImages) { mapImages.put(fileOrURL, weakRef(im)); }
                    } catch(Throwable e){ putln(e,"ChUtils f=",f); }
                }
                ChDelay.invokeAndWait(target,ChRunnable.SET_ICON_IMAGE, im);
                imageDownloadStarted=0;
                if (--countImageDownloads<0) countImageDownloads=0;
            }
        }
        if (id=="WATCH_DOWNLOAD") {
            final File
                f0=(File)argv[0],
                ff[]={f0,file(f0+".gz"),file(f0+"TMP"),file(f0+".gzTMP")};
            final ChRunnable log=(ChRunnable)argv[1];
            String msg=null;
            while(argv[0]!=null && ff!=null) {
                for(File f : ff) {
                    if (sze(f)>0) {
                        canDownload=true;
                        final StringBuffer sb=new StringBuffer(f.getName()).append(' ');
                        msg=format10(sze(f),10,true,sb).append(" bytes downloaded").toString();
                        break;
                    }
                }
                if (msg==null && f0!=null) msg="Downloading: "+f0.getName();
                sleep(222);
                sayDownloading(log, msg!=null ? msg+(sze(f0)>0 ? " done" : " ...") : null);
            }
        }
        if (id=="actionPerformed") ((ActionListener)argv[0]).actionPerformed((ActionEvent)argv[1]);
        if (id=="runnable") for(Runnable r : (Runnable[])arg) if (r!=null) r.run();
        if (id=="writePngLater") { sleep(333); ChDelay.invokeAndWait(this, "writePng",arg); }
        if (id=="writePng") writePng((JComponent)argv[0], (File)argv[1]);
        if (id=="MARCHING_ANT") marchingAnts();
        if (id=="RESTORE_LAF") {
            final LookAndFeel l=(LookAndFeel)argv[0];
            final int wait=atoi(argv[1]);
            if (isEDT()) {
                if (l!=null) try { UIManager.setLookAndFeel(l); } catch(Exception e){}
            } else {
                sleep(wait);
                inEDT(ChDelay.newThread(this,id,arg));
            }
        }

        if (id=="CURR_VERS") putln(readStrg("http://www-intern.charite.de/bioinf/strap/currentVersion?n="+arg+"&os="+systProprty(SYSP_OS_NAME)+systProprty(SYSP_OS_VERSION)));
        if (id=="POST_BROWSER") {
            final String sUrl=(String)argv[0];
            final ByteArray postData=(ByteArray)argv[1];
            final File fHtml=createTempFile(".html");
            final ByteArray ba=readBytes(Web.getServerResponseAsStream(sUrl,postData));
            if (ba!=null) {
                Web.insertBaseTag(url(sUrl),fHtml,ba);
                wrte(fHtml,ba);
                visitURL(fHtml,0);
            }
        }
        if (id=="getServerResponseTime") {
            final String url=(String)argv[0];
            final int[] time=(int[])argv[1];
            final long t0=currentTimeMillis();
            final InputStream is=inStreamT(99,url,0L);
            if (is!=null) {
                time[0]=(int)(currentTimeMillis()-t0);
                closeStrm(is);
            }
        }
        if (id=="addHelpSource") addHelpSource((String)argv[0], (ChTabPane)argv[1], argv[2]==TRUE);
        if (id=="removeAllChilds") rmAllChilds((Component)arg);
        if (id=="INPUT_STREAM") if ((argv[2]=inStream((String)argv[0], atol(argv[1])))==null) argv[2]="";
        if (id=="LM_HTTP") if ( (argv[1]=lastModifiedMsHttpHeader((URL)argv[0]))==null) argv[1]="";
        if (id=="gHF_") argv[2]=getHeaderFld((String)argv[0],(URL)argv[1]);
        if (id=="gHF") {
            try {
                final java.net.URLConnection c=((URL)argv[1]).openConnection();
                argv[3]=c;
                if (c!=null) {
                    c.setUseCaches(false);
                    argv[2]=c.getHeaderField((String)argv[0]);
                }
            } catch(Exception ex) { putln("caught gHF ", ex);}

        }
        if (id=="EVENT") {
            final Object[] oo=(Object[])arg;
            final Collection vListener= (Collection)oo[0];
            final  EventObject ev=(EventObject) oo[1];
            if (vListener==null || ev==null) return null;
            for(Object o : vListener.toArray()) {
                final Object listener=deref(o);
                if (listener==null) vListener.remove(o);
                if (listener instanceof ActionListener && ev instanceof ActionEvent) ((ActionListener)listener).actionPerformed((ActionEvent)ev);
                if (listener instanceof ChangeListener && ev instanceof ChangeEvent) ((ChangeListener)listener).stateChanged((ChangeEvent)ev);
            }
        }
        return null;
    }
    /* <<< ChRunnable <<< */
    /* ---------------------------------------- */
    /* >>> ImageIcon >>> */
    protected final static String IC_ERROR_ICON="CU$$EI";
    private static ImageIcon _errIc;
    private final static Map<String,ImageIcon> mapColor=new HashMap();
    public static ImageIcon iicon(String s) {
        if (_errIc==null) _errIc=new ImageIcon();
        if (""==s || s==null || !isGraphicsAvailable()) return null;
        if (s==IC_ERROR_ICON) return _errIc;
        if (s==IC_WWW) s=isMacintosh() ? IC_SAFARI:IC_FIREFOX;
        ImageIcon icon=mapColor.get(s);
        if (icon==null) {
            final int esc=s.indexOf('\u001B');
            if (esc>0) {
                int fnSize=atoi(s);
                if (fnSize<3) fnSize=12;
                final ByteArray ba=new ByteArray(s.substring(esc));
                final long[] escape=ba.getAnsiEscapes();
                final int escapeL=ba.countAnsiEscapes();
                final AnsiEscape attr=new AnsiEscape();
                for(int i=0;i<escapeL;i++) AnsiEscape.inferIntoAttribute(escape[i],attr);
                Color fg=attr.fg(), bg=attr.bg();
                if (fg==null) fg=Color.BLACK;
                final Font font=getFnt(fnSize,true,Font.BOLD);
                icon=new ImageIcon(ChIcon.text2image(ba.newString(), font, fg,bg));

            } else icon=ChIcon.findIcon(s);
            mapColor.put(s,icon!=null ? icon : _errIc);
        }
        return icon!=_errIc ? icon : null;
    }
    /* <<< ImageIcon <<< */
    /* ---------------------------------------- */
    /* >>> Color >>> */
    public static Color darker(Color c0) {
        if (c0==null) return null;
        final int rgb=c0.getRGB();
        final int  r0=(rgb>>16)&255, g0=(rgb>>8)&255, b0=rgb&255;
        final int r=r0*45875/65536, g=g0*45875/65536, b=b0*45875/65536;
        return C( (r<<16)|(g<<8)|b);
    }
    private static Reference<Map<Color[],Color[]>> mapDarkerr;
    public static Color[] darker(Color cc0[]) {
        if (cc0==null) return null;
        Map<Color[],Color[]> m=(Map)deref(mapDarkerr);
        if (m==null) mapDarkerr=new SoftReference(m=new IdentityHashMap());
        Color[] cc=m.get(cc0);
        if (cc==null) {
            cc=new Color[cc0.length];
            for(int i=cc0.length; --i>=0;) cc[i]=darker(cc0[i]);
            m.put(cc0, cc);
        }
        return cc;
    }
    private static Reference<Map<Color[],int[]>> mapRgb;
    public static int[] colors2rgb(Color[]cc){
        Map<Color[],int[]> m=(Map)deref(mapRgb);
        if (m==null) mapRgb=new SoftReference(m=new IdentityHashMap());
        int[] rgb=m.get(cc);
        if (rgb==null) {
            rgb=new int[cc.length];
            for(int i=0;i<cc.length;i++) {
                final Color c=cc[i];
                rgb[i]=i>0 && cc[i]==cc[0] ? rgb[0] : c.getRGB()|0xff000000;
            }
        }
        return rgb;
    }
    /**
     * a value 0<=x<=1 is turned into a color blue ... yellow ... red
     */
    public static Color float2blueRed(double value) {
        float x=(float)value;
        if (Float.isNaN(x)) return Color.WHITE;
        if (x>1) x=1f;
        if (x<0) x=0;
        float r=0,g=0,b=0;
        if (x< 0.5f) { b=1-x-x; r=x+x; g=x+x; }
        if (x>=0.5f) { r=1; g=2-x-x; }
        return new Color(r,g,b);
    }
    public static Color str2color(String s) {
        final int noSpc=nxt(NO_SPC,s);
        if (chrAt(noSpc,s)=='#' && s.length()-noSpc==7)  return C((int)HtmlUtil.hexToInt(s,1));
        final int c1=s.indexOf(',',noSpc);
        final int c2=s.indexOf(',',c1+1);
        final int c3=s.indexOf(',',c2+1);
        if (c2>0) {
            final int
                r=atoi(s,0),
                g=atoi(s,c1+1),
                b=atoi(s,c2+1),
                a=c3>0?atoi(s,c3+1) : 255;
            return C( (r<<16) + (g<<8)+b,a);
        }
        return null;
    }
    private final static Color[] blueYellowRed=new Color[100];
    /**
     * a value 0<=x<=1 is turned into a color blue ... yellow ... red
     */
    public static Color blueYellowRed(float x) {
        final Color cc[]=blueYellowRed;
        if (x>1) x=1f;
        if (x<0) x=0;
        final int  L=cc.length;
        int idx=(int)(x* L);
        if (idx>=L) idx=L-1;
        if (cc[idx]!=null) return cc[idx];
        float r=0,g=0,b=0;
        if (x< 0.5f) { b=1-x-x; r=x+x; g=x+x; }
        if (x>=0.5f) { r=1; g=2-x-x; }
        return cc[idx]=new Color(r,g,b);
    }
    private static ChButton togBG;
    public static boolean isWhiteBG() { return isSelctd(togBG);}
    public static ChButton togWhiteBG() {
        if (togBG==null) pcp(HtmlDoc.KEY_DO_NOT_CLONE,"",togBG=toggl("Printer friendly background"));
        return togBG;
    }
    /* <<< Color - methods <<< */
    /* ---------------------------------------- */
    /* >>> LAF >>> */
    public static void makeTranslucent(JComponent cont) {
        for(Component c:cont.getComponents()) {
            c.setBackground(C(0,0));
            if (c instanceof JComponent) { ((JComponent)c).setOpaque(false); makeTranslucent((JComponent)c);}
        }
    }
    private static boolean isAntialiasing;
    public static void setAntiAlias(char trueFalse) {
        isAntialiasing= trueFalse=='t' ? true : trueFalse=='f' ? false : !isAntialiasing;
        final ChFrame f=ChFrame.getMainFrame();
        if (togAntialiasing!=null) togAntialiasing.s(isAntialiasing);
        if (f!=null) f.repaint();
    }
    private static ChButton togAntialiasing;
    public static ChButton togAntialiasing() {
        if (togAntialiasing==null) togAntialiasing=toggl("Anti-aliasing (Enhance graphics quality)").s(isAntialiasing).li(listener(0));
        return togAntialiasing;
    }
    public static void antiAliasing(Graphics g, boolean always) {
        if (always || isAntialiasing) {
            if (g!=null) ((Graphics2D)g).setRenderingHint  (RenderingHints.KEY_ANTIALIASING,   RenderingHints.VALUE_ANTIALIAS_ON);
        }
    }
    public static void delayedRestoreLAF(int waitMS) { ChDelay.newThread(instance(0), "RESTORE_LAF",new Object[]{UIManager.getLookAndFeel(), intObjct(waitMS)}).start(); }
    /* <<< LAF <<< */
    /* ---------------------------------------- */
    /* >>> Date  >>> */
    private static java.text.DateFormat dateFmt0, dateFmt1;
    public static String day(long when) {
        if (dateFmt0==null) dateFmt0=java.text.DateFormat.getDateInstance(java.text.DateFormat.LONG,Locale.ENGLISH);
        try {
            return dateFmt0.format(new Date(when==0 ? currentTimeMillis() : when));
        } catch(Exception ex) { return "Error: Wrong date";}
    }
    public static String fmtDate(long when) {
        if (dateFmt1==null) dateFmt1=new java.text.SimpleDateFormat("yyyy_MM_dd-HH_mm");
        try {
            return dateFmt1.format(new Date(when==0 ? currentTimeMillis() : when));
        } catch(Exception ex) { return "Error: Wrong date";}
    }
    /* <<< Date <<< */
    /* ---------------------------------------- */
    /* >>> String Array >>> */
    public static int findSfx(String suffices[], String s) {
        for(int i=0;i<suffices.length; i++) {
            if (s!=null && s.endsWith(suffices[i])) return i;
        }
        return -1;
    }

    /* <<< String Array <<< */
    /* ---------------------------------------- */
    /* >>> CharSequence >>> */
    public static String substrg(Object txt,int from,int to) {
        if (txt==null) return null;
        final int f=maxi(0,from), t=mini(to,sze(txt));
        if (f>=t) return "";
        if (txt instanceof CharSequence) return toStrg(((CharSequence)txt).subSequence(f,t));
        if (txt instanceof byte[]) return bytes2strg((byte[])txt,f, t);

        assertTrue(false);
        return null;
    }
    public static byte[] substrgB(byte bb[], int from ,int to) {
        if (sze(bb)==0) return NO_BYTE;
        if (from<=0 && to>=bb.length) return bb;
        final int f=maxi(0,from), t=mini(bb.length,to);
        if (f>=t) return NO_BYTE;
        final byte rr[]=new byte[t-f];
        System.arraycopy(bb,f,rr,0,t-f);
        return rr;
    }
    public static byte[] concat(byte[] txt1,int from1,int to1,   byte[] txt2,int from2,int to2,  byte buffer[]) { return concat( txt1, from1, to1,    txt2, from2, to2,  null,0,0, buffer);}
    public static byte[] concat(byte[] txt1,int from1,int to1,   byte[] txt2,int from2,int to2,  byte[] txt3,int from3,int to3, byte buffer[]) {
        final int f1=maxi(0,from1), t1=mini(sze(txt1),to1);
        final int f2=maxi(0,from2), t2=mini(sze(txt2),to2);
        final int f3=maxi(0,from3), t3=mini(sze(txt3),to3);
        final int L=maxi(0,t1-f1)+maxi(0,t2-f2)+maxi(0,t3-f3);
        final byte txt[]=sze(buffer)>=L ? buffer : new byte[L];
        if (t1-f1>0) System.arraycopy(txt1,f1,txt,0,t1-f1);
        if (t2-f2>0) System.arraycopy(txt2,f2,txt,t1-f1,t2-f2);
        if (t3-f3>0) System.arraycopy(txt3,f3,txt,t1-f1+t2-f2,t3-f3);
        return txt;
    }
    private final static Reference<BufferedImage> refImage[]=new Reference['v'+1];
    public static BufferedImage sharedImage(char h_or_v, int n) {
        assert (h_or_v|32)=='v' || (h_or_v|32)=='h';
        final boolean isVertical= (h_or_v|32)=='v';
        BufferedImage i=(BufferedImage)deref(refImage[h_or_v]);
        if (i==null|| (isVertical ? i.getHeight() : i.getWidth())<n ) {
            refImage[h_or_v]=new SoftReference(i=new BufferedImage(isVertical?1:n, isVertical?n:1,
                                                                   (h_or_v|32)==h_or_v ? BufferedImage.TYPE_USHORT_GRAY : BufferedImage.TYPE_INT_RGB));
        }
        return i;
    }
    public static String strgTrim(byte[] txt, int from,int to) {
        final int f=nxtE(NO_SPC,txt,from,to);
        final int t=prevE(NO_SPC, txt, mini(txt.length,to)-1, from)+1;
        return bytes2strg(txt,f,t);
    }
    public static StringBuffer toStringBuffer(Object s) {
        return s==null ? new StringBuffer("null") :
            s instanceof StringBuffer ? (StringBuffer)s : new StringBuffer().append(toStrg(s));
    }
    public static CharSequence toCharSeq(Object o) { return o instanceof CharSequence ? (CharSequence)o : toStrg(o);}
    public static ByteArray toByteArray(CharSequence cs) { return cs==null ? null : cs instanceof ByteArray ? (ByteArray)cs : new ByteArray(cs); }
    //public static String[] bytes2strings(byte oo[][]) { return toStringArray(oo);}
    public static String[] toStringArray(Object oo[]) {
        if (oo instanceof String[]) return (String[]) oo;
        final int count=countNotNull(oo);
        if (count==0) return NO_STRING;
        final String ss[]=new String[count];
        int j=0;
        for(Object o : oo) {
            final String s=toStrg(o);
            if (s!=null) ss[j++]=s;
        }
        return ss;
    }
    private static List<String>vTmpS=new ArrayList();
    public static String[] collectIDs(String search,  ByteArray ba, String pfx) {
        return collectIDs(search,ba.getBytes(), ba.getBegin(), ba.getEnd(), pfx);
    }
    public static String[] collectIDs(String search,  byte txt[], int b, int e, String pfx) {
        synchronized(vTmpS){
            vTmpS.clear();
            final boolean prefix=sze(pfx)>0;
            int i=b;
            boolean added=false;
            while( (i=strstr(STRSTR_AFTER,search,txt,i,e))>0) {
                final int t=nxtE(SPC,txt,i,e);
                vTmpS.add(prefix ? byteArr(SB_TIP).append(pfx).append(txt,i,t).newString() : new String(txt,i,t-i) );
                added=true;
            }
            return added ? toArry(vTmpS,String.class) : NO_STRING;
        }
    }
    private static Reference<Map<String,byte[]>> mapS2B;
    public static byte[] toByts(String s) {
        if (s==null) return null;
        Map<String,byte[]> m=mapS2B!=null ? mapS2B.get() : null;
        if (m==null) mapS2B=new SoftReference(m=new HashMap());
        byte bb[]=m.get(s);
        if (bb==null)  m.put(s,bb=strg2bytes(s));
        return bb;
    }
    public static boolean cntainsOnly(int charClass, Object txt) { return cntainsOnly(charClass(charClass),txt,0,MAX_INT);}
    public static boolean cntainsOnly(int charClass, Object txt, int f, int t) { return cntainsOnly(charClass(charClass),txt,f,t);}
    public static boolean cntainsOnly(boolean[] charClass, Object txt, int from, int to0) {
        final int to=mini(sze(txt), to0);
        if (txt==null || to-from<=0) return false;
        if (txt instanceof CharSequence) {
            final CharSequence T=(CharSequence)txt;
            for(int i=maxi(0,from); i<to; i++) {
                final char c=T.charAt(i);
                if (c>127 || !charClass[c])  return false;
            }
        } else  {
            final byte[] T=(byte[])txt;
            for(int i=maxi(0,from); i<to; i++) {
                final byte c=T[i];
                if (c<0 || !charClass[c])  return false;
            }
        }
        return true;
    }
    public static byte[][] strings2bytes(Object[] ss) {
        if (ss==null) return null;
        final byte[][] bb=new byte[ss.length][];
        for(int i=ss.length; --i>=0;) {
            final String s=toStrg(ss[i]);
            if (s!=null) bb[i]=strg2bytes(s);
        }
        return bb;
    }
    /* <<< CharSequence <<< */
    /* ---------------------------------------- */
    /* >>> HashCode and Compare >>> */
    public static int hashCd(Object o) {
        return o==null ? 0 :
            o instanceof String ? ((String)o).hashCode() :
            hashCd(o, 0, MAX_INT, false);
    }
    public static int hashCd(Object bytesOrCharSeq, int from, int to,boolean toUpper) {
        final int L=mini(to,sze(bytesOrCharSeq));
        if (bytesOrCharSeq instanceof ByteArray) {
            final ByteArray ba=(ByteArray)bytesOrCharSeq;
            return hashCd(ba.getBytes(), ba.getBegin()+from, ba.getBegin()+L,  toUpper);
        }

        final byte bb[]=bytesOrCharSeq instanceof byte[] ? (byte[]) bytesOrCharSeq : null;
        final CharSequence cs=bytesOrCharSeq instanceof CharSequence ? (CharSequence)bytesOrCharSeq : null;
        if (bb==null && cs==null) { assert bytesOrCharSeq==null;  return -1; }
        int h=0;
        if (toUpper) {
            for (int i=from; i<L; i++) {
                final int b=(bb!=null?bb[i] : cs.charAt(i))&~32;
                if (b==0) break;
                h= 31*h + b;
            }
        } else {
            for (int i=from; i<L; i++) {
                final byte b=(byte)(bb!=null?bb[i] : cs.charAt(i));
                if (b==0) break;
                h= 31*h + b;
            }
        }
        return h;
    }
    public static long hashCd(File f) {
        if (f==null) return -1;
        InputStream is=null;
        try {
            is=new BufferedInputStream(new FileInputStream(f));
            long h=0;
            for(int c;  (c=is.read())>=0;) {
                h= 31*h + c;
            }
            return h;
        } catch (IOException iox) {
            return -1;
        }
        finally { closeStrm(is); }
    }
    public static int hashCdOnlyLetters(byte bb[],int from, int to,boolean toUpper) {
        if (bb==null) return -1;
        final int iMax=mini(bb.length,to);
        int h=0;
        for (int i=from; i<iMax; i++) {
            final byte c=bb[i];
            if ('a'<=c && c<='z' || 'A'<=c && c<='Z') {
                final int b=toUpper ? c&~32 : c;
                if (b==0) break;
                h= 31*h + b;
            }
        }
        return h;
    }

    /* <<< CharSequence <<< */
    /* ---------------------------------------- */
    /* >>> Looks like ... >>> */
    public final static int LIKE_EC=1, LIKE_EXTURL=2, LIKE_MAILADDR=3, LIKE_ENSGhm=4, LIKE_FILEPATH=6, LIKE_FILEPATH_EVALVAR=7,  LIKE_KEGG=8, LIKE_KEGGc=9, LIKE_KEGGr=10;

    public static boolean looks(int like, Object T) { return looks(like,T,0,MAX_INT); }
    public static boolean looks(int like, Object T, int from) { return looks(like, T, from, nxtE(SPC,T,from,MAX_INT));}
    public static boolean looks(int like, Object T, int from0, int to0) {
        if (T==null) return false;
        assertIsText(T);
        final int to=mini(sze(T),to0);
        final int from=maxi(0,from0);
        final int L=to-from;
        if (like==LIKE_EC) {
            final int dot1=nxt(NO_DIGT,T, from,to);
            if (dot1<=from || chrAt(dot1,T)!='.')  return false;
            final int dot2=nxt(NO_DIGT,T,dot1+1,to);
            if (dot2<dot1+2 || chrAt(dot2,T)!='.')  return false;
            final int dot3=nxt(NO_DIGT,T,dot2+1,to);
            if (dot3<dot2+2 || chrAt(dot3,T)!='.')  return false;
            return dot3+1<to0 && is(DIGT,T,dot3+1);
        }

        final char c0=chrAt(from,T), prev=chrAt(from-1,T);
        if (like==LIKE_EXTURL) {
            if ((c0=='h' || c0=='f') && (equls("http://",T,from) || equls("ftp://",T,from))) {
                return !is(LETTR_DIGT_US,prev) && !is(SLASH,prev);
            } else  return false;
        }
        final char  c1=chrAt(from+1,T), c2=chrAt(from+2,T);
        if (like==LIKE_ENSGhm) {
            if (L<15) return false;
            if (c0!='E' || c1!='N' || c2!='S') return false;
            if (L==15 && chrAt(from+3,T)=='G'   && cntainsOnly(DIGT,T,from+4, to)) return true;
            if (L==18 && equls("MUSG",T,from+3) && cntainsOnly(DIGT,T,from+7, to)) return true;
            return false;
        }
        if (like==LIKE_FILEPATH || like==LIKE_FILEPATH_EVALVAR) {
            if (c0=='%' || c0=='$') {
                if (equls("$HOME/",T,from)) return true;
                if (like==LIKE_FILEPATH_EVALVAR) {
                    for(String s : ChEnvironment.getNames(ChEnvironment.WITH_FILEPATH)) {
                        if (equls(s,T,from) && !is(LETTR_DIGT_US,T, from+s.length()) ) return true;
                    }
                }
            }
            if (c0=='f' && equls("file:/",T,from) ||
                (c0=='.'||c0=='~')&& is(SLASH,c1) || is(SLASH, c0)&&is(LETTR_DIGT_US,c1) ||
                c1==':' && is(LETTR,c0)&&isWindows() && is(SLASH,c2)) {
                return prev!=':' && !is(SLASH,prev) && !is(LETTR_DIGT_US,prev);
            }
        }
        if (like==LIKE_KEGG || like==LIKE_KEGGc || like==LIKE_KEGGr) {
            if (L!=6 ||
                like==LIKE_KEGG  && c0!='R' && c0!='C' && c0!='G' ||
                like==LIKE_KEGGr && c0!='R' ||
                like==LIKE_KEGGc && c0!='C' && c0!='G') return false;
            return cntainsOnly(DIGT,T,from+1,to);
        }
        if (like==LIKE_MAILADDR) {
            final int at=strchr('@',T,from,to);
            //if (at==6 && w.charAt(0)=='R') return false; /* R00658@any4.2.1.11 */
            if (at<1 || strchr('.',T,at,to)<0) return false;
            int i=0;
            for(i=to; --i>=from;) {
                final char c=chrAt(i,T);
                int atRel=i-at;
                if (atRel<0) atRel=-atRel;
                if (c=='.' && (atRel==1 || i>0 && chrAt(i-1,T)=='.')) return false;
                if (c=='@' && i!=at) return false;
                if (!is(LETTR_DIGT_US,c) && c!='.' && c!='@') return false;
            }
            return true;
        }
        return false;
    }
    /* <<< Looks like ... <<< */
    /* ---------------------------------------- */
    /* >>> Directory >>> */
    public static void setFolderIcon(File dir, String icon, String tip) {
        final String fn=isWindows() ? withoutLastComponent(icon,'.')+".ico" : icon;
        final File fIco=file(dir+"/"+fn);
        if (sze(fIco)==0) {
            cpy(rscAsStream(_CC+"myIcons",fn), fIco);
            if (sze(fIco)>0) {
                if (isWindows()) {
                    final File desktopIni=file(dir+"/Desktop.ini");
                    wrte(desktopIni,"[.ShellClassInfo]\r\nConfirmFileOp=0\r\nNoSharing=1\r\nIconFile="+fn+"\r\nIconIndex=0\r\nInfoTip="+tip);
                    new ChExec(0).setCommandLineV("attrib", "+s",dir.toString()).run();
                    new ChExec(0).setCommandLineV("attrib", "+s",dir).run();
                    new ChExec(0).setCommandLineV("attrib", "+H",desktopIni).run();
                    new ChExec(0).setCommandLineV("attrib", "+H",fIco).run();
                }
            }
        }
    }
    private static URL urlDirPlugins;
    public static URL urlDirPlugins() {dirPlugins();return urlDirPlugins;}
    private static File dirHome, dirDesktop, dirDesktopUtils, dirBin,dirDataFiles,_dirWorking, _dirTmp, _dirUser, _dirLog, dirDndData,dirJars,dirSettings_,dirPlugins,dirDocumentation,dirWeb;

    public static void setWorkingDir(File f) {
        refMapFiles=null;
        _dirTmp=null;
        _dirWorking=f;
    }
    public static File dirWorking() { return _dirWorking!=null ? _dirWorking : dirUser(); }
    public static File dirTmp() {
        final File dw=_dirWorking;
        if (_dirTmp==null) _dirTmp= dw!=null ? file(dw+"/"+STRAPTMP) : file("~/@/"+STRAPTMP);
        return _dirTmp;
    }

    public static File dirWeb() {
        if (dirWeb==null) {
            File f=file("~/@/web");
            mkdrsErr(f,"This directory caches files loaded from the WEB.");
            dirWeb=f;
        }
        return dirWeb;
    }
    public static File dirHome() {
        if (dirHome==null) dirHome= new ChFile(systProprty(SYSP_USER_HOME),isWindows());
        return dirHome;
    }
    public static File dirDesktop() {
        if (dirDesktop==null) dirDesktop= file(sysGetProp(USER_DOT_HOME)+"/Desktop");
        return dirDesktop;
    }
    public static File dirDesktopUtils() {
        if (dirDesktopUtils==null) {
            dirDesktopUtils= file(dirDesktop()+Insecure.DIR_DesktopUtils);
            setFolderIcon(dirDesktopUtils,"superimpose.jpg", "This folder contains useful utilities of the Strap project");
        }
        return dirDesktopUtils;
    }
    public static File dirDndData() {
        if(dirDndData==null)  {
            mkdrsErr(dirDndData=file("~/@/tmp/dnd"),"Tmp files for Drag'n Drop");
            delFileOnExit(dirDndData);
        }
        return dirDndData;
    }
    //        if (setPrpty(ChUtils.class,KEY_CYGWIN,"?:/cygwin/");
    public static File dirUser() {
        if(_dirUser==null) _dirUser=new ChFile(systProprty(SYSP_USER_DIR),isWindows());
        return _dirUser;
    }
    public static File dirLog() {
        if(_dirLog==null) {
            mkdrsErr(_dirLog=new ChFile(dirSettings()+"/log/"+fmtDate(0),isWindows()),"Log-messages\r\nYou can delete this folder");
            final File dirCurrent=new ChFile(dirSettings()+"/log/current",isWindows());
            if (!delFile(dirCurrent)) putln("Failed to remove "+dirCurrent);
            mkLink(_dirLog, dirCurrent,true);
        }
        return _dirLog;
    }
    public static File dirDataFiles() {
        if(dirDataFiles==null) mkdrsErr(dirDataFiles=new ChFile(dirSettings(),"dataFiles",isWindows()),"This directory contains downloaded data files of\n");
        return dirDataFiles;
    }
    private static ByteArray msgSettingsDir;
    public static void setBufferForMsg(ByteArray ba, char type) {
        msgSettingsDir=ba;
    }
    public static File dirSettings(){
        if (dirSettings_==null) {
            final boolean isWin=isWindows();
            final File fRelocate=new File(toStrg(dirHome())+File.separatorChar+".location_of_StrapAlign.ini");
            final String dotStrapAlign=isWin ? Insecure.DIR_STRAP_ALIGN : "."+Insecure.DIR_STRAP_ALIGN;
            final String dirHomeEnv=ChEnvironment.get("STRAP_USER_HOME");
            final String dirHome=dirHomeEnv!=null && new File(dirHomeEnv).isDirectory() ?  dirHomeEnv : toStrg(dirHome());
            final ByteArray ba=readBytes(fRelocate);
            File d=null;
            if (ba!=null) {
                ba.delBlanksL();
                final byte[] T=ba.getBytes();
                final int begin=ba.getBegin(), end=nxtE(SPC,T, begin, ba.getEnd());
                if (end-begin>0) d=new File(ba.newString(begin,end));
            }
            if (d==null) {
                if (isWin && dirHome.indexOf(' ')>0) {
                    for(char root='C'; root<='E'; root++) {
                        final File dTry=new File((char)root+":\\"+dotStrapAlign), dJars=new File(dTry+"\\jars");
                        if (!dJars.exists()) mkdrs(dJars);
                        if (dJars.isDirectory()) {
                            d=dTry;
                            final String txt=d+
                                "\r\nThis file contains the location of STRAP's  application data folder.\r\n"+
                                "To change the location modify the first line.\r\n"+
                                "The file path must not contain white space.";
                            wrte(fRelocate,txt);
                            final ByteArray msg=(msgSettingsDir!=null ? msgSettingsDir : new ByteArray(999))
                                .append("The directory for the application data for Strap is\r\n")
                                .append(d.getAbsolutePath())
                                .append("\r\nYou may specify a different location by modifying\r\n")
                                .append(fRelocate)
                                .append("\r\nThe directory path must not contain white space.\r\n")
                                .append("The home directory is therefore not applicable.\r\n")
                                .append(dirHome).append("\r\n");
                            if (msgSettingsDir!=msg) new AsciiView(msg).showInFrame("Info directory created",ChFrame.CENTER);
                            break;
                        }
                    }
                }
            }
            if (d==null) d=new File(dirHome+File.separatorChar+dotStrapAlign);
            dirSettings_=d;
            if (d.toString().indexOf(' ')>0) {
                error("The application data folder for STRAP\n"+d+"\ncontains white space which might cause problems.\n"+
                      "Please specify a suitable location in\n\n"+fRelocate);
            }
            final String readme=
                "This directory contains application data of STRAP.\r\n"+
                "To free hard disk space you might delete the directories \"web\" and \"cache\".";
            mkdrsErr(d,readme);
        }
        return dirSettings_;
    }
    public static File dirBin() {
        if (dirBin==null) {
            mkdrsErr(dirBin=new ChFile(dirSettings(),"bin",isWindows()),"This directory contains external programs which have been installed automatically.\n"+
                     "Packages are installed when they are needed for the first time\n"+
                     "You can remove the directory and its files to force reinstallation of all packages.");
        }
        return dirBin;
    }
    public static File dirJars() {
        if (dirJars==null) {
            mkdrsErr(dirJars=new ChFile(dirSettings(),"jars",isWindows()),
                     "This directory contains downloaded jar-files.\n"+
                     "jar-files are zipped archives usually containing java-files.\n"+
                     "The jar files are included into the CLASSPATH when Strap is running.\n"+
                     "If the files are deleted they are downloaded again when required.\n\n"+
                     "You can delete all *.pack.gz files because those are converted into .jar files and then not needed any more.\n");
        }
        return dirJars;
    }
    public static File dirDocumentation() {
        if (dirDocumentation==null) {
            dirDocumentation=file("~/@/doc");
            mkdrsErr(dirDocumentation,"This directory contains generated HTML.\r\nThey can be viewed in Web browsers.");
        }
        return dirDocumentation;
    }
    public static File dirPlugins() {
        if (dirPlugins==null) {
            dirPlugins=file("~/@/plugins");
            if (!dirPlugins.exists()) {
                final File fOld=file("~/strapPlugins");
                if (fOld.isDirectory()) renamFile(fOld,dirPlugins);
            }
            mkdrsErr(dirPlugins,"Plugin files need to be copied here.\n");
        }
        try { urlDirPlugins=dirPlugins.toURL(); }catch(Exception e){}
        return dirPlugins;
    }
    /* <<< Directory <<< */
    /* ---------------------------------------- */
    /* >>> File >>> */
    private static Set<String> vDelOnExit;
    private static int iTempFile;
    private static int countCache;
    private static Reference<Map<String,File>> refMapFiles;
    private static String tempFiles;
    public static ChFile createTempFile(String suffix) {
        if (tempFiles==null) {
            final String s="~/@/tempFiles";
            tempFiles=s+"/tmp"+(TIME_AT_START/1000)+"/";
            mkdrsErr(file(s),"Temporary files.\nIt is safe to delete all files in this directory.");
        }
        final String fn=tempFiles+iTempFile++ +suffix;
        final ChFile f=(ChFile)file(fn);
        mkParentDrs(f);
        delFileOnExit(f);
        mkParentDrs(f);
        return f;
    }
    public static void delFileOnExit(File f) { delFileOnExit(toStrg(f)); }
    public static void delFileOnExit(String s) {
        if (s!=null)  (vDelOnExit==null ? vDelOnExit=new HashSet() : vDelOnExit).add(s);
    }
    private static boolean stckTrc_delFile;
    public static boolean delFile(File f) {
        if (f==null || !f.exists()) return false;
        for(int iTry=0; iTry<3; iTry++) {
            if (!f.exists()) break;
            Insecure.delFile(f);
            sleep(99);
        }
        //f.delete();
        if (sze(f)>0) {
            String jar=isWindows() && f.toString().endsWith(".jar") ? "<br>Upgrading to Java 1.7 might solve the problem.<br>" : "";
            String msg="ChUtils#delFile <br>Unable to Delete <br>"+filepathUnixStyle(f)+jar+"  "+sze(f)+"Bytes";
            error(msg);
            putln(msg);
            if (!stckTrc_delFile) stckTrc();
            stckTrc_delFile=true;
            delFileOnExit(f);
            return false;
        }

        return f!=null && !f.exists();
    }
    public static void deleteTree(File f) {
        if (f==null) return;
        if (f.isDirectory()) {
            final String ff[]=f.list();
            if (ff!=null)
                for(String child : ff)
                    deleteTree(new File(f,child));
        }
        delFile(f);
    }
    public static OutputStream fileAppendStream(File f) throws IOException {  return Insecure.fileOutputStream(f,true); }
    public static OutputStream fileOutStream(File f)    throws IOException { return Insecure.fileOutputStream(f,false);}
    public static Writer fWriter(File f) throws IOException {
        if (f==null || f.isDirectory()) return null;
        mkParentDrs(f);
        return Insecure.fileWriter(f);
    }
    public static Writer fWriter(String f) throws IOException { return fWriter(file(f));}

    public static boolean renamFile(File src, String dest) { return renamFile(src,file(dest)); }
    public static boolean renamFile(File src,File dest) {
        if (sze(src)==0  || dest==null) return false;
        mkParentDrs(dest);
        delFile(dest);
        return Insecure.renameFile(src,dest);
    }

    public static boolean renamFileOrCpy(File src,File dest) {
        if (sze(src)==0  || dest==null) return false;
        renamFile(src,dest);
        if (sze(dest)==0) {
            try {
                if (!cpy(new FileInputStream(src),dest)) return false;
            } catch(Exception iox) { return false;}
            if (dest.exists()) {
                delFileOnExit(src.getAbsolutePath());
                delFile(src);
            }
            return false;
        }
        return sze(dest)>0;
    }

    public static boolean filesEqual(File f1, File f2) throws IOException {
        if (f1==null || f2==null || !f1.exists() || f1.isDirectory() || !f2.exists() || f2.isDirectory()  ) return false;
        final long L=f1.length();
        if (L!=f2.length()) return false;
        final BufferedInputStream
            is1=new BufferedInputStream(new FileInputStream(f1)),
            is2=new BufferedInputStream(new FileInputStream(f2));
        for(long i=0; i<L; i++) {
            final int c1=is1.read(), c2=is2.read();
            if (c1!=c2) return false;
        }

        closeStrm(is1);
        closeStrm(is2);
        return true;
    }
    public static File mostRecentFile(File dirs[], String extensions[]) {
        long lm=0;
        File fLast=null;
        for(File dir : dirs) {
            final String ff[]= dir!=null ? dir.list() : null;
        nextFile:
            for(int i=sze(ff); --i>=0;) {
                for(String e : extensions) {
                    if (e!=null && ff[i].indexOf(e)>=0 && ( ff[i].endsWith(e) || ff[i].endsWith(withoutLastComponent(e,'-')))) {
                        final File f=new File(dir,ff[i]);
                        final long modified=f!=null ?  f.lastModified() : 0;
                        if (lm<modified && f.length()>0 ) { lm=modified; fLast=f; }
                        continue nextFile;
                    }
                }
            }
        }
        return fLast;
    }
    public static void makeExecutable(File f) {
        if (!isWindows())new ChExec(0).setCommandLineV("chmod", "a+x", f).run();
    }

    public static File file(File dir, String filename) { return filename==null||dir==null ?  null : new ChFile(dir,filename,isWindows());}
    public static File file(Object filename) { return filename instanceof File ? (File)filename : file(filename, 0);}
    protected static String processFileName(String filename) {
        if (filename==null || looks(LIKE_EXTURL,filename)) return null;
        final String fn=rplcToStrg("/./","/",_processFileName(filename));
        return isWindows() ? fn.replace('/',File.separatorChar) :  fn;
    }
    public static String _processFileName(String filename0) {
        final String filename=filename0!=null ? filename0.trim() : null;
        if (filename==null || filename.length()==0) return null;
        String pattern;
        final char c0=chrAt(0,filename);
        if (c0=='f' && (filename.startsWith(pattern="file://localhost/") ||  filename.startsWith(pattern="file:/")) )  {
            int start=pattern.length();
            while(chrAt(start,filename)=='/') start++;
            if (!(is(LETTR,filename,start) && ':'==chrAt(start+1,filename))) start--;
            return urlDecode(filename.substring(start));
        }
        final String fn=rplcToStrg("%20"," ",filename);
        final char  c1=chrAt(1,fn);
        if (c0=='/' && c1=='c' && fn.startsWith("/cygdrive/") && chrAt(11,fn)=='/') {
            return (char)(fn.charAt(10)&~32)+":\\"+ fn.substring(12);
        }
        if (c0=='?' && c1==':' && isWindows() && sze(fn)>2 ) {
            final String fn0= fn.substring(2);
            for(File driveLetter: listExistingFileRoots()) {
                if (driveLetter.exists() && chrAt(1,driveLetter.getAbsolutePath())==':') {
                    final File f=new File(driveLetter,fn0.replace('/',File.separatorChar));
                    if (f.exists()) return f.getAbsolutePath();
                }
            }
            return fn;
        }
        if (c0=='/' || c0=='\\' || c1==':' && is(LETTR,c0) && is(SLASH,fn,2)) return fn;
        if (c0=='~') return  fn.startsWith("~/@/") ?  dirSettings()+(fn.substring(3)) :  dirHome()+fn.substring(1);
        if (c0=='$' ||  c0=='%' && isWindows()) {
            final String fnNew=rplcEnvInPath(fn);
            if (fnNew!=fn) return fnNew;
        }
        return dirWorking()+("/"+fn);
    }

    //public static String toFileName(String s) { return s=="" ? "" : s==null ? "null" : s.replaceAll("[^a-zA-Z0-9-+~=]","_"); }

    public static boolean mkdrs(File dir) {
        if (dir==null) return false;
        for(int iTry=2;--iTry>=0 && !dir.isDirectory();) {
            Insecure.makeDirectories(dir, iTry==0);
            sleep(111);
        }
        return dir.isDirectory();
    }
    public static boolean mkdrsErr(File dir) { return mkdrsErr(dir,"");}
    public static boolean mkdrsErr(File dir, String readme) {
        if (dir==null) return false;
        if (!dir.exists()) {
            mkdrs(dir);
            if (!dir.exists() || !dir.isDirectory()) {
                if (!vErrorAlreadyReported.contains(dir)) error("Could not create directory "+dir+"<pre class=\"data\">"+stackTrceAsStrg(null)+"</pre>");
                vErrorAlreadyReported.add(dir);
            } else {
                if (!dir.canWrite()) error("No permission to create files in directory "+dir);
                else {
                    if (readme!="" && readme!=null) {
                        wrte(new File(dir,"README.txt"),readme);
                    }
                }
            }
        } else if(!dir.isDirectory()) error("Error: Cannot create directory\n"+dir+"\nIt is a regular file.");
        return dir.isDirectory();
    }
    public static boolean mkParentDrs(File dir) { return dir!=null ?  mkdrsErr(file(dir.getParent())) : false;}

    public static String rplcEnvInPath(final String s) {
        if (sze(s)==0) return s;
        final char c0=s.charAt(0);
        if (c0=='$' || c0=='%' && isWindows()) {
            for(String env : ChEnvironment.getNames(ChEnvironment.WITH_FILEPATH)) {
                if (s.startsWith(env)) {
                    final int envL=env.length();
                    if (!is(LETTR_DIGT_US,s,envL)) {
                        final String v=ChEnvironment.get(env);
                        if (v!=null) return v+s.substring(envL);
                        else assert false;
                    }
                }
            }
        }
        return s;
    }
    public final static long FILE_NEW_INSTANCE=1<<1, FILE_NO_ERROR=1<<2;
    public static File file(final Object filename, long options) {
        final boolean newInstance=(options&FILE_NEW_INSTANCE)!=0;
        final String toString0=toStrg(filename);
        if (toString0==null) return null;
        final boolean isURL=looks(LIKE_EXTURL,toString0);
        final String toString;
        if (isURL) {
            String s=delPfx("ftp://",delPfx("http://",delSfx(".gz",delSfx(".Z",toString0))));
            final int amp=s.lastIndexOf('&');
            if (amp>0 && cntainsOnly(DIGT,s,amp+1,MAX_INT)) s=s.substring(0,amp);
            toString=dirWeb()+"/"+rplcChars(charClass(NO_FILEP), '_', s);
        } else toString=toString0;
        if (sze(toString)==0) return null;
        if ((options&FILE_NO_ERROR)==0 && toString.indexOf(':',2)>1 && !toString.startsWith("file:")) {
            putln("Error ChUtils.file ",toString); stckTrc();
        }
        if (!newInstance && filename instanceof File) return (File)filename;
        final boolean lookup=!newInstance && toString.charAt(0)!='?';
        Map<String,File> map=null;
        if (lookup) {
            map=(Map)deref(refMapFiles);
            if (map==null) refMapFiles=new SoftReference(map=new HashMap());
            final File f=map.get(toString);
            if (f!=null) return f;
        }
        final String fn=filename.equals(systProprty(SYSP_USER_DIR)) ? toString : processFileName(toString);
        if (fn==null) return null;
        if (lookup) {
            File f=map.get(fn);
            if (f==null) {
                f=new ChFile(fn,isWindows());
                if ((countCache++&32)==0) {
                    map.put(toString,f);
                    map.put(fn,f);
                }
            }
            return f;
        }
        return new ChFile(fn,isWindows());
    }

    public static File unzip(File f) {
        if (f==null) return null;
        final String fn=f.getAbsolutePath();
        final int i=findSfx(COMPRESS_SUFFIX,fn);
        final String fnDest= i>=0 ? delSfx(COMPRESS_SUFFIX[i],fn) : fn.endsWith(".tgz") ? delSfx(".tgz",fn)+".tar" : null;
        if (fnDest==null) return f;
        final File fDest=file(fnDest);
        cpy(inStream(fn,STREAM_UNZIP),fDest);
        return sze(fDest)>0 ? fDest : null;
    }
    private static List<File> vRoots;
    /**
       Sometimes  Windows says " ... Please insert disk ... " when checking for C: D: E: ...
       This is a work around. The user is confronted with the windows message only once.
    */
    public static File[] listExistingFileRoots() {
        if (vRoots==null) {
            vRoots=new ArrayList();
            final File rr[]=File.listRoots();
            for (File f : rr) {
                final String s=f.getAbsolutePath();
                if (isWindows() && chrAt(1,s)==':') {
                    if (s.charAt(0)=='A' || s.charAt(0)=='B') continue;
                    if (Insecure.EXEC_ALLOWED) {
                        final ChExec ex=new ChExec(0).setCommandLineV("SH","VOL",s.substring(0,2));
                        ex.run();
                        if (ex.exitValue()!=0) continue;
                        ex.dispose();
                    }
                }
                adUniq(f,vRoots);
            }
            if (sze(vRoots)==0) adAllUniq(rr,vRoots);
        }
        final File ff[]=toArry(vRoots, File.class);
        for(int i=ff.length; --i>=0;) if (ff[i]!=null && !ff[i].exists()) ff[i]=null;
        return rmNull(ff,File.class);
    }
    /** absolute path in unix style */
    public static String filepathUnixStyle(Object file) {
        if (file==null) return null;
        final String path= toStrg(file), home=sysGetProp(USER_DOT_HOME);
        final int L=home.length();
        return (sze(home)>4 && path.startsWith(home) ? "~"+path.substring(is(SLASH,home,L-1) ? L-1 : L) :  path).replace('\\','/');
    }
    public static String readLne(InputStream is) throws IOException {
        StringBuffer sb=null;
        for(int b; (b=is.read())>=0;) {
            if (sb==null) sb=new StringBuffer(99);
            if (b=='\n') break;
            if (b!='\r') sb.append((char)b);
        }
        return sb!=null ? sb.toString() : null ;
    }
    public static boolean rplcInTextFile( String[][] replacements, File f) {
        InputStream is=null;
        OutputStream os=null;
        try {
            try {

                final File fTmp=createTempFile(".txt");
                os=fileOutStream(fTmp);
                is=new FileInputStream(f);
                final ChInStream cis=new ChInStream(is);
                final ByteArray buf=new ByteArray(99);
                while( cis.readLine(buf.setEnd(0))) {
                    for(String[] replacement : replacements)  buf.replace(replacement[0],replacement[1]);
                    buf.write(os);
                    os.write('\n');
                }
                delFile(f);
                renamFileOrCpy(fTmp,f);
                return true;
            } catch(IOException iox) {}
            return false;
        } finally{ closeStrm(is); }

    }
    /* <<< File <<< */
    /* ---------------------------------------- */
    /* >>> Jar File >>> */
    private static File thisJarFile;
    private static URL urlThisJarFile;
    public static URL urlThisJarFile() {
        URL u=urlThisJarFile;
        if (u==null) {
            final String res=toStrg(ChUtils.class.getResource("ChUtils.class"));
            u=res!=null ? url(withoutLastComponent(delPfx("jar:",res),'!')) : null;
            if (u==null) {
                try {
                    u=ChUtils.class.getProtectionDomain(). getCodeSource().getLocation();
                } catch(Throwable ex) { error(0L,ex,"");}
            }
            urlThisJarFile=u!=null ? u : ERROR_URL;
        }
        return urlThisJarFile!=ERROR_URL ? urlThisJarFile : null;
    }
    public static File thisJarFile() {
        if (thisJarFile==null) {
            final  URL u=urlThisJarFile();
            File f=file(u);
            if (u!=null) {
                if (sze(f)==0) {
                    f=createTempFile(".jar");
                    try {cpy(u.openStream(),f);} catch(Exception e){stckTrc(e);}
                }
            }
            thisJarFile=sze(f)>0 && !f.toString().endsWith(".class") ? f : ERROR_FILE;
        }
        return thisJarFile!=ERROR_FILE ? thisJarFile : null ;
    }
    private final static Map<Object,Boolean> isProxyClassUnavailable=new HashMap();
    public final static boolean isProxyClassUnavailable(Object classOrClassName) {
        if (!(classOrClassName instanceof String || classOrClassName instanceof Class)) return false;
        Boolean unavailable=isProxyClassUnavailable.get(classOrClassName);
        if (unavailable==null) {
            final String cn;
            final Class c;
            if (classOrClassName instanceof Class) {
                c=((Class)classOrClassName);
                cn=c.getName();
            } else {
                Class _c=null;
                cn=(String)classOrClassName;
                try { _c=Class.forName(cn);} catch(Exception ex) { }
                c=_c;
            }
            final String shrt=shrtClasNam(c);
            unavailable=
                cn!=null && c!=null && shrt!=null &&
                c.getResource(shrt+".class")!=null &&
                c.getResource(delSfx("PROXY",shrt)+".class")==null ? TRUE : FALSE;
            isProxyClassUnavailable.put(cn,unavailable);
            isProxyClassUnavailable.put(c,unavailable);
        }
        return unavailable==TRUE;
    }
    /* <<< Jar  <<< */
    /* ---------------------------------------- */
    /* >>> ZipFile  >>> */
    private static Map<String,Object> mapZip=new HashMap();
    public static java.util.zip.ZipFile zipFle(String fPath) {
        final File f=file(fPath);
        if (sze(f)==0) return null;
        Object zf=deref(mapZip.get(fPath));
        if (zf==ERROR_OBJECT) return null;
        if (zf==null) {
            try {
                zf=new java.util.zip.ZipFile(f);
                mapZip.put(fPath,new SoftReference(zf));
            } catch(Exception ex) {zf=ERROR_OBJECT; return null;}
        }
        return deref(zf,java.util.zip.ZipFile.class);
    }
    public static InputStream zipEntryStrm(String entryName, String fPath) {
        final java.util.zip.ZipFile zipFile=zipFle(fPath);
        final java.util.zip.ZipEntry entry=zipFile==null ? null : zipFile.getEntry(entryName);
        try {
            if (entry!=null) return zipFile.getInputStream(entry);
        } catch(IOException iox) { putln(RED_CAUGHT_IN,"zipEntryStrm ",iox);}
        return null;

    }
    /* <<< ZipFile <<< */
    /* ---------------------------------------- */
    /* >>> Streams >>> */
    public static String readStrg(InputStream is) { return joinAsStrg(readLines(is),"\n"); }
    public static String readStrg(URL url) { return  joinAsStrg(readLines(url),"\n");}
    public static String readStrg(File f) { return f==null || f.length()==0 ? null : joinAsStrg(readLines(f),"\n");}
    public static String readStrg(String file) { return joinAsStrg(readLines(file),"\n");}
    public static ByteArray readAndDecompress(File f,final ByteArray buffer) {
        return readAndDecompress(f.getAbsolutePath(),buffer);
    }
    public static ByteArray readAndDecompress(final String fn,final ByteArray buffer0) {
        final InputStream fi=inStream(fn,STREAM_UNZIP);
        if (fi==null) return null;
        final boolean isZip=fi instanceof java.util.zip.InflaterInputStream;
        int fLen=0;
        if (!looks(LIKE_EXTURL,fn)) {
            final File file=file(fn);
            if (file!=null && !file.isDirectory()) fLen=(int)file.length();
        }
        final ByteArray buffer=buffer0!=null ? buffer0 : new ByteArray(0);
        final int txtLen=isZip ? fLen*3 : fLen;
        if (fLen>0 && buffer!=null) {
            final byte[] bb=buffer.getBytes();
            if (bb.length<txtLen) buffer.set(new byte[txtLen],0,buffer.getEnd());
        }
        return readBytes(fi, fLen>0 && buffer==null ? new ByteArray(txtLen) :  buffer);
    }
    /**
       @param buffer buffer to load file contents into.
       If buffer is large enough to hold the data then  buffer is also the  returned value.
       If buffer is null or too small then a new byte array with the exact size is returned.
    */
    public static ByteArray readBytes(final File f, long maxBytes, ByteArray buffer) {
        final long L=Math.min(maxBytes,f==null ? 0:f.length());
        if (L==0) return null;
        try {
            InputStream is=deflaterAccordingToExtension(new FileInputStream(f),f.getName());
            final boolean isUnzip=is instanceof java.util.zip.InflaterInputStream;
            final int sze= (int) (isUnzip ? L*5 : L);
            final ByteArray ba= readBytes(is,buffer!=null ? buffer : new ByteArray(sze));
            if (!isUnzip && isMyComputer() && L>ba.getEnd()) putln(RED_ERROR+" in readBytes: Read only "+ba.getEnd()+" File: "+L+" Bytes");
            return ba;
        } catch (Exception e){ return null;}
    }
    public static ByteArray readBytes(final File f) { return readBytes(f,MAX_INT,(ByteArray)null);}
    public static ByteArray readBytes(final File f,  ByteArray buffer) { return readBytes(f,MAX_INT,buffer);}
    public static ByteArray readBytes(final InputStream inStr) { return readBytes(inStr,(ByteArray)null); }
    public static ByteArray readBytes(final InputStream inStr, final ByteArray origBuffer) {
        final boolean debug=isMyComputer();
        final int SIZE=1024;
        if (inStr==null) return null;
        final InputStream fi=inStr instanceof java.util.zip.InflaterInputStream && !(inStr instanceof BufferedInputStream) ? new BufferedInputStream(inStr) : inStr;
        try {
            int available=0, countAllBytes=0, bufferEnd=0;
            try {fi.available();}catch(Exception e){}
            final ByteArray buffer=origBuffer!=null ? origBuffer : new ByteArray(0);
            byte bb[]=buffer.getBytes();
            try {
                if (sze(bb)==0) bb=new byte[available>0 ? available : SIZE];
                try{
                    final int read=fi.read(bb);
                    bufferEnd=maxi(0,read);
                    if (read<0) return buffer;
                    countAllBytes+=read;
                } catch(IOException e) { return null;}
                int nextByte=-1;
                try {nextByte=fi.read();} catch(IOException e){}
                if (nextByte!=-1){
                    final List<byte[]> v=new ArrayList();
                    v.add(chSze(bb,countAllBytes));
                    v.add(new byte[]{(byte)nextByte}); countAllBytes++;
                    try {
                        while(true) {
                            available=fi.available();
                            final byte[] ba=new byte[available>0 ? available:SIZE];
                            final int read=fi.read(ba);
                            if (read<0) break;
                            if (debug && read!=available && available!=0) putln("ChUtils#readBytes read!=available "+read+" != "+available+( read==1?" !!!!!!!!!! ":" "));
                            countAllBytes+=read;
                            v.add(chSze(ba,read));
                        }
                    } catch(IOException e){ putln("caught ChUtils#readBytes ",e);}
                    bb=new byte[countAllBytes];
                    final int N=sze(v);
                    for(int i=0,nextIdx=0; i<N; i++) {
                        final byte[] ba=v.get(i);
                        System.arraycopy(ba,0, bb, nextIdx, ba.length);
                        nextIdx+=ba.length;
                        bufferEnd=countAllBytes;
                    }
                }
                buffer.set(bb,0,bufferEnd);
                return buffer;
            } catch(OutOfMemoryError oome) {
                buffer.set(NO_BYTE,0,0);
                final String msg="Caught: ChUtils#readBytes: OutOfMemoryError \n"+fi+"\nIncrease maxHeapSize "+stackTrceAsStrg(oome);
                error(msg);
                putln(msg);
                return new ByteArray(msg);
            }
        } finally{ closeStrm(fi);closeStrm(inStr);}
    }
    private static boolean copyNoClose(InputStream from, OutputStream to,IsEnabled isEnabled, byte stop[][],boolean[] returnIsTruncated) throws IOException {
        if (from==null || to==null) return false;
        if (isEnabled!=null && !isEnabled.isEnabled(ChUtils.class)) return false;
        final byte[][] saved= stop!=null ? new byte[stop.length][] : null;
        final byte[] buffer=new byte[4096];
        int bytes_read;
        boolean success=true;
    readBlock:
        while((bytes_read=from.read(buffer))!=-1) {
            Thread.yield();
            if (isEnabled!=null && !isEnabled.isEnabled(ChUtils.class)) { success=false; break;}
            if (stop!=null) {
                for(int iS=stop.length; --iS>=0;) {
                    final byte[] stp=stop[iS], sav=saved[iS];
                    final int l=sze(stp);
                    if (l==0) continue;
                nextH:
                    for (int h=sav!=null ? -l : 0; h<bytes_read-l; h++) {
                        boolean equ=true;
                        for(int n=0; n<l ; n++) {
                            final byte ch= h+n>=0 ?  buffer[h+n] : sav[l+h+n];
                            if (stp[n]!=ch) { equ=false; break;}
                        }
                        if (equ) {
                            to.write(buffer,0,h+l);
                            if (returnIsTruncated!=null) returnIsTruncated[0]=true;
                            break readBlock;
                        }
                    }
                }
                for(int iS=stop.length; --iS>=0;) {
                    if (saved[iS]==null) saved[iS]=new byte[stop[iS].length];
                    final byte[] sav=saved[iS];
                    for(int n=0; n<sav.length; n++) {
                        final int i=bytes_read-(sav.length-n), i2=n+bytes_read;
                        assert bytes_read<=buffer.length;
                        sav[n]= 0<=i && i<bytes_read ?  buffer[i] : 0<=i2 && i2<sav.length ? sav[i2] : 0;
                    }
                }
            }
            to.write(buffer,0,bytes_read);
        }
        return success;
    }
    public static void closeStrm(Object str) {
        try {
            if (str instanceof InputStream) ((InputStream)str).close();
            else if (str instanceof Reader) ((Reader)str).close();
            else if (str instanceof OutputStream) {
                try { ((OutputStream)str).flush();}catch(IOException e){}
                ((OutputStream)str).close();
            }
            else if (str instanceof Writer) {
                try { ((Writer)str).flush();}catch(IOException e){}
                ((Writer)str).close();
            }
        }catch(IOException e){}
    }
    public static URL resourceAsURL(String s) {
        final URL url=CLASSLOADER.getResource(s);
        return url!=null ?  url : ChClassLoader.resource(s);
    }
    public static InputStream rscAsStream(String path, String fileName) {
        if (path==null || fileName==null) return null;
        final String p=path.replace('.','/').replaceAll("//","/");
        final String s=p.endsWith("/") ? p+fileName : p+"/"+fileName;
        InputStream is=CLASSLOADER.getResourceAsStream(s);
        if (is==null) is=ChClassLoader.resourceAsStream(s);
        return is;
    }
    public static InputStream deflaterAccordingToExtension(final InputStream is,String s) {
        try {
            if (s.endsWith(".gz")||s.endsWith(".GZ")||s.endsWith(".tgz")) return new java.util.zip.GZIPInputStream(is);
            if (s.endsWith(".z")||s.endsWith(".Z")) return new HTTPClient.UncompressInputStream(is);
            if (s.endsWith(".bz2")) {
                if ('B'!=is.read() || 'Z'!=is.read()) {
                    putln("Error in ChUtils.deflaterAccordingToExtension bz2. ",s);
                }
                return new  org.apache.tools.bzip2.CBZip2InputStream(is);
            }
        } catch(Exception e){ putln("caught ChUtils#deflaterAccordingToExtension ",e);}
        return is;
    }
    public final static long STREAM_UNZIP=1<<1;

    public static InputStream inStream(final String fileNameOrUrl,final long options) {
        assert options<=STREAM_UNZIP;
        if (fileNameOrUrl!=null)
            try {
                final String fn=fileNameOrUrl.trim();
                final InputStream is;
                if (looks(LIKE_EXTURL,fn)) {
                    is=new URL(fn).openStream();
                } else {
                    final File f=file(fn);
                    if (!f.exists()) return null;
                    is=new FileInputStream(f);
                }
                canDownload=true;
                return (STREAM_UNZIP&options)!=0 ? deflaterAccordingToExtension(new BufferedInputStream(is),fn) : is;
            } catch(Exception e){
                putln("Caught ChUtils#inputStream ",fileNameOrUrl, e);
                /* throws .StringIndexOutOfBoundsException due to holding=idecuhmlib_ */
            }
        return null;
    }
    public static InputStream inStreamT(int timeOutSec, final String fn,long options ) {
        final Object params[]={fn, longObjct(options),null};
        final Thread t=ChDelay.newThread(instance(0),"INPUT_STREAM",params);
        t.start();
        int time=0;
        while(params[2]==null) {
            sleep(1000);
            if (time++>timeOutSec) {t.interrupt();break;}
        }
        return params[2] instanceof InputStream ? (InputStream)params[2] : null;
    }
    public static String[] readLines(Object o) {
        final File f=o instanceof File ? (File)o : null;
        if (f!=null && f.isDirectory()) return f.list();
        InputStream is=null;
        try {
            is=
                f!=null ? deflaterAccordingToExtension(new FileInputStream(f),f.toString()) :
                o instanceof InputStream ? (InputStream)o :
                o instanceof URL ? ((URL)o).openStream() :
                inStream(toStrg(o),STREAM_UNZIP);
        } catch(IOException e){}
        return readLines(is,null,null);
    }

    public static String[] readLines(InputStream is,String untilStartsWith, IsEnabled isEnabled ) {
        if (is==null) return null;
        final List<String> v=new ArrayList(999);
        final ChInStream chIs=new ChInStream(is);
        final ByteArray LINE=new ByteArray(999);
        try {
            int i=0;
            while(chIs.readLine(LINE.setEnd(0))) {
                final String line=LINE.newString();
                v.add(line);
                if (untilStartsWith!=null && line.startsWith(untilStartsWith)) break;
                if (isEnabled!=null && i%10==0  && !isEnabled.isEnabled(null)) return null;
                i++;
            }
        }
        finally{closeStrm(is);}
        return toStrgArry(v);
    }
    /* <<< Streams <<< */
    /* ---------------------------------------- */
    /* >>> Write >>> */
    public static boolean wrte(File f,byte bb[],int from,int to) {
        OutputStream fo=null;
        final int L=mini(sze(bb),to)-from;
        if (f==null || bb==null || L<0) return false;
        try {
            mkParentDrs(f);
            fo=fileOutStream(f);
            fo.write(bb,from,L);
        } catch(Exception e) { return false; }
        finally{
            closeStrm(fo);
        }
        if (fo!=null) for(int i=0;i<3; i++) if (sze(f)==0) sleep(99);
        wrteCheck(f,L);
        return true;
    }
    private static void wrteCheck(File f, int tL) {
        final int fL=sze(f);
        if (fL!=tL) {
            putln("Error writing file ",f," size is "+fL+" instead of "+tL);
        }
    }
    public static boolean wrte(File f,CharSequence cs) {
        if (f==null || cs==null) return false;
        OutputStream fw=null;
        mkParentDrs(f);
        try{
            fw=fileOutStream(f);
            if (!wrte(fw,cs)) return false;
        } catch(IOException ex){ return false;}
        finally {
            closeStrm(fw);
            if (fw!=null && sze(cs)>0) afterWrte(f);
        }
        wrteCheck(f,sze(cs));
        return true;
    }
    public static boolean wrte(File f,CharSequence... ss) {
        if (f==null || ss==null) return false;
        OutputStream fw=null;
        mkParentDrs(f);
        int len=0;
        try{
            fw=fileOutStream(f);
            for(CharSequence cs : ss) {
                if (cs!=null) {
                    wrte(fw,cs);
                    len+=cs.length();
                }
            }
        } catch(IOException ex){ return false;}
        finally {
            closeStrm(fw);
            if (fw!=null && len>0) afterWrte(f);
        }
        return true;
    }
    private static void afterWrte(File f) {
        if (isWindows()) {
            for(int i=0;i<3; i++) if (sze(f)==0) sleep(99);
        } else {
            final String name=f.toString();
            if (name.endsWith(".sh") || name.endsWith(".bat") || name.endsWith(".command")) makeExecutable(f);
        }
    }
    public static boolean wrte(OutputStream os,CharSequence cs)  throws IOException {
        if (os==null||cs==null) return false;
        if (cs instanceof ByteArray) {
            ((ByteArray)cs).write(os);
            return true;
        } else {
            final String s=toStrg(cs);
            if (s!=null) os.write(strg2bytes(s));
        }
        return true;
    }
    public static void hardLinkOrCopy(File src, File dest) {
        if (src==null || dest==null || src.equals(dest) || dest.length()>0) return;
        mkParentDrs(dest);
        synchronized(SYNC_CPY) {
            mkLink(src,dest,false);
            if (dest.length()==0) cpy(src,dest);
        }
    }

    public static boolean mkLink(File src, File dest, boolean soft) {
        if (src==null || dest==null || isWindows() || !Insecure.EXEC_ALLOWED) return false;
        mkParentDrs(dest);
        final String cmd[]={"ln", soft?"-s":null,  toStrg(src), toStrg(dest)};
        try { runtimeExec(rmNull(cmd)); } catch(IOException iox) {}
        return dest.exists();
    }
    public static boolean cpy(File src, File dest) {
        if (src!=null && dest!=null && src.length()>0) {
            try {
                return cpy(new FileInputStream(src),dest);
            } catch(IOException iox) {}
        }
        return false;
    }
    public static boolean cpy(InputStream from, File dest) {
        mkParentDrs(dest);
        if (from==null || dest==null) return false;
        OutputStream to=null;
        delFile(dest);
        try {
            if (!copyNoClose(from,to=fileOutStream(dest), (IsEnabled)null, (byte[][])null, (boolean[]) null)) return false;
        } catch(IOException e) {
            return false;
        } finally{
            closeStrm(from);
            closeStrm(to);
        }
        return sze(dest)>0;
    }
    private static Map<File,Writer> mapAppndF;
    public static Writer appndToFile(String s, File f) {
        if (mapAppndF==null) mapAppndF=new HashMap();
        Writer w=mapAppndF.get(f);
        try {
            if (w==null) {
                mkParentDrs(f);
                mapAppndF.put(f, w=fWriter(f));
            }
            w.write(s);
            w.flush();
        } catch(IOException iox) {stckTrc(iox); return null;}
        return w;
    }
    /* <<< Write <<< */
    /* ---------------------------------------- */
    /* >>> Tokens >>> */
    public static String tokn(Object txt, int from,int to0) {
        final int to= mini(sze(txt),to0);
        int b=nxt(NO_SPC,txt,from,to0);
        if (b<0) return "";
        int e=b;
        final byte[] T=txt instanceof byte[] ? (byte[])txt : null;
        final CharSequence cs=T==null ? (CharSequence)txt : null;

        while(e<to && !isSpc(T!=null ? T[e] : cs.charAt(e))) e++;
        return T!=null ? bytes2strg(T,b,e) : substrg(cs,b,e);
    }
    public static String tokn(byte[] txt, int from,int to0,String separator) {
        final int to= mini(txt.length,to0);
        int b=from;
        while(b<to && separator.indexOf((char)txt[b])>=0) b++;
        int e=b;
        while(e<to && separator.indexOf((char)txt[e])<0) e++;
        return bytes2strg(txt,b,e);
    }

    private static Reference<String[]> _bufSplit;
    public final static long  SPLIT_ALLOW_EMPTY_TOKENS=1<<0, SPLIT_TRIM_L=1<<1, SPLIT_TRIM_R=1<<2,SPLIT_TRIM=SPLIT_TRIM_R|SPLIT_TRIM_L;
    public static String[] splitTokns(long options, Object text, boolean[] delim) { return _splitTokns(options, text, 0, MAX_INT,  delim, (String)null);}
    public static String[] splitTokns(long options, Object text, String delim) { return _splitTokns(options, text, 0, MAX_INT, (boolean[])null, delim);}
    public static String[] splitLnes(long options, Object text)  { return _splitTokns(options, text, 0, MAX_INT, charClassOneChar('\n'), (String)null);}
    public static String[] splitTokns(long options,Object text) { return _splitTokns(options, text, 0, MAX_INT, charClass(SPC), (String)null);}
    public static String[] splitTokns(long options, Object text, int from, int to, boolean[] delim) {return _splitTokns(options, text,from,to,delim, (String)null);}
    public static String[] _splitTokns(long options, Object text, int from, int to, boolean[] delim, String sDelim) {
        final int L=mini(to,sze(text));
        if (L==0) return NO_STRING;
        if (text instanceof ByteArray) {
            final ByteArray ba=(ByteArray)text;
            return _splitTokns(options, ba.getBytes(), ba.getBegin()+from, ba.getBegin()+L,  delim, sDelim);
        }
        final byte[] bb=text instanceof byte[] ? (byte[])text : null;
        final String s= text instanceof String ? (String)text : null;
        final CharSequence cs= text instanceof CharSequence ? (CharSequence)text : null;
        if (bb==null && cs==null) assertNotNull(s);
        int begin=from;
        int count=0;
        synchronized("CU$$SYNCsplit") {
            final String buf0[]=deref(_bufSplit,String[].class);
            String[] buf=buf0;
            for(int i=from; i<L+1;i++) {
                final char c= i==L ? '?' : cs!=null ? cs.charAt(i) : (char)bb[i];
                if (i==L || (delim!=null && c<delim.length && delim[c]) || sDelim!=null && sDelim.indexOf(c)>=0) {
                    int end=i;
                    if (0!=(options&SPLIT_TRIM_R)) while(chrAt(end-1,text)==' ') end--;
                    if (0!=(options&SPLIT_TRIM_L)) while(chrAt(begin,text)==' ') begin++;
                    if ( 0!=(options&SPLIT_ALLOW_EMPTY_TOKENS) || end-begin>0) {
                        if (buf==null || buf.length<=count) buf=chSze(buf,count*3/2+100);
                        buf[count++]=substrg(text,begin,end);
                    }
                    begin=i+1;
                }
            }
            if (count==0) return NO_STRING;
            if (buf!=buf0) _bufSplit=new SoftReference(buf);
            {
                final String ss[]=new String[count];
                System.arraycopy(buf,0,ss,0,count);
                return ss;
            }
        }
    }

    private static ChTokenizer tokenizer;
    public static StringBuffer joinLines(Object ss[]) { return join(ss,"\n",new StringBuffer(999)); }
    private static Reference<StringBuffer> refJoin;
    public static String joinAsStrg(Object[] ss,String glue) {
        if (sze(ss)==0) return "";
        StringBuffer sb=(StringBuffer)deref(refJoin);
        if (sb==null) refJoin=new SoftReference(sb=new StringBuffer(9999));
        synchronized(sb) {
            sb.setLength(0);
            return toStrg(join(ss,glue,sb));
        }
    }
    public static StringBuffer join(Object[] ss,final String glue, StringBuffer sb) {
        return join(ss,glue, -1,-1, (String)null, sb);

    }

    public static StringBuffer join(Object[] ss,final String glue, int foldInitWidth, int foldWidth, String lineBreak, StringBuffer sb) {
        boolean isFirst=true;
        int sbL=sb.length()+foldInitWidth;
        for(int i=0; ss!=null && i<ss.length;i++) {
            if (ss[i]==null) continue;
            if (!isFirst && glue!=null) sb.append(glue);
            isFirst=false;
            sb.append(ss[i]);
            if (lineBreak!=null && sb.length()-sbL>foldWidth) {
                sb.append(lineBreak);
                sbL=sb.length();
            }
        }
        return sb;
    }
    /* <<< Tokens <<< */
    /* ---------------------------------------- */
    /* >>> Exec >>> */
    public static boolean cmdExists(String...cmd) {
        try { Insecure.runtimeExec(cmd,null,null);} catch(IOException e){ return false;}
        return true;
    }
    public static Process runtimeExec(String arg[]) throws IOException{ return runtimeExec(arg, null,null);}
    public static Process runtimeExec(String arg[], String[] env, File dir) throws IOException{
        if (!Insecure.EXEC_ALLOWED) return null;
        try {
            putln("ChUtils.runtimeExec ",arg);
            return Insecure.runtimeExec((String[])arg, env, dir);
        } catch(Exception e){ putln("ChUtils caught",e," ",arg);}
        return null;
    }

    /* <<< Exec <<< */
    /* ---------------------------------------- */
    /* >>> Count >>> */
    public static int countLetters(byte text[]) { return countLetters(text,0,MAX_INT);}
    public static int countLetters(byte text[],int start,int end) {
        if (text==null) return 0;
        int count=0;
        for(int i=mini(text.length,end);--i>=start;) {
            final int  b=text[i];
            if ('a'<=b && b<='z' || 'A'<=b && b<='Z' ) count++;
        }
        return count;
    }
    public static int[] count01234(int n) {
        int r[]=new int[n];
        for(int i=0;i<n;i++) r[i]=i;
        return r;
    }
    private static int countCharacters(String s,char c) {
        if (s==null) return 0;
        int iCR=-1,count=0;
        while(( iCR=s.indexOf(c,iCR+1))>=0) count++;
        return count;
    }
    public static int sumOf(int[] num, int toIndex) {
        int sum=0;
        for(int i=mini(toIndex,num.length); --i>=0;) sum+=num[i];
        return sum;
    }
    // ************** String & TEXT STUFF **************************
    public static String[] splitStrg(Object txt,char delimiter) {
        if (txt==null) return NO_STRING;
        final String s=toStrg(txt);
        final int n=countCharacters(s,delimiter)+1;
        final String lines[]=new String[n];
        Arrays.fill(lines,"");
        int iCR=-1,count=0,lastCR=-1;
        while(true) {
            iCR=s.indexOf(delimiter,iCR+1);
            if (iCR<0 && lastCR<s.length()-1) iCR=s.length(); // last line no CR
            if (iCR<0) break;
            lines[count]=s.substring(lastCR+1,iCR);
            count++;
            lastCR=iCR;
        }
        return lines;
    }

    public static StringBuffer format10(long num,int wInt, boolean separator, StringBuffer sb0) {
        final StringBuffer sb=sb0!=null ? sb0 : strBuf(SB_DEC_FORMAT);
        final int oldL=sb.length();
        sb.append(num);
        if (separator)for(int j=sb.length(); (j-=3)> (num>0?oldL:oldL+1);) sb.insert(j,',');
        for(int j=wInt+oldL-sb.length(); --j>=0;) sb.insert(oldL,' ');
        return sb;
    }

    public static int ftoa(double number,int wInt,int wFrac, byte buffer[], int pos0) {
        final boolean minus=number<0;
        final double f= minus ? -number : number;
        final long integ=(long)f;
        int pos=pos0;
        for(int i=wInt-stringSizeOfInt(integ)-(minus ? 1 : 0); --i>=0;) buffer[pos++]=' ';
        if (minus) buffer[pos++]='-';
        pos+=itoa(integ,buffer,pos);
        if (wFrac>0) {
            final double frac=f- integ;
            buffer[pos++]='.';
            for(int i=1; i<=wFrac; i++) {
                final int dig=((int)(frac*power10(i)))%10;
                buffer[pos++]=(byte)('0'+dig);
            }
        }
        return pos=pos0;
    }
    private static ByteArray _ftoa_ba;
    public static StringBuffer ftoa(double number,int wInt,int wFrac, StringBuffer buffer) {
        final StringBuffer sb=buffer!=null ? buffer : new StringBuffer(wInt+1+wFrac);
        ByteArray ba=_ftoa_ba;
        if (ba==null) ba=_ftoa_ba=new ByteArray(30);
        synchronized(ba) {
            ba.setEnd(0).append(number,wInt, wFrac);
            appnd(ba.getBytes(),0,ba.getEnd(),sb);
        }
        return sb;
    }
    public static int power10(int exp) {
        switch(exp) {
        case 0: return 1;
        case 1: return 10;
        case 2: return 100;
        case 3: return 1000;
        case 4: return 10000;
        case 5: return 100000;
        case 6: return 1000000;
        case 7: return 10000000;
        case 8: return 100000000;
        case 9: return 1000000000;
        default: return 1000000000;
        }
    }
    public static int stringSizeOfInt(final long x0) {
        final long x=x0<0 ? -x0 : x0;
          return
              (x!=x0 ? 1 : 0)+
              (
               x<10 ? 1 :
               x<100 ? 2 :
               x<1000 ? 3 :
               x<10000 ? 4 :
               x<100000 ? 5 :
               x<1000000 ? 6 :
               x<10000000 ? 7 :
               x<100000000 ? 8 :
               x<1000000000 ? 9 :
               x<10000000000L? 10 :
               x<100000000000L? 11 :
               x<1000000000000L? 12 :
               x<10000000000000L? 13 :
               x<100000000000000L? 14 :
               x<1000000000000000L? 15 :
               x<10000000000000000L? 16 :
               x<100000000000000000L? 17 :
               x<1000000000000000000L? 18 :
               19
               );
    }
    public static void foldText(byte[] bb,int from,int to, int lettersPerLine,StringBuffer sb) {
        final int n=mini(sze(bb),to);
        if (sb==null) sb=new StringBuffer(n+n/10);
        for(int  i=from;i<n;i+=lettersPerLine) {
            appnd(bb,i,mini(i+lettersPerLine,n),sb).append('\n');
        }
    }
    /* ---------------------------------------- */
    public static String onlyLetters(String s) {return s!=null ? s.replaceAll("[^A-Za-z]","") : null;}
    public static byte[] onlyLetters(byte[] bb) { return onlyLetters(bb,true,0,MAX_INT);}
    public static byte[] onlyLetters(byte[] bb, int from, int toIndex) { return onlyLetters(bb,true,from,toIndex);}
    public static byte[] onlyLetters(byte[] bb,boolean isAlsoLower, int from, int toIndex) {
        if (bb==null) return null;
        final int to=mini(bb.length, toIndex);
        byte[] aa=null;
        while(true) {
            int count=0;
            for(int i=from; i<to; i++) {
                final byte c=bb[i];
                if (c<='Z' && c>='A' || isAlsoLower && c<='z' && c>='a' ) {
                    if (aa!=null) aa[count]=c;
                    count++;
                }
            }
            if (aa==null) {
                if (count==0) return NO_BYTE;
                aa=new byte[count];
            } else break;
        }
        return aa;
    }
    /* ---------------------------------------- */

    public static String rplcToStrg(String needle, String str, CharSequence haystack) { return rplcToStrg(needle,str,haystack,null,null,0); }
    public static String rplcW(String needle, String str, CharSequence haystack) { return rplcToStrg(needle,str,haystack, charClass(SPC),charClass(SPC),0); }

    public static String rplcToStrg(String needle, String str, CharSequence haystack,  boolean[] leftDelim, boolean[] rightDelim, int from) {
        if (needle==null||str==null||haystack==null) return toStrg(haystack);
        if (haystack instanceof String && ((String)haystack).indexOf(needle,from)<0) return (String)haystack;
        final StringBuffer sb=toStringBuffer(haystack);
        return rplcSb(0L, needle,str, sb,from, leftDelim, rightDelim) ? sb.toString() : toStrg(haystack);

    }
    public static boolean rplcSb(char needle, char replacement, StringBuffer haystack) {
        boolean changed=false;
        if (haystack!=null) for(int i=haystack.length();--i>=0;) if (haystack.charAt(i)==needle) { changed=true; haystack.setCharAt(i,replacement); }
        return changed;
    }

    public static boolean rplcSb(long options, String needle, String replacement, StringBuffer haystack) {
        return rplcSb(options,needle,replacement,haystack, 0, (boolean[])null, (boolean[])null);
    }

    public static boolean rplcSb(long options, String needle, String replacement, StringBuffer haystack, int from, boolean[] leftDelim, boolean[] rightDelim) {
        if (needle==null||replacement==null||haystack==null) return false;
        final int needleL=needle.length(), replaceL=replacement.length();
        final boolean neval=0==(options&STRSTR_EVALOPTIONS);
        int start=from-1;
        boolean replaced=false;
        assert 0==(options&(STRSTR_IC|STRSTR_PREV));
        while((start=haystack.indexOf(needle,start+1))>=0) {
            if (start>0 && leftDelim!=null && !leftDelim[haystack.charAt(start-1)]) continue;
            if (rightDelim!=null && start+needleL<haystack.length() && !rightDelim[haystack.charAt(start+needleL)]) continue;
            if (!neval && !strstr_evalOptions(options, start, start+needleL,  haystack, from, haystack.length())) continue;
            haystack.replace(start,start+needleL,replacement);
            start+=replaceL-needleL;
            replaced=true;
            if ( (options&RPLC_ONLY_ONE_REPLACEMENT)!=0) return true;
        }
        return replaced;
    }

    public static byte[] rplc(long options, Object needle, Object replacement, byte haystack[]) { return rplc(options,needle,replacement,haystack,0,MAX_INT,MAX_INT);}

    public static byte[] rplc(long options, Object needle, Object replacement, byte haystack[], int from, int to) {
        return rplc(options,needle,replacement,haystack,from, to, MAX_INT);
    }
    public static byte[] rplc(long options, Object oNeedle, Object oReplacement, byte haystack[], int from0, int to0, int haystackTotalL) {
        final int needleL=sze(oNeedle), replacementL=sze(oReplacement);
        if (needleL==0 || oReplacement==null || haystack==null) return haystack;
        final int totalL=mini(haystack.length,haystackTotalL), from=maxi(0,from0),  to=mini(to0,totalL);
        final byte[] needle=oNeedle instanceof byte[] ? (byte[])oNeedle : null;
        final CharSequence sNeedle=oNeedle instanceof CharSequence ? (CharSequence)oNeedle : null;
        assertIsText(oNeedle);
        assertIsText(oReplacement);
        if (from>=to) return haystack;
        final char c0=chrAt(0,oNeedle);
        byte[] result=null,replacement=null;
        final boolean ignoreCase=0!=(options&STRSTR_IC), neval=0==(options&STRSTR_EVALOPTIONS);
        while(true) {
            int count=0;
            final int iMax=to-needleL+1;
            for(int i=from,d=from; i<iMax; ) {
                boolean match;
                if (ignoreCase ?  (haystack[i]|32)==(c0|32) : haystack[i]==c0) {
                    match=true;
                    for(int j=needleL; --j>=0;) {
                        final int cn=needle!=null?needle[j] : sNeedle.charAt(j);
                        final int ch=haystack[i+j];
                        //if (ch!=cn && (ignoreCase && is(LETTR,ch) ? (ch|32)!=(cn|32) :  true) )  {
                        if (!(ch==cn || ignoreCase && (ch|32)==(cn|32) && is(LETTR,ch))) {
                            match=false;
                            break;
                        }
                    }
                } else match=false;
                if (match && (neval || strstr_evalOptions(options, i, i+needleL,  haystack, from,to))) {
                    if (result!=null) {
                        if (replacement==null) replacement=oReplacement instanceof byte[] ? (byte[])oReplacement : strg2bytes(toStrg(oReplacement));
                        if (replacementL>0) System.arraycopy(replacement,0, result,d,replacementL);
                        d+=replacementL;
                    }
                    i+=needleL;
                    count++;
                } else {
                    if (result!=null && d<result.length) result[d++]=haystack[i];
                    i++;
                }
            }
            if (result==null && count>0) {
                result=new byte[totalL+count*(replacementL-needleL)];
                if (from>0) System.arraycopy(haystack,0,result,0,from);
                final int r=totalL-to+needleL;
                if (r>0 && result.length-r>=0) System.arraycopy(haystack, to-needleL, result, result.length-r, r);
            } else break;
        }
        return result!=null ? result : haystack;
    }

 public static String rplcChars(boolean[] charClass, char in, String s) { return rplcChars(charClass,in,s,0,MAX_INT); }
    public static String rplcChars(boolean[] charClass, char in, String s, int from, int to) {
        char cc[]=null;
        if (s!=null) {
            for(int i=mini(to,s.length()); --i>=from;) {
                final char c=s.charAt(i);
                if (c>127 || charClass[c]) {
                    if (cc==null) cc=s.toCharArray();
                    cc[i]=in;
                }
            }
        }
        return cc!=null ? new String(cc) : s;

    }
    public static String rplcNoFilenameChars(Object charSeq) { return rplcChars(charClass(NO_FILENM),'_',toStrg(charSeq),0,MAX_INT); }
    public static String uCase(String s) { return s!=null ? s.toUpperCase() : null;}
    public static String lCase(String s) { return s!=null ? s.toLowerCase() : null;}
    public static char uCase(char c) { return (char)(is(LOWR,c) ? c&~32 : c); }
    public static char lCase(char c) { return (char)(is(UPPR,c) ? c|32 : c); }
    public static String capitalize(CharSequence cs) {
        if (cs==null) return null;
        String s=toStrg(cs);
        return s.length()>0 ? uCase(s.charAt(0))+  s.substring(1) : s;
    }

    public static String delAfter(String pattern,Object haystack, boolean last) {
        final String h=toStrg(haystack);
        final int i=h==null||pattern==null ? -1 : last ? h.lastIndexOf(pattern) : h.indexOf(pattern);
        return i>=0 ? h.substring(0,i) : h;
    }
    public static String delSfx(String suffix,Object haystack) {
        final String h=toStrg(haystack);
        return h!=null && suffix!=null && h.endsWith(suffix) ? h.substring(0,h.length()-suffix.length()) :h;
    }
    public static String delPfx(String prefix,Object haystack) {
        String h=toStrg(haystack);
        return h!=null && prefix!=null && h.startsWith(prefix) ? h.substring(prefix.length()) :h;
    }
    public static String getSfx(Object text,char sep) {
        final String s=toStrg(text);
        if (s==null) return null;
        final int i= s.lastIndexOf(sep);
        return i<0 ? "" : s.substring(i);
    }
    public static String delFromChar(String s, char c) {
        final int i=s!=null ? s.indexOf(c) : -1;
        return i>=0 ? s.substring(0,i) : s;
    }
    public static String withoutLastComponent(Object text,char sep) {
        String s=toStrg(text);
        if(s==null) return s;
        final int i=s.lastIndexOf(sep);
        return i<0 ? s:  s.substring(0,i);
    }
    public static String lastComponent(Object text, char sep) {
        final String s=toStrg(text);
        final int i=s==null ? -1 : s.lastIndexOf(sep);
        return i<0 ? "" :  s.substring(i+1);
    }

    public static String lastPathCompnt(Object text) {
        final String s=toStrg(text);
        final int i= s==null ? -1 : maxi(s.lastIndexOf('/'),s.lastIndexOf('\\'));
        return i<0 ? "" :  s.substring(i+1);
    }

    public static String withoutDotSuffix(Object o) { return withoutLastComponent(o,'.');}
    public static String dotSuffix(Object file) {
        final String n= file!=null ? file.toString() : null;
        if (n==null) return null;
        final int dot=n.lastIndexOf('.');
        return dot>=0 ? n.substring(dot).intern() : null;
    }
    public static String dotSuffixLC(Object file) {
        final String n= file!=null ? file.toString() : null;
        if (n==null) return null;
        final int dot=n.lastIndexOf('.');
        return dot>=0 ? n.substring(dot).toLowerCase().intern() : null;
    }

    public static String frstTkn(String s) { return wordAt(nxt(NO_SPC,s),s);}
    public static String wordAt(int from, CharSequence u) { return wordAt(from,u, NO_SPC);}
    public static String wordAt(int from, CharSequence u, int charClass) {
        if (u==null) return null;
        int to=from;
        while(is(charClass,u,to)) to++;
        return from<to ? toStrg(u.subSequence(from,to)) : "";
    }

    public static int idxOfLetters(byte needle[], byte haystack[]) { return idxOfLetters(needle,haystack,0,MAX_INT);}

    public static int idxOfLetters(byte needle[], byte haystk[], int hFrom, int hTo0) {
        final int hTo=mini(hTo0,sze(haystk));
        final int nFrom=nxt(LETTR,needle,0,MAX_INT);
        final int nTo=prev(LETTR,needle,needle.length-1,-1)+1;
        //putln(" nFrom="+nFrom+"  nTo="+nTo);
        if (nFrom<0 || nFrom>=nTo) return -1;
        final int n0=needle[nFrom]|32;
        nextH:
        for(int iH0=hFrom; iH0<hTo; iH0++) {
            if ( (32|haystk[iH0]) != n0) continue nextH;
            for(int iN=nFrom+1, iH=iH0+1; iN<nTo; iN++, iH++) {
                if (iH>=hTo) continue nextH;
                while(  !is(LETTR, needle,iN) ) if (++iN>=nTo) continue nextH;
                while(  !is(LETTR, haystk,iH) ) if (++iH>=hTo) continue nextH;
                //putln("n/h="+iN+" "+iH+"  "+chrAt(iN,needle)+chrAt(iH,haystk));
                if ((haystk[iH]|32) != (needle[iN]|32) ) continue nextH;
            }
            return iH0;
        }

        return -1;

    }

    public static double variableValueF(String varName, Object haystack, int  hFrom, int hTo, char equalsSign, boolean spaceBeforeEquals, boolean ignoreCase) {
        for(int i=hFrom; (i=strstr(STRSTR_w|(ignoreCase?STRSTR_IC:0L),varName, haystack, i, hTo))>=0; i++) {
            i+=varName.length();
            if (spaceBeforeEquals) i=nxt(NO_SPC,haystack,i,hTo);
            if (chrAt(i,haystack)==equalsSign) {
                i++;
                if (spaceBeforeEquals) i=nxt(NO_SPC,haystack,i,hTo);
                final double f=atof(haystack,i);
                if (!Double.isNaN(f)) return f;
            }
        }
        return Double.NaN;
    }

    /* <<< String <<< */
    /* ---------------------------------------- */
    /* >>> Bit-Sets >>> */
    public static boolean isTrue(boolean[] bb,int i) {  return bb!=null && i>=0 && i<bb.length && bb[i];}
    public static boolean isTrue(String s,final int i) {
        final int i4=i/4, L=sze(s);
        if (L==3 && "all".equals(s)) return true;
        if (L<=i4) return false;
        final char c=s.charAt(i4);
        final int d= c>='a' ? c-('a'-10) : c>='A' ? c-('A'-10) : c>='0' ? c-'0' : 0;
        return (d&(1<<(i%4)))!=0;
    }

    public static boolean[] withoutOffset(final boolean bb[], final int offset) {
        if (offset==0 || bb==null) return bb;
        if (bb.length+offset<0) return NO_BOOLEAN;
        final boolean selected[]=new boolean[bb.length+offset];
        if (offset>0) System.arraycopy(bb,0,selected,offset,bb.length);
        else System.arraycopy(bb,0,selected,0,bb.length+offset);
        return selected;
    }

    public static boolean looksLikeSet(byte T[], int from, int to, boolean allowColonChain) {
        if (nxt(DIGT,T,from,to)<0) return false;
        for(int i=from; i<to;i++) {
            final char c=(char)T[i];
            if (!is(DIGT,c) && c!=',' && c!='-'  &&  !(allowColonChain&&c==':')) {
                if (! (allowColonChain && is(LETTR,c) && i>from && T[i-1]==':') ) return false;
            }
        }
        return true;

    }
    public static boolean[] parseSet(CharSequence charSeq, int maxIdx, int offset0) {
        return parseSet(charSeq, maxIdx, offset0, (Range)null);
    }
    public static boolean[] parseSet(CharSequence charSeq, int maxIdx, int offset0, Range minMax) {
        if (charSeq==null) return null;
        final String s=toStrg(charSeq);
        boolean flag[]=null;
        int maxIndex=0, minIndex=MAX_INT, offset=offset0;
        rplcToStrg(" ","",s);
        for(int pass=0; pass<2; pass++) {
            boolean firstToken=true;
            final StringTokenizer st1=new StringTokenizer(s,", ");
            while(st1.hasMoreTokens()) {
                final String t1=st1.nextToken();
                if(firstToken) {
                    firstToken=false;
                    final char c0=chrAt(0,t1);
                    if (c0=='+' || c0=='-') { offset=offset0+atoi(t1);continue;}
                }
                final int i=t1.indexOf('-');
                if (i>0) { // range ,e.g. 3-7
                    final int
                        from=maxi(0,offset+atoi(t1)),
                        to=mini(maxIdx,t1.endsWith("-") ?  MAX_INT : offset+atoi(t1,i+1));
                    if (to>maxIndex) maxIndex=to;
                    if (from<minIndex) minIndex=from;
                    if (flag!=null) for(int j=from;j<=to && j<flag.length;j++) flag[j]=true;
                } else if (i<0) { //single number
                    final int num=offset+atoi(t1);
                    if (num>maxIndex) maxIndex=num;
                    if (num<minIndex) minIndex=num;
                    if (flag!=null && num<flag.length && num>=0) flag[num]=true;
                }
            }
            if (flag==null) flag=new boolean[mini(maxIndex,maxIdx)+1];
        }
        if (minMax!=null) minMax.set(minIndex,maxIndex+1);
        return flag!=null ? flag : NO_BOOLEAN;
    }
    public static void reverseArray(boolean bb[],int from,int to) {
        for(int i=from,iRev=mini(bb.length,to)-1; i<iRev; i++,iRev--) {
            boolean bTemp=bb[iRev]; bb[iRev]=bb[i]; bb[i]=bTemp;
        }
    }
    /* <<< Bit-Sets <<< */
    /* ---------------------------------------- */
    /* >>> Boolean >>> */
    public static int lastTrue(boolean bb[]) {
        if (bb==null) return -1;
        for(int i=bb.length;--i>=0;) if (bb[i]) return i;
        return -1;
    }
    public static int firstTrue(boolean bb[]) {
        if (bb==null) return -1;
        for(int i=0;i<bb.length;i++) if (bb[i]) return i;
        return -1;
    }
    public static int countTrue(boolean bb[]) {
        if (bb==null) return 0;
        int count=0;
        for(int i=bb.length;--i>=0;) if (bb[i]) count++;
        return count;
    }
    public static int countTrue(boolean bb[], int from, int to) {
        if (bb==null) return 0;
        int count=0;
        for(int i=mini(to,bb.length);--i>=from;) if (bb[i]) count++;
        return count;
    }

    public static boolean[] trimArray(final boolean bb[],final int first) {
        if (bb==null) return null;
        final int last=lastTrue(bb)+1;
        if (first==0 && last==bb.length) return bb;
        if (first<0 || first>=last) return NO_BOOLEAN;
        final boolean[] bbNew=new boolean[last-first];
        System.arraycopy(bb,first,bbNew,0,last-first);
        return bbNew;
    }
  public static String intArrayToTxt(int ii[], int width) { return intArrayToTxtFromTo(ii,0,MAX_INT, width); }
  public static String intArrayToTxtFromTo(int ii[], int from, int to, int width) {
        final int t=mini(to,sze(ii));
        final ByteArray sb=new ByteArray(t*width+t);
        for(int i=from; i<t;i++) {
            if (i>0) sb.append(',');
            sb.append(ii[i],width);
        }
        return sb.toString();
    }

    public static String boolToTxt(boolean bb[]) { return boolToTxt(bb,0,"-",new ByteArray(999)).newString(); }
    public static ByteArray boolToTxt(boolean bb[],int offset, String intervall, ByteArray sb) {
        if (bb==null) return new ByteArray("null");
        if (sb==null) sb=new ByteArray(99);
        boolean isFirst=true;
        for(int i=0; i<bb.length; i++) {
            if (!bb[i]) continue;
            if (isFirst)  isFirst=false; else sb.append(',');
            final int i0=i;
            while( i<bb.length && bb[i]) i++;
            sb.append(i0+offset);
            if (i-i0>1) sb.append(i-i0>2 ? intervall : ",").append(i+offset-1);
        }
        return sb;
    }
    public static ByteArray boolToTxt(long bb,int offset, String intervall, ByteArray sb) {
        if (sb==null) sb=new ByteArray(99);
        boolean isFirst=true;
        for(int i=0; i<64; i++) {
            if ( (bb & (1l<<i))==0) continue;
            if (isFirst)  isFirst=false; else sb.append(',');
            final int i0=i;
            while( i<64 &&   (bb & (1l<<i))!=0) i++;
            sb.append(i0+offset);
            if (i-i0>1) sb.append(i-i0>2 ? intervall : ",").append(i+offset-1);
        }
        return sb;
    }
    public static long boolToLong(boolean bb[]) {
        long r=0;
        for(int i=sze(bb); --i>=0;) if (bb[i]) r|= (1L<<i);
        return r;
    }
    /* <<< Boolean <<< */
    /* ---------------------------------------- */
    /* >>> Properties >>> */
    public static void storePrprts(Properties p ,File f) {
        if (f!=null && p!=null) {
            OutputStream fOut=null;
            try {
                mkParentDrs(f);
                p.store(fOut=fileOutStream(f),null);
            } catch(Exception e){ putln("caught ChUtils#store properties ",e); }
            finally { closeStrm(fOut);}
        }
    }
    public final static String PROPERTY_FILE="~/@/myProperties.txt";
    private static Properties properties;
    private static Properties properties() {
        if (properties==null) {
            properties=new Properties();
            InputStream is=null;
            final File f=file(PROPERTY_FILE);
            if (sze(f)>0) {
                try {
                    properties.load(is=new FileInputStream(f));
                } catch(Exception e){ putln("caught ChUtils#properties() ",e); }
                finally{ closeStrm(is);}
            }
        }
        return properties;
    }
    public static String getPrpty(Class clas,String key,String defaulT) { return properties().getProperty(clas.getName()+"."+key,defaulT); }
    public static void setPrpty(Class clas,String key,boolean bool) { setPrpty(clas,key,bool ? "true":"false");}
    public static void setPrpty(Class clas,String key,int v) { setPrpty(clas,key,String.valueOf(v));}
    public static void setPrpty(Class clas,String key,String defaulT) {
        try {
            properties().setProperty(clas.getName()+"."+key,defaulT);
        }catch(Exception e){}
    }
    public static int getPrpty(Class clas,String key,int defaulT) {
        return atoi(properties().getProperty(clas.getName()+"."+key,String.valueOf(defaulT)),0);
    }
    public static boolean getPrpty(Class clas,String key,boolean defaulT) {
        return "true".equals(properties().getProperty(clas.getName()+"."+key,defaulT ? "true":"false"));
    }
    /* <<< Properties <<< */
    /* ---------------------------------------- */
    /* >>> Encoding >>> */
    /**
       32 bit given as an int value are converted to a String of 4 characters.
       In protein model Strings of 4 characters are encoded as an int and can be decoded with this method.
    */
    public static char[] bit32To4chars(int bit32,char[] buffer4chars) {
        if (buffer4chars==null) buffer4chars=new char[4];
        final int l=buffer4chars.length;
        if (l>3) buffer4chars[3]=(char)(((bit32 & 0xff000000)>>24));
        if (l>2) buffer4chars[2]=(char)(((bit32 & 0x00ff0000)>>16));
        if (l>1) buffer4chars[1]=(char)(((bit32 & 0x0000ff00)>>8));
        if (l>0) buffer4chars[0]=(char)(( bit32 & 0x000000ff));
        return buffer4chars;
    }
    public static String htmlEncod(Object o) {
        final CharSequence s= o instanceof CharSequence ? (CharSequence)o : toStrg(o);
        if (s==null) return null;
        final int l=s.length();
        StringBuffer sb=null;
        for(int i=0; i<l;i++) {
            final char c=s.charAt(i);
            if (c=='<' || c=='>' || c=='&') {
                if (sb==null) sb=new StringBuffer(l+40).append((Object)s.subSequence(0,i));
                sb.append( c=='<' ? "&lt;" : c=='>' ? "&gt;" : "&amp;");
            } else {
                if (sb!=null) sb.append(c);
            }
        }
        return toStrg(sb!=null ? sb : o);
    }
    public final static byte[] HEX2INT=new byte[256];
    static {
        Arrays.fill(HEX2INT,(byte)-1);
        for(byte i=0;i<10;i++) HEX2INT[i+'0']=i;
        for(byte i=10;i<16;i++) HEX2INT['A'-10+i]=HEX2INT['a'-10+i]=i;
    }
    public static String htmlDecodAsStrg(CharSequence cs) { return toStrg(htmlDecod(cs)); }   public static CharSequence htmlDecod(CharSequence s) {
        if (s==null) return null;
        final int L=s.length();
        StringBuffer sb=null;
        for(int i=0; i<L;i++) {
            final char c=s.charAt(i);
            boolean done=false;
            if (c=='&' && i+3<L) {
                final int c1=s.charAt(i+1)|32, c2=s.charAt(i+2)|32, c3=s.charAt(i+3)|32;
                final boolean
                    amp= c1=='a' && c2=='m' && c3=='p',
                    lt=  c1=='l' && c2=='t',
                    gt=  c1=='g' && c2=='t',
                    hex= c1=='#' && HEX2INT[c2]>=0 && HEX2INT[c3]>=0;
                final int l=amp||hex ? 4 : lt||gt ? 3 : -1;
                if (l>0 && chrAt(i+l,s)==';') {
                    if (sb==null) sb=new StringBuffer(L+40).append((Object)s.subSequence(0,i));
                    sb.append(amp ? '&' : lt ? '<' : gt ? '>' : hex ? (char) (16*HEX2INT[c2]+HEX2INT[c3]) : '?');
                    i+=l;
                    done=true;
                }
            }
            if (sb!=null && !done) sb.append(c);
        }
        return toStrg(sb!=null ? sb : s);
    }
    /* <<< Encoding <<< */
    /* ---------------------------------------- */
    /* >>> Download >>> */
    private final static Map<String,int[]>  countDownloads=new HashMap();
    private static ChRunnable downloadLogger;
    public static void setDefaultDownloadLogger(ChRunnable r) { downloadLogger=r;}
    public static void sayDownloading(ChRunnable log, String msg) {
        final ChRunnable r=log!=null ? log : downloadLogger;
        if (r!=null) r.run(ChRunnable.SAY_DOWNLOADING, msg);
    }

    public static Thread thread_download(URL url, int ageDays) { return thread_download(url, ageDays,  (File[])null, downloadLogger); }
    public static Thread thread_download(URL url, int ageDays, File ffEquivalent[],  ChRunnable log) {
        return threadM("download_TS",ChUtils.class, new Object[]{url,intObjct(ageDays), ffEquivalent, log});
    }
    public static File download_TS(URL url, int ageDays) { return download_TS(url,ageDays, (File[])null, downloadLogger);   }
    //public static File download_TS(URL url, int ageDays, File ffEquivalent[]) { return download_TS(url,ageDays, ffEquivalent, downloadLogger); }
    public static File download_TS(URL url, int ageDays, File ffEquivalent[],  ChRunnable log) {
        final String s=url!=null ? url.toString() : null;
        final File f=file(s);
        if (sze(f)>0) return f;
        for(int i=sze(ffEquivalent); --i>=0;) if (sze(ffEquivalent[i])>0) return ffEquivalent[i];
        if (s==null) return null;
        int count[]=null;
        try {
            synchronized(countDownloads) {
                count=countDownloads.get(s);
                if (count==null) countDownloads.put(s,count=new int[1]);
                sleep(999*count[0]*count[0]);
                count[0]++;
            }
            synchronized(toStrgIntrn(f)) {
                if (sze(f)==0 || (currentTimeMillis()-f.lastModified())/(1000*60*60*24)>ageDays) {
                    delFile(f);
                    mkParentDrs(f);
                    final Object ff[]={f,log};
                    if (log!=null) ChDelay.newThread(instance(0),"WATCH_DOWNLOAD",ff).start();
                    downloadAndDecompress(s,f);
                    ff[0]=null;
                    //debug("Downloadanddecompress f="+f+" "+sze(f)+" done");
                    ff[0]=null;
                }
            }
            if (log!=null && sze(f)>0) log.run(ChRunnable.DOWNLOAD_FINISHED,f);
            return f;
        } finally { count[0]=maxi(count[0]--,0); }

    }
    private static Writer fwLogDownload;
    public static void logDownload(URL src, File f, String comment) {
        if (src==null) return;
        try {
            Writer fw=fwLogDownload;
            if (fw==null) (fw=fwLogDownload=fWriter(dirLog()+"/downloads.log")).write("Files downloaded from the Internet\n\n");
            if (comment!=null) fw.write(comment);
            fw.write('\t');
            fw.write(src.toString());
            fw.write('\t');
            if (f!=null) fw.write(filepathUnixStyle(f));
            fw.write('\n');
            fw.flush();
        } catch(IOException iox) { stckTrc(iox);}
    }

    //    public static  Thread thread_unattendedDownload(URL url) { return threadM("unattendedDownload",ChUtils.class,new Object[]{url});}
    public static File unattendedDownload(URL url) {
        if (url==null) return null;
        final String sURL=toStrg(url);
        final int slash=sURL.indexOf('/',10);
        final String server=slash>0 ? sURL.substring(0,slash) : sURL;
        final File f=file(sURL), fTmp=file(f+"TMP");

        logDownload(url,fTmp,"unattendedDownload");
        synchronized(server.intern()) {
            if (isMyComputer()) out.print(" ... ");
            final InputStream is=inStreamT(15,sURL, 0L);
            cpy(is,fTmp);
        }
        renamFileOrCpy(fTmp,f);
        return f;
    }
    public static void setEdtFTP(boolean b) {
        useEdtFTP=b;
        if (b) new AnonymousFTPPROXY().proxyObject();
        else mapFTP.clear();
    }
    private static boolean useEdtFTP;
    private final static Map<String,AnonymousFTPPROXY> mapFTP=new HashMap();
    private final static byte ENDMDL[][]={"\nENDMDL".getBytes()}; // "MODEL        2"    2O0S 2JQU
    protected static boolean useEdtFTP(String src) {
        return Insecure.CLASSLOADING_ALLOWED && src!=null && (useEdtFTP || /* src.startsWith("ftp://ftp.genome.jp") || */ src.startsWith("ftp://ftp.embl-heidelberg.de"));
    }

    public static void downloadAndDecompress( String src, File fDest) { downloadAndDecompress(src,fDest,(ChRunnable)null,(IsEnabled)null);}
    public static void downloadAndDecompress( String src,final File fDest, ChRunnable log,IsEnabled isEnabled) {
        if (fDest==null || src==null || fDest.length()>0 || (isEnabled!=null && !isEnabled.isEnabled(null))) return;
        logMsg(log,Color.YELLOW,"ChUtils.downloadAndDecompress ",src," ==> ",fDest,"\n",Color.WHITE);
        final String fnDest=fDest.getName();
        mkParentDrs(fDest);
        String srcSuffix=null,destSuffix=null;
        for(String suffix:COMPRESS_SUFFIX) {
            if (fnDest.endsWith(suffix)) destSuffix=suffix;
            if (src.endsWith(suffix)) srcSuffix=suffix;
        }
        final File fDownloadTmp=file(fDest+TMP_DOWNLOAD_SFX);
        delFile(fDownloadTmp);
        final URL url=url(src);
        logDownload(url,fDest,"downloadAndDecompress ");
        if (url==null) return;
        if (src.startsWith("ftp://")) {
            AnonymousFTPPROXY ftp=null;
            if (useEdtFTP(src)) {
                logMsg(log,"Going to initialize edtftpj: ");
                ftp=mapFTP.get(url.getHost());
                if (ftp==null && sze(file(dirJars()+"/"+delSfx(".gz",delSfx(".pack",AbstractProxy.jarFile(AbstractProxy.EDTFTPJ)))))>0 ) {
                    mapFTP.put(url.getHost(),ftp=new AnonymousFTPPROXY());
                }
                logMsg(log,"edtftpj "+(ftp!=null?" success\n":" failed\n"));
            }
            if (ftp!=null) {
                final File fDownload= (srcSuffix!=destSuffix)  ? file(fDest+srcSuffix) : fDest;
                delFile(fDownload);
                ftp.download(url,fDownloadTmp,log);
                if (fDownloadTmp.length()>0) {
                    logMsg(log,Color.GREEN,"success AnonymousFTPPROXY ",fDownloadTmp.getName(),"\n");
                    renamFileOrCpy(fDownloadTmp,fDownload);
                    if (fDownload!=fDest) unzip(fDownload);
                }
            }
        }
        if (fDest.length()+fDownloadTmp.length()==0) {
            if (!startedInfoProxy&&!canDownload) { startedInfoProxy=true; ChDelay.newThread(instance(0),"INFO_PROXY",null).start();}
            logMsg(log,"Using ChUtils.inputStream for "+src+"\n");
            final byte[][] STOP= getPrpty(ChUtils.class,PROP_NMR_ONLY_FIRST_MODEL,true) &&
                (src.startsWith("http://www.rcsb.org/pdb/files") ||src.indexOf("/pub/pdb/data/structures/")>0) ? ENDMDL : null;
            final InputStream is=inStreamT(99, src,  srcSuffix!=destSuffix ? STREAM_UNZIP : 0L);
            canDownload=true;
            OutputStream fo=null;
            if (is!=null) {
                final boolean[] isTruncated= STOP==ENDMDL ? new boolean[1]: null;
                boolean success=false;
                try {
                    fo=fileOutStream(fDownloadTmp);
                    success=copyNoClose(is,fo,isEnabled,STOP,isTruncated);
                } catch(IOException e){ putln("ChUtils#downloadAndDecompress ",e);}
                finally {
                    if (isTruncated!=null && isTruncated[0]) try {
                            fo.write("\nREMARK   only the first model has been downloaded!\n".getBytes());
                        } catch(Exception e){}
                    closeStrm(is);
                    closeStrm(fo);
                    if (fDownloadTmp.length()>0) canDownload=true;
                    if (success && sze(fDownloadTmp)>0) renamFileOrCpy(fDownloadTmp,fDest);
                }
            }
        }
        final String ex=dotSuffixLC(fDest);
        if (sze(fDest)>0 && (ex==".zip" || ex==".jar"))
            if (!ChZip.checkIntegrityOfZipFile(fDest))
                error("The zip file "+fDownloadTmp+" <br>is corrupt.<br>Please delete it!");
    }
    private static boolean canDownload, startedInfoProxy;

    public static boolean isHttpResponse404(File f) {
        if (sze(f)==0 || sze(f)>30000) return false;
        InputStream is=null;
        try {
            is=new FileInputStream(f);
            final byte bb[]=new byte[2048];
            is.read(bb);
            final int idx=strstr(STRSTR_IC,"not found</title>",bb);
            return bb[0]=='<' && idx>0;
        } catch(IOException e) { return false;}
        finally{closeStrm(is);}
    }

    /* <<< Downloading <<< */
    /* ---------------------------------------- */
    /* >>> Networking >>> */
    public static String getHeaderFld(String field, URL u, int timeOut_ms) {
        final Object params[]={field,u,null,null};
        final Thread t=ChDelay.newThread(instance(0),"gHF",params);
        t.setDaemon(true);
        t.start();
        long time=currentTimeMillis();
        while(params[2]==null) {
            sleep(3);
            if (currentTimeMillis()-time>timeOut_ms) {
                t.interrupt();
                break;
            }
        }
        java.net.URLConnection uc=(java.net.URLConnection)params[3];
        return (String)params[2];
    }
    public static String getHeaderFld(String field, URL u) {
        if (u!=null) {
            try {
                final java.net.URLConnection c=u.openConnection();
                if (c!=null) {
                    c.setUseCaches(false);
                    return c.getHeaderField(field);
                }
            } catch(Exception ex) { putln("caught getHeaderField url=",u, ex);}
        }
        return null;
    }
    public static int isUpToDate(File f, URL u) {
        if (f==null || u==null) return -1;
        if (f.length()==0) return 0;
        final long[] time=lastModifiedMsHttpHeader(u,5);

        if (time==null || time[0]<=0) {
            debug("ChUtils#isUpToDate: "+ANSI_FG_RED+"no response"+ANSI_RESET+" "+u);
            return -1;
        }
        final long ageServer=time[1]-time[0];
        final long ageFile=currentTimeMillis()-f.lastModified();
        if (debug(u.toString())) {
            final StringBuffer sb=new StringBuffer(99);
            format10(time[1]/1000,     8, true, sb.append("\n    ageServer = "));
            format10(time[0]/1000,     8, true, sb.append(" - "));
            format10(ageServer/1000,   8, true, sb.append(" - "));
            format10(ageFile/1000,     8, true, sb.append(" age-local="));
            format10(time[1]/1000,     8, true, sb.append("\n   http-Date         ="));
            format10(time[0]/1000,     8, true, sb.append("\n   http-Last-modified="));
            format10(ageFile-ageServer,8, true, sb.append("\n ageFile-ageServer ="));
            putln(sb);
        }
        boolean isU2D=ageFile<ageServer;
        //debug( "isUpToDate="+isU2D);
        return isU2D ? 1 : 0;
    }
    public static long[] lastModifiedMsHttpHeader(URL u, int timeOutSec) {
        final Object params[]={u,null};
        final Thread t=ChDelay.newThread(instance(0),"LM_HTTP",params);
        t.start();
        int time=0;
        while(params[1]==null) {
            sleep(1000);
            if (time++>timeOutSec) {t.interrupt();break;}
        }
        return params[1] instanceof long[] ? (long[])params[1] : null;
    }
    public static long[] lastModifiedMsHttpHeader(URL u) {
        if (u==null) return null;
        try{
            final java.net.URLConnection c=u.openConnection();
            c.setUseCaches(false);
            final String lm=c.getHeaderField("Last-Modified");
            final String date=c.getHeaderField("Date");
            final long ms_lm=sze(lm)>0 ? Date.parse(lm) : -1;
            final long ms_st=sze(date)>0 ? Date.parse(date) : -1;
            if (ms_lm>ms_st) {
                debug(RED_ERROR+" in lastModifiedMsHttpHeader url=");
                debug(u.toString());
                debug(" lm=");
                debug(lm);
                debug(" date=");
                debug(date);
            }
            return new long[]{ms_lm,  ms_st};
        } catch(Exception ex) { putln("caught lastModifiedMsHttpHeader ",u, ex);}
        return null;
    }
    public static URL url(Object txt) {
        if (txt==null || txt instanceof URL) return (URL)txt;
        if (txt instanceof File) try { return ((File)txt).toURL(); }catch(Exception e){}
        final String s0=rplcToStrg(DO_NOT_ASK, "", toStrgTrim(txt));
        if (s0!=null) {
            final int daysCache=s0.indexOf(KEEP_DAYS_IN_CACHE);
            final String s=daysCache>0?s0.substring(0,daysCache):s0;
            final File f=!looks(LIKE_EXTURL,s) && looks(LIKE_FILEPATH_EVALVAR,s) ? file(s) : null;
            try {  return f!=null ?  f.toURL() : new URL(s); }catch(Exception e){}
        }
        return null;
    }
    public static int keepDaysInCache(CharSequence url) {
        final int i=strstr(STRSTR_AFTER,KEEP_DAYS_IN_CACHE,url);
        return i>0 ? atoi(url, i) : 99999;
    }
    public static String urlDecode(String s) {
        if (s!=null) try {return  java.net.URLDecoder.decode(s);} catch(IllegalArgumentException e){}
        return s;
    }
    public static String jnlpDecode(String s) {
        return rplcToStrg("JNLPAMP","&", rplcToStrg("JNLPGT",">", rplcToStrg("JNLPLT","<",rplcToStrg("JNLPLINEBREAK","\n",rplcToStrg("JNLPFRAGEZEICHEN","?",s)))));
    }
    public static URL[] urls(String txt) {
        List v=null;
        final StringTokenizer st=new StringTokenizer(txt);
        while(st.hasMoreTokens()) {
            final URL u=url(withoutLastComponent(st.nextToken(),'|'));
            if (v!=null && v.contains(v)) continue;
            (v==null ? v=new ArrayList() : v).add(u);
        }
        return toArry(v,URL.class);
    }
    /* <<< Network <<< */
    /* ---------------------------------------- */
    /* >>> Proxy >>> */
    private static Object proxySelector;
    public static java.net.InetSocketAddress proxyForUrl(URL url) {
        if (proxySelector==null) {
            proxySelector=invokeMthd("getDefault","java.net.ProxySelector");
            if (proxySelector==null) proxySelector=ERROR_OBJECT;
        }
        java.net.URI uri=null;
        try {
            uri=url!=null && proxySelector!=ERROR_OBJECT ? new java.net.URI(toStrg(url)) : null;
        } catch(Exception e){}
        if (uri!=null) {
            List v=(List)invokeMthd("select",proxySelector, new Object[]{uri},0L);
            final int n=sze(v);
            for(int i=0; i<n; i++) {
                final java.net.Proxy proxy=(java.net.Proxy)get(i,v);
                return proxy==null || proxy.type()==java.net.Proxy.Type.DIRECT ?  null : (java.net.InetSocketAddress)proxy.address();
            }
        }
        return null;
    }
    private static JComponent pnlProxy;
    private static ChTextArea taProxy;
    public static ChButton newButTestProxy() { return new ChButton("TEST_PROXY").t("Test Web proxy").li(listener(0));}
    public static String testProxySelector() {
        final StringBuffer sb=new StringBuffer(999);
        for(String u: getCustomSettings(Customize.testProxySelector)){
            final java.net.InetSocketAddress p=proxyForUrl(url(u));
            sb.append(u).append(" ==> ").append(p!=null?p:"None").append('\n');
        }
        return sb.toString();
    }

    public static String[] commandLineParametersForProxy() {
        final java.net.InetSocketAddress  proxyGoogle=proxyForUrl(url("http://www.google.com"));
        if (proxyGoogle==null) {
            putln(" google direct connection ");
            return NO_STRING;
        }
        final String[] vPara=new String[3];
        vPara[0]="-DproxyHost="+proxyGoogle.getHostName();
        vPara[1]="-DproxyPort="+proxyGoogle.getPort();
        final Set<String> v=new HashSet();
        for(String url : Hyperrefs.getDatabases(Hyperrefs.WEB_LINK|Hyperrefs.PLAIN_TEXT|Hyperrefs.PROTEIN_FILE)[1]) {
            final int to=mini(strchr(STRSTR_E,'/',url,7,MAX_INT),strchr(STRSTR_E,'?',url));
            v.add(url.substring(0,to));
        }
        StringBuffer sb=null;
        for(Object[] urls : new Object[][]{v.toArray(), getCustomSettings(Customize.testProxySelector)}) {
            for(Object o : urls) {
                final String u=toStrgTrim(o);
                if (u!=null && u.startsWith("http://")) {
                    final URL url=url(u);
                    if (url!=null && proxyForUrl(url)==null) {
                        (sb==null?sb=new StringBuffer("-Dhttp.nonProxyHosts="):sb.append('|')).append(url.getHost());
                    }
                }
            }
        }
        if (sb!=null) vPara[2]=sb.toString();
        return rmNull(vPara,String.class);
    }
    /* <<< Proxy <<< */
    /* ---------------------------------------- */
    /* >>> flow control >>> */
    public static boolean sleep(final long i) {return sleep(i,"sleep");}
    public static boolean sleep(final long i,String msg) {try {Thread.sleep(i);} catch (Exception e) { return false;} return true; }
    private static List<Runnable> vShutDown;
    public static void addShutdownHook1(Runnable r) {
        if (vShutDown==null) vShutDown=new ArrayList();
        if (r!=null && !vShutDown.contains(r)) vShutDown.add(r);
    }
    private static boolean deleteTmpFiles=true;
    public static void shutDown() {
        debug("ChUtils#shutDown");
        saveUndocked();
        for(int i=sze(vShutDown); --i>=0;) vShutDown.get(i).run();
        if (deleteTmpFiles) {
            deleteTmpFiles=false;
            deleteTree(file(tempFiles));
            for(String path : toStrgArry(vDelOnExit)) deleteTree(new File(path));
        }
        if (properties!=null) { storePrprts(properties,file(PROPERTY_FILE)); }
        if (isMyComputer()) {
            if (CHCL!=null) {
                final boolean cc[][]=initCharClasses();
                for(int i=CHCL.length; --i>=0;) if (!Arrays.equals(cc[i],CHCL[i])) stckTrc();
            }
            for(int i=sze(charClass1); --i>=0;) {
                if (charClass1[i]!=null && (!charClass1[i][i] || countTrue(charClass1[i])!=1)) {
                    //putln("Error i="+(char)i+" "+i+"  "+charClass1[i][i]+"  countTrue="+countTrue(charClass1[i]));
                    stckTrc();
                }
            }
        }
        if (debugHtml!=null) htmlTidy();
        System.exit(0);
    }
    public static void stopAllAlignments() { stopAll(CanBeStopped.vALIGNMENTS);}
    private static void stopAll(List v) {
        for(Object ref : v.toArray()) {
            final Object o=deref(ref);
            if (o instanceof CanBeStopped) ((CanBeStopped)o).stop();
            else if (o instanceof boolean[]) {
                final boolean isInterrupted[]=(boolean[])o;
                if (isInterrupted.length>0) isInterrupted[0]=true;
            }
        }
        v.clear();
    }

    public static int idxOfOption(String needle, String haystack[]) {
        if (haystack==null || needle==null) return  idxOf(needle,haystack);
        for(int i=0; i<haystack.length; i++) {
            final String h=haystack[i];
            if (needle.equals(h) || chrAt(strstr(STRSTR_AFTER,needle,h),h)=='=') return i;
        }
        return -1;
    }
    /* <<< flow control <<< */
    /* ---------------------------------------- */
    /* >>> Program parameters >>> */
    private static String prgrParam[];
    public static String[] getPrgParameters() { return prgrParam; }
    public static void  setPrgParameters(String[] argv) {
        prgrParam=argv;
        deleteTmpFiles=idxOfStrg("-keepFiles",getPrgParameters())<0;
    }

    public static boolean isPrgOption(String opt, String arg) {
        return equls(opt,arg,0) && (isPrgOptionTF(opt,true,arg) || isPrgOptionTF(opt,false,arg));
    }
    private final static String[] isPrgOptionTF={null};
    public static boolean isPrgOptionTF(String opt, boolean trueOrFalse, String arg) {
        if (!equls(opt,arg,0)) return false;
        synchronized(isPrgOptionTF) {
            isPrgOptionTF[0]=arg;
            return isPrgOptionTF(opt,trueOrFalse,isPrgOptionTF);
        }
    }

    public static boolean isPrgOptionTF(String opt, boolean trueOrFalse, String argv[]) {
        final int L=sze(opt);
        if (L==0 || argv==null) return false;
        for(String s : argv) {
            final int sL=s!=null ? s.length() : 0;
            if (sL==0) continue;
            if (s.equals(opt) && trueOrFalse) return true;
            if (s.startsWith(opt) && sL>L+1 && s.charAt(L)=='=' && s.charAt(L+1)==(trueOrFalse?'t':'f')) {
                if (sL==L+2) return true;
                final String sTF=trueOrFalse ? "true" : "false";
                if (sL==L+ 1+ sTF.length() && equls(sTF, s, L+1)) return true;
            }
        }
        return false;
    }
    public static String getParamValue_(String var) { return getParamValue(var, getPrgParameters());}
    public static String getParamValue(String name, String argv[]) {
        return _getParamValue(name,argv,(List)null);
    }
    public static String[] getParamValues(String name, String argv[]) {
        final List v=new ArrayList();
        _getParamValue(name,argv,v);
        return toStrgArry(v);
    }

    private static String _getParamValue(String name, String argv[], List v) {
        final int nL=sze(name);
        if (argv==null || nL==0) return null;
        final int nDash=chrAt(0,name)!='-' ? 0 : chrAt(1,name)!='-' ? 1 : 2 ;
        boolean takeNext=false;
        for(String arg : argv) {

            if (takeNext) {
                if (v!=null) v.add(arg);
                return arg;
            }
            final int aL=sze(arg);
            if (aL==0) continue;
            final int aDash=chrAt(0,arg)!='-' ? 0 : chrAt(1,arg)!='-' ? 1 : 2 ;
            final int equals=arg.indexOf('=');
            //putln(" aDash="+aDash+" nDash="+nDash+" arg="+arg+" name="+name+ " equals="+equals+"/"+(nL-nDash+aDash));
            if (equls(arg,aDash,  equals>0 ? equals : arg.length(),  name,nDash)) {
                if (equals-aDash==nL-nDash) {
                    final String value=arg.substring(equals+1);
                    if (v!=null) v.add(value);
                    else return value;
                }
                else if (aL-aDash==nL-nDash) takeNext=true;
            }
        }
        return null;
    }
    /* <<< PrgParas <<< */
    /* ---------------------------------------- */
    /* >>> Collections >>> */
    public static <T extends Object> T  getLast(Object collection, Class<T> c) {
        return get(sze(collection)-1,collection,c);
    }
    public static <T extends Object> T  get(int i, Object collection, Class<T> c) {
        if (i<0) return null;
        Object o;
        if (collection instanceof List) {
            final Object ref;
            try { ref=i<sze(collection) ? ((List)collection).get(i) : null;} catch(Exception e){  putln("caught ChUtils#get ",e); return null; }
            o=deref(ref);
            if (o==null) ((List)collection).remove(ref);
        }
        else o=deref(get(i,collection));
        return isInstncOf(c,o) ? (T)o : null;
    }

    public  static boolean adAllUniq(Object[] oo, Collection v) { return adAll(oo,v,true); }
    public  static boolean adAll(Object[] oo, Collection v) { return adAll(oo,v,false); }
    private static boolean adAll(Object[] oo, Collection v, boolean uniq) {
        boolean changed=false;
        if (oo!=null && v!=null) {
            if (v instanceof ArrayList) ((ArrayList)v).ensureCapacity(oo.length);
            for(Object o : oo)
                if (o!=null && (!uniq || !v.contains(o)))
                    changed|=v.add(o);
        }
        return changed;
    }

    public static boolean addIfNotNull(Object  o, Collection v) {
        if (o!=null && v!=null) return v.add(o);
        return false;
    }

    public static boolean adUniq(Object  o, Collection v) {
        if (o!=null && v!=null && (v instanceof Set || !v.contains(o))) return v.add(o);
        return false;
    }

    public static <T>  void adUniq(T  o, int row, List<T> v) {
        if (o==null || v==null) return;
        final int iSrc=v.indexOf(o),  iDst=mini(sze(v), maxi(0,row));
        if (iSrc!=iDst) {
            v.remove(o);
            v.add(iDst-(iSrc>=0 && iSrc<iDst?1:0),o);
        }
        assert v.contains(o);
    }
    public static int modiCount(Object o) {
        return o instanceof HasModiCount ? ((HasModiCount)o).getModificationCount() : 0;
    }
    /* >>> Collections >>> */
    /* ---------------------------------------- */
    /* >>> Sort >>> */
    public final static int COMPARE_ALPHABET=1,  COMPARE_ALPHABET_IC=2, COMPARE_SIZE=4, COMPARE_NAME=5, COMPARE_ID=6, COMPARE_REVERT=7,
        COMPARE_WHEN_CREATED=8,
        COMPARE_WHEN_MODIFIED=9,
        COMPARE_RENDERER_TEXT=10;

    public static int compareAlphabetically(Object o1, Object o2, boolean ignoreCase) { return ChComparator.compareAlphabetically(o1,o2,ignoreCase);}
    private final static Comparator[] comparator=new Comparator[99];

    public static Comparator comparator(int type) {
        if (comparator[type]==null) comparator[type]=new ChComparator(type);
        return comparator[type];
    }
    /* <<< Sort <<< */
    /* ---------------------------------------- */
    /* >>> Arrays  >>> */
    public static void sortArry(Object o) { sortArry(o,null);}
    public static void sortArry(Object o, Comparator comp) {
        final List v=o instanceof List ? (List)o : null;
        final Object oo[]=o instanceof Object[] ? (Object[])o : v!=null ? v.toArray() : null;
        if (sze(oo)==0) return;
        if (comp!=null) Arrays.sort(oo,comp); else Arrays.sort(oo);
        if (v!=null) {
            for(int i=oo.length; --i>=0;) {
                try {v.set(i,oo[i]);} catch(Exception ex) {putln(RED_ERROR+" caught in sortArry",ex);}
            }
        }
    }

    public static int[] ad(int item, int collection[], int reserve) {
        final int L=sze(collection);
        for(int i=0;i<L;i++) {
            if (collection[i]==-1) {
                collection[i]=item;
                return collection;
            }
        }
        final int ss[]=chSze(collection, L+1+reserve);
        Arrays.fill(ss,L+1,ss.length,-1);
        ss[L]=item;
        return ss;
    }
  public static String[] ad(String item, String collection[], int reserve) {
        final int L=sze(collection);
        for(int i=0;i<L;i++) {
            if (collection[i]==null) {
                collection[i]=item;
                return collection;
            }
        }
        final String ss[]=chSze( L==0 ? NO_STRING:collection, L+1+reserve);
        ss[L]=item;
        return ss;
    }
    public static <T extends Object> T[] adToArray(T item, T collection[], int reserve, Class<T> clazz) {
        final int L=sze(collection);
        for(int i=0;i<L;i++) {
            if (collection[i]==null) {
                collection[i]=item;
                return collection;
            }
        }
        final Object ss[]=chSze( L==0 ? emptyArray(clazz):collection, L+1+reserve, clazz);
        ss[L]=item;
        return (T[])ss;
    }

    public static int countNull(Object[] oo) {
        int count=0;
        if (oo!=null) for(Object o : oo) if (o==null) count++;
        return count;
    }
    public static int countNotNull(Object[] oo) { return oo==null ? 0 : oo.length-countNull(oo); }

    private final static Map<Class, Object> mapEmpty=new HashMap();
    public static <T extends Object> T[] emptyArray(Class<T> clazz) {
        final Object empty=
            clazz==String.class ? NO_STRING :
            clazz==File.class ? NO_FILE :
            clazz==URL.class ? NO_URL :
            clazz==Map.class ? NO_MAP :
            clazz==Map.Entry.class ? NO_MAP_ENTRY :
            clazz==Class.class ? NO_CLASS :
            clazz==Object.class ? NO_OBJECT :
            null;
        if (empty!=null) return (T[])empty;

        Object oo=mapEmpty.get(clazz);
        if (oo==null) mapEmpty.put(clazz,oo=Array.newInstance(clazz,0));
        return (T[])oo;
    }

    final static int C_ARRAYe=1, C_ARRAYks=2, C_ARRAYkb=3, C_ARRAYk=4, C_ARRAYv=5, C_MAP_name2o=6;

    public static String[] toStrgArry(Collection v) { return v==null ? NO_STRING : (String[])v.toArray(NO_STRING); }
    public static <T extends Object> T[] toArry(Collection v, Class<T> clazz) {
        final int n=v==null ? 0 : v.size();
        return (T[]) (n==0 ? emptyArray(clazz) :  v.toArray(emptyArray(clazz)));
    }

    public static Map.Entry[] entryArry(Map m) {
        if (m==null) return NO_Entry;
        final Object[] cached= m instanceof ChMap ? ((ChMap)m).cached() : null;
        Object vv=cached!=null ? cached[C_ARRAYe]:null;
        if (vv==null) vv=toArry(m.entrySet(),Map.Entry.class);
        if (cached!=null) cached[C_ARRAYe]=vv;
        return (Map.Entry[])vv;
    }

    public static String[] keyStrgArry(Map m) {
        if (sze(m)==0) return NO_STRING;
        final Object[] cached= m instanceof ChMap ? ((ChMap)m).cached() : null;
        Object vv=cached!=null ? cached[C_ARRAYks]:null;
        if (vv==null) vv=toStrgArry(m.keySet());
        if (cached!=null) cached[C_ARRAYks]=vv;
        return (String[])vv;
    }

    public static byte[][] keyByteArry(Map m) {
        if (m==null) return NO_BYTE_ARRAY;
        final Object[] cached= m instanceof ChMap ? ((ChMap)m).cached() : null;
        Object vv=cached!=null ? cached[C_ARRAYkb]:null;
        if (vv==null) vv=strings2bytes(keyStrgArry(m));
        if (cached!=null) cached[C_ARRAYkb]=vv;
        return (byte[][])vv;
    }

    private static <K extends Object, K2 extends K>  K[] k_v_Arry(Map m, Class<K> c, char k_or_v) {
        if (sze(m)==0) return emptyArray(c);
        if (m instanceof ChMap) return (K[]) ((ChMap)m).toArrayKV(k_or_v=='K', (ChRunnable)null, "");
        return (K[]) rmNull(toArry(k_or_v=='k' ? m.keySet():m.values(),c));
    }

    public static Object[] keyArry(Map m) {  return keyArry(m, Object.class); }
    public static Object[] valueArry(Map m) { return valueArry(m,Object.class);}
    public static <V extends Object, V2 extends V> V[] valueArry(Map<?,V2> m, Class<V> c) { return  k_v_Arry(m, c, 'v');}
    public static <K extends Object, K2 extends K> K[]   keyArry(Map<K2,?> m, Class<K> c) { return  k_v_Arry(m, c, 'k');}

    public static boolean setToNull(Object needle, Object[] haystack) {
        boolean changed=false;
        if (haystack!=null && needle!=null) {
            for(int i=haystack.length; --i>=0;) {
                if (haystack[i]==needle) {
                    haystack[i]=null;
                    changed=true;
                }
            }
        }
        return changed;
    }
    public static Object[] rmNull(Object oo[]) { return rmNull(oo, Object.class);}
    public static String[] rmNull(String oo[]) { return rmNull(oo, String.class);}
    public static <T extends Object> T[] rmNull(T[] tt, Class<T> clazz) {
        final int count=countNull(tt);
        if (count>0) {
            final T[] newArray=(T[])Array.newInstance(clazz,tt.length-count);
            int j=0;
            for(T t : tt) if (t!=null) newArray[j++]=t;
            return newArray;
        }
        return tt;
    }
    public static <T extends Object> T[] rmNullNewInst(T[] tt, Class<T> clazz) {
        final T[] nn=rmNull(tt,clazz);
        return nn==null ? null : nn!=tt ? nn : nn.clone();
    }
    public static void rmNull(List v) {
        for(int i=v!=null ? v.size() : 0; --i>=0;) {
            try {
                Object o=v.get(i);
                while(o instanceof Reference) o=((Reference)o).get();
                if (o==null) v.remove(i);
            } catch(Exception ex){}
        }
    }

    public static <T extends Object> T[] set1stElement(T item, T collection[], int reserve, Class<T> clazz ) {
        if (item==null || collection!=null && collection.length>0 && collection[0]==item) return collection;
        T[] coll=collection;
        int idx=idxOf(item,coll);
        if (idx<0)  idx=idxOf(item,coll=ad(item,collection, reserve, clazz));
        assert idx>=0;
        final T item0=coll[0];
        coll[0]=coll[idx];
        coll[idx]=item0;
        return coll;
    }

    public static <T extends Object> T[] ad(T item, T collection[], int reserve, Class<T> clazz ) {
        final int L=sze(collection);
        for(int i=0;i<L;i++) {
            if (collection[i]==null) {
                collection[i]=item;
                return collection;
            }
        }
        final T ss[]=chSze( L==0 ? NO_STRING:collection, L+1+reserve,clazz);
        ss[L]=item;
        return ss;
    }
    public static void addRef(String key, Reference ref, Object target) {
        pcp(key, ad(ref, gcp(key,target,Reference[].class),4,  Reference.class), target);
    }

    public static int idxOfStrg(String needle, String haystack[]) {
        if (haystack==null || needle==null) return  idxOf(needle,haystack);
        final int hc=needle.hashCode();
        for(int i=0; i<haystack.length; i++) {
            final String h=haystack[i];
            if (h!=null && h.hashCode()==hc && needle.equals(h)) return i;
        }
        return -1;
    }
    public static int idxOfStrg(byte[] needle, String haystack[], int from, int to0, int strLen[]) {
        final int to=mini(to0,haystack.length);
        for(int i=from; i<to; i++) {
            final String h=haystack[i];
            if (h!=null && strLen[i]==needle.length && equls(h,needle,0)) return i;
        }
        return -1;
    }

    public static String rplcByListElement(String s, Object collection) {
        if (collection==null) return s;
        else if (collection instanceof String[]) {
            final String ss[]=(String[])collection;
            final int i=idxOfStrg(s,ss);
            return i>=0 ? ss[i] : s;
        } else if (collection instanceof List) {
            final List v=(List)collection;
            final int i=v.indexOf(s);
            return i>=0 ? (String)v.get(i) : s;
        }
        return s;
    }
    public static boolean cntains(Object o, Object oo[]) { return idxOf(o,oo,0,MAX_INT)>=0;}
    public static boolean cntainsAll(Object needles[], Object haystack[]) {
        if (haystack==null) return false;
        if (needles!=null) for(Object o : needles)  if (!cntains(o,haystack)) return false;
        return true;
    }
    public static boolean cntainsAll(Object needles, Object haystack[]) {
        if (haystack==null) return false;
        for(int i=sze(needles); --i>=0;) {
            final Object o=get(i,needles);
            if (o!=null && !cntains(o, haystack)) return false;
        }
        return true;
    }

    public static boolean cntainsAtLeastOne(Object needles[], Object haystack[]) {
        if (haystack==null || haystack==null) return false;
        for(Object o : needles)  {
            if (o!=null && cntains(o,haystack)) return true;
        }
        return false;
    }

    public static <T extends Object> T[] delet(Object element, Object[] aa, Class<T> clazz) { return delet(element,aa,clazz,false); }
    public static <T extends Object> T[] delet(Object element, Object[] aa, Class<T> clazz, boolean extended) {
        if (aa==null) return null;
        int count=aa.length;
        for(Object a:aa) if (a==element) count--;
        if (count==aa.length) return (T[])aa;
        final Object bb[]=(Object[])Array.newInstance(clazz,count);
        count=0;
        for(Object a:aa) if (a!=element && count<bb.length) bb[count++]=a;
        return (T[])bb;
    }
    public static int sze(Object o) {
        int ret=
            o==null ? 0 :
            o instanceof CharSequence ? ((CharSequence)o).length() :
            o instanceof Object[] ? ((Object[])o).length :
            o instanceof int[] ? ((int[])o).length :
            o instanceof byte[] ? ((byte[])o).length :
            o instanceof boolean[] ? ((boolean[])o).length :
            o instanceof short[] ? ((short[])o).length :
            o instanceof long[] ? ((long[])o).length :
            o instanceof float[] ? ((float[])o).length :
            o instanceof double[] ? ((double[])o).length :
            o instanceof Collection ? ((Collection)o).size() :
            o instanceof Map ? ((Map)o).size() :
            o instanceof File ? (int)((File)o).length() :
            o instanceof JList ? ((JList)o).getModel().getSize() :
            o instanceof ListModel ? ((ListModel)o).getSize() :

            -1;
        if (ret<0 && isMyComputer()) {
            putln(clazz(o));
            assertTrue(false);
        }
        return maxi(0,ret);
    }
    public static int[] chSze(int[] a,int n) {
        if (a!=null && n==a.length) return a;
        final int[] b=new int[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static long[] chSze(long[] a,int n) {
        if (a!=null && n==a.length) return a;
        final long[] b=new long[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static String[] chSze(String[] a,int n) {
        if (a!=null && n==a.length) return a;
        final String[] b=new String[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static short[] chSze(short[] a,int n) {
        if (a!=null && n==a.length) return a;
        final short[] b=new short[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static byte[] chSze(byte[] a,int n) {
        if (a!=null && n==a.length) return a;
        final byte[] b=new byte[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static byte[][] chSze(byte[][] a,int n) {
        if (a!=null && n==a.length) return a;
        final byte[][] b=new byte[n][];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static boolean[] chSze(boolean[] a,int n) {
        if (a!=null && n==a.length) return a;
        final boolean[] b=new boolean[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static float[] chSze(float[] a,int n) {
        if (a!=null && n==a.length) return a;
        final float[] b=new float[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static double[] chSze(double[] a,int n) {
        if (a!=null && n==a.length) return a;
        final double[] b=new double[n];
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static <T extends Object> T[] chSze(Object[] a,int n, Class<T> clazz) {
        if (a!=null && n==a.length) return (T[])a;
        final T[] b=(T[])Array.newInstance(clazz,n);
        if (a!=null) System.arraycopy(a,0,b,0,mini(a.length,n));
        return b;
    }
    public static boolean[] redim(boolean[] ii,int n,int reserve) {
        boolean jj[]=ii;
        if (jj==null || jj.length<=n) jj=new boolean[n+reserve];
        return jj;
    }
    public static float[] redim(float[] ii,int n,int reserve) {
        float jj[]=ii;
        if (jj==null || jj.length<=n) jj=new float[n+reserve];
        return jj;
    }
    public static double[] redim(double[] ii,int n,int reserve) {
        double jj[]=ii;
        if (jj==null || jj.length<=n) jj=new double[n+reserve];
        return jj;
    }
    public static byte[] redim(byte[] ii,int n,int reserve) {
        byte jj[]=ii;
        if (jj==null || jj.length<=n) jj=new byte[n+reserve];
        return jj;
    }
    public static int[] redim(int[] ii,int n,int reserve) {
        int jj[]=ii;
        if (jj==null || jj.length<=n) jj=new int[n+reserve];
        return jj;
    }

    public static <T extends Object> T[] subArry(int from, int to, T[] oo,  int reserve, Class c) {
        if (oo==null) return null;
        final int f=maxi(0,from), t=mini(oo.length,to);
        final T[] tt=(T[])Array.newInstance(c,t-f+reserve);
        System.arraycopy(oo,f, tt,0,tt.length);
        return tt;
    }

    final static Collection setTmp=new HashSet(), vTmp=new ArrayList();
    public static  <T extends Object> T[] joinArrays(T[] a1, T[] a2, Class<T> c) {
        final int n1=sze(a1), n2=sze(a2);
        if (n1+n2==0) return (T[])Array.newInstance(c,0);
        if (cntainsAll(a1,a2)) return a2;
        if (cntainsAll(a2,a1)) return a1;
        synchronized(setTmp) {
            final Collection v=n1*n1+n2*n2<1000 ? vTmp : setTmp;
            setTmp.clear();
            for(Object a : a1) adUniq(a,v);
            for(Object a : a2) adUniq(a,v);
            return toArry(v,c);
        }
    }

    public static String[] ss(Object o) {
        if (o==null) return NO_STRING;
        if (o instanceof Collection) return toStrgArry((Collection)o);
        if (o instanceof String[]) return (String[])o;
        if (o instanceof CharSequence || o instanceof byte[]) return new String[]{toStrg(o)};
        assert false;
        return NO_STRING;
    }

    public static Object[] oo(Object o) {
        return
            o==null ? NO_OBJECT :
            o instanceof UniqueList ? ((UniqueList)o).asArray() :
            o instanceof Collection ? toArry((Collection)o, Object.class) :
            o instanceof Object[] ? (Object[]) o : new Object[]{o};
    }

    /* <<< Arrays <<< */
    /* ---------------------------------------- */
    /* >>> Array Element Accessor >>> */
    public static <T extends Object> T getV(Object key, Map m, Class<T> c) {
        if (key==null || m==null) return null;
        final Object o=deref(m.get(key));
        return isInstncOf(c,o) ? (T)o : null;
    }
    public static int get(int i, int[] a) { return a!=null && a.length>i && i>=0  ? a[i] : MIN_INT;}
    public static long get(int i, long[] a) { return a!=null && a.length>i && i>=0  ? a[i] : MIN_INT;}
    public static short get(int i, short[] a) { return a!=null && a.length>i && i>=0  ? a[i] : Short.MIN_VALUE;}
    public static byte get(int i,byte[] a) { return a!=null && a.length>i && i>=0 ? a[i] : 0;}
    public static String get(int i, String[] a) {  return a!=null && a.length>i && i>=0 ? a[i] : null;}
    public static boolean get(int i, boolean[] a) {  return a!=null && a.length>i && i>=0 ? a[i] : false;}
    public static Object get(int i, Object collection) {
        assert !(collection instanceof Reference);
        if (i<0) return null;
        final int N=sze(collection);
        final ListModel m=collection instanceof JList ? ((JList)collection).getModel() :null;
        Object o;
        try{
            o=collection instanceof Object[] ? ( i<N ? ((Object[])collection)[i] : null) :
                collection instanceof ListModel ? ( i<N ? ((ListModel)collection).getElementAt(i) : null) :
                collection instanceof List ? ( i<N ? ((List)collection).get(i) : null) :
                m!=null && i<m.getSize() ? m.getElementAt(i) : null;
        } catch(Exception e){ putln("caught ChUtils#get ",e); return null; }
        return deref(o);
    }
    public static <T extends Object> T  get(Object collection0, Class<T> c) {
        if (collection0==null) return null;
        final Object collection=c==Reference.class ? collection0: deref(collection0);
        if (isInstncOf(c,collection)) return (T)collection;
        final int N=sze(collection);
        for(int i=0; i<N; i++) {
            final Object o=get(i,collection);
            if (isInstncOf(c,o)) return (T)o;
        }
        return null;
    }
    public static <T extends Object> T  deref(Object object, Class<T> c) {
        if (object==null) return null;
        final Object o=deref(object);
        return isInstncOf(c,o) ?  (T)o : null;
    }
    public static Object deref(Object ref0) {
        Object r=ref0;
        while(r instanceof Reference) r=((Reference)r).get();
        return r;
    }
    public static <T extends Object> T[] derefArray(Object objects, Class<T> clazz) {
        final Object oo[]= oo(objects);
        Object pp[]=null;
        while(true) {
            int count=0;
            final int N=oo!=null ? oo.length : 1;
            for(int i=0; i<N; i++) {
                final Object o=deref(oo!=null ? oo[i] : objects);
                if (o!=null && clazz.isAssignableFrom(o.getClass())) {
                    if (pp!=null) pp[count]=o;
                    count++;
                }
            }
            if (pp==null) pp=(Object[])Array.newInstance(clazz,count); else break;
        }
        return (T[])pp;
    }
    /* <<< Array Element Accessor <<< */
    /* ---------------------------------------- */
    /* >>> Needle Haystack >>> */
    public static void assertIsText(Object o) {
        if (!( o==null || o instanceof CharSequence || o instanceof byte[])) {
            putln("o="+shrtClasNam(o));
            assert false;
        }
    }
    public static void assertNotNull(Object o) { assert o!=null; }
    public static void assertTrue(boolean b) { assert b; }

    /* >>> Character >>> */
    public final static int
    SPC=2, DIGT=3, LETTR=4, UPPR=5, LOWR=6, LETTR_DIGT=7, UPPR_DIGT=8,  LOWR_DIGT=9,  LETTR_DIGT_US=10,  FILENM=11, ACTGUN=12,  SPC_PIPE=13,
        NO_SPC=14, NO_DIGT=15,NO_LETTR=16, NO_LETTR_DIGT=17, NO_LETTR_DIGT_US=18, NO_FILENM=19, NO_ACTGUN=20, WORD_DELIM_L=21, WORD_DELIM_R=22,
        TAB_COMPL_DELIM=23, LETTR_DASH=24, SPC_CLOSE=25, SLASH=26, DIGT_DASH=27, DIGT_SPC=28,LETTR_DASH_TILDE_DOT=29, LETTR_DIGT_US_COLON=30,
        HEX_DIGIT=32,  FILEP=34, NO_FILEP=35, DIGT_DOT=36, NO_DIGT_DOT=37, LETTR_DIGT_US_DASH=38,NO_LETTR_DIGT_US_DASH=39;

    public static boolean is(int charType, Object txt, int i) {
        if (txt==null || i<0) return false;
        if (txt instanceof byte[]) {
            final byte[] T=(byte[])txt;
            return i<T.length && T[i]>=0 && charClass(charType)[T[i]];
        } else {
            CharSequence T=(CharSequence)txt;
            return i<T.length() && is(charType, T.charAt(i));
        }
    }
    public static boolean isSpc(int c) { return ' '==c || '\r'==c || '\n'==c || '\t'==c;}
    /* loss of speed due to additional parameter: 20%  Compared to direct comparison: nearly half the speed */

    private final static HashMap<String,boolean[]>mapDelim=new HashMap();
    public static boolean[] charClass(String s) {
        if (s==BLANKS) return charClass(SPC);
        final int L=s!=null ? s.length() : 0;
        boolean[] d=null;
        if (L==1) d=charClassOneChar(s.charAt(0));
        else if (L>1) {
            d=mapDelim.get(s);
            if (d==null) {
                mapDelim.put(s,d=new boolean[128]);
                for(int i=s.length(); --i>=0;) d[s.charAt(i)]=true;
            }
        }
        return d;
    }

    private final static boolean[][] charClass1=new boolean[128][];
    public static boolean[] charClassOneChar(char c) {
        if (charClass1[c]==null) (charClass1[c]=new boolean[128])[c]=true;
        return charClass1[c];
    }
    public final static boolean[][] CHCL=initCharClasses();
    public static boolean[] charClass(int type) { return CHCL[type];}
    private static boolean[][] initCharClasses() {
        final boolean cc[][]=new boolean[40][128];
        for(int t=cc.length; --t>=0;) {
            final boolean c[]=cc[t];
            if (t==SPC|| t==SPC_PIPE || t==SPC_CLOSE || t==DIGT_SPC || t==WORD_DELIM_L || t==WORD_DELIM_R || t==TAB_COMPL_DELIM) {
                c[' ']=c['\t']=c['\r']=c['\n']=true;
            }
            if (t==DIGT  || t==HEX_DIGIT || t==LETTR_DIGT || t==UPPR_DIGT || t==LOWR_DIGT || t==LETTR_DIGT_US || t==LETTR_DIGT_US_DASH || t==DIGT_DASH || t==DIGT_SPC || t==LETTR_DIGT_US_COLON ||  t==FILENM || t==FILEP || t==DIGT_DOT) {
                for(int j='0';j<='9'; j++) c[j]=true;
            }
            if (t==SLASH || t==WORD_DELIM_L || t==WORD_DELIM_R || t==TAB_COMPL_DELIM) c['/']=c['\\']=true;
            if (t==LETTR || t==LETTR_DIGT || t==LETTR_DIGT_US || t==LETTR_DIGT_US_DASH || t==LETTR_DASH || t==LETTR_DASH_TILDE_DOT || t==LETTR_DIGT_US_COLON || t==FILENM || t==FILEP) {
                for(int j='A';j<='Z'; j++) c[j]=c[32|j]=true;
            }
            if (t==LOWR || t==LOWR_DIGT)  for(int j='a';j<='z'; j++) c[j]=true;
            if (t==UPPR || t==UPPR_DIGT)  for(int j='A';j<='Z'; j++) c[j]=true;

            if (t==LETTR_DIGT_US || t==LETTR_DIGT_US_DASH || t==FILENM || t==FILEP) c['_']=true;
            if (t==LETTR_DASH || t==DIGT_DASH || t==LETTR_DASH_TILDE_DOT || t==FILENM || t==FILEP) c['-']=true;
            if (t==ACTGUN) c['a']=c['c']=c['t']=c['g']=c['n']=c['u']=c['A']=c['C']=c['T']=c['G']=c['N']=c['U']=true;
            if (t==HEX_DIGIT) for(int j='A'; j<='F'; j++) c[j]=c[32|j]=true;

            if (t==FILENM || t==FILEP) c['.']=c['+']=c['_']=true;
            if (t==FILEP) c['/']=c['\\']=true;

            if (t==WORD_DELIM_R) c['=']=c['.']=true;
            if (t==TAB_COMPL_DELIM) c['=']=c['.']=c['#']=true;
            if (t==LETTR_DASH_TILDE_DOT) c['~']=c['.']=true;
        }
        cc[LETTR_DIGT_US_DASH]['-']=
            cc[DIGT_DOT]['.']=
            cc[SPC_CLOSE][')']=
            cc[LETTR_DIGT_US_COLON][':']=cc[LETTR_DIGT_US_COLON]['_']=
            cc[SPC_PIPE]['|']=
            cc[WORD_DELIM_L]['=']=true;

        final int[] INVERSE={
            NO_DIGT_DOT,           DIGT_DOT,
            NO_SPC,                SPC,
            NO_DIGT,               DIGT,
            NO_LETTR,              LETTR,
            NO_LETTR_DIGT,         LETTR_DIGT,
            NO_LETTR_DIGT_US,      LETTR_DIGT_US,
            NO_FILENM,             FILENM,
            NO_FILEP,             FILEP,
            NO_ACTGUN,             ACTGUN,
            NO_LETTR_DIGT_US_DASH,LETTR_DIGT_US_DASH
        };
        for(int i=0;i<INVERSE.length; i+=2) {
            final boolean c[]=cc[INVERSE[i]],inv[]=cc[INVERSE[i+1]];
            for(int j=128;--j>=0;)c[j]=!inv[j];
        }
        return cc;
    }
    public static boolean is(int charType, int c) {   return c>=0 && c<128 && charClass(charType)[c];}
    public static char chrAt(int i, Object txt) {
        if (txt==null ||i<0) return (char)0;
        else if (txt instanceof CharSequence) return i<((CharSequence)txt).length() ? ((CharSequence)txt).charAt(i) : (char)0;
        else if (txt instanceof byte[]) return (char)get(i,(byte[])txt);
        else { assert false; return (char)0; }
    }
    /* <<< Character <<< */
    /* ---------------------------------------- */
    /* >>> Needle Haystack >>> */
    public static int nxt(boolean[] charClass, Object txt, int from,int to) {
        if (txt instanceof byte[]) {
            final byte[] T=(byte[]) txt;
            final int t=mini(to,  T.length);
            for(int i=maxi(0,from); i<t; i++) if (T[i]>=0 && charClass[T[i]]) return i;
        } else if (txt instanceof ByteArray) {
            final ByteArray ba=(ByteArray)txt;
            final int B=ba.getBegin(), E=ba.getEnd();
            final int b=B+from, e=mini(B+(to&0x3FffFFff),E);
            return maxi(-1,  nxt(charClass,ba.getBytes(),b,e)-B);
        } else if (txt!=null) {
            final CharSequence T=(CharSequence) txt;
            final int t=mini(to, T.length());
            for(int i=maxi(0,from); i<t; i++) {
                final char c=T.charAt(i);
                if (c<128 && charClass[c]) return i;
            }
        }
        return -1;
    }
    public static int nxt(int charType, Object txt) { return nxt(charType,txt,0,MAX_INT);}
    public static int nxt(int charType, Object txt, int from) { return nxt(charType,txt,from,MAX_INT); }
    public static int nxt(int charType, Object txt, int from,int to) {
        if ( (charType==SPC || charType==NO_SPC) && txt instanceof byte[]) {
            final byte[] T=(byte[]) txt;
            final int t=mini(to, T.length), f=maxi(0,from);
            if (charType==SPC) {
                for(int i=f; i<t; i++) if (T[i]==' ' || T[i]=='\t' || T[i]=='\n' || T[i]=='\r') return i;
            } else  {
                for(int i=f; i<t; i++) if (!(T[i]==' ' || T[i]=='\t' || T[i]=='\n' || T[i]=='\r')) return i;
            }
            return -1;
        }
        return nxt(charClass(charType), txt,from,to);
    }

    public static int prev(int charType, Object txt,int from, int to) {
        //assert from>=to;
        if ( (charType==SPC || charType==NO_SPC) && txt instanceof byte[]) {
            final byte[] T=(byte[]) txt;
            final int t=maxi(-1,to), f=mini(from, T.length-1);
            if (charType==SPC) {
                for (int i=f; i>t; --i) if (T[i]==' ' || T[i]=='\t' || T[i]=='\n' || T[i]=='\r')  return i;
            } else {
                for (int i=f; i>t; --i) if (!(T[i]==' ' || T[i]=='\t' || T[i]=='\n' || T[i]=='\r'))  return i;
            }
            return -1;
        }
        return prev(charClass(charType), txt,from,to);
    }

    public static int prev(boolean charClass[], Object txt,int from, int to) {
        assert from>=to;
        final int t=maxi(-1,to);
        if (txt instanceof CharSequence) {
            final CharSequence T=(CharSequence) txt;
            for (int i=mini(from, T.length()-1); i>t; --i) {
                final char c=T.charAt(i);
                if (c<128 && charClass[c])  return i;
            }
        } else if (txt!=null) {
            final byte[] T=(byte[]) txt;
            for (int i=mini(from, T.length-1); i>t; --i) {
                if (T[i]>=0 && charClass[T[i]])  return i;
            }
        }
        return -1;
    }
    // ----------------------------------------
    public static int prevE(boolean charClass[], Object T,int from, int to) {
        final int i=prev(charClass,T,from,to);
        return i>=0 ? i : maxi(-1,to);
    }

    public static int prevE(int charClass, Object T,int from, int to) {
        final int i=prev(charClass,T,from,to);
        return i>=0 ? i : maxi(-1,to);
    }
    // ----------------------------------------
    public static int nxtE(boolean[] charType, Object txt, int from,int to) {
        final int i=nxt(charType,txt, from,to);
        return i>=0 ? i : mini(to, sze(txt));
    }
    public static int nxtE(int charType, Object txt, int from,int to) {
        final int i=nxt(charType,txt, from,to);
        return i>=0 ? i : maxi(from, mini(to, sze(txt)));
    }
    public static int nxtE(int charType, Object txt) { return nxtE(charType, txt, 0,MAX_INT);}
    // ----------------------------------------
    public static byte[] rplc(char needle,char replacement,byte haystack[], int from, int to) { return rplc((byte)needle,(byte)replacement,haystack,from,to);}
    public static byte[] rplc(byte needle,byte replacement,byte haystack[], int from, int to) {
        if (haystack==null) return null;
        for(int i=mini(to,haystack.length);--i>=from;)
            if (haystack[i]==needle) haystack[i]=replacement;
        return haystack;
    }
    public static boolean equls(Object needle, int from, int to, Object haystack, int fromH) {  return equls(0L, needle,from,to, haystack,fromH);}
    public static boolean equls(Object needle,  Object haystack, int fromH) {  return equls(0L, needle,0,MAX_INT, haystack,fromH);}
    public static boolean equls(Object needle,  Object haystack) {  return equls(0L, needle,0,MAX_INT, haystack,0);}
    public static boolean equls(long options, Object needle,  Object haystack) {  return equls(options, needle,0,MAX_INT, haystack,0);}
    public static boolean equls(long options, Object needle,  Object haystack, int i) {  return equls(options, needle,0,MAX_INT, haystack,i);}

    public static boolean equls(long options, Object oNeedle, int needleFrom0, int needleTo0, Object oHaystack, int fromH) {
        if (oNeedle==null || oHaystack==null) return false;
        assertIsText(oHaystack);
        final int t=mini(sze(oNeedle),needleTo0), f=maxi(0,needleFrom0);
        final byte[] hsbb=oHaystack instanceof byte[] ? (byte[]) oHaystack:null;
        final CharSequence hss=hsbb!=null ? null : toCharSeq(oHaystack);
        final byte[] nbb=oNeedle instanceof byte[] ? (byte[])oNeedle : null;
        final CharSequence ns=oNeedle instanceof CharSequence ? (CharSequence)oNeedle : null;
        if (sze(hsbb!=null ? hsbb : hss)-fromH<t-f) return false;
        if (0!=(options&STRSTR_EVALOPTIONS) && !strstr_evalOptions(options, fromH, fromH+t-f,  oHaystack, 0, sze(oHaystack))) return false;
        final boolean ignoreCase=0!=(options&STRSTR_IC);
        for(int i=t-f; --i>=0;) {
            final int cn=nbb!=null?nbb[f+i]:ns.charAt(f+i);
            final int ch=hsbb!=null?hsbb[fromH+i]:hss.charAt(fromH+i);
            if (!(ch==cn || ignoreCase && (ch|32)==(cn|32) && is(LETTR,ch))) return false;
        }
        return true;
    }

    public static boolean equlsBB(byte[] bb1, int from1, int to1,  byte[] bb2, int from2) {
        if (bb1==null || bb2==null || from1<0 || from2<0) return false;
        final int t1=mini(bb1.length,to1);
        if (bb2.length-from2 < t1-from1) return false;
        for(int i1=from1, i2=from2; i1<t1; i1++, i2++) {
            if (bb1[i1]!=bb2[i2]) return false;
        }
        return true;
    }
    public static boolean endWith(CharSequence s, Object o) { return endWith(0L,s,o);}
    public static boolean endWith(long options, Object s, Object text) {
        final int sL=sze(s), tL=sze(text);
        return tL*sL==0 || tL<sL  ? false : equls(options, s,text, tL-sL);
    }

    public final static long STRSTR_IC=1<<1, STRSTR_E=1<<3, STRSTR_LF_L=1<<4, STRSTR_LF_R=1<<5,
        STRSTR_w_L=1<<6, STRSTR_w_R=1<<7, STRSTR_w=STRSTR_w_L|STRSTR_w_R, STRSTR_AFTER=1<<8, STRCHR_NOT=1<<9, STRSTR_PREV=1<<10, RPLC_ONLY_ONE_REPLACEMENT=1<<11;

    private final static long STRSTR_EVALOPTIONS=STRSTR_w|STRSTR_LF_L|STRSTR_LF_R;
    private static boolean strstr_evalOptions(long options, int hitFrom, int hitTo, Object haystack,  int haystackFrom,  int haystackTo) {
        final int cL,cR;
        if (haystack instanceof byte[]) {
            final byte bb[]=(byte[])haystack;
            cL=hitFrom>haystackFrom && hitFrom<=haystackTo ?  bb[hitFrom-1] : 0;
            cR=hitTo<haystackTo ? bb[hitTo] : 0;
        } else {
            final CharSequence s=(CharSequence)haystack;
            cL=hitFrom>haystackFrom && hitFrom<=haystackTo ? s.charAt(hitFrom-1) : 0;
            cR=hitTo<haystackTo ? s.charAt(hitTo) : 0;
        }
        if ( (options&STRSTR_w_R)!=0 && is(LETTR_DIGT_US,cR)) return false;
        if ( (options&STRSTR_w_L)!=0 && is(LETTR_DIGT_US,cL)) return false;
        if ( (options&STRSTR_LF_L)!=0 && cL!=0 && '\n'!=cL) return false;
        if ( (options&STRSTR_LF_R)!=0 && cR!=0 && '\n'!=cR && '\r'!=cR) return false;
        return true;

    }
    public static int strstr(              Object needle, Object haystack)                     { return strstr(0L,      needle,0,MAX_INT,  haystack,0,MAX_INT); }
    public static int strstr(              Object needle, Object haystack, int hFrom, int hTo) { return strstr(0L,      needle,0,MAX_INT,  haystack,hFrom,hTo); }
    public static int strstr(long options, Object needle, Object haystack)                     { return strstr(options, needle,0,MAX_INT,  haystack,0,MAX_INT); }
    public static int strstr(long options, Object needle, Object haystack, int from,  int to)  { return strstr(options, needle,0,MAX_INT,  haystack,from,to); }
    public static int strstr(long options, Object needle, int nFrom0, int nTo0,  Object haystack,  int hFrom0,  int hTo0) {
        if (needle==null || haystack==null) return -1;
        assertIsText(needle);
        assertIsText(haystack);
        final int H=sze(haystack), N=sze(needle);
        final int hT=mini(H,hTo0), nT=mini(N,nTo0);
        final int hF=maxi(0,hFrom0), nF=maxi(0,nFrom0), nL=nT-nF;
        if (haystack instanceof ByteArray) {
            final ByteArray ba= (ByteArray)haystack;
            final int b=ba.getBegin(), e=ba.getEnd();
            final int i=strstr(options, needle,nF,nT, ba.getBytes(),  mini(e, hF+b),    mini(e, hT+b));
            if (i>=0) assert i>=b;
            return i>=0 ? i-b : i;
        }
        final byte[] bNeedle=needle instanceof byte[] ? (byte[])needle : null;
        final byte[] bHaystack=haystack instanceof byte[] ? (byte[])haystack : null;
        final CharSequence sNeedle=bNeedle==null ? toCharSeq(needle) : null;
        final CharSequence sHaystack=bHaystack==null ? toCharSeq(haystack) : null;
        final int c0,c1,c2,c3,c9;
        if (sNeedle!=null) {
            if (sNeedle.length()==0) return -1;
            c0=        sNeedle.charAt(nF+0);
            c9=        sNeedle.charAt(nT-1);
            c1=nT<=nF+1?0: sNeedle.charAt(nF+1);
            c2=nT<=nF+2?0: sNeedle.charAt(nF+2);
            c3=nT<=nF+3?0: sNeedle.charAt(nF+3);
        } else {
            if (bNeedle.length==0) return -1;
            c0=        bNeedle[nF+0];
            c9=        bNeedle[nT-1];
            c1=nT<=nF+1?0: bNeedle[nF+1];
            c2=nT<=nF+2?0: bNeedle[nF+2];
            c3=nT<=nF+3?0: bNeedle[nF+3];
        }
        final boolean ignoreCase=0!=(options&STRSTR_IC), neval=0==(options&STRSTR_EVALOPTIONS);
        final int hMax=hT-nL + 1;
        int result=-1;
        for(int h=hF;   h<hMax; h++) {
            if (bHaystack!=null && !ignoreCase && (bHaystack[h]!=c0 || bHaystack[h+ nL -1]!=c9)) continue;
            boolean match=true;
            for(int n=nL; --n>=0; ) {
                final int cn= bNeedle!=null ? bNeedle[nF+n] : n==nL-1?c9:n==0?c0: n==1?c1: n==2?c2 : n==3?c3:  sNeedle.charAt(nF+n);
                final int ch=bHaystack!=null ? bHaystack[h+n] : sHaystack.charAt(h+n);
                if (!(ch==cn || ignoreCase && (ch|32)==(cn|32) && is(LETTR,ch))) {
                    match=false;
                    break;
                }
            }
            if (match && (neval || strstr_evalOptions(options, h, h+nL,  haystack,hF,hT))) {
                result=h;
                break;
            }
        }
        if (0!=(options&STRSTR_AFTER) && result>=0)result+=nL;
        return (options&STRSTR_E)!=0 && result<0 ? hT: result;
    }
    public static int strchr(char ch, Object txt) { return strchr(0L, ch,txt,0,MAX_INT); }
    public static int strchr(long options, char ch, Object txt) {
        final boolean prev=0!=(options&STRSTR_PREV);
        return strchr(options, ch,txt, prev?MAX_INT:0, prev?-1:MAX_INT);
    }

    public static int strchr(char ch, Object txt,int from, int to) { return strchr(0L, ch,txt,from,to); }
    public static int strchr(long options, char ch, Object txt,int from0, int to0) {
        if (txt==null) return -1;
        if (txt instanceof ByteArray) {
            final ByteArray ba= (ByteArray)txt;
            final int b=ba.getBegin(), e=ba.getEnd();
            final int i=strchr(options, ch, ba.getBytes(), mini(e,  mini(from0,e)+b),    mini(e, mini(to0,e)+b));
            if (i>=0) assert i>=b;
            return i>=0 ? i-b : i;
        }
        final byte bb[]= txt instanceof byte[] ? (byte[])txt : null;
        final CharSequence cs=txt instanceof CharSequence ? (CharSequence)txt : null;
        assert (ch==(byte)ch) && ( bb!=null || cs!=null) ;
        int result=-1;
        final int from,to;
        final boolean not=0!=(options&STRCHR_NOT), neval=0==(options&STRSTR_EVALOPTIONS);
        if (0!=(options&STRSTR_PREV)) {
            from=mini(sze(txt)-1,from0);
            to=maxi(-1,to0);
            if (bb!=null) for(int i=from;i>to;i--) if (not==(ch!=bb[i])       && (neval||strstr_evalOptions(options,i,i+1,txt,from,to))) {result=i; break;}
            if (cs!=null) for(int i=from;i>to;i--) if (not==(ch!=cs.charAt(i))&& (neval||strstr_evalOptions(options,i,i+1,txt,from,to))) {result=i; break;}
        } else {
            from=maxi(0,from0);
            to=mini(sze(txt),to0);
            if (bb!=null) for(int i=from; i<to;i++) if (not==(ch!=bb[i])&&        (neval||strstr_evalOptions(options,i,i+1,txt,from,to))) {result=i; break;}
            if (cs!=null) for(int i=from; i<to;i++) if (not==(ch!=cs.charAt(i))&& (neval||strstr_evalOptions(options,i,i+1,txt,from,to))) {result=i; break;}
        }
        return 0!=(STRSTR_E&options) && result<0 ? to : result;
    }

    public static int idxOf(Object o,Object oo[]) { return idxOf(o,oo,0,MAX_INT);}
    public static int idxOf(Object o,Object oo[],int idx, int to) {
        if (oo!=null) {
            assert !(o instanceof Integer || o instanceof Character);
            final int toIndex=mini(oo.length,to);
            for(int i=idx;i<toIndex; i++)  if (o==(oo[i])) return i;
        }
        return -1;
    }
    public static int idxOf(int o,int oo[],int idx, int to) {
        if (oo!=null) {
            final int toIndex=mini(oo.length,to);
            for(int i=idx;i<toIndex;i++)
                if (o==(oo[i])) return i;
        }
        return -1;
    }

    /* <<< Needle Haystack <<< */
    /* ---------------------------------------- */
    /* >>> append >>> */
    /** about 5 times faster than .append(new String(...)); */
    private final static char[] append_buffer=new char[1024];
    public static StringBuffer appnd(byte[] bb, int from, int to_,StringBuffer sb) {
        if (bb!=null && sb!=null) {
            int to=mini(bb.length,to_);
            synchronized(append_buffer) {
                for(int start=from; start<to; start+=append_buffer.length) {
                    final int nCopy=mini(append_buffer.length, to-start);
                    for(int i=nCopy; --i>=0;) {
                        append_buffer[i]=(char)bb[start+i];
                    }
                    sb.append(append_buffer,0,nCopy);
                }
            }
        }
        return sb;
    }
    /* <<< append <<< */
    /* ---------------------------------------- */
    /* >>> atoi >>> */
    public static boolean  atob(Object o) { return TRUE.equals(o);}
    public static boolean isFloat(final byte[] T,final int from, final int to) {
        if (T==null) return false;
        final int t=mini(to,T.length);
        int f=maxi(0,from);
        if (to>f && T[f]=='+') f++;
        if (to>f && T[f]=='-') f++;
        boolean prevExp=false;
        for(int i=f, dots=0, countE=0; i<t; i++) {
            final byte c=T[i];
            final boolean exp=c=='E' || c=='e';
            if (!(exp&&++countE<2 || c=='.' && ++dots<2 || '0'<=c&&c<='9' || prevExp&&(c=='+'||c=='-'))) return false;
            prevExp=exp;
        }
        return true;
    }

    public static double atof(final Object o) { return atof(o,0);}
    public static double atof(final Object o,final int position) {
        if (o==null) return 0;
        if (o instanceof Number) return
                                     o instanceof Double ? ((Double)o).doubleValue() :
                                     o instanceof Float ? ((Float)o).floatValue() :
                                     atol(o);

        final byte bb[]=o instanceof byte[] ? (byte[])o : null;
        final CharSequence s=bb!=null ? null : o instanceof CharSequence ? (CharSequence)o : toStrg(o);
        final int L=bb!=null ? bb.length : sze(s);
        if (L==0) return Double.NaN;
        int pos=position;
        while(pos<L && (bb!=null ? bb[pos] : s.charAt(pos))==' ') pos++;
        while(pos<L && (bb!=null ? bb[pos] : s.charAt(pos))=='+') pos++;
        if (L<=pos) return Double.NaN;
        final int b0=bb!=null ? bb[pos] : s.charAt(pos);
        final boolean minus=b0=='-';
        if (minus) pos++;
        int end=pos, e=-1, dot=-1;
        boolean skip=false;
        for(int c=b0,c1 ; end<L; end++,c=c1) {
            c1=L>end+1 ? (bb!=null?bb[end+1]:s.charAt(end+1)) :0;
            if (skip) { skip=false; continue;}
            if (end==pos && c=='-') continue;
            if (c=='E' || c=='e') {
                if (e!=-1) break;
                e=end;
                if (c1=='-' || c1=='+') skip=true;
            } else if (c=='.') {
                if (e+dot!=-2) break;
                dot=end;
            } else if ('0'>c || c>'9') break;
        }
        if (pos==end) return Double.NaN;
        atoi_debug=false;
        double v= bb!=null ? atol(bb,pos,MAX_INT) : atol(s,pos,MAX_INT);
        atoi_debug=true;
        if (dot!=-1) {
            final int exp=mini(19,(e!=-1 ? e : end)-dot-1);
            if (exp>0) {
                final double f=exp<FRAC.length ? FRAC[exp] : Math.pow(10,-exp);
                final long frac= (bb!=null ? atol(bb,dot+1,dot+1+exp): atol(s,dot+1,dot+1+exp)) ;
                v+=frac*f;
            }
        }
        if (e!=-1) {
            final int exp=bb!=null ? atoi(bb,e+1) : atoi(s,e+1);
            final double f= exp>=0 && exp<DEC.length ? DEC[exp] : -exp>=0 && -exp<DEC.length ? FRAC[-exp] : Math.pow(10,exp);
            v*=f;
        }
        return minus ? -v : v;
    }
    private static int atoiLookup[][];
    private static float[][] atofLookup;
    public static float[][] atofLookup() { atoiLookup();  return atofLookup;}
    public static int[][] atoiLookup() {
        if (atoiLookup==null) {
            atoiLookup=new int[7][];
            atofLookup=new float[7][];
            for(int decpos=7; --decpos>=0;) {
                final float ff[]=atofLookup[decpos]=new float[256];
                final int dd[]=atoiLookup[decpos]=new int[256];
                final int fac=power10(decpos);
                for(int i=10; --i>0; ) { dd[i+'0']=fac*i; ff[i+'0']=((float)i)/fac; }
            }
        }
        return atoiLookup;
    }
    public static boolean atoi_debug=true;
    private final static double[] FRAC=new double[18], DEC=new double[18];
    static {
        long d=1;
        for(int i=0; i<FRAC.length; i++) {
            FRAC[i]=1.0/d;
            DEC[i]=d;
            d*=10;
        }
    }

    public static long atolDecHex(Object s, final int position) {
        assert s instanceof CharSequence || s instanceof byte[];
        final int pos=nxt(NO_SPC,s,position, MAX_INT);
        if (pos<0 || sze(s)<=pos) return 0L;
        final int c1=chrAt(pos+1,s)|32;
        if (chrAt(pos,s)=='0' && (c1=='x' || c1=='b')) {
            try {
                return Integer.parseInt(toStrg(s).substring(pos+2).trim(),c1=='x'?16:2);
            } catch(Exception ex){return 0L;}
        }
        return atol(s,pos,MAX_INT);
    }
    public static int atoi(final byte[] bb, final int position) {
        if (bb==null || position<0) return INT_NAN;
        int pos=position;
        final int L=bb.length;
        while(pos<L && bb[pos]==' ') pos++;
        while(pos<L && bb[pos]=='+') pos++;
        final boolean minus=L>pos && bb[pos]=='-';
        int ret=0;
        int debug_count=0;
        for(int i=minus ? pos+1 : pos; i<L; i++) {
            final byte b=bb[i];
            if (!is(DIGT,b)) break;
            debug_count++;
            ret=ret*10+ b-'0';
        }
        /*
          if (atoi_debug && debug_count==0) {
          putln("Error in atoi: ");
          if (position<bb.length) putln(new String(bb,position,mini(30,L-position)));
          stckTrc();
          }
        */
        return minus ? -ret : ret;
    }
    public static int  atoiOrDefault(Object o, int defaultValue) {  return atoiOrDefault(o,0,defaultValue); }
    public static int  atoiOrDefault(Object o, int pos, int defaultValue) {

        final int noSpc=nxt(NO_SPC,o,pos,MAX_INT);
        final char c0=chrAt(noSpc,o);
        if (is(DIGT,c0) || is(DIGT,o,noSpc+1)&&(c0=='-'||c0=='+')) return (int)atol(o,pos,MAX_INT);
        return defaultValue;
    }
    public static int trailInt(Object o) {
        final int L=sze(o);
        final int pos=is(DIGT,o,L-1) ? prev(NO_DIGT,o,L-1,-1) : -1;
        return pos<0?INT_NAN : atoi(o,pos+1);
    }
    public static int  atoi(Object o, int pos) { return (int)atol(o,pos,MAX_INT);}
    public static int  atoi(Object o) { return (int)atol(o,0,MAX_INT); }
    public static long atol(Object o) { return atol(o,0,MAX_INT); }
    public static long atol(final Object o, final int position, final int end) {
        final byte[] bb=o instanceof byte[] ? (byte[])o : null;
        final CharSequence s;
        if (bb==null) {
            if (o==null) return 0;
            if (o instanceof byte[]) return atol((byte[])o,position,end);
            if (o instanceof long[]) return position>=0 && ((long[])o).length>position ? ((long[])o)[position] : 0;
            if (o instanceof  int[]) return position>=0 && (( int[])o).length>position ? (( int[])o)[position] : 0;
            if (o instanceof Long) return ((Long)o).longValue();
            if (o instanceof Integer) return ((Integer)o).intValue();
            if (o instanceof Byte) return ((Byte)o).byteValue();
            if (o instanceof Short) return ((Short)o).shortValue();
            if (o instanceof Character) return ((Character)o).charValue();
            if (o instanceof char[]) assert false;
            s=o instanceof CharSequence ? (CharSequence)o : toStrg(o);
        } else s=null;
        final int L=mini(bb!=null ? bb.length : s!=null ? s.length() : 0,end);
        if (L==0 || position<0) return 0;
        int pos=position;

        while(pos<L && (bb!=null?bb[pos]:s.charAt(pos))==' ') pos++;
        while(pos<L && (bb!=null?bb[pos]:s.charAt(pos))=='+') pos++;
        final boolean minus=L>pos && (bb!=null?bb[pos]:s.charAt(pos))=='-';

        long ret=0;
        int debug_count=0;
        for(int i=minus ? pos+1 : pos; i<L; i++) {
            final int b=bb!=null ? bb[i] : s.charAt(i);
            if (b<'0' || b>'9') break;
            debug_count++;
            ret=ret*10+ (b-'0');
        }
        //if (atoi_debug) { if (debug_count<=0) { putln("s=",s); assert false;} }
        return minus ? -ret : ret;
    }

    public static int itoa(final int number, final byte[] T) { return itoa(number,T, 0); }
    public static int itoa(final long number, final byte[] T, final int textPosition) {
        long i= number<0?-number:number;
        final int sz=stringSizeOfInt(number);
        int idx=textPosition+sz;
        if (T.length>idx) T[idx]=0;
        while(i>=0) {
            T[--idx]= (byte) ('0'+i%10);
            if ( (i/=10) ==0) break;
        }
        if (number<0)  T[idx-1]=(byte)'-';
        return sz;
    }
    /* <<< atoi <<< */
    /* ---------------------------------------- */
    /* >>> Math  >>> */
    public static int maxi(int a, int b) {  return a>=b?a:b; }
    public static int maxi(int a, int b, int c) {  return (b >= c) ?  (a>=b?a:b) : (a>=c?a:c);    }
    public static int mini(int a, int b) {  return a<=b?a:b; }
    public static int mini(int a, int b, int c) {  return (b <= c) ?  (a<=b?a:b) : (a<=c?a:c);    }

    public static int mini(int[] aa) {
        int min=MAX_INT;
        for(int a :aa ) if (min>a)min=a;
        return min;
    }
    public static int maxi(int[] aa) {
        int maxi=MIN_INT;
        for(int a :aa ) if (maxi<a)maxi=a;
        return maxi;
    }
    /* <<< Math <<< */
    /* ---------------------------------------- */
    /* >>> Customize >>> */
    public static void setSettings(Object dialog, int...c)       {  Customize.mapSettings().put(dialog,c); if (!(dialog instanceof Class))  Customize.mapSettings().put(dialog.getClass(),c); }
    public static void setSettings(Object dialog, Customize...cc0) {
        final Customize[] cc=rmNull(cc0,Customize.class);
        Customize.mapSettings().put(dialog,cc);
        if (!(dialog instanceof Class))  Customize.mapSettings().put(dialog.getClass(),cc);
    }
    public static String getCustomSetting(int id) { final Customize c=Customize.customize(id); return c!=null ? c.getSetting() : null;}
    public static String[] getCustomSettings(int id) { final Customize c=Customize.customize(id); return c!=null ? c.getSettings() : NO_STRING;}
    public static void edFile(int lineNumber,Object fileObject, int awtModifiers) {
        if (fileObject==null) return;
        setNextProcessHasLogPanel((awtModifiers&CTRL_MASK)!=0);
        final File f=fileObject instanceof File ? (File)fileObject : file(fileObject.toString());
        mkParentDrs(f);
        if (!f.exists()) wrte(f,"");
        final String fn=f.getAbsolutePath();
        final Customize c=Customize.customize(fn.endsWith(".java") ?  Customize.javaSourceEditor : Customize.textEditors);
        final ChExec ex=new ChExec(0).setCommandsAndArgument(c.getSettings(),fn);
        if (logPanelNextExec) ex.log(c);
        new Thread(ex).start();
        logPanelNextExec=false;
    }
    public static String[] getCustomSettings(Class clazz,int id) {
        final Customize c=Customize.getCustomizableForClass(clazz,id);
        return c!=null?c.getSettings() : NO_STRING;
    }
    /* <<< Customize <<< */
    /* ---------------------------------------- */
    /* >>> OS -dependent services >>> */

    private static boolean logPanelNextExec;
    private static long logPanelNextExecTime;
    public static boolean getNextProcessHasLogPanel() { return logPanelNextExec; }
    public static void setNextProcessHasLogPanel(boolean b) { if (currentTimeMillis()-logPanelNextExecTime>999) logPanelNextExec=b;}
    public static void setNextProcessHasLogPanel(long time) { logPanelNextExecTime=time;}
    public static boolean isExeFileName(Object o) {
        final String s=toStrg(o);
        return s==null ? false : s.endsWith(jControl());
    }
    public static void setViewFileWith(Object fileAbsPath, char type) {
        (viewFileWith[type]==null ? viewFileWith[type]=new HashSet() : viewFileWith[type]).add(toStrg(fileAbsPath));
    }
    private final static Set<String>[] viewFileWith=new HashSet['z'+1];
    public static void viewFile(File f, int awtModifiers) {
        final String path=toStrg(f);
        if (path==null || !f.exists()) return;
        if (!Insecure.EXEC_ALLOWED /*&& name2class(ChJnlp.BASIC_SERVICE)!=null*/) {
            ChJnlp.showURL(url(f));
            return;
        }

        if (f.isDirectory()) { openInFilebrowser(f,awtModifiers); return; }
        int c;
        {
            boolean isCompressed=false;
            for(String s : COMPRESS_SUFFIX) if (path.endsWith(s)) { isCompressed=true; break;}
            char type=0;
            for(char iT='z'+1; --iT>='A';) if (viewFileWith[iT]!=null && viewFileWith[iT].contains(path)) { type=iT; break;}
            c=type=='v' || isCompressed && type=='e' ? MAX_INT : type=='e' ? Customize.textEditors : -1;
        }
        if (c<0) {
            final String n=f.getName(), ext=n.lastIndexOf('.')>0 ? n.substring(n.lastIndexOf('.')).toLowerCase().intern() : "";
            if (ext==".html" || ext==".htm")  visitURL(f, awtModifiers);
            else if (ext==".pdf") c=Customize.pdfViewer;
            else if (ext==".ps") c=Customize.psViewer;
            else if (ext==".log") c=Customize.watchLogFile;
            else if (ext==".txt" || ext==".msf"  || ext==".aln" || ext==".fasta" ||
                     strstr(STRSTR_w_R|STRSTR_IC,".sbml",n)+strstr(STRSTR_w_R|STRSTR_IC,".xml",n)>0 ||
                     n.indexOf("_segment=")>0) c=Customize.textEditors;
            else if (ext==".tex") c=Customize.latexEditors;
            else if (ext==".java") c=Customize.javaSourceEditor;
            else  {
                if (isExeFileName(n)) new Thread(new ChExec(0L).setCommandLine(f)).start();
                openInFilebrowser(f, awtModifiers);
            }
        }
        if (c==MAX_INT) { ByteArray ba=readBytes(f); if (ba!=null) new AsciiView(ba).showInFrame(path,0); }
        else if (c>=0) {
            Customize cust=Customize.customize(c);
            ChExec ex=new ChExec(ChExec.LOG).setCommandsAndArgument(cust.getSettings(),f);
            if (logPanelNextExec) ex.log(cust);
            new Thread(ex).start();
        }
        logPanelNextExec=false;
    }
    public static void openInFilebrowser(File file, int awtModifiers) {
        if (file==null) return;
        setNextProcessHasLogPanel( (awtModifiers&CTRL_MASK)!=0);
        if (!file.isDirectory()) file=file(file.getParent());
        final Customize c=Customize.customize(Customize.fileBrowsers);
        ChExec ex=new ChExec(0).setCommandsAndArgument(c.getSettings(),file);
        if (logPanelNextExec) ex.log(c);
        new Thread(ex).start();
        logPanelNextExec=false;
    }
    private static long whenVisitURL;
    private static String lastVisitURL;
    public final static String VISIT_URL_JAVAWS="&USEJAVAWS";
    private static Boolean jnlpServiceBrowser;
    public static void visitURL(final Object o, int evtMask) {
        if (o==null) return;

        final List<String> v=new ArrayList();
        if (o instanceof CharSequence && equls("mailto:",o,0)) v.add(toStrg(o));
        for(URL url : o instanceof URL[] ? (URL[])o : new URL[]{url(o)}) {
            final String sUrl=toStrg(url);
            if (sUrl==null || sUrl.equals(lastVisitURL) && currentTimeMillis()-whenVisitURL<444) continue;
            lastVisitURL=sUrl;
            adUniq(sUrl,v);
        }
        final boolean jnlpService=!Insecure.EXEC_ALLOWED && name2class(ChJnlp.BASIC_SERVICE)!=null;
        for(String sUrl: toStrgArry(v)) {
            final int postData=sUrl.indexOf("??");
            final String sUrl0=postData>0?sUrl.substring(0,postData) : sUrl;
            if (postData>0) {
                ChDelay.newThread(instance(0),"POST_BROWSER", new Object[]{sUrl0, new ByteArray(sUrl.substring(postData+2))}).start();
            } else if (postData<0 || sUrl.indexOf('?')<postData) {
                ChExec ex=null;
                Customize c=null;
                if (jnlpService) {
                    final String msg="On a very few systems STRAP freezes when opening URLs.<br>In this rare case you have the option to change to the Sun Java system.<br><br>Open URL in Browser?";
                    if (jnlpServiceBrowser==null && isEDT() && (!isSystProprty(IS_OPENJDK) || ChMsg.yesNo(msg))) jnlpServiceBrowser=TRUE;
                    if (!isEDT()||jnlpServiceBrowser==TRUE) ChJnlp.showURL(url(sUrl0));
                } else if (sUrl.indexOf(VISIT_URL_JAVAWS.substring(1))>0 || sUrl.indexOf(".jnlp?")>0 || sUrl.endsWith(".jnlp")) {
                    ex=new ChExec(ChExec.LOG).setCommandLineV(dirJavaws()+"javaws",sUrl);
                } else {
                    c=Customize.customize(Customize.webBrowser);
                    ex=new ChExec(ChExec.LOG).setCommandsAndArgument(c.getSettings(),sUrl0);
                }
                if (ex!=null) {
                    if ((evtMask&CTRL_MASK)!=0) ex.log(c);
                    new Thread(ex).start();
                }
            }

        }
        whenVisitURL=currentTimeMillis();
        logPanelNextExec=false;
    }
    public static File dirCygwin() {
        String t=getPrpty(ChUtils.class,KEY_CYGWIN,"?:/cygwin/");
        if (t==null) return null;
        t=t.toLowerCase().trim().replace('\\','/').replaceAll("/*(bin)?/*(cygwin1.dll)* *$","");
        return file(t);
    }
    protected static boolean currVers(String s) { ChDelay.newThread(instance(0),"CURR_VERS",s).start(); return true;}

    /* <<< OS-dependent services <<< */
    /* ---------------------------------------- */
    /* >>> Write Image >>> */
    private static ChFrame writePng_frame;
    private static JTabbedPane writePng_tabbed;
    private static CellRendererPane writePng_pane;
    private final static Object KEY_writePng_file=new Object();
    public static void writePng(Component c, File f) {
        if (c==writePng_tabbed && c!=null) {
            for(int i=writePng_tabbed.getTabCount(); --i>=0;) {
                final JScrollPane sp= childs(writePng_tabbed.getComponentAt(i),JScrollPane.class)[0];
                final JComponent jc=(JComponent)sp.getViewport().getView();
                if (jc!=null) {
                    final File file=gcp(KEY_writePng_file,jc,File.class);
                    if (file!=null && (file.length()==0 || (currentTimeMillis()-file.lastModified()>60*1000))) {
                        writePng(jc, file, true);
                    }
                }
            }
            writePng_frame.setExtendedState(JFrame.ICONIFIED);
        } else if (c==null || f==null)  {
            if (writePng_tabbed!=null) {
                ChDelay.newThread(instance(0),"writePngLater",new Object[]{writePng_tabbed,(File)null}).start();
            }
        } else  {
            writePng(c,f,false);
        }
    }
    private static void writePng(Component c, File f, boolean alsoComplexComponents) {
        if (c==null || f==null)  return;
        if (writePng_pane==null) writePng_pane=new CellRendererPane();
        final boolean complex=childs(c).length>0 && !(c instanceof JComboBox);
        if (!alsoComplexComponents && complex && c.getParent()==null) {
            if (writePng_frame==null) writePng_frame=new ChFrame("writePng: you can close this frame").ad(writePng_tabbed=new JTabbedPane()).shw(ChFrame.ALWAYS_ON_TOP);
            boolean already=false;
            for(int i=writePng_tabbed.getTabCount(); --i>=0;) {
                final JScrollPane sp= childs(writePng_tabbed.getComponentAt(i),JScrollPane.class)[0];
                if (f.equals(gcp(KEY_writePng_file,sp.getViewport().getView()))) already=true;
            }
            if (!already) {
                pcp(f,"",writePng_tabbed);
                pcp(KEY_writePng_file,f,c);
                adTab(shrtClasNam(c),newCNSEW(new JScrollPane(c),null,f,null,null),  writePng_tabbed);
            }
        } else {
            pcp(KEY_JUST_WRITING_PNG,"",c);
            int w=c.getWidth(),h=c.getHeight();
            final Dimension prefSize;
            if (w*h==0) {
                prefSize=HtmlDoc.getPrefSize(deref(c,JComponent.class));
                w=maxi(1,prefSize.width);
                h=maxi(1,prefSize.height);
            } else prefSize=null;
            final BufferedImage im=new BufferedImage( w,h,BufferedImage.TYPE_INT_RGB);
            final Graphics g=im.getGraphics();
            try {
                g.setColor(C(0xFFFFFF));
                g.fillRect(0,0,99999,99999);
                if (complex || prefSize==null) c.paint(g);
                else if (prefSize!=null)  writePng_pane.paintComponent(g, c, new JPanel(), 0, 0, w, h, true);
                mkParentDrs(f);
                javax.imageio.ImageIO.write(im,"png",f);
            } catch(Throwable e) { stckTrc(e); }
            pcp(KEY_JUST_WRITING_PNG,null,c);
        }
    }
    /* <<< Write Image <<< */
    /* ---------------------------------------- */
    /* >>> Help and Soruce code  >>> */
    public static boolean hasHelp(Object o) {
        final String cn=toStrgIntrn(clazzName(o));
        return  cn!=null &&
            (
             CLASS_DesktopUtils==cn ||
             CLASS_EditDnaParentPane==cn ||
             CLASS_ChJmolPROXY==cn ||
             CLASS_MainDialogProjectFiles==cn ||
             CLASS_DialogProjectFiles==cn ||
             CLASS_ResidueAnnotationView==cn ||
             cn.endsWith("StrapAlign") ||
             cn.endsWith("StrapTree") ||
             cn.endsWith("StrapView") ||
             cn.endsWith("Protein3d") ||
             getHlp(o)!=null);
    }
    private static String benchmark="";
    public static void addBenchmark(char type) {benchmark+=type;}
    public static boolean isBenchmark(char type) {return benchmark.indexOf(type)>=0;}
    /* >>> Help and Source >>> */
    public static boolean hasSource(Object o) {
        return ChZip.javaSource(clazzName(o),null,false)!=null;
    }
    private static byte allHelp_[];
    private static byte[] allHelp() {
        if (allHelp_==null) allHelp_=ByteArray.trimSize(readBytes(rscAsStream(_CC,"allHelp"),new ByteArray(260*1000)));
        if (allHelp_==null) allHelp_=NO_BYTE;
        return allHelp_;
    }
    private static Map<String,String> mapHelp;
    protected static void clearHelp() { if (mapHelp!=null) mapHelp.clear();}
    public static String getHlp(Object object) {
        final String cnSlash=HotswapUtil.classNameWithSlash(object);
        if (cnSlash==null||cnSlash.startsWith("java/")) return null;
        if (mapHelp==null) mapHelp=new HashMap();
        String sHelp=mapHelp.get(cnSlash);
        if (sHelp=="") return null;
        if (sHelp!=null) return sHelp;
        StringBuffer sbHelp=null;
        {
            String h_=readStrg(resourceAsURL(cnSlash+"Help.html"));
            if (sze(h_)>0) sbHelp=new StringBuffer().append(h_);
        }
        final byte all[]=allHelp();
        if (sbHelp==null && sze(all)>0) {
            final String tab_cn=("\t"+cnSlash.replace('/','.')+"\n");
            final int from=strstr(tab_cn,all);
            if (from>=0) {
                final int cr=strchr('\n',all,from,MAX_INT);
                final int to=strchr('\t',all,cr,MAX_INT);
                if (to>0) {
                    sbHelp=appnd(all,cr+1,to,new StringBuffer());
                    for(int i=4;--i>=0;) sbHelp.append("\n<i>"+HtmlDoc.PACKAGE).append(i==0?_CC:i==1?_CCS:i==2?_CCSE:_CCP).append("</i>\n");
                }
            }
        }
        if (sbHelp==null) {
            final ByteArray ba=getJavaSource(cnSlash);
            if (ba!=null) {
                final byte[] src=ba.getBytes();
                final int end=ba.getEnd();
                int from=strstr(0L,"/"+"**HELP",src,0,end);
                if (from>=0) {
                    from+=7; while(isSpc(src[from])) from++;
                    final int author=strstr(0L,"@author",src,from,end);
                    final int to=author>0 ? author : strstr(0L,"\n*/",src,from,end);
                    if (to>from) {
                        sbHelp=new StringBuffer(to+999);
                        appnd(src,from,to,sbHelp);
                        if (strstr(0L,"<i>",src,from,to)>=0) {
                            sbHelp.append("\n<i>PACKAGE:").append(clazzName(object)).append(".</i>\n");
                            for (Object i : ChCodeViewer.getImportedPackages(ba)) sbHelp.append("<i>"+HtmlDoc.PACKAGE).append(i).append("</i>\n");
                        }
                    }
                }
            }
        }
        if (sbHelp!=null) {
            sHelp=sbHelp.toString();
            mapHelp.put(cnSlash,sHelp);
            return sHelp;
        } else {
            mapHelp.put(cnSlash,"");
            return null;
        }
    }
    public static boolean showHelp(Object o) {
        if (o instanceof URL) {
            new ChTextViewer(addHtmlTagsAsStrg(readStrg(((URL)o)))).title("Help").shw(0);
            return true;
        } else return addHelpSource(clazzName(o),panHelps,true);
    }
    public static boolean showJavaSource(String shortClassName, String[] packages) {
        final String cn=fullClassName(shortClassName,packages);
        return cn!=null ? addHelpSource(cn,panSource,false) : false;
    }
    public static ByteArray getJavaSource(String shortOrLongClassName) {
        InputStream is= (InputStream)ChZip.javaSource(shortOrLongClassName,NO_STRING,true);
        return is!=null ? readBytes(is) :  null;
    }
    private static boolean addHelpSource(final String className, ChTabPane tabbed, final boolean helpOrSource) {
        if (className==null) return false;
        if(!isEDT()) {
            ChDelay.invokeAndWait(instance(0),"addHelpSource",new Object[]{className,tabbed, boolObjct(helpOrSource)});
            return false;
        }
        if (tabbed!=null) {
            for(JComponent h :tabbed.getTabComponents()) {
                if (isAssignblFrm(ChTextViewer.class,h) && className.equals(gcp(KEY_CLASS_NAME,h))) {
                    tabbed.setSelectedComponent(h);
                    return true;
                }
            }
        }
        final String
            shortCn=className.substring(className.lastIndexOf('.')+1).replaceAll("PROXY$","*"),
            tip=TabItemTipIcon.item(className)+"<br><b>"+shortCn+"</b><br><sup>"+className+"</sup>",
            key=(helpOrSource ? "" : "class ")+className;
        final Reference<ChTextViewer> ref=mapTextViewer.get(key);
        final ChTextViewer lastTV=ref!=null ? ref.get():null,  tv;
        if (lastTV==null || lastTV.getPanel()==null) {
            StringBuffer sb=null;
            if (helpOrSource) {
                sb=toStringBuffer(getHlp(className));
                HtmlDoc.insertHeadline(className,'2',sb, DOCTYPE_TUTORIAL);
            } else {
                final ByteArray ba=getJavaSource(className);
                if (ba!=null) appnd(ba.getBytes(),0,ba.getEnd(),sb=new StringBuffer(ba.getEnd()));
            }
            if (sb==null) return false;
            if (className.endsWith("PROXY")) {
                if (!helpOrSource) addHelpSource(delSfx("PROXY",className),tabbed,false);
                else sb.append("\n<br><sub><b>Source code:</b> ").append(URL_STRAP_JARS).append("src</sub><br>");
            }
            tv=new ChTextViewer(sb).title(shortCn);
            pcp(KEY_CLASS_NAME,className,tv);
        } else tv=lastTV;
        mapTextViewer.put(key,weakRef(tv));
        TabItemTipIcon.set(shortCn,className,tip,TabItemTipIcon.icn(className),tv);
        TabItemTipIcon.set(shortCn,className,tip,TabItemTipIcon.icn(className),tv.getPanel());
        if (tabbed!=null) {
            tabbed.addTab(tv.getPanel());
            //if (lastTV==null) tv.addNorth(new ChButton().actionUndock(tv));
            try { ((ChTabPane)tabbed.getParent() ).setSelectedComponent(tabbed);} catch(Exception e) {}
        } else tv.shw(0);
        return true;
    }
    private static Map<String,Reference<ChTextViewer>> mapTextViewer=new HashMap();
    public static JComponent panHS(Object... oo) {
        final JComponent c=hB(OPAQUE_FALSE);
        boolean isOpaque=true,addHelp=false;
        for(Object o : oo) {
            if (o==null) continue;
            if (o==Boolean.FALSE) { isOpaque=false; continue;}
            if (!(o instanceof Boolean)) addHelp=true;
            ChButton b=ChButton.actionCustomize(o);
            if (b!=null) c.add(b.magnifyUnderMouse(IC_CUSTOM24));
            b=ChButton.actionSharedCtrl(o);
            if (b!=null) c.add(b.magnifyUnderMouse(IC_CONTROLPANEL).options(ChButton.NO_FILL|ChButton.NO_BORDER));
            b=ChButton.actionCtrl(o);
            if (b!=null) c.add(b.magnifyUnderMouse(IC_CONTROLPANEL).options(ChButton.NO_FILL|ChButton.NO_BORDER));
        }
        if (addHelp) {
            final ChButton bs=smallSourceBut(oo);
            final ChButton bh=smallHelpBut(oo);
            if (!isOpaque) { bs.options(ChButton.NO_FILL|ChButton.NO_BORDER); bh.options(ChButton.NO_FILL|ChButton.NO_BORDER);}
            c.add(bs);
            c.add(bh);
        }
        return c;
    }
    private static ChTabPane panHelps,panSource;
    public static void setHelpPanel(ChTabPane tp) { panHelps=tp;}
    public static void setJavaPanel(ChTabPane tp) { panSource=tp;}
    public static ChTabPane getHelpPanel() { return panHelps;}
    public static ChTabPane getJavaPanel() { return panSource;}
    public static File sourceFile(Class c) {
        if (c==null) return null;
        final File f=file(resourceAsURL(HotswapUtil.classNameWithSlash(c)+".java"));
        return f!=null && f.exists() ? f : null;
    }
    public static ChButton smallHelpBut(Object o) {
        final ChButton b=helpBut(o).options(ChButton.NO_MARGIN|ChButton.NO_FILL|ChButton.NO_BORDER).magnifyUnderMouse("?").i(IC_BLANK);
        return b;
    }
    public static ChButton smallSourceBut(Object o) {return ChButton.actionHelpOrJava(oo(o),'J').magnifyUnderMouse(IC_JAVA).i(IC_BLANK);}
    public static ChButton helpBut(Object o) { return ChButton.actionHelpOrJava(o,'H'); }
    public static ChButton sourceBut(Object o) { return ChButton.actionHelpOrJava(o,'J').t("See java source code"); }
    private static transient File toolsDotJar[];
    public static File toolsDotJar() {
        if (toolsDotJar==null) {
            final char c2=systProprty(SYSP_JAVA_VERSION).charAt(2);
            for(char c='4'; c<'8'; c++) {
                if (c2!=c) {
                    File fJar=file(dirJars(),"tools_1."+c+".jar");
                    renamFile(fJar, fJar+"_");
                }
            }
            File f=file(delSfx("jre",systProprty(SYSP_JAVA_HOME))+"/lib/tools.jar");
            toolsDotJar=new File[]{f.exists() ? f : null};
        }
        return toolsDotJar[0];
    }
    /* <<< Help and Source <<< */
    /* ---------------------------------------- */
    /* >>> ClientProperty >>> */
    final static Map getPropertyMap(Object o) {
        return
            o instanceof ChButton ? ((ChButton)o).MAPCP :
            o instanceof ChPanel ? ((ChPanel)o).MAPCP :
            o instanceof ChLabel ? ((ChLabel)o).MAPCP :
            o instanceof ChCombo ? ((ChCombo)o).MAPCP :
            o instanceof HasPropertyMap ? ((HasPropertyMap)o).getPropertyMap(true) :
            null;
    }
    private static Map<Object,Map> _mapCP=new WeakHashMap();
    private final static Map mapcp(Object o, boolean create) {
        Map m=getPropertyMap(o);
        if (m==null) m= _mapCP.get(o);
        if (m==null && create) _mapCP.put(o,m=new HashMap());
        return m;
    }

    public static void pcp(Object key, Object value,  Object c) {
        if (c==null || key==null) return;
        assert !(key instanceof ChEventAdapter);
        mapcp(c,true).put(key,value);
    }

    public static void addCP(Object key, Object value,  Object container, int reserve) {
        if (container==null || value==null || key==null) return;
        final Object collection=gcp(key,container);
        final Object oo[]=ad(value, oo(collection), reserve, Object.class);
        if (oo!=collection) pcp(key,oo,container);
    }
    public static <T extends Object>T gcp(Object key, Object c, Class<T> clazz) {
        Object o=gcp_(key,c,false);
        return isInstncOf(clazz,o) ? (T)o : null;
    }
    public static <T extends Object>T gcpClear(Object key, Object c, Class<T> clazz) {
        Object o=gcp_(key,c,false);
        if (o!=null) pcp(key,null,c);
        return isInstncOf(clazz,o) ? (T)o : null;
    }
    public static Object gcp(Object key, Object c) { return gcp_(key,c,false);}
    public static Object gcpa(Object key, Object c) { return gcp_(key,c,true);}
    private static Object gcp_(Object key, Object c,boolean alsoAncestor) {
        if (c==null || key==null) return null;
        assert !(key instanceof ChEventAdapter);
        Object ret=null;
        if (alsoAncestor &&  c instanceof JComponent) {
            final Object clonedFrom=gcp(KEY_CLONED_FROM,c);
            if (clonedFrom instanceof JComponent) ret=gcp(key,clonedFrom);
        }
        if (ret==null) {
            if (c instanceof Map) ret=((Map)c).get(key);
            else {
                Map m=mapcp(c,false);
                if (m!=null) ret=m.get(key);
            }
        }
        return deref(ret);
    }
    public static Object mkIdObjct(String key, Object o) {
        Object k=gcp(key,o);
        if (k==null) pcp(key, k=new Object(),o);
        return k;
    }
    /* <<< ClientProperty <<< */
    /* ---------------------------------------- */
    /* >>> DnD >>> */
    private static File[] dragFiles;
    private static long dragFilesWhen;
    private static TransferHandler fth;
    public static void resetDragFiles() { dragFiles=null;}
    public static File[] getDragFiles() {
        final File ff[]=dragFiles;
        return ff!=null && currentTimeMillis()-dragFilesWhen < 180*1000 ? ff:  NO_FILE;
    }

    public static void exportDrg(JComponent c, AWTEvent ev, int copy_move) {
        if (c==null) return;
        //putln("exportDrg="+c+" "+ev);
        if (fth==null) fth=new TransferHandler("dndDateien") {
                @Override protected java.awt.datatransfer.Transferable createTransferable(JComponent c) { return ChUtils.createTransf(c);}
            };

        if (c.getTransferHandler()!=fth) c.setTransferHandler(fth);
        fth.exportAsDrag(c,(MouseEvent)ev,copy_move);
    }

    private static java.awt.datatransfer.Transferable createTransf(JComponent c) {
        final Object[] oo=oo(invokeMthd("getDndDateien",c, NO_OBJECT,INVOKE_MTHD_ASSERT_EXISTS));
        //putln("ChUtils "+clazzName(c)+" DDD createTransf "+sze(oo),oo);
        if (sze(oo)==0) return null;
        ChUtils.dragFilesWhen=currentTimeMillis();
        ChUtils.dragFiles=derefArray(oo,File.class);
        return lastTransferable=new ChTransferable(oo, ChTransferable.FILE | ChTransferable.OBJECT );
    }
    public static java.awt.datatransfer.Transferable getDnD_lastTransferable() {  return lastTransferable; }
    private static java.awt.datatransfer.Transferable lastTransferable;
    public static File toFile(Object object) {
        if (object==null) return null;
        Object o=deref(object);
        if (o instanceof MouseEvent) {
            final MouseEvent mev=(MouseEvent)o;
            final Object q=mev.getSource();
            if (q instanceof JList) {
                final int i=((JList)q).locationToIndex(mev.getPoint());
                if (i>=0) o=get(i,q);
            }
        }
        Object  f=o instanceof File || o instanceof URL ? file(o) : invokeMthd("getFile",o);
        if (o instanceof String) { File f_=file(o); if (f_!=null && f_.exists()) f=f_;}
        return f instanceof File ? (File)f : null;
    }

    private final static Object KEY_dndF=new Object();
    public static List getDndFilesV(JComponent c) {
        List v=(List)gcp(KEY_dndF, c);
        if (v==null) pcp(KEY_dndF,v=new ArrayList(),c);
        return v;
    }

    /* <<< DnD <<< */
    /* ---------------------------------------- */
    /* >>> Window >>> */

    /*  Redundant:   ChDelay.parentWindowToFront( */
    private static File exeSWS;
    public static Thread thread_setWndwState(char m, Object f) {
        if (f==null) return new Thread();
        final Object[] args={charObjct(m), f};
        return threadM("setWndwState", ChUtils.class, args);
    }

    public static boolean setWndwState(char state, Object windowOrChildOrArray) {
        if (windowOrChildOrArray instanceof Object[]) {
            for(Object o : (Object[])windowOrChildOrArray) if (setWndwState(state,o)) return true;
            return false;
        }

        final Component windowOrChild=deref(windowOrChildOrArray,Component.class);
        final Window f=parentWndw(windowOrChild);
        if (f==null) return false;
        if (!isEDT()) {
            inEDT(thread_setWndwState(state,f));
            return true;
        }
        if (javaVsn()==14) {
            if (state=='F' || state=='T') {
                f.show();
                if (f instanceof JFrame) ((JFrame)f).setExtendedState(JFrame.NORMAL);
                f.toFront();
            }
        } else {
            if (state=='t') f.setAlwaysOnTop(false);
            if (state=='F' || state=='T') {
                f.setAlwaysOnTop(true);
                if (state=='F') {
                    //f.setAlwaysOnTop(false);
                    runAftrMS(555, thread_setWndwState('t', f)); // Problem under opensuse
                }
            }
        }
        return true;
    }

    public static Thread thread_setWndwStateT(char m, int x, int y, String ...title) {
        final Object[] args={charObjct(m), intObjct(x),intObjct(y), title};
        return threadM("setWndwStateT", ChUtils.class, args);
    }

    public static void setWndwStateT(char m, int x, int y, String ...title) {
        if (sze(title)==0) return;
        if (title.length==1 && title[0]=="D") title=new String[]{"Downloads", "Geladene Dateien", "Download Manager"};
        if (isMacintosh()) {
            if (m=='I') {
                if (exeSWS==null) {
                    exeSWS=new File(dirBin(),"minimize.applescript");
                    delFile(exeSWS);
                    cpy( CLASSLOADER.getResourceAsStream("charite/christo/files/"+exeSWS.getName()),exeSWS);
                }
                ChExec ex=new ChExec(ChExec.IGNORE_ERROR).setCommandLineV("osascript",exeSWS);
                new Thread(ex).start();
            }
            return;
        } else if (Insecure.EXEC_ALLOWED) new NativeTools().setWindowState(m,x,y,title);
    }

    public static void setWndwStateLaterT(char m, int sleep, String ...title) {
        newThrd( threadSleep(sleep), thread_setWndwStateT(m, -1, -1,title)).start();
    }

    /* <<< Window <<< */
    /* ---------------------------------------- */
    /* <<< Threading <<< */

    public static void runAftrMS(int msg, Runnable r) { if (r!=null)  newThrd(threadSleep(999), r).start(); }
    public static Thread threadSleep(int msec) { return ChDelay.newThread(instance(0), "WAIT_MS", intObjct(msec));}
    public static Thread threadM(String methodName, Object instOrClass, Object para[]) { return threadM(methodName,instOrClass, para,(Object[]) null);}
    public static Thread threadM(String methodName, Object instOrClass, Object para[], Object ret[]) {
        assert ret==null || ret.length==1;
        final Method m=findMthd(methodName, instOrClass, para, 0L);
        if (m==null && isMyComputer()) {
            stckTrc();
            putln("methodName=",methodName+"  instOrClass"+instOrClass);
            putln("para=",para);
            System.exit(1);
        }
        return m==null ? null : ChDelay.newThread(instance(0), "INVOKE_MTHD",  new Object[]{m,instOrClass, para, ret});
    }

    public static Object inEdtM(String methodName, Object instanceOrClass, Object para[]) {
        if (!isGraphicsAvailable() || isEDT()) return invokeMthd(methodName,instanceOrClass,para, INVOKE_MTHD_PRINT_EXCEPTIONS | INVOKE_MTHD_ASSERT_EXISTS);
        else {
            final Object ret[]={null};
            inEDT(threadM(methodName,instanceOrClass, para,ret));
            return ret[0];
        }
    }
    /* <<< Threading <<< */
    /* ---------------------------------------- */
    /* >>> Reflection >>> */
    public static Object invokeMthd(String methodName,final Object instanceOrClassOrClassname) {
        return invokeMthd(methodName,instanceOrClassOrClassname,NO_OBJECT,0L);
    }
    public final static long INVOKE_MTHD_ASSERT_EXISTS=1, INVOKE_MTHD_PRINT_EXCEPTIONS=1<<1, INVOKE_MTHD_VERBOSE=1<<2, INVOKE_MTHD_RETURN_ERROR=1<<3;
    public final static Object INVOKE_MTHD_ERROR=new Object();
    public static Method findMthd(final String methodName,final Object instanceOrClass, final Object para[], long options) {
        if (instanceOrClass==null || methodName==null) return null;
        final Object instOrClass;
        if (instanceOrClass instanceof String) {
            try {
                instOrClass=Class.forName((String)instanceOrClass);
            } catch(Exception e){
                if ( (options&INVOKE_MTHD_PRINT_EXCEPTIONS)!=0) putln("invokeMthd ",e);
                if ( (options&INVOKE_MTHD_ASSERT_EXISTS)!=0) assert false;
                return null;
            }
        } else instOrClass=instanceOrClass;
        final Class c= instOrClass instanceof Class ? (Class)instOrClass : instOrClass.getClass();
        final int nPara=sze(para);

    nextMethod:
        for(Method m : c.getMethods()) {
            if (!m.getName().equals(methodName) || (m.getModifiers()&java.lang.reflect.Modifier.PUBLIC)==0) continue nextMethod;
            final Class[] cc=m.getParameterTypes();
            if (cc.length!=nPara) continue;
            for(int iP=nPara; --iP>=0; ) {
                if (para[iP]!=null) {
                    final Class ci=cc[iP], pi=para[iP].getClass();
                    if ( !(ci==boolean.class&&pi==Boolean.class) &&
                         !(ci==int.class&&pi==Integer.class) &&
                         !(ci==long.class&&pi==Long.class) &&
                         !(ci==short.class&&pi==Short.class) &&
                         !(ci==float.class&&pi==Float.class) &&
                         !(ci==double.class&&pi==Double.class) &&
                         !(ci==byte.class&&pi==Byte.class) &&
                         !(ci==char.class&&pi==Character.class) &&
                         !cc[iP].isAssignableFrom(para[iP].getClass()))
                        continue nextMethod;
                }
            }
            return m;
        }
        if ((options&INVOKE_MTHD_ASSERT_EXISTS)!=0) assert false;
        return null;
    }
    public static Object invokeMthd(String methodName,final Object instanceOrClass, final Object para[], long options) {
        final Method m=findMthd(methodName, instanceOrClass, para,options);
        return invokeMthd(m, instanceOrClass, para,options);
    }

    public static Object invokeMthd(final Method m,final Object instOrClass, final Object para[], long options) {
        final Object objectError= 0!=(options&INVOKE_MTHD_RETURN_ERROR)?INVOKE_MTHD_ERROR : null;
        if (m==null) {
            if ((options&INVOKE_MTHD_ASSERT_EXISTS)!=0) assert false;
            return objectError;
        }
        if ((options&INVOKE_MTHD_VERBOSE)!=0) putln("invokeMthd method=", m);
        try {
            return m.invoke(instOrClass,para!=null ? para : NO_OBJECT);
        } catch(Exception e){
            if ( (options&INVOKE_MTHD_PRINT_EXCEPTIONS)!=0) {  stckTrc(e); }
        }
        return objectError;
    }

    private final static Map<Class,String[]> mapFieldName=new HashMap();
    private final static Map<Class,Map<Long,String>> mapFieldNameM=new HashMap();
    public static String[] getFinalStaticFields(Class clas,int MAX) {
        String[] nn=mapFieldName.get(clas);
        if (nn==null)  mapFieldName.put(clas,nn=getFinalStaticFields(clas,MAX,null));
        return nn;
    }
    public static Map<Long,String> getFinalStaticFields(Class clas) {
        Map<Long,String>  m=mapFieldNameM.get(clas);
        if (m==null) {
            getFinalStaticFields(clas,0, m=new HashMap());
            mapFieldNameM.put(clas,m);
        }
        return m;
    }

    public static boolean processEvt(EventObject ev,Object component) {
        boolean succ= ERROR_OBJECT!=invokeMthd("processEvent", component, new Object[]{ev}, INVOKE_MTHD_RETURN_ERROR);
        return succ;
    }
    public static String getTxt(final Object button) {
        final Object b=deref(button);
        return
            b instanceof AbstractButton ?  ((AbstractButton)b).getText() :
            b instanceof JLabel ? ((JLabel)b).getText() :
            toStrg(invokeMthd("getText",b));
    }
    public static Icon getIcn(Object button) {
        final Object b=deref(button);
        final Object i= b instanceof AbstractButton ?  ((AbstractButton)b).getIcon() :
            b instanceof JLabel ? ((JLabel)b).getIcon() :
            (Icon)invokeMthd("getIcon",b);
        return i instanceof Icon ? (Icon)i : null;
    }

    private static String[] getFinalStaticFields(Class clas,int MAX, Map<Long,String>map ) {
        final java.lang.reflect.Field[] fields=clas.getDeclaredFields();
        final String[] nn=MAX>0 ? new String[MAX] : null;
        for(java.lang.reflect.Field field:fields) {
            final int modi=field.getModifiers();
            if ( (modi & java.lang.reflect.Modifier.FINAL)==0 || (modi & java.lang.reflect.Modifier.PUBLIC)==0 || (modi & java.lang.reflect.Modifier.STATIC)==0) continue;
            try {
                final Object o=field.get(null);
                if (!(o instanceof Integer)) continue;
                final int value=atoi(o);
                final String name=field.getName();
                if (clas==ChUtils.class && !name.startsWith("SYSP_") && !name.startsWith("IS_")) continue;
                if (nn!=null && value>=0 && value<nn.length && nn[value]==null) nn[value]=name.intern();
                if (map!=null) {
                    final Long key=new Long(value);
                    assert map.get(key)==null;
                    map.put(key, field.getName().intern());
                }
            } catch(Exception e){ }
        }
        return nn;
    }
    public static boolean isInstncOf(Class c, Object o) { return HotswapUtil.isInstanceOf(c,o); }
    public static String shrtClasNam(Object o) { return HotswapUtil.shortClassName(o);}
    public static String clazzName(Object o) { return HotswapUtil.className(o);}
    public static boolean isAssignblFrm(Class c, Object o) { return HotswapUtil.isAssignableFrom(c,o); }
    public static boolean cntainsAssignblFrm(Class c, Object oo[]) {
        if (c!=null && oo!=null) for(Object o : oo) if (isAssignblFrm(c,o)) return true;
        return false;
    }
    public static Class name2class(String name) {
        if (name==null) return null;
        Class c=null;
        try {
            try {
                try {
                    c=Class.forName(name.replace('/','.'));
                } catch(NoClassDefFoundError er){}
            } catch(ClassNotFoundException ex){}
        } catch(ExceptionInInitializerError ex) { stckTrc(ex);}
        if (c==null) c=ChClassLoader.name2c(name);
        return c;
    }
    public static Class findClas(String s,String[] vPackages) {
        Class c=
            "String[]".equals(s) ? String[].class :
            "java.lang.String[]".equals(s) ? String[].class :
            "String[][]".equals(s) ? String[][].class :
            "java.lang.String[][]".equals(s) ? String[][].class :
            "double".equals(s) ? double.class :  "float".equals(s) ? float.class : "boolean".equals(s) ? boolean.class : "byte".equals(s) ? byte.class : "char".equals(s) ? char.class : "short".equals(s) ? short.class : "int".equals(s) ? int.class : "long".equals(s) ? long.class :
            "double[]".equals(s) ? double[].class :  "float[]".equals(s) ? float[].class : "boolean[]".equals(s) ? boolean[].class : "byte[]".equals(s) ? byte[].class : "char[]".equals(s) ? char[].class : "short[]".equals(s) ? short[].class : "int[]".equals(s) ? int[].class : "long[]".equals(s) ? long[].class : null;
        if (c==null) c="boolean[][]".equals(s) ? boolean[][].class : "byte[][]".equals(s) ? byte[][].class : "char[][]".equals(s) ? char[][].class : "short[][]".equals(s) ? short[][].class : "int[][]".equals(s) ? int[][].class : "long[][]".equals(s) ? long[][].class : null;
        if (c!=null) return c;
        final String cname=toArrayName(s);
        if (isClassName(cname) && (c=name2class(cname))!=null) return c;
        for(Object o:vPackages){
            if (o==null) continue;
            String cn=toArrayName(o+s);
            if (isClassName(cn) && (c=name2class(cn.replace('/','.')))!=null) return c;
        }
        return c;
    }
    private static String toArrayName(String cn) {
        if (cn==null || !cn.endsWith("[]")) return cn;
        int count=0;
        for(int i=cn.length()-1; i>0 && cn.charAt(i)==']'; i-=2) count++;
        return "[[[[[[[[[[[[[[[[".substring(0,count)+"L"+cn.substring(0,cn.length()-2*count)+";";
    }
    private static Set vCLASS_NAMES=new HashSet();
    public static boolean isClassName(final String s) {
        if (vCLASS_NAMES.contains(s)) return true;
        if (s!=null && resourceAsURL(s.replace('.','/')+".class")!=null) {
            vCLASS_NAMES.add(s.intern()); return true;
        }
        String full=fullClassName(s,null);
        if (full!=null) { vCLASS_NAMES.add(full); return true;}
        else { return false;}
    }
    public static String fullClassName(String shortOrLongClassName, String[] packages) { return ChZip.fullCN(shortOrLongClassName,packages); }
    /** get the file from a javadoc file generated with the JDK javadoc tool.*/
    public static Class javadocFile2class(CharSequence txt) {
        final int idxContent=strstr(" CONTENT=\"",txt);
        if (idxContent>0 && idxContent< strstr("</HEAD>",txt)) {
            final int idxSpace=strstr(0L," ",txt,idxContent+1, MAX_INT);
            if (idxSpace>0 && (substrg(txt,idxSpace,idxSpace+12).equals(" interface\">") || substrg(txt,idxSpace,idxSpace+8).equals(" class\">"))) {
                return name2class(substrg(txt,idxContent+10,idxSpace).trim());
            }
        }
        return null;
    }
    public static Class clazz(Object o) { return o!=null ? o.getClass() : null;}
    public final static Map<String,Class> MAP_LOADED_CLASSES=new HashMap();
    private final static Map<Object,Reference> mapWRef=new WeakHashMap(999);
    private final static Reference REF_NULL=new java.lang.ref.WeakReference(null);
    public static Reference weakRef(final Object o) { return weakRef(o,true); }

    public static Reference weakRef(final Object o, boolean create) {
        if (o==null) return REF_NULL;
        if (o instanceof HasWeakRef) return ((HasWeakRef)o).getWeakRef();
        synchronized(mapWRef) {
            Reference r;
            final Map m=getPropertyMap(o);
            if (m!=null) {
                r=(Reference)m.get(mapWRef);
                if (r==null && create) m.put(mapWRef,r=new java.lang.ref.WeakReference(o));
            } else {
                r=mapWRef.get(o);
                if (r==null && create) mapWRef.put(o,r=new java.lang.ref.WeakReference(o));
            }
            return r;
        }
    }
    public static String niceShrtClassNam(Object viewer) {
        return delSfx("PROXY",delPfx("Ch",delPfx("PairAligner",delPfx("Superimpose_",shrtClasNam(viewer)))));
    }
    /* <<< Reflection <<< */
    /* ---------------------------------------- */
    /* >>> HasName Streams >>> */
    public static String getNam(final Object o) {
        return
            o==null ? null :
            o instanceof File ?  ((File)o).getName() :
            o instanceof HasName ? ((HasName)o).getName() :
            toStrg(invokeMthd("getName",o));
    }
    public static String getID( Object o) {
        return o instanceof HasID ? ((HasID)o).getID() : null;
    }

    public static float getScor(Object o) {
        return o!=null && isAssignblFrm(HasScore.class,o) ? ((HasScore)o).getScore() : Float.NaN;
    }
    public static <T extends Object> T findWithName(String name, Object oo[],Class<T> clazz ) {
        if (oo==null||name==null) return null;
        for(Object s : oo) {
            if (isAssignblFrm(clazz,s) && name.equals(getNam(s))) return (T)s;
        }
        return null;
    }
    public static int longestName(Object oo[]) {
        int len=0;
        for(int i=sze(oo) ;--i>=0;) len=maxi(len,sze(getNam(oo[i])));
        return len;
    }
    public static int maxSze(Object oo[]) {
        int len=0;
        for(int i=sze(oo) ;--i>=0;) len=maxi(len,sze(oo[i]));
        return len;
    }

    /* <<< HasName <<< */
    /* ---------------------------------------- */
    /* >>> Standard Streams >>> */
    public static void putln(boolean b) { out.println(b); }
    public static void putln(int n) { out.println(n); }
    public static void putln(Object o) {
        puts(o);
        //if (strstr("success",toStrg(o))>=0) stckTrc();
        out.print('\n');
    }
    public static void putln(Object o0, Object o1) {  puts(o0);  putln(o1); }
    public static void putln(Object o0, Object o1, Object o2) {  puts(o0); putln(o1, o2); }
    public static void putln(Object o0, Object o1, Object o2, Object o3) {  puts(o0); putln(o1,o2,o3); }
    public static void putln(Object o0, Object o1, Object o2, Object o3, Object o4) {  puts(o0); putln(o1,o2,o3, o4); }
    public static boolean puts(Object o) {
        //if (o instanceof String && ((String)o).indexOf("Caught")>=0) stckTrc();
        // if (o!=null) {String s=o.toString(); if (s!=null && s.indexOf("DEFINITION  ")>=0) stckTrc(); }
        try {
            //if (o instanceof File) out.print(filepathUnixStyle(o));
            if (o instanceof byte[]) out.write((byte[])o);
            else if (o instanceof int[]) {
                boolean isFirst=true;
                for(int i : (int[])o) {
                    if (!isFirst) out.print(',');
                    out.print(i);
                    isFirst=false;
                }
            }
            else if (o instanceof Object[]) {
                boolean komma=false;
                for(Object o2 : (Object[])o) {
                    if (komma) puts(", ");
                    komma=true;
                    puts(o2);
                }
            } else out.print(o);
            //if (o!=null && o.toString().indexOf("PALSSON#")>=0) { stckTrc(); exit(99);}
        } catch(IOException iox){}
        return true;
    }
    /* <<< Standard Streams <<< */
    /* ---------------------------------------- */
    /* >>> Columns >>> */
    public final static int tabulatrs(char ch09, byte txt[], int from, int end, int[] TABS) {
        int count=0;
        Arrays.fill(TABS,-1);
        final int E=mini(end,txt.length);
        for(int i=maxi(0,from); i<E; i++) {
            if (txt[i]==ch09) TABS[count++]=i;
            if (TABS.length==count || txt[i]=='\n') break;
        }
        return count;
    }
    public static int nthColumn(int n, char separator, byte[] txt, int from, int to) {
        int pos=maxi(0,from);
        for(int i=n; --i>=0;) if (  (pos=1+strchr(separator,txt,pos,to)) <1) return -1;
        return pos;
    }
    /* <<< Columns <<< */
    /* ---------------------------------------- */
    /* >>> HashMaps >>> */
    public final static int MAP_VALUES_AS_CHARSEQUENCE=1<<16, MAP_VALUES_AS_INTERN=1<<17, MAP_ALLOW_EMPTY_STRING=1<<19,
        MAP_RM_TERMINAL_QUOTES=1<<18;
    public static void mapKey2Array(ByteArray ba, Map<String, String[]> map, long options) {
        if (ba==null) return;
        final ChTokenizer tok=new ChTokenizer();
        final List<String> v=new ArrayList(), vVal=new ArrayList();
        final int B=ba.getBegin(), ends[]=ba.getLineEnds();
        final byte[] T=ba.getBytes();

        for(int iL=0; iL<ends.length; iL++) {
            final int b= iL==0?B : ends[iL-1]+1, e=strchr(STRSTR_E,'#',T,b,ends[iL]);
            final int tab=strchr('\t',T,b,e);

            if (tab<0) continue;
            v.clear();
            tok.setText(T,tab+1, e);
            while(tok.nextToken()) {
                final String s=tok.asString();
                adUniq((options&MAP_VALUES_AS_INTERN)!=0 ? s.intern() : s,v);
            }
            if (v.size()>0) {
                tok.setText(T,b, tab);
                while(tok.nextToken()) {
                    final String k=tok.asString();
                    final String vv[]=map.get(k);
                    vVal.clear();
                    for(int i=v.size(); --i>=0;) adUniq(v.get(i),vVal);
                    adAllUniq(vv,vVal);
                    if (vv==null || vv.length!=vVal.size())map.put(k, toArry(vVal,String.class));
                }
            }
        }
    }
    public static void mapColumns012345to9(ByteArray ba, Map<String, String> map, long options) {
        if (ba==null) return;
        final ChTokenizer TOK=new ChTokenizer();
        final int B=ba.getBegin(), ends[]=ba.getLineEnds();
        final byte[] T=ba.getBytes();
        final List<String> v=new ArrayList();
        for(int iL=0; iL<ends.length; iL++) {
            final int b= iL==0?B : ends[iL-1]+1, e=strchr(STRSTR_E,'#',T,b,ends[iL]);
            if (e-b<3) continue;
            String rep=null;
            TOK.setText(T,b,e);
            v.clear();
            while(TOK.nextToken()) v.add(rep=TOK.asString());
            if (rep!=null && sze(v)>1) {
                if ((options&MAP_VALUES_AS_INTERN)!=0) rep=rep.intern();
                for(int i=sze(v)-1; --i>=0;) map.put(v.get(i),rep);
            }
        }
    }
    //     public static <T extends Object> T[] mapStringToArray( T item, String key, Map<String,T[]> map, int reserve, Class<T> clazz ) {
    //         if (key!=null && key.length()>0) {
    //             final T[]  dd=map.get(key);
    //             if (!(clazz==String.class ? idxOfStrg((String)item, (String[])dd)>=0 : cntains(item,dd) )) {
    //                 final T[] newDD=ad(item, dd, reserve, clazz);
    //                 map.put(key, newDD);
    //                 return newDD;
    //             }
    //             return dd;
    //         }
    //         return null;
    //     }

    public static <VALUE extends Object, KEY extends Object> VALUE[] mapOneToMany( VALUE item, KEY key, Map<KEY,VALUE[]> map, int reserve, Class<VALUE> clazz ) {
        if (item!=null && key!=null && (!(key instanceof String) || ((String)key).length()>0)) {
            final VALUE[]  dd=map.get(key);
            if (!(clazz==String.class ? idxOfStrg((String)item, (String[])dd)>=0 : cntains(item,dd) )) {
                final VALUE[] newDD=ad(item, dd, reserve, clazz);
                map.put(key, newDD);
                return newDD;
            }
            return dd;
        }
        return null;
    }

    public static <T extends Object> void rmNulls(Map<? extends Object,T[]> map, Class<T> clazz ) {
        for(Map.Entry<String,T[]> e : entryArry(map)) {
            final T[] tt=e.getValue();
            final T[] tt2=rmNull(tt, clazz);
            if (tt!=tt2) e.setValue(tt2);
        }

    }

    public static void mapColumn1Column2(ByteArray ba,int column1, int column2, char separator, Map<String,String> map, long mode) {
        if (ba==null) return;
        final int B=ba.getBegin(), ends[]=ba.getLineEnds();
        final byte[] T=ba.getBytes();
        final boolean emptyStrg=(mode&MAP_ALLOW_EMPTY_STRING)!=0;
        for(int iL=0; iL<ends.length; iL++) {
            final int b= iL==0?B : ends[iL-1]+1, e=ends[iL];
            if (e-b<3 || T[b]=='#') continue;
            final int col1=nthColumn(column1,separator,T,b,e);
            if (col1<0) continue;
            final int col2=nthColumn(column2,separator,T,b,e);
            if (col2<0) continue;
            final int end2=strchr(STRSTR_E,separator,T,col2,e);
            final int end1=strchr(STRSTR_E,separator,T,col1,e);
            if (col1>=0 && col2>=0 && end1>col1 && (emptyStrg && end2==col2 ||  end2>col2) ) {
                String v= ba.toString(col2,end2, mode&(ByteArray.STRING_TRIM|ByteArray.STRING_POOL));
                String k=ba.newString(col1,end1);
                if ((mode&MAP_RM_TERMINAL_QUOTES)!=0) {
                    v=delSfx("\"",delPfx("\"",v));  k=delSfx("\"",delPfx("\"",k));
                    if ((mode&ByteArray.STRING_TRIM)!=0) { v=v.trim();  k=k.trim();  }
                }
                if ((mode&MAP_VALUES_AS_INTERN)!=0) v=v.intern();
                map.put(k, v);
            }
        }
    }
    /* <<< HashMaps <<< */
    /* ---------------------------------------- */
    /* >>> toString >>> */
    public static String[] intrn(String ss[]) {
        if (ss!=null)   for(int i=ss.length; --i>=0;) ss[i]=ss[i]!=null?ss[i].intern() : null;
        return ss;
    }
    public static String toStrgIntrn(Object o) { final String s=toStrg(o); return s!=null ? s.intern() : null;}
    public static String toStrgTrim(final Object o) {
        final String s=toStrg(o);
        return s!=null ? s.trim() : null;
    }
    public static String toStrg(final Object s) {
        assert !(s instanceof CharSequence[]);
        if (s==null) return null;
        if (s instanceof File && !(s instanceof ChFile)) { /* --- In Javaws5 s instanceof File ? ((File)s).getAbsolutePath() : (java.util.PropertyPermission user.dir read) --- */
            try{
                return ((File)s).getCanonicalPath();
            } catch(Exception e) { return ((File)s).getAbsolutePath(); }
        }
        final String str=
            s instanceof byte[] ? bytes2strg((byte[])s,0,MAX_INT) :
            s instanceof String ? (String)s :
            s.toString();
        return "".equals(str) ? "" : str;
    }
    public static String toStrg(final int i) { return String.valueOf(i); }
    public static String[] toStrgs(CharSequence[] ss) {
        if (ss==null) return null;
        if (ss instanceof String[]) return (String[])ss;
        final String st[]=new String[ss.length];
        for(int i=0;i<ss.length;i++) st[i]=toStrg(ss[i]);
        return st;
    }
    private static String[] strgLen1;
    public static String[] getStringsLenght1() {
        if (strgLen1==null) {
            strgLen1=new String[256];
            for(int i=256; --i>=0;)  strgLen1[i]=String.valueOf((char)i);
        }
        return strgLen1;
    }
    public static String toStrg(Object o, int from, int to) {
        if (o instanceof ByteArray) return ((ByteArray)o).newString(from,to);
        final byte bb[]=o instanceof byte[] ? (byte[])o : null;
        final String s=bb!=null ? null : toStrg(o);
        if (bb==null && s==null) return "";
        final int L=bb!=null ? bb.length : s.length();
        if (from>=L || from>=to) return "";
        final int f=from>=0?from:0, t=to<L?to:L;
        return bb!=null ? bytes2strg(bb,f, t) : s.substring(f,t);
    }

    private final static String _c2s[]=new String[256];
    public static String toStrg(char c) {
        if (c>255) return String.valueOf(c);
        if (_c2s[c]==null) _c2s[c]=String.valueOf(c);
        return _c2s[c];
    }

    private static Reference<char[]> refB2S;
    private final static Object syncB2S=new Object();
    public final static String bytes2strg(byte[] bb) { return bytes2strg(bb,0,MAX_INT); }
    public final static String bytes2strg(byte[] bb, int from, int to) {
        final int t=mini(bb!=null ? bb.length:0,to), f=maxi(0,from), N=t-f;
        if (N<=0) return "";
        synchronized(syncB2S) {
            char cc[]=refB2S!=null?refB2S.get() : null;
            if (cc==null || cc.length<N) refB2S=new SoftReference(cc=new char[N]);
            for(int i=N; --i>=0; ) {
                final byte b=bb[i+f];
                cc[i]=(char)(b<0?256+b:b);
            }
            return new String(cc,0, N);
        }
    }

    public static byte[] chars2bytes(char cc[]) {
        if (cc==null || cc.length==0) return NO_BYTE;
        final byte bb[]=new byte[cc.length];
        for(int i=cc.length; --i>=0;) bb[i]=(byte)cc[i];
        return bb;
    }

    public static byte[] strg2bytes(String s) { return strg2bytes(s, (byte[])null);}
    public static byte[] strg2bytes(String s, byte buf[]) {
        if (s==null) return null;
        final int N=s!=null?s.length() : 0;
        if (N==0) return NO_BYTE;
        synchronized(syncB2S) {
            char cc[]=refB2S!=null?refB2S.get() : null;
            if (cc==null || cc.length<N) refB2S=new SoftReference(cc=new char[N]);
            s.getChars(0,N,cc,0);
            final byte bb[]=buf!=null && buf.length>=N ? buf : new byte[N];
            for(int i=N; --i>=0;) bb[i]=(byte)cc[i];
            return bb;
        }

    }

    /*
      http://forums.sun.com/thread.jspa?forumID=256&threadID=265010
      Hashtable HashMap
      Length 13: 463ns instead of 1094   ( or 911  Java6 )
      Length 58: 465ns instead of 1598   ( or 1211  Java6 )
    */
    public static int sPoolCountRecycled, sPoolCountNotRecycled;
    private static String[] sPoolIP, sPoolP;
    public static String toStrgIP(byte[] bb, int from, int to) {
        if (sPoolIP==null) sPoolIP=new String[256*256];
        return toStrg_(bb,from,to,sPoolIP);
    }
    public static String toStrgP(byte[] bb, int from, int to) {
        if (sPoolP==null) sPoolP=new String[256*256];
        return toStrg_(bb,from,to,sPoolP);
    }
    private static String toStrg_(byte[] bb, int from, int to, final String sPool[]) {
        if (from>=bb.length || from>=to) return "";
        final int f=from>=0?from:0, t=to<bb.length ? to : bb.length;
        final int hashCd=hashCd(bb,f,t,false);
        final String s=sPool[hashCd&0xffff];
        if (s!=null && s.length()==t-f && s.hashCode()==hashCd && equls(s,bb,f)) { sPoolCountRecycled++; return s; }
        sPoolCountNotRecycled++;
        return sPool[hashCd&0xffff]= sPool==sPoolIP ? bytes2strg(bb,f,t).intern() : bytes2strg(bb,f,t);
    }
    /* <<< toString <<< */
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    private static Reference<int[]> refRGB;
    public static int[] sharedRGB(int n) {
        int[] ii=refRGB!=null ? refRGB.get():null;
        if (ii==null||ii.length<n )  refRGB=new SoftReference(ii=new int[n]);
        return ii;
    }

    public static void looksLikeDivider(Component c,Graphics g,int x0,int y0,int dx,int dy) {
        if (g==null) g=c.getGraphics();
        g.setColor(C(0x8080ff,64));
        g.fillRect(x0,y0,dx,dy);
        for(int y=y0; y<y0+dy; y+=3) {
            for(int x=x0-y%3; x<x0+dx; x+=3) {
                g.setColor(Color.BLUE); g.fillRect(x,y,1,1);
                g.setColor(Color.WHITE);g.fillRect(x,y+1,1,1);
            }
        }
    }
    public static void mouseOverPrintMsg(Component c, String ss[], Component target, int x, int y,Font f) {
        final Object para[]=new Object[]{ss,intObjct(x),intObjct(y), weakRef(target),f};
        if (c==null || ss==null) pcp(instance(MOLI_OVER_PRINT),null,c);
        else {
            addMomoli(MOLI_OVER_PRINT,c);
            pcp(instance(MOLI_OVER_PRINT),para,c);
        }
    }
    private static Stroke STROKE[][];
    public static Stroke dashedStroke(int type) {
        if (STROKE==null) STROKE=new Stroke[][]{new Stroke[12],new Stroke[3]};
        final Stroke[] S=STROKE[type];
        int nStroke=S.length, iStroke=(int) ((currentTimeMillis()>>8)%nStroke);
        Stroke s=S[iStroke];
        if (s==null) s=S[iStroke]=new BasicStroke(1f,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND,1f,new float[]{nStroke/3f,nStroke-nStroke/3f},iStroke);
        return s;
    }
    public static Thread thread_drawMsg(String txt, JComponent c) {
        final Object[] para={txt,c};
        return threadM("drawMsg",ChUtils.class,para);
    }

    public static void drawMsg(String msg0, Component c) {
        if (c!=null) {
            final String msg;
            final int y;
            if (chrAt(0,msg0)=='@') {
                final int charH=charH(c)+1;
                y=(charH+1)*atoi(msg0,1);
                msg=substrg(msg0,nxt(NO_DIGT,msg0,1),MAX_INT);
            } else {
                msg=msg0;
                y=0;
            }
            if (sze(msg)==0) c.repaint(0,y,9999,EX);
            else drawMsg(splitLnes(SPLIT_ALLOW_EMPTY_TOKENS, msg),c,null,y);
        }
    }

    public static void drawMsg(Object[] msgs, Component c, Graphics g0, int y0) {
        if (c==null) return;
        if (sze(msgs)==0) {
            c.repaint();
            return;
        }
        try {
            final Graphics g=g0!=null ? g0:c.getGraphics();
            if (g!=null) {
                Color fg=null, bg=null;
                final int charH=charH(g)+1, charA=charA(g);
                int row=0;
                for(Object oMsg : msgs) {
                    if (oMsg instanceof Color) {
                        bg=(Color)oMsg;
                        continue;
                    } else  if (oMsg instanceof String) {
                        final String msg=(String)oMsg;
                        String txt=msg;
                        if (txt.indexOf('\u001B')>=0)  {
                            final ByteArray ba=new ByteArray(txt);
                            final long[] escape=ba.getAnsiEscapes();
                            final int escapeL=ba.countAnsiEscapes();
                            final AnsiEscape attr=new AnsiEscape();
                            for(int i=0;i<escapeL;i++) AnsiEscape.inferIntoAttribute(escape[i],attr);
                            txt=ba.newString();
                            fg=attr.fg();
                            bg=attr.bg();
                        }
                        if (fg==null) fg=Color.BLACK;
                        if (bg==null) bg=c.getBackground();
                        if (bg==null) bg=Color.WHITE;
                        final String key="CU$$W"+row;
                        final int w=strgWidth(g,txt)+EM, y=y0+row*charH;
                        g.setColor(bg);
                        g.fillRect(0,y, maxi(w,atoi(gcp(key,c))),charH);
                        g.setColor(fg);
                        g.drawString(txt, 0,charA+y);
                        pcp(key,intObjct(w),c);
                        row++;
                    }
                }
            }
        } catch(Exception ex) {}
    }
    /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> Hooks >>> */
    private static Map<Object,Map> _mapForService=new HashMap();
    public static List listServices(boolean create, Object o, Class clazz) {
        if (o==null || clazz==null) return null;
        Map<Object,List<Reference>> m=_mapForService.get(clazz);
        if (m==null) _mapForService.put(clazz,m=new WeakHashMap());
        List v=m.get(o);
        if (create && v==null)  m.put(o, v=new ArrayList());
        rmNull(v);
        return v;
    }
    public static void rmService(Object li, Object o, Class clazz) {
        final List v=li==null?null:listServices(false,o,clazz);
        if (v!=null) v.remove(weakRef(li));
    }

    public static void addService(Object li, Object o, Class clazz) {
        adUniq(weakRef(li), listServices(true,o,clazz));
    }

    private final static Object KEY_pe=new Object(), KEY_ps=new Object();
    public static void setProcessEvt(ChProcessEvent pe, JComponent c) { pcp(KEY_pe,pe,c); }
    public static boolean processEvt(JComponent c, AWTEvent ev) {
        if (c==null||ev==null||gcp(KEY_DISABLE_EVENTS,c)!=null) return false;
        final ChProcessEvent pe=(ChProcessEvent)gcp(KEY_pe,c);
        return pe==null || null!=pe.processEvent(c,ev);
    }

    public static void setPrefSize(PreferredSize ps, Object o) { pcp(KEY_ps, ps, o); }
    public static Dimension getPrefSize(JComponent c) {
        if (c==null) return null;
        if (!Insecure.EXEC_ALLOWED && gcp(KEY_HIDE_IF_EXEC_FORBIDDEN,c)!=null) return dim(0,0);
        if (CollapseComponent.isCollapsed(c)) return dim(0,0);
        final Object toggl=gcp(KEY_TOGGLE_COLLAPSE[0],c);
        if (toggl!=null && !isSelctd(toggl) || isSelctd(gcp(KEY_TOGGLE_COLLAPSE[1],c))) return dim(0,0);
        if (UserProfile.isHidden(c) && gcp(UserProfile.KEY_IGNORE,c)==null) return dim(0,0);
        Dimension d=!c.isEnabled() ? gcp(KEY_PREF_SIZE_IF_DISABLED,c,Dimension.class) : null;
        if (d==null) d=gcp(KEY_PREF_SIZE,c,Dimension.class);
        if (d!=null) return d;
        final PreferredSize ps=(PreferredSize)gcp(KEY_ps, c);
        return ps!=null ? ps.getPreferredSize(c) : null;
    }

    public static int getPrefHeight(Object c) {
        final Dimension d=c instanceof JComponent ? ((JComponent)c).getPreferredSize() : null;
        return d==null ? 0 : d.height;
    }
    public static JComponent addPaintHook(PaintHook hook, JComponent o) { addService(hook,o,PaintHook.class); return o; }
    public static Object addActLi(ActionListener li, Object o) { addService(li,o, ActionListener.class); return o; }
    public static JComponent addTooltip(TooltipProvider tip, JComponent o) {addService(tip,o,TooltipProvider.class); return  rtt(o); }

    public static void handleEvt(Object hasListeners, AWTEvent ev) {
        List v=listServices(false,hasListeners,ActionListener.class);
        if (v==null && hasListeners instanceof List) v=(List)hasListeners;
        if (sze(v)>0) {
            final Object arg=new Object[]{v,ev};
            if (isEDT()) instance(0).run("EVENT",arg);
            else ChDelay.invokeAndWait(instance(0),"EVENT",arg);
        }
    }
    public static void handleActEvt(Object hasListeners, String cmd, int modifiers) {
        final List v=listServices(false,hasListeners,ActionListener.class);
        if (sze(v)>0) {
            final Object source=gcp(KEY_EVENT_SOURCE,hasListeners);
            handleEvt(hasListeners, new ActionEvent(source!=null ? source : hasListeners,ActionEvent.ACTION_PERFORMED,cmd,modifiers));
        }
    }
    public static boolean paintHooks(JComponent hasPaintHook, Graphics g, boolean after) {
        final JScrollBar sb=gcp(KEY_NO_PAINT_IF_ADJUSTING,hasPaintHook, JScrollBar.class);
        if (sb!=null && sb.getValueIsAdjusting()) return false;
        final List v=listServices(false, hasPaintHook,PaintHook.class);
        boolean ret=true;
        final int L=sze(v);
        for(int i=0; i<L; i++) {
            final PaintHook h=get(i,v,PaintHook.class);
            if (h!=null && !h.paintHook(hasPaintHook, g,after)) ret=false;
        }
        if (after) ChRenderer.drawSmallButtons(hasPaintHook,g);
        return ret;
    }

    public static String ballonMsg(Object object, AWTEvent ev) {
        final StringBuffer sb=appendTooltips(object,ev,null);
        if (sb!=null) return sb.toString();
        String tip=TabItemTipIcon.tip(objectAt(ev));
        if (tip==null) tip=TabItemTipIcon.tip(object);
        return tip;
    }

    public static StringBuffer appendTooltips(Object hasToolTips, AWTEvent ev, StringBuffer sb0) {
        StringBuffer sb=sb0;
        final List v= listServices(false, hasToolTips,TooltipProvider.class);
        int count=0;
        final int L=sze(v);
        for(int i=0; i<L; i++) {
            final TooltipProvider t=get(i,v,  TooltipProvider.class);
            final String s=t!=null && hasToolTips instanceof JComponent ? t.getToolTipText((JComponent)hasToolTips,ev) : null;
            if (sze(s)>0) (sb==null ? sb=strBuf(SB_TIP_PROVIDER) : sb).append(count++>0 ? "<br>" :"").append(s);
        }
        return sb;
    }

    /*    public static void addRunIfModiHook(Runnable hook, Class o) {  addService(hook,o, HasModiCount.class); }
    public static void runUpdateHooks(Object hasServices) {
        final List v=listServices(false, hasServices,ActionListener.class);
        final int L=sze(v);
        for(int i=0; i<L; i++) {
            final Object o=v.get(i);
            final Runnable r=deref(v, Runnable.class);
            if (r!=null) r.run();
        }
    }
    */
    /* <<< Hooks <<< */
    /* ---------------------------------------- */
    /* >>> 3D >>> */
    public static int charsTo32bit(int c0,int c1,int c2,int c3) { return c0+(c1<<8)+(c2<<16)+(c3<<24);}
    public static int charsTo32bit(byte T[], int i) {  return T[i+0]+(T[i+1]<<8)+(T[i+2]<<16)+(T[i+3]<<24);}
    public static String pdbID(String s) {
        return withoutLastComponent(withoutLastComponent(withoutLastComponent(delPfx("pdb",delPfx("PDB:",delSfx("__",s))),':'),'_'),'.');
    }
    public static char pdbChain(String s) {
        if (sze(s)<LENGTH_PDBIDS) return 0;
        final int start=(s.charAt(0)|32)!='p'||(s.charAt(1)|32)!='d'||(s.charAt(2)|32)!='b' ? 0 : s.charAt(3)==':' ?4 : 3;
        final char colon=chrAt(start+LENGTH_PDBIDS,s);
        final char chain= colon==':' || colon=='_' ? chrAt(start+(LENGTH_PDBIDS+1), s) : 0;
        return is(LETTR_DIGT,chain) ? chain : (char) 0;
    }

    private static byte[] pdbModels;
    private static boolean isPdbModel(String id4) {
        if (pdbModels==null) {
            final ByteArray ba=readBytes(ChUtils.class.getResourceAsStream("PDBmodels.rsc"));
            pdbModels= ba==null ?  NO_BYTE : ByteArray.trimSize(ba);
        }
        return strstr(STRSTR_IC,id4,pdbModels)>=0;
    }
    public static String urlForPDB(String id0) {
        final String id=pdbID(id0);
        for(String mask : getCustomSettings(Customize.pdbSite)) {
            if (sze(mask)>0 && !mask.startsWith("\\\\")) {
                final String url=urlForPdbMask(id,mask);
                final File f=file(url);
                if (sze(f)>0) return url;
            }
        }
        final String mask= isPdbModel(id) ?
            "ftp://ftp.wwpdb.org/pub/pdb/data/structures/models/current/pdb/??/pdb????.ent.gz" :
            choseFastestPDBServer(getCustomSettings(Customize.pdbSite));
        return urlForPdbMask(id,mask!=null ? mask : "http://www.rcsb.org/pdb/files/????.pdb.gz");
    }
    private static String urlForPdbMask(String pdbId,final String mask) {
        final String id=pdbID(pdbId);
        return id!=null && mask!=null ? rplcToStrg("??",id.substring(1,3),rplcToStrg("????",id,mask)) : null;
    }
    public static File localPdbFile(String pdbID, char chain) {
        return pdbID!=null ? file(chain==0 ? urlForPDB(pdbID) : dirSettings()+"/pdbChains/"+pdbID.substring(1,3)+"/"+pdbID+"_"+chain+".pdb") : null;
    }
    public static File downloadPdbChain(String pdbId_chain,  char chain) {
        final String id=pdbID(pdbId_chain);
        File f=localPdbFile(id,chain);
        if (sze(f)==0 && id!=null) {
            downloadAllPdbChains(id);
            f=localPdbFile(id,chain);
        }
        return f;
    }
    private final static Map<String,File[]> mapSingleChain=new HashMap();
    public static File[] downloadAllPdbChains(String id4) {
        File f=file(urlForPDB(id4));
        if (sze(f)==0) {
            if(fastestPDBserver==null) sayDownloading(null,"@0 Obtaining fastest PDB-repository");
            f=download_TS(url( urlForPDB(id4)),999);
        }
        if (sze(f)==0) f=download_TS(url("http://www.rcsb.org/pdb/files/"+id4+".pdb.gz"), 999);
        final File dir=file(dirSettings()+"/pdbChains/"+id4.substring(1,3));
        if (!dir.exists()) {
            deleteTree(file(dirWeb()+"/pdbChains/"));
            mkdrs(dir);
        }
        File ff[];
        synchronized(SYNC_CPY) {
            ff=alreadyExtractedChains(dir,id4);
            if (ff.length==0 && sze(f)>0) {
                for(File fChain : new PDB_separateChains().processFile((ByteArray)null, f,false)) {
                    final String n=fChain.getName();
                    final int us=n.indexOf('_');
                    if (us>0) renamFile(fChain, localPdbFile(id4, chrAt(us+1,n)));
                }
            }
            ff=mapSingleChain.get(id4);
        }
        if (ff==null)  mapSingleChain.put(id4,ff=alreadyExtractedChains(dir,id4));
        return ff;
    }
    private static File[] alreadyExtractedChains(File dir, String id4) {
        File[] v=null;
        int count=0;
        final String[] files=dir.list();
        if (files!=null) {
            sortArry(files);
            for(int i=0; i<files.length; i++) {
                if (files[i].startsWith(id4)) {
                    (v==null?v=new File[files.length-i] : v)[count++]=file(dir+"/"+files[i]);
                }
            }
        }
        return chSze(v,count,File.class);
    }
    private final static Map<String,int[]> mapServerResponseTime=new HashMap();
    private static int getServerResponseTime(String url, boolean testOnlyHost, boolean saveOnlyForHost) {
        if (!looks(LIKE_EXTURL,url)) return MAX_INT;
        synchronized(mapServerResponseTime) {
            int[] time=mapServerResponseTime.get(url);
            if (time==null) {
                final int slash=url.indexOf('/',8);
                String base=slash>0 ? url.substring(0,slash+1) : url;
                time=mapServerResponseTime.get(base);
                if (time==null) {
                    time=new int[]{-1};
                    mapServerResponseTime.put(base,time);
                    ChDelay.newThread(instance(0),"getServerResponseTime",new Object[]{testOnlyHost?base:url,time}).start();
                }
                if (!saveOnlyForHost) mapServerResponseTime.put(url,time);
            }
            return time[0];
        }
    }
    private static String fastestPDBserver;
    private static String choseFastestPDBServer(String[] urls) {
        synchronized(SYNC_FASTEST_P) {
            if (fastestPDBserver==null) {
                String best=null;
            loop:
                while(true) {
                    for(String s : urls) {
                        final String u=urlForPdbMask("3rec",s);
                        if (u==null) continue;
                        int time=getServerResponseTime(u,false,false);
                        if (time!=MAX_INT && time>=0) {
                            best=s;
                            break loop;
                        }
                    }
                    sleep(222);
                    sayDownloading(null, "@0 Looking for closest PDB mirror");
                }
                fastestPDBserver=best;
                sayDownloading(null, "@0 Closest PDB mirror "+best);
            }
        }
        return fastestPDBserver;
    }
    public static float squareDistance(float x, float y, float z,  float[] xyz, int fromIdx, int toIdx) {
        final int to3=mini(toIdx*3,xyz.length);
        float distance=Float.MAX_VALUE;
        for(int i= 3*(0<fromIdx?fromIdx:0);  i<to3; i+=3) {
            final float dx=xyz[i]-x, dy=xyz[i+1]-y, dz=xyz[i+2]-z,  d=dx*dx + dy*dy + dz*dz;
            if (distance>d) distance=d;
        }
        return distance;
    }
    /* <<< 3D <<< */
    /* ---------------------------------------- */
    /* >>> Databases >>> */
    public static String guessProteinDbFromId(final String id) { return guessProteinDbFromId(id,false);}
    public static String guessProteinDbFromId(final String id, boolean onlyNT) {
        final int L=id==null ? 0 : id.length();
        if (L==0) return "";
        final char c0=id.charAt(0);
        final boolean d1= cntainsOnly(DIGT, id,1, MAX_INT);
        final boolean ud= cntainsOnly(UPPR_DIGT, id);
        final boolean u0=is(UPPR,c0);
        return
            id.indexOf(':')>=0 ? "" :
            L==6 && c0=='C' && d1 ? "KEGGc:" :
            L==6 && c0=='R' && d1 ? "KEGGr:" :
            ud && u0 && L==6 ?  (onlyNT ?  "EMBL:" : "UNIPROT:") :
            ud && L==11  && c0=='I' && id.startsWith("IPI") ? "IPI:" :      // IPI00000021
            ud && L==13  && c0=='U' && id.startsWith("UPI") ? "UNIPARC:" :  // UPI00000017EA
            ud && L==15  && c0=='E' && id.startsWith("ENSP")&& cntainsOnly(DIGT,id,4,15) ? "ENSEMBL:" : //  ENSP00000329399
            "";
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Cache >>> */
    private static ChButton cbCache;
    public static AbstractButton cbCache(){
        if (cbCache==null) cbCache=toggl("Use cached results").s(true).li(listener(0)).tt("The results of computationally expensive calculations are stored on hard disk.");
        return cbCache.cb();
    }
    public static void cpyIfDiffers(File src,File dst) {
        if (sze(src)!=0 && dst!=null && (dst.length()==0 || !fileEquls(src,dst))) cpy(src,dst);
    }
    public static boolean fileEquls(File f, ByteArray ba) {
        if (f==null || ba==null) return false;
        final int B=ba.getBegin(), E=ba.getEnd();
        if (f.length()!=E-B) return false;
        InputStream is=null;
        final byte[] buf=new byte[4096], T=ba.getBytes();
        try {
            try {
                int pos=B;
                is=new BufferedInputStream(new FileInputStream(f));
                while(true) {
                    final int n=is.read(buf,0, 4096);
                    if (n==0) sleep(111);
                    if (n<0) break;
                    assert n<=T.length-pos;
                    for(int i=mini(n,T.length-pos);--i>=0;) if (buf[i]!=T[i+pos]) return false;
                    pos+=n;
                }
            } catch(IOException ex) {stckTrc(ex);  return false;}
            return true;
        } finally { closeStrm(is); }
    }
    public static boolean fileEquls(File f1,File f2) {
        final long L1=f1.length(), L2=f2.length();
        if (L1!=L2)return false;
        InputStream is1=null, is2=null;
        final byte buf1[]=new byte[4096], buf2[]=new byte[4096];
        try {
            try {
                is1=new BufferedInputStream(new FileInputStream(f1));
                is2=new BufferedInputStream(new FileInputStream(f2));
                while(true) {
                    final int n=maxi(1,mini(4096, is1.available(), is2.available()));
                    final int n1=is1.read(buf1,0,n), n2=is2.read(buf2,0,n);
                    if (n1==0) sleep(111);
                    assert n1==n2;
                    if (n1<0) break;
                    for(int i=n1;--i>=0;) if (buf1[i]!=buf2[i]) return false;
                }
            } catch(IOException ex) {stckTrc(ex);  return false;}
            return true;
        } finally { closeStrm(is1); closeStrm(is2); }
    }
    /* <<< Cache <<< */
    /* ---------------------------------------- */
    /* >>> marchingAnts >>> */
    private static Map<JComponent,Object[][]> mapMarchingAnts[]=new WeakHashMap[2];
    public final static int ANTS_SEARCH=0, ANTS_PROTECT_ALIG=1;
    private  static Thread threadMarchingAnt;
    public static void setMarchingAnt(int id,JComponent jc, Shape r, Color fg,Color bg) {
        addMarchingAnt(id,jc,null, fg,bg);
        Map<JComponent,Object[][]> m=mapMarchingAnts[id];
        if (m!=null && jc!=null) m.put(jc,null);
        addMarchingAnt(id,jc,r  ,fg,bg);
    }
    public static void addMarchingAnt(int id, Object refJc, Shape r, Color fg,Color bg) {
        final JComponent jc=deref(refJc,JComponent.class);
        if (jc==null) return;
        Map<JComponent,Object[][]> m=mapMarchingAnts[id];
        if (m==null) m=mapMarchingAnts[id]=new WeakHashMap();
        final Object[][] lastRR=m.get(jc);
        if (r==null) {
            if (lastRR!=null) {
                for(Object[] o : lastRR) {
                    if (o==null) continue;
                    final Rectangle b=((Shape)o[0]).getBounds();
                    jc.repaint(b.x-1, b.y-1, b.width+2, b.height+2);
                }
            }
            m.put(jc, null);
        } else {
            if (threadMarchingAnt==null) {
                threadMarchingAnt=ChDelay.newThread(instance(0),"MARCHING_ANT", null);
                ChThread.callEvery(333, threadMarchingAnt, "MARCHING_ANT",EDT);
            }
            m.put(jc, ad(new Object[]{r,fg,bg}, lastRR, 10, Object[].class));
        }
    }
    private static void marchingAnts() {
        final Stroke dashedStroke0=dashedStroke(0);
        try {
            for(Map<JComponent,Object[][]> m : mapMarchingAnts) {
                if (m!=null) {
                    for(Map.Entry<JComponent,Object[][]> e: entryArry(m)) {
                        final JComponent jc=e.getKey();
                        if (!jc.isShowing()) continue;
                        final Object[][] vvv=e.getValue();
                        if (vvv==null) continue;
                        for(Object[] vv : vvv) {
                            if (vv==null) continue;
                            final Shape r=(Shape)vv[0];
                            final Color fg=(Color)vv[1], bg=(Color)vv[2];
                            final Graphics2D g=(Graphics2D)jc.getGraphics();
                            if (g==null) continue;
                            g.translate(BUGFIX_OPENJDK_G2,BUGFIX_OPENJDK_G2);
                            final Object scale=gcp(KEY_SCALE_FACTOR,jc);
                            final java.awt.geom.AffineTransform transform0=scale!=null ? g.getTransform() : null;
                            if (scale!=null) {final double s=atof(scale); g.scale(s,s);}
                            final Stroke stroke0=g.getStroke();
                            g.setColor(jc.getBackground());
                            g.translate(1,1); g.draw(r);
                            g.translate(-2,-2); g.draw(r);
                            g.translate(1,1);
                            for(boolean isDashed:FALSE_TRUE) {
                                g.setColor(isDashed ? fg : bg);
                                g.setStroke(isDashed ? dashedStroke0 : stroke0);
                                g.draw(r);
                            }
                            g.setStroke(stroke0);
                            if (transform0!=null) g.setTransform(transform0);
                            g.translate(-BUGFIX_OPENJDK_G2,-BUGFIX_OPENJDK_G2);
                        }
                    }
                }
            }
        } catch(Throwable ex) {stckTrc(ex);}
    }
    /* <<< mapMarchingAnts <<< */
    /* ---------------------------------------- */
    /* >>> Utils >>> */
    private static ChButton togDesktopUtils;
    public static ChButton togDesktopUtils() {
        if (togDesktopUtils==null) togDesktopUtils=toggl("Create folder  \""+dirDesktopUtils().getName()+"\" on the Desktop").save(ChUtils.class,"DesktopUtils");
        return togDesktopUtils;
    }
    /* <<< Utils <<< */
    /* ---------------------------------------- */
    /* >>> Bugs workaround >>> */
    private final static Rectangle RECT_FILL=new Rectangle();
    public final static void fillBigRect(Graphics g, int x0, int y0, int w, int h) {
        if (g==null) return;
        if ((w>0x7fff || h>0x7fff || x0+w>0x7fff || y0+h>0x7fff) && g instanceof Graphics2D) {
            RECT_FILL.x=x0;
            RECT_FILL.x=y0;
            RECT_FILL.width=w;
            RECT_FILL.height=h;
            ((Graphics2D)g).fill(RECT_FILL);
        } else g.fillRect(x0,y0,w,h);
    }

}
