package charite.christo;
import charite.christo.interfaces.*;
import javax.swing.*;
import java.io.File;
import java.util.Vector;
import java.awt.event.*;
import java.lang.ref.*;
import static charite.christo.ChUtils.*;
/**
   @author Christoph Gille
*/
public abstract class AbstractInteractiveFileProcessor implements ActionListener  {
    private final Vector vector=new Vector();
    private final JList jList=new JList(vector);
    private ChFrame frame;
    private File[] ffCreated={};
    public File[] getCreatedFiles() { return ffCreated;}
    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev==null ? "A":ev.getActionCommand();
        if (cmd=="APPLY" || cmd=="A") {
            final Object oo[]=cmd=="APPLY" ? jList.getSelectedValues() : vector.toArray();
            if (sze(oo)==0) error("You must select files");
            else {
                for(Object o: oo) {
                    final String s=o.toString();
                    final File f=file(delFromChar(s,' '));
                    if (sze(f)==0) debug("error  in AbstractInteractiveFileProcessor: f=null");
                    ffCreated=processFile(null,f,true);
                }
                handleActEvt(this,"CREATED",0);
                new ChFrame(shrtClasNam(this)).ad(scrllpn(0L,new ChJList(ffCreated,ChJList.OPTIONS_FILES))).shw(ChFrame.AT_CLICK);
            }
        }
    }

    public void interactiveProcess(File ...ff) {
        vector.clear();
        for(File f:ff){
            if (f==null) continue;
            final ByteArray ba=readAndDecompress(f,(ByteArray)null);
            final Object fileEntry=fileEntry(ba,f);
            if (fileEntry!=null) vector.add(fileEntry);
        }
        if (sze(vector)==0) error(errorNonSelected);
        else if (sze(vector)==1) actionPerformed(null);
        else {
            if (frame==null) {
                ChButton butHelp=hasHelp(getClass()) ? smallHelpBut(getClass()) : null;
                ChButton butApply=new ChButton("APPLY").t("Process selected files").li(this);
                frame=new ChFrame("").ad(newCNSEW(new JScrollPane(jList),textNorth,pnl(butApply,butHelp),null,null));
            }
            jList.repaint();
            jList.setSelectedIndex(0);
            frame.shw(0);
        }
    }

    public abstract String fileEntry(ByteArray byteArray,File f);
    public void setTextNorth(String s) { textNorth=s;}
    private String textNorth,errorNonSelected;
    public void setErrorNonSelected(String s) { errorNonSelected=s;}
    public abstract File[] processFile(ByteArray byteArray,File file,boolean overwrite);
}
