package charite.christo;
import charite.christo.interfaces.*;
import java.net.URL;
import java.io.File;
import java.io.InputStream;
import static charite.christo.ChUtils.*;
/**HELP
The standard Java way to fetch files from the Internet fails for some FTP-addresses.
These problems are solved with  http://www.enterprisedt.com/products/edtftpj/.
<br>
<b>License of edtFTPj/Free:</b>  WIKI:LGPL
*/
public class AnonymousFTPPROXY extends AbstractProxy {
    @Override public String getRequiredJars() { return jarFile(EDTFTPJ);}
    public boolean download(URL url, File f, ChRunnable log) {
        ChRunnable i=(ChRunnable)proxyObject();
        final boolean success;
        if (i==null) success=false;
        else {
            final boolean[] bb={false};
            i.run(null, new Object[]{url,f,log, bb});
            success=bb[0];
        }
        if (!success) {
            try {
                if (log!=null) log.run(ChRunnable.APPEND,"AnonymousFTPPROXY: going to use Java API since  edtftpj failed\n");
                InputStream is=url.openStream();
                if (f==null) { closeStrm(is); return is!=null;}
                cpy(is,f);
            } catch(Exception e){ if (log!=null) log.run(ChRunnable.APPEND, new Object[]{C(0xFF0000),e,C(0xFFffFF),"\n"}); return false;}
        }
        return f==null || f.length()>0;
    }
}

// http://www.nsftools.com/tips/JavaFtp.htm
