package charite.christo;
import charite.christo.interfaces.*;
import java.io.*;
import java.util.*;

import java.awt.event.*;
import javax.swing.*;

import java.awt.*;
import java.lang.ref.*;
import java.util.zip.*;
import java.util.List;
import static charite.christo.ChUtils.*;
import static java.awt.Color.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
import static java.awt.event.KeyEvent.*;
import static charite.christo.ChTextComponents.Highlight;
public class AsciiView extends ChPanel implements ChRunnable {
    public final static String KEY_BLAST_RESULT="KB$$B";
    private final static int LINE_NUM_WIDTH=7;
    private File file;
    private boolean lineNumbers;
    private ByteArray byteArray;
    private long byteArray_mc;
    private int modiCount;
    public File getFile() { return file;}
    public void setFile(File f) { file=f; byteArray=null; refText=null; ChDelay.repaint(this,333); }
    private int setText_byteArray_mc=0;
    public void setText(CharSequence cs) {

        final ByteArray baOld=byteArray, ba=byteArray=toByteArray(cs);
        if (ba==null) {
            return;
        }
        final int mc=byteArray.getModificationCount();
        if (baOld==null || baOld!=ba || setText_byteArray_mc!=mc) {

            maxLineWidth=0;
            setText_byteArray_mc=mc;
            file=null;
            ChDelay.revalidate(this,222);
            ChDelay.repaint(this,333);
            modiCount++;
        }
    }
    private Reference<ByteArray> refText;
    private ChTextComponents tools_;
    public ChTextComponents tools() { if (tools_==null) tools_=new ChTextComponents(this); return tools_;}
    private int maxLineWidth=0,lineSkip=1, posLastClicked=-1;
    private final Highlight region;
    protected Highlight region(){ return region;}

    private final int regionFromTo[]=new int[2];
    private int regionFrom, regionTo;
    public AsciiView(File f) { file=f;}
    public AsciiView(ByteArray ba) { setText(ba);}
    public AsciiView(int size) { this(new ByteArray(size));}
    {
        setAutoscr(this);
        monospc(this);
        tools().addHighlight(this.region=ChTextComponents.newHighlight(regionFromTo, C(0x0000ff,0x30),HIGHLIGHT_NOT_IN_SCROLLBAR|HIGHLIGHT_NEVER_REMOVE));

    }
    public AsciiView setLineNumbers(boolean b) { lineNumbers=b; repaint(); return this;}
    public synchronized ByteArray byteArray() {
        if (byteArray!=null) return byteArray;
        ByteArray ba=refText!=null ? refText.get() : null;
        if (ba==null) {
            refText=new SoftReference(ba=readBytes(file));
            if (ba!=null) ChTextComponents.tools(this).underlineRefs(UNDERLINE_REFS_BG);
            if (ba==null) ba=new ByteArray(NO_BYTE);
        }
        return ba;
    }
    private int gps_byteArray_mc;
    @Override public Dimension getPreferredSize() {
        final ByteArray text=byteArray();
        if (text==null) return dim(1,1);
        final File f=this.file;
        final int charW=charW(this);
        final int mc=text.getModificationCount() + (f!=null ? (int)(f.lastModified()/1024) : 0);
        final int ends[]=text.getLineEnds();
        if (maxLineWidth==0 || gps_byteArray_mc!=mc) {
            gps_byteArray_mc=mc;
            int begin=0;
            for(int i=0; i<ends.length; i++) {
                final int e=ends[i];
                if (e-begin>maxLineWidth) maxLineWidth=e-begin;
                begin=e;
            }
        }
        final int w=charW*maxLineWidth+(lineNumbers ? LINE_NUM_WIDTH*charW : 0);
        final int h=getFixedRowHeight()* ends.length;
        return dim(maxi(1,w), maxi(1,h));
    }

    private int ba_mc;
    private static AnsiEscape attributes;
    @Override public void paintComponent(Graphics g) {
        final Color background,forground;
        {
            final Color bg=getBackground(), fg=getForeground();
            forground=fg!=null ? fg : BLACK;
            background=bg!=null ? bg : WHITE;
        }
        if (attributes==null) attributes=new AnsiEscape(); else attributes.reset();
        testWheterChanged(byteArray());
        final Rectangle clip=g.getClipBounds();
        final int
            clipX1=clip!=null ? clip.x : 0,
            clipY1=clip!=null ? clip.y : 0,
            clipX2=clip!=null ? clip.x+clip.width : getWidth(),
            clipY2=clip!=null ? clip.y+clip.height: getHeight();
        g.clearRect(clipX1,clipY1,clipX2-clipX1, clipY2-clipY1);

        tools().paintHook(this,g,false);
        final String strgLen1[]=getStringsLenght1();
        final ByteArray text=byteArray();
        if (text==null) return;
        final long[] escape=text.getAnsiEscapes();
        final int escapeL=text.countAnsiEscapes();

        final byte T[]=text.getBytes();

        final int mc=text.getModificationCount()+modiCount;
        if (ba_mc!=mc) { ba_mc=mc; ChDelay.revalidate(this,222,(long[])null);}
        final int ends[]=text.getLineEnds();
        final int charH=charH(this), charW=charW(this), charA=charA(this);
        final int wLineNum=lineNumbers?charW*LINE_NUM_WIDTH : 0;
        final int firstRow=maxi(0,clipY1/(charH+lineSkip)) ,lastRow=(clipY2-1)/(charH+lineSkip)+1;
        final int firstCol=maxi(0, (clipX1-wLineNum)/charW) ,lastCol=(clipX2-1)/charW+1;
        final int maxRow=mini(ends.length, lastRow+1);
        int countPainted=0, nextEscapeI=-1, nextEscapePos=-1;
        Color fg=null, bg=null;
        for(int row=firstRow; row<maxRow; row++) {
            final int begin=row==0 ? text.getBegin(): ends[row-1]+1;
            final int y=row*(charH+lineSkip);
            final int to=mini(ends[row],begin+lastCol);
            final int from=mini(to,begin+firstCol);
            for(int i=from,  x=firstCol*charW+wLineNum; i<to; i++,x+=charW ) {
                if (i>=nextEscapePos) {
                    //putln(" pos="+i+" nextEscapePos="+nextEscapePos+ " nextEscapeI="+nextEscapeI);
                    final int j0=maxi(0,nextEscapeI);
                    nextEscapePos=nextEscapeI=MAX_INT;
                    boolean changed=false;
                    for(int j=j0; j<escapeL; j++) {
                        final long e=escape[j];
                        final int pos=(int)(e&AnsiEscape.MASK_POS);
                        if (pos<=i) {
                            AnsiEscape.inferIntoAttribute(e,attributes);
                            changed=true;
                        } else {
                            nextEscapePos=pos;
                            nextEscapeI=j;
                            break;
                        }
                    }
                    if (changed) {
                        bg=attributes.bg();
                        fg=attributes.fg();
                    }
                }
                countPainted++;
                if (bg!=background && bg!=null) {
                    g.setColor(bg);
                    g.fillRect(x,y,charW,charH);
                }
                g.setColor(fg!=null ? fg : forground);
                g.drawString(T[i]=='\t' ? "\u00bb" : strgLen1[127&T[i]],x,y+charA);
            }
            if (lineNumbers) {
                g.setColor(BLUE);
                final String s=String.valueOf(row);
                g.drawString(s,charW*(LINE_NUM_WIDTH-s.length()-1),y+charA);
            }
        }
        tools().paintHook(this,g,true);
    }

    public AsciiView showInFrame(String t) {
        return showInFrame(t,ChFrame.AT_CLICK|ChFrame.SIZE_REGARD_RESOLUTION|ChFrame.DISPOSE_ON_CLOSE|DISPOSE_ON_CtrlW);
    }

    public AsciiView showInFrame(String title0,long options) {
        final String title= title0!=null ? title0 : filepathUnixStyle(getFile());
        ChFrame.frame(title,this, options|ChFrame.SCROLLPANE|(getFile()!=null?DISPOSE_ON_CtrlW:0)).shw(options);
        return this;
    }
    public void modelToView(int iPosition, Rectangle r) {
        final ByteArray text=byteArray();
        final int[] ends=text.getLineEnds();
        for(int i=0;i<ends.length; i++) {
            if (ends[i]>iPosition) {
                final int row=i;
                final int begin=i==0 ? 0 : ends[i-1]+1;
                final int col=iPosition-begin;
                final int charW=charW(this), charH=charH(this);
                r.setBounds(col*charW, row*(lineSkip+charH), charW,charH);
                return;
            }
        }
        r.setBounds(getWidth(), getHeight(), 0,0);
    }

    public int viewToModel(int x, int y) {
        final ByteArray ba=byteArray();
        if (y<0 || ba==null) return 0;
        final int ends[]=ba.getLineEnds();
        final int row=y/maxi(1,getFixedRowHeight());
        if (row>=ends.length) return ba.getEnd();
        final int charW=charW(this);
        final int wLineNum=lineNumbers ? LINE_NUM_WIDTH*charW : 0;

        final int lineStart=row<=0 ? 0 : ends[row-1]+1;
        return mini(ends[row],lineStart+(maxi(0,x-wLineNum))/charW);
    }
    //    public Dimension getMinimumSize() {return dim(100,100);}
    private boolean testWheterChanged(ByteArray text) {
        //putln("size="+getSize());
        if (text==null) return false;
        long mc=text.getModificationCount();
        if(byteArray_mc!=mc) {
            byteArray_mc=mc;
            setText(text);
            //putln(ANSI_CYAN+" Changed"+ANSI_RESET);
            return true;
        }
        //putln(ANSI_CYAN+" SAME"+ANSI_RESET);
        return false;
    }

    @Override public void processEvent(AWTEvent ev) {
        final int id=ev.getID();
        final ByteArray text=byteArray();
        if (text==null) return;
        testWheterChanged(text);
        final int B=text.getBegin(), E=text.getEnd();
        final boolean ctrl=isCtrl(ev), shift=isShift(ev);
        final int kcode=keyCode(ev);
        final int x=x(ev), y=y(ev);
        final int pos=viewToModel(x,y);
        if (!shift && id==MOUSE_DRAGGED || id==MOUSE_CLICKED && shift) {
            if (posLastClicked>=0) regionFrom=posLastClicked;
            regionTo=pos;
            repaint();
        }
        if (id==MOUSE_PRESSED || id==MOUSE_CLICKED) {
            requestFocus();
            if (!shift) posLastClicked=pos;
        }

        if (id==KEY_PRESSED && ctrl) {
            if (kcode==VK_L)  setLineNumbers(!lineNumbers);
            if (kcode==VK_A)  { regionFrom=0; regionTo=E; repaint(); }
        }
        if ( (id==MOUSE_RELEASED || ctrl && kcode==VK_C) && text!=null) {
            int hFrom=regionFrom;
            int hTo=regionTo;
            if (hFrom>hTo) {int t=hFrom; hFrom=hTo;hTo=t;}
            if (hFrom<B) hFrom=B;
            if (hTo>E) hTo=E;
            if (hTo>hFrom) toClipbd(new String(text.getBytes(),hFrom,hTo-hFrom));
        }
        final AWTEvent newEv=tools().processEvent(this,ev);
        if (newEv!=null) super.processEvent(newEv);
        regionFromTo[0]=mini(regionFrom,regionTo);
        regionFromTo[1]=maxi(regionFrom,regionTo);
    }

    { this.enableEvents(MOUSE_EVENT_MASK|MOUSE_MOTION_EVENT_MASK|KEY_EVENT_MASK|MOUSE_WHEEL_EVENT_MASK);}

    public int getFixedRowHeight() { return charH(this)+lineSkip;}

    //     @Override public Cursor getCursor() {
    //         Cursor c=tools().getCursor();
    //         return c!=null ? c: super.getCursor();
    //     }

    public void highlightXML(ByteArray ba) {
        //final byte[] T=ba.getBytes();
        //final int E=ba.getEnd();
        //final int B=ba.getBegin();
        if (strstr("><",ba)>=0) {
            ba.replace("><FEATURE",">\n\n  <FEATURE");
            ba.replace("><TYPE ",">\n   <TYPE ");
            ba.replace("><START>",">\n   <START>");
            ba.replace("><START>",">\n   <START>");
            ba.replace("</FEATURE><","</FEATURE>\n\n  <");
        }
        final Object[][] hl={
            {"<FEATURE", RED}, {"</FEATURE", RED}, {"<TYPE", YELLOW},
            {"<START>", CYAN}, {"</START>", CYAN}, {"<END>", CYAN}, {"</END>", CYAN}
        };
        setText(ba);
        for(Object[]  o :hl) tools().highlightOccurrence((String)o[0], null,null, HIGHLIGHT_NOT_IN_SCROLLBAR, (Color)o[1]);
        tools().highlightOccurrence("<SEGMENT ", null,null, 0, PINK);
        tools().underlineRefs(UNDERLINE_REFS);
    }
    @Override public String getToolTipText(MouseEvent mev) {
        final String tt=tools().getToolTipText(mev);
        return sze(tt)>0 ? tt :  super.getToolTipText(mev);
    }

    public java.util.List getDndDateien() { return getDndFilesV(this); }

    private final static List vSplit=new ArrayList();
    public AsciiView appendS(CharSequence s) {
        final ByteArray ba=this.byteArray();
        if (s==null || ba==null) return this;
        ba.append(s);
        ChDelay.repaint(this,555);
        return this;
    }
    public AsciiView appendSS(CharSequence... ss) {
        if (sze(ss)>0) for(CharSequence s : ss) appendS(s);
        return this;
    }
    public AsciiView appendBB(byte bb[]) {
        final ByteArray ba=this.byteArray();
        if (ba!=null &&sze(bb)>0) {
            ba.append(bb);
            ChDelay.repaint(this,555);
        }
        return this;
    }
    public Object run(final String id, Object arg) {
    final Object argv[]=arg instanceof Object[] ? (Object[]) arg : null;
      if (id==ChRunnable.APPEND && arg!=null) {
        if (argv!=null) for(Object o : argv) run(id,o);
        else if (arg instanceof byte[]) appendBB((byte[])arg);
        else if (arg!=null) appendS(toStrg(arg));
      }
      return null;
    }
}
