package charite.christo;
import javax.swing.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   Opens a JColorChooser.
   @author Christoph Gille
*/
public class ButColor extends ChButton implements javax.swing.event.ChangeListener, Disposable {
    public final static String KEY_FRAME_TITLE="BuCol$$1", KEY_PAN_SOUTH="BuCol$$2";
    public final static long NO_TRANSPARENCY=1<<0, SHOW_PREVIEW_PANEL=1<<1;
  private JColorChooser colorChooser;
  private final Object colored;
  private final Color defaultColor;
  private final long options;
  public ButColor(long options, Color col, Object c) {
    this.colored=c;
    this.defaultColor=col!=null ? col:Color.MAGENTA;
    this.options=options;
    i(IC_COLOR).options(ICON_SIZE).tt("Change color");
  }

  private JSlider slider;
  private ChFrame frame;
  private ActionEvent aev;
  private boolean shown;
    public void shw() {
        if (colorChooser==null) {
            (colorChooser=new JColorChooser()).getSelectionModel().addChangeListener(this);

            if (0==(options&SHOW_PREVIEW_PANEL)) colorChooser.setPreviewPanel(new JLabel());
            if (defaultColor!=null) colorChooser.setColor(defaultColor);

            final int alpha=defaultColor!=null? defaultColor.getRGB()>>>24 : 255;

            String title=(String)gcp(KEY_FRAME_TITLE,this);
            Object panTransp=null;
            if (0==(options&NO_TRANSPARENCY)) {
              panTransp=hB("Transparency ",slider=new JSlider(0,255,alpha&255));
              slider.addChangeListener(this);
            }
            frame=new ChFrame(title!=null ? title : "color").ad(newCNSEW(colorChooser,panTransp, gcp(KEY_PAN_SOUTH,this),null,null));
        }
        frame.shw(ChFrame.AT_CLICK|ChFrame.PACK);
        shown=true;
    }
    public Color getColor() {
        final Color c=colorChooser!=null?colorChooser.getColor() : defaultColor;
        return c!=null ? C(c.getRGB()&0xFFffFF, slider!=null ? slider.getValue()&255 : 255) : defaultColor;
    }
    public void stateChanged(javax.swing.event.ChangeEvent ev) {
        final Color col=getColor();
        Container parent=getParent();
        if (parent!=null) {
            java.awt.image.ImageProducer ip=new java.awt.image.FilteredImageSource(iicon(IC_COLOR).getImage().getSource(),new ColorFilter(col));
            i(new ImageIcon(createImage(ip)));
            parent.repaint();
        }
        if (colored instanceof Colored) ((Colored)colored).setColor(col);
        if (colored instanceof ActionListener && shown) {
            if (aev==null) aev=new ActionEvent(this,ActionEvent.ACTION_PERFORMED,ACTION_COLOR_CHANGED);
            ((ActionListener)colored).actionPerformed(aev);
        }
    }
    @Override public final void r() {shw(); }
    public void dispose() {
        slider=null;
        colorChooser=null;
    }
}
