package charite.christo;
import javax.swing.*;
import java.awt.event.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.util.Map;
import java.util.HashMap;
import java.util.ArrayList;

import java.io.File;
import java.net.URL;

import static java.lang.Boolean.TRUE;
import static java.lang.Boolean.FALSE;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.Color.*;

/**
   the extended button class
   @author Christoph Gille
*/
public class ChButton extends JButton implements HasRendererComponent,ActionListener,Runnable,ChRunnable, HasModiCount {
    public final static long CROSSING_OUT=1<<1, SHOW_HIDE=1<<2, NO_FILL=1<<3, NO_BORDER=1<<4, NO_MARGIN=1<<5,ICON_SIZE=1<<6,
        NOT_OPAQUE=1<<7, PAINT_IN_TABLE=1<<8, DISABLED=1<<9, HEIGHT_I=1<<10, UNDOCKABLE=1<<11, HIDE_IF_DISABLED=1<<12;
    final Map MAPCP=new HashMap();
    public final static String MAXIMIZE="CHT$$M", GO="CB$$1",
        MSG_SHOW_ALL_PREVIOUS="Show all previous info  messages";

    private boolean  contains, handleEvt=true;
    private final char type;
    private int mouseX, mouseY,  modifiers, height=-1, modiCount;
    public final static JButton BUTTON_GO=new JButton("<html><body><b> GO </b></body></html>");
    static {
        BUTTON_GO.setForeground(C(0x007c00));
        Font f=BUTTON_GO.getFont();
        BUTTON_GO.setFont(new Font(f.getName(),Font.BOLD,f.getSize()+2));
        BUTTON_GO.setPreferredSize(dim(32,32));
    }

    private final static Object
        VIEW_MSG=new Object(),
        FRAME_TITLE=new Object(),DO_HIDE_PARENT_WINDOW=new Object(),
        KEY_EXECUTE_CUST=new Object(),KEY_EXECUTE_ARG=new Object(), KEY_VIEW_FILE=new Object(),
        KEY_EDIT_FILE=new Object(),KEY_PRINTABLE=new Object(),KEY_ChTabPane=new Object(),
        KEY_CTRL=new Object(),KEY_SHARED_CTRL=new Object(), KEY_CUSTOMIZE=new Object(),
        KEY_HELP_OBJECTS=new Object(), KEY_HELP_SUFFIX=new Object(),
        KEY_pack=new Object(),
        KEY_undock_component=new Object(),KEY_OPEN_URL=new Object(),
      CLOSE=new Object(),CLOSE_OPTION=new Object(), KEY_COLLAPSE[]={new Object(),new Object(), new Object()};

    // ----------------------------------------
    /* >>> Constructor >>> */
    {  assertInstAllowed(); }
    private long options;
    public ChButton options(long o) {
        if (0!=(SHOW_HIDE&o)) { i(IC_HIDE,IC_SHOW);}
        if (0!=(NO_FILL&o))   { setContentAreaFilled(false); setOpaque(false); }
        if (0!=(NO_BORDER&o)) setBorderPainted(false);
        if (0!=(NO_MARGIN&o)) noMargn(this);
        if (0!=(ICON_SIZE&o)) {
            pcp(KEY_PREF_SIZE,dim(ICON_HEIGHT,ICON_HEIGHT),this);
            noMargn(this);
        }
        if (0!=(NOT_OPAQUE&o)) setOpaque(false);
        if (0!=(PAINT_IN_TABLE&o)) { setOpaque(false); setRequestFocusEnabled(false); }
        if (0!=(DISABLED&o)) setEnabld(this,false);
        if (0!=(HEIGHT_I&o)) height=ICON_HEIGHT;
        if (0!=(UNDOCKABLE&o)) ChUtils.setUndockble(this);
        if (0!=(HIDE_IF_DISABLED&o)) pcp(KEY_PREF_SIZE_IF_DISABLED, dim(0,0), this);
        options=o;
        return this;
    }

    public ChButton(AbstractButton b) {
        this(b instanceof ChButton ? ((ChButton)b).type:'B',b.getText());
        setModel(b.getModel());
        pcp(KEY_CLONED_FROM, weakRef(b),this);
    }
    public ChButton() { this('B',null);}

    public ChButton(String s) { this('B',s); }
    public ChButton(String s, long options) { this('B',s); options(options); }
    public ChButton(char buttonType, String s) {
        this.type=buttonType;
        setModel(buttonType=='T'||buttonType=='C' ? new JToggleButton.ToggleButtonModel() : new DefaultButtonModel());
        setAlignmentX(LEFT_ALIGNMENT);
        setAlignmentY(CENTER_ALIGNMENT);
        pcp(KEY_ACTION_COMMAND,s,this);
        setDefaultCapable(false);
        if (s!=null) setText(addHtmlTagsAsStrg(s));
        addActionListener(this);
        if (s==MAXIMIZE) t(" ").t(MAXIMIZE,MAXIMIZE,dim(32,32));
        if (buttonType=='C') {
            setBorderPainted(false);
            setText(s);
            setHorizontalAlignment(LEADING);
        }
        updateUI();
    }
    @Override protected void finalize() throws Throwable {
        logFinalize(ANSI_RED+ANSI_FG_WHITE+"ChButton ",getText());
        super.finalize();
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    @Override public void paintChildren(Graphics g) {
        if (UserProfile.isHidden(this)) {return;  }
        super.paintChildren(g);
    }
    public ChButton paintIfEnabled() { pcp("PAINT_IF_ENABLED","",this); setOpaque(false); return this; }
    @Override public void paintComponent(Graphics g) {
        final int w=getWidth(), h=getHeight();
        final long opt=this.options;
        final boolean isEnabled=isEnabled(), isPaintInTable=0!=(opt&PAINT_IN_TABLE);
        if (
            (!isEnabled && (gcp(KEY_HELP_OBJECTS,this)!=null || gcp(KEY_CUSTOMIZE,this)!=null || gcp(KEY_SHARED_CTRL,this)!=null)) ||
            (!isEnabled && gcp("PAINT_IF_ENABLED",this)!=null)) return;

        if (null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this)) {
            if (isOpaque()) g.clearRect(0,0,w,h); return;
        }
        antiAliasing(g,false);
        if (paintHooks(this, g, false)) {
            final Color inTable_saveBG=isPaintInTable ? getBackground() : null;
            if (inTable_saveBG!=null) setBackground(null);
            if (this.oIcon!=null) getIcon();
            if (sze(vMaliciousIcons)>0 && vMaliciousIcons.get(getIcon())!=null) setIcon(null);
            if (getModel().isEnabled()!=isEnabled()) super.setEnabled(isEnabled);
            final Color bg=getBackground();

            if (isPaintInTable) {
                final int dx=3,dy=2;
                g.translate(dx,dy);
                g.clipRect(0,0,w-dx-2,h-dy-2);
                g.setColor(bg);
                g.fillRect(0,0,w,h);
            }
            try { super.paintComponent(g); } catch(Throwable ex){  vMaliciousIcons.put(getIcon(),"");}
            if (isPaintInTable) g.translate(-3,-2);
            final Object magnify=gcp("MAGNIFY",this);
            if (magnify!=null) {
                // g.setColor(Color.RED); g.fillRect(mouseX-1,mouseY-1, 3,3);
                final int a; /*Abstand zum Rand */
                final float ZOOM=.3f;
                if (contains) {
                    g.setColor(Color.GRAY);g.drawRect(0,0,w-1,h-1);
                    int dx=mouseX-w/2, dy=mouseY-h/2;
                    if (dx<0) dx=-dx;
                    if (dy<0) dy=-dy;
                    a=(int)((dx+dy)*ZOOM);
                } else a=(int)(ZOOM*(w+h)/4);

                if (magnify instanceof ImageIcon)  {
                    if (isEnabled()) {
                        final Image im=((ImageIcon)magnify).getImage();
                        g.drawImage(im,
                                    a,a,w-a,h-a,
                                    0,0,im.getWidth(this),im.getHeight(this),this);

                    }
                } else if (magnify instanceof String) {
                    g.setColor(Color.BLACK);
                    final String s=(String) magnify;
                    final int font=maxi(h-a, 2);
                    final Font f=getFnt(font,true,Font.BOLD);
                    g.setFont(f);
                    final Rectangle cb=charBounds(f);
                    final int x=(w-strgWidth(f,s))/2;
                    final int y=(h-cb.height)/2;
                    g.drawString(s,x, y+charA(f)-4);

                }
            }
            drawTopAndButtomText(this,g);
            if (gcp(IC_CURSOR16,this)!=null)  ChIcon.drawCursor(g,64,8,16,16,this);
            if (isPaintInTable) setBackground(inTable_saveBG);
            if (0!=(opt&CROSSING_OUT)) {
                 g.setColor(C(0xFF0000));
                 g.drawLine(0,0,w,h);
                 g.drawLine(0,h,w,0);
            }
        }
        paintHooks(this, g, true);
        //drawProgress(progress,g);
        if (gcp("IF_SELECTED_GREEN",this)!=null && s()) { g.setColor(C(0xff00,55)); g.fillRect(0,0,w,h);}
    }

     public static void drawTopAndButtomText(final JComponent c,final Graphics g) {
         final Color  color= c.isEnabled() ? c.getForeground() : GRAY;
         final int h=c.getHeight();
         final Rectangle cb=charBounds(c.getFont());
         final boolean sel=isSelctd(c);
         boolean maxi=false;
         for(int i=0;i<2;i++) {
             final String s0=toStrg(gcpa(i==0?TOP_TEXT:BOTTOM_TEXT,c));
             if (s0==null) continue;
             if (s0==MAXIMIZE) maxi=true;
             // http://www.pccl.demon.co.uk/java/unicode.html
             final String s= !maxi ? s0 :  i==0 !=sel ? "  \u2191" : "  \u2193";
             final int y=  c instanceof JSlider ? h+2-cb.height : i==0 ? 4 : h-1-cb.height;
             final int x=2-cb.x+(maxi?2:0);
             if (c.isEnabled() && (!(c instanceof ChButton) || !((ChButton)c).s())) {
                 g.setColor(C(0xFFffFF,160));
                 if (!maxi) g.fillRoundRect(x-2,y-2,  4+strgWidth(g,s)   , 4+cb.height,8,8);
             }
             g.setColor(color);
             g.drawString(s,x,y+cb.y);
         }

         for(int i=0;i<2;i++) {
             g.setColor(color);
             final String s0=toStrg(gcpa(i==0 ? LEFT_TEXT : RIGHT_TEXT,c));
             final String s= !maxi ? s0 :  i==0 !=sel ? "\u2190" : "\u2192";
             if (s==null) continue;
             final int y=h/2+cb.y-cb.height/2;
             final int x=i>0 ? c.getWidth()-strgWidth(g,s) : 0;
             g.drawString(s,x,y);
         }
     }

    public ChButton magnifyUnderMouse(String icon ) {
        final ImageIcon i=iicon(icon);
        pcp("MAGNIFY",i!=null ? i : icon,this);
        i(IC_BLANK);
        options(ICON_SIZE|NO_FILL|NO_BORDER);
        return this;
    }
    /* ---------------------------------------- */
    /* >>> Icon >>> */
    private Object oIcon;
    public final ChButton i(Object o) {
        if (o instanceof Icon || o==null) { this.oIcon=null; super.setIcon((Icon)o); }
        else {
            this.oIcon=o;
            final ChButton [] bb=derefArray(gcp(KEY_CLONES,this), ChButton.class);
            if (bb!=null) for(ChButton b: bb) b.i(o);
        }
        return  this;
    }
    public final ChButton i(String iUnselected,String iSelected) {
        if (iSelected!=null) setSelectedIcon(iicon(iSelected));
        i(iUnselected);
        return this;
    }
    @Override public Icon getIcon() {
        if (oIcon!=null) {
            final Object o=this.oIcon;
            this.oIcon=null;
            Icon i=o instanceof Icon ? (Icon)o : TabItemTipIcon.icn(o);
            if (i==null) i=iicon(toStrg(o));
            if (i!=null) setIcon(i);
            setIcon(i);
        }
        return super.getIcon();
    }
    /* <<< Icon <<< */
    /* ---------------------------------------- */
    /* >>> Label Text >>> */
    public final ChButton t(String top,String bot) {
        int w=0;
        for(int i=2; --i>=0;) {
            final String s=i==0?top:bot;
            if (s!=null) w=maxi(w,strgWidth(this,s));
        }
        return t(top,bot,dim(w+2,ICON_HEIGHT));
    }
    public final ChButton t(String top,String bot, Dimension d) {
        t(null);
        pcp(TOP_TEXT,top,this);
        pcp(BOTTOM_TEXT,bot,this);
        if (d!=null) ps(d);
        return this;
    }
    public final ChButton t(CharSequence t) {
        if (t==GO) like(BUTTON_GO);
        else setText(t==null ? null : addHtmlTagsAsStrg(t));return this;
    }
    /* <<< Label Text <<< */
    /* ---------------------------------------- */
    /* >>> ToolTip >>> */
    @Override public String getToolTipText(MouseEvent ev) {
        final StringBuffer sbP=appendTooltips(this,ev,null);
        if (sbP!=null)  return sbP.toString();
        final StringBuffer sb=strBuf(SB_TIP);
         if (!super.isVisible()) return null;
        final Object cloned=gcp(KEY_CLONED_FROM,this);
        if (cloned instanceof JComponent) return ((JComponent)(cloned)).getToolTipText();

        Object o=gcp(KEY_HELP_OBJECTS,this);
        if (o!=null) {
            if (gcp(KEY_HELP_SUFFIX,this)==FALSE) sb.append("Source code of<br>");
            for(Object q :oo(o)) {
                if (q==null || q instanceof Boolean) continue;
                if (sze(sb)>0) sb.append("<br>");
                sb.append(clazzName(q));
            }
            if (isMyComputer()) sb.append("<br>SHIFT: edit  CTRL: clear");
            if (sze(sb)>0) return addHtmlTagsAsStrg(sb);
        }

        if ((o=gcp(KEY_TOOLTIP,this))!=null) return addHtmlTagsAsStrg(toStrg(o));
        if ((o=gcp(KEY_SHARED_CTRL,this))!=null || (o=gcp(KEY_CUSTOMIZE,this))!=null) return "Settings for "+clazzName(o);
        if ((o=gcp(KEY_EXECUTE_CUST,this))!=null) return addHtmlTagsAsStrg(o+"<br>"+toStrg(gcp(KEY_EXECUTE_ARG,this)));
        return super.getToolTipText();
    }
    public final ChButton tt(Object tt) {
        if (tt==null) setToolTipText(null);
        else if (tt instanceof TooltipProvider) addTooltip((TooltipProvider)tt,this);
        else {
            CharSequence tip=addHtmlTagsAsStrg(tt instanceof CharSequence ? (CharSequence)tt : tt.toString());
            setToolTipText(toStrg(tip));
        }
        return this;
    }
    @Override public String toString() { return (isToggle() ? "ChToggle " :"ChButton ")+getText()+" / "+gcp(KEY_ACTION_COMMAND,this)+" "+isEnabled();}
    /* <<< Label Text <<< */
    /* ---------------------------------------- */
    /* >>> Appearance >>> */
    @Override public boolean isBorderPainted() { return UserProfile.isHidden(this) ?  false : super.isBorderPainted(); }
    public final ChButton fg(Color c) { ChDelay.afterMS(EDT,ChDelay.FG_COLOR,this,0,c);return this;}
    public final ChButton bg(Color c) { ChDelay.afterMS(EDT,ChDelay.BG_COLOR,this,0,c);return this;}

    @Override public boolean isContentAreaFilled() {
        return null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this) ? false : super.isContentAreaFilled();
    }

    public ChButton like(JComponent protoType) {
        if (protoType==null) return this;
        t(getTxt(protoType));
        setIcon(getIcn(protoType));
        fg(protoType.getForeground());
        setFont(protoType.getFont());
        tt(protoType.getToolTipText());

        for(Object key : new Object[]{TOP_TEXT,BOTTOM_TEXT, KEY_PREF_SIZE})  pcp(key, gcp(key, protoType), this);

        setFont(protoType.getFont());
        if (protoType instanceof AbstractButton) {
            Icon i= ((AbstractButton)protoType).getSelectedIcon();
            if (i!=null) setSelectedIcon(i);
            if (((AbstractButton)protoType).isSelected()) s(true);
        }
        return this;
    }
    public ChButton tabItemTipIcon(Object c) {
        if (c!=null) pcp(Class.class,c,this);
        return t(TabItemTipIcon.item(c)).tt(TabItemTipIcon.tip(c)).i(TabItemTipIcon.iconOrStrg(c));
    }
    /* <<< Appearance <<< */
    /* ---------------------------------------- */
    /* >>> Renderer >>> */

    public JComponent getRendererComponent() { return this;}
    /* <<< Renderer <<< */
    /* ---------------------------------------- */
    /* >>> Size >>> */
    @Override public Insets getMargin() { return UserProfile.isHidden(this) ? insets0(false) : super.getMargin();}
    @Override public Dimension getMinimumSize() { try { return super.getMinimumSize();} catch(Throwable e){return dim(32,32);}}
    @Override public Dimension getMaximumSize() { try { return super.getMaximumSize();} catch(Throwable e){return dim(32,32);}}

    @Override public Dimension getPreferredSize() {
        {
            final Dimension ps=getPrefSize(this);
            if (ps!=null) return ps;
        }
        final JComponent cloned=gcp(KEY_CLONED_FROM,this,JComponent.class);
        if (cloned!=null) return cloned.getPreferredSize();
        try {  // NullPointer  at javax.swing.plaf.synth.SynthLookAndFeel.paintRegion(SynthLookAndFeel.java:352)
            if (0!=(options&SHOW_HIDE) && sze(getText())==0) return dim(32,32);
            final Dimension d=super.getPreferredSize();
            return height>0 ? dim(d.width,height) : d;
        } catch(Exception e) {
            return dim(ICON_HEIGHT*10,ICON_HEIGHT);
        }
    }
    public ChButton ps(Dimension d) { pcp(KEY_PREF_SIZE,d,this); return this; }
    /* <<< Size <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    public ChButton li(ActionListener l) { addActLi(l,this);  return this;}
    @Override public void processEvent(AWTEvent ev) {
        final int id=ev.getID();
        if(id==MOUSE_PRESSED) setEventLocationOnScreen(ev);
        if (gcp(KEY_DISABLE_EVENTS,this)!=null) return;
        if (ev instanceof MouseEvent) {
            final MouseEvent moEv=(MouseEvent)ev;
            if (id==MOUSE_EXITED) { contains=false;repaint();}
            if (id==MOUSE_MOVED && gcp("MAGNIFY",this)!=null) {
                setTipTiming(-1,0);
                mouseX=moEv.getX();
                mouseY=moEv.getY();
                contains=true;
                repaint();
            }
        }
        try {  super.processEvent(ev); } catch(Throwable ex) { stckTrc(ex);}
    }

    public void actionPerformed(ActionEvent ev){
        final int modi=this.modifiers=ev.getModifiers();
        final boolean isSel=s();
        if (propertyClass!=null && propertyId!=null) {
            setPrpty(propertyClass,propertyId, isSel);
        }
        modiCount++;
        if (gcp(KEY_EXECUTE_CUST,this)!=null) run(); else ChDelay.runAfterMS(EDT,this,9);

        CollapseComponent.doNotCollapseNow();
        contains=false;
        Object para=null;

        if ((para=gcp(DO_HIDE_PARENT_WINDOW,this))!=null) {
            try {
                parentWndw(this).setVisible(false);
            } catch(Exception e) {}
        } else if ((para=gcp(KEY_undock_component,this))!=null) {
            final ChFrame frame=gcp(KEY_dock_frame, para,ChFrame.class);
            if (frame!=null) panelDock(para); else panelUndock(para, -1, -1);
        } else if ((para=gcp(VIEW_MSG,this))!=null) {
            if( para==MSG_SHOW_ALL_PREVIOUS) ChMsg.showAllPreviousMsgs();
            else if (para instanceof JPopupMenu) ((JPopupMenu)para).show(this,EM,EX);
            else {
                Object m=para instanceof File ? readStrg((File)para) : para;
                if (para instanceof String && equls(_CC,para) && nxt(SPC,para)<0 && strchr('/',para)>0) {
                    final String ss[]=((String)para).split("/");
                    if (ss.length==2) m=readBytes(rscAsStream(ss[0],ss[1]));
                    else assert false;
                }
                if (m instanceof Map) {
                    final StringBuffer sb=new StringBuffer(999);
                    for(Object e : entryArry((Map)m)) sb.append(e).append('\n');
                    m=sb;
                }
                final Component jComp=getPnl(m);
                if (jComp==null)  {
                     String s=toStrg(m);
                     ChTextViewer tv=gcp(s,this,ChTextViewer.class);
                    if (tv==null) pcp(s,weakRef(tv=new ChTextViewer(addHtmlTags(s))),this);
                    tv.shw(0);
                } else {
                    ChFrame.frame(toStrg(gcp(FRAME_TITLE,this)), jComp, CLOSE_ON_CtrlW).i(getIcon()).shw(ChFrame.AT_CLICK|ChFrame.SIZE_REGARD_RESOLUTION);
                    jComp.invalidate();
                    ChDelay.afterMS(EDT,ChDelay.VALIDATE,jComp,333,null);
                }
            }
        } else if ((para=gcp(CLOSE,this))!=null) {
            dispos(atol(gcp(CLOSE_OPTION,this)),para);
        }
        visitURL(gcp(KEY_OPEN_URL,this),modi);
    }

    /* <<< Event <<< */
    /* ---------------------------------------- */
    /* >>> When pressed >>> */
    private Object run;
    public final ChButton r(Runnable r) { run=r; return this;};
    public final ChButton r(String r) { run=r; return this;};
    public void r(){
        final int modi=this.modifiers;
        final boolean ctrl=(modi&CTRL_MASK)!=0, shift=(modi&SHIFT_MASK)!=0;
        final Container ctrlPnl=getCtrlPanel(gcp(KEY_CTRL,this));
        if (ctrlPnl!=null){
            final String KEY="Frame for getControlPanel";

            ChFrame f=gcp(KEY,this,ChFrame.class);
            if (f==null) {
                final Dimension dim=ctrlPnl.getPreferredSize();
                final Container cont= child(ctrlPnl,JScrollPane.class)==null ? scrllpn(0L,ctrlPnl) : ctrlPnl;
                f=new ChFrame("Details").ad(cont).size(mini(800,dim.width)+40,mini(600,dim.height)+40).shw(CLOSE_ON_CtrlW|ChFrame.AT_CLICK);
                pcp(KEY,weakRef(f),this);
            }
            setWndwState('F',f.shw(0));
        }
        for(Customize c : Customize.cc(gcp(KEY_CUSTOMIZE,this))) Customize.addDialog(c);

        Object o=gcp(KEY_HELP_OBJECTS,this);
        if (o!=null) {
            final JRootPane rp=SwingUtilities.getRootPane(this);
            ChTabPane tp=gcp(KEY_ChTabPane,this,ChTabPane.class);
            if (rp!=null && rp.getParent() instanceof JDialog) tp=null;
            boolean success=false;
            for(Object q: oo(o)){
                q=deref(q);
                if (q==null || q instanceof Boolean) continue;
                final boolean isHelp=gcp(KEY_HELP_SUFFIX,this)==TRUE;
                if (isHelp && ctrl) clearHelp();
                if (shift) edFile(-1, sourceFile(HotswapUtil.getClass(q)), 0);
                else success|=  isHelp ? showHelp(q) : showJavaSource(clazzName(q),(String[])null);
            }
            if (tp!=null && success) {
                pushDivider(tp,0.7);
                pushDivider(tp.getParent(),0.7);
            }
        }
        if ((o=gcp(KEY_SHARED_CTRL,this))!=null) {
            final Container cp=getSharedCtrlPan(o,true);
            if (cp!=null) {
                final Dimension dim=cp.getPreferredSize();
                final ChFrame f=ChFrame.frame("Control Panel for "+shrtClasNam(o),cp,ChFrame.SCROLLPANE|ChFrame.AT_CLICK)
                    .size(mini(800,dim.width)+40,mini(600,dim.height)+40)
                    .shw(0);
                setWndwState('F',f);
            }
        }
        if ((o=gcp(KEY_PRINTABLE,this))!=null) {
            int i=0;
            for(Object c:oo(gcp(KEY_PRINTABLE_COMPONENTS, o))) {
                if (!(c instanceof JComponent)) continue;
                Object fn=gcp(KEY_IMAGE_FILE_NAME,c);
                if (fn==null) fn=String.valueOf(i++);
                final File f=file(STRAPOUT+"/images/"+fn+".png");
                pcp(KEY_IS_PRINTING,"",c);
                writePng((JComponent)c,f);
                pcp(KEY_IS_PRINTING,null,c);
                visitURL(f, modi);
            }
            new Thread(new ChExec(0).setCommandsAndArgument(getCustomSettings(Customize.fileBrowsers),file(STRAPOUT+"/images/").toString())).start();
        }
        if ((o=gcp(KEY_VIEW_FILE,this))!=null)  viewFile(file(o), modi);
        if ((o=gcp(KEY_EDIT_FILE,this))!=null)  edFile(-1, o, modi);
        if ((o=gcp(KEY_EXECUTE_CUST,this))!=null) {
            final Customize cust=(Customize)o;
            final ChExec ex=new ChExec(0);
            ex.setCommandsAndArgument(cust.getSettings(),gcp(KEY_EXECUTE_ARG,this));
            if (ctrl) ex.log(cust);
            new Thread(ex,"ChButton").start();
            if (cust==Customize.customize(Customize.fileBrowsers))
                ChMsg.savedMsg("<h2>Drag and Drop</h2>You can drag protein files from the native file browser or from the desktop<br>"+
                                                  "into the STRAP-application frame.","DnD");
        }
    }
    public final void run(){
        if (!handleEvt) return;
        assertEDT();
        r();
        if (run!=null) {
            Runnable r=run instanceof Runnable ? (Runnable) run: null;
            if (r==null) {
                try {
                    Class c= run instanceof Class ? (Class)run: Class.forName(run.toString());
                    r=(Runnable)c.newInstance();
                } catch(Exception ex){ stckTrc(ex);}
            }
            if (r!=null) r.run();
        }
        final String cmd=gcp(KEY_ACTION_COMMAND,this,String.class);
        handleActEvt(this, cmd!=null?cmd:getText(), this.modifiers);

        this.modifiers=0;
        {
            Window window=null;
            for(Object key : KEY_COLLAPSE) {
                final Object collapse=gcp(key, this);
                if (collapse!=null) {
                    for(JMenu jm : derefArray(collapse,JMenu.class)) {
                        final Dimension pfs=gcp(KEY_COLLAPSE,jm,Dimension.class);
                        if (pfs!=null) jm.setPreferredSize(s()? pfs : dim(0,0));
                    }

                    revalidateComponentsInArray(collapse,true);

                    if (window==null) window=gcp(KEY_pack,this,Window.class);
                    if (window==null && gcp(KEY_pack,this)!=null) window=parentWndw(this);
                }
                if (window!=null) window.pack();
            }
        }
        final String t=getText();
        if (t=="+" || t=="-") {
            for(Object k : KEY_COLLAPSE) {
                if (gcpa(k,this)!=null) {
                    t(s() ? "-" : "+");
                    break;
                }
            }
        }
    }
    private static void revalidateComponentsInArray(Object array_or_comp, boolean alsoParent) {
        final Object[]   oo=deref(array_or_comp, Object[].class);
        final JComponent  c=deref(array_or_comp, JComponent.class);
        if (oo!=null)  for(Object o : oo) revalidateComponentsInArray(o,alsoParent);
        if (c!=null) {
            c.revalidate();
            if (alsoParent) revalidateComponentsInArray(c.getParent(), false);
        }
    }
    /* <<< When pressed <<< */
    /* ---------------------------------------- */
    /* >>> Clone >>> */
    public final ChButton cln() { 
        final char buttonType=this.type;
        final boolean isCB=buttonType=='C';
        final ChButton b=new ChButton(buttonType, isCB ? getText() : null).like(this);
        pcp(KEY_CLONED_FROM,weakRef(this),b);
        if (buttonType==type) {
            pcp(KEY_PREF_SIZE,gcp(KEY_PREF_SIZE,this),b);
            if (isCB) pcp("MAGNIFY",gcp("MAGNIFY",this),b);
        }
        pcp(UserProfile.KEY_IGNORE, gcp(UserProfile.KEY_IGNORE,this),b);
        b.fg(getForeground());
        addRef(KEY_CLONES,weakRef(b),this);
        b.addActionListener(this);

        return b;
    }
    public final AbstractButton mi(String txt) {
        final JMenuItem mi;
        if (isToggle()) {
            mi=new JCheckBoxMenuItem(txt!=null ? txt:getText(),ChButton.this.isSelected()) {
                    @Override public Dimension getPreferredSize() {
                        final Dimension ps=getPrefSize(this);
                        if (ps!=null) return ps;
                        return UserProfile.isHidden(ChButton.this) ? dim(0,0):super.getPreferredSize();
                    }
                    @Override public void paintComponent(Graphics g) {
                        if (isMacintosh()) {
                            setBackground(Color.GRAY);
                            setForeground(Color.BLACK);
                            g.setColor(Color.GRAY);
                            g.fillRect(0,0,9999,9999);
                            g.setColor(Color.BLACK);
                        }
                        super.paintComponent(g);
                        ChRenderer.drawSmallButtons(this,g);
                    }
                    @Override public void processEvent(AWTEvent ev) {
                        if(ev.getID()==MOUSE_PRESSED) setEventLocationOnScreen(ev);
                        super.processEvent(ev);
                    }
                };
            mi.setModel(getModel());
            mi.setOpaque(false);
        } else {
            mi=new JMenuItem(txt!=null ? txt : getText()) {
                    @Override public Dimension getPreferredSize() {
                        return
                            UserProfile.isHidden(ChButton.this) ? dim(0,0):
                            super.getPreferredSize();
                    }
                    @Override public void paintComponent(Graphics g) {
                        if (UserProfile.isHidden(this) || UserProfile.isHidden(ChButton.this)  ) return;
                        try{
                            final boolean isE=ChButton.this.isEnabled();
                            if (isEnabled()!=isE) setEnabled(isE);
                            final Icon ic0=ChButton.this.getIcon(), ic=!isIconsInMenus() ? null : ic0!=null ? ic0 : iicon(IC_BLANK);
                            if (ic!=getIcon()) setIcon(ic);
                            final int w=getWidth(), h=getHeight();
                            Color bg=gcp(KEY_BACKGROUND,this,Color.class);
                            if (bg==null) bg=this.getBackground();
                            if (bg!=null) { g.setColor(this.getBackground()); g.fillRect(0,0,9999,99);}
                            Color fg=gcp(KEY_FOREGROUND,this, Color.class);
                            if (fg==null) fg=this.getForeground();
                            if (bg==null) bg=this.getBackground();
                            if (fg!=null) g.setColor(fg);
                            super.paintComponent(g);
                            ChRenderer.drawSmallButtons(this,g);
                        }catch(Throwable ex){ }

                    }
                    @Override public void processEvent(AWTEvent ev) {
                        if(ev.getID()==MOUSE_PRESSED) setEventLocationOnScreen(ev);
                        super.processEvent(ev);
                    }
                };
            mi.setIcon(iicon(IC_BLANK));
            final KeyStroke ks=gcp(KEY_ACCELERATOR,this, KeyStroke.class);

            if (ks!=null) mi.setAccelerator(ks);
        }
        ChUtils.setUndockble(mi);
        mi.addActionListener(this);
        pcp(Class.class,gcp(Class.class,this),mi);
        pcp(KEY_CLONED_FROM,weakRef(this),mi);
        mi.setToolTipText(getToolTipText());
        pcp(KEY_MENU_ID,gcp(KEY_MENU_ID,this),mi);
        return mi;
    }
    public AbstractButton cb() {
        assert isToggle();
        final String t=getText();
        final AbstractButton cb=new JCheckBox(t!=null ? t : " ", isSelected()) {
                @Override public Dimension getPreferredSize() {
                    final Dimension ps=getPrefSize(this);
                    if (ps!=null) return ps;
                    return super.getPreferredSize();
                }
                @Override public Cursor getCursor() { return ChButton.this.isEnabled() ? getCursr('D') : super.getCursor();}
                @Override public void processEvent(AWTEvent ev) {
                    if(ev.getID()==MOUSE_PRESSED) setEventLocationOnScreen(ev);
                    if (gcp(KEY_DISABLE_EVENTS,this)!=null) return;
                    super.processEvent(ev);
                }
            };
        pcp(KEY_CLONED_FROM,weakRef(this),cb);
        cb.setModel(getModel());
        cb.setToolTipText(getToolTipText());
        return cb;
    }
    protected AbstractButton radio() {
        assert isToggle();
        final String t=getText();
        final JRadioButton cb=new JRadioButton(t!=null ? t : " ",isSelected());
        cb.setModel(getModel());
        cb.setToolTipText(getToolTipText());
        pcp(KEY_CLONED_FROM,this,cb);
        return cb;
    }
    /* <<< Clone <<< */
    /* ---------------------------------------- */
    /* >>> Enabled >>> */
    /* Bugfix, it does not notice isEnabled(); */
    public final ChButton enabled(boolean b) {
        setEnabld(this,b);
        return this;
    }
    @Override public boolean isEnabled() {
        if (!Insecure.EXEC_ALLOWED && gcp(KEY_HIDE_IF_EXEC_FORBIDDEN,this)!=null) return false;
        final boolean superEnabled=super.isEnabled();
        boolean enabled=superEnabled;
        final JComponent cloned=gcp(KEY_CLONED_FROM,this,JComponent.class);
        Object o;
        if (null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this)) enabled=false;
        else if (cloned!=null) enabled= cloned.isEnabled();
        o=gcp(KEY_HELP_OBJECTS,this);
        if (get(0,o) instanceof URL) enabled=true;
        else if (o!=null) return helpIsEnabled(o);
        else if ( (o=gcp(KEY_SHARED_CTRL,this))!=null) enabled=hasSharedControlPanel(o);
        else if ( (o=gcp(KEY_CUSTOMIZE,this))!=null) enabled=Customize.cc(o).length>0;
        else if ( (o=gcp(KEY_VIEW_FILE,this))!=null) enabled=sze(file(o))>0;
        else if ( (o=gcp(KEY_ENABLED,this)) instanceof IsEnabled) enabled=((IsEnabled)o).isEnabled(this);
        else if ( (o=gcp(KEY_CTRL,this))!=null) enabled=getCtrlPanel(o)!=null;
        //if (enabled!=superEnabled) super.setEnabled(enabled);
        return enabled;
    }
    /* <<< Enabled <<< */
    /* ---------------------------------------- */
    /* >>> Specific Actions >>> */
    //private static ChButton actionHideParentWindow() { ChButton b=new ChButton("close"); pcp(DO_HIDE_PARENT_WINDOW,"",b);return b;}

    public static ChButton actionClose(Object o) { return actionClose(o,0L);}
    public static ChButton actionClose(Object o, long options) {
        ChButton b=new ChButton().magnifyUnderMouse(IC_CLOSE).tt("Close");
        pcp(CLOSE,weakRef(o),b);
        pcp(CLOSE_OPTION,longObjct(options),b);
        return b;
    }

    public static ChButton actionViewMessage(String title,Object msg) {
        ChButton b=new ChButton(title);
        if (msg==MSG_SHOW_ALL_PREVIOUS) {
            if (title==null) b.t(MSG_SHOW_ALL_PREVIOUS);
            b.i(IC_INFO);
        }
        pcp(FRAME_TITLE,title,b);
        pcp(VIEW_MSG,msg,b);
        return b;
    }
    public static ChButton actionOpenURL(Object o) {
        final String url;
        final String s;
        if (o instanceof File) {
            s=filepathUnixStyle(o);
            url=toStrg(url(o));
        } else {
            s=toStrg(o);
            url=Hyperrefs.toUrlString(s,Hyperrefs.WEB_LINK|Hyperrefs.PLAIN_TEXT|Hyperrefs.PROTEIN_FILE);
        }
        final ChButton b=new ChButton(s).i(IC_WWW).tt(url);
        pcp(KEY_OPEN_URL,url,b);
        return b;
    }
    public static ChButton actionHelp(Object o) {  return actionHelpOrJava(o,'H'); }
     static ChButton actionHelpOrJava(Object o,char HJ) {
        final ChButton b;
        if (o instanceof CharSequence && o.toString().indexOf(' ')>0)  b=ChButton.actionViewMessage("",addHtmlTagsAsStrg(o));
        else {
            b=new ChButton(null,HIDE_IF_DISABLED);
            pcp(KEY_HELP_SUFFIX, HJ=='H' ? TRUE:FALSE,b);
            pcp(KEY_HELP_OBJECTS,oo(o),b);
            pcp(KEY_ChTabPane, HJ=='H' ? getHelpPanel() : getJavaPanel(),b);
            b.paintIfEnabled();
        }
        if (HJ=='J') UserProfile.set('e',b.i(IC_JAVA));
        rtt(b);
        return b;
    }

    private boolean helpIsEnabled(Object objects) {
        for(Object o:oo(objects)) {
            o=deref(o);
            if (o==null) continue;
            if (gcp(KEY_HELP_SUFFIX,this)==TRUE ? hasHelp(o) : hasSource(o)) return true;
        }
        return false;
    }
    public static ChButton actionSharedCtrl(Object o) {
        final ChButton b=new ChButton();
        pcp(KEY_SHARED_CTRL,weakRef(o),b);
        rtt(b);
        b.tt("Control panel");
        b.magnifyUnderMouse(IC_CONTROLPANEL);
        if (o instanceof ChCombo) UIupdateList.add(b,UIupdateList.COMBOBOX);
        return b;
    }
    public static ChButton actionCtrl(Object o) {
        boolean success=false;
        for(Class c : CLASS_MAY_HAVE_CTRL_PANEL) success=success ||  (o!=null && isInstncOf(c,o));
        final ChButton b=success ? new ChButton().t("Details") : null;
        pcp(KEY_CTRL,o,b);
        return b;
    }

    public static ChButton actionCustomize(Object o) {
        if (!(o instanceof JComboBox || o instanceof JList || Customize.cc(o).length>0)) return null;
        final ChButton b=new ChButton(null,ChButton.NOT_OPAQUE|ChButton.ICON_SIZE);
        pcp(KEY_CUSTOMIZE,weakRef(o),b);
        rtt(b);
        return b.i(IC_CUSTOM);
    }
    public ChButton actionViewFile(File f) { pcp(KEY_VIEW_FILE,f,this); return this; }
    public ChButton actionEditFile(Object file) {
        pcp(KEY_EDIT_FILE,file instanceof CharSequence ? file((CharSequence)file) : file,this);

        if (!Insecure.EXEC_ALLOWED) pcp(KEY_HIDE_IF_EXEC_FORBIDDEN,"",this);
        return this;
    }
    public static ChButton actionPrint(Object o) {
        ChButton b=new ChButton().magnifyUnderMouse(IC_CAMERA)
            .tt("An image file is written to <pre>"+file(dirTmp()+"/images")+"</pre>and opened in the Web-browser."+
                "<br>In the browser it can be printed.<br>CTRL key: use light background");
        pcp(KEY_PRINTABLE,weakRef(o),b);
        return b;
    }
    public ChButton actionExecuteProgram(Customize cust,Object arg) {
        rtt(this);
        pcp(KEY_EXECUTE_ARG,arg,this);
        pcp(KEY_EXECUTE_CUST,cust,this);
        return this;
    }
    public ChButton actionFileBrowser(Object oFile) {
        Object arg= oFile instanceof File ? ((File)oFile).getAbsolutePath() : oFile;
        t("Open directory in "+systProprty(SYSP_NAME_FILE_BROWSER));
        i(systProprty(SYSP_ICON_FILE_BROWSER));
        actionExecuteProgram(Customize.customize(Customize.fileBrowsers),arg);
        if (!Insecure.EXEC_ALLOWED) pcp(KEY_HIDE_IF_EXEC_FORBIDDEN,"",this);
        return this;
    }
    public ChButton actionCollapse(boolean b, Object toolbar) {
        assert isToggle();
        if (sze(getText())==0) t("+").options(ChButton.NO_MARGIN);
        pcp(KEY_COLLAPSE[b?0:1],toolbar,this);
        pcpTargetArray(KEY_TOGGLE_COLLAPSE[b?1:0], weakRef(this),toolbar);

        for(JMenu jm : derefArray(toolbar,JMenu.class)) {
            if (jm instanceof ChJMenu) continue;
            pcp(KEY_COLLAPSE, jm.getPreferredSize(),jm);
            jm.setPreferredSize(dim(0,0));
        }
        return this;
    }

    private static void pcpTargetArray(Object key, Object value, Object target) {
        if (target instanceof Object[]) {
            for(Object t : (Object[])target) pcpTargetArray(key,value, t);
        } else pcp(key,value,target);
    }

    public ChButton actionPack() { return actionPack(null);}
    public ChButton actionPack(Window w) {
        assert isToggle();
        pcp(KEY_pack,w!=null?w:"",this);
        return this;
    }
    public ChButton actionUndock(Object component) {
        magnifyUnderMouse(IC_DETACH);
        pcp(KEY_undock_component,component,this);
        return this;
    }
    /* <<< Specific Actions <<< */

    /* ---------------------------------------- */
    /* >>> ChToggle >>> */
    public int getModificationCount() { return modiCount;}
    public String getUIClassID() { return type=='T'? "ToggleButtonUI" : type=='C' ? "CheckBoxUI" :  "ButtonUI"; }
    public boolean isToggle() { return type=='T'; }
    public final ChButton s(boolean isSelected) { handleEvt=false; setSelected(isSelected); handleEvt=true;  return this;}
    public boolean s() {return isSelected();}
    private Class propertyClass;
    private String propertyId;
    public ChButton save(Class propertyClass,String id_str) {
        id_str=id_str.intern();
        this.propertyClass=propertyClass; this.propertyId=id_str;
        s(getPrpty(propertyClass,propertyId,s()));
        return this;
    }
    /* <<< ChToggle <<< */
    /* ---------------------------------------- */
    /* >>> Threading >>> */
    public Object run(String id, Object arg) {
        if (id==ChRunnable.SET_ICON_IMAGE) {
            Image im=(Image)arg;
            if (im!=null) {
                final long options=atol(gcp(KEY_REQUEST_IMAGE_OPTIONS,this));
                final int maxWidth=atoi(gcp(KEY_REQUEST_IMAGE_MAX_WIDTH,this));
                final int w=im.getWidth(this), h=im.getHeight(this);
                if (maxWidth>0 && w>maxWidth) {
                    im=ChIcon.getScaledInstance(im, maxWidth, h*maxWidth/w,null,Color.WHITE);
                }
                if (0!=(options&REQUEST_IMAGE_REMOVE_TEXT)) setText(null);
                if (0!=(options&REQUEST_IMAGE_PACK)) {
                    final Window win=parentWndw(this);
                    if (win!=null) win.pack();
                }
            }
            setIcon(im!=null ? new ImageIcon(im) : null);
        }
        return null;
    }

}

