package charite.christo;
import charite.christo.interfaces.*;
import charite.christo.hotswap.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.ref.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
import static java.awt.Color.*;
/**
   extended choice box
   @author Christoph Gille
*/
public class ChCombo extends JComboBox implements ActionListener,Runnable,IsEnabled,HasModiCount {
    final Map MAPCP=new HashMap();
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
    public ChCombo(String...oo) { super(oo); ini(0); }
    public ChCombo(Object data, int options) {
        if (data instanceof ComboBoxModel) setModel((ComboBoxModel)data);
        else if (data instanceof List) setModel(new JListModel((List)data));
        else if (data instanceof Object[]) setModel(new DefaultComboBoxModel((Object[])data));
        ini(options);
    }
    private void ini(int options){
        assertInstAllowed();
        setMaximumRowCount(30);
        if ( (options&ChJTable.DEFAULT_RENDERER)!=0) {
            final ChRenderer r=new ChRenderer();
            setRenderer(r); rtt(this);
            if ((options&(ChJTable.ICON_ROW_HEIGHT))!=0) r.LABEL.setMinimumSize(dim(ICON_HEIGHT,ICON_HEIGHT));
        }
        if ( (options&ChJTable.CLASS_RENDERER)!=0) {
            setRenderer(new ChRenderer().options(ChRenderer.CLASS_NAMES));
            rtt(this);
            containsClasses=true;
        }
        if ( (options&(ChJTable.ICON_ROW_HEIGHT))!=0) {
            setMinimumSize(dim(ICON_HEIGHT,ICON_HEIGHT));
        }
        if ( (options&ChJTable.RTT)!=0) rtt(this);
        addActionListener(this);
    }
    public ChCombo cln() {
        final ChCombo c=new ChCombo(getModel(),0);
        c.setRenderer(getRenderer());
        c.clas=clas;
        c.id=id;
        pcp(KEY_CLONED_FROM, weakRef(this),c);
        rtt(c);
        return c;
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    private boolean wasPainted, handleEvent=true;
    private int lastCount=-1;
    @Override public void paintComponent(Graphics g){
        final int L=getModel().getSize();
        if (!wasPainted) {
            wasPainted=true;
            if (containsClasses && isProxyClassUnavailable(getSelectedItem())) {
                final ComboBoxModel m=getModel();
                final int N=sze(m);
                for(int i=0; i<N; i++) {
                    if (!isProxyClassUnavailable(get(i,m))) {
                        s(i);
                        break;
                    }
                }
            }
            selNextEnabled();
        }
        try {
            super.paintComponent(g);
            if (L==0) {
                final String msg=gcp(KEY_IF_EMPTY,this,String.class);
                if (msg!=null)  {
                    g.clearRect(0,0,99999,999);
                    g.setColor(BLUE);
                    g.drawString(msg,0,charA(g));
                }
            }
            final int lc=this.lastCount;
            this.lastCount=L;
            if (L>=0 && lc!=L) ChDelay.updateUI(this,3333, (long[])null); // !!!!!!!
        } catch(Exception e){}
    }
    /* <<<Paint  <<< */
    /* ---------------------------------------- */
    /* >>> Layout >>> */
    private JComponent pan,panHSnf;
    public JComponent panel() {
        if (containsClasses && panHSnf==null)  {
            final JComponent panHSnf_=panHS(Boolean.FALSE,this);
            final int n=panHSnf_.getComponents().length;
            panHSnf_.setLayout(new GridLayout(1,n));
            panHSnf_.setPreferredSize(dim(ICON_HEIGHT*n,ICON_HEIGHT));
            panHSnf=newCNSEW(this,null,null,panHSnf_,null);
        }
        if (pan==null) pan=mayAddHttpProxy(newCNSEW(labToString(),panHSnf,null,null,null));
        return pan;
    }
    @Override public Dimension getMinimumSize() { try { return super.getMinimumSize();} catch(Throwable e){return dim(32,32);}}
    @Override public Dimension getMaximumSize() { try { return super.getMaximumSize();} catch(Throwable e){return dim(32,32);}}
    @Override public Dimension getPreferredSize() {
        final Dimension d=getPrefSize(this);
        return d!=null ? d : super.getPreferredSize();
    }
    /* <<< Layout <<< */
    /* ---------------------------------------- */
    /* >>> Web proxy  >>> */
    private JComponent mayAddHttpProxy(JComponent c) {
        if (c==null) return null;
        if (!isSystProprty(IS_WEBSTARTED) && isAssignblFrm(NeedsInternet.class,this)) {
            if (panProxy==null) panProxy=pnl(newButTestProxy());
            c.add(panProxy,BorderLayout.SOUTH);
        } else if(panProxy!=null) c.remove(panProxy);
        return c;
    }
    private Container panProxy;
    /* <<< Web proxy <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    private long whenLastWheel;
    @Override public void processEvent(AWTEvent ev) {
        if (gcp(KEY_DISABLE_EVENTS,this)!=null) return;
        final int id=ev.getID();
        if (id==MOUSE_PRESSED) setEventLocationOnScreen(ev);
        try{super.processEvent(ev);}catch(Throwable ex){}
        if (id==MOUSE_RELEASED && isWindows() && getParent()!=null) getParent().requestFocus();
        final int rotation=wheelRotation(ev);
        if (rotation!=0 && gcp(HtmlDocEditorKit.class,this)==null &&  (System.currentTimeMillis()-whenLastWheel)>33) {
            whenLastWheel=System.currentTimeMillis();
            final int idx=getSelectedIndex() + (rotation<0 ? -1 : 1);
            if (idx>=0 && idx<getItemCount())  setSelectedIndex(idx);
            repaint();
        }
    }
    { this.enableEvents(MOUSE_EVENT_MASK|MOUSE_WHEEL_EVENT_MASK);}
    @Override public void actionPerformed(ActionEvent ev) {
        if (!wasPainted||!handleEvent) return;
        modificationCount++;
        ChDelay.runAfterMS(EDT,this,99);
        final ChCombo clone= (ChCombo) gcp(KEY_CLONED_FROM,this);
        final Object cmd=gcp(KEY_ACTION_COMMAND,this);
        final ActionEvent event=new ActionEvent(clone!=null ? clone : this, ev.getID(), cmd!=null ? cmd.toString() : ev.getActionCommand(), ev.getModifiers());
        handleEvt(clone,event);
        handleEvt(this,event);
        /* --- In Windows the selected Item is not drawn if it has the focus. --- */
        if (isWindows() && getParent()!=null) getParent().requestFocus();
    }
    public ChCombo li(ActionListener l) { addActLi(l,this); return this;}
    /* <<< AWTEvent <<< */
    /* ---------------------------------------- */
    /* >>> selected index >>> */
    private int modificationCount;
    public int getModificationCount() { return modificationCount;}
    public void run() {
        setLabToString();
        storeInProperties();
        mayAddHttpProxy(pan);
        if (panHSnf!=null) {panHSnf.revalidate();   ChDelay.repaint(panHSnf,99);}
        UIupdateList.update(UIupdateList.COMBOBOX);
    }
    public ChCombo s(int i) {
        if (i>=0) {
            handleEvent=false;
            super.setSelectedIndex(i);
            handleEvent=true;
        }
        return this;
    }
protected void selNextEnabled() {
        final Object o=getSelectedItem();
        if (o==null || !isEnabled(o)) {
            final ComboBoxModel m=getModel();
            for(int i=sze(m); --i>=0;) {
                final Object item=m.getElementAt(i);
                if (isEnabled(item)) {
                    s(item);
                    break;
                }
            }
        }
    }
    public ChCombo s(Object o) {
        if (o==null) return null;
        final ComboBoxModel m=getModel();
        final String cn=o instanceof Class ? ((Class)o).getName() : o instanceof String ? (String)o : null;
        for(int i=sze(m); --i>=0;) {
            final Object item=m.getElementAt(i);
            if (item instanceof ProxyClass && o==((ProxyClass)item).getClassInstance() ||
                item instanceof Class && cn!=null  && ((Class)item).getName().equals(cn) ||
                cn!=null && cn.equals(item) || o==item)  {
                if (o!=m.getSelectedItem()) {
                    m.setSelectedItem(o);
                    modificationCount++;
                    if (wasPainted) repaint();
                }
                return this;
            }
        }
        return this;
    }
    public int i() { return getSelectedIndex();}
    @Override public void setSelectedItem(Object o) {
        if (o!=getSelectedItem()) {
            modificationCount++;
            super.setSelectedItem(o);
        }
    }
    /* <<<  selected index <<< */
    /* ---------------------------------------- */
    /* >>> save >>> */
    private Class clas;
    private String id;
    public ChCombo save(Class clas,String id_str) {
        this.clas=clas; this.id="combobox_"+id_str;
        final int savedIdx=getPrpty(clas,id,-1);
        if (savedIdx>=0 && sze(getModel())>savedIdx) s(savedIdx);
        return this;
    }
    private void storeInProperties() {
        if (clas!=null && id!=null) setPrpty(clas,id, i());
    }
    /* <<< save <<< */
    /* ---------------------------------------- */
    /* >>> Renderer >>> */
    public ChCombo tt(Object o) { pcp(KEY_TOOLTIP,o,this); rtt(this); return this; }
    private boolean containsClasses;
    private Class myInterface;
    public ChCombo classRenderer(Class myInterface) {
        this.myInterface=myInterface;
        containsClasses=true;
        setRenderer(new ChRenderer().options(ChRenderer.CLASS_NAMES).setEnabled(this));
        rtt(this);
        return this;
    }
    private ScrollLabel labToString;
    @Override public String toString() { Object o=getSelectedItem(); return o!=null?o.toString() : ""; }
    private void setLabToString() {
        if (labToString!=null) {
            String s=TabItemTipIcon.item(getSelectedItem());
            final Object inst=instanceOfSelectedClass(null);
            if (s==null) s=toStrg(inst);
            s=rplcToStrg("\n"," ",s);
            s=rplcToStrg("<br>"," ",s);
            if (s==null) s="";
            final int l=s.length();
            final String txt=s.indexOf('@')>0 && s.startsWith(inst.getClass().getName()) ?  "" : s;
            final boolean license=l>0 && s.charAt(0)=='$';
            labToString.t(license ? "Read the license and conditions of use. "+txt : txt);
            labToString.setBackground(license ? RED: C(DEFAULT_BACKGROUND));
            labToString.setForeground(license? WHITE:BLACK);
        }
    }
    private JComponent labToString() {
        if (labToString==null) labToString=new ScrollLabel("");
        setLabToString();
        return labToString;
    }
    @Override public String getToolTipText(){
        ChCombo combo=(ChCombo)gcpa(KEY_CLONED_FROM,this);
        if (combo==null) combo=this;
        Object tt=gcpa(KEY_TOOLTIP,combo);
        if (tt instanceof CharSequence) return addHtmlTagsAsStrg(tt);
        if (tt instanceof CharSequence[]) {
            final CharSequence ss[]=(CharSequence[])tt;
            int i=i();
            if (i>=0 && i<ss.length) {
                return addHtmlTagsAsStrg(ss[i]);
            }
        }
        if (containsClasses) return TabItemTipIcon.tip(instanceOfSelectedClass(null));
        return super.getToolTipText();
    }
    /* <<< Renderer  <<< */
    /* ---------------------------------------- */
    /* >>> isEnabled >>> */
    public boolean isEnabled(Object o) {
        final Object oEnabled=gcp(KEY_ENABLED,this);
        final IsEnabled isEnabled=oEnabled instanceof IsEnabled ? (IsEnabled)oEnabled : null;
        if (isEnabled!=null) return isEnabled.isEnabled(o);
        final Class interFace=myInterface;
        if (interFace!=null) {
            if (!isAssignblFrm(interFace,o)) return false;
            if (NOT_AVAILABLE_CLASSES.contains(o)) return false;
        }
        return true;
    }
    /* <<< isEnabled <<< */
    /* ---------------------------------------- */
      /* >>> Choice of Class  >>> */
    private Map mapSharedInstances;
    public <T extends Object>T instanceOfSelectedClass(Class<T> clazz) {
        if (myInterface==null) return null;
        if (mapSharedInstances==null) mapSharedInstances=new HashMap();
        final Object selected=getSelectedItem();
        Object instance=mapSharedInstances.get(selected);
        if (instance==null) mapSharedInstances.put(selected, instance=HotswapUtil.instance(selected));
        return clazz==null || isAssignblFrm(clazz,instance) ? (T)instance : null;
    }
    /* <<< Choice of Class <<< */
    /* ---------------------------------------- */
    /* >>>  >>> */

}
