package charite.christo;
import charite.christo.interfaces.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
//import static java.lang.System.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;

/**
In Java1.4 the shell variables are read by calling the command "set".
In Java1.5 the method  System.getenv(s); is user.
*/
public class ChEnvironment {
    {  assertInstAllowed(); }
    private ChEnvironment(){}
    private static Map<String,String> map;
    private static synchronized Map<String,String> get() {
        Map m=map;
        if (m==null) {
            m=map=new HashMap();
            final boolean isWin=isWindows();
            Map mSyst=null;
            try { mSyst=System.getenv(); } catch(Throwable ex) {putln("Caught in ChEnvironment "+ex);}
            if (mSyst!=null) m.putAll(mSyst);
            else {
                final ChExec ex=new ChExec(ChExec.STDOUT).setCommandLine("SH set");
                ex.run();
                for(String s : splitStrg(ex.getStdout(),'\n')) {
                    final int iEqu=s.indexOf('=');
                    if (iEqu<1 || !is(LETTR_DIGT,s.charAt(0)) || !is(LETTR_DIGT,s, iEqu-1)) continue;
                    final String k=s.substring(0,iEqu), v=s.substring(iEqu+1);
                    m.put(k,v);
                }
                ex.dispose();
            }
            final int L=m.size();
            final String[] vDollarKeys=new String[(isWin?2:1)*L], vKeys=new String[L], vFile=new String[vDollarKeys.length];
            int iDollarKeys=0, iKeys=0, iFile=0;
            for(Map.Entry e : entryArry(m)) {
                final String k=(String)e.getKey(), v=(String)e.getValue();
                final String dk="$"+k;
                m.put(dk,v);
                vDollarKeys[iDollarKeys++]=dk;
                vKeys[iKeys++]=k;
                final boolean isFile= looks(LIKE_FILEPATH,v) && new File(v).exists();
                if (isFile) vFile[iFile++]=dk;
                if (isWin) {
                    final String pk="%"+k+"%";
                    m.put(pk,v);
                    vDollarKeys[iDollarKeys++]=pk;
                    if (isFile) vFile[iFile++]=pk;
                }
            }

            ChEnvironment.keys=new String[][]{
                chSze(vKeys,iKeys),
                chSze(vDollarKeys,iDollarKeys),
                chSze(vFile,iFile)
            };
        }
        return m;
    }

    public final static int WITHOUT_DOLLAR=0, WITH_DOLLAR=1, WITH_FILEPATH=2;
    private static String[][] keys;
    public static String[] getNames(int i) {  get();  return keys[i];  }

    public static String get(String s) { return s!=null ? get().get(s) : null; }

    public static void show() {
        final StringBuffer sb=new StringBuffer(9999);
        final String nn[]=ChUtils.getFinalStaticFields(ChUtils.class,30);
        for(int i=0; i< nn.length; i++) {
            if (nn[i]==null) continue;
            sb.append(nn[i]).append(' ');
            if(nn[i].startsWith("SYSP_")) sb.append(systProprty(i)); else sb.append(isSystProprty(i));
            sb.append('\n');
        }
        for(String s : new String[]{".", "..", "~/", "~", "~/@/", "~/@/bin",  "@/", "@/bin"}) sb.append(s).append("   ").append(file(s)).append('\n');
        sb.append(
                  "javaVsn="+javaVsn()+
                  "\n argv="+joinAsStrg(getPrgParameters(),",")+
                  "\n\n ClassLoader ="+CLASSLOADER+
                  "\n dirWorking()="+dirWorking()+
                  "\n dirHome()="+dirHome()+
                  "\n plugins="+urlDirPlugins()+
                  "\n urlThisJarFile()="+urlThisJarFile()+
                  "\n thisJarFile()="+thisJarFile()+
                  "\n isMyComputer()="+isMyComputer()+
                  "\n"
                  );
        if (isWindows()) {
            final File f1=file("C:\\temp"), f2=file("\\temp");
            String cp1=null,cp2=null;
            try {
                cp1=f1.getCanonicalPath();
                cp2=f2.getCanonicalPath();
            } catch(Exception e){stckTrc(e);}
            sb.append(f1+" getCanonicalPath ="+cp1+ "\n"+f2+" getCanonicalPath ="+cp2+ "\n"+" equals = "+f1.equals(f2)+"\n");
        }
        sb.append("envWithFilepath="); for(String s : getNames(WITH_FILEPATH)) sb.append(s).append(' '); sb.append('\n');
        for(int i=0;i<2;i++) {
            sb.append("\n\nFile.list"+(i==0?"":"Existing")+"Roots()=\n");
            for(File f: i==0? File.listRoots() : listExistingFileRoots())
                sb.append(f).append(f.canRead() ? " (exists) " : " (not available) ").append("\n");
        }

        sb.append("\n\nSystem.getProperties()\n");
        for(Object  key : keyArry(System.getProperties())) sb.append(key+" ==> "+System.getProperties().get(key)+"\n");
        sb.append("\n");
        sb.append("C:\\temp = "+file("C:\\temp")+"\n /cygdrive/C/temp = "+file("/cygdrive/C/temp")+"\n");

        new ChTextArea(sb).showInFrame("properties",ChFrame.STAGGER).tools().underlineRefs(UNDERLINE_REFS);

        /* ---------------------------------------- */
        final ChTextArea tp=new ChTextArea("");
        int longest=0;
        for(String k : getNames(WITHOUT_DOLLAR )) if (longest<k.length()) longest=k.length();
        for(String k : getNames(WITHOUT_DOLLAR)) {
            if (is(LETTR_DIGT_US,k,0)) {
                for(int j=longest-k.length(); --j>0;) tp.appnd(" ");
                tp.appnd(ANSI_YELLOW,k,"   "+ANSI_RESET, get(k),"\n\n");
            }
        }
        tp.showInFrame("ChEnvironment: environment variables",ChFrame.STAGGER);

    }
}
