package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.lang.ref.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**
   @author Christoph Gille
*/
public class ChFileChooser extends JFileChooser implements ActionListener, KeyListener {
    private String id;
    public ChFileChooser(Class c) { this(c.getName()); }
    public ChFileChooser(String id) {
        this.id=id;
        if (id!=null) {
            File dir=file(getPrpty(ChFileChooser.class,id,null));
            if (dir!=null && dir.isDirectory()) setCurrentDirectory(dir);
        }
        setDragEnabled(true);
        setMinimumSize(dim(4*EM,4*EX));
        addActionListener(this);
    }
    private JComponent panel=this, pSouth;
    public JComponent getPanel() { return panel; }
    public ChFileChooser addButton(JComponent but) {
        if (panel==this) { panel=new ChPanel(new BorderLayout()); panel.add(this,BorderLayout.CENTER);}
        if (pSouth==null) { panel.add(pSouth=new ChPanel(),BorderLayout.SOUTH);}
        pSouth.add(but);
        return this;
    }
    public ChButton butProject() { return butDir(dirWorking(),"go to project directory");}
    public ChButton butDir(File dir,String title) {
        return new ChButton(">"+dir).t(title).li(this);
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    public void keyPressed(KeyEvent ev) {
        final ChTextComponents tools=gcp("TOOLS",ev.getSource(),ChTextComponents.class);
        if (tools!=null) tools.processEvent(this,ev);
    }
    public void keyReleased(KeyEvent ev) {}
    public void keyTyped(KeyEvent ev) {}
    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        if (chrAt(0,cmd)=='>') setCurrentDirectory(file(cmd.substring(1)));
        if (id!=null)
            setPrpty(ChFileChooser.class,id,getCurrentDirectory()+"");
        if ((CANCEL_SELECTION==cmd || APPROVE_SELECTION==cmd) && setVisibleFalse)
            try {
                parentWndw(this).setVisible(false);
            } catch(Exception e) { }
        if (APPROVE_SELECTION==cmd || CANCEL_SELECTION==cmd) handleActEvt(this,cmd,ev.getModifiers());
    }
    /* <<< AWTEvent <<< */
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    private boolean paintFirstTime=true;

    public void paintComponent(Graphics g) {
        antiAliasing(g,false);
        super.paintComponent(g);
        for(JTextField tf : childs(this,JTextField.class)) {
            if (gcp("TOOLS",tf)==null) {
                pcp("TOOLS",new ChTextComponents(tf).enableWordCompletion(this),tf);
                tf.addKeyListener(this);
            }
        }
        if (paintFirstTime){
            paintFirstTime=false;

            LookAndFeel old=UIManager.getLookAndFeel();
            try {
                UIManager.setLookAndFeel((LookAndFeel)Class.forName(UIManager.getSystemLookAndFeelClassName()).newInstance());
                SwingUtilities.updateComponentTreeUI(this);
            } catch(Exception e){}
            try{
                UIManager.setLookAndFeel(old);
            }catch(Exception e){}
        }

    }

    private ChFileFilter filter_;
    public ChFileFilter filter() { if (filter_==null) addChoosableFileFilter(filter_=new ChFileFilter()); return filter_;}
    public ChFileChooser setVisibleFalseParentFrame() {setVisibleFalse=true; return this;}
    private boolean setVisibleFalse;

}
