package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.util.List;
import java.lang.ref.*;
import java.awt.event.*;
import static java.awt.event.WindowEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   @author Christoph Gille
addComponentListener addContainerListener
*/
public class ChFrame extends JFrame implements  ActionListener {
    public final static long
        SCROLLPANE=1<<10, ALWAYS_ON_TOP=1<<11, TO_FRONT=1<<12,
        AT_CLICK_R=1<<13, CENTER=1<<14, AT_CLICK=1<<15, STAGGER=1<<16, TO_ICON=1<<17,
        CLEAR_BUTTON=1<<18, PACK=1<<19,     DISPOSE_CHILDREN=1<<20, SYSTEM_EXIT_WHEN_ALL_CLOSED=1<<21,
        ICONIFY_ON_CLOSE=1<<22, DISPOSE_ON_CLOSE=1<<23,  SHUT_DOWN_ON_CLOSE=1<<24, SIZE_REGARD_RESOLUTION=1<<25,
        SHOW_IF_NOT_ICONIFIED=1<<30, SHOW_IF_VISIBLE=1<<31;
    static { assert RM_TAB_ON_CtrlW<SCROLLPANE; }

    private static long globalOptions;
    public static void setGlobalOptions(long options) { globalOptions=options;}
    private Component titleBar;
    public final static Reference<ChFrame> gainedFocus[]=new Reference[2];
    @Override protected void finalize() throws Throwable{ logFinalize(ANSI_CYAN+"ChFrame",""); super.finalize(); }
    private static ChButton togNative_;
    private long options;
    public static ChButton togNative() {
        if (togNative_==null)  togNative_=toggl("Use Java style window decorations").li(getMainFrame());
        return togNative_;
    }
    private static List<Reference> vFrames;
    protected static Component imageObserver() {
        synchronized(vFrames) {
            for(int i=sze(vFrames); --i>=0;) {
                final Component c=get(i,vFrames,Component.class);
                if (c!=null && c.isVisible()) return c;
            }
        }
        return null;
    }

    private static Reference<ChFrame> refLastFrame, refMainFrame;
    public static ChFrame getMainFrame() { return deref(refMainFrame,ChFrame.class);}
    public static void setMainFrame(ChFrame f) {
        refMainFrame=weakRef(f);
        if (togNative_!=null) togNative_.li(f);
    }
    public final ChFrame size(int w,int h) { setSize(maxi(1,w),maxi(1,h)); return this;}
    public final ChFrame t(String s) { setTitle(rplcToStrg("<br>"," ",s)); return this;}
    private boolean alreadyShown;
    public final Thread thread_shw(long options) { return threadM("shw",this,new Object[]{longObjct(options)}); }
    public final ChFrame shw(long options) {
        if (!isEDT()) {
            inEDT(thread_shw(options));
            return this;
        }
        this.options=options;

        if ( (options&SHOW_IF_NOT_ICONIFIED)!=0 && getExtendedState()==JFrame.ICONIFIED) return this;
        if ( (options&SHOW_IF_VISIBLE)!=0 && !isVisible()) return this;
        boolean alwaysOnTop=false;
        if (javaVsn()>14) { alwaysOnTop=isAlwaysOnTop(); setAlwaysOnTop(true);}
        alreadyShown=true;
        setVisible(true);
        setExtendedState(NORMAL);
        setVisible(true);
        refLastFrame=weakRef(this);
        final String title=getTitle();
        if (sze(title)>0 && (options&TO_FRONT)!=0) {
            setWndwStateLaterT('F', 999, title);
            final Thread t=thread_setWndwState('F',this);
            t.run();
            runAftrMS(333,t);
        }
        if (javaVsn()>14) setAlwaysOnTop(alwaysOnTop);
        applyOptions(options, deref(refJC,JComponent.class));
        try {
            final Rectangle screen=getGraphicsConfiguration().getBounds();
            final Point l=getLocation();
            final int y=screen.y+screen.height-getHeight();
            final int x=screen.x+screen.width-getWidth();
            if (l.y>y || l.x>x)  setLocation(l.x>x ? x:l.x, l.y>y ? y : l.y);

        } catch(Exception e){}
        return this;
    }

    public void processWindowEvent(WindowEvent e) {
        final int id=e.getID();
        String evt=null;
        if (id==WINDOW_ACTIVATED || id==WINDOW_GAINED_FOCUS || id==WINDOW_DEICONIFIED) {
            if (gainedFocus[1]!=weakRef(this)) gainedFocus[0]=weakRef(this);
        }
        if (id==WINDOW_DEACTIVATED) evt=ACTION_WINDOW_DEACTIVATED;
        if (id==WINDOW_ACTIVATED) evt=ACTION_WINDOW_ACTIVATED;
        if (id==WINDOW_CLOSING) {
            setVisible(false);
            if ( (this.options& (DISPOSE_ON_CLOSE|DISPOSE_CHILDREN))!=0)  this.dispose();
            if ( (this.options&SHUT_DOWN_ON_CLOSE)!=0)  shutDown();
            evt=ACTION_WINDOW_CLOSING;
            if ( (options&ICONIFY_ON_CLOSE)!=0) { show();  setExtendedState(ICONIFIED); }
        }  else super.processWindowEvent(e);
        if (evt!=null) handleActEvt(this,evt,0);
    }
    private final long[] durationValidate=new long[ARRAY_DURATION];
    public final ChFrame ad(Object obj) {
        final Component c=getPnl(obj);
        if (c instanceof Container) setContentPane((Container)c);
        else  if (c!=null) getContentPane().add(c);
        ChDelay.afterMS(0,ChDelay.VALIDATE,this,333,null,durationValidate);
        return this;
    }

    public final ChFrame relativeSize(double x,double y) {
        Rectangle screen=getGraphicsConfiguration().getBounds();
        size(maxi(640,(int)(screen.width*x)),maxi(400,(int)(screen.height*y)));
        return this;
    }
    {  assertInstAllowed(); }
    public ChFrame(String title) {
        t(title);
        if (!imageIconCausesException)  { ImageIcon ic=iicon(IC_STRAP); if (ic!=null) setIconImage(ic.getImage()); }
        size(366,366);
        try {
            ((JComponent)getContentPane()).revalidate();
            validate();
        }catch(Exception e){}
        gainedFocus[0]=weakRef(this);
        if (togNative_!=null && togNative_.s()) setJavaStyle(true);
        (vFrames==null ? vFrames=new ArrayList() : vFrames).add(weakRef(this));
    }
    private void setJavaStyle(boolean javaStyle) {
        setDefaultLookAndFeelDecorated(javaStyle);
        if (javaStyle) {
            try { setUndecorated(javaStyle); }catch(Exception e){ }
            final JRootPane rp=getRootPane();
            {
                rp.setWindowDecorationStyle(JRootPane.FRAME);
                final JMenu m=child(rp, JMenu.class);
                if (m!=null) {
                    if (child(m,JSeparator.class)==null) {
                        m.add(new JSeparator());
                        final JMenuItem mi=(JMenuItem)toggl("T").li(this).mi("Always floating on top");
                        m.add(mi);
                        mi.setAccelerator(KeyStroke.getKeyStroke('T',KeyEvent.CTRL_MASK));
                        ChTextField tf=new ChTextField(getTitle()).cols(40,true,false).li(this);
                        tf.tools().underlineRefs(UNDERLINE_REFS_NOT_CLICKABLE);
                        m.add(hB("Title: ",tf));
                    }
                    if (this.titleBar==null) {
                        this.titleBar=parnt(parnt(m, Container.class), Container.class);
                        if (this.titleBar!=null) {
                            for(int i=0;i<2;i++)
                                for(MouseMotionListener mml : (i==0?titleBar:this).getListeners(MouseMotionListener.class))
                                    removeMouseMotionListener(mml);
                            setDragMovesWindow(titleBar,this);
                            mouseOverPrintMsg(this,new String[]{"Use left corner menu","to enable \"Floating on-top\""},titleBar,-66,-2,getFnt(10,false,0));
                            mouseOverPrintMsg(titleBar,new String[]{"Use left corner menu","to enable \"Floating on-top\""},titleBar,-66,-2,getFnt(10,false,0));
                        }
                    }
                }
            }
        }
    }
    public final ChFrame i(String icon) { return i(iicon(icon));}
    public final ChFrame i(Icon ic) {
        if (ic instanceof ImageIcon) {
            Image im=((ImageIcon)ic).getImage();
            if (im!=null && !imageIconCausesException)  setIconImage(im);
        }
        return this;
    }
    public static ChFrame textFrame(byte bb[], int lettersPerLine) {
        StringBuffer sb=new StringBuffer(bb!=null ? bb.length+bb.length/20 : 0);
        foldText(bb,0,MAX_INT,lettersPerLine,sb);
        return new ChFrame("").ad(new ChTextArea("").t(sb).tools().scrollPane()).shw(AT_CLICK);
    }

    private boolean imageIconCausesException;
    @Override public void show() {
        try { super.show(); } catch(Exception e) {
            setIconImage(null);
            imageIconCausesException=true;
            super.show();
        }
    }
    @Override public void setVisible(boolean b) {
        try { super.setVisible(b); } catch(Exception e) {
            setIconImage(null);
            super.setVisible(b);
            imageIconCausesException=true;
        }
    }
    private boolean isDisposed;
    public boolean isDisposed() { return isDisposed;}
    @Override public void dispose() {
        if ( (options&DISPOSE_CHILDREN)!=0) {
            disposeChildren(getContentPane());
            rmAllChilds(getContentPane());
        }
        super.dispose();
        isDisposed=true;
        if ( ((globalOptions|options)&SYSTEM_EXIT_WHEN_ALL_CLOSED)!=0) {
            for(int i=sze(vFrames); --i>=0;) {
                final ChFrame f=get(i,vFrames,ChFrame.class);
                if (f==null || f.isDisposed) vFrames.remove(i);
            }
            if (sze(vFrames)==0) shutDown();
        }
        for(Map.Entry<Object,ChFrame> e :  entryArry(mapContentFrame)) {
            if (e.getValue()==this) mapContentFrame.remove(e.getKey());
        }
    }

    private final static Map<Object,ChFrame> mapContentFrame=new WeakHashMap();
    private Reference refJC;
    public long getOptions() { return options;}
    public static ChFrame frame(String title,  Object object,  long options) {
        final Object o=gcp(KEY_PANEL,object)!=null ? gcp(KEY_PANEL,object) : object;

        ChFrame f=mapContentFrame.get(o);
        if (f==null || f.isDisposed()) {
            final ChTextComponents tools=ChTextComponents.tools(o);
            final JComponent jc=o instanceof JComponent ?(JComponent)o : null;
            final OverlayScrollPane osp=tools!=null ? OverlayScrollPane.getSP(jc) : null;
            if (osp!=null && (options&CLEAR_BUTTON)!=0) osp.addButton(tools.newClearButton());
            final Object cont= osp!=null ? osp :
                jc!=null && (options&SCROLLPANE)>0 && child(jc,JScrollPane.class)==null ? scrllpn(0L,jc) : o,
                pNorth=gcp(KEY_NORTH_PANEL,o),
                pSouth=gcp(KEY_SOUTH_PANEL,o);

            f=new ChFrame(title).ad(pNorth!=null||pSouth!=null?newCNSEW(cont,pNorth,pSouth,null,null) :cont);
            f.refJC=weakRef(jc);
            f.applyOptions(options, jc);
            mapContentFrame.put(o,f);
            f.options=options;
        }
        return f;
    }

    private void applyOptions(long options, JComponent jc) {
        try {
            if ((options&AT_CLICK)!=0)    setLocation(EVT_LAST_XY[0], EVT_LAST_XY[1]);
            if ((options&AT_CLICK_R)!=0)  setLocation(EVT_LAST_XY[0]-getWidth(), EVT_LAST_XY[1]);
        } catch(Exception e){}
        if ((options&CENTER)!=0) setLocationRelativeTo(null);
        final long closeOptions=options& (CLOSE_ON_CtrlW|DISPOSE_ON_CtrlW|CLOSE_ON_ESC|DISPOSE_ON_ESC);
        ChFrame ff[]=null;
        for(int j=2; closeOptions!=0 && --j>=0;) {
          for(JComponent  c: childs(getContentPane(), j==0 ? AsciiView.class: javax.swing.text.JTextComponent.class)) {
            closeOnKeystroke(c,ff==null?ff=new ChFrame[]{this}:ff,closeOptions);
          }
        }

        if ((options&PACK)!=0) pack();

        if ((options&ALWAYS_ON_TOP)!=0 && javaVsn()>14) super.setAlwaysOnTop(true);
        if ((options&STAGGER)!=0 && !alreadyShown) {
            final ChFrame lastFrame=deref(refLastFrame,ChFrame.class);
            final Point loc=lastFrame!=null ? lastFrame.getLocation() :  new Point(50,50);
            setLocation(loc.x+20,loc.y+20);
        }
        if ((options&TO_ICON)!=0) setExtendedState(ICONIFIED);
        if ((options&SIZE_REGARD_RESOLUTION)!=0)  setSizeAccordingTo(jc, 0,0);

    }

    public void setSizeAccordingTo(JComponent jc, int extraW, int extraH) {
        final Dimension d=jc!=null ? jc.getPreferredSize() : null;
        final Rectangle screen=getGraphicsConfiguration().getBounds();
        if (screen!=null && d!=null) {
            final Point p=getLocation();
            final int w=mini(screen.width -4*EM-p.x, d.width +extraW+4*EM);
            final int h=mini(screen.height-4*EX-p.y, d.height+extraH+4*EX);
            size(w, h);
        }
    }
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        final boolean isSel=isSelctd(q);
        if (cmd=="T")  {
            if (javaVsn()>14) super.setAlwaysOnTop(isSel);
            final Graphics g=titleBar!=null ? titleBar.getGraphics() : null;
            if (g!=null) { g.setColor(C(isSel?0x00FF00 : 0x0000ff)); g.fillRect(0,0,9999,4);}
        }
        if (q instanceof ChTextField )   setTitle(toStrg(q));
    }

}

/*

http://saloon.javaranch.com/cgi-bin/ubb/ultimatebb.cgi?ubb=get_topic&f=2&t=014048
JRootPane
MetalRootPaneUI

MetalIconFactory
  MetalTitlePane
MetalTitlePane
JFrame

http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6491619
http://www.onjava.com/pub/a/onjava/excerpt/swinghks_hack41/index.html?page=3
*/
