package charite.christo;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   @author Christoph Gille
*/
public final class ChJMenu extends JMenu implements MouseListener, ActionListener {
    {  assertInstAllowed(); addMouseListener(this);}
    private Object oIcon;
    public void i(Object icon) {oIcon=icon;}
    {enableEvents(MOUSE_EVENT_MASK|MOUSE_MOTION_EVENT_MASK);}
    @Override public Insets getMargin() { return UserProfile.isHidden(this) ? insets0(false) : super.getMargin();}
    @Override public Dimension getPreferredSize() {
        {
            final Dimension ps=getPrefSize(this);
            if (ps!=null) return ps;
        }
        return
            getText()==KEY_ACCELERATOR ||UserProfile.isHidden(this) ? dim(0,0):
            super.getPreferredSize();
    }
    @Override public void processEvent(AWTEvent ev) {
        if (UserProfile.isHidden(this)) return;
        super.processEvent(ev);
    }
    @Override public void paintComponent(Graphics g) {
        if (oIcon!=null) {
            super.setIcon(oIcon instanceof Icon ?(Icon)oIcon : iicon(toStrg(oIcon)));
            oIcon=null;
        }
        if (UserProfile.isHidden(this)) g.clearRect(0,0,999,999);
        else try { super.paintComponent(g);} catch(Throwable ex){}
    }
    @Override public Icon getIcon() {
        return isIconsInMenus() ? super.getIcon() : null;
    }

    @Override public void menuSelectionChanged(boolean isIncluded) {
        super.menuSelectionChanged(isIncluded);
        handleActEvt(this, CMD_MENU_SELECTION_CHANGED,0);
        final Menu awtM=this.awtMenu;
        if (awtM!=null) {
            long hc=0;
            for(int i=awtM.getItemCount(); --i>=0;) {
                hc+=awtM.getItem(i).hashCode()+awtM.getItem(i).getLabel().hashCode()<<32;
            }
            if (awtMenuHC!=hc) {
                removeAll();
                awtMenuHC=hc;
                menu2jAddItems(awtM,this);
                this.awtMenuHC=awtM.getItemCount();
            }
        }
    }

    public void mouseExited(MouseEvent ev) {}
    public void mouseEntered(MouseEvent ev) {
        if (isSelctd(togDebug)) putln("ChJMenu mouseEntered ",getText());
        getLocationOnScreen();
    }
    public void mouseReleased(MouseEvent ev) {}
    public void mouseClicked(MouseEvent ev) {}
    public void mousePressed(MouseEvent ev) {}
    private static ChButton togDebug;
    public static ChButton togDebug() { return togDebug==null ? togDebug=toggl("Debug menu") : togDebug;}
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> awt-Menu >>> */
    private final static Object KEY_AWT_MI=new Object();
    private Menu awtMenu;
    private long awtMenuHC;
    private String rplcMenuItems[][];
    protected ChJMenu setAwtMenu(Menu m, String[][] rplc) {
        this.awtMenu=m;
        this.rplcMenuItems=rplc;
        String label=m.getLabel();
        for(int j=sze(rplc); --j>=0;) {
            if (label.equalsIgnoreCase(rplc[j][0]) && get(1,rplc[j])!=null) label=get(1,rplc[j]);
        }
        setText(label);
        setHeavy(this);
        return this;
    }
    protected void menu2jAddItems(Menu m, JMenu jm) {
        nextItem:
         for(int i=0; i<m.getItemCount(); i++) {
            final MenuItem it=m.getItem(i);
            final String label0=it.getLabel(), rplc[][]=this.rplcMenuItems;
            String label=label0;
            for(int j=sze(rplc); --j>=0;) {
                if (label0.equalsIgnoreCase(rplc[j][0])) label=get(1,rplc[j]);
            }
            if (label==null) continue;
            if ("-".equals(label)) jm.addSeparator();
            else if (it instanceof Menu) jm.add(new ChJMenu().setAwtMenu((Menu)it,this.rplcMenuItems));
            else {
                final CheckboxMenuItem cb=it instanceof CheckboxMenuItem ? ((CheckboxMenuItem)it) : null;
                final ChButton b=new ChButton(cb!=null ? 'T':'B',label).li(this);
                if (cb!=null) b.s(cb.getState());
                pcp(KEY_AWT_MI,it, b);
                setUndockble(b);
                jm.add(b.mi(null));
            }
        }
    }
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final MenuItem mi=(MenuItem)gcp(KEY_AWT_MI,q);
        if (mi!=null) {
            if (mi instanceof CheckboxMenuItem) ((CheckboxMenuItem)mi).setState(isSelctd(q));
            final ActionEvent aev=new ActionEvent(mi,ActionEvent.ACTION_PERFORMED, mi.getActionCommand(),modifiers(ev));
            for(ActionListener al  : mi.getActionListeners()) al.actionPerformed(aev);
        }
    }

    /* <<< awt-Menu <<< */
    /* ---------------------------------------- */
    /* >>>  >>> */

    /*
      @Override public void setPopupMenuVisible(boolean b) {
      stckTrc();
        super.setPopupMenuVisible(b);
    }
    */

}

/*
I click "Options"-menu, the help "Options"-menu opens for a 10th of a second, then opens the "File"-menu.
*/