package charite.christo;
import java.io.*;
import java.util.zip.*;
import static charite.christo.ChUtils.*;

public class ChJarrer implements FileFilter {
    public static void makeJarFile(File  jarFile, File jarDir,File[] files,FileFilter filter){
        ZipOutputStream jarOut = null;
        try {
            mkParentDrs(jarFile);
            final OutputStream fileOut = fileOutStream(jarFile);
            jarOut = new ZipOutputStream(fileOut);
            jar(jarOut,jarDir.getAbsolutePath().length()+1,files,filter);
        }catch(Exception ioe){ putln("caught makeJarFile "+ioe);}
        finally {closeStrm(jarOut);}
    }
    private static void jar(final ZipOutputStream jarOut,int jarDirLength,  File[] files,FileFilter filter){
        try {
            for(final File f:files){
                if (f.isDirectory()) {
                    jar(jarOut,jarDirLength,f.listFiles(),filter);
                } else if (filter==null || filter.accept(f)) {
                    final InputStream from=new FileInputStream(f);
                    final String fileName = f.getAbsolutePath().substring(jarDirLength).replace('\\','/');
                    final ZipEntry entry = new ZipEntry(fileName);
                    jarOut.putNextEntry(entry);
                    try {
                        final byte[] buffer=new byte[4096];
                        int bytes_read;
                        while((bytes_read=from.read(buffer))!=-1) {
                            Thread.yield();
                            jarOut.write(buffer,0,bytes_read);
                        }
                    } catch(Exception e){}
                    finally { closeStrm(from);}
                }
            }
        }catch(IOException ioe){ stckTrc(ioe); }
    }
    public boolean accept(File f) {
        return f!=null && !f.getName().endsWith(".o") && !f.getName().endsWith(".O");
    }
    private ChJarrer(){}
}
