package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.io.File;
import java.util.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static javax.swing.JOptionPane.*;
/**
   Some modale message dialogs
   @author Christoph Gille
*/
public class ChMsg implements ChRunnable {
    private  static String TITLE="STRAP-dialog";
    public static void setDefaultTitle(String s) {TITLE=s;}
    public static String titleReopenCtrl_I() { return "You can close this window. Reopen with "+(isSystProprty(IS_MAC)?"Command-":"Ctrl")+"+i";}

    private ChMsg(){}
    private static ChMsg inst;
    private static ChMsg instance() {if (inst==null) inst=new ChMsg(); return inst;}

    private static Window getMainF() {
        final ChFrame f=ChFrame.getMainFrame();
        return f!=null && f.isVisible() ? f : null;
    }

    public static void msgDialog(Object o) {
        showMessageDialog(getMainF(),addTags(0L,o),TITLE,INFORMATION_MESSAGE);
    }

    public static  boolean yesNo(Object o){ return yesNo(0L,o);}
    public static  boolean yesNo(long options,Object o){
        nativeToFront(TITLE);
        return 0==showConfirmDialog(getMainF(),new Object[] {addTags(options,o)},TITLE,YES_NO_OPTION,QUESTION_MESSAGE);
    }

    public static String askUserHome(String old) {
        String msg="<sub>";

        String varHome=isWindows() ? "HOMEPATH":"HOME";
        if (ChUtils.javaVsn()>14) msg+="Environment $"+varHome+"="+ChEnvironment.get(varHome)+"<br>";
        msg+="System.getProperty("+USER_DOT_HOME+")="+sysGetProp(USER_DOT_HOME)+"<br>";
        msg+="</sub><br>Problem: System.getProperty(user.home) is not defined. <br>Please enter the user home path";
        return (String)showInputDialog(getMainF(),addTags(0L,msg),TITLE,QUESTION_MESSAGE,null,null,old);
    }

    public final static long AT_CLICK=ChFrame.AT_CLICK;
    public static String input(long options, Object msg, int size, String old) {
        nativeToFront(TITLE);
        return (String)showInputDialog(getMainF(), addTags(options,msg),TITLE,QUESTION_MESSAGE,null,null,old);
    }

    private static int option_;
    private static Window win;
    public Object run(String id,Object arg) {
        if (id=="AT_CLICK") {
            sleep(222);
            try {
                final Window w=parentWndw(arg);
                if (w!=null) w.setLocation(EVT_LAST_XY[0], EVT_LAST_XY[1]);
            } catch(Throwable ex){}
        }
        if (id=="toFront") setWndwState('F',(Frame)arg);
        if (id=="OPTION") {
            sleep(333);
            //Exception in thread \"AWT-EventQueue-0\" java.lang.ArrayIndexOutOfBoundsException: No such child: 4
            //at java.awt.Container.getComponent(Container.java:280)
            //at javax.swing.JComponent.rectangleIsObscured(JComponent.java:4123)
            final Object oo[]=(Object[])arg;
            final String title=(String)oo[0];
            Object msg=addTags(0L,oo[1]);
            final Object choice[]=(Object[]) oo[2];
            if (!(msg instanceof JComponent)) msg=pnl(msg);
            for(int iTry=3;--iTry>=0;)
                try {
                    nativeToFront(TITLE);
                    option_= showOptionDialog(getMainF(),msg,title,DEFAULT_OPTION,QUESTION_MESSAGE,null,choice,null);
                    win=parentWndw(msg);
                    setEventLocationOnScreen(win);
                    break;
                } catch(Throwable e) { option_=0; putln("Caught in ChMsg ",e);}
        }

        if (id.startsWith("SOUND_") && isSound && System.currentTimeMillis()-whenLastSound>999) {
            String sound=id=="SOUND_FAILURE" ? "failed" : "finished";
            try {
                java.applet.Applet.newAudioClip(resourceAsURL("charite/christo/myIcons/"+sound+".wav")).play();
                whenLastSound=System.currentTimeMillis();
            } catch(Exception e){}
        }
        return null;
    }
    public static synchronized int option(Object msg,Object[] oo) {
        final Object param[]={TITLE,msg,oo};
        ChDelay.invokeAndWait(instance(),"OPTION",param);
        return option_;
    }
    public static Object optionVal(Object msg,Object[] oo) {
        int i= option(msg,oo);
        return i<0 ? null : oo[i];
    }
    private static Object addTags(long options, Object o) {
        if (o==null) return null;
        final Component c=o instanceof CharSequence ? pnl(o) : o instanceof Component ? (Component)o : null;
        if (c!=null) {
            repaintOnMouseEnterAndExit(c);
            ChDelay.repaint(c,2222);
            revalidate_whenMouseEnter1(true,c);
            for(int sleep=3; --sleep>=0;) newThrd(threadSleep(sleep*99+99),thread_setWndwState('F', c)).start();
        }
        if (c!=null) {
            final Thread t=thread_setWndwState('T',c);
            newThrd(threadSleep(3333),t,threadSleep(3333),t).start();
            if (0!=(options&AT_CLICK)) ChDelay.newThread(instance(),"AT_CLICK",c).start();
            return c;
        }

        return o;
    }

    private static File dirSavedMessages_;
    private static File dirSavedMessages() {
        if (dirSavedMessages_==null)
            mkdrsErr(dirSavedMessages_=file("~/@/savedMsgs"),"Here are messages that had been shown previously.");
        return dirSavedMessages_;
    }
    private static String[] savedMsgsFF;
    private static Collection vAlreadyShown=new HashSet();
    public static void savedMsg(CharSequence msg,String id) {
        if (vAlreadyShown.contains(id)) return;
        vAlreadyShown.add(id);
        final File dir=dirSavedMessages();
        {
            final int baseL=prevE(NO_DIGT,id,999,0);
            String id0=id.substring(0,baseL);
            if (savedMsgsFF==null) savedMsgsFF=dir.list();
            if (savedMsgsFF==null) savedMsgsFF=NO_STRING;
            for(String f:savedMsgsFF){
                if (!f.equals(id) && f.startsWith(id0) && baseL==prevE(NO_DIGT,f,999,0)) {
                    delFile(file(dir,f));
                }
            }
        }

        final File f=file(dir,id);
        if (sze(f)>0 || msg==null) return;
        final StringBuffer sCR=toStringBuffer(msg);
        rplcSb(0L,"\n","<br>",sCR);
        wrte(f,sCR);
        sCR.append("<br><br>All messages can be reviewed by typing <font color=\"RED\"> CTRL+I </font>");
        addHtmlTags(sCR.append("<br><br>&nbsp;"));
        new ChTextViewer(sCR).infoIcon().shw(0);
    }
    public static void showAllPreviousMsgs() {
        for(String del: new String[]{"scrollV","alignmentMouseWheel","strapWeb","FileBrowser"}) {
            delFile(file(dirSavedMessages(),del));
        }
        final String files[]=dirSavedMessages().list();
        if (files!=null && files.length>0) {
            final StringBuffer sb=new StringBuffer(9999);
            for(String f:files) {
                sb.append((Object)readStrg(file(dirSavedMessages(),f))).append("<br><hr>");
            }
            addHtmlTags(sb);
            new ChTextViewer(sb).title("Previous messages").shw(0).infoIcon();
        }
        if (frameError!=null) { frameError.show(); frameError.setExtendedState(JFrame.NORMAL);}
        if (InteractiveDownload.frameDownloads!=null) { InteractiveDownload.frameDownloads.show(); InteractiveDownload.frameDownloads.setExtendedState(JFrame.NORMAL);}
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Error >>> */
    private static ChTabPane tabbedPaneError;
    private static ChFrame frameError;
    private final static Map<String,JComponent> MAP_ERROR=new HashMap();
    private static int iError;
    private static Runnable RUN_ERROR_F, RUN_MSG_F;
    static Thread thread_showError(long frameOpt, CharSequence s,JComponent jc) {
        return threadM("showError", ChMsg.class, new Object[]{longObjct(frameOpt),s,jc});
    }
    public static void showError(long frameOpt, CharSequence cs, JComponent cError) {
        final String s=toStrg(cs);
        if (!isEDT()) {
            inEDT(thread_showError(frameOpt, s, cError));
            return;
        }
        if (s==null && cError==null) {
            if (frameError!=null) frameError.show();
            return;
        }
        final String TITLE="STRAP warnings and errors. "+titleReopenCtrl_I();
        if (frameError==null) frameError=new ChFrame(TITLE).ad(newCNSEW(tabbedPaneError=new ChTabPane("W"),null,"<sup>"+titleReopenCtrl_I()+"</sup>",null,null)).shw(ChFrame.CENTER|ChFrame.ALWAYS_ON_TOP);
        if (RUN_ERROR_F==null) RUN_ERROR_F=ChDelay.newThread(instance(),"toFront",frameError);
        ChDelay.runAfterMS(EDT,RUN_ERROR_F,555);
        JComponent jc=s!="" && s!=null ? MAP_ERROR.get(s) : null;
        if (jc==null) {
            final JComponent cErrorSP=(cError!=null && child(cError,JScrollPane.class)==null) ? scrllpn(0L,cError) : cError;

            final CharSequence sb=addHtmlTags(s);
            jc= cError!=null ?  cErrorSP : new ChTextViewer(sb).getPanel();
            TabItemTipIcon.set(String.valueOf(++iError),null,null,null,jc);
            tabbedPaneError.addTab(jc);
            if (s!=null) MAP_ERROR.put(s.intern(),jc);
        }
        tabbedPaneError.setSelectedComponent(jc);
        setWndwState('F',frameError.shw(CLOSE_ON_CtrlW|frameOpt));
        frameError.setSizeAccordingTo(jc,EM,2*EX);
    }
    /* <<< Error <<< */
    /* ---------------------------------------- */
    /* >>> Sound  >>> */

    private static long whenLastSound;
    public final static String SOUND_SUCCESS="SOUND_SUCCESS", SOUND_FAILURE="SOUND_FAILURE",SOUND_ON="SOUND_ON",SOUND_OFF="SOUND_OFF";
    public static void sound(String id) {
        if (id==SOUND_OFF) isSound=false;
        else if (id==SOUND_ON) isSound=true;
        else ChDelay.newThread(instance(),id,null).start();
    }
    private static boolean isSound;
    /* <<< Sound <<< */
    /* ---------------------------------------- */
    /* >>> Msg >>> */
    private final static Map<String,ChFrame> mapMSG_FRAME=new HashMap();
    public static void msg(String m) {
        ChFrame f=mapMSG_FRAME.get(m);
        final String TITLE="STRAP messgs ";
        if (f==null) {
            ChTextViewer tv=new ChTextViewer(addHtmlTags(m));
            mapMSG_FRAME.put(m,f=new ChFrame(TITLE).ad(tv.getTextComponent()));
            ChTextComponents.reduceHeight(f,tv.getTextComponent());
            f.shw(CLOSE_ON_CtrlW);
        }
        if (RUN_MSG_F==null) RUN_MSG_F=ChDelay.newThread(instance(),"toFront",f);
        ChDelay.runAfterMS(EDT,RUN_MSG_F,555);
        f.shw(0);
    }

    private static void nativeToFront(String t) {
        if (Insecure.EXEC_ALLOWED && sze(new NativeTools().fileExecutable())>0) {
            setWndwStateLaterT('T', 999, t);
            setWndwStateLaterT('F', 999, t);
        }
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Special Messeges  >>> */
    public static boolean noProteinsSelected(Object pp[]) {
        if (pp==null||pp.length==0) {
            error("no proteins selected");
            return true;
        }
        return false;
    }
    public static boolean noProtsSelectedButWantTakeAll(int nAll) {
        return ChMsg.yesNo("No proteins selected! \nDo you want to take all "+nAll+" proteins?");
    }
    public static void ubuntuFontError() {
        final String
            f1="/usr/share/fonts/truetype/ttf-gujarati-fonts/aakar-medium.ttf",
            f2="/usr/share/fonts/truetype/ttf-gujarati-fonts/Rekha.ttf";
        boolean exists=false;
        try{ exists= isSystProprty(IS_LINUX) && javaVsn()==15 && sze(new File(f1))+sze(new File(f2))>0; } catch(Throwable e){}
        if (exists) {
            final String msg=
                "Under Ubuntu-Linux two fonts may kill the entire JVM.<br>"+
                "Workaround: either update Java or remove these troublesome fonts:<br>"+
                "<br>"+
                "<pre class=\"terminal\">\n\n"+
                "sudo mv "+f1+" "+f2+" /tmp/\n"+
                "</pre>";
            msg(msg);
        }
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Disclaimer >>> */
    private static boolean disclaimerShown;
    public static void disclaimerMsg(String warning, String fPath) {
        if (disclaimerShown) return;
        disclaimerShown=true;
        if (!isPrgOptionTF("-noDisclaimer",true,getPrgParameters()) ) {
            final File f=new File( isWindows() ? fPath.replace('/','\\'):fPath);
            if (sze(f)==0) {
                final AbstractButton cb=cbox("Do not ask again");
                final JTextArea ta=new JTextArea(warning+"\n\nThis message will be written to\n"+f);
                ta.setEditable(false);
                final Object msg=newCNSEW(ta,"<h2>Disclaimer</h2>",cb,null,null);
                if (0!=JOptionPane.showConfirmDialog(null,msg,"Disclaimer",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE)) {
                    System.exit(0);
                }
                if (cb.isSelected()) wrte(f,warning);
            }
        }
    }
}
