package charite.christo;
import javax.swing.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.util.List;
import java.util.ArrayList;
import java.awt.event.*;

import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.lang.System.*;
public class ChPanel extends JPanel implements Scrollable {
    final java.util.Map MAPCP=new java.util.HashMap();
    { setBackground(C(DEFAULT_BACKGROUND));}
    {  assertInstAllowed(); }
    { pcp(KEY_NOT_YET_PAINTED,"",this); }
    public ChPanel() {}
    public ChPanel(LayoutManager l) { super(l);}
    /* ---------------------------------------- */
    /* >>> Paint >>> */
    private long duration[];
    public void paintChildren(Graphics g){
        final JScrollBar sb=gcp(KEY_NO_PAINT_IF_ADJUSTING, this, JScrollBar.class);
        if (sb!=null && sb.getValueIsAdjusting()) return;

        try {
            super.paintChildren(g);
        } catch (Exception e){ putln(RED_CAUGHT_IN+"ChPanel paintChildren ",e); }
        CollapseComponent.paintComponent(this,g);
    }

    public long[] getWhenPainted() {
        if (duration==null) duration=new long[ARRAY_DURATION];
        return duration;
    }

    @Override public void paintComponent(Graphics g){
        final long time=currentTimeMillis();
        if (paintHooks(this, g, false)) {
            try {super.paintComponent(g);}catch(Throwable t){}
            final long d[]=this.duration;
            if (d==null) {
                pcp(KEY_NOT_YET_PAINTED,null,this);
            }
            if (d!=null) d[DURATION]=(d[WHEN]=currentTimeMillis())-time;
            paintHooks(this, g, true);
        }
    }
    public boolean isAlreadyPainted() { return duration!=null;}

    @Override public boolean isShowing() { return super.isShowing() || gcp(KEY_JUST_WRITING_PNG,this)!=null;  }
    /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> preferredSize >>> */
    @Override public Dimension getMaximumSize() {
        Dimension d=getPrefSize(this);
        return d!=null && d.width+d.height==0 ? d : super.getMaximumSize();
    }
    @Override public Dimension getPreferredSize() {
        Dimension d=getPrefSize(this);
        try { // =Fri.08.09.06 42 linux .NullPointerException
            return d!=null ? d : super.getPreferredSize();
        } catch(Exception e) { return dim(333,333);}
    }
    /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> Tip >>> */
    @Override public String getToolTipText(MouseEvent ev) {
        final StringBuffer sb=appendTooltips(this,ev,null);
        if (sb!=null) return sb.toString();
        return super.getToolTipText(ev);
    }

    @Override public Point getToolTipLocation(MouseEvent event) {
        final Point p=(Point)gcp(KEY_TIP_LOCATION,this);
        if (p!=null) {
            final JViewport parent=parnt(this,JViewport.class);
            final Point vp=  parent!=null ? parent.getViewPosition() : null;
            return vp!=null ? new Point(vp.x+p.x, vp.y+p.y) : p;
        }
        return null;
    }
    /* <<< Tip <<< */
    /* ---------------------------------------- */
    /* >>> Scroll >>> */
     @Override public Dimension getPreferredScrollableViewportSize() { return getPreferredSize();}
     @Override public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction) {
        return visibleRect==null ? 10 : orientation==SwingConstants.VERTICAL ? visibleRect.height-EX : visibleRect.width-EM;
    }
    @Override public boolean getScrollableTracksViewportHeight() { return gcp(SCROLLABLE_TRACKS_VIEWPORT_HEIGHT,this)!=null;}
    @Override public boolean getScrollableTracksViewportWidth() { return gcp(SCROLLABLE_TRACKS_VIEWPORT_WIDTH,this)!=null;}
    @Override public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction) { return EX;}

    /* <<< Scroll <<< */
    /* ---------------------------------------- */
    /* >>> Event >>> */
    { this.enableEvents(ENABLE_EVT_MASK);}
    @Override public void processEvent(AWTEvent ev) { if (processEvt(this,ev)) try {super.processEvent(ev);} catch(Throwable e){} }
    /* <<< Scroll <<< */

    public List getDndDateien() { return getDndFilesV(this);}
    @Override public void removeAll() {
        if (!isEDT()) {
            inEdtM("removeAll", this,NO_OBJECT);
        }
        else try {
                super.removeAll();
            } catch(Exception ex){ stckTrc(ex);}
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>>  >>> */
    @Override public boolean isEnabled() {
        boolean enabled=super.isEnabled();
        Object o;
        if (null==gcp(UserProfile.KEY_IGNORE,this) && UserProfile.isHidden(this)) enabled=false;
        else if ( (o=gcp(KEY_ENABLED,this)) instanceof IsEnabled) enabled=((IsEnabled)o).isEnabled(this);
        return enabled;
    }
}

