package charite.christo;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.util.regex.PatternSyntaxException;
import java.util.Map;
import java.util.HashMap;
import java.lang.ref.*;
import static charite.christo.ChUtils.*;
/**
   putln(ChRegex.replace(ChRegex.pattern("(34)"), " $1$1 ", "12345678"));
   @author Christoph Gille
*/
public class ChRegex {
    private ChRegex(){}
    private static Reference<Map<String,Pattern>> refMap;
    public final static String NO_MATCH="no match";
    public static Pattern pattern(String s) throws PatternSyntaxException {
        if (s==null) return null;
        Map<String,Pattern> map=refMap!=null ? refMap.get() : null;
        if(map==null) refMap=new SoftReference(map=new HashMap());
        Pattern p=map.get(s);
        if (p==null) map.put(s,p=Pattern.compile(s));
        return p;
    }
    final static StringBuffer sb=new StringBuffer();
    public static String replace(Pattern pattern,String replacement, String haystack ) {
        if (pattern==null || haystack==null || replacement==null) return haystack;
        try {
            Matcher matcher=pattern.matcher(haystack);
            sb.setLength(0);
            boolean found=false;
            while (matcher.find()) {
                try{
                    matcher.appendReplacement(sb, replacement);
                    found=true;
                } catch(Exception e){ stckTrc(e);}
            }
            if (!found) return NO_MATCH;
            matcher.appendTail(sb);
            return sb.toString();
        } catch(IllegalStateException ex) { stckTrc(ex); }
        return haystack;
    }
}
