package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.ref.Reference;
import java.lang.reflect.Constructor;
import java.net.URL;
import java.io.File;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.dnd.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**
 */
public class ChScriptPanel implements ActionListener, CaretListener {
    public final static String RUN_SCRIPT="CSC$$RS";
    private ChTextArea ta;
    private long options;
    private String id;
    private Object wordCompl;
    private URL url;
    private JComponent pSouth;
    private ChFrame frame;
    ChRunnable run;
    private ChButton butSelection;
    public ChScriptPanel(long options, String id, Object wordCompl, URL url,  ChRunnable run) {
        this.options=options;
        this.id=id;
        this.wordCompl=wordCompl;
        this.url=url;
        this.run=run;
    }

    public ChTextArea getTextPane() {
        if (ta==null) {
            ta=new ChTextArea("");
            ta.addCaretListener(this);
            (butSelection=new ChButton("Run selected lines").li(this)).setEnabled(false);
            final JComponent
                b1=new ChButton("LINE").li(this).t("Run script line at cursor"),
                bURL=url!=null?ChButton.actionOpenURL(this.url).t("?").i(null):null;
            pcp(KEY_SOUTH_PANEL,hB(b1, " ", butSelection,"#", bURL ), ta);
            ta.saveInFile("scriptpanel_"+id).tools()
                .enableWordCompletion(wordCompl)
                .enableUndo(true).underlineRefs(UNDERLINE_REFS_NOT_CLICKABLE);
            ta.tools().underlineRefs(UNDERLINE_REFS_NO_ICON);
        }
        return ta;
    }

    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        final boolean scrpt_line=cmd=="LINE";
        if (scrpt_line || q==butSelection) {
            final ByteArray ba=ta.tools().byteArray();
            final byte[] T=ba.getBytes();
            final int E=ba.getEnd(), B=ba.getBegin(), from, to;
            if (scrpt_line) {
                final int c=ta.getCaretPosition();
                if (c>=0) {
                    final int b=strchr(STRSTR_PREV,'\n',T,c-1,B);
                    from=b>0?b+1:B;
                    to=strchr(STRSTR_E,'\n',T,c,E);
                } else from=to=-1;
            } else { from=ta.getSelectionStart(); to=ta.getSelectionEnd(); }
            if (from>=0 && from<to) {
              run.run(RUN_SCRIPT,new Object[]{this.id, new ByteArray(T, from, to), this});
            }

        }
    }
    public void caretUpdate(javax.swing.event.CaretEvent ev) {
        final int from=ta.getSelectionStart(), to=ta.getSelectionEnd();
        butSelection.setEnabled(from>=0 && from<to);
    }
    public void showFrame(String title) {
        if (frame==null) {
            final JComponent
                tp=getTextPane(),
                p=newCNSEW(scrllpn(0L,tp),null,gcp(KEY_SOUTH_PANEL,tp),null,null);
            frame=new ChFrame("").ad(p).size(EM*80,EX*30);
        }
        frame.shw(ChFrame.CENTER|CLOSE_ON_CtrlW).setTitle(title);
    }

}