package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;

import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.lang.System.currentTimeMillis;
import static java.awt.event.MouseEvent.*;
public class ChScrollBar extends JScrollBar {
    public ChScrollBar(int v_or_h) {
        super(v_or_h);
        setUnitIncrement(EX);
        final DefaultBoundedRangeModel model=new DefaultBoundedRangeModel(0, 1, 0, 100) {
                @Override public int getValue() {
                    return (currentTimeMillis()-ChScrollBar.this.lockAtEnd)<5555 ? super.getMaximum() : super.getValue();
                }
            };
        setModel(model);

    }

    private int[] selected;
    private int rowHeight;
    private Color colors[];

    public void setSelectedY(int[] ii, int rowHeight,Color cc[]) { this.selected=ii; this.colors=cc; this.rowHeight=rowHeight; repaint();}

    public void paintComponent(Graphics g) {
        if (paintHooks(this, g, false)) {
            try { super.paintComponent(g); } catch(Exception e){}
            final int ii[]=this.selected;
            final Rectangle track=getTrack();
            if (ii!=null && track!=null) {
                final int max=getMaximum();
                final int w=track.width-5;
                final Color cc[]=this.colors;
                final Color colSel=C(COLOR_SELECTED);
                Color c=colSel;
                if (max>0 && w>0 && track.height>0) {
                    for(int i=0; i<ii.length; i++) {
                        if (ii[i]>=0) {
                            if (cc!=null && i<cc.length) c=cc[i];
                            g.setColor(c!=null ? c : colSel);
                            g.fillRect(4,track.y + ii[i]*rowHeight * track.height/max, w,2);
                        }
                    }
                }
            }
        }
        paintHooks(this, g, true);
        if (currentTimeMillis()-lockAtEnd<5555) { g.setColor(Color.BLUE);
            final Rectangle r=getThumb();
            g.drawRect(0,r.y,r.width-1,r.height-1);
        }
    }

    { this.enableEvents(ENABLE_EVT_MASK);}
    @Override public void processEvent(AWTEvent ev) {
        final int id=ev.getID();
        if (id==MOUSE_DRAGGED || id==MOUSE_ENTERED || id==MOUSE_EXITED) lockAtEnd=0;
        if (processEvt(this,ev)) {
            if (!isCtrl(ev) || wheelRotation(ev)==0) super.processEvent(ev);
        }
    }

    public Rectangle getTrack() { return ui().getTrackBounds();}
    public Rectangle getThumb() { return ui().getThumbBounds();}

    @Override public void updateUI() {
        try {
            setUI(this.ui=new ChScrollBarUI());
        } catch(Exception ex){  stckTrc(ex); }
    }
    private ChScrollBarUI ui;
    private ChScrollBarUI ui() {
        if (this.ui==null) updateUI();
        return this.ui;
    }

    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>>  Lock End position >>> */
    private long lockAtEnd=0;
    public void setLock(boolean b) {  lockAtEnd=b ? currentTimeMillis() : 0; }
}

/*

.BasicScrollBarUI.uninstallListeners(BasicScrollBarUI.java:322)

 */