package charite.christo;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import javax.swing.JSlider;
import javax.swing.JLabel;
import java.awt.event.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.util.*;
/**
   convenient extension of JSlider
   @author Christoph Gille
*/
public final class ChSlider extends JSlider implements javax.swing.event.ChangeListener,MouseWheelListener, HasModiCount {
    {  assertInstAllowed(); }
    /* --- associated object[s] --- */
    private String command="";
    //    public void add(int i) { int v=getValue()+i; v=maxi(v,getMinimum()); v=mini(v,getMaximum()); setValue(v); }
    public void stateChanged(javax.swing.event.ChangeEvent ev) {
        storeInProperties();
        handleActEvt(this,command,0);
        ChDelay.repaint(this,1111);
        modi++;
    }
    {  assertInstAllowed(); }
    public ChSlider(String cmd,int mi,int ma,int ini ) {
        super(mi,ma,maxi(mi,ini));
        command=cmd;
        addChangeListener(this);
        addMouseWheelListener(this);
    }
    @Override public void processEvent(AWTEvent e) {
        try{ super.processEvent(e);} catch(Exception ex){}

    }
    private final String[] labels=new String[2];
    public ChSlider endLabels(String l0,String l1) {
        labels[0]=l0;
        labels[1]=l1;
        if (l0!=null || l1!=null) {
            Hashtable ht=new Hashtable();
            ht.put(intObjct(0),new JLabel(" "));
            setLabelTable(ht);
            try { setPaintLabels(true); } catch(Exception e){}
        }
        return this;
    }
    public ChSlider tt(CharSequence tt) {
        setToolTipText(tt!=null ? addHtmlTagsAsStrg(tt) : null);return this;
    }
    private boolean lastIsEnabled=true;
    public void paintComponent(Graphics g) {
        if (lastIsEnabled!=isEnabled()) { revalidate(); lastIsEnabled=isEnabled();}
        try { super.paintComponent(g);} catch(Throwable e){}
        if (labels[0]!=null || labels[1]!=null) {
            g.setFont(getFnt(11,false,0));
            final Rectangle cb=charBounds(getFnt(11,false,0));
            final int y=getHeight()-cb.height+cb.y;
            g.setColor(Color.BLACK);
            final int w0=strgWidth(getFnt(11,false,0),labels[0]);
            final int w1=strgWidth(getFnt(11,false,0),labels[1]);
            if (w0+w1<getWidth()) {
                if (w0>0) g.drawString(labels[0],0,y);
                if (w1>0) g.drawString(labels[1],getWidth()-w1,y);
            }
        }
        ChButton.drawTopAndButtomText(this,g);
    }
    @Override public Dimension getPreferredSize() {
        if (!isEnabled()) {
            final Dimension d=gcp(KEY_PREF_SIZE_IF_DISABLED,this,Dimension.class);
            if (d!=null) return d;
        }
        try {

            return UserProfile.isHidden(this) ? dim(0,0) : super.getPreferredSize();
        } catch(Exception e){ return dim(32,32);}
    }
    private Class clas;
    private String id;
    public ChSlider property(Class clas,String id_str) {
        this.clas=clas; this.id="slider_"+id_str;
        setValue(getPrpty(clas,id,getValue()));
        return this;
    }
    private void storeInProperties() {
        if (clas!=null && id!=null)
            setPrpty(clas,id,ChSlider.this.getValue());
    }
    public void mouseWheelMoved(MouseWheelEvent ev) {
        final int ma=getMaximum(),mi=getMinimum();
        int i=ev.getWheelRotation()*(ma-mi)/ (isCtrl(ev) ? 200:50)+getValue();
        if (i<mi)i=mi;
        if (i>ma)i=ma;
        setValue(i);
        modi++;
    }
    private int modi;
    public int getModificationCount() { return modi;}
    public JSlider cln() {
        return new JSlider(getModel());
    }
}
