package charite.christo;
import java.util.List;
import java.util.*;
import javax.swing.table.*;
import javax.swing.*;
import java.awt.event.*;
import java.lang.ref.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChJTable.*;
/**
   @author Christoph Gille
*/
public class ChTableModel extends AbstractTableModel {
    private boolean editable[];
    private Object rowData, columnNames[];
    public ChTableModel(String...header) { columnNames=header;}
    public ChTableModel setData(Object data[][]) { rowData=data; return this; }
    public ChTableModel setData(List data)       { rowData=data; return this;}
    @Override public String getColumnName(int col) { return col>=0 && sze(columnNames)>col ? toStrg(columnNames[col]) : ""; }

    @Override public int getRowCount() { return sze(rowData); }
    @Override public int getColumnCount() { return sze(columnNames); }

    @Override public Object getValueAt(int row, int col) { return get(col,get(row,this.rowData));}
    public ChTableModel editable(boolean... bb) { editable=bb; return this; }

    @Override public boolean isCellEditable(int row, int col) {
        final Object o=getValueAt(row,col) ;
        return o instanceof AbstractButton || o instanceof JComboBox && ((JComponent)o).isEnabled() || get(col,editable);
    }
    @Override public void setValueAt(Object aValue, int row, int col) {
        if ( get(col,editable)) {
            sv(aValue,row,col);
            handleActEvt(this,toStrg(aValue) ,256*row+col);
            if ( (options&SET_VALUE_SELECTED_ROWS)!=0) {
                final JTable t=(JTable)deref(refTable);
                final int ii[]=ChJTable.selectedRowsConverted(t);
                if (idxOf(row,ii,0,999999)>=0)
                    for(int i=sze(ii); --i>=0;) if (i!=row) sv(aValue,i,col);
            }
        }
    }
    private void sv(Object aValue, int row, int col) {
        final Object data[]=get(row,this.rowData,Object[].class);
        if (0<=col && col<sze(data) && !(data[col] instanceof AbstractButton || data[col] instanceof List)) data[col]=aValue;
    }
    private Reference<JTable> refTable;
    public void setJTable(JTable t, int options) { refTable=weakRef(t);this.options=options;}
    private int options;

}
