package charite.christo;
import charite.christo.interfaces.*;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**
   Displays the free memory
   @author Christoph Gille
*/
public class FreeMemoryBar extends ChButton implements ChRunnable {
    public FreeMemoryBar() {
        super("   ",ChButton.NO_MARGIN|ChButton.HEIGHT_I);
        monospc(this);
        i(IC_BLANK);
        addMoliRefreshTip(this);
        setToolTipText("");
        t("","   kbyte",dim(64,ICON_HEIGHT));
    }
    private long free,max,total;
    @Override public void paintComponent(Graphics g) {
        this.total=Runtime.getRuntime().totalMemory()>>10;
        this.max=Runtime.getRuntime().maxMemory()>>10;
        final long totalFree=max-total+free;
        final float freeByMax=totalFree/(float)max;

        final String t=format10(totalFree,8,true,strBuf(SB_TIP)).toString();
        pcp(TOP_TEXT,t,this);
        super.paintComponent(g);

        g.setColor(blueYellowRed(1-freeByMax));
        final int  h0=(int)(ICON_HEIGHT*(1-Math.sqrt(freeByMax)));
        g.fill3DRect(3,ICON_HEIGHT-h0,4,h0,true);
    }
    @Override public Object run(String id, Object arg) {
        super.run(id,arg);
        if (id=="P") {
            final long f=Runtime.getRuntime().freeMemory()>>10;
            if ((f/32)!=(free/32)) { free=f;repaint(); }
        }
        return null;
    }
    @Override public void r() {
        Runtime.getRuntime().gc(); System.gc(); System.runFinalization();
    }
    public FreeMemoryBar start() {
        ChThread.callEvery(333,ChDelay.newThread(this,"P",null),"FreeMemoryBar",0);
        return this;
    }
    private static boolean checked;
    @Override public String getToolTipText(MouseEvent ev) {
        final StringBuffer sb=strBuf(SB_TIP).append("<html><body><pre>How much memory is left? ( max-total+free): ");
        format10(max-total+free,8,true,sb);
        format10(total,8,true,sb.append(" kb\n\n total Memory: "));
        format10(free,8,true,sb.append(" kb\n  free Memory: "));
        format10(max,8,true,sb.append(" kb\n   max Memory: "));
         final String html=sb.append(
                      " kb\n\n"+
                      "Click to run garbage collection   to find out how much memory there is left after unsused data is removed.\n"+
                      "The max memory  can be increased  in the Java control panel or with the command line option -Xmx.\n"+
                      "Example for -Xmx:\n"+
                      "  java -Xmx100M -jar strap.jar \n"+
                      "</pre></body></html>").toString();
        if (!checked) { checked=true;ckHtml(html);}
        return html;
    }
}
