package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.*;
import javax.swing.JPopupMenu;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**HELP

This list shows  currently downloaded files.<br>

Stalled downloads are recognized by a file size that does not change for a long time.<br>

They can block the program flow.

This view provides the possibility to cancel running downloads.
<br>
<br>
Sometimes it happens that a very large file is downloaded unintendedly by clicking the wrong hyper-link.
In this case cancel the download here.

@author Christoph Gille
*/
public class JavaclassPopup  implements ActionListener {
    private  static JavaclassPopup inst;
    public static JavaclassPopup instance() {if (inst==null) inst=new JavaclassPopup(); return inst;}

    private File file;
    private ChButton bJAVADOC,bJAVASRC,bJAVAEDIT;
    private JPopupMenu popup;
    private Object clazz;
    private String[] vPackages;
    public JPopupMenu menu() {
        if (popup==null) {
            final boolean my=false;//isMyComputer();
            Object oo[]={
                "This context menu acts on a Java-class",
                bJAVADOC=new ChButton("Javadoc in Web-Browser").li(this),
                bJAVASRC=new ChButton("Java-source code").li(this),
                bJAVAEDIT=new ChButton("Edit Java-source").li(this)

            };
            popup=jPopupMenu("Java-class",oo);
        }
        final File f=sourceFile(HotswapUtil.getClass(clazz));
        bJAVASRC.setEnabled(hasSource(clazz));
        final String javadocUrl=clazz instanceof Class ? ChJavadoc.javadocUrl((Class)clazz) : ChJavadoc.javadocUrl((String)clazz);
        bJAVADOC.setEnabled( javadocUrl!=null);
        bJAVAEDIT.setEnabled(sze(f)>0);
        return popup;
    }
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        final File f=sourceFile(HotswapUtil.getClass(clazz));

        final String javadocUrl=clazz instanceof Class ? ChJavadoc.javadocUrl((Class)clazz) : ChJavadoc.javadocUrl((String)clazz);
        if (q==bJAVASRC) showJavaSource(delSfx("PROXY",clazz),vPackages);
        if (q==bJAVADOC) visitURL(javadocUrl,0);
        if (q==bJAVAEDIT) edFile(-1, f, 0);

    }

    public static JPopupMenu menu(Object clazz, String[] vPackages) {
        final JavaclassPopup jp=instance();
        jp.clazz=clazz;
        jp.vPackages=vPackages;
        return jp.menu();
    }

}

