package charite.christo;
import java.awt.*;
import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**
   Creates a documentation from menus.
   @author Christoph Gille
*/
public class Menu2html {
    private Menu2html(){}
    public static StringBuffer menubar2html(JMenuBar bar,String skip,StringBuffer sb) {
        int n=bar.getMenuCount();
        for(int i=0;i<n;i++) {
            //sb.append("<DIV id=\"menuInMenuBar\">");
            JMenu m=bar.getMenu(i);
            if (m!=null &&  skip.indexOf(m.getText())<0) {
                menu2html(m,sb);
            }
            //sb.append("</DIV>");
        }
        return  sb;
    }
    private static StringBuffer popup2html(JPopupMenu menu,StringBuffer sb) {
        sb.append("<ul>\n");
        for(Component c:menu.getComponents())item2html(c,sb);
        return sb.append("</ul>\n");
    }
    private static StringBuffer item2html(Component c,StringBuffer sb) {
        if (c!=null) {
        final StringBuffer SB_ITEM=new StringBuffer(88);
        Object link=gcp(Class.class,c);
        if (link !=null && !(link instanceof String || link instanceof Class)) link=link.getClass();
        final boolean hasDocu=link !=null && getHlp(link)!=null;
        if (hasDocu) SB_ITEM.append("<a href=\"").append(URL_STRAP_DOC).append(link instanceof Class ? ((Class)link).getName() : link).append(".html\">");
        if (c instanceof JCheckBoxMenuItem) SB_ITEM.append("&lt;x&gt;").append(removeHtmlHeadBody(((JCheckBoxMenuItem)c).getText()));
        else if (c instanceof JMenu) menu2html((JMenu)c,SB_ITEM);
        else if (c instanceof JMenuItem)  SB_ITEM.append(removeHtmlHeadBody(((AbstractButton)c).getText()));
        if (hasDocu) SB_ITEM.append("</a>");
        if (SB_ITEM.length()>0) sb.append("\n<li>").append((Object)SB_ITEM).append("</li>\n");
        }
        return sb;
    }
    private static StringBuffer menu2html(JMenu menu,StringBuffer sb) {
        sb.append("\n<div class=\"submenu\"><span class=\"menuname\">").append(menu.getText()).append("</span>\n<ul>\n");
        final int n=menu.getItemCount();
        for(int i=0;i<n;i++) item2html(menu.getItem(i),sb);
        return removeHtmlHeadBody(sb.append("</ul>\n</div>\n"));
    }
    public static StringBuffer toHtml(Object comp,StringBuffer sb) {
        return
            comp instanceof JMenu ?  menu2html((JMenu)comp,sb) :
            comp instanceof JPopupMenu ? popup2html((JPopupMenu)comp,sb) :
            sb;
    }
}
