package charite.christo;
import java.lang.ref.SoftReference;
import java.util.*;
import charite.christo.interfaces.IsEnabled;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static java.lang.System.*;
/**
   Find places of patterns in text
   @author Christoph Gille
*/
public final class OccurInText {

    private static SoftReference<int[]> refFromTo;

    public static synchronized int[] find(long mode, byte needle[], ByteArray ba, boolean[] delimL, boolean[] delimR,IsEnabled isEnabled, int[] buffer) {
        final boolean
            ignoreCase= (mode & HIGHLIGHT_IGNORE_CASE)!=0,
            skipBlanks= (mode & HIGHLIGHT_SKIP_BLANKS)!=0,
            ignoreLenOfSpc= (mode & HIGHLIGHT_IGNORE_LEN_OF_BLANK)!=0,
            dotMatchesAny= (mode & HIGHLIGHT_DOT_MATCHES_ANY)!=0;
        final int L= sze(needle);
        if (L==0 || ba==null) return NO_INT;
        final byte c0=needle[0];
        final int lc0='A'<=c0 && c0<='Z' ? c0|32 : c0;
        final int end=ba.getEnd(),begin=ba.getBegin();
        final byte T[]=ba.getBytes();
        int fromTo[]=(int[])deref(refFromTo);
        if (fromTo==null) fromTo=new int[900];
        int count=0;

        if (needle==ChTextComponents.WRONG_CHARS_IN_FILEN) {
            final boolean[] charClassFN=charClass(FILENM);
            for(int i=begin; i<end; i++) {
                final char c=(char)T[i];
                if (c>127 || !charClassFN[c]  && c!='/' && c!='\\' && (i!=1||c!=':') && (i>0||c!='~')  ) {
                    if (2*count>=fromTo.length) refFromTo=new SoftReference(fromTo=chSze(fromTo,4*(count+1)));
                    fromTo[2*count]=i;
                    fromTo[2*count+1]=i+1;
                    count++;
                }
            }
        } else {
            if (L==1) {
                nextPosition:
                for(int i=begin; i<end; i++) {
                  if (T[i]==c0 || ignoreCase && (T[i]|32)==lc0 && is(LETTR,lc0)) {
                        int hitStart=i;
                        while (i+1<end && (T[i+1]==c0 || ignoreCase && (T[i+1]|32)==lc0) ) i++;
                        if (2*count>=fromTo.length) refFromTo=new SoftReference(fromTo=chSze(fromTo,4*(count+1)));
                        if (i>begin && delimL!=null  && !delimL[127&T[i-1]]) continue nextPosition;
                        if (delimR!=null  && i+1<end && !delimR[127&T[i+1]]) continue nextPosition;
                        fromTo[2*count]=hitStart;
                        fromTo[2*count+1]=i+1;
                        if (count++>9999) break;
                    }
                }
            } else {
                nextPosition:
                for(int i=begin, endL1=end-L+1; i<endL1; i++) {
                  if (ignoreCase ? (T[i]|32)==lc0 : T[i]==c0 ) {
                        int iQ=1,iH=i+1;
                        for(; iQ<L && iH<end; iQ++,iH++) {
                            byte cQ= needle[iQ];
                            byte cH=T[iH];
                            if (ignoreLenOfSpc && iQ>0 && iQ!=needle.length-1 && isSpc(cH) && isSpc(cQ)) {
                                cQ=get(iQ=nxtE(NO_SPC,needle,iQ, L),needle);
                                cH=get(iH=nxtE(NO_SPC,T,iH,end),T);
                            }
                            while (skipBlanks && (cH<'0' && isSpc(cH) || cH=='-') && cQ!=cH && iH<end-1) cH=T[++iH];
                            //if ((!dotMatchesAny||cQ!='.') && (ignoreCase  ? cQ!=cH : (cQ|32)!=(cH|32))) continue nextPosition;
                            if (!(dotMatchesAny&&cQ=='.' || ignoreCase && (cQ|32)==(cH|32) && is(LETTR,cQ) || cQ==cH)) continue nextPosition;
                        }
                        if (i>begin && delimL!=null  && !delimL[127&T[i-1]]) continue nextPosition;
                        if (delimR!=null && iH<end-1 && !delimR[127&T[iH]]) continue nextPosition;
                        if (2*count>=fromTo.length) refFromTo=new SoftReference(fromTo=chSze(fromTo, 4*(count+1)));
                        fromTo[2*count]=i;
                        fromTo[2*count+1]=iH;
                        if (count++>9999) break;
                    }
                }
            }
        }
        final int[] newFromTo=count==0?NO_INT : buffer!=null&&buffer.length==2*count?buffer:new int[2*count];
        if (count>0) arraycopy(fromTo,0,newFromTo,0, 2*count);
        return newFromTo;
    }
    public static synchronized int[] findLU(long options, byte[] lookup[][], ByteArray ba, boolean[] delimL,boolean[] delimR,IsEnabled isEnabled,  int[] buffer) {
        final byte T[]=ba!=null ? ba.getBytes() : null;
        final int E=T!=null ? mini(T.length,ba.getEnd()) : 0;
        if (E==0) return NO_INT;
        final int B=ba.getBegin();
        int fromTo[]=(int[])deref(refFromTo);
        if (fromTo==null) fromTo=new int[900];
        final int found[]={-1,-1};
        int pos=B-1, count=0;
        while( pos<E-1 && (pos=idxOfNeedles(lookup, delimL, T, pos, E, found, options)) >=0 ) {
            if (2*count>=fromTo.length) refFromTo=new SoftReference(fromTo=chSze(fromTo,4*(count+1)));
            final byte hit[]=lookup[found[0]][found[1]];
            final int n=hit!=null ? hit.length : 0;
            if (n==0) continue;
            if (delimR!=null && pos+n<E && !delimR[127&T[pos+n]]) continue;
            fromTo[2*count]=pos;
            fromTo[2*count+1]=pos+n;
            count++;
        }
        final int[] newFromTo=count==0?NO_INT : buffer!=null&&buffer.length==2*count?buffer:new int[2*count];
        if (count>0) arraycopy(fromTo,0,newFromTo,0, 2*count);
        return newFromTo;
    }

    protected static int idxOfNeedles(byte[][][] lookupTable,   boolean[] delimL,  byte[] T,  int from, int to, int[] found, long options) {
        final boolean ignoreCase=(options&HIGHLIGHT_IGNORE_CASE)!=0;
        final int toIndex=mini(T.length,to), fromIndex=maxi(0,from);
        final long strstr_opt=ignoreCase ? STRSTR_IC : 0L;
        for(int i=fromIndex; i<toIndex;i++) {
            if (delimL!=null && i>fromIndex && !delimL[127&T[i-1]]) continue;
            for(int upperLower=0; upperLower<=(ignoreCase?32:0); upperLower+=32) {
                final int c=T[i]^upperLower;
                final byte[][] words=0<c && c<128 ? lookupTable[c] : null;
                if (words!=null) {
                    final int c1=i+1<toIndex ? T[i+1] : 0;
                    for(int iK=maxi(0,c==found[0] ? found[1]+1 : 0); iK<words.length; iK++) {
                        final byte[] word=words[iK];
                        if (word==null) break;
                        if ( (word.length<2 || c1==word[1] || ignoreCase && (c1|32)==(word[1]|32) && is(LETTR,c1)) &&
                             i+word.length<=toIndex && equls(strstr_opt, word,T,i)) {
                            found[0]=c;
                            found[1]=iK;
                            return i;
                        }
                    }
                }
            }
            found[0]=found[1]=-1;
        }
        return found[0]=found[1]=-1;
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>>  >>> */
    public static byte[][][] lookupTableFirstLetter(Object[] strings) {
        final byte[][][] ttt=new byte[128][][];
        addToLookupTable(strings,ttt);
        //for(int i=128; --i>=0;) ttt[i]=rmNull(ttt[i], byte[].class);
        return ttt;
    }
    private static void addToLookupTable(Object[] ss, byte[][][] ttt) {

        for(Object s:ss) {
            if (s instanceof Object[]) addToLookupTable((Object[])s,ttt);
            else if (s instanceof Collection) addToLookupTable(((Collection)s).toArray(),ttt);
            else if (s!=null) {
                final byte[] T=s instanceof String ? ((String)s).getBytes() : (byte[])s;
                if (T.length>0) {
                    final byte b0=T[0];
                    ttt[b0]=ad(T, ttt[b0], sze(ttt[b0])+10, byte[].class);
                }
            }
        }
    }

}