package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import static charite.christo.ChUtils.*;
/**
   @author Christoph Gille
*/
public class RendererNumberAsOval extends JComponent implements  TableCellRenderer {
    public final static String TYPES[]={"colored oval","symbol","number"};
    private double scale=1,offset=0;
    public void setScale(double s) {scale=s;}
    public void setOffset(double o) {offset=o;}
    private int type;
    public void type(String t) { type=0; for(int i=TYPES.length; --i>=0;) if (TYPES[i]==t) type=i;}
    private final static String NAN="?";
    private static RendererNumberAsOval _inst;
    public Component getTableCellRendererComponent(JTable t,Object o,boolean isSel,boolean hasFocus,int row,int col) {
        final RendererNumberAsOval inst=_inst==null ? _inst=new RendererNumberAsOval() : _inst;
        if (!(o instanceof FloatValue)) return new JLabel("Error "+o);
        final float v=((FloatValue)o).floatValue(o);
        if (type==2) {
            String s=v+"";
            if (s.length()>4) s=s.substring(0,4);
            return new JLabel(s);
        }
        inst.value=v;
        inst.type=type;
        inst.setToolTipText(o.toString());
        ChUtils.rtt(inst);
        inst.setScale(scale);
        inst.setOffset(offset);
        return inst;
    }
    private float value;
    public void paintComponent(Graphics g) {
        ChUtils.antiAliasing(g,false);
        super.paintComponent(g);
        if (Double.isNaN(value)) {
            g.drawString(NAN,0,charA(g));
            return;
        }
        if (Double.isNaN(scale)) {
            g.drawString(String.valueOf(value),0,charA(g));
            return;
        }
        final double v2=(offset+value)*scale;
        final int w=getWidth()-2;
        final int h=getHeight()-2;
        float v1=1-(float)v2;
        if (v1>1) v1=1;
        if (v1<0) v1=0;
        g.setColor(type==0 ? ChUtils.float2blueRed((float)v2): new Color(v1,v1,v1));
        final int radius=(int)(w*v2)/2,x=1+w/2-radius;
        g.fillOval(x,1,2*radius,h);
        g.setColor(Color.BLACK);
        g.drawOval(x,1,2*radius,h);
    }
}
