package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static java.awt.event.MouseEvent.*;
public class ScrollLabel extends JPanel  {
    { setBackground(C(DEFAULT_BACKGROUND));}
    public ScrollLabel(CharSequence s){
        t(s);
    }
    @Override public Cursor getCursor() { return getCursr(realWidth()<strgWidth(this,getText()) ? 'M':'D'); }
    private String txt;
    public String getText() { return txt;}
    public final ScrollLabel t(CharSequence t) { txt=ChUtils.toStrg(t);ChDelay.repaint(this,333);return this;}
    private int getPreferredHeight() {
        final Insets i=getInsets();
        return  charA(this)+charH(this)+i.top+i.bottom;
    }
    @Override public Dimension getMinimumSize() {
        return new Dimension(9,getPreferredHeight());
    }
    @Override public Dimension getPreferredSize() {
        return new Dimension( strgWidth(this,getText()),getPreferredHeight());
    }

    @Override public void paintComponent(Graphics g) {
        ChUtils.antiAliasing(g,false);
        final int width=realWidth();

        final String t=getText();
        if (t!=null) {
            scrollX=mini(0, maxi(scrollX, width-strgWidth(this,getText())));
            final Color bg=getBackground(), fg=getForeground();
            g.setColor(bg);
            g.fillRect(0,0,22222,999);
            g.setColor(fg);
            final int charA=charA(g);
            final Insets i=getInsets();
            g.drawString(t,scrollX+i.left,charA+i.top);
            /* --- dot dot dot --- */
            final int wDots=strgWidth(this," ... "), wText=strgWidth(this,t),xDots=scrollX+wText>width ? width-i.right-wDots : scrollX<0 ? i.left : -1;
            if (xDots!=-1) {
                g.setColor(bg);g.fillRect(xDots,0,wDots,999);
                g.setColor(fg);g.drawString(" ... ",xDots,charA+i.top);
            }
        }
        else  super.paintComponent(g);
        ChRenderer.paint(this, g); //4350
    }
    private int lastX,scrollX;
    private long lastWhen;
    private int realWidth() {
        int width=22222;
        Container parent=this;
        do {
            width=mini(width,parent.getWidth());
            parent=parent.getParent();
        } while(parent!=null);
        return width;
    }

    { this.enableEvents(MOUSE_EVENT_MASK | MOUSE_WHEEL_EVENT_MASK | MOUSE_MOTION_EVENT_MASK);}
    @Override public void processEvent(AWTEvent ev) {

        final int id=ev.getID();
        if (ev instanceof MouseEvent) {
            final MouseEvent mev=(MouseEvent)ev;
            final long when=mev.getWhen();
            final int x=mev.getX(),prefWidth= strgWidth(this,getText()),width=realWidth();
            if (id==MOUSE_MOVED || id==MOUSE_DRAGGED) {
                if (x==0 || x==width) return;
                if (when-lastWhen<222) {
                    final double k=x-lastX<0 ? -scrollX/(double)x : (prefWidth-width+scrollX)/(width-(double)x);
                    scrollX+=(x-lastX)*(k>1 ? k:1);
                    //putln(k+" "+scrollX);
                }
                lastX=x;
                lastWhen=when;
                repaint();
            }
        }
        final int rotation=wheelRotation(ev);
        if (rotation!=0) {
            scrollX+=rotation*realWidth()/3;
            repaint();
        }
    }
    // java charite.christo.ScrollLabel
    /*
    public static void main(String argv[]) {
        new ChFrame("").ad(newCNSEW(null,new ScrollLabel("alle meine Entchen schwimmen auf dem See, schwimmen auf dem See"),null,null,null)).size(800,100).shw(0);
    }
    */
}
