package charite.christo;
import charite.christo.interfaces.*;
import java.awt.*;
import java.util.*;
import java.util.jar.JarFile;
import java.util.jar.JarEntry;
import javax.swing.JComponent;

import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;

/**
Lists all java source files in a give jar file
@author Christoph Gille
*/
// java charite.christo.SourcefilesInJarfile $HOME/java/strap.jar
public class SourcefilesInJarfile implements ChProcessEvent {
    private ArrayList<JarFile> vJarfiles=new ArrayList();
    private void add(JarFile jf) {  adUniq(jf, vJarfiles=vJarfiles);}
    final UniqueList<String> vEntries=new UniqueList(String.class);

    private void collectFiles() {
        final int mc=vEntries.getModificationCount();
        for(int i=0; i<sze(vJarfiles); i++) {
            final JarFile jf=get(i,vJarfiles,JarFile.class);
            if (jf==null) continue;
            final Enumeration entries=jf.entries();
            while(entries.hasMoreElements()) {
                final JarEntry je=((JarEntry)entries.nextElement());
                final String eName=je.getName(), name=delSfx(".java",eName);

                if (eName==name) continue;
                adUniq(name.replace('/','.'), vEntries);

            }
        }
        sortArry(vEntries);
        getTree().updateKeepStateLater(0L, 99);
    }

    private ChJTree jTree;
    private ChJTree getTree() {
        if (jTree==null) {
            jTree=new ChJTree(0L,new ChTreeModel(0L, new Strings2Tree(Strings2Tree.LEAFS_CONTAIN_ENTIRE_PATH,vEntries,'.')));
            jTree.setCellRenderer(new ChRenderer().options(ChRenderer.LAST_PATH_COMPONENT_DOT));
            jTree.setRootVisible(false);
            jTree.setShowsRootHandles(true);
            jTree.addMouseListener(LI);
        }
        return jTree;
    }

    public SourcefilesInJarfile(JarFile...jarFiles){
        if (jarFiles!=null) for(JarFile jf:jarFiles) add(jf);
    }
    private static SourcefilesInJarfile instance;
    public static ChButton newButton(){ return newButton(null); }
    private static JarFile thisJF;
    private static ChButton newButton(final SourcefilesInJarfile instance0) {
        if (instance0==null && instance==null) instance=new SourcefilesInJarfile();
        return new ChButton("LIST").t("List all Java Classes").li( (instance0!=null ? instance0 : instance).LI);
    }

    private ChEventAdapter LI=new ChEventAdapter(this);
     public AWTEvent  processEvent(JComponent component, AWTEvent ev) {
            final String cmd=actionCommand(ev);
            final int x=x(ev), y=y(ev);
            final int id=ev.getID();
            if (id==MOUSE_CLICKED) {
                final String s=(String)objectAt(ev);
                if (s!=null && s.indexOf('.')>0) JavaclassPopup.menu(s,(String[])null).show( getTree(), x(ev)+EM, y(ev)+EX);
            }
            if (cmd=="LIST") {
                if (0==sze(vJarfiles)) {
                    try{
                        adUniq(new JarFile(thisJarFile()),vJarfiles);
                        collectFiles();
                    }catch(Exception ex){stckTrc(ex);}
                }
                ChFrame.frame("Classes in vJarfiles", getTree(), ChFrame.SCROLLPANE|ChFrame.STAGGER).shw(ChFrame.TO_FRONT);
            }

            return ev;
    }

    // java charite.christo.SourcefilesInJarfile ~/java/strap.jar
    public static void main(String argv[]) throws Exception{
        SourcefilesInJarfile s=new SourcefilesInJarfile();
        s.add(new JarFile(file(argv[0])));
        s.collectFiles();

        ChFrame.frame("Classes in vJarfiles",s.getTree(), ChFrame.SCROLLPANE|ChFrame.STAGGER).shw(ChFrame.TO_FRONT);
    }
}
