package charite.christo;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import charite.christo.interfaces.*;
import java.util.*;

import javax.swing.*;
/**
   Utility class to allow to append to JTextPane's outside the event dispatch thread
   @author Christoph Gille
*/
public class TextAppender  implements Runnable {
    protected TextAppender(ChTextArea a) {appendable=a;}
    private final ChTextArea appendable;
    protected int maxLength=333333;
    private int len;
    private List v;
 boolean isRunning;
    protected final static Object OVERFLOW=new Object();
    private boolean alreadyMsgOverflow;
    protected synchronized void appnd(Object o) {
        if (o==null) return;

        if (o instanceof Object[]) {
            for(Object line : (Object[])o) {
                appnd(line);
            }
            return;
        }
        if (v==null) v=new ArrayList();
        if (o instanceof CharSequence && len>maxLength) {
            if (!alreadyMsgOverflow) {
                alreadyMsgOverflow=true;
                v.add(RED_ERROR+"\n\nTEXT LENGTH OVERFLOW indicated by exclammation mark !!\n STOPPED APPENDING TEXT - resolve by deleting text.");
            }
            if (!v.contains(OVERFLOW)) v.add(OVERFLOW);
            return;
        }
        v.add(o);
        len+=6;
        if (!isRunning && appendable.shouldAppend() ) {  run(); isRunning=true;}
    }

    public void run() {
        if (sze(v)>0) {
            if (!isEDT()) {
                inEDT(this);
            } else synchronized(this) {
                    for(Object o : v.toArray()) appendable.appendNow(o);
                    v.clear();
                    
                    if (!isRunning) {
                        isRunning=true;
                        ChThread.callEvery(555,this,"TextAppender", ChThread.WEAK_REFERENCE);
                    }
                    
                }
        }
    }
}
