package charite.christo;


import java.awt.event.*;
import java.lang.ref.*;
import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static java.awt.Color.*;
/**HELP
To avoid that users are confused by the number of menu items and options
only those GUI elements are shown that the user is interested in.
@author Christoph Gille
*/
public class UserProfile implements ActionListener {
    public final static String KEY_IGNORE="UP$$I";
   private  static UserProfile inst;
    private static UserProfile instance() {if (inst==null) inst=new UserProfile(); return inst;}

    private UserProfile(){}
    public static void setWebMode(boolean b) {
        if (webMode!=b) {
            webMode=b;
            if (cbWebMode!=null) cbWebMode.setSelected(!b);            
        }
    }
    public static boolean isWebMode() { return webMode; }
    private static boolean webMode;
    public static JComponent newCbWebMode() {
        if (cbWebMode==null)
            cbWebMode=toggl("Show menu-bar").li(instance()).s(!isWebMode())
                .tt("In Web-mode there is only reduced functionality");
        return cbWebMode.cb();
    }
    private static ChButton cbWebMode;
    private final static ChButton[] TOG=new ChButton['z'+1];
    public static boolean get(char mode) {
        if (mode>'z') return false;
        if (mode=='W') return !isWebMode();
        return set[mode] || (TOG[mode]!=null && TOG[mode].s());
    }
    private final static boolean set[]=new boolean['z'+1];
    public static void set(char mode,boolean b) { if (mode<='z') set[mode]=b;}

    private static JComponent panel;
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        if (cmd=="SHOW")  {
            if (frame==null) frame=new ChFrame("User level").ad(init());
            frame.shw(ChFrame.AT_CLICK|ChFrame.AT_CLICK|ChFrame.PACK);
        }
        if (q==cbWebMode) webMode=!cbWebMode.s();
        if (q instanceof ChButton && ((ChButton)q).isToggle() || q==cbWebMode) {
            handleActEvt(UserProfile.class,"USER_PROFILE",0);
        }
    }
    public static JComponent init() {
        if (panel==null) {
            panel=Box.createVerticalBox();
            panel.add(new JTextArea( "The user interface is kept simple for novices while providing full functionality for the advanced. \n"+
                                     "Selecting the check-boxes exhibits more graphical elements and menu items."));
            for(int i=3;--i>=0;) {
                final char ch= i==0?'e' : i==1?'n' : 'a';
                final String t=
                    ch=='a'?"  I  make ID for residues (i. e. selections or features) ":
                    ch=='n'?"  I translate coding ID into protein":
                    "  I am an ID user ";
                final String id= ch=='e'?"advanced"  : ch=='n'?"nucleotides" : "annotations";
                (TOG[ch]=toggl(rplcToStrg("ID","<font color=\"red\">"+id+"</font>",t))).li(instance()).save(UserProfile.class,id);
                final AbstractButton cb=TOG[ch].cb();
                cb.setBackground(WHITE);
                panel.add(hB(cb));
            }
        }
        return panel;
    }
    private static ChFrame frame;
    public static ChButton newButton() {
         return (ChButton)set('W',new ChButton("SHOW").t("User level...").li(instance()));
     }
    public static boolean isHidden(JComponent c) {
        if (panel==null) return false;
        final String prop=(String)gcp(instance(),c);
        if (prop==null) return false;
        for(int i=prop.length(); --i>=0;) if (get(prop.charAt(i))) return false;
        return true;
    }
    public static JComponent set(char ch,JComponent c) {
        if (c==null) return null;
        final String prop=(String)gcp(instance(),c);
        pcp(instance(),prop==null ? String.valueOf(ch) : prop+ch,c);
        return c;
    }
    public static JComponent set(String profile,JComponent c) {
        pcp(instance(),profile,c);
        return c;
    }
    public static String interpretLabelText(String s,JComponent c) {
        if (chrAt(0,s)=='@') {
            int iSpace=s.indexOf(' ');
            set( iSpace>0 ? s.substring(0,iSpace) : s,c);
            return s.substring(iSpace+1);
        }
        return s;
    }
}
