package charite.christo;
import static charite.christo.ChUtils.*;
import charite.christo.interfaces.ChRunnable;
import java.net.URL;
import java.util.*;
import java.io.*;
import javax.swing.JComponent;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

<br><br><b>Internet and Web-proxy</b><br>
<br>
In some institutions all Internet connections are going through a Web proxy (see WIKI:Proxy_server).

If the proxy is not set correctly, STRAP is unable to download files from the Web.

The proxy cannot be set in the running application.

The way how the proxy is set depends on whether the application is
started via WIKI:Webstart (See WIKI:JNLP) or started directly.

<h3>Webstart</h3>

In Windows or Linux there is a program called Java control panel  which allows to set the proxy (Button "Network settings"):
<i>STRING:charite.christo.ChUtils#fileJcontrol()</i> located in
<i>STRING:ChUtils#dirJavaws()</i>.

Under Macintosh, however, the system wide proxy setting is also used in Java.

<h3>Direct start without Webstart</h3>

The proxy is specified with command line arguments. Example:
<pre class="terminal">
java -Dhttp.proxyHost=realproxy.charite.de -Dhttp.proxyPort=888   ...
</pre>

If there are addresses that should bypass the proxy use vertical bar separated list of hosts as in the following example:
<pre class="terminal">
 ....  -Dhttp.nonProxyHosts="localhost|host.mydomain.com" ...
</pre>

<h3>Testing the Proxy settings</h3>

Use the item <i>BUTTON:charite.christo.ChUtils#newButTestProxy()!</i>
In the menu "Options" is.

Further reading http://java.sun.com/javase/6/docs/technotes/guides/net/proxies.html

   @author Christoph Gille

*/

public class Web implements ChRunnable {
    private Web(){}
    private  static Web inst;
    private static Web instance() {if (inst==null) inst=new Web(); return inst;}

    public static String toolTip(URL url[]) {
        final StringBuffer sb=new StringBuffer("Click this button to call the web browser<br>Hold down the CTRL key to open debug window.<br>");
        if (url!=null)
            for(URL u:url)
                if (u!=null)
                    sb.append("<li>").append(u).append("</li>\n");
        return addHtmlTagsAsStrg(sb);
    }
    // ----------------------------------------
    public static void setAsk(boolean b) { ask=b; if (togAsk!=null) togAsk.s(b);}
    private static boolean ask=true;
    private static ChButton togAsk;
    public static ChButton togAskBeforeUploadingData() {
        if (togAsk==null) togAsk=toggl("Always request confirmation for uploading data").s(ask);
        return togAsk;
    }

    public static ByteArray getServerResponse(String url,Object variables[][]) {
        InputStream is=getServerResponseAsStream(url,variables);
        ByteArray ba=readBytes(is);
        closeStrm(is);
        return ba;
    }

    public static InputStream getServerResponseAsStream(String url,Object data[][]) {
        final ByteArray httpData=new ByteArray(99999), baTmp=new ByteArray(0);
        int i=0;
        for(Object dd[]:data) {
            if (dd==null||dd.length<2  || dd[1]==null) continue;
            if (i++>0) httpData.append("&");
            baTmp.setEnd(0).append(dd[1]);
            httpData.append(dd[0]).append("=").urlEncode(baTmp.getBytes(),0,baTmp.getEnd());
        }
        return getServerResponseAsStream(url,httpData);
    }

    public static InputStream getServerResponseAsStream(String url,ByteArray httpData) {
        OutputStream os=null;
        InputStream is=null;
        java.net.URLConnection uc=null;
        try {
            final ByteArray folded=new ByteArray(0).foldText(httpData.getBytes(),0,httpData.getEnd(),  90);
            if (ask && url.indexOf(DO_NOT_ASK)<0) {
                final int[] answer={MIN_INT};
                final Thread t=new Thread(ChDelay.newThread(instance(),"ASK_POST",new Object[]{folded,url,answer}));
                if(isEDT()) t.run();
                else {
                    inEDT(t);
                    for(int w=0; w<999; w++) { /* Workaround:  Macintosh kommt erst gar nicht in die run() methode */
                        sleep(99);
                        if (answer[0]>=-1) break;
                        if (w>10 && answer[0]==MIN_INT) {
                            answer[0]=0;
                            try {t.destroy(); } catch(NoSuchMethodError er){}
                        }
                    }
                }
                switch(answer[0]) {
                case 1: setAsk(false); break;
                case 2: return null;
                }
            }
            final URL u=url(url);
            if (u!=null) {
                uc=u.openConnection();
                uc.setDoOutput(true);
                uc.setDoInput(true);
                uc.setUseCaches(false);
                os=new BufferedOutputStream(uc.getOutputStream());
                wrte(os,httpData);
                os.flush();
                return uc.getInputStream();
            } else assert false;
        }
        catch(IOException e) { closeStrm(is); }
        finally{ closeStrm(os); }
        return null;
    }

    // ----------------------------------------
    public static URL[] urls(Object urlBase, String files) {
        final String tokens[]=splitTokns(0L, files);
        if (tokens==null) return null;
        assert files.indexOf('|')<0;
        final ArrayList<URL> v=new ArrayList();
        for(String jar : tokens) {
            adUniq(url(looks(LIKE_EXTURL,jar) || urlBase==null ? jar : delSfx("/",urlBase.toString())+"/"+delPfx("/",jar)),v);
        }
        return toArry(v,URL.class);
    }
    // ----------------------------------------
    public static void insertBaseTag(URL url, File fDest, ByteArray html) {
        if (html==null) return;
        byte[] T=html.getBytes();
        final int B=html.getBegin(), E=html.getEnd();
        final String  sUrl=url.toString();
        final int slash=-1;//sUrl.lastIndexOf('/');
        final int eHead=strstr(STRSTR_IC,"</head",T,B, E);
        {
        final String insert= (eHead<0?"<head>\n":"") + "<base href=\""+ (slash>9 ? sUrl.substring(0,slash) : sUrl)+"\"  /> \n"+(eHead<0?"</head>\n":"");
        if (eHead>0 &&  strstr(STRSTR_IC,"<base",T, B, eHead)>0) return;
        final int i= eHead>0?eHead: strstr(STRSTR_IC,"<body",T, B, E);
        if (i>0) { html.replace(i,i,insert.getBytes()); T=html.getBytes(); }
        }
        final byte[] fDestBB=toByts(toStrg(url(fDest)));
        if (fDest!=null) {
            String base0=null;
            for(int i=html.getEnd(); --i>=0; ) {
                if ((T[i]|32)=='h' && ( equls(STRSTR_IC,"href=\"#",T,i) || equls("href=\'#",T,i))) {
                    html.replace(i+6,i+6,fDestBB);
                    T=html.getBytes();
                }
            }
        }
    }
    public Object run(String id, Object arg) {
        final Object[] argv=arg instanceof Object[] ? (Object[])arg:null;
        if (id=="TEST_URL") {
            final String url=(String)argv[0];
            final AsciiView v=(AsciiView)argv[1];
            final ByteArray ba=readBytes(inStreamT(20,url,STREAM_UNZIP));
            v.setText(ba!=null ? ba : new ByteArray("Unable to connect to "+url));
            v.revalidate();
        }
        if (id=="ASK_POST") {
            final ByteArray folded=(ByteArray)argv[0];
            final Object url=argv[1];
            final int[] answer=(int[])argv[2];
            if (answer[0]!=MIN_INT) return null; /* Mac Workaround */
            answer[0]=-2;
            AsciiView tp=new AsciiView(folded);
            tp.tools().highlightOccurrence("&",null,null,0,C(0xFF0000));
            tp.tools().highlightOccurrence("%09",null,null,HIGHLIGHT_SKIP_BLANKS, C(0xFFFF00));
            final JComponent sp=tp.tools().scrollPane();
            sp.setPreferredSize(dim(EM*80,EX*10));
            Object msg=newCNSEW(sp, null,  hB("Going to transmit above data to ",url,"#"), null,null);
            answer[0]=ChMsg.option(msg,new String[] {"Transmit data","Transmit data, never ask","Cancel"});
        }
        return null;
    }

    public static void setProxyFromShellVariable() {
        putln("This method is not supported anny more.\nSee http://java.sun.com/javase/6/docs/technotes/guides/net/proxies.html");
    }

    protected static void testConnectionForURL(String url) {
        putln(" testConnectionForURL ",url);
        if (url(url)!=null) {
            final AsciiView v=new AsciiView(new ByteArray("Connecting to "+url+" ...\n\n"));
            v.showInFrame("Test connection "+url,DISPOSE_ON_CtrlW|DISPOSE_ON_ESC|ChFrame.ALWAYS_ON_TOP);
            ChDelay.newThread(instance(), "TEST_URL",new Object[]{url,v}).start();
        }
    }

    public static Thread thread_startJnlp(URL url, ChTextReplacement rplc) {
        final Object[] para={url,rplc};
        return threadM("startJnlp", Web.class,para);
    }
    public static void startJnlp(URL url, ChTextReplacement rplc) throws IOException {
        if (url==null) return;
        final ByteArray ba=readBytes(url.openStream());
        if (ba!=null) {
            ba.replace(rplc);
            final File f=createTempFile("jnlp");
            wrte(f,ba);
            visitURL(f,0);
        }

    }
}
