package charite.christo.interfaces;
import java.awt.*;
/**
Implemented by objects that can contain a GUI where the user can
manipulate the inner state.

Usually the settings within this control panel are valid for all instances of
this class.

However, if the class  implements NeedsSharedInstance it is valid for all those instances that 
have a reference to the same shared instance.


The user can access the control panel by pressing a tool button
<i>ICON:IC_CONTROLPANEL</i>.

After pressing this button the control panel is obtained by creating a  temporary instance of the class.  

In case the classe implements NeedsSharedInstance the reference of
this instance is passed to all instances, otherwise the instance is
discarded after retrieving the control panel.

See also <i>JAVADOC:HasControlPanel</i> which provides a control panel
for a specific instance.

@author Christoph Gille
*/
public interface HasSharedControlPanel {

    Container getSharedControlPanel();
}
