package charite.christo.protein;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.util.Map;
import java.util.WeakHashMap;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;

/**
   @author Christoph Gille
*/
public abstract class AbstractProteinViewerProxy extends AbstractProxy implements ProteinViewer, ChRunnable {

    public ProteinViewer pv(){
        ProteinViewer v=(ProteinViewer)proxyObject();
        return v;
    }
    //    {  if (ChUtils.isMyComputer())  ChFrame.frame("ChClassLoader", ChClassLoader.log(),0).shw(0);    }
    public Protein getProtein() { ProteinViewer pv=pv(); return pv!=null ? pv.getProtein() : null;}
    public boolean setProtein(Protein p, ProteinViewer inSameView, Runnable runAfterInstallation, long options) {
        try {
            final ProteinViewer pv=pv();
            this.toString=p+"@"+ChUtils.shrtClasNam(this);
            return pv!=null && p!=null && pv.setProtein(p,inSameView,null,0);
        } catch(Throwable ex) {ChUtils.stckTrc(ex); return false;}
    }
    public void setSelectedResidues(long options,boolean[] p1, int p2, String p3) {  ProteinViewer pv=pv(); if (pv!=null)  pv.setSelectedResidues(options,p1,p2,p3);}
    public void handleEvent(StrapEvent ev) {
        final ProteinViewer pv=pv();
        if (pv instanceof ProteinListener) ((ProteinListener)pv).handleEvent(ev);
    }
    public void transform(Matrix3D m){ProteinViewer pv=pv(); if (pv!=null) pv.transform(m);}

    public java.awt.Component getViewerPanel() { ProteinViewer pv=pv(); return pv!=null ? pv.getViewerPanel() : null;}
    public Object run(String id, Object arg) {
        if (id==ChTableLayout.RUN_COLUMN_TITLE) return Protein.titleFor3dViewers(new Protein[]{getProtein()});
        final ProteinViewer pv=pv();
        return pv instanceof ChRunnable ? ((ChRunnable)pv).run(id,arg) : null;
    }
    @Override public void dispose() {
        super.dispose();
        new StrapEvent(this, StrapEvent.PROTEIN_VIEWER_CLOSED).setParameter(this).run();
    }
    public ProteinViewer[] getViewersSharingView() {
        final ProteinViewer pv=pv();
        final ProteinViewer vvPo[]=pv!=null ? pv.getViewersSharingView() : null;
        if (vvPo==null) return ProteinViewer.NONE;
        final ProteinViewer vv[]=new ProteinViewer[vvPo.length];
        for(int i=vv.length; --i>=0;) {
            vv[i]=getProxy(vvPo[i],ProteinViewer.class);
        }
        return vv;
    }
    public javax.swing.JMenuBar getMenuBar() { final ProteinViewer pv=pv(); return pv!=null ? pv.getMenuBar() : null; }
    public long getPropertyFlags() { final ProteinViewer pv=pv(); return pv!=null ? pv.getPropertyFlags() : 0; }

    public boolean getSupportsCommand(String cmd) { final ProteinViewer pv=pv(); return pv!=null ? pv.getSupportsCommand(cmd) : false;  }

    private String toString;
    @Override public String toString() { return toString!=null ? toString : super.toString();}

    {
        ProteinUtils.initCustomizableSettings(this);
    }

}
