package charite.christo.protein;
import charite.christo.*;
import charite.christo.interfaces.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import javax.swing.*;
import java.io.File;

/**HELP

   <b>Home: </b> http://openastexviewer.net  http://www.astex-therapeutics.com/<br>
   <b>License of OpenAstexViewer:</b>  WIKI:LGPL <br>
   <b>Authors: </b> Mike Hartshorn, Tom Oldfield<br><br>
   When clicking into the 3D-pane, the menu-bar of Astex is shown.
   STRAP added a view menus. There is a style menu to change the style of the active amino acids.
   <br><br>

   Also try the Dialog Astex-menu-bar&gt;Select&gt;Popup.

   @author Christoph Gille
   http://openastexviewer.net/web/OpenAstexViewer.jar
*/
public class  ChAstexPROXY extends AbstractProteinViewerProxy implements HasControlPanel {

    @Override public String getRequiredJars() { return "OpenAstexViewer.jar.pack.gz"; }

    // java charite.christo.protein.ChAstexPROXY ~/m1/a1_SaccharomycesCerevisiae.pdb
    public static void main(String argv[]) throws Exception {
        final Protein p=new Protein();
        final File f=file(argv[0]);
        new PDB_Parser().parse(p,0,readBytes(f));
        p.setFile(f);
        final ChAstexPROXY pv=new ChAstexPROXY();
        pv.setProtein(p, null,  null, 0);
        new ChFrame("hello").ad(pv.getViewerPanel()).shw(0);
    }

    public static String getCustomizableInitCommands() {
        return
            "secstruc ( molecule 'PROTEIN' );\n"+
            COMMANDcartoon+"\n"+
            "display  lines off  ( molecule 'PROTEIN'  );\n"+
            "display lines on (all and aminoacid and ( atom C or atom CA or atom CB or atom N or atom O));\n"+
            "display sticks  on  (all and not aminoacid );\n"+
            "";
    }
    public static String getCustomizableLateCommands() {
        return "center (aminoacid );\n";
    }

    public static String getCustomizableExamples() {
        return
            "display  spheres on  (group RESIDUES);\n"+
            "display  spheres off (group RESIDUES);\n"+
            "display  cylinders on  (group RESIDUES);\n"+
            "display  cylinders off (group RESIDUES);\n"+
            "display  sticks on  (group RESIDUES);\n"+
            "display  sticks off  (group RESIDUES);\n"+
            "display  lines on (group RESIDUES);\n"+
            "display  lines off (group RESIDUES);\n"+
            "color blue   (group RESIDUES);\n"+
            "schematic -name 'schematic_RESIDUES' -alltube  true  -ribbonwidth 20 (group RESIDUES);\n"+
            "object remove 'schematic_PROTEIN';\n"+
            "surface -solid true  'surface_RESIDUES' pink (group RESIDUES);\n"+
            "object remove 'surface_PROTEIN';\n"+
            "schematic -name 'schematic_PROTEIN'  ( molecule 'PROTEIN' );\n"+
            "object remove 'schematic_PROTEIN';\n";
    }

    public static String getWordCompletionList() {
        return
            "select schematic  secstruc display center remove "+
            "object molecule aminoacid group surface current default "+
            "-alltube "+
            "-arrowheadwidth "+
            "-arrowsmoothing "+
            "-arrowthickness "+
            "-arrowwidth "+
            "-quality "+
            "-ribboncylinders "+
            "-ribbonellipse "+
            "-ribbonminwidth "+
            "-ribbonthickness "+
            "-ribbonwidth "+
            "-tuberadius "+
            "-tubesmoothing "+
            "-tubetaper "+
            "-tubetaperradius "+
            "true false ";
    }
}
