package charite.christo.protein;
import charite.christo.*;
import charite.christo.interfaces.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import javax.swing.*;
/**HELP
   The protein structure viewer WIKI:Jmol is written in Java and understands  Rasmol-instructions.
   <br>

   <br><br><b>Limitations:</b> Currently only one protein can be loaded in one Jmol view.
   @author Christoph Gille
*/
public class  ChJmolPROXY  extends AbstractProteinViewerProxy implements  ProteinViewer  {
    @Override public String getRequiredJars() { return "jmol_10.jar.pack.gz ";}

    public static String getCustomizableInitCommands() {
        return
                "select all\n"+
                "wireframe off; spacefill off;\n"+
                "select backbone; wireframe on;\n"+
                "select all; cartoon \n"+
                "select hetero and not water; spacefill true";
    }

    public static String getCustomizableExamples() { return ProteinUtils.RASMOL_EXAMPLES; }

}
