package charite.christo.protein;

/**HELP
<i>PACKAGE:charite.christo.strap.</i>
<i>PACKAGE:charite.christo.</i>

<h2>The  multiple sequence alignment panel</h2>

In the alignment window the amino acid sequences are written under each other.
In case of protein files from the PDB-database helices are written in red and beta-sheets in yellow.

<b>Scrolling</b>

To scroll in the 3D alignment use the scroll-bar or turn the mouse wheel.

Alternatively, drag the mouse holding SHIFT.

As in a word processor the  cursor is  navigated it with the arrow keys.
The visible part of the alignment follows the cursor and
previously hidden parts of the alignment get into view.

The scroll-bar  serves as an overview
of the entire alignment.  The knob represents the visible part when
the alignment is too large to be displayed as a whole.

<br><br><b>Zooming</b>

To zoom in or out, use the CTRL + mouse wheel or set the cursor into the alignment pane and type CTRL <b>+</b> or CTRL <b>-</b>.

On some computers, the plus and
minus keys of the number block must be used.
In the context menu (right-click) the font type is changed.

<br><br><b>Highlighting conserved residues:</b>
For each alignment column STRAP counts the number of identical residues.

If this number exceeds a threshold the residues are highlighted.
This allows the user to identify, conserved alignment regions as they appear brighter.

The slider <i>JCOMPONENT:StrapView#sliderSimilarity()!</i> below the
alignment is used to manipulate the minimum number of identical residues to be regarded as conserved.  If the knob is at the
left then all residues are highlighted whereas only completely
conserved positions are highlighted if the knob is at the right.

<br><br><b>Editing the protein file</b><br>

To change a protein file with the text editor, move the cursor
to the respective protein and press CTRL-E.
Specify the editor in <i>JCOMPONENT:Customize#newButtonAll("A")!</i>.

<br><br><b>Upper and lower case</b><br>

Some regions of a protein structure may be flexible and not localized.  For those
residues no atom coordinates are recorded in PDB files.  They are not
shown in the 3D-backbone view and the residues are written in lower
case in the alignment.

<br><br><b>Interoperability  of the 3D panel and the alignment panel</b><br>

The main advantage of showing the sequence alignment and the 3D-models simultaneously is that
the user can relate alignment positions and 3D-positions.

Clicking on an amino acid in the 3D model  sets the alignment cursor to the corresponding alignment
position and scrolls so that  the   amino acid becomes visible.

If a c-Alpha atom is clicked while the CTRL key is pressed the amino acid is selected or deselected.
With the SHIFT key an interval of residues is selected.

Vice versa, recognizing alignment positions in 3D-models is also possible:
The alignment cursor is displayed as a blue ball.

By dragging over a sequence region in the alignment residues are selected.

*/
public interface ProteinAlignment {
    int countRows();
    int findRow(Protein p);
    Protein getProtein(int row);
    Protein getProteinAtCursor();
    int getIndexOfAminoAcidAtCursor();
    void dispatch(StrapEvent ev);
    void removeListener(StrapListener l);
    void addListener(StrapListener l);
    javax.swing.JComponent newProteinLabel(Protein p);

}
