package charite.christo.protein;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.util.List;

import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import java.util.Comparator;
public class ProteinUtils implements Comparator {

    private ProteinUtils(){};
    private static ProteinUtils _inst, compSeqAlphaIC,compVis;
    private static ProteinUtils instance() { return _inst==null ? _inst=new ProteinUtils() : _inst; }
    /* ---------------------------------------- */
    /* >>> Comparator >>> */
    public static Comparator comparatorSequenceAlphaIC() { return compSeqAlphaIC==null ? compSeqAlphaIC=new ProteinUtils() : compSeqAlphaIC;}
    public static Comparator comparatorVisible123() { return compVis==null ? compVis=new ProteinUtils() : compVis;}

    public int compare(Object o0, Object o1) {
        if (this==compSeqAlphaIC) {
            if (o0 instanceof Protein && o1 instanceof Protein) {
                return compareAlphabetically(((Protein)o0).getResidueTypeExactLength(),((Protein)o1).getResidueTypeExactLength(),true);
            }
        }
        if (this==compVis) {
        if (o0 instanceof VisibleIn123 && o1 instanceof VisibleIn123) {
            final int
                style0= ((VisibleIn123)o0).getStyle(),
                style1= ((VisibleIn123)o1).getStyle();
            return style0<style1 ? -1 : style0>style1 ? 1 : 0;
        }
        }
        return 0;
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> ProteinViewer >>> */
    public  static String RASMOL_EXAMPLES=
        "spacefill on\n"+
        "spacefill off\n"+
        "cpk on\n"+
        "cpk off\n"+
        "ribbons on\n"+
        "ribbons off\n"+
        "wireframe on\n"+
        "wireframe off\n"+
        "color red\n"+
        "color green\n"+
        "color blue\n"+
        "color yellow\n"+
        "label on\n"+
        "label off\n"+
        sATOM_TYPE_CA+" label \"hello\"\n"+
        sATOM_TYPE_CA+" label \"$FIRST_NUMBER\"\n"+
        sATOM_TYPE_CA+" label \"$FIRST_Aaa\"\n"+
        sATOM_TYPE_CA+" LABEL %n";
    /* <<< ProteinViewer <<< */
    /* ---------------------------------------- */
    public static void initCustomizableSettings(ProteinViewer pv) {
        final Class c=pv.getClass();
        setSettings(pv,
                    Customize.getCustomizableForClass(c, Customize.CLASS_Example),
                    Customize.getCustomizableForClass(c, Customize.CLASS_ExecPath),
                    Customize.getCustomizableForClass(c, Customize.CLASS_InitCommands),
                    Customize.getCustomizableForClass(c, Customize.CLASS_LateCommands)

                    );
    }


}