package charite.christo.protein;
import charite.christo.*;
import java.awt.*;
import java.util.*;

import java.lang.ref.*;

import static java.awt.Color.*;

/**
Residues are shaded according to their physical and chemical properties.
The colors were taken from texshade.sty
   @author Christoph Gille
*/
public class ShadingAA extends ChCombo {
				private final static String[] WHAT_IS={"white on black",null,null,null,null};
    private final static Color[]	NON, GRAY256, CHARGE,	HYDROPATHY;
    public final static Color[] CHEMICAL, ACTG, SECSTRU, SOLVENT_ACCESSIBILITY2WHITE_BLUE;
				static {
								NON=new Color[256];
								Arrays.fill(NON,WHITE);
								GRAY256=new Color[256];
								Arrays.fill(GRAY256,GRAY.brighter().brighter());

        SOLVENT_ACCESSIBILITY2WHITE_BLUE=new Color[150];
        for(int i=0;i<150;i++) {
            SOLVENT_ACCESSIBILITY2WHITE_BLUE[i]=new Color(255-i,255-i,100+i);
        }

        SECSTRU=NON.clone();
								set(SECSTRU,"H",new Color(255,100,100),"helix");
								set(SECSTRU,"E",YELLOW,"sheet");

        CHARGE=NON.clone();
        WHAT_IS[1]="<b>charge</b>"+
            set(CHARGE,"DE",new Color(255,100,100),"acidic")+
            set(CHARGE,"RKH",CYAN,"basic");

								HYDROPATHY=NON.clone();
        WHAT_IS[2]="<b>hydropathy </b>"+
												set(HYDROPATHY,"DE",new Color(255,100,100),"acidic")+
            set(HYDROPATHY,"RKH",CYAN,"basic")+
            set(HYDROPATHY,"YSTGNQC",YELLOW,"polar uncharged")+
            set(HYDROPATHY,"AFPMWVIL",GREEN,"hydrophob unpolar");

								CHEMICAL=NON.clone();
								WHAT_IS[3]="<b>chemical</b> "+
												set(CHEMICAL,"DE",new Color(255,100,100),"acidic")+
												set(CHEMICAL,"RKH",CYAN,"basic")+
												set(CHEMICAL,"AGVIL",WHITE,"aliphatic")+
												set(CHEMICAL,"NQ",GREEN,"amide")+
												set(CHEMICAL,"FYW",new Color(0.7f,0.3f,0.1f),"aromatic")+
												set(CHEMICAL,"ST",MAGENTA,"hydroxyl")+
												set(CHEMICAL,"P",ORANGE,"imine")+
												set(CHEMICAL,"CM",YELLOW,"sulfur");

								ACTG=NON.clone();
        WHAT_IS[4]="<b>nucleotide_actg</b> "+
            set(ACTG,"G",GRAY.brighter(),"guanine")+
            set(ACTG,"A",GREEN,"adenine")+
            set(ACTG,"T",RED,"thymine")+
            set(ACTG,"C",CYAN,"cytosine");

				}
    private static String set(Color cc[],String s,Color c,String explain) {
        for(int i=s.length(); --i>=0;) {
            int b=s.charAt(i);
            cc[b]=cc[b|32]=c;
        }
        return "<br>"+s+" "+explain;
    }
    public final static String[] TYPES={"white","charge","hydropathy","chemical","nucleotide"};
    public ShadingAA() {
        super(TYPES);
        tt(WHAT_IS);
    }

    //public String getSelectedMode() { return toString();}
    public Color[] getColors() { return getColors(i());}
    public static Color[] getColors(int i) {
        return i==1 ? CHARGE : i==2 ? HYDROPATHY : i==3 ? CHEMICAL : i==4 ? ACTG : NON;
    }
}
