package charite.christo.protein;
import charite.christo.*;
import java.util.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   Thanks to Fabrice David for providing this service

   @author Christoph Gille
   fab punkt dav a gmail punkt com
   w3m 'http://research.isb-sib.ch/up3d/client/up3d_batch_text?format=strap&ac_list=UNIPROT:P0A7B8+UNIPROT:P31059+UNIPROT:P97542'

   UNIPROT:P0A7B8	PDB:1kyi:R	80.2325581395349
   UNIPROT:P0A7B8	PDB:1ofi:N	80.2325581395349
   UNIPROT:P0A7B8	PDB:1g4b:P	100
   UNIPROT:P0A7B8	PDB:1ht1:Z	100
   UNIPROT:P0A7B8	PDB:1ned:C	100
   UNIPROT:P0A7B8	PDB:1ned:A	100

*/
public class SimilarPdbProviderSSMap implements SimilarPdbProvider {

    public void get(String[] ids,  Map<String,Result[]> m, Map<String,Result[]> mNew) {
        final ByteArray ba=new ByteArray(ids.length*20);

        for(int j=0; j<ids.length; j++) ba.append(ids[j]).append('\t');
        final ByteArray ret=Web.getServerResponse("http://research.isb-sib.ch/up3d/client/up3d_batch_text"+DO_NOT_ASK,
                                                  new Object[][]{{"ac_list",ba},{"format","strap"}});

        Utils.parse(ret,m,mNew);
        Utils.notFound(ids,m, mNew,this);
    }
    // java charite.christo.protein.SimilarPdbProviderSSMap UNIPROT:P0A7B8 UNIPROT:P31059 UNIPROT:P97542

    public static void main(String argv[]) throws Exception {
        final SimilarPdbProvider inst=new SimilarPdbProviderSSMap();
        final Map<String,Result[]> m=new HashMap();

        inst.get(argv,m, (Map)null);
        for(Object key : keyArry(m)) {
            final Result[] rr=m.get( (String)key);
            putln(Utils.toText(rr,(ByteArray)null));
        }
        System.exit(0);
    }

}

/*
 wget -O /dev/stdout 'http://research.isb-sib.ch/up3d/client/up3d_batch_text?format=strap&ac_list=UNIPROT%3AP14074'
Has results

 wget -O /dev/stdout 'http://research.isb-sib.ch/up3d/client/up3d_batch_text?format=strap&ac_list=UNIPROT%3AO56227'
Does not have results

Both are the same entry:
ID   PRO_HTL1C               Reviewed;         651 AA.
AC   P14074; O56227;
DT   01-JAN-1990, integrated into UniProtKB/Swiss-Prot.

The same is true for Q94EI0 Q94EI0
 wget -O /dev/stdout 'http://research.isb-sib.ch/up3d/client/up3d_batch_text?format=strap&ac_list=UNIPROT%3AO23708'
 wget -O /dev/stdout 'http://research.isb-sib.ch/up3d/client/up3d_batch_text?format=strap&ac_list=UNIPROT%3AQ94EI0'

*/