package charite.christo.protein;
import charite.christo.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;

import static charite.christo.ChUtils.*;
/**
   The program wish is a tk-tcl interpreter in UNIX.
   With this java class you can send commands to running tk-windows
   This class was written for RASMOL on UNIX
   @author Christoph Gille
*/
public class Wish  {
    private Wish(String display) {}
    private void newProcess() {
        myExec=new ChExec(ChExec.STDOUT | ChExec.IGNORE_ERROR);
        boolean d=display!=null&&!display.equals("");
        myExec.setCommandLineV("wish", "-geometry","1x1+0+0",  d ? "-display" : null,  d ? display : null);
        new Thread(myExec,"exec wish").start();
        myExec.waitFor();
        String error=null;
        if (myExec.hasFinished()) error="could launch the TCL/TK interpreter wish  but it already terminated";
        else if (!myExec.isRunning()) error="could not launch the  TCL/TK interpreter wish ";
        if (error!=null) error(0L,"",vBpnl("Error in Rasmol.java: <br>"+error, getCtrlPanel(myExec)));
    }
    // ---
    private ChExec myExec;
    private String display="";
    private void wish(String TKwindow,String command) { wish("send {"+TKwindow+"} {"+command+"};");}
    private final JTextPane taCommands=new JTextPane();
    public boolean couldNotLaunch() { return myExec!=null && myExec.couldNotLaunch();}
    private void wish(String s) {
        taCommands.setText(taCommands.getText()+s+"\n");
        putln(s);
        try {
            if (myExec==null || !myExec.isRunning()) newProcess();
            myExec.write(s+"\n"); /*myExec.flush(); */}
        catch(Exception e){}
    }
    // ========================================
    /**
       tells what TK-windows are currently open
    */

    public static String getWinfo(String display) {
       return tryGetWinfo(display);
     }
    private static String tryGetWinfo(String display) {
        ChExec e=new ChExec(ChExec.STDOUT| ChExec.STDERR).setCommandLine("wish "+(sze(display)==0 ? "" :  " -display "+display+" "));
        e.setStdin("puts [winfo interps];\n\n exit; \n").run();
        String s=toStrg(e.getStdout());
        e.dispose();
        return s;
    }
    // ----------------------------------------
    /**
       send a command to a TKwindow
       @param xDisplay e.g. 141.43.56.62:0
       @param tkWindow name of TKwindow
       @param command command
    */
    public static void wish(String xDisplay,String  tkWindow, String command) {
        Wish w=getW(xDisplay);
        if (w==null) { putln("Error: in Wish.wish:  could not get wish for  the display '"); putln(xDisplay); return;}
        w.wish(tkWindow,command);
    }
    // ----------------------------------------
    private final static Map<String,Wish> vWish=new HashMap();
    private static Wish getW(String xDisplay) {
        Wish w=vWish.get(xDisplay);
        if (w!=null) return w;
        w=new Wish(xDisplay);
        if (w.couldNotLaunch()) { new ChTextViewer(" \ncould not start the TCL/TK interpreter wish").title("error").shw(0); return null;}
        vWish.put(xDisplay,w);
        return w;
    }
    // ----------------------------------------
    public static Container getControlPanel(String xDisplay) {
        final Wish w=getW(xDisplay);
        return w!=null  ? getCtrlPanel(w.myExec) : null;
    }
}
