package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.strap.extensions.Distance3DToHetero;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.net.URL;
import java.util.*;
import java.util.List;
import javax.swing.*;

import static charite.christo.ChUtils.*;
import static java.awt.Color.*;
public abstract class AbstractAlignmentProject extends AbstractDialogJPanel implements  ActionListener {
    public final static String DIR_PROTEINS="proteins/";
    private static boolean haveAddedPath;

    private void renameOld() {
        {
           String ff[]=file(DIR_PROTEINS+"/global2").list();
            if (ff!=null) {
                for(String f:ff) {
                    renamFile(file(DIR_PROTEINS+"/global2/"+f), DIR_PROTEINS+"/"+f);
                }
            }
            renamFile(file("global2/"), DIR_PROTEINS);
        }
        {
            final String ss[]=file("3dTrans").list();
            if (ss!=null) for(String s : ss) renamFile(file("3dTrans/"+s),"gaps/"+s);
        }
    }

    public void run() {
        if (scrollPane!=null) return;
        if (!haveAddedPath){
            Customize.customize(Customize.file_directories).addHiddenEntries(DIR_PROTEINS);
            haveAddedPath=true;
        }
        Distance3DToHetero.setDefaultHeteroCode("!");
        boolean protect=isMyComputer()&& dirWorking().getAbsolutePath().indexOf("people/christo/Projects/")>=0;
        final JComponent
            pan=vBpnl(
                      "<h3>Data Preparation</h3>"+
                      "For This alignment project a special directory should be created because many files will be downloaded.<br>"+
                      "If you are still in a project directory of another project, restart Strap with a new project directory.<br><br>"+
                      "Two large zip files need to be loaded from the web.<br>",
                      new ChButton("DOWNLOAD").t("download").li(this).tt("Hold shift to load only the alignment but not the proteins")
                      ),

            butPrepare=protect ? null : ChButton.actionViewMessage("prepare project",pan),
            pNorth1=hB("Before you start you must prepare a few things",butPrepare),
            pNorth=vBpnl(pTop(),pNorth1),
            butCloseAll=new ChButton("CLOSE_ALL").t("close all proteins").li(this)
            .tt(" loaded proteins in the alignment are closed.<br>Unsaved alignment data is lost"),
            pSouth1=pnl(butCloseAll),
            pSouth=pnl(new GridLayout(2,1),  pnl(radioGrp(new String[]{"#","files","comment","definition","title","EC"},0,this)),pSouth1);
        scrollPane=new JScrollPane(getPanelButtons(),JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scrollPane.getVerticalScrollBar().setUnitIncrement(32);
        cnsew(this,scrollPane,pNorth,pSouth,null,null);
        revalidate();
        renameOld();
    }
    private static String lastListFile="";
    //protected static String getLastListFile() { return lastListFile;}
    private URL urls[];
    public void setURLs(URL alignments, URL proteinsCalpha) {
        urls=new URL[]{alignments,proteinsCalpha};
    }
    private final UniqueList<Alignment> vAlignments=new UniqueList(Alignment.class);
    private final static UniqueList<String> vOneFromEach=new UniqueList(String.class), vUnsorted=new UniqueList(String.class);
    {
        final ChTokenizer t=new ChTokenizer();
        t.setText(readBytes(file("ALL_IDs")));
        while(t.nextToken()) vUnsorted.add(t.asString());
    }
    public Alignment[] getAlignments() { return vAlignments.asArray();}
    private void downloadAndExtract(URL url, File destDir) {
        mkdrsErr(destDir);
        final String path=url.getPath();
        final File f=file(delSfx(".gz",path.substring(path.lastIndexOf('/')+1)));
        if (f.exists()) delFile(f);
        InteractiveDownload.downloadFiles(new URL[]{url},new File[]{f});
        ChZip.extractAll(f,destDir);
        renameOld();
    }
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        if (cmd=="DOWNLOAD") {
            downloadAndExtract(urls[0],dirWorking());
            scrollPane.getViewport().removeAll();
            scrollPane.getViewport().add(getPanelButtons());
            if ( !isShift(ev)) downloadAndExtract(urls[1],file(DIR_PROTEINS));
        }
        if (cmd=="CLOSE_ALL") {
            final StringBuffer sb=new StringBuffer();
            for(StrapProtein p : align.getVisibleProteins()) sb.append(p.getName()).append("\n");
            wrte(file("sorted/"+lastListFile),sb);
            align.removeProteins(false,align.getProteins());
        }
        int iRadio=radioGrpIdx(q);
        if (iRadio>=0) for(Alignment a:getAlignments()) a.setInfo(iRadio);
    }

    private JScrollPane scrollPane;
    private Container getPanelButtons() {
        Container pnl=Box.createVerticalBox();
        final StringBuffer sb=new StringBuffer();
        for(String suffix: new String[]{".LIST"}) {
            final String files[]=file(".").list();
            sortArry(files);
            for(String l:files) {
                if (l.endsWith(suffix)) {
                    boolean each=false;
                    for(String s : new Alignment(l,vAlignments,pnl).getProteinNames()) {
                        if (!each) {vOneFromEach.add(s);each=true;}
                        if (s.length()>6) sb.append(s.substring(0,6)).append(".ent ");
                    }
                    sb.append("\n");
                    pnl.add(new JSeparator());
                }
            }
        }
        wrte(file("ll"),sb);
        final String[] unsort=vUnsorted.asArray(), each=vOneFromEach.asArray();
        for(int i=2; --i>=0;) {
            pnl.add(new JSeparator());
            final String fn= i==0 ? "OneFromEach" : "Unsorted";
            wrte(file(fn), joinAsStrg(i==0?each:unsort," "));
            new Alignment(fn,vAlignments,pnl);
        }
        return pnl;
    }
    public final static int COUNT=0,FILES=1,NOTE=2,DEF=3,TITLE=4,EC=5,NAME=6,CHART_DATA=7;

    public StrapProtein[] loadProteins(String name,String proteinNames[]) {
        assertEDT();
        final StringBuffer sb=new StringBuffer(999);
        for(String fn:proteinNames) sb.append(proteinName2file(fn)).append('\n');
        final StrapProtein ppLoaded[][]=align.loadTheProteinsInList(sb, StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
        return ppLoaded==null ? StrapProtein.NONE : ppLoaded[0];
    }

    public final class Alignment implements ActionListener {
        private JComponent additionalComponentEast,additionalComponentWest;
        public void setAdditionalComponent(JComponent c,int where) {
            if (where==SwingConstants.WEST) additionalComponentWest=c;
            if (where==SwingConstants.EAST) additionalComponentEast=c;
        }
        private final JEditorPane tf=new JEditorPane();
        public final String[] getProteinNames() {
            final UniqueList<String> l=new UniqueList(String.class);
            add(name,l);
            final String sorted[]=readLines(file("sorted/"+name));
            if (sorted!=null) {
                for(int i=sorted.length; --i>=0;) {
                    String s=sorted[i];
                    if (l.contains(s)) {l.remove(s); l.add(0,s);}
                }
            }
            return l.asArray();
        }
        private final String base,name;
        public String getName() { return name;}
        public String getInfo(int i) {
            CharSequence cs=null;
            switch(i) {
            case COUNT: cs=getProteinNames().length+" proteins"; break;
            case FILES: final String txt=readStrg(name); cs=txt!=null ? txt.replace('\n',' '): null; break;
            case NOTE: cs=addHtmlTags(readStrg("info/"+base+".NOTE")); break;
            case DEF: cs=addHtmlTags(readStrg("info/"+base+".DEF")); break;
            case TITLE: cs=addHtmlTags(readStrg("info/"+base+".TITLE")); break;
            case EC:
                final String ss[]=readLines("info/"+base+".EC");
                if (ss!=null) {
                    final StringBuffer sb=new StringBuffer();
                    for(String s:ss) sb.append("<a href=\"").append("http://www.expasy.org/cgi-bin/nicezyme.pl?").append(s).append("\">").append(s).append("</a>  ");
                    cs=sb;
                }
                break;
            case CHART_DATA:
                final String sd[]=readLines(fChartData());
                if (sd!=null) {
                    StringBuffer sb=new StringBuffer();
                    for(String s:sd)
                        if (s.indexOf("NaN")>0)
                            sb.append(s).append("\n");
                    cs=sb;
                }
                break;
            case NAME: cs=name; break;
            default:
                cs=null;
            }
            return cs==null ? "" : cs.toString();
        }
        public String pdbLink(String url) {
            final StringBuffer sb=new StringBuffer();
            final String ss[]=getProteinNames();
            if (ss!=null)
                for(String s:ss){
                    if (s.length()<4) { sb.append(s).append(" | ");continue;}
                    final String s4=s.substring(0,4);
                    sb.append("<a href=\"").append(rplcToStrg("*",s4,url)).append("\">").append(s).append("</a> | ");
                }
            return sb.toString();
        }
        public void actionPerformed(ActionEvent ev) {
            final String cmd=ev.getActionCommand();
            final Object q=ev.getSource();
            if (q instanceof JComponent) ((JComponent)q).setBackground(((JComponent)q).getBackground().darker());
            if (cmd=="1D"){
                if (name.endsWith(".LIST")) lastListFile=Strap.listFileName=name;
                if (isCtrl(ev)) edFile(-1, file("info/"+base+".NOTE"), 0);
                else if (isShift(ev)) edFile(-1, file("info/"+base+".TITLE"), 0);
                else {
                    loadProteins(name,getProteinNames());
                    final DialogSelectionOfResidues d=child(align.getFrame(),DialogSelectionOfResidues.class);
                    if (d!=null) d.proteinList().selectAll(0);
                }
            }
            if (cmd=="3D") {
                if (isCtrl(ev)) edFile(-1, file(name), 0);
                else {
                    final String nn[]=getProteinNames();
                    final StrapProtein pp[]=new StrapProtein[nn.length];
                    for(int i=nn.length; --i>=0;) {
                        StrapProtein p=StrapProtein.getProteinWithName(nn[i],null);
                        if (p==null) {
                            p=StrapProtein.newInstance(proteinName2file(nn[i]));
                            if (p!=null) {
                                p.setName(nn[i]);
                                StrapAlign.readAttributes("3",p,(File)null);
                            }
                        }
                        pp[i]=p;
                    }
                    align.newBackbone3D_View(pp,0L);
                }
            }
        }
        private Alignment(String theName, List<Alignment> v,Container panel) {
            this.name=theName;
            HtmlDoc.addHyperlinkListener(tf);
            base=withoutDotSuffix(name);
            final ChButton
                but1d=new ChButton("1D").li(this).bg(WHITE).fg(BLUE)
                .tt("<ul><li>Load all proteins => STRAP alignment</li><li>CTRL: edit note</li><li>SHIFT: edit title</li></ul>"),
                but3d=new ChButton("3D").li(this).bg(WHITE).fg(BLUE)
                .tt("<ul><li>no shift no ctrl: all proteins in one 3d</li><li>CTRL: edit List file </li><li>SHIFT: grep </li>");
            setInfo(0);
            tf.setEditable(false);
            alignmentInstantiatedHook(this);
            final JComponent
                pButtons=hB(vBpnl(name,hB( cbox((String)null),but3d,but1d,additionalComponentWest)),additionalComponentEast);
            monospc(tf);
            JScrollPane sp=new JScrollPane(tf,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            panel.add(newCNSEW(sp,null,null,null,pButtons));
            v.add(this);
        }

        public void setInfo(int i) {
            String s=getInfo(i);
            tf.setText("");
            if (s!=null) {
                s=addHtmlTagsAsStrg(s);
                tf.setContentType(s.indexOf("<html>")>=0 ? "text/html": "text/plain");
                tf.setText(s);
            }
        }
        public File fChartData() { return file("chartData/"+base+".data");}
    }
    public File proteinName2file(String name) { return file(DIR_PROTEINS+name); }
    private static void add(final String fn, final List l) {
        final ChTokenizer t1=new ChTokenizer();
        t1.setText(readBytes(file(fn)));
        while(t1.nextToken()) {
            final String s1=t1.asString();
            if (s1.startsWith("uuu")|| s1.startsWith("xxx")) continue;
            if (!s1.endsWith(".L")) {
                l.add(s1);
                vUnsorted.remove(s1);

            } else  add(s1,l);
        }
    }
    public void alignmentInstantiatedHook(Alignment a){}
}
