package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.interfaces.*;
import javax.swing.*;
import java.awt.event.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

<h2>Activate/Deactivate entries in annotations of residues</h2>

With this form the text entries in residue annotations can be activated or deactivated or deleted.

For example Pymol commands that are deactivated are not sent to Pymol.

<i>SEE_DIALOG:DialogResidueAnnotationChanges</i>
<i>SEE_CLASS:ResidueAnnotationView</i>
@author Christoph Gille
*/
public class ActivateDeactivate extends JPanel implements ActionListener {
    private final  ChCombo
        comboKeys=new ChCombo(new ComboKeys(false),ChJTable.CLASS_RENDERER).li(this).s(CLASS_Pymol),
        choice=new ChCombo("Activate","Deactivate","Delete");
    private final ChButton togFilter=toggl("Process only entries that contain a string ");
    private final ChTextField tfFilter=new ChTextField();
    private final ContextObjects hasResidueAnnotations;

    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        if (cmd=="GO") {
            for(ResidueAnnotation a:(ResidueAnnotation[])hasResidueAnnotations.residueSelections('A')) {
                final String sKey;
                {
                    final Object k=comboKeys.getSelectedItem();
                    sKey=k instanceof Class ? ((Class)k).getName() : toStrg(k);
                    if (sze(k)==0) continue;
                }
                final String filter=togFilter.s() ? toStrg(tfFilter) : null;
                for(ResidueAnnotation.Entry e : a.getEntries()) {
                    if (!sKey.equals(e.getKey())) continue;
                    if (sze(filter)>0 && e.getValue().indexOf(filter)<0) continue;
                    final int i=choice.i();
                    if (i<2) e.setEnabled(i==0);
                    else a.removeEntry(e);
                }
            }
            StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
        } else ChFrame.frame("",this,ChFrame.CENTER).shw(ChFrame.PACK);
    }
    public ActivateDeactivate(ContextObjects annotations) {
        hasResidueAnnotations=annotations;
        tfFilter.tools().highlightOccurrence(" ",null,null,HIGHLIGHT_UPDATE_IF_TEXT_CHANGES,C(DEFAULT_BACKGROUND));
        pcp(KEY_PREF_SIZE_IF_DISABLED, "" ,tfFilter);
        final JComponent
            panTF=hB(tfFilter),
            vB=vBpnl(
                     hB(smallHelpBut(this),"#"," Type of Entries: ",comboKeys),
                     " ",
                     hB(choice,pnl(new ChButton("GO").li(this).tt("Activate/deacivate the key -value pairs in the residue annotations").t(ChButton.GO))),
                     " ",
                     togFilter.actionCollapse(false,panTF).cb(),
                     panTF,
                     " "
                     );
        add(vB);
    }
}
