package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import static java.awt.Color.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
public final class DialogAlignResult extends JPanel implements ChRunnable,Disposable, PaintHook, ChProcessEvent  {
    public final static String BUT_LAB_Apply="Approve alignment";
    private final ChEventAdapter LI=new ChEventAdapter(this);

    protected final static long USE_THREADS=1<<1;
    private final StrapAlign align=StrapAlign.getInstance();
    private final DrawGappedSequence dgs=new DrawGappedSequence();
    private final JComponent
        togSort=toggl("Apply order of aligned proteins").li(LI),
        butApply=new ChButton(BUT_LAB_Apply, ChButton.NO_MARGIN).li(LI),
        butUndo=new ChButton("Undo",ChButton.NO_MARGIN|ChButton.DISABLED|ChButton.HIDE_IF_DISABLED).t("Undo").li(LI),
        rowHeader=new ChPanel(),
        panAlignment=new ChPanel();
    {
        addPaintHook(this,rowHeader);
        addPaintHook(this,panAlignment);
    }
    private final SequenceAligner aligner;
    private final ChTableLayout tLayout;
    private static SequenceAligner lastRunningAligner;
    private Thread thread;
    private Protein proteins[];
    private int iiSorting[];
    private JComponent butDetails;
    private final boolean isRectangle;
    private byte[][] aligned;
    //  public Protein[] getProteins() { return proteins;}
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
    DialogAlignResult(boolean isRectangle,SequenceAligner aligner,Protein pp[], long options) {
        this.aligner=aligner;
        this.proteins=pp;
        this.isRectangle=isRectangle;
        monospc(rowHeader);
        monospc(panAlignment);
        panAlignment.addMouseListener(LI);
        scrollByWheel(panAlignment);
        butDetails=noMargn(ChButton.actionCtrl(aligner));
        final JScrollPane scrollPane=scrllpn(0L,panAlignment);
        panAlignment.setPreferredSize(dim(EM*100,EX*100));
        tLayout=new ChTableLayout(ChJTable.NO_REORDER);
        final JScrollPane spHeader=scrllpn(0L,rowHeader);
        scrollPane.getViewport().setBackground(BLACK);
        spHeader.getViewport().setBackground(WHITE);
        tLayout.addColumn(spHeader);
        tLayout.addColumn(scrollPane);
        scrollPane.setVerticalScrollBar(spHeader.getVerticalScrollBar());
        thread=ChDelay.newThread(this,"MAIN",null);
        thread.setPriority(Thread.MIN_PRIORITY);
        if ( (options&USE_THREADS)!=0) thread.start(); else thread.run();
        final JComponent
            pButtonsC=pnl(butApply, butUndo, " ", isAssignblFrm(SequenceAlignerSorting.class,aligner) ? ((ChButton)togSort).cb() : null,butDetails),
            bClose=javaVsn()<16 ? ChButton.actionClose(this, OPTION_DISPOSE_RM_CHILDS) : null,
            pButtons=newCNSEW(pButtonsC,null,null,bClose,null);
        cnsew(this, tLayout,null,pButtons,null,null);
        run("ENABLE_DISABLE",null);
        tLayout.setColWidth(true,0, 10*EM);
        ChDelay.revalidate(rowHeader,999,(long[])null);
        ChDelay.revalidate(panAlignment,999,(long[])null);
        setDragScrolls(scrollPane.getViewport(),scrollPane);
        setDragScrolls(panAlignment,scrollPane);
        for(JComponent c:new JComponent[]{tLayout,panAlignment,scrollPane}) closeOnKeystroke(c,new Object[]{this},DISPOSE_ON_CtrlW);
        addActLi(LI,aligner);
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> PaintHook >>> */
    private final static int lineSkip=5;
    private final static Point origin=new Point();
    private int rowHeaderWidth, localAliStartsAt[];
    private int maxCol;
    private short frequenciesOfAA[][];
    public boolean paintHook(JComponent toBePainted,Graphics g, boolean after) {
        final Protein[] pp=this.proteins;
        if (pp==null) return true;
        final int W=toBePainted.getWidth(), H=toBePainted.getHeight();
        g.setColor(toBePainted==panAlignment ? BLACK : WHITE);fillBigRect(g, 0,0,W,H);
        final boolean isSorting=isSelctd(togSort) && sze(iiSorting)>=pp.length;
        int newRowHeaderWidth=0;
        final Rectangle cb=charBounds(getFont());
        final int lineH=cb.height+lineSkip;

        if (toBePainted==rowHeader && after) {
            for(int i=0;i<pp.length;i++) {
                final int y=lineH*i;
                final int idx=mini(pp.length-1,maxi(0,isSorting ?  iiSorting[i] :i));
                final Protein p=pp[idx];
                if (p==null) continue;
                final Image im=p.getIconImage();
                if (im!=null) {
                    final int imW=im.getWidth(toBePainted),imH=im.getHeight(toBePainted);
                    g.drawImage(im,0,y,imW*cb.height/imH,cb.height,toBePainted);
                }
                g.setColor(BLACK);
                g.drawString(p.getName(),cb.height*2,y+cb.y);
                newRowHeaderWidth=maxi(newRowHeaderWidth,cb.height*2+strgWidth(rowHeader,p.getName()));
                if (rowHeaderWidth!=newRowHeaderWidth) {
                    rowHeader.setPreferredSize(dim(rowHeaderWidth=newRowHeaderWidth, pp.length*lineH));
                }
            }
        }
        if (toBePainted==panAlignment) {
            if (!isReady) paintProgress(g);
            else {
                final byte[] aligned[]=this.aligned;
                final int alignedL=sze(aligned);
                if (alignedL!=pp.length)  { g.drawString("error   ",0,cb.y);return true;}
                if (frequenciesOfAA==null) {
                    frequenciesOfAA=new short[maxCol]['z'-'a'+1];
                    for(byte[] s : aligned) {
                        for(int iCol=mini(frequenciesOfAA.length, sze(s)); --iCol>=0;) {
                            final int c=(s[iCol]|32)-'a';
                            if (0<=c && c<='z'-'a')
                                frequenciesOfAA[iCol][c]++;
                        }
                    }
                }
                final boolean isShadeSecStru=StrapAlign.isShadingSecStru();
                final int[] startsAt=this.localAliStartsAt;
                final Color shadingColors[]=StrapAlign.getShadingColors();
                for(int i=0;i<pp.length;i++) {
                    final int iP=isSorting && iiSorting!=null && iiSorting.length>=pp.length ?  iiSorting[i] : i;
                    final Protein p=pp[iP];
                    final int y=lineH*i;
                    final byte[] s=(aligned!=null && alignedL>iP && aligned[iP]!=null) ? aligned[iP] : "error".getBytes();
                    origin.x=0;
                    origin.y=y;
                    dgs.setConservation(frequenciesOfAA,StrapView.sliderSimilarity().getValue()*pp.length/100);
                    final int firstAmino=startsAt!=null ? startsAt[i] : 0;
                    final long options=isShadeSecStru && firstAmino>=0 ? DrawGappedSequence.SHADE_SEC_STRU : 0L;
                    dgs.draw(panAlignment,g,origin, maxi(0,firstAmino) ,s,0,MAX_INT,(StrapProtein)p,shadingColors, options);
                    dgs.setConservation(null,0);
                }
                final int y=(pp.length+1)*lineH;
                g.setColor(GRAY);
                g.drawString("Info: This is the alignment result preview",0,y);
                g.drawString("You need to press the button \""+BUT_LAB_Apply.replaceAll("<[^>]*>","")+"\"" ,0,y+lineH);
            }
        }
        return true;
    }

    /* <<< Paint <<< */
    /* ---------------------------------------- */
    /* >>> Disposable >>> */
    public void dispose() { // war InvokeAndWait warum ?
        try { thread.stop();}catch(Exception e){}
        dispos(0L,aligner);
        dispos(0L,lastRunningAligner);
        rmAllChilds(this);
        rmFromParent(this);
        proteins=null;
        thread=null;
    }
    /* <<< Disposable <<< */
    /* ---------------------------------------- */
    /* >>> Threading >>> */
    private boolean isReady;
    public Object run(String id, Object arg) {
        if (id=="ENABLE_DISABLE") {
            final byte[] aligned[]=this.aligned;
            tLayout.setTitle(0, aligned!=null && isInstncOf(HasScore.class,aligner) ?
                             "score="+((HasScore)aligner).getScore() : "protein names");
            final Object clazz=aligner instanceof MultiFromPairAligner ? ((MultiFromPairAligner)aligner).getClasses()[0]:aligner;
            tLayout.setTitle(1,"preview of "+delSfx("PROXY",shrtClasNam(clazz)));

            if (butApply!=null) butApply.setEnabled(aligned!=null);
            if (togSort!=null) togSort.setEnabled(aligned!=null);
            repaint();
            validate();
            panAlignment.repaint();
        }
        if (id=="MAIN") {
            (lastRunningAligner=aligner).compute();

            if (this.butDetails!=null) butDetails.revalidate();
            if (isInstncOf(SequenceAlignerSorting.class,aligner)) {
                iiSorting= ((SequenceAlignerSorting)aligner).getIndicesOfSequences();
            }
            isReady=true;
            final byte ali[][]=this.aligned=ChAlignUtils.trimAlignment(2,aligner.getAlignedSequences());
            if (ali!=null) {
                for(byte[] s : ali) {
                    if (maxCol<sze(s)) maxCol=s.length;
                }

                final Protein[] pp=this.proteins;
                final int L=sze(pp), startsAt[]=new int[L];
                for(int i=mini(sze(aligned),L); --i>=0;) {
                    startsAt[i]=idxOfLetters(aligned[i], pp[i].getResidueTypeExactLength(),0,pp[i].countResidues());
                }
                this.localAliStartsAt=startsAt;
            }

            final Rectangle cb=charBounds(getFont());
            panAlignment.setPreferredSize(dim( (1+maxCol)*cb.width , (cb.height+lineSkip)*(2+proteins.length)));
            ChDelay.invokeLater(this,"ENABLE_DISABLE",null);
            ChDelay.revalidate(panAlignment,999,(long[])null);
        }
        return null;
    }
    private String progress;
    private void paintProgress(Graphics gr) {
        final String progr=this.progress;
        if (progr==null) return;
            try {
                final Graphics g=gr!=null ? gr : panAlignment.getGraphics();
                g.setColor(BLACK);
                g.fillRect(0,0,EM*100,2*EX);
                g.setColor(GREEN);
                g.drawString(progr,10,EX);
            } catch(Exception ex){}

    }
    /* <<< Threading  <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    public AWTEvent processEvent(JComponent component, AWTEvent ev) {
        final int id=ev.getID(),kcode=keyCode(ev), modi=modifiers(ev);
        final Object q=ev.getSource();
        final String cmd=actionCommand(ev);
        if (id==MouseEvent.MOUSE_CLICKED && q==panAlignment) {
            error(
                  "This alignment preview is not editable.<br>"+
                  "You can only edit the working alignment in the alignment panel below.<br>"+
                  "If you do not see this panel you may need to drag the divider bar up.<br><br>"+
                  "By pressing the button <I> BUT_LAB_Apply</I><br>"+
                  "The alignment from the preview is infered to  the working  alignment panel."
                  );
        }
        if (cmd!=null && cmd.startsWith(KEY_PROGRESS)) {
                this.progress=delPfx(KEY_PROGRESS,cmd);
                paintProgress(null);
        }
        if (q==togSort) repaint();
        if (q==butApply || q==butUndo) {
            final StrapProtein pp[]=StrapProtein.pp(this.proteins);
            if (pp!=null) {
                final StrapView panel=align.getAlignmentPanelWithFocus();
                final StrapProtein ppVis[]=panel!=null ? panel.getProteins() : null;
                for(StrapProtein p : ppVis!=null ? ppVis : pp) {
                    final int gg[]=gcp(butApply, p, int[].class);
                    if (q==butApply && gg==null) pcp(butApply, p.getResidueGap().clone(),p);
                    if (q==butUndo  && gg!=null) p.setResidueGap(gg.clone());
                }
                if (q==butApply) {
                    final byte[] aligned[]=this.aligned;
                    if (panel==null || sze(aligned)<pp.length || pp.length<2) return null;

                    int midColumn=0;
                    final int lastIdx[]=new int[pp.length];
                    for(int r=pp.length; --r>=0;) {
                        final int col=idxOfLetters(aligned[r],pp[r].getGappedSequenceExactLength());
                        final int nL=countLetters(aligned[r]);
                        lastIdx[r]=pp[r].column2nextIndex(col)+nL;
                        midColumn+=col+nL/2;
                    }
                    midColumn/=pp.length;

                    final AcceptAlignment2 accept=new AcceptAlignment2(pp,aligned);
                    final int[] inserts=accept.getCountInserts();
                    putln("getCountInserts ", inserts);
                    putln("getLastChangedA ", lastIdx);
                    putln("midColumn "+midColumn);

                    final int MAX_SQUEEZE=5;
                    boolean canCompensate=true;
                    for(int r=pp.length; --r>=0;) {

                        final int a0=lastIdx[r]+1, nR=pp[r].countResidues();
                        if (a0+MAX_SQUEEZE>=nR) continue;
                        int bias=inserts[r];
                        for(int a=a0; bias>0 && a<nR && a<a0+MAX_SQUEEZE; a++)  bias-=pp[r].getResidueGap(a);
                        if (bias>0) { canCompensate=false; break; }
                    }
                    final int addToBias= canCompensate ? 0 : -maxi(inserts);
                    putln(ANSI_GREEN+"canCompensate="+canCompensate+"addToBias="+addToBias+ANSI_RESET);
                    for(int r=pp.length; --r>=0;) {
                        final int a0=lastIdx[r]+1, nR=pp[r].countResidues();
                        int bias=inserts[r]+addToBias;
                        for(int a=a0; bias!=0 && a<nR; a++) {
                            bias+=pp[r].addResidueGap(a,-bias);
                            putln(pp[r]+" addResidueGap "+a+" "+ (-bias));
                        }
                    }

                    if (addToBias!=0 && ppVis!=null) {
                        for(StrapProtein p : ppVis) {
                            if (cntains(p,pp)) continue;
                            putln("addToBias "+addToBias+"  "+p+"  column2nextIndex "+p.column2nextIndex(midColumn));
                            p.addResidueGap(p.column2nextIndex(midColumn), -addToBias);
                        }

                    }
                    align.setChanged();
                    new StrapEvent(this,StrapEvent.ALIGNMENT_CHANGED).run();
                    if (isSelctd(togSort) && sze(iiSorting)==pp.length) {
                        for(int i=iiSorting.length; --i>=0;) ((StrapProtein)pp[i]).setPreferedOrder(iiSorting[i]);
                        align.inferOrderOfProteins(pp,StrapAlign.SORT_PREFORDER);
                    }
                    for(Protein p:pp) pcp("ALIGNED_BY_METHOD",aligner.getClass(),p);
                }

                setEnabld(butUndo,q==butApply);

                StrapAlign.dispatchLater(StrapEvent.ALIGNMENT_CHANGED,1);
            }
        }
        return ev;
    }
}
