package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
import static java.lang.System.*;
/**
   @author Christoph Gille
*/
public class DialogDotPlot_Sequence extends JPanel implements ActionListener,Runnable {
    private DialogDotPlot dotplot;
    private final char X_or_Y;
    private JScrollPane scroll;
    private JComponent pnl;
    private int charH,charW, last_sbPos;
    private final static Point ORIGIN=new Point();
    private final DrawGappedSequence dgs=new DrawGappedSequence();
    protected void move(int d){ dotplot.setAlignmentPos(X_or_Y, dotplot.alignmentPos(X_or_Y)+d); run(); }

    private int fontSize;
    protected Font setFontSize(int s,boolean isAbs) {
        int size=s+(isAbs?0:this.fontSize);
        if (size<4) size=4;
        final Font font=getFnt(this.fontSize=size,true,0);
        setFont(font);
        final Rectangle cb=charBounds(font);
        charW=cb.width; charH=cb.height;
        return font;
    }
    protected JScrollBar sb() { return scroll.getHorizontalScrollBar();}
    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        if (cmd=="<") move(-1);
        if (cmd==">") move(+1);
    }
    public JComponent getPanel() { return pnl;}
    public DialogDotPlot_Sequence(DialogDotPlot dotplot, char X_or_Y) {
        this.X_or_Y=X_or_Y;
        this.dotplot=dotplot;
        scroll=new JScrollPane(this,JScrollPane.VERTICAL_SCROLLBAR_NEVER, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        this.pnl=newCNSEW(scroll,null,null,
                          monospc(new ChButton(">",ChButton.NO_MARGIN).li(this)),
                          monospc(new ChButton("<",ChButton.NO_MARGIN).li(this)));
        setFontSize(24,true);
        setPreferredSize(dim(Short.MAX_VALUE,charH+1));
        setDragScrolls(this,scroll);
        pcp(KEY_SCROLL_EVEN_IF_INVISIBLE,"",sb());
    }
    public void run() {
        final int pos=dotplot.alignmentPos(X_or_Y)*charW;
        if (pos>=0) sb().setValue(pos);
    }
    @Override public Dimension getPreferredSize() {
        final byte[] seq=dotplot.getSeq(X_or_Y);
        return dim(seq!=null ? seq.length*charW+getOffset()*2 : 1,charH+2);
    }
    private int getOffset() { return scroll.getViewport().getWidth()/2; }

    @Override public void paintComponent(Graphics g) {
        super.paintComponent(g);
        final Color[] shadingColors=StrapAlign.getShadingColors();
        final StrapProtein p=dotplot.protein(X_or_Y);
        if (p==null) return;
        g.setColor(isWhiteBG() ? Color.WHITE : Color.BLACK);
        g.fillRect(0,0, Short.MAX_VALUE,charH+9);
        ORIGIN.x=getOffset();
        final byte sequence[]=dotplot.getSeq(X_or_Y);
        final char t=dotplot.sequenceType(X_or_Y);
        final int mode=
            (StrapAlign.isShadingSecStru() ? dgs.SHADE_SEC_STRU:0) |
            (t=='B' ? DrawGappedSequence.AA2NT : t=='N' ? dgs.NUCLEOTIDES : 0);
        dgs.draw(this,g,ORIGIN,0,sequence,0,MAX_INT,p,shadingColors,mode);

        final int sbPos=sb().getValue();
        if (last_sbPos!=sbPos) {
            last_sbPos=sbPos;
            dotplot.setAlignmentPos(X_or_Y,sbPos/charW);
        }
    }

}

