package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.extensions.*;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.io.File;
import java.net.URL;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.text.JTextComponent;
import javax.swing.text.StyleConstants;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.Document;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;

import static java.lang.Boolean.TRUE;
import static java.lang.Boolean.FALSE;
public class DialogNeighbors extends AbstractDialogJPanel implements ActionListener,ChRunnable, StrapListener {
    private int iTab;
    private String proteinPdbId;
    private StrapProtein proteins[];
    private JTabbedPane tp;
    private final boolean isInterrupted[]={false};
    private boolean alreadyLoaded;
    private final static Object CATALYTIC_SITE_DONE=new Object();
    private final Map<String,AbstractButton> mapID_CB=new HashMap();
    @Override public void dispose() { isInterrupted[0]=true; mapID_CB.clear();}
    private final Object KEY_CHAIN=new Object();
    public DialogNeighbors(final StrapProtein proteins[],String pdbId) {
        this.proteins=proteins;
        this.proteinPdbId=pdbID(pdbId); ///delPfx("pdb:",delPfx("PDB:",pdbId));
        setLayout(new BorderLayout());
        //align.addDialog(align.panelBackbone3D().getPanel());
        StrapView.setReduceHeight();
        StrapAlign.dispatchLater(StrapEvent.PRINT_COMPUTATION_STARTED,333);
        CanBeStopped.vALIGNMENTS.add(isInterrupted);
        ChDelay.newThread(this,"whatChains",null).start();
        align.addListener(this);
    }
    private void whatChains() {
        final StrapProtein pp[]=proteins.clone();
        for(int iP=0; iP<pp.length; iP++) {
            final StrapProtein p=pp[iP];
            if (p==null) continue;
            StringBuffer sb=(StringBuffer)gcp(KEY_CHAIN,p);
            if (sb==null) pcp(KEY_CHAIN,sb=new StringBuffer(p.getChainsAsString()),p);

            for(int jP=iP+1;jP<pp.length; jP++) {
                if (pp[jP]!=null && equls(STRSTR_IC, p.getResidueType(),pp[jP].getResidueType())) {
                    sb.append(pp[jP].getChainsAsString());
                    pp[jP]=null;
                }
            }
        }
        /* --- COMBINE_GROUPS --- */
        final StrapProtein groups[][]=combineGroups(pp,Superimpose_TM_align.class,.7f,isInterrupted);
        if (groups.length>0) {
            this.tp=new JTabbedPane(JTabbedPane.BOTTOM);
            for(StrapProtein  group[] : groups) {
                putln("Group=",group);
                final StringBuffer sbCh=new StringBuffer();
                for(StrapProtein p: group) sbCh.append(gcp(KEY_CHAIN,p)).append(',');
                ceDali(delSfx(",",sbCh));
            }
        }
    }
    public Object run(final String id,final Object arg) {
        final StrapAlign align=StrapAlign.getInstance();
        final Object[] argv=arg instanceof Object[] ? (Object[])arg : null;
        final long time=System.currentTimeMillis();
        if (id=="whatChains") whatChains();
        if (id.startsWith("NEIGHBOURS_")) {
            final boolean onlyOneChain=this.proteins.length<2;
            final String sChain=(String)(String)argv[0];
            final HyperTextPane tPane=(HyperTextPane)argv[1];
            final ChButton butGo=(ChButton)gcp("GO",tPane);
            closeOnKeystroke(tPane, new Object[]{this},DISPOSE_ON_CtrlW);
            pcp(DialogFindInText.KEY_ID,"DialogNeighbors",tPane);
            monospc(tPane);
            final int countSelected[]=(int[])argv[2];
            final UniqueList<String> vEntries=new UniqueList(String.class);
            File fHtml=null;
            String subTitle="";
            Color bgColor=C(0xFFffFF);
            if (id=="NEIGHBOURS_Vast") {
                sleep(999);
                bgColor=C(0x4444FF);
                final File fGetMmdb=fHtml=read("http://www.ncbi.nlm.nih.gov/Structure/mmdb/mmdbsrv.cgi?uid="+proteinPdbId,3,true);
                final String[] linesMmdb=readLines(fGetMmdb);
                String mmdb=null;
                if (linesMmdb!=null) {
                    for(String l:linesMmdb) {
                        final int
                            uid= l.indexOf("name=\"uid\""),
                            value=uid>0 ? l.indexOf("value=\"") : -1,
                            endQuote=value>0 ? l.indexOf('"',value+7) : -1;
                        if (endQuote>0) {
                            mmdb=l.substring(value+7,endQuote);
                            break;
                        }
                    }
                }
                final File  fVast=mmdb!=null ? read("http://www.ncbi.nlm.nih.gov/Structure/mmdb/mmdbsrv.cgi?ShowOp=VastSum&uid="+mmdb,3,true) : null;
                if (fVast!=null) fHtml=fVast;
                final String vastChains=readStrg(fVast);
                String sdid=null;
                int bracketL=-1;
                while( vastChains!=null && (bracketL=vastChains.indexOf('[',bracketL+1))>0 ) {
                    final int
                        bracketR= vastChains.indexOf(']',bracketL+1),
                        pdb_id=bracketR-bracketL==2 ? vastChains.indexOf("sdid=",bracketR) : -1,
                        endQuote=pdb_id>0 ? vastChains.indexOf('"',pdb_id+6) : -1;
                    if (endQuote>0) {
                        final char ch=chrAt(bracketL+1, vastChains) ,chain=chrAt(0,sChain);
                        if (ch==chain || ch==' ' || chain=='_' || chain==0) {
                            sdid=vastChains.substring(pdb_id+5,endQuote);
                            break;
                        }
                    }
                }
                // <td class="Text"><a href="http://www.ncbi.nlm.nih.gov/Structure/mmdb/mmdbsrv.cgi?uid=66174&amp;Dopt=s">3DBB</a>&nbsp;<a href="vastsrv.cgi?sdid=286164">B</a>&nbsp;<a href="http://www.ncbi.nlm.nih.gov/Structure/mmdb/mmdbsrv.cgi?uid=66174&amp;Dopt=s">2</a></td>

                final File fNeighbors=sdid!=null ? read("http://www.ncbi.nlm.nih.gov/Structure/vast/vastsrv.cgi?sdid="+sdid+"&sort=4&subset=2&DispOp=2",3,true) : null;
                if (fNeighbors!=null) fHtml=fNeighbors;
                final String neighbors=readStrg(fNeighbors);
                int checkbox=0;
                while( neighbors!=null && (checkbox=neighbors.indexOf("\"checkbox\"",checkbox+1)) >0) {
                    final int
                        iPdbid=checkbox>0  ? neighbors.indexOf("Dopt=s\">",checkbox) : -1,
                        iPdbidEnd=iPdbid>0 ? neighbors.indexOf("</a>",iPdbid+8) : -1,
                        iChain=iPdbidEnd>0 ? neighbors.indexOf("</a>",iPdbidEnd+3) -1 : -1;
                    if (iPdbidEnd<0) continue;
                    int td=checkbox;
                    for(int iTd=0; iTd<10; iTd++) {
                        td= neighbors.indexOf("<td",td+1);
                    }
                    final int font=neighbors.indexOf("<font>",td+1), fontEnd=neighbors.indexOf("</font>",font+1);
                    if (fontEnd>0) {
                        boolean isLastCol=neighbors.indexOf("</a></td>",iChain)==1+7+iChain;
                        vEntries.add(neighbors.substring(iPdbid+8,iPdbidEnd)+":"+
                                     (iChain<td &&  !isLastCol ? chrAt(iChain,neighbors) : '_')+
                                     "  "+simplifyTitle(neighbors.substring(font+6,fontEnd)).trim()+"\n");
                    }
                }
            }
            if (id=="NEIGHBOURS_GangstaPlus") {
                bgColor=C(0xFFFF00);
                final String url="http://agknapp.chemie.fu-berlin.de/gplus/addons/getinfo.php?id="+proteinPdbId+(onlyOneChain ? "" : sChain)+"&.txt";
                fHtml=read(url,1,false);
                final String lines[]=readLines(fHtml=read(url,1,false));
                if (lines!=null) {
                    nextLine:
                    for(int iL=0; iL<lines.length; iL++) {
                        final String l=lines[iL].toUpperCase()+"\t";
                        if (chrAt(0,l)=='<') continue;
                        final int tab=l.indexOf('\t');
                        if (iL==0) subTitle="GangstaPlus representative which is an entry of  SCOP 1.71: "+l.substring(0,tab)+"\n";
                        if (l.startsWith(proteinPdbId.toUpperCase())) continue;
                        if (tab<4) continue;
                        final String id_blank=(tab>4 ? l.substring(0,4)+":"+ chrAt(4,l)+" " : l)+"  ";
                        for(String s : vEntries.asArray()) if (s.startsWith(id_blank)) continue nextLine;
                        vEntries.add(id_blank+simplifyTitle(l.substring(tab+1).replace('\t',' ')));
                    }
                }
            }
            if (id=="NEIGHBOURS_Dali") {
                /*
 500:  2dbz-A  3.2  3.8  111   333    9   MOLECULE: GLYOXYLATE REDUCTASE;
   3: 1ryp-A 2fak-G   186 - 242 <=>  186 - 242   (ASN  195  - GLN  251  <=> ASN  184  - GLN  239 )
                */
                bgColor=C(0xff00ff);
                sleep(2222);
                String urlHtml=null;
                fHtml=read("http://ekhidna.biocenter.helsinki.fi/dali/daliquery_txt?pdbid="+proteinPdbId+"&chainid="+(sze(sChain)==1 && chrAt(0,sChain)!='_'  ? sChain : ""),1,false);
                final String lines[]=readLines(fHtml);
                if (lines!=null) {
                    final Map<String,String> mapName=new HashMap();
                    for(int iL=0; iL<lines.length; iL++) {
                        final String line=lines[iL];
                        if (chrAt(0,line)=='#' || line.length()<40 || chrAt(4,line)!=':') continue;
                        final int iMolecule=strstr(STRSTR_AFTER,"MOLECULE:",line);
                        if (iMolecule>0) mapName.put(line.substring(7,11),simplifyTitle(line.substring(iMolecule)));
                        else {
                            final String idColonChain=line.substring(13,19).replace('-',':').trim();
                            vEntries.add(idColonChain+" "+mapName.get(withoutLastComponent(idColonChain,':')));
                        }
                    }
                }
            }
            if (id=="NEIGHBOURS_CE_CL") {
                bgColor=C(0xFF7755);
                fHtml=file(dirWeb()+ "/neighbor_CE/"+proteinPdbId+"_"+sChain+".html");
                ByteArray ceNeighborsHtml=readBytes(fHtml);
                if (ceNeighborsHtml==null  || (time-fHtml.lastModified())/(1000*60*60*24)>1) {
                    final String sUrl="http://cl.sdsc.edu/cgi-bin/align_db_get.cgi";
                    for(int iTry=2; --iTry>=0;) {
                        final Object[][] httpData={
                            {"entity",(proteinPdbId+(iTry>0? ":"+sChain : ""))},
                            {"cmd","get_all_ent_rep"},
                            {"scratch_path", "/misc/cl/ce_scratch"},
                            {"scratch_url","http://cl.sdsc.edu/ce_scratch"},
                            {"db_moose","/misc/cl/db/pdbplus"},
                            {"db_ata","/misc/cl/db/db_ata"},
                            {"pe_url","http://www.umass.edu/microbio/chime/explorer/pe.htm?x=1&id"},
                            {"mkdb_exe","/misc/cl/bin/mkDB"},
                            {"align_db_get_url","http://cl.sdsc.edu/cgi-bin/align_db_get.cgi"},
                            {"compare3d_href","http://cl.sdsc.edu/align_db.html"},
                            {"nb_help_url","http://cl.sdsc.edu/ce/all-to-all/all-to-all-results-help.html"},
                            {"compare3d_cgi_url","http://cl.sdsc.edu/cgi-bin/align_db_get.cgi"},
                            {"compare3d_help_url","http://cl.sdsc.edu/compare_3d_help.html"},
                            {"rcsb_explore_url","http://www.rcsb.org/pdb/cgi/explore.cgi?pdbId"},
                            {"pdb_flat_path","/projects/us/indus1/pbpdb/data"},
                            {"thr_z","4.0"},
                            {"thr_len_diff","100000.0"},
                            {"thr_seq_sim","-1.0"},
                            {"sort_by","z"},
                            {"thr_rmsd","5.0"},
                            {"thr_gaps","100000.0"},
                            {"show_rn","n"}
                        };
                        ceNeighborsHtml=Web.getServerResponse(sUrl,httpData);
                        if (ceNeighborsHtml!=null) {
                            if (strstr("Sorry, no chain",ceNeighborsHtml)<0) break;
                            else wrte( file(fHtml+".failed"),ceNeighborsHtml);
                        }
                    }
                    if (ceNeighborsHtml!=null) wrte(fHtml, "<html>",ceNeighborsHtml,"</html>");
                }
                if (ceNeighborsHtml!=null) {
                    final byte[] T=ceNeighborsHtml.getBytes();
                    final int ends[]=ceNeighborsHtml.getLineEnds();
                    for(int iL=0; iL<ends.length; iL++) {
                        final int b=iL==0 ? 0 : ends[iL-1]+1 ,e=ends[iL];
                        final String line=ceNeighborsHtml.newString(b,e);
                        final int checkbox=line.indexOf("\"checkbox\""),
                            idxID=line.indexOf("<B>"), tdtd=line.indexOf("</TD><TD>");

                        if (checkbox<0||idxID<0||tdtd<0) continue;
                        final String
                            sId=line.substring(idxID+3,line.indexOf("</B>")).trim(),
                            sMolId=line.substring(tdtd+12,line.indexOf("</TD>",tdtd+1)).trim();
                        if (sId.startsWith(proteinPdbId)) continue;
                        vEntries.add(sId+" "+simplifyTitle(sMolId));
                    }
                }
            }
            final String dbName=id.substring(id.indexOf('_')+1);
            final List v=new ArrayList();
            v.add("--------------------------------------------------------------------------------\n");
            if (sze(fHtml)>0) v.add(ChButton.actionOpenURL(fHtml).t(null).options(ChButton.NO_FILL|ChButton.NO_BORDER|ChButton.NO_MARGIN).i(IC_FIREFOX16));
            if (sze(vEntries)>0) {
                v.add(bgColor);
                final SimpleAttributeSet att=new SimpleAttributeSet();
                StyleConstants.setBold(att,true);
                StyleConstants.setUnderline(att,true);
                v.add(att);
                v.add("Similar structures from the "+dbName+"*\n\n");
                v.add(subTitle);
                for(String entry:vEntries.asArray()) {
                    if (isInterrupted[0]) break;
                    final int space=entry.indexOf(' ');
                    final String pdb_id=space>0 ? entry.substring(0,space) : entry;
                    final AbstractButton cb=cbox((String)null);
                    cb.setPreferredSize(dim(ICON_HEIGHT,13));
                    cb.setCursor(getCursr('D'));
                    synchronized(mapID_CB) {
                        if (mapID_CB.get(pdb_id)!=null) cb.setModel(mapID_CB.get(pdb_id).getModel());
                        else {
                            mapID_CB.put(pdb_id,cb);
                            cb.setBackground(bgColor);
                            pcp("CHAIN",sChain,cb);
                            pcp("PDB_ID",pdb_id,cb);
                            if (!alreadyLoaded) {
                                align.addDialog(this);
                                alreadyLoaded=true;
                            }
                        }
                    }
                    v.add(cb);
                    v.add(" PDB:");
                    v.add(entry);
                    v.add("\n");
                }
            } else v.add("No result from the "+dbName+"*\n\n");
            if (!isInterrupted[0]) ChDelay.invokeAndWait(this,"ADD_TO_PANEL",new Object[]{v.toArray(),tPane});
            ChDelay.invokeAndWait(this,"HL",new Object[]{tPane,sze(vEntries)>0 ? intObjct(this.iTab-1) : null});
        }
        if (id=="HL") {
            highlightLoaded((HyperTextPane)argv[0]);
            if (argv[1]!=null) try { tp.setSelectedIndex(atoi(argv[1])); } catch(Exception ex){}
        }
        if (id=="ADD_TO_PANEL") {
            final Object[] oo=(Object[])argv[0];
            final HyperTextPane tPane=(HyperTextPane)argv[1];
            pcp(ACTION_DATABASE_CLICKED,"Load",tPane);
            addActLi(StrapAlign.li(),tPane);
            final Document doc=tPane.getDocument();
            SimpleAttributeSet attr=null;
            for(Object o : oo) {
                if (o instanceof SimpleAttributeSet) { attr=(SimpleAttributeSet)o; continue;}
                final int len=doc.getLength();
                try {
                    if (o instanceof CharSequence)  doc.insertString(len,o.toString(),attr);
                    else if (o instanceof JComponent) { tPane.setCaretPosition(len); tPane.insertComponent((JComponent)o);}
                } catch(Exception ex){stckTrc(ex);}
                attr=null;
            }
        }
        if (id=="FINISHED") {
            StrapAlign.drawMessage("@2 "+ANSI_GREEN+" finished computation");
            ChMsg.sound(ChMsg.SOUND_SUCCESS);
        }
        if (id=="ADD_TAB") {
            final JComponent tab=(JComponent)arg;
            if (iTab++==0) {
                removeAll();
                if (tp==null) add(tab,BorderLayout.CENTER);
                else add(tp,BorderLayout.CENTER);
                TabItemTipIcon.set(proteinPdbId,null,null,null,this);
                align.addDialog(this);
                align.addDialog(align.getTablePanel(CLASS_Protein3d));
            }
            if (tp!=null) adTab((String)gcp("TAB",tab),tab, tp);
        }
        if (id=="GO") {
            final String queryChain= (String)argv[0];
            final boolean buttonPressed=argv[1]==TRUE;
            final ChButton butGo=(ChButton)argv[2];
            StrapAlign.dispatchLater(StrapEvent.COMPUTATION_STARTED,333);
            final UniqueList<String> vCheckboxText=new UniqueList(String.class);
            final Object oo[];
            try {
                synchronized(mapID_CB) { oo=mapID_CB.values().toArray(); }
                for(Object o : oo) {
                    final AbstractButton cb=(JCheckBox)o;
                    if (cb.isSelected() && gcp("CHAIN",cb)==queryChain)
                        vCheckboxText.add((String)gcp("PDB_ID",cb));
                }
                if (sze(vCheckboxText)==0) {
                    if (sze(mapID_CB)>1 && buttonPressed) StrapAlign.errorMsg("No checkbox selected!");
                }
                else {
                    vCheckboxText.add(proteinPdbId+":"+queryChain);
                    final UniqueList<StrapProtein> vP=new UniqueList(StrapProtein.class);
                    final boolean noMore[]=new boolean[1];
                    newThrd(
                            StrapProteinUtils.threadLoopSuperimposeProteinsV(vP,noMore, (boolean[])null, StrapProteinUtils.SUPERIMP_EVENT),
                            StrapProteinUtils.threadAlignProteins(null,vP,CAN_BE_STOPPED, 0L),
                            ChDelay.newThread(this,"FINISHED",null)
                            ).start();

                    CanBeStopped.vALIGNMENTS.add(noMore);
                    Protein3d p3d=null;
                    for(String txt : vCheckboxText.asArray()) {
                        final String pdbId=txt.substring(0,4).toLowerCase();
                        final char ch=chrAt(5,txt);
                        StrapProtein p=null;
                        if (pdbId.equals(this.proteinPdbId)) {
                            for(StrapProtein p0 : proteins) {
                                if (p0==null) continue;
                                final String s=p0.getChainsAsString();
                                if (sze(s)==1 && chrAt(0,s)==ch)     p=p0;
                            }
                        }
                        if (p==null) {
                            final String chain=(ch!=0 && ch!=' ' && ch!='_' ? "_"+ch : "");
                            p=get(0, align.downloadProteinID("PDB:"+pdbId+chain, new Object[]{StrapAlign.class}, null,0 ), StrapProtein.class);
                        }
                        if (p==null || p.getResidueCalpha()==null) continue;
                        if (p3d==null) { p3d=align.newBackbone3D_View(new StrapProtein[]{p}, 0L);}
                        if (p3d!=null) p3d.addProteins(p);
                        vP.add(p);
                        if (align.setIsInAlignment(true,p)) align.dispatchLater(StrapEvent.PROTEINS_SHOWN, 100);
                    }
                    //SequenceFeatures.loadGFF_BG(vP.asArray(),SequenceFeatures.CSA_EBI);
                    noMore[0]=true;
                    StrapProteinUtils.threadSuperimposeProteins(vP,CAN_BE_STOPPED, StrapProteinUtils.SUPERIMP_EVENT).start();
                    if (p3d!=null) p3d.eachProteinInDifferentColor(false,false);
                    StrapProteinUtils.setProteinIcon(vP.asArray(),false,'A');
                }
            } finally {pcp("C",null,butGo.t("GO")); }
        }
        return null;
    }

    private void ceDali(final String chains) {
        if (isInterrupted[0]) return;
        sleep(333*iTab);
        final char c0=chrAt(0,chains), chain=c0!=0 && c0!=' ' ? c0: '_';
        final String sChain=String.valueOf(chain);
        final HyperTextPane tPane=new HyperTextPane();
        tPane.setLineWrap(false);
        tPane.setText(ChTextViewer.KEYBINDINGS);
        tPane.tools().underlineRefs(0);
        final ChButton butGo=new ChButton("GO").t(ChButton.GO).li(this)
            .tt("The selected structural neighbors will be loaded and aligned three-dimensionally.");
        pcp("GO",butGo,tPane);
        pcp("CHAIN",sChain,butGo);
        final JComponent
            but3d=new ChButton("3D-WIRE").t("View 3D","backbone",dim(64,32)).li(this),
            pNorth=pnl(enlargeFont(proteinPdbId,2f)),
            tab=newCNSEW(
                         tPane.tools().scrollPane(),
                         newCNSEW(pNorth,null,null, pnl(smallHelpBut(this),ChButton.actionClose(this)),pnl(but3d)),
                         pnl("Load and superimpose proteins of selected checkboxes: ",enlargeFont(butGo,1.5)),
                         " "," ");
        pcp("TAB",chains,tab);
        pcp("I_TAB",intObjct(iTab), tPane);
        ChDelay.invokeAndWait(this,"ADD_TAB",tab);

        final List v=new ArrayList();
        final StringTokenizer st=new StringTokenizer(chains," ,");
        boolean isFirst=true,isSecond=false;
        final SimpleAttributeSet attUB=new SimpleAttributeSet(), attB=new SimpleAttributeSet();
        StyleConstants.setBold(attUB,true);
        StyleConstants.setBold(attB,true);
        StyleConstants.setUnderline(attUB,true);
        while(st.hasMoreTokens()) {
            final String
                t=st.nextToken(),
                pdb_id=this.proteinPdbId+":"+chrAt(0,t);
            final AbstractButton cb=cbox((String)null);
            cb.setCursor(getCursr('D'));
            pcp("CHAIN",sChain,cb);
            pcp("PDB_ID",pdb_id,cb);
            cb.addActionListener(this);
            mapID_CB.put(pdb_id,cb);
            if (isFirst) {
                v.add(attUB);
                v.add("\nQuery:");
            } else if (isSecond) {
                v.add(attB);
                v.add("The following backbones are very similar:\n");
            }
            v.add("  ");
            v.add(cb);
            v.add(isFirst ? " PDB" : "    ");
            v.add( sze(t)>1 ? pdb_id+"  Identical sequences: "+t.substring(1) : pdb_id);
            v.add("\n");
            if (isFirst) { isFirst=false; isSecond=true;} else isSecond=false;
        }
        ChDelay.invokeAndWait(this,"ADD_TO_PANEL",new Object[]{v.toArray(),tPane});

        final int countSelected[]={0,0};
        for(String db : new String[]{"NEIGHBOURS_CE_CL","NEIGHBOURS_Dali","NEIGHBOURS_GangstaPlus", "NEIGHBOURS_Vast"})
            if (!isInterrupted[0])
                ChDelay.newThread(this,db,new Object[]{sChain,tPane,countSelected}).start();
    }

    public void actionPerformed(ActionEvent ev) {
        final String cmd=ev.getActionCommand();
        final Object q=ev.getSource();
        if (cmd=="GO")  {
            StrapAlign.drawMessage("@1");
            final ChButton butGo=(ChButton)q;
            if (gcp("C",butGo)==null) {
                isInterrupted[0]=false;
                pcp("C","C",butGo.t("cancel"));
                ChDelay.newThread(this,"GO", new Object[]{gcp("CHAIN",q),TRUE,q}).start();
            } else {
                isInterrupted[0]=true;
                pcp("C",null,butGo.t("GO"));
            }
        }
        final String soap_sq=delPfx(SOAP_WSDbfetch.CMD_WSDBFETCH_SEND_QUERY,cmd);
        if (cmd!=soap_sq) StrapAlign.drawMessage("@2"+ANSI_W_ON_R+"SOAP "+soap_sq);
        final String soap_fe=delPfx(SOAP_WSDbfetch.CMD_WSDBFETCH_SEND_QUERY,cmd);
        if (cmd!=soap_fe) StrapAlign.drawMessage("@2"+ANSI_GREEN+"SOAP success");
        if (cmd=="3D-WIRE") align.newBackbone3D_View(proteins,0L);
    }
    private static File read(String url, int days,boolean debug) {
        final URL u=url(url);
        return download_TS(u, CacheResult.isEnabled()?days:0);
    }
    private final static String[]
        delPrefix={"_ID: 1; MOLECULE: ","The ","Nmr ","X-Ray ","Crystal ","Solution ","Structure ","Struture ","Of ","The ","Structural Analysis Of ","Asymmetric Structure Of ","Conformation Of The ","Solution Structure Of ","And Function Of ","Structural Basis Of ","Structural Basis For ","Structural Genomics",","},
        delPREFIX=new String[delPrefix.length];

    public static String simplifyTitle(String s) {
        s=s.replaceAll("  +"," ");
        s=s.replaceAll("; CHAIN:.*","");
        s=s.replaceAll("Crystal Structure ","");
        s=s.replaceAll("CRYSTAL STRUCTURE ","");
        s=s.replaceAll("MOLID: 1; MOLECULE: ","");
        for(int i=0; i< delPrefix.length; i++) {
            if (delPREFIX[i]==null) delPREFIX[i]=delPrefix[i].toUpperCase();
            s=delPfx(delPrefix[i],s);
            s=delPfx(delPREFIX[i],s);
        }
        return s.trim();
    }

    private final UniqueList<ChTextComponents.Highlight> vHighlights=new UniqueList(ChTextComponents.Highlight.class);
    private void highlightLoaded(HyperTextPane tp) {
        if (tp==null) {
            for(HyperTextPane t : childs(this, HyperTextPane.class)) if (t!=null) highlightLoaded(t);
            return;
        }
        final ChTextComponents tools=tp.tools();
        //for(ChTextComponents.Highlight hl : vHighlights.asArray()) tools.removeHighlight(hl);
        //vHighlights.clear();
        final UniqueList<ChTextComponents.Highlight> vHighlights=new UniqueList(ChTextComponents.Highlight.class);
        final UniqueList<String> vIDs=new UniqueList(String.class);
        for(StrapProtein p:align.getProteins()) {
            final String id=pdbID(p.getPdbID()), chains=p.getChainsAsString();
            vIDs.add(id);
            if (id==null) continue;
            for(int i=sze(chains); --i>=0;) {
                final char c=chrAt(i,chains);
                vIDs.add(id+":"+(c==' ' ? '_' : c));
            }
        }
        for(String id:vIDs.asArray()) vHighlights.add(tools.highlightOccurrence(id, null,null, HIGHLIGHT_IGNORE_CASE|HIGHLIGHT_UPDATE_IF_TEXT_CHANGES, C(0xffff,00)));
        tools.repaintLater(999);
    }
    public void handleEvent(StrapEvent ev) {
        final int type=ev.getType();
        if (type==StrapEvent.PROTEINS_ADDED||type==StrapEvent.PROTEINS_KILLED) highlightLoaded(null);
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Static Utilities  >>> */
    private static StrapProtein[][] combineGroups(StrapProtein[] proteins,Object hasScore,float threshhold, boolean isInterrupted[]) {
        final UniqueList<StrapProtein> vGroups[]=new UniqueList[proteins.length];
        int iGroups=0;
        final Map<String,Float> mapScores=new HashMap();
        for(StrapProtein pNew : proteins) {
            if (pNew==null) continue;
            boolean foundGroup=false;
            for(int iG=0;iG<iGroups;iG++) {
                boolean isSimilar=true;
                for(StrapProtein pInGroup : vGroups[iG].asArray()) {
                    if (isInterrupted[0]) return new StrapProtein[0][];
                    final String key=pNew+" "+pInGroup;
                    Float score=mapScores.get(key);
                    if (score==null) {
                        final Superimpose_TM_align s3d=new Superimpose_TM_align();
                        s3d.setMobileProtein(pNew);
                        s3d.setReferenceProtein(pInGroup);
                        s3d.compute();
                        mapScores.put(key,score=new Float(s3d.getScore()));
                        //putln("ssssssssss "+pNew+" "+pInGroup+"  "+score);
                        if (Float.isNaN(score.floatValue()) || score.floatValue()<threshhold) { isSimilar=false; break;}
                    }
                }
                if (isSimilar) { vGroups[iG].add(pNew); foundGroup=true; break;}
            }
            if (!foundGroup) (vGroups[iGroups++]=new UniqueList(StrapProtein.class)).add(pNew);
        }

        StrapProtein ppGroups[][]=new StrapProtein[iGroups][];
        for(int iG=iGroups; --iG>=0;) { ppGroups[iG]=vGroups[iG].asArray(); theOneWithMostCalphaToTop(ppGroups[iG]);}
        return ppGroups;
    }
    private static void theOneWithMostCalphaToTop(StrapProtein pp[]) {
        if (pp==null || pp.length<2) return;
        int countMax=0, idx=-1;
        for(int i=pp.length; --i>=0;) {
            final int nR=pp[i].countResidues();
            final byte bb[]=pp[i].getResidueType();
            int count=0;
            for(int iA=mini(nR,bb.length); --iA>=0;) if ('A'<=bb[iA] && bb[iA]<='Z') count++;
            if (count>countMax) { countMax=count; idx=i;}
        }
        final StrapProtein tmp=pp[0];
        pp[0]=pp[idx]; pp[idx]=tmp;
    }

}
/*

Problems 2hpl not yet.

"Christopher Wilton" <chris.wilton@helsinki.fi> Dali

ERROR
QuickPdb for 1sbc

java.lang.IllegalArgumentException: InputStream can notnot be null

Error in BDB-site:
Search expression should be repeated on the following pages

<span class="TreeviewSpanArea"> where do you close the tag
*/

