package charite.christo.strap;
import charite.christo.*;

import javax.swing.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
/**HELP

The user enters the name of a protein and an amino acid sequence.
Instead of a crude sequence a protein file text in PDB, Swissprot or Fasta format can be typed.

<i>SEE_CLASS:charite.christo.protein.ProteinParser</i>.

   @author Christoph Gille

*/
public class DialogNewProtein extends AbstractDialogJPanel implements Runnable {
    private final Object tfName, ta;
    public DialogNewProtein() {
        final ChTextField tfName=new ChTextField("",COMPLETION_FILES_IN_WORKING_DIR);
        final ChTextArea ta=new ChTextArea("");
        pcp(KEY_IF_EMPTY,"Enter the name of the protein file.",this.tfName=tfName);
        pcp(KEY_IF_EMPTY,"Enter the file contents of the protein file",this.ta=ta);
        setNFC(ta,tfName);
        setNFC(tfName,ta);
        final JComponent  pSouth=newCNSEW(tfName,null,null,new ChButton("Create protein file").r(this),null);
        cnsew(this,ta.tools().enableUndo(true).scrollPane(),vB(pTop(),pSouth),null,null,null);
    }
    public void run() {
        final String fn=tfName.toString(),t=toStrg(ta);
        if (""==fn ||  t.trim().length()==0) { error("Please enter a name and a file text for the protein"); return;}
        if (fn.indexOf(' ')>=0) { error("A file name should not contain space"); return;}
        final java.io.File f=file(fn);
        if (f.isDirectory()) { error(f+"<br> is a directory"); return;}
        if (sze(f)>0 && !ChMsg.yesNo("File already exists, overwrite ?")) return;
        align.removeProteins(false,StrapProtein.getProteinWithName(fn,align.getProteins()));
        wrte(f,t);
        align.loadTheProteinsInList(fn,StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
    }
}
