package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.*;
import javax.swing.JComponent;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;

/**
@author Christoph Gille
*/
public class DialogRenameProteins implements ActionListener, Runnable {
    private  final static String INVALID="/=;^\\*\"$%&(){}[],<>|", II[]=new String[128], KEY_PREV="DRP$$P";
    public final static int
        P40301=1, P40301_DroMe=2, PRC3_DROME=3, PRC3_DROME_P40301=4,  Drosophila_melanogaster_P40301=5,
        D_melanogaster_P40301=6, P40301_D_melanogaster=7, Fruit_fly_P40301=8, MAX_VARIABLE=9,
        GENERATE=1<<0, COPY=1<<1, INFO_CUT_TERMINI=1<<2;
    private final static int RENAME_UNDO=1<<2;
    private final ChLabel labInfo=new ChLabel();
    private final ChFrame frame;
    private final ChTextArea ta=new ChTextArea(""), taHeader=new ChTextArea("");
    private final ChCombo
        combo=new ChCombo(getFinalStaticFields(DialogRenameProteins.class, MAX_VARIABLE)),
        comboMvCp=new ChCombo("Rename proteins","Create new proteins");
    private final JComponent pnl,pnlCutTermini,
        pnlGenerate=pnl("#ETBem","Alternatively, protein.names<br>can be generated.<br>Chose a template:",combo.s(4),new ChButton("C",ChButton.NO_MARGIN).t("generate").li(this)),
        pnlTogGenerate=hBL(toggl().actionCollapse(false,pnlGenerate),"Alternatively, use organsim name, compound name, Swiss-ID etc.");
    private final Map<StrapProtein,String> mapProteins=new WeakHashMap();
    /* ---------------------------------------- */
    /* >>> Constructor  >>> */
    private static DialogRenameProteins _lastInst;
    private DialogRenameProteins() {
        _lastInst=this;
        addActLi(this,ta.tools().enableWordCompletion(dirWorking()).enableUndo(true));
        taHeader.setEditable(false);

        final JComponent
            pnlExplainCut0=
            hBL("#ETB","An exclamation mark and a range expression is appended to the protein name.<br><br>"+
                "Assume you have a protein named \"myProtein\".<br>"+
                "Assume you want only the sequence part from residue 100 to 200.<br>"+
                "You would type the following rename line:"+
                "<pre class=\"terminal\">\n  myProtein.seq ==> myProtein.seq!100-200\n</pre>"+
                "<sub>For PDB files you can refer to the residue number and chain using the Rasmol syntax (residueNumber-colon-chainLetter).</sub><br>"),
            pnlExplainCut=pnl(" ",pnlExplainCut0," ");
        this.pnlCutTermini=
            vB(hB("<font color=\"#AA0000\">You want to remove N- and C-termini?</font> ",toggl().actionCollapse(false,pnlExplainCut).actionPack(),"<font color=\"#AA0000\">Explain </font>","#"),
               pnlExplainCut
               );
        setEnabld(pnlCutTermini,false);
        pcp(KEY_PREF_SIZE_IF_DISABLED,dim(0,0),pnlCutTermini);

        final JComponent
            pS=vBpnl(
                     pnl(comboMvCp," ",new ChButton("GO").li(this).t(ChButton.GO).tt("The proteins are renamed according to the list of old and new names  in the text area.")),
                     pnl("#TB Undo, Set to original name",
                         new ChButton("R").t("Reset to previous").li(this),new ChButton("R0").t("Reset to original").li(this),"#"),
                     labInfo),

            pN=vBpnl(
                     pnlCutTermini,
                     "<h3>Renaming / copying protein files</h3>",
                     "Edit the protein names in the right column and press the go-button.",
                     pnlTogGenerate,
                     pnlGenerate,
                     " "
                     ),
            pC=newCNSEW(scrllpn(0L,ta,dim(50*EM,10*EX)),taHeader,null,null,"#ETB");

        pcp(KEY_PREF_SIZE_IF_DISABLED, dim(0,0),pnlGenerate);
        pcp(KEY_PREF_SIZE_IF_DISABLED, dim(0,0),pnlTogGenerate);
        pnl=newCNSEW(pC,pN,pS,null,null);
        frame=new ChFrame("rename proteins").ad(pnl).size(555,444).shw(CLOSE_ON_CtrlW|ChFrame.AT_CLICK);
        Object hl=StrapAlign.getInstance();
        ta.tools().highlightOccurrence(hl, charClass(SPC), charClass(SPC), HIGHLIGHT_UPDATE_IF_TEXT_CHANGES, C(0xFFff14,90));
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> API >>> */
    private static ChMap<Object,DialogRenameProteins> mapInst;
    public static DialogRenameProteins instance(Object key) {
        if (mapInst==null) mapInst=new ChMap(0L,String.class, DialogRenameProteins.class,4);
        DialogRenameProteins d=mapInst.get(key);
        if (d==null) mapInst.put(key,d=new DialogRenameProteins());
        return d;
    }
    static void update() {
        DialogRenameProteins d=_lastInst;
        if (d!=null && mapInst!=null) ChDelay.runAfterMS(EDT,d,999);

    }
    public void run() {
        for(DialogRenameProteins d : mapInst.vArray()) d.ta.setText(d.ta.getText());
    }
    public void rename(long options, StrapProtein pp[], Object key) {
        mapProteins.clear();
        for(StrapProtein p : pp) if (p!=null) mapProteins.put(p,p.getName());
        applyOptions(options);
        setText(0,key);
        frame.shw(ChFrame.AT_CLICK|ChFrame.PACK);
    }
    /* <<< API  <<< */
    /* ---------------------------------------- */
    /* >>> AWTEvent >>> */
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        if (cmd=="R")  setText(-1,null);
        if (cmd=="R0") setText(-RENAME_UNDO,null);
        if (cmd=="C")  setText(combo.i(),null);
        if (cmd=="GO") go();
    }
    /* <<< AWTEvent  <<< */
    /* ---------------------------------------- */
    /* >>> go >>> */
    private void go() {
        final StrapAlign align=StrapAlign.getInstance();
        final StrapView view=align.getAlignmentPanelWithFocus();
        final StrapProtein pp[]=align.getProteins();
        final ByteArray ba=ta.tools().byteArray();
        final int ends[]=ba.getLineEnds();
        final byte[] txt=ba.getBytes();
        final ChTokenizer t=new ChTokenizer();
        final StringBuffer sbError=new StringBuffer(9999);
        StringBuffer sbCopy=null;
        final boolean copy=comboMvCp.i()>0;
        int success=0;
        for(int iL=0;iL<ends.length; iL++) {
            final int b= iL==0 ? 0 : ends[iL-1]+1;
            final int e=ends[iL];
            if (e>b && txt[b]=='#') continue;
            t.setText(txt,b,e);
            t.setDelimiters(charClass(SPC));
            if (!t.nextToken()) continue;
            final String old=t.asString();
            if (!t.nextToken()) {
                sbError.append("Line "+iL+": missing new name\n");
                continue;
            }
            final String neu=t.asString();
            if (t.nextToken()) {
                sbError.append("Line "+iL+": more than two tokens found in line\n");
                continue;
            }
            if (old.equals(neu)) continue;
            final StrapProtein p=StrapProtein.getProteinWithName(old,pp);
            if (p==null)     {
                sbError.append("Line "+iL+": no such protein  \""+old+"\"\n");
                continue;
            }
            final File fOld=p.getFile();
            if (fOld==null) {
                sbError.append("Line "+iL+": \""+old+"\" has no file\n");
                continue;
            }
            if (neu.indexOf(':')>0 && !p.hasCalpha()) {
                sbError.append("Line "+iL+":  colon found in \""+neu+"\" but file is not a protein file\n");
                continue;
            }
            final int R=p.countResidues();
            final int idx0_old=maxi(0,firstTrue(p.getResidueSubsetAsBooleanArray()));
            final int gaps[]=p.getResidueGap().clone();
            final int cols[]=p.getResidueColumn().clone();
            final int exclamOld=old.lastIndexOf('!');
            final int exclamNeu=neu.lastIndexOf('!');
            if (exclamNeu>=0 && exclamNeu<StrapAlign.underscoreChainDotExtIdx(neu)) {
                sbError.append("Line "+iL+":  exclamation mark which preceed residue range expressions must be after the file extension. \""+neu+"\" \n");
                continue;
            }
            final String dir=copy ? "" :  fOld.getParent()+"/";
            final File fNeu=file(dir+StrapAlign.name2file(neu));
            final File fNeuNoChain=file(dir+StrapAlign.name2file(deleteUnderscoreChain(neu)));
            final File fOldNoChain=file(dir+StrapAlign.name2file(deleteUnderscoreChain(old)));
            if (!p.isInMsfFile()) {
                if (copy) p.save(dirWorking(),null);
                for(String m : Protein.FILE_MASKS) {
                    final File fN= Protein.strapFile(null,neu,m);
                    final File fO= Protein.strapFile(null,old,m);
                    if (!fO.equals(fN)) {
                        delFile(fN);
                        if (copy) cpy(fO,fN);
                        else renamFileOrCpy(fO,fN);
                    }
                }
            }
            if (copy) {
                if (!fNeu.equals(fOld)) {
                    delFile(fNeu);
                    if (p.isInMsfFile()) {
                        putln("fNeu="+fNeu);
                        final byte[] seq=p.getResidueTypeFullLength();
                        wrte(fNeu,">"+p+"\n"+toStrg(seq)+"\n");
                        final int idx=p.getFirstResidueIndexOffset();
                        final File f=Protein.strapFile(null, fNeu.getName(), Protein.m1stIdx);
                        if (idx==0) delFile(f); else wrte(f,String.valueOf(idx));
                        //align.loadTheProteinsInList(f.toString(),0L);
                    } else if (sze(fOldNoChain)>0) {
                        if (!fNeuNoChain.equals(fOldNoChain)) {
                            delFile(fNeuNoChain);
                            cpy(fOldNoChain,fNeuNoChain);
                        }
                    } else cpy(fOld,fNeu);
                    success++;
                }
                putln(" neu="+neu);
                if (sbCopy==null) sbCopy=new StringBuffer();
                sbCopy.append(neu).append('\n');
            } else {
                final String colonChainNeu=StrapAlign.colonChain(neu);
                final char usChainNeu=StrapAlign.underscoreChain(neu);
                final boolean colonChainChanged=!colonChainNeu.equals(StrapAlign.colonChain(old));
                final boolean usChainChanged= usChainNeu!=StrapAlign.underscoreChain(old);
                final boolean subsetChanged=exclamNeu+exclamOld>-2 && !neu.substring(exclamNeu+1).equals(old.substring(exclamOld+1));
                if (sze(fNeu)==0) {
                    if (usChainChanged) {
                        final File fOrig=sze(fOldNoChain)>0 ? fOldNoChain : fOld;
                        PDB_separateChains.writePdbOnlyChain(fNeu, usChainNeu,readBytes(fOrig));
                    } else {
                        if (!p.isInMsfFile()) renamFile(fOld,fNeu);
                        success++;
                    }
                }
                if (colonChainChanged || usChainChanged || subsetChanged) {
                    p.setOnlyChains(colonChainNeu!="" ? colonChainNeu : null);
                    p.parse(fNeu,null,StrapProtein.getParserOptions());
                    final String subset=exclamNeu>0 ? neu.substring(exclamNeu+1): "";
                    p.setResidueSubset(subset);
                    final int idx0=maxi(0,firstTrue(p.getResidueSubsetAsBooleanArray()));
                    final int D=idx0-idx0_old;
                    if (D>0 ) {
                        if (idx0>=0 && R>D) {
                            final int[] gapNew=new int[R];
                            System.arraycopy(gaps,D,gapNew,0,R-D);
                            for(int i=0; i<D; i++) gapNew[0]+=(gaps.length>i ? gaps[i]:0)+1;
                            p.setResidueGap(gapNew);                            
                            pcp(KEY_PREV+p.getName(),gaps,p);
                        }
                    } if (D<0) {
                        int[] gapNew=gcp(KEY_PREV+neu,p,int[].class);
                        if (gapNew==null) {
                            gapNew=new int[R-D];
                            System.arraycopy(gaps,0,gapNew,-D, R);
                            gapNew[0]=maxi(0,gapNew[-D]+D);
                            gapNew[-D]=0;
                        }
                        p.setResidueGap(gapNew);
                    }
                    StrapAlign.dispatchLater(StrapEvent.RESIDUE_TYPES_CHANGED,1);
                    if (p.hasCalpha()) StrapAlign.dispatchLater(StrapEvent.ATOM_COORDINATES_CHANGED,1);
                }
                p.setName(neu);
                p.setFile(fNeu);
            }
        }
        if (sbCopy!=null) align.loadTheProteinsInList(sbCopy,StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
        if (sze(sbError)>0) error(sbError);
        labInfo.t(" successfully  "+ (copy ?"copied " : "renamed ")+success+" proteins.").fg(C(0x00FF00));
        StrapAlign.dispatchLater(StrapEvent.PROTEIN_RENAMED,111);
        StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
        ta.setText(ta.getText());
    }
    /* <<< GO <<< */
    /* ---------------------------------------- */
    /* >>> setText >>> */
    private void setText(int type, Object key) {
        final String col0="Current protein name";
        final ByteArray sb=new ByteArray(999);
        final StrapProtein[] pp= keyArry(mapProteins,StrapProtein.class);
        final int max=maxi(longestName(pp),sze(col0));
        for(StrapProtein p: pp) {
            if (p==null) continue;
            final int idx0=p.getFirstResidueIndex();
            final int[] fromTo=gcp(key,p,int[].class);
            final String name=p.getName();
            final String neu=
                fromTo!=null ? withoutLastComponent(toStrg(p),'!')+"!"+(fromTo[0]+1+idx0)+"-"+(fromTo[1]+idx0) :
                (-type==RENAME_UNDO) ? p.getName0() :  type<0 ? mapProteins.get(p) : newName(p,type);
            sb.append(' ',max+1- sze(name)).append(name).append(' ',2).append(neu!=null?neu:name).append('\n');
        }
        ta.setText(sb.newString());
        taHeader.setText(sb.setEnd(0).append(' ',max+1-sze(col0)).append(col0).append("  New protein name").newString());
        taHeader.setBackground(C(DEFAULT_BACKGROUND));
    }
    private void applyOptions(long options) {
        comboMvCp.s((options&COPY)!=0 ? 1 :0);
        setEnabld(pnlGenerate,    0!=(options&GENERATE));
        setEnabld(pnlTogGenerate, 0!=(options&GENERATE));
        setEnabld(pnlCutTermini,  0!=(options&INFO_CUT_TERMINI));
    }

    /* <<< setText <<< */
    /* ---------------------------------------- */
    /* >>> Utils  >>> */
    private static String deleteUnderscoreChain(String p) {
        final int us=StrapAlign.underscoreChainDotExtIdx(p);
        return us<0 || p.charAt(us)!='_' ? p : p.substring(0,us)+p.substring(us+2);
    }
    public static String newName(Protein p, int type) {
        final String
            allID[]=p.getSequenceRefs(),
            org0=p.getOrganism(),
            sc0=p.getOrganismScientific(),
            org=org0!=null ? org0.replaceAll("[^-A-Za-z0-9_+-]","_") : null,
            sc=sc0!=null ? sc0.replaceAll("[^-A-Za-z0-9_+-]","_") : null;
        final int spc=sc!=null ? sc.indexOf('_') : -1;
        String swiss=null, embl=null;
        for(String s0:allID) {
            final String s=s0.substring(s0.indexOf(':')+1);
            if (s.indexOf('_')>2) swiss=s; else if (embl==null)  embl=s;
        }
        StringBuffer r=null;
        switch(type) {
        case P40301:
            if (embl!=null) r=new StringBuffer(embl);
            break;
        case PRC3_DROME:
            if (swiss!=null) r=new StringBuffer(swiss);
            break;
        case PRC3_DROME_P40301:
            if (embl!=null && swiss!=null) r=new StringBuffer(swiss).append('_').append(embl);
            break;
        case P40301_DroMe:
            if (spc>1 && spc+2< sze(sc)) {
                r=new StringBuffer().append(embl).append('_');
                if ("Escherichia_Coli".equalsIgnoreCase(sc)) r.append("coli");
                else if ("Homo_Sapiens".equalsIgnoreCase(sc)) r.append("human");
                else if ("Mus_Musculus".equalsIgnoreCase(sc)) r.append("mouse");
                else if (sc.startsWith("Rattus")) r.append("rat");
                else
                    r.append(uCase(sc.charAt(0)))
                        .append(lCase(sc.charAt(1)))
                        .append(lCase(sc.charAt(2)))
                        .append(uCase(sc.charAt(spc+1)))
                        .append(lCase(sc.charAt(spc+2)));
            }
            break;
        case Drosophila_melanogaster_P40301:
            if (sc!=null && embl!=null) r=new StringBuffer(sc).append('_').append(embl);
            break;
        case Fruit_fly_P40301:
            if (org!=null && embl!=null) r=new StringBuffer(org).append('_').append(embl);
            break;
        case P40301_D_melanogaster:
        case D_melanogaster_P40301:
            if (sc!=null && embl!=null && spc>1) {
                r=new StringBuffer();
                final boolean e=(type==P40301_D_melanogaster);
                if (e) r.append(embl).append('_');
                r.append(sc.charAt(0)).append('_').append(sc.substring(spc+1));
                if (!e) r.append('_').append(embl);
            }
            break;
        }
        if (r!=null) {
            final String ext =StrapAlign.underscoreChainDotExt(p.getName());
            if (ext!=null) r.append(ext);
            return r.toString();
        }
        return null;
    }
}
