package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.ResidueSelection;
import java.util.*;
import java.lang.ref.Reference;

import static charite.christo.ChUtils.*;
import java.awt.Rectangle;
import java.awt.Color;
import javax.swing.JComponent;
import static charite.christo.ChConstants.*;

public class NextAndPrevSelection {
  private int currentCol;
  private Reference<StrapProtein> currentProt;
  private long whenLast;
  public void goNextMatch(String direction, ResidueSelection[] selections) {
    final StrapAlign align=StrapAlign.getInstance();
    final boolean bb[]=toAlignmentPositions(selections);
    final StrapProtein pp[]=getProteinsAtCol(currentCol,selections);

    StrapProtein p=deref(this.currentProt,StrapProtein.class);
    final int iP=idxOf(p,pp);
    int column=this.currentCol;

    if (whenLast<align.whenChangedCursor()) {
      column=align.getColumnAtCursor();
      p=align.getProteinAtCursor();
    }
    final int col0=column;
    whenLast=System.currentTimeMillis();
    if ("<"==direction) {
        while(column>=0 && !(column<bb.length && bb[column])) column--;
        p=column!=col0 && 0<=idxOf(p,getProteinsAtCol(column,selections)) ? p :  get(column,bb) ? get(iP-1,pp,StrapProtein.class) : null;
        if (p==null) {
            while(column>=0 && !(get(--column,bb)));
            p=getLast(getProteinsAtCol(column,selections),StrapProtein.class);
        }
    }
    if (">"==direction) {
        while(column<bb.length && !( column>=0 && bb[column])) column++;

        p= column!=col0 && 0<=idxOf(p,getProteinsAtCol(column,selections)) ? p : get(column,bb) ?  get(iP+1,pp, StrapProtein.class) : null;
        if (p==null) {
            while(column<bb.length && !get(++column,bb));
            p=get(0,getProteinsAtCol(column,selections),StrapProtein.class);
        }
    }
    final boolean success=p!=null && p.column2index(column)>=0;
    if ("|<"==direction || "<"==direction && !success) {
      p=get(0,getProteinsAtCol(column=firstTrue(bb),selections),StrapProtein.class);
    }

    if (">|"==direction || ">"==direction && !success) {
      p=getLast(getProteinsAtCol(column=lastTrue(bb),selections),StrapProtein.class);
    }
    final int iA=p!=null ? p.column2index(column) : -1;
    if (iA>=0) {
      this.currentProt=weakRef(p);
      this.currentCol=column;

      StrapAlign.startAnimatePosition(StrapAlign.ANIM_SET_CURS_SCROLL_TO_VISIBLE, p, iA);
      final StrapView view=align.getAlignmentPanelWithFocus();
      if (view!=null) {
        final ResidueSelection s=get(0, p.getResidueSelectionsAt(0L,iA,iA+1,VisibleIn123.ANYWHERE), ResidueSelection.class);
        final int fromA, toA;
        if (s instanceof HighlightPattern.Selector) {
          fromA=iA;
          toA=fromA+get(iA,((HighlightPattern.Selector)s).getMatchLenghts());
        } else {
          fromA=s!=null ? s.getSelectedAminoacidsOffset()+firstTrue(s.getSelectedAminoacids()) : -1;
          toA=s!=null ? fromA+lastTrue(s.getSelectedAminoacids())+1 : -1;
        }
        final int row=view.findRow(p);
        if (fromA>=0 && toA>fromA && row>=0) {
          final int x=view.col2x(p.getResidueColumn(fromA));
          final int y=view.row2y(row);
          final Rectangle r=new Rectangle(x, y, view.charB().width*(toA-fromA), view.charB().height);
          view.scrRectToVis(new Rectangle(r.x-8, r.y-8, r.width+16, r.height+16),false);
          setMarchingAnt(ANTS_SEARCH,   view.getAlignmentPane(), r, C(0xFFffFF),C(0xFF0000));
        } else addMarchingAnt(ANTS_SEARCH, view.getAlignmentPane(), (Rectangle)null,(Color)null, (Color)null );
      }
    }
  }

  public static StrapProtein[] getProteinsAtCol(int col, ResidueSelection ss[]) {
    final List v=new ArrayList(sze(ss));
    for(int iS=sze(ss); --iS>=0;) {
      final ResidueSelection s=ss[iS];
      final StrapProtein p=s!=null ? (StrapProtein)s.getProtein() : null;
      final int iA=p==null ? -1 : p.column2index(col);
      if (get(iA-s.getSelectedAminoacidsOffset(), s.getSelectedAminoacids() )) {
        adUniq(p,v);
      }
    }
    final StrapProtein pp[]=toArry(v,StrapProtein.class);
    StrapProteinUtils.sortVisibleOrder(pp);
    return pp;
  }

  private static boolean[] buff=new boolean[999];
  public static boolean[] toAlignmentPositions(ResidueSelection[] ss) {
    boolean bb[]=buff;
    Arrays.fill(buff,false);
    for(int iS=sze(ss); --iS>=0;) {
      final ResidueSelection s=ss[iS];
      final StrapProtein p=s!=null ? (StrapProtein)s.getProtein() : null;
      if (p==null) continue;
      final boolean[] selRes=s.getSelectedAminoacids();
      final int offset=s.getSelectedAminoacidsOffset();
      for(int i=lastTrue(selRes)+1; --i>=0;) {
        if (selRes[i]) {
          final int col=p.getResidueColumn(i+offset);
          if (col>=0 && !(get(col-1,bb) && get(col+1,bb))) (sze(bb)<=col ?  bb=chSze(bb,col+333) : bb)[col]=true;
        }
      }
    }
    return buff=bb;
  }

}