package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static java.awt.Color.*;
import static java.lang.System.*;

/**
   A choice menu containing for selecting a protein.
   @author Christoph Gille
*/
public class ProteinCombo extends ChCombo implements HasProtein {
    @Override public Dimension getPreferredSize() { return dim(super.getPreferredSize().width,ICON_HEIGHT);}

    @Override public boolean isEnabled(Object o) {
        return !(o instanceof StrapProtein) ? false :  filter!=0  ? ProteinList.isEnabled((StrapProtein)o,this.filter) : super.isEnabled(o);
    }
    private final long filter;
    public ProteinCombo(StrapAlign align, long filter) {
        super(new ProteinComboModel(align,filter),ChJTable.ICON_ROW_HEIGHT);
        this.filter=filter;
        setForeground(null);
        setBackground(WHITE);
        setRenderer(new ChRenderer().setEnabled(this));
        setLightWeightPopupEnabled(false);
        rtt(this);
        UIupdateList.add(this,UIupdateList.PROTEIN_LABEL);
        UIupdateList.add(this,UIupdateList.SELECTED_OBJECTS);
        UIupdateList.add(this,UIupdateList.PROTEIN_AT_CURSOR);
        monospc(this);
        pcp(KEY_IF_EMPTY,ANSI_FG_BLUE+" No protein present",this);
        selNextEnabled();
    }
    @Override public void actionPerformed(java.awt.event.ActionEvent ev) {
        changed();
        setForeground(getStrapProtein()!=null&&isEnabled(getStrapProtein())? BLACK:GRAY);
        super.actionPerformed(ev);
    }
    public void changed() {}
    public Protein getProtein() { return getStrapProtein();}

    public StrapProtein getStrapProtein() {
        Object o=getSelectedItem();
        if (o instanceof StrapProtein) return (StrapProtein) o;
        return null;
    }
}
