package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.lang.ref.*;
import javax.swing.*;
import javax.swing.event.ListDataListener;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static java.lang.System.*;
/**
A choice menu containing for selecting a protein.
   @author Christoph Gille
*/
public class ProteinComboModel implements ComboBoxModel, HasModiCount  {
    private final StrapAlign align;
    public void addListDataListener(ListDataListener l){/*vListDataListener.add(l);*/}
    public void removeListDataListener(ListDataListener l){/*vListDataListener.remove(l);*/}
    public Object getElementAt(int i) {
        final StrapView v=align.getAlignmentPanelWithFocus();
        StrapProtein pp1[]=v!=null ? v.getProteins() : align.getProteinsInAlignment();
        StrapProtein pp2[]=align.getProteinsNotInAlignment();
        if (i<0 || i>=pp1.length+pp2.length) return null;
        return i<pp1.length ? pp1[i] : pp2[i-pp1.length];
    }
    public int getModificationCount() {
        final StrapView v=align.getAlignmentPanelWithFocus();
        return StrapProtein.MODI_COUNTS_ALL[charite.christo.protein.ProteinModiCount.MCA_PROTEINS_V]+(v!=null ? v.getModificationCount()  : 0);
    }
    public int getSize() {
        final StrapView panel=align.getAlignmentPanelWithFocus();
        StrapProtein pp1[]=panel!=null ? panel.getProteins() : align.getProteinsInAlignment();
        StrapProtein pp2[]=align.getProteinsNotInAlignment();
        return pp1.length+ pp2.length;
    }
    private Object selectedItem;
    public void setSelectedItem(Object o) { selectedItem=o;}
    public Object getSelectedItem() {
        Object i=this.selectedItem;
        if (i instanceof StrapProtein && indexOf((StrapProtein)i)>=0)  return i;
        final long f=this.filter;
        final StrapView panel=align.getAlignmentPanelWithFocus();
        final StrapProtein pp1[]=panel!=null ? panel.getProteins() : align.getProteinsInAlignment();
        final StrapProtein pp2[]=align.getProteinsNotInAlignment();
        for(int i10=2; --i10>=0;) {
            StrapProtein[] pp= i10==1? pp1:pp2;
            for(StrapProtein p:pp) if (ProteinList.isEnabled(p,f)) return this.selectedItem=p;
        }
        return null;
    }
    private long filter;
    public ProteinComboModel(StrapAlign a,long filter) { align=a; this.filter=filter;}
    public int indexOf(StrapProtein p) {
        final StrapView panel=align.getAlignmentPanelWithFocus();
        StrapProtein pp1[]=panel!=null ? panel.getProteins() : align.getProteinsInAlignment();
        StrapProtein pp2[]=align.getProteinsNotInAlignment();
        int idx=idxOf(p,pp1);
        if (idx>=0) return idx;
        idx=idxOf(p,pp2);
        if (idx>=0) return pp1.length+idx;
        return -1;
    }
}
