package charite.christo.strap;
import charite.christo.strap.interfaces.*;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import java.io.File;
import java.util.*;
import java.util.List;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static charite.christo.strap.ProteinList.*;
import static charite.christo.Insecure.EXEC_ALLOWED;
/**
   The protein menu.
   @author Christoph Gille
*/
public class ProteinPopup implements java.awt.event.ActionListener, IsEnabled , ChRunnable {
    public final static String
        ACTION_select_all_p="Select all Proteins",
        ACTION_showInList="Show in list",
        ACTION_backbone="Protein backbone",
        ACTION_EDIT="Edit protein file",
        ACTION_close3d="Close protein in all external 3D-viewers such as Pymol";
    private final static String
        CMD_CLIPB="PP$$CB", CMD_EXPORT_DnD="$PP$$ED",
        TT_CLIPB="The sequence can then be pasted (Ctrl-V) into other applications";
    private static int shownMovie3d;
    private final ContextObjects objects;
    private static int countJList;
    private JPopupMenu popup;
    private final JLabel LAB_TITLE=new JLabel();
    private final static ChTextArea TA[]=new ChTextArea['Z'+1];

    public ProteinPopup(ContextObjects o) { objects=o;}
    private final ChButton
        bHIDE=b("Do not display protein in alignment",IN_ALI).i(IC_HIDE),
        bUNHIDE=b("Display protein in alignment",NOT_IN_ALI).i(IC_SHOW);
    public static JComponent butRemove3D() { return butRemove3D(null, null);}
    public static JComponent butRemove3D(ChJTable t, ProteinPopup menu0) {
        final ProteinPopup menu= menu0!=null ? menu0 : StrapAlign.getContextObjects().proteinMenu();
        final ChButton but=new ChButton(t!=null ? "RM_3D_GO" : "RM_3D").t("Detach associated 3D-Structure").i(IC_KILL).li(menu);
        pcp("T",weakRef(t),but);
        return but;
    }
    /** These methods are for Tutorials */
    private static ProteinPopup m() { return StrapAlign.getInstance().SELECTED_OBJECTS.proteinMenu();}
    public static JComponent docuSelectedSeparateChains() { return  m().b(IC_SEPARATECHAINS,CHAINS).tabItemTipIcon(PDB_separateChains.class);}
    public static JComponent docuSelectedEditProtein() { return m().b(ACTION_EDIT,0); }
    public boolean isEnabled(Object buttton) {
        for(StrapProtein p : this.objects.proteins()) {
            if (ProteinList.isEnabled(p, atol(gcp("F",buttton)))) return true;
        }
        return false;
    }
    private ChButton b(String s,long flags) {
        ChButton b=new ChButton(s);
        rtt(b);
        b.li(ProteinPopup.this);
        if (flags!=0) pcp("F",longObjct(flags),b);
        if (objects==StrapAlign.getInstance().CURSOR_OBJECTS) pcp(IC_CURSOR16,"",b);
        pcp(KEY_ENABLED,this,b);
        if (s==CMD_CLIPB) b.t("Copy sequence").tt(TT_CLIPB);
        if (s==CMD_EXPORT_DnD) b.t("Export protein files by Drag-and-Drop ...").i(IC_CURSOR_DRAG);
        return b;
    }
    // ----------------------------------------
    public Object run(String id, Object arg) {
        if (id==StrapAlign.RUN_OPEN_DIALOG_HOOK) {
            final StrapProtein pp[]=objects.proteins();
            if (sze(pp)>0) {
                final Object oo[]=oo(gcp(StrapAlign.KEY_CHOICE_PROTEIN,arg));
                for(int i=sze(oo); --i>=0;) {
                    final ProteinList  pl=deref(oo[i], ProteinList.class);
                    final ProteinCombo pc=deref(oo[i], ProteinCombo.class);
                    if (pl!=null) ChDelay.setSelII(pl,selIndices(pp, pl.getModel()),666);
                    if (pc!=null) pc.s(pp[0]);
                }
            }
        }
        return null;
    }
    public JPopupMenu menu() {
        final StrapAlign align=StrapAlign.getInstance();
        final int n=objects.proteins().length;
        LAB_TITLE.setText("Menu For "+n+" Protein"+(n==1 ? "" : "s"));
        if (popup==null) {
            Object oo[]=newMenuObjects(align);
            oo[1]=pnl(newCNSEW(pnl(LAB_TITLE),null,b(ACTION_showInList,0L).options(ChButton.NO_MARGIN),null,null));
            align.replaceClassByButton(oo, (ChRunnable)this);
            popup=jPopupMenu("Context-menu for proteins", oo);
        }
        return popup;
    }
    private Object msgExportByDnD;
    Object[] pMenu(char id, boolean longTitle) {
        if (id=='e') {
            return new Object[] {
                null,
                longTitle?"Export proteins":"Export",
                null,
                CLASS_DialogExportProteins,
                b(CMD_EXPORT_DnD,0),
                "-",
                TT_CLIPB,
                "&Cc", b(CMD_CLIPB,0)
            };
        }
        if (id=='E') {
            return new Object[] {
                null,
                "Export Alignment",
                CLASS_DialogExportAlignment,
                "&Pc", CLASS_Texshade,
                CLASS_DialogPublishAlignment,
                "Hint: You may open a rubber band in the alignment panel with the mouse",
            };
        }
        if (id=='I') {
            final boolean isV=StrapAlign.isViewer();
            final Object msg=vB(
                                "You may import proteins by",
                                "WIKI:Drag_and_drop",
                                "Simply drag a protein label to the Desktop.",
                                WATCH_MOVIE+MOVIE_Load_Proteins
                                );
            return new Object[] {
                longTitle?"Add proteins":"Import",
                null,
                "&Nc",CLASS_DialogNewProtein,
                "-",
                ChButton.actionViewMessage("Load protein files by Drag-and-Drop ...",msg).i(IC_CURSOR_DRAG),
                new ChButton("OPEN").t("Open file").li(this).i(IC_DIRECTORY),
                isV?null:"&Oc", isV?null : CLASS_MainDialogProjectFiles,
                "-",
                "&Bcs",CLASS_DialogFetchPdb,
                CLASS_DialogFetchSRS
            };
        }
        assertNotNull(null);
        return null;
    }
    Object[] newMenuObjects(StrapAlign align) {
        final Object
            bPF=b("VIEW",0).t("View protein file ").i(IC_SHOW),
            bINFO=b("INFO",0).t("Cross-references ..."),
            bBT=b("BT",0).t("Backtranslate amino acids to DNA ...").i(IC_DNA1),
            bTO3D=b("TO3D",IN_3D).t("Send 3D-commands in residue annotations to 3D-view[s]"),
            bListNuc=b("LIST_N", NUC3D).t("List nucleotide chain structures").i(IC_DNA1),
            bListHet=b("LIST_H", HETERO3D).t("List hetero structures (i.e. ligands)").i(IC_FLAVIN),
            bIcon=helpBut(ChIcon.class).t("Protein icons ...").i(""),
            b1stIdx=b("1ST_IDX",0).t("Set index of first residue ");
        final ChButton
            bCoding=b("VIEW_TRANSLATED",NT).t("Coding sequence containing all translated nucleotides"),
            bAlsoIntrons=b("VIEW_TRANSFORMED",NT).t("Nucleotides including introns and UTRs").tt("all nts in current direction"),
            bNeighb=b(CLASS_DialogNeighbors, PDB_ID).tabItemTipIcon(CLASS_DialogNeighbors),
            bViewAA=b("VIEW_AA",0).t("Amino acids");
        final Object[]
            menuSearch={
            "i",IC_SEARCH,
            "Search",
            bNeighb,
            CLASS_DialogBlast
        };
            final Object[] menuRotate3D={
                "i",IC_JMOL,
                "View  3D-Structure",
                b(ACTION_backbone,CALPHA).i((IC_WIRE3D)).tt("Opens a new 3-D-wireframe of the protein[s] when <br>it has c-alpha coordinates"),
                "&3c",CLASS_Dialog3DViewer,
                bTO3D,
                b("CLOSE_3D",IN_3D).t(ACTION_close3d).i(IC_CLOSE)
            };
            final Object[] menuListResSel=new Object[]{
                "i",IC_ANNO,
                "Residue selections",null,
                b("NEW_RA",0).t("New Residue annotation"),
                b("FEATURES",0).t("Download sequence features ..."),
                "-",
                b("LIST_A",RES_ANNO).t("List residue annotaions").i(IC_ANNO),
                b("LIST_F",SEQ_FEATURE).t("List sequence features"),
                b("LIST_S",RES_SEL).t("List residue selections"),
                bTO3D,
                "-",
                CLASS_DialogSelectionOfResiduesMain
            };
            final Object[] menuChains={
                "i",IC_PROTEASOME,
                "Peptide chains",
                "&Ccs",b(IC_SEPARATECHAINS,CHAINS).tabItemTipIcon(PDB_separateChains.class),
                b("1",CHAINS).t("Only one certain chain ...")
            };
            final String msgHet=
                "<h2>You need to use Drag-and-Drop to add hetero structures to protein</h2>"+
                "PDB-files containing only nucleotide chains or hetero compounds can be "+
                "dragged onto a protein label to associate the compound to the protein<br><br>"+
                "Also hetero compound items in list elements can be dragged to another protein.<br>"+
                "You may need to superimpose the source and target proteins to make coordinate systems compatible.";
            final Object[] menuChilds={
                "Child objects",
                "The  viewed object lists support Drag'n drop and context menu.",
                bListNuc,
                bListHet,
                ChButton.actionViewMessage("Add hetero structure ... ",vBpnl(msgHet,pnl("See Tutorial ",Tutorials.b("copy_DNA")))),
                "-",
                b("SEC_STRU",CALPHA).t("Secondary structure elements as text"),
                "_",
                menuChains,
                menuListResSel
            };
            final Object[] menuSuper={
              "Structure superposition",
              "&Uc",CLASS_DialogSuperimpose3D,
              b("RESET3D",CALPHA).t("Restore original coordinates")
              .i(IC_ORIGINALCOORDINATES).tt("The original coordinates are valid <br>The transformation is reset."),
              bNeighb,
            };
            final Object[] menuAlign={
              "Protein Alignment",
              CLASS_DialogAlign,
              CLASS_DialogAlignOneToAll,
              menuSuper,
              align.BUT_STOP_ALL
            };
            return new Object[]
            {
                null,null,null,null,
                new Object[] {
                    "File",
                    pMenu('I',false),
                    pMenu('e',false),
                    pMenu('E',false),
                    "-",
                    new Object[] {
                        "View","i",IC_SHOW,
                        b("LISTF",0).t("List files ..."),
                        b("CLIPBRD",0).t("Copy file path"),
                        "&Vc",bPF
                    },
                    new Object[]{
                        "Modify", "i", IC_EDIT,
                        EXEC_ALLOWED ? "&Ec" : null,   EXEC_ALLOWED ? b(ACTION_EDIT,0).i(IC_EDIT) : null,
                        "&Rc", b("RENAME",0).t("Rename or Copy ..."),
                        bIcon,
                        EXEC_ALLOWED ? b(IC_BALLOONTIP,0).t("Write balloon message ...").i(IC_BALLOONTIP).tt("The message appears when the mouse pointer is over a protein label") : null,
                        b1stIdx
                    },
                    "-",
                      EXEC_ALLOWED ? new Object[] {
                        "Execute program for selected proteins", "i", IC_BATCH,
                        bExec('f'), bExec('s'), bExec('g'),
                    } :null
                },
                new Object[] {
                    "View",
                    "i",IC_SHOW,
                    new Object[]{
                        "Sequence",
                        bViewAA,
                        UserProfile.set('n',bCoding),
                        UserProfile.set('n',bAlsoIntrons),
                        bBT
                    },
                    new Object[]{
                        "Properties",
                        b("NAME",0).t("Protein Names").tt("Generates a list of protein names."),
                        b("ACC_IDS",0).t("Accession IDs").tt("Generates a list of Accession IDs."),
                        b("header",0).t("Compound header").tt("Generates a list of protein compounds."),
                        bINFO
                    },
                    menuRotate3D,
                    new Object[]{ "Alignment panel",
                                  StrapAlign.menuItem('n'),
                                  StrapAlign.menuItem('N'),
                                  "-",
                                  "Visibility in the alignment",
                                  bHIDE,
                                  bUNHIDE,
                                  "h",CLASS_DialogManyInOneRow

                    }
                },
                new Object[]{
                    "i",IC_CURSOR_ARROW,
                    "Select",
                    new ChButton("SP").li(this).t(ACTION_select_all_p),
                    align.BUT_SELECT_BY_NAME,
                    new ChButton("INVERT_SEL").li(this).t("Invert selection"),
                    new Object[] {
                        "3D", "i", IC_JMOL,
                        new ChButton("SP3D").li(this).t("Select all Proteins with 3D-coordinates").i(IC_STRUCTURE),
                        new ChButton("SPhet").li(this).t("Select all Proteins with hetero compounds").i(IC_FLAVIN),
                        new ChButton("SPnuc").li(this).t("Select all Proteins with DNA/RNA-structure").i(IC_DNA1)
                    },
                    "-",
                    "To deselect hold shift-key",
                    b("SA",RES_ANNO).t("Select all Residue Annotations"),
                    b("SS",RES_SEL).t("Select all Residue Selections"),
                    b("SF",SEQ_FEATURE).t("Select all Sequence Features")
                },
                "-",
                new Object[] {
                    "Sequence",
                    b(CMD_CLIPB,0),
                    bViewAA,
                    b("RANGE",0).i(IC_SCISSOR).t("Cut-ends, Remove N- or C-terminus ..."),
                    b1stIdx,
                    "-",
                    "Nucleotide sequence",
                    bCoding, bAlsoIntrons, bBT,
                    "-",
                    "Search",
                    CLASS_DialogBlast,
                    new Object[]{
                        "i",IC_COMPARE,
                        "Compare proteins",
                        CLASS_DialogCompareProteins,
                        CLASS_DialogPhylogeneticTree,
                        CLASS_DialogDotPlot,
                        menuAlign
                    }
                },
                new Object[] {
                    "i",IC_JMOL,
                    "3D", null,
                    menuRotate3D,
                    menuSuper,
                    menuChilds,
                    new Object[]{
                        "Measure", "i",IC_MEASURE,
                        CLASS_DialogSelectionOfResiduesMain
                    },
                    new Object[]{
                        "Associate 3D with sequence",
                        "h",SimilarPdb.class,
                        butRemove3D(null,this),
                        "Note: This Applies to sequence files without 3D-information",
                        "but not to PDB-files which already have 3D-information."
                    }
                },
                new Object[]{
                    "i",IC_DNA1,"@n Nucleotide sequence",null,
                    "&Ncs", b("RF",NT_or_ACTGN).tabItemTipIcon(EditDnaParentPane.class),
                    "&Gcs", b("GB",0).i(IC_DNA).tabItemTipIcon(CLASS_DialogGenbank),
                    b("EXON",NT).tabItemTipIcon(CLASS_DnaExonStart),
                    b("NO_DNA",NT).t("Dispose nucleotide reading frame").i(IC_KILL),
                    "-",
                    bBT,
                    CLASS_DialogInferCDS,
                    new Object[]{
                        "View",
                        "i", IC_SHOW,
                        bCoding,
                        bAlsoIntrons
                    }
                },
                "-",

                new Object[] {
                    "Calculate",
                    "From sequence",
                    b("COMPO",0).t("Amino acid composition"),
                    bBT,
                    "-",
                    new Object[]{
                        "Predict",
                        CLASS_DialogPredictSecondaryStructures,
                        CLASS_DialogPredictTmHelices2,
                        CLASS_DialogPredictCoiledCoil,
                        CLASS_DialogSubcellularLocalization
                    },
                    menuSearch,
                    new Object[] {
                        "Plot", "i",IC_PLOT,
                        CLASS_DialogPlot,
                        CLASS_DialogBarChart
                    },
                    CLASS_DialogSelectionOfResiduesMain,
                    menuAlign
                },
                menuSearch,
                "-",
                menuChilds,
                menuListResSel,
                "-",
                new Object[]{
                    "Delete","i",IC_KILL,
                    b(IC_KILL,0).t("Move protein to ./trash/").i(IC_KILL).tt("The protein is disposed in the current session and its file is moved to './trash/' "),
                    new ChButton().actionFileBrowser(file(dirWorking()+"/trash/")).t("Open ./trash/ in "+systProprty(SYSP_NAME_FILE_BROWSER))
                },
                "&Kc",  b(IC_CLOSE,0).t("Close protein").i(IC_CLOSE).tt("the protein is disposed from STRAP without saving. <br>The file is not deleted"),
                null
            };
    }
    // ---
    private DialogExecuteOnFile execF, execG;
    protected ChButton bExec(char t) {
        ChButton b=
            t=='f' ?  b("EX_F",0).t("... on protein file names ...") :
            t=='s' ?  b("EX_S",0).t("... on amino acid sequences ...") :
            b("EX_G",0).t("... on gapped amino acid sequences ...");
        return b.i(IC_BATCH);
    }
    // ----------------------------------------
    private static ChFileChooser fileChooser;
    public void actionPerformed(java.awt.event.ActionEvent ev) {
        final StrapAlign align=StrapAlign.getInstance();
        if (align==null) return;
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        final UniqueList vSel=StrapAlign.getSelectedObjectsV();
        final int modiVsel=vSel.getModificationCount();
        final StrapProtein[] pp0=objects.proteins(), pp, ppVis=align.getVisibleProteins();
            if (q==fileChooser && cmd==JFileChooser.APPROVE_SELECTION) {
                final File ff[]=fileChooser.getSelectedFiles();
                final StringBuffer sb=new StringBuffer(333);
                for(int i=sze(ff); --i>=0;) {
                    final File f=ff[i];
                    File fDest=file(f.getName().replace(' ','_'));
                    if (!toStrg(f).equals(toStrg(fDest))) ChUtils.cpy(f,fDest);
                    sb.append(fDest).append(' ');
                }
                align.loadTheProteinsInList(sb, StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
            }
            if (cmd=="OPEN") {
                if (fileChooser==null) {
                    fileChooser=new ChFileChooser("Strap");
                    fileChooser.addActionListener(this);
                    fileChooser.setMultiSelectionEnabled(true);
                    fileChooser.setMinimumSize(dim(99,99));
                    final JComponent panel=newCNSEW(fileChooser,"Open protein or alignment file",pnl(WATCH_MOVIE+MOVIE_Load_Proteins),null,null);
                    pcp("pnl",panel,fileChooser);
                    TabItemTipIcon.set("Open","Open file","Open file",iicon(IC_DIRECTORY),panel);
                }
                align.addDialog(gcp("pnl",fileChooser,JComponent.class));
            }
        if (cmd=="SP") adAll(ppVis,vSel);
        if (cmd=="INVERT_SEL") {
            for(StrapProtein p : ppVis) {
                if (vSel.contains(p)) vSel.remove(p);
                else vSel.add(p);
            }
        }
        if (cmd=="SPnuc" || cmd=="SPhet" || cmd=="SP3D") {
            vSel.removeAll(pp0);
            pp= sze(pp0)<2 ? ppVis : pp0;
        } else pp=pp0;
        final int nP=pp.length;
        StrapEvent strEv=null;
        if (cmd==ACTION_showInList) {
            final String title="Proteins "+ ++countJList;
            StrapAlign.showInJList(0L, null, pp, title, null).showInFrame(ChFrame.AT_CLICK|ChFrame.SIZE_REGARD_RESOLUTION, title);
        }
        if (cmd=="CLIPBRD") {
            final StringBuffer sb=new StringBuffer(999);
            for(Protein p : pp)  sb.append(p.getFile()).append('\n');
            toClipbd(sb);
        }
        if (cmd=="RM_3D_GO") {
            final ChJTable t=(ChJTable)gcp("T",q);
            final int ii[]=ChJTable.selectedRowsConverted(t);
            if (ii.length==0) ChMsg.msgDialog("You must select some table rows");
            else {
                for(int i:ii) {
                    final StrapProtein p=(StrapProtein)t.getValueAt(i,SimilarPdb.COL_PROT);
                    if (p==null || p.isLoadedFromStructureFile()) continue;
                    p.setResidueCalphaOriginal(null);
                    p.setResidueSecStrType(null);
                    p.setResidueNumber(null);
                    p. setResidueChain(null);
                }
            }
            StrapAlign.dispatchLater(StrapEvent.ATOM_COORDINATES_CHANGED,1);
        }
        {
            final StrapProtein[] ppAll=align.getProteins();
            if (cmd=="SS" || cmd=="SA" || cmd=="SF") {
                for(StrapProtein p:pp) {
                    for(ResidueSelection s : p.getAllResidueSelections()) {
                        final char mID=ContextObjects.menuID(s);
                        if (mID=='A' && cmd=="SA" || mID=='S' && cmd=="SS" || mID=='F' && cmd=="SF") {
                            if (isShift(ev)) vSel.remove(s); else vSel.add(s);
                        }
                    }
                }
            }
        }
        if (nP==0) return;
        if (cmd=="FEATURES") SequenceFeatures.instance().showPanel();
        if (cmd=="NEW_RA" && pp.length>0) {
            if (pp.length==1 || ChMsg.yesNo("Create residue annotations for "+pp.length+" proteins?")) {
                for(StrapProtein p : pp) {
                    final ResidueAnnotation a=new ResidueAnnotation(p);
                    a.add(ResidueAnnotation.POS,"10-100",true);
                    a.add(ResidueAnnotation.GROUP,"created in context-menu of proteins",true);
                    p.addResidueSelection(a);
                    align.editAnnotation(a);
                }
            }
        }

        final Class cChild=
            cmd=="LIST_S" ? ResidueSelection.class :
            cmd=="LIST_A" ? ResidueAnnotation.class :
            cmd=="LIST_F" ? SequenceFeatures.class :
            cmd=="LIST_H" ? HeteroCompound.class :
            null;
        putln("cChild="+cChild, pp);
        if (cChild!=null) StrapProteinUtils.showChildObjects(cChild,pp);

        if (cmd==CLASS_DialogNeighbors) StrapProteinUtils.structureNeighbors(pp);
        if (cmd=="TO3D") {
            boolean success=false;
            for(StrapProtein p:pp) {
              success|=ProteinViewerUtils.residueSelectionsTo3D(ProteinViewerUtils.RSto3D_COMMANDS|ProteinViewerUtils.RSto3D_COLOR|ProteinViewerUtils.RSto3D_NO_WIRE,
                                                                p.getResidueAnnotations(), p.getProteinViewers(null));
            }
            if (!success) error("No 3D-commands to send to the 3D viewer");
        }
        if (cmd==ACTION_EDIT) {
            if (nP>3 && !ChMsg.yesNo("Really edit "+nP+" protein files?")) return;
            for(StrapProtein p:pp) edFile(-1,p.getFile(), modifiers(ev));
        }
        if (cmd=="COMPO") {
            final ByteArray sb=new ByteArray(1000);
            int nameLen=0;
            for(StrapProtein p:pp) nameLen=maxi(nameLen,p.toString().length());
            for(int isAbsolute=0; isAbsolute<2; isAbsolute++) {
                sb.append("Amino acid composition (").append(isAbsolute>0 ? "absolute values":"percent").append(")\n");
                for(StrapProtein p:pp) {
                    sb.append(' ',nameLen-p.toString().length()).append(p).append(' ',3);
                    final byte rt[]=p.getResidueType();
                    final int nR=p.countResidues();
                    if (nR==0) continue;
                    for(char c='A'; c<='Y'; c++) {
                        if (c=='B'||c=='J'||c=='O'||c=='U'||c=='X') continue;
                        int count=0;
                        for(int iA=nR; --iA>=0;) if ((rt[iA]&~32)==c) count++;
                        //final int num=isAbsolute>0 ? count: round(100f*count/nR);
                        if (isAbsolute>0) sb.append(count,5); else sb.append(100f*count/nR, 3,1);
                        sb.append(c);
                    }
                    sb.append('\n');
                }
                sb.append('\n');
            }
            if (TA['C']==null) TA['C']=new ChTextArea("Also see MOL_TOOLKIT:procomp \n\n");
            TA['C'].showInFrame("AA composition",ChFrame.AT_CLICK).appnd(sb);
        }
        if (cmd=="VIEW") {
            if (nP<4 || ChMsg.yesNo("Really view "+nP+" protein files?"))
                for(StrapProtein p:pp) {
                    final File f=p.getFile();
                    final AsciiView v=new AsciiView(f).showInFrame(toStrg(f),ChFrame.AT_CLICK);
                    pcp(KEY_CONTAINS_AA,"",v);
                    pcp(DialogFindInText.KEY_ID, "ProteinFile",v);
                    pcp(ACTION_DATABASE_CLICKED,"load",v);
                    addActLi(StrapAlign.li(),v);
                    //v.tools().underlineRefs(UNDERLINE_REFS_NEW_THREAD);
                }
        }
        if (cmd=="RF") {
            if (nP<5 || ChMsg.yesNo("Really open nucleotide panel for "+nP+" sequences?"))
                for(StrapProtein p : pp)
                    ((EditDnaParentPane)align.addDialog(EditDnaParentPane.class,false)).addEditor(p,true);
        }
        //if (cmd=="INFER_3D") SimilarPdb.showTablePDB(pp,true);
        if (cmd=="GB") {
            NeedsProteins diaGB=(NeedsProteins)align.addDialog(CLASS_DialogGenbank,false);
            diaGB.setProteins(pp);
            ((Runnable)diaGB).run();
        }
        if (cmd=="NO_DNA") {
            if (!ChMsg.yesNo("Really discard all reading frame and intron/exon information on this nucleotide sequences?")) return;
            for(StrapProtein p:pp) {
                if (p.getNucleotides()!=null) p.setUniprotID("");
                p.setTranslatedStrand(null);
            }
            strEv=new StrapEvent(this,StrapEvent.NUCL_TRANSLATION_CHANGED).setParameters(pp);
        }
        if (cmd=="SEC_STRU") {
            if (TA['S']==null) TA['S']=new ChTextArea(
                                                      "Showing  WIKI:Protein_structure#Secondary_structure recorded in PDB and DSSP files.\n"+
                                                      "Note: The prediction from amino acid sequences  is not shown here.\n\n"
                                                      );
            final ChTextArea sb=TA['S'];
            for(StrapProtein p:pp){
                sb.appnd(Color.CYAN,p);
                final byte ss[]=p.getResidueSecStrType();
                if (ss==null) {sb.appnd( "no structure information"); continue;}
                boolean bb[]=new boolean[ss.length];
                for(char c : new char[]{'H','E','C'}) {
                    for(int i=ss.length;--i>=0;) bb[i]= c==ss[i];
                    sb.appnd(
                              c=='H'?"\n  HELICES ":c=='E'?"\n EXTENDED ":"\n   OTHER ",
                              Protein.selectedPositionsToText(bb,0,p)
                              );
                }
                sb.appnd("\n\n");
            }
            sb.showInFrame("Secondary Structure",ChFrame.AT_CLICK);
        }
        if (q instanceof PDB_separateChains) {
            final File[] ff=((PDB_separateChains)q).getCreatedFiles();
            align.loadTheProteinsInList(joinAsStrg(ff,"\n"),StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
        }
        if (cmd==IC_SEPARATECHAINS) {
            List<File> v=new ArrayList();
            for(StrapProtein p:pp) adUniq(p.getFile(),v);
            final PDB_separateChains psc=new PDB_separateChains();
            addActLi(this,psc);
            psc.interactiveProcess(toArry(v, File.class));
        }
        if (cmd=="RESET3D") {
            for(StrapProtein p:pp) p.setRotationAndTranslation(null);
            strEv=new StrapEvent(ProteinPopup.class,StrapEvent.PROTEIN_3D_MOVED).setParameters(pp);
        }
        if (cmd=="RM_3D") {
            final List<Object[]> v=new ArrayList();
            for(int iP=0; iP<pp.length; iP++) {
                final StrapProtein p=pp[iP];
                final int[] match=p.getInferred3dCountMatches();
                if (match==null) continue;
                v.add(new Object[]{intObjct(iP+1), p," "+match[0]+" / "+match[1]});
            }
            final ChTableModel model=new ChTableModel("No", "Protein", "matching / all").setData(v);
            final ChJTable t=new ChJTable(model, ChJTable.DEFAULT_RENDERER|ChJTable.ICON_ROW_HEIGHT|ChJTable.TABLE_ROW_SORTER);
            final JComponent pNorth=newCNSEW("Removing 3D-coordinates",null,null,smallHelpBut(SimilarPdb.class),null);
            new ChFrame("Detach loaded 3D coordinates ...").ad(newCNSEW(scrllpn(0L,t),pNorth,pnl(butRemove3D(t,this)),null,null)).shw(ChFrame.CENTER);
        }
        if (cmd=="NAME")  {
            final ChTextArea sb=TA['N']==null ?  TA['N']=new ChTextArea("") : TA['N'];
            sb.appnd(pp.length+" proteins\n",joinAsStrg(pp,"\n"),"\n\n");
            sb.tools().enableWordCompletion(dirWorking());
            sb.showInFrame("Protein names",ChFrame.AT_CLICK);
        }
        if (cmd=="LISTF") {

            final UniqueList<File> v=new UniqueList(File.class);
            for(Protein p : pp) v.add(p.getFile());
            final ChJList jl=new ChJList(v, ChJTable.DEFAULT_RENDERER|ChJTable.DRAG_ENABLED|ChJTable.FILE_POPUP|ChJTable.FILE_NAME);
            final JComponent pnl=newCNSEW(scrllpn(SCRLLPN_INHERIT_PREF_SIZE,jl),null,"Note: The files have a context menu by right-click.",null,null);
            pcp(KEY_PANEL, pnl,jl);
            jl.showInFrame(ChFrame.AT_CLICK|ChFrame.TO_FRONT|ChFrame.SIZE_REGARD_RESOLUTION, "Files of Proteins");
        }
        if (cmd=="ACC_IDS")  {
            final ChTextArea sb=TA['N']==null ?  TA['N']=new ChTextArea("") : TA['N'];
            sb.appnd(pp.length+" Accession IDs and sequence refs\n\n");
            for(Protein p : pp) {
                sb.appnd(p.getAccessionID(),"  ",joinAsStrg(p.getSequenceRefs()," "),"\n\n");
            }
            sb.tools().enableWordCompletion(dirWorking());
            sb.showInFrame("Accession IDs",ChFrame.AT_CLICK);
        }
        if (cmd=="header") {
            final ChTextArea sb=TA['H']==null ?  TA['H']=new ChTextArea("") : TA['H'];
            for(StrapProtein p:pp) sb.appnd(">",Color.PINK,p,"\n",p.getCompound(),"\n\n\n");
            sb.tools().enableWordCompletion(dirWorking());
            sb.showInFrame("compound headers",ChFrame.AT_CLICK);
        }
        if (cmd==IC_KILL || cmd==IC_CLOSE) {
            final int row=align.getRowAtCursor(), col=align.getColumnAtCursor();
            if (cmd==IC_CLOSE || ChMsg.yesNo(vBpnl(joinAsStrg(nP<5 ? pp: null,"\n"), pnl("Kill the "+nP+" proteins and move their files to ","./trash/"," ?")))) {
                align.removeProteins(cmd==IC_KILL, pp);
                final StrapView v=align.getAlignmentPanelWithFocus();
                if (v!=null) v.setCursorToColumn(v.getProtein(row), col);
            }
        }
        if (cmd=="EX_F") {
            String files[]=new String[nP]; for(int i=0;i<nP;i++) files[i]= rplcToStrg(" ","%20",toStrg(pp[i].getFile()));
            if (execF==null) execF=new DialogExecuteOnFile(new Customize("execProtFile",getCustomSettings(Customize.textEditors),"shell programs for protein files",Customize.LIST));
            execF.show(files);
        }
        if (cmd=="EX_S") {
            final String ss[]=new String[nP];
            for(int i=0;i<nP;i++) {
                if (pp[i]!=null) ss[i]=pp[i]+"\t"+pp[i].getResidueTypeAsStringUC();
            }
            new DialogExecuteOnFile(Customize.customize(Customize.execAminoSeq)).show(ss);
        }
        if (cmd=="EX_G") {
            final String ss[]=new String[nP];
            for(int i=0;i<nP;i++)
                if (pp[i]!=null)
                    ss[i]=pp[i]+"\t"+pp[i].getGappedSequenceAsString();
            if (execG==null) execG=new DialogExecuteOnFile(new Customize("execGappedSeq",getCustomSettings(Customize.execAminoSeq),"shell programs for gapped sequences",Customize.LIST));
            execG.show(ss);
        }
        if (cmd=="BT") {
            ChCombo combo=new ChCombo(Backtranslate.ORGANISMS);
            final File dir=file(STRAPOUT+"/toDNA");
            mkdrsErr(dir);
            final Object msg=vBpnl(
                                   "The Backtranslated protein files will be written to",
                                   dir,
                                   "Codon usage of ",
                                   combo,
                                   " ",
                                   monospc("Also see MOL_TOOLKIT:rtranslate"),
                                   "Backtranslate the selected proteins?"
                                   );
            if (ChMsg.yesNo(msg)) {
                Backtranslate.Codonusage usage=Backtranslate.codonUsage(combo.toString());
                if (usage==null) { return;}
                for(StrapProtein p:pp) {
                    final byte nt[]=Backtranslate.backtranslate(p.getResidueType(),p.countResidues(),usage,false);
                    for(int i=nt.length; --i>=0;) if (i%3==0) nt[i]&=~32; else nt[i]|=32;
                    wrte(file(dir+"/"+p+".toDNA"),">"+p+"\r\n"+toStrg(nt)+"\r\n");
                }
                ChUtils.viewFile(dir, modifiers(ev));
            }
        }

        if (cmd=="1" || cmd=="RANGE" || cmd=="RENAME") {
            DialogRenameProteins.instance(ProteinPopup.class)
                .rename(cmd=="1"||cmd=="RANGE"?DialogRenameProteins.INFO_CUT_TERMINI:DialogRenameProteins.GENERATE,pp,null);
        }
        if (cmd==CMD_EXPORT_DnD) {
            if (msgExportByDnD==null) {
                final ChButton b=StrapAlign.drag_buttonOptions();
                msgExportByDnD=vB(
                                  "You may export proteins by",
                                  "WIKI:Drag_and_drop",
                                  WATCH_MOVIE+MOVIE_Export_Proteins,
                                  pnl("You can change the export options: ",b.cln().like(b))
                                  );
            }
            ChFrame.frame(cmd,msgExportByDnD,0).shw(ChFrame.AT_CLICK);
        }
        if (cmd==CMD_CLIPB) {
            StringBuffer sb=new StringBuffer();
            for(StrapProtein p:pp) {
                byte aa[]=p.getResidueType();
                if (aa==null) continue;
                sb.append(">").append(p).append('\n');
                appnd(aa,0,aa.length,sb).append('\n');
            }
            toClipbd(sb);
        }
        if (cmd==ACTION_backbone) {
            if (shownMovie3d++==0) ChMsg.msgDialog(vBpnl("Use Drag-and-Drop to add further proteins to the same view.",WATCH_MOVIE+MOVIE_Drag_protein_to_3D));
            align.newBackbone3D_View(pp,0L);
        }
        if (cmd=="VIEW_TRANSFORMED") {
            for(StrapProtein p:pp) {
                final byte[] nn=p.getNucleotidesCurrentStrand();
                if (nn!=null) ChFrame.textFrame(nn,50).t(p+": transformed nucleotides");
            }
        }
        if (cmd=="VIEW_AA") {
            if (TA['A']==null) pcp(KEY_CONTAINS_AA, "", TA['A']=new ChTextArea(""));
            for(StrapProtein p:pp)   {
                TA['A'].appnd(">", p,"\n",p.getResidueTypeAsStringUC(),"\n\n");
            }
            TA['A'].showInFrame("AA-sequence ",ChFrame.AT_CLICK);
        }
        if (q==bHIDE) {
            if (align.setIsInAlignment(false,pp)) align.dispatchLater(StrapEvent.PROTEINS_HIDDEN, 99);
            ChMsg.savedMsg(
                           "For re-introduction hidden proteins into the alignment there are two possibilities:<ul>"+
                           "<li>Visiting a dialog with a protein list such as the alignment or blast dialogs. Dragging the hidden protein into the alignment.</li>"+
                           "<li>Opening the object tree view which is usually not visible because the vertical divider is at the left margin of the application frame. "+
                           "Dragging the protein from the tree-view (node \"Hidden proteins\") .</li>"+
                           "</ul>",
                           "hiddenProteins");
        }
        if (q==bUNHIDE) if (align.setIsInAlignment(true,pp)) align.dispatchLater(StrapEvent.PROTEINS_SHOWN, 99);
        if (cmd=="INFO" && sze(pp)>0)  {
            final AWTEvent mev=getLastEvt(java.awt.event.MouseEvent.MOUSE_MOVED);
            StrapView.rh_info_Show(pp[0], xScreen(mev),yScreen(mev));
        }
        if (cmd=="1ST_IDX") {
            final ByteArray sb=new ByteArray(999);
            final int maxL=longestName(pp);
            for(Protein p : pp) {
                sb.append(' ',maxL-p.toString().length()+1).append(p).append(p.getFirstResidueIndexOffset()+1,5).append('\n');
            }
            final ChTextArea ta=new ChTextArea(sb);
            final String msg="The table shows the index of the first residue for each protein. <br>You can change the values.";
            if (ChMsg.yesNo(newCNSEW(scrllpn(0L,ta,dim(80*EM,30*EX)),msg,"Change index of first residue.",null,null))) {
                StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,99);
                for(String s : splitLnes(SPLIT_TRIM, ta.tools().byteArray())) {
                    final int spc=nxt(SPC,s);
                    final StrapProtein p=spc<0?null:StrapProtein.getProteinWithName(s.substring(0,spc),pp);
                    if (p!=null) p.setFirstResidueIndexOffset(atoi(s,spc+1)-1);
                }
            }
        }

        for(StrapProtein p:pp) {
            if (p==null) continue;
            if (cmd=="SPnuc" && ProteinList.isEnabled(p,NUC3D) || cmd=="SPhet" && ProteinList.isEnabled(p,HETERO3D) || cmd=="SP3D" && ProteinList.isEnabled(p,CALPHA))
                if (isShift(ev)) vSel.remove(p); else vSel.add(p);
            if (cmd=="CLOSE_3D") {
                for(ProteinViewer pv : p.getProteinViewers((Class)null)) {
                    ProteinViewerUtils.disposeProteinViewer(pv);
                }
            }
            if (cmd==IC_BALLOONTIP) {
                final File f=Protein.strapFile(null,p,Protein.mTIPS);
                if (!f.exists()) wrte(f,"");
                edFile(-1, f, modifiers(ev));
            }
            if (cmd=="VIEW_TRANSLATED")  {
                final byte[] bb=DNA_Util.onlyTranslated(p.getNucleotidesCurrentStrand(),p.areNucleotidesCurrentStrandTranslated());
                if (bb!=null) {
                    DNA_Util.firstCodonToUpperCase(bb);
                    ChFrame.textFrame(bb,50).t(p+": amino acids");
                }
            }
            if (cmd=="EXON") {
                if (ChMsg.yesNo(pnl("Create residue annotation at each ","WIKI:Exon"," start? ",smallHelpBut(DnaExonStart.class)))) DnaExonStart.mark(pp);
            }
            if (cmd=="LINK_EC")  visitURL("http://www.expasy.org/cgi-bin/nicezyme.pl?"+get(0,p.getEC()),modifiers(ev));
        }
        if (strEv!=null) strEv.run();
        if (modiVsel!=vSel.getModificationCount()) new StrapEvent(this,StrapEvent.OBJECTS_SELECTED).run();
    }
}
