package charite.christo.strap;
import charite.christo.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.io.File;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.*;
import java.util.List;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.Color.*;
import static charite.christo.interfaces.VisibleIn123.*;
/**
   @author Christoph Gille
 */
public class ResidueSelectionPopup implements ActionListener, IsEnabled {
    public final static String
        ACTION_addLine="Add annotations ...",
        ACTION_edit="View/edit annotation ...",
        ACTION_convertToResidueAnnotation="Create persistent annotation supporting 3D-rendering commands etc. ...";
    private ContextObjects objects;
    private char mID;
    public ResidueSelectionPopup(ContextObjects hs, char id) { objects=hs; this.mID=id; }
    private JPopupMenu pop;
    private final JLabel LAB_TITLE=new JLabel();
    protected final ButColor COLOR_BUTTON=new ButColor(0L,C(0xffFF00),this); { COLOR_BUTTON.t("Color ...");}
    private String title;
    public JPopupMenu menu() {
        final int n=objects.residueSelections(mID).length;
        this.title=mID=='A' ? "Annotation" : mID=='F' ? "Sequence feature" :  "Residue-selection";
        LAB_TITLE.setText("Menu for "+n+" "+title+(n==1 ? "" : "s"));
        final Object butColor=mID=='F' ?  SequenceFeatures.customizeColors().newButton().i(IC_COLOR).t(null) : COLOR_BUTTON;
        if (pop==null) {
            ActivateDeactivate actDeact=new ActivateDeactivate(objects);
            final String
                tt_bTo3D="In case the respective protein is loaded in Pymol or any other protein viewer<br>the residues are selected in the viewer.<br>"+
                "Any 3D-commands associated with the selection are interpreted by the 3D-viewer";
            final Object
                wikiDnD[]={"You can use","WIKI:Drag_and_drop"},
                bActivate=new ChButton().t("Activate / Deactivate annotations ... ").li(actDeact),
                    top=newCNSEW(pnl(LAB_TITLE),null, pnl(b("L",ProteinPopup.ACTION_showInList).options(ChButton.NO_MARGIN)),null,
                             smallHelpBut(mID=='S' ? ResidueSelection.class : ResidueAnnotation.class)),
                bToAnno=b(ACTION_convertToResidueAnnotation,ACTION_convertToResidueAnnotation).i(IC_ANNO),
                    bTo3D=b("TO3D","Send the amino acids selections to all 3D-views of the protein ...").tt(tt_bTo3D).i(IC_JMOL);
            pcp(actDeact,actDeact,bActivate);
            final String
                ttAct="In the table view the first toggle button indicates wheter the selection is activated or deactivated.",
                msgHidden="Note: Invisible selections can be accessed in the object tree.<br>"+
                "The object tree is beyond the vertical divider at the left.";
            final Object[] menuView={
                "View",
                new Object[]{
                    "Style",
                    "Note: Not all selections support changing the style",
                    mID=='A' || mID=='F' ? b("STYLE","Set display style like \"Underline\" or \"Full background\"") : null,
                },
                new Object[] {
                    "i",IC_SHOW,
                    "Show",
                    b("SHOW1","in alignment").i(IC_SHOW),
                    b("SHOWV","in scroll bar").i(IC_SHOW),
                    b("SHOW3","in 3D-Backbone").i(IC_SHOW),
                    ChButton.actionViewMessage("Access hidden selections",msgHidden)
                },
                  new Object[] {
                      "i",IC_HIDE,
                      "Hide",
                      b("HIDE1","in alignment").i(IC_HIDE),
                      b("HIDEV","in scroll bar").i(IC_HIDE),
                      b("HIDE3","in 3D-Backbone").i(IC_HIDE),
                      b("HIDEA","everywhere").i(IC_HIDE),
                  },
                " ",
                mID=='S' ? null : b("ACTIV","Activate").i(IC_SHOW).tt(ttAct),
                mID=='S' ? null : b("DEACT","Deactivate").i(IC_HIDE).tt(ttAct),
                "-"
            };
            final Object[] menuCursor={
                "i",IC_CURSOR16,
                "Alignment cursor",
                b("GO1","Set cursor to first selected residue").i(IC_CURSOR16),
                b("GO9","Set cursor to last selected residue").i(IC_CURSOR16),
                "-",
                b(IC_CURSOR,"Add/remove cursor position").i(IC_CURSOR16),
                b(IC_CURSOR,"Add/remove cursor position (not always supported)").i(IC_CURSOR16),
            };
            final Object[] menuFile={
                "i",IC_DIRECTORY,
                "File",
                new Object[]{
                    "New",
                    CLASS_DialogResidueAnnotationList,
                    StrapView.button(StrapView.BUT_FEATURE).mi("Import sequence features ..."),
                    CLASS_DialogSelectionOfResiduesMain,
                    b('D')
                },
                new Object[]{
                    "Export",
                    b("AS_STRING","Selected amino acids as text").tt("The  amino acids of a selection as a string."),
                    b(IC_PDB,"Wite PDB-files of selected c-Alpha positions").i(IC_PDB),
                    b('D'),
                },
                Insecure.EXEC_ALLOWED ? new Object[] {"Execute external program ",bExec()} : null
            };
            final Object[] menu3D={
                "i", IC_JMOL,
                "3D",
                bTo3D,
                b('3'),
                "-",
                CLASS_DialogSelectionOfResiduesMain
            };
            final Object oo[]=
                mID=='S' ? new Object[]{
                top,
                new Object[]{
                    "Annotate",
                    "i",IC_EDIT,
                    bToAnno,
                },
                menuView,
                menu3D,
                " ",
                menuCursor,
                "-",
                butColor,
                "-",
                b(IC_CLOSE,"Dispose selection").i(IC_CLOSE)
            } : new Object[]{
                "? context-menu for residue selections",null,
                top,
                "-",
                menuFile,
                new Object[]{
                    "Edit",
                    b(ACTION_edit,ACTION_edit).i(IC_ANNO),
                    b(ACTION_addLine,ACTION_addLine).i(IC_ANNO),
                    bActivate,
                    butColor,
                    "-",
                    "Advanced",
                    CLASS_DialogResidueAnnotationChanges
                },
                menuView,
                new Object[]{
                    "Select",
                    StrapAlign.getInstance().BUT_SELECT_BY_NAME
                },
                "-",
                new Object[] {
                    "Apply/Send ",
                    mID=='F' ? bToAnno : null,
                    menuCursor,
                    " ",
                    menu3D,
                    new Object[]{
                        "Copy",
                        b("COPY","Copy annotation to other protein[s]"),
                        b('D')
                    }
                },
                menu3D,
                "-",
                b(IC_KILL,"Delete ...").i(IC_KILL).tt("Kill the annotation[s].<br>After saving the project<br>it/they will be erased permanently<br>because all annotations of a protein are stored in a single file")
            };
            StrapAlign.getInstance().replaceClassByButton(oo,null);
            pop=jPopupMenu( title+"-contextmenu", oo);
        }
        return pop;
    }
    protected ChButton bExec(){
        return b("EXEC","... on residue selections ...").i(IC_BATCH)
            .tt("A program is executed.<br>The arguments arg[0], arg[1] ... are the protein sequences.<br>The selected positions are upper case.");
    }
    private ChButton b(String id,String label) { ChButton b=new ChButton(id).t(label).li(this); pcp(KEY_ENABLED,this,b); return b;}
    static  ChButton b(char id) {
        final String
            toCopy="to copy the residue selection to",
            usingDnD=" using Drag-and-Drop ...";
        final Object wikiDnD[]={"You can use","WIKI:Drag_and_drop"};
        if (id=='3' || id=='D') {
            final Object
                msgInfoDrag3D=vBpnl(pnl(wikiDnD),toCopy," a 3D-View",WATCH_MOVIE+MOVIE_Sequence_Features_in_3D),
                msgInfoDrag=vBpnl(pnl(wikiDnD),toCopy," another protein", WATCH_MOVIE+MOVIE_Sequence_Features_in_3D);
            if (id=='3') return ChButton.actionViewMessage("Copy to 3D-Viewer"+usingDnD,msgInfoDrag3D).i(IC_CURSOR_DRAG);
            if (id=='D') return ChButton.actionViewMessage("Copy"+usingDnD,msgInfoDrag3D).i(IC_CURSOR_DRAG);
        }
        return null;
    }
    public boolean isEnabled(Object o) { return  objects!=null && objects.residueSelections(mID).length>0;}
    private static int countJList;
    public void actionPerformed(ActionEvent ev) {
        final StrapAlign align=StrapAlign.getInstance();
        final String cmd=ev.getActionCommand();
        final Object q=ev.getSource();
        if (objects==null) {
            if (cmd=="OCMc" || cmd=="OCM") {
                if (cmd=="OCM") {
                    char type=' ';
                    for(int i=RADIOS.length; --i>=0;) if (isSelctd(RADIOS[i])) type=(char)i;
                    staticShowPopup(type);
                }
                final Window w=parentWndw(q);
                if (w!=null) w.setVisible(false);
            }
            return;
        }
        final ResidueSelection[] ss=objects.residueSelections(mID);
        final ResidueAnnotation aa[]=mID=='A'||mID=='F' ? (ResidueAnnotation[])ss : null;
        if (ss.length==0) return;
        if (cmd==ACTION_edit) {
            if (aa.length>3 && !ChMsg.yesNo("Really edit "+aa.length+" residue annotations?")) return;
            for(int i=aa.length;--i>=0;) align.editAnnotation(aa[i]);
        }
        if (cmd=="GO9" || cmd=="GO1") {
            final boolean bb[]=ss[0].getSelectedAminoacids();
            final Protein p=ss[0].getProtein();
            final int iA=ss[0].getSelectedAminoacidsOffset()+ (cmd=="GO1" ? firstTrue(bb) : lastTrue(bb));
            align.setCursorToResidue(p,iA);
            align.startAnimatePosition(StrapAlign.ANIM_SET_CURS_SCROLL_TO_VISIBLE, p, iA);
        }
        if (cmd=="COPY") {
            final StrapProtein pp[]=align.getSelectedProteins();
            if (!ChMsg.noProteinsSelected(pp)) ResidueSelectionUtils.copyResidueSelections(aa,pp, ResidueSelectionUtils.COPY_ADD_TO_PROTEIN|ResidueSelectionUtils.COPY_REPORT);
        }
        if (cmd=="STYLE" && sze(aa)>=0) {
            final ChCombo combo=AbstractVisibleIn123.newComboStyle();
            if (ChMsg.yesNo(vB(combo,"Change display style of residue annotations?"))) {
                for(ResidueAnnotation a:aa) a.setStyle(combo.i());
                StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
            }
        }
        if (cmd=="L")  {
            StrapAlign.showInJList(0L,null, ss,title,null).showInFrame(ChFrame.AT_CLICK, title+ " "+ ++countJList);
            if (pop!=null) pop.setVisible(false);
        }
        if (cmd=="TO3D") ProteinViewerUtils.residueSelectionsTo3D_I(ProteinViewerUtils.RSto3D_SAME_PROTEIN|ProteinViewerUtils.RSto3D_NO_WIRE,ss, (ProteinViewer[])null);
        if (cmd==IC_KILL) ResidueSelectionUtils.killResidueAnnotation(aa);
        boolean changed=false, changedColor=false;
        for (int iA=ss.length; --iA>=0;) {
            if (!(ss[iA] instanceof VisibleIn123)) continue;
            final VisibleIn123 s= (VisibleIn123)ss[iA];
            final int visible=s.getVisibleWhere();
            int visibleNew=visible | (cmd=="SHOW1" ? VisibleIn123.SEQUENCE:0) | (cmd=="SHOW3" ? VisibleIn123.STRUCTURE:0) | (cmd=="SHOWV "? VisibleIn123.SB:0);
            if (cmd=="HIDE1") visibleNew &= ~(VisibleIn123.SEQUENCE);
            if (cmd=="HIDEV") visibleNew &= ~(VisibleIn123.SB);
            if (cmd=="HIDE3") visibleNew &= ~(VisibleIn123.STRUCTURE);
            if (cmd=="HIDEA") visibleNew = 0;
            if (cmd=="ACTIV" || cmd=="DEACT") {
                changed=true;
                ((ResidueAnnotation)s).setEnabled(cmd=="ACTIV");
            }
            if (visibleNew!=visible) { changed=true; s.setVisibleWhere(visibleNew);}
        }
        if (cmd==ACTION_addLine) ChFrame.frame("add row",new AddAnnotation(aa),ChFrame.CENTER).shw(0);
        /* --- selections --- */
        if (cmd==IC_PDB) {
            final UniqueList<Protein> vP=new UniqueList(Protein.class);
            for(ResidueSelection s:ss) vP.add(s.getProtein());
            for(Protein p:vP.asArray()) {
                final boolean selected[]=new boolean[p.countResidues()];
                final ByteArray sb=new ByteArray(99999).append("REMARK protein=").append(p).append('\n');
                for(ResidueSelection s:ss) {
                    if (p!=s.getProtein()) continue;
                    if (p==null || !p.hasCalpha()) { sb.append(p).append(" no C-alpha - skipped"); continue;}
                    p.loadSideChainAtoms(null);
                    final boolean bb[]=s.getSelectedAminoacids();
                    final int offset=s.getSelectedAminoacidsOffset();
                    for(int i=mini(selected.length,bb.length+offset); --i>=0;)
                        if (i-offset>=0 && bb[i-offset]) selected[i]=true;
                }
                final long mode=ProteinWriter.PDB | ProteinWriter.ATOM_LINES | (p.getAtomCoordinates()!=null ? ProteinWriter.SIDE_CHAIN_ATOMS : 0) | ProteinWriter.SEQRES | ProteinWriter.HELIX_SHEET;
                final ProteinWriter1 pw=new ProteinWriter1();
                pw.selectResidues(selected);
                final File f=file(STRAPOUT+"/selectedAsPdb/"+p+".pdb");
                sb.append("REMARK ").append(f).append('\n');
                pw.toText(p, new Matrix3D[]{p.getRotationAndTranslation()}, mode,sb);
                wrte(f,sb);
                new AsciiView(f).showInFrame("Written cAlpha coordinats",0);
            }
        }
       if (cmd=="EXEC") {
            String para[]=new String[ss.length];
            for(int j=ss.length; --j>=0;) para[j]=selectedToUpperCase(ss[j]);
            new DialogExecuteOnFile(Customize.customize(Customize.execResidueSelection)).show(para);
        }
        if (cmd=="AS_STRING")  {
            StringBuffer sb=new StringBuffer();
            for(ResidueSelection s:ss) {
                sb.append("<pre class=\"data\">\n");
                final Protein p=s.getProtein();
                sb.append(p).append('\t').append(s instanceof HasName ? ((HasName)s).getName() : s).append('\t');
                ResidueSelectionUtils.selectedAsString(s,sb).append("\n</pre>\n");
                for(int i012=3; --i012>=0;) {
                    final int nn[]=p.getResidueNumber();
                    if (i012==2 && nn==null) continue;
                    sb.append(i012==2 ? "<b>PDB-numbers: </b>" : "<b>Indices start counting with "+i012+": </b> ");
                    final boolean bb[]=withoutOffset(s.getSelectedAminoacids(),s.getSelectedAminoacidsOffset());
                    if (bb==null) continue;
                    for(int i=0;i<bb.length;i++)
                        if (bb[i]) {
                            if (i012==2) {  if (i<nn.length && nn[i]!=MIN_INT) sb.append(nn[i]).append(':').append((char)p.getResidueChain(i)).append(", ");}
                            else sb.append(i+i012).append(',');
                        }
                    sb.append("<br>\n");
                }
                sb.append("<br>\n");
            }
            new ChTextViewer(sb).title("selected residues").shw(0);
        }
        if (cmd==ACTION_convertToResidueAnnotation) ResidueSelectionUtils.createResidueAnnotation(ss);
        for(ResidueSelection s:ss) {
            final StrapProtein p=(StrapProtein)s.getProtein();
            if (cmd==IC_CLOSE) { p.removeResidueSelection(s); changed=true; if (s instanceof Disposable) ((Disposable)s).dispose(); }
            if (cmd==IC_CURSOR)  {
                final int iAa=p.column2index(StrapAlign.getInstance().getColumnAtCursor());
                if (iAa<0) return;
                boolean bb[]=withoutOffset(s.getSelectedAminoacids(), s.getSelectedAminoacidsOffset());
                if (bb==null) return;
                if (bb.length<=iAa) bb=chSze(bb,iAa+1);
                bb[iAa]^=true;
                s.setSelectedAminoacids(bb,0);
                StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
            }
            if (q instanceof ButColor) {
                if (s instanceof Colored) {
                    ((Colored)s).setColor(COLOR_BUTTON.getColor());
                    changedColor=true;
                }
            }
        }
        if (changed) StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
        if (changedColor) StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED_COLOR,111);
    }
    /* <<< actionPerformed <<< */
    /* ---------------------------------------- */
    /* >>> static Protein Viewer methods >>> */
    protected static void optimizeExpression(ResidueAnnotation s) {
        final StrapProtein p=(StrapProtein) s.getProtein();
        if (p==null) return;
        final boolean
            isAmino=s.isAmino(),
            bb[]= isAmino ? s.getSelectedAminoacids() :  s.getSelectedNucleotides();
        final int offset=isAmino ? s.getSelectedAminoacidsOffset() : s.getSelectedNucleotidesOffset();
        final String selected=Protein.selectedPositionsToText(bb, offset, p);
        if (!ChMsg.yesNo("Do you want to replace the  list of residues by the following equivalent expression ?<br>"+selected)) return;
        s.setValue(ResidueAnnotation.POS,selected);
        StrapAlign.dispatchLater(StrapEvent.RESIDUE_SELECTION_CHANGED,111);
        //ResidueAnnotationView.updateTable(s.getView(),false);
    }
    private static String selectedToUpperCase(ResidueSelection sel) {
        final Protein p=sel.getProtein();
        if (p==null) return null;
        final byte[] aa0=p.getResidueType();
        if (aa0==null) return null;
        final byte[] aa=new byte[aa0.length];
        for(int i=aa.length; --i>=0;) aa[i]=(byte)(aa0[i]|32);
        final boolean bb[]=sel.getSelectedAminoacids();
        if (bb!=null) {
            final int selOffset=sel.getSelectedAminoacidsOffset();
            final int to=mini(bb.length, p.countResidues()-selOffset);
            for(int i=maxi(0,-selOffset); i<to; i++ )
                if (bb[i]) aa[i+selOffset]&=~32;
        }
        return new String(aa);
    }
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Ask for type of Context Menu >>> */
    private static JComponent pnlRadioSelection; // Container
    private final static JRadioButton RADIOS[]=new JRadioButton['S'+1];
    private static ActionListener actLi;
    private static ContextObjects staticObjects;
    private static AWTEvent staticEvent;
    private static UniqueList<ResidueSelection> staticSelV;
    static void showContextMenu(ResidueSelection ssMouse[],  AWTEvent ev) {
        if (staticSelV==null) {
            staticSelV=new UniqueList(ResidueSelection.class);
            staticObjects=new ContextObjects(staticSelV);
        }
        staticSelV.clear();
        adAll(ssMouse,staticSelV);
        staticEvent=ev;
        if (RADIOS['S']==null) {
            RADIOS['S']=new JRadioButton("Simple residue selections");
            RADIOS['A']=new JRadioButton("Annotated residue selections");
            RADIOS['F']=new JRadioButton("Sequence features");
            radioGrp('S',RADIOS);
            actLi=new ResidueSelectionPopup(null,' ');
        }
        boolean anno=false, sel=false, feature=false;
        final boolean radios[]=new boolean['S'+1];
        char lastType=(char)0;
        for(ResidueSelection s : ssMouse) {
            final char type=ContextObjects.menuID(s);
            if (type==0) continue;
            lastType=type;
            radios[type]=true;
        }
        switch(countTrue(radios)) {
        case 0: return;
        case 1:
            staticShowPopup(lastType);
            break;
        default:
            if (pnlRadioSelection==null) {
                pnlRadioSelection=pnl(
                                      new GridLayout(4,1),
                                      RADIOS,
                                      pnl(new ChButton("OCM").li(actLi).t("Open Context Menu"), new ChButton("OCMc").li(actLi).t("Cancel"))
                                      );
            }
            for(int i=sze(RADIOS); --i>=0;) {
                final JRadioButton r=RADIOS[i];
                if (r!=null) {
                    r.setEnabled(radios[i]);
                    r.setSelected(i==lastType);
                }
            }
            ChFrame.frame("Context Menu for Residue Selections",pnlRadioSelection,ChFrame.ALWAYS_ON_TOP|ChFrame.PACK).shw(ChFrame.AT_CLICK);
        }
    }
    private static void staticShowPopup(char type) {
        StrapAlign.showContextMenu(type, staticSelV.toArray(), staticEvent);
    }
}
