package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.io.File;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
   Result panel of DialogCompareProteins
*/
class ResultCompareProteins extends AbstractDialogJPanel implements  Disposable,StrapListener,ActionListener,MouseListener,TableModel,ChRunnable,TableCellRenderer,IsEnabled {
    @Override public void dispose() {
        isRunning=false;
        if (gs!=null)  gs.dispose();
        align.removeListener(this);
        rmFromParent(getPanel());
        myGraphEdge=null;
   }

    private Container panel=this;
    public Container getPanel() { return panel;}
    private ChJTable table;
    private boolean isRunning=true;
    private GraphSun gs;
    private Object clas;
    private ProteinProteinValue sharedInstance;
    private StrapProtein ppRow[],ppCol[];
    private int fromColumn,toColumn;
    private MyGraphEdge myGraphEdge[][];
    private Container pNorth;

   ResultCompareProteins(Object clas,ProteinProteinValue sharedInstance, StrapProtein ppRow[],StrapProtein ppCol[],int fromColumn,int toColumn) {
        this.fromColumn=fromColumn;
        this.toColumn=toColumn;
        this.clas=clas;
        this.sharedInstance=sharedInstance;
        this.ppRow=ppRow;this.ppCol=ppCol;
        TabItemTipIcon.set(null,shrtClasNam(clas),null,null,this);
        pNorth=align.headLine(this);
        makeEdges(ppRow,ppCol!=null ? ppCol : ppRow);
        ChDelay.newThread(this,"COMPUTE",null).start();

        if (ppCol==null) graph();
        else {
            table();
            if (isInstncOf(StrapListener.class,sharedInstance)) {
                align.addListener( (StrapListener)sharedInstance);
                align.addListener(this);
            }
        }
        {
        pcp(KEY_IMAGE_FILE_NAME,"compareProteins_graph",gs);
        pcp(KEY_IMAGE_FILE_NAME,"compareProteins_table",table);
        pcp(KEY_PRINTABLE_COMPONENTS,  new Object[]{gs,table}, this);
        }
    }

    public boolean isEnabled(Object o) { return !align.needsRepaintAlignment();}
    private void graph() {
        gs=new GraphSun();
        gs.setEnabled(this);
        MyGraphEdge eee[][]=myGraphEdge;
        for(MyGraphEdge ee[]:eee)
            for(MyGraphEdge e:ee)
                gs.addEdge(e);
        gs.start();
        makeTranslucent(gs);
        gs.addButton(new ChButton("T").t("Text").li(this),0);
        gs.addButton(smallHelpBut(clas),0);
        gs.addButton(ChButton.actionSharedCtrl(sharedInstance),0);
        cnsew(panel,gs,pNorth,null,null,null);
    }
    // ----------------------------------------
    private final RendererNumberAsOval rendererNumberAsOval=new RendererNumberAsOval();
    private final TableCellRenderer chRen=new ChRenderer();//.onlyIcons();

    public Component getTableCellRendererComponent(JTable t,Object o,boolean isSel,boolean foc,int row,int col) {
        if (row==-1) {
            final int c=table.convertColumnIndexToModel(col);
            return  c==0 ? blankLabel() : ppCol[c-1].getVerticalRendererComponent();
        }
        return (col>0 ? rendererNumberAsOval : chRen).getTableCellRendererComponent(t,o,isSel,foc,row,col);
    }
    /* --- TableModel --- */
            public String getColumnName(int c) {return c==0 ? "" : ppCol[c-1].getName();}
            public boolean isCellEditable(int row,int column) {return false;}
            public void setValueAt(Object o,int row,int col) {}
            public Class getColumnClass(int c) {return c==0 ? StrapProtein.class : MyGraphEdge.class;}
            public int getColumnCount() {return ppCol.length+1;}
            public int getRowCount() {return ppRow.length;}
            public Object getValueAt(int row_,int col) {
                try{
                    final int row=  ppRow==ppCol && row_+1<getColumnCount() ?  table.convertColumnIndexToModel(row_+1)-1 : row_;
                    return  (col==0) ?  ppRow[row] :  myGraphEdge[row][col-1];
                } catch(Exception e) { return "error";}
            }
            public void addTableModelListener(javax.swing.event.TableModelListener l){}
            public void removeTableModelListener(javax.swing.event.TableModelListener l){}
    /* --- TableModel --- */
    private final ChCombo comboRenderTable=new ChCombo(RendererNumberAsOval.TYPES).li(this);
    private final ChSlider
        sliderHeight=new ChSlider("sliderHeight",0,50,16).endLabels("height",null),
        sliderScale=new ChSlider("sliderScale",0,400,100).endLabels("scale",null);
    {
        addActLi(this,sliderHeight);
        addActLi(this,sliderScale);
    }
    private void table() {
        table=new ChJTable(this,ChJTable.ICON_ROW_HEIGHT).renderer(this);
        rtt(table);
        table.getTableHeader().setDefaultRenderer(this);
        table.getTableHeader().setCursor(getCursr('M'));
        UIupdateList.add(table.getTableHeader(),UIupdateList.SELECTED_OBJECTS);
        UIupdateList.add(table.getTableHeader(),UIupdateList.PROTEIN_AT_CURSOR);
        final Container  pSouth=hB(
                                   ChButton.actionSharedCtrl(sharedInstance),
                                   sliderHeight,sliderScale," ", comboRenderTable," ",new ChButton("T").t("Text").li(this));
        cnsew(panel,scrllpn(0L,table),pNorth,pSouth,null,null);
       table.addMouseListener(this);
    }
    @Override public void mouseClicked(MouseEvent ev) {
        final Point p=ev.getPoint();
        final int row=table.rowAtPoint(p),col=table.columnAtPoint(p);
        final Object o=getValueAt(row,col);
        if (!(o instanceof MyGraphEdge)) return;
        final ProteinProteinValue ppd=((MyGraphEdge)o).ppd;
        ChMsg.savedMsg("Clicking into the table:<ul><li>right mouse button: show details</li><li>left mouse button: depending on method show alignment or superposition</li></ul>","ResultCompareProteins-click");
        setEventLocationOnScreen(ev);
        if (isPopupTrigger(ev)) {
            final Container ctrl=getCtrlPanel(ppd);
            if (ctrl!=null) new ChFrame(ppd.getProtein()+"  "+ppd.getOtherProtein()).ad(getCtrlPanel(ppd)).shw(ChFrame.AT_CLICK|ChFrame.DISPOSE_ON_CLOSE);
        } else {
            StrapProteinUtils.viewComparison((StrapProtein)ppd.getProtein(), ppd.getOtherProtein(),sharedInstance);
        }
    }

    public void handleEvent(StrapEvent ev) {
        if (ev.getType()==StrapEvent.PROTEIN_PROTEIN_DISTANCE_CHANGED) {
            ChDelay.runAfterMS(EDT,this,"REPAINT",111);
        }
    }
    private void makeEdges(Protein ppRows[], Protein ppCols[]) {
        final int nR=ppRows.length,nC=ppCols.length;
        GraphNode nodeCol[]=new GraphNode[nC];
        final GraphNode nodeRow[]=new GraphNode[nR];
        for(int i=0;i<nR;i++)
            nodeRow[i]=new GraphNode(ppRows[i]);
        if (ppRows==ppCols) nodeCol=nodeRow;
        else for(int i=0;i<nC;i++) nodeCol[i]=new GraphNode(ppCols[i]);
        final MyGraphEdge ee[][]=new MyGraphEdge[nR][nC];
        for(int iR=0;iR<nR;iR++)
            for(int iC=0;iC<nC;iC++) {
                ee[iR][iC]=new MyGraphEdge(nodeRow[iR],nodeCol[iC]);
            }
        myGraphEdge=ee;
    }
    // ----------------------------------------
    public Object run(String id, Object argv) {
        if (id=="REPAINT") {
            if (max>min) { rendererNumberAsOval.setScale(sliderScale.getValue()/100f/(max-min)); rendererNumberAsOval.setOffset(-min); }
            if (table!=null) { table.revalidate(); table.repaint();}
        }
        if (id=="COMPUTE") {
            final MyGraphEdge eee[][]=myGraphEdge;
            max=Double.MIN_VALUE;
            min=Double.MAX_VALUE;
            long time=System.currentTimeMillis();
            for(MyGraphEdge ee[]:eee){
                //float rowSum=0;
                for(MyGraphEdge e:ee)  {
                    if (!isRunning) break;
                    while(align.needsRepaintAlignment()) sleep(999);
                    final ProteinProteinValue dis=HotswapUtil.instance(clas,ProteinProteinValue.class,true);
                    setSharedParas(this.sharedInstance,dis);
                    if (dis==null) continue;
                    dis.setProtein((StrapProtein)e.getNodeFrom().getObject());
                    dis.setOtherProtein((StrapProtein)e.getNodeTo().getObject());
                    dis.setColumnRange(fromColumn,toColumn);
                    dis.compute();
                    final double v=dis.getValue();
                    if (max<v) max=v; if (min>v) min=v;
                    e.setPPD(dis);
                    final long t=System.currentTimeMillis();
                    if (t-time>444) { time=t; if (table!=null) table.repaint(); }
                    while (align.needsRepaintAlignment()) sleep(99);
                }
                sleep(99);
                ChDelay.runAfterMS(EDT,this,"REPAINT",111);
            }
        }
        return null;
    }
    private double max=Double.MIN_VALUE,min=Double.MAX_VALUE;
    // ----------------------------------------
    private static class MyGraphEdge extends GraphEdge implements FloatValue {
        public ProteinProteinValue ppd;
        void setPPD(ProteinProteinValue ppd) {
            this.ppd=ppd;
        }
        public MyGraphEdge(GraphNode from,GraphNode to) { super(from,to);}
        public float floatValue(Object o){return (float)getLen();}
        @Override public  double getLen() {
            if (ppd!=null) {
                GraphNode from=getNodeFrom(),to=getNodeTo();
                if (ppd.getProtein()==null) {
                    ppd.setProtein((StrapProtein)from.getObject());
                    ppd.setOtherProtein((StrapProtein)to.getObject());
                    ppd.compute();
                    while (StrapAlign.getInstance().needsRepaintAlignment()) sleep(99);
                }
                return ppd.getValue();
            }
            return Double.NaN;
        }
    }
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        final String cmd=ev.getActionCommand();
        if (q==comboRenderTable) {
            rendererNumberAsOval.type(comboRenderTable.getSelectedItem().toString());
            ChDelay.runAfterMS(EDT,this,"REPAINT",111);
            sliderScale.setEnabled(comboRenderTable.getSelectedIndex()<2);
        }
        if (q==sliderHeight) { table.setRowHeight(sliderHeight.getValue()); table.revalidate();}
        if (q==sliderScale && max!=min) ChDelay.runAfterMS(EDT,this,"REPAINT",111);
        if (cmd=="T") {
            final StrapProtein[] ppR=this.ppRow, ppC=this.ppCol!=null ? this.ppCol:ppR;
            final StringBuffer sb=new StringBuffer(ppR.length*ppC.length*100);
            for(Protein p: ppC) sb.append(p).append("\t");
            sb.append("\n");
            int iRow=0;
            for(StrapProtein pR:ppR) {
                sb.append(pR).append("\t");
                for(int iCol=0;iCol<ppC.length;iCol++)
                    sb.append(myGraphEdge[iRow][iCol].floatValue(null)).append("\t");
                sb.append("\n");
                iRow++;
            }
            sb.append("\n\n");
            iRow=0; for(StrapProtein pR:ppR) {
                int iCol=0;for(StrapProtein pC:ppC) {
                    sb.append(myGraphEdge[iRow][iCol++].floatValue(null)).append("\t")
                        .append(pR).append("\t")
                        .append(pC).append("\n");
                }
                iRow++;
            }
            final File f=file(STRAPOUT+"/Result_CompareSomeSequences.txt");
            wrte(f,sb);
            final AsciiView v=new AsciiView(f).showInFrame("Compare proteins",0);
            v.setBackground(C(0xFFffFF));
            v.tools().highlightOccurrence("\t", (boolean[])null, (boolean[])null, HIGHLIGHT_NOT_IN_SCROLLBAR, C(0xc0c0c0));

        }
    }
}
