package charite.christo.strap;
import charite.christo.protein.*;
import charite.christo.*;
import charite.christo.interfaces.*;
import org.biojava.bio.seq.*;

/**
			@author Christoph Gille
*/

public class StrapBiojavaAlignmentTools {
    private StrapBiojavaAlignmentTools(){}
				public static boolean alignAminoAcidSequences(GappedSequence gss[], SequenceAligner ali) {
								if (gss==null || ali==null) return false;
								final byte[] gappedSequences[]=new byte[gss.length][];
								final byte[] sequences[]=new byte[gss.length][];
								for(int i=0;i<gss.length;i++) {
												if (gss[i]==null) continue;
												final byte s[]=gss[i].seqString().getBytes();
												sequences[i]=gss[i].seqString().replaceAll("[^A-Za-z]","").getBytes();
												gappedSequences[i]=s;
								}
								ali.setSequences(sequences);
								ali.compute();
								final byte[] result0[]=ali.getAlignedSequences();
        if (result0!=null) {
            final StringBuffer sb=new StringBuffer("result0=\n");
            for(byte[] a : result0) sb.append(new String(a)).append('\n');
            System.out.println(sb.append('\n'));
        }
        final byte[] result[]=/*ChAlignUtils.isLocal(gappedSequences,result0) ? Local2GlobalAlignment.local2global(gappedSequences,result0) :*/ result0;
        if (result!=null) {
            final StringBuffer sb=new StringBuffer("result=\n");
            for(byte[] a : result) sb.append(a).append('\n');
            System.out.println(sb.append('\n'));
        }
								for(int i=0;i<gss.length;i++) {
												removeAllGaps(gss[i]);
												inferGapsFromGappedSequence(gss[i],result[i]);
								}
								return true;
				}

				private static void removeAllGaps(GappedSequence gs) {
								String s=gs.seqString();
								for(int i=s.length();--i>=0;)
												if (!Character.isLetter( (char)s.charAt(i)))
																try {
																				gs.removeGap(i+1);
																} catch(Exception e) {	System.out.println("caught in removeAllGaps:"+e);}
				}

				private static void inferGapsFromGappedSequence(GappedSequence gs, byte s[]) {
								System.out.println(s);
								int l=s.length;
								boolean error=false;
								for(int i=0,iAa=0;i<l;i++) {
												final byte c=s[i];
												if ('a'<=c && c<='Z' || 'A'<=c && c<='Z') iAa++;
												else {
																try {
																				gs.addGapInSource(iAa+1);
																} catch(IndexOutOfBoundsException e) {error=true;}
            }
								}

								if (error)
												System.out.println("error in StrapBiojavaAlignmentTools.inferGapsFromGappedSequence "+s);
				}

}
