package charite.christo.strap;
import charite.christo.*;
import charite.christo.protein.*;
import java.awt.*;
import java.lang.ref.*;
import javax.swing.*;
import java.io.File;
import java.util.*;
import java.awt.event.*;
import static java.lang.System.*;
import static java.awt.event.MouseEvent.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**
Cell renderer for protein files.
   @author Christoph Gille
*/
public class StrapFileCellRenderer implements ListCellRenderer,KeyListener{
    private static ChLabel LABEL; { if (LABEL==null) monospc(LABEL=new ChLabel());}
    private final static StringBuffer SB=new StringBuffer(99);
    private File directory;
    public StrapFileCellRenderer(File dir) { directory=dir;}
    private transient Reference<JList> refList;
    public Component getListCellRendererComponent(JList list,Object value,int index,boolean isSelected, boolean cellHasFocus) {
        if (deref(refList)!=list) refList=weakRef(list);
        if (value==null) return LABEL.t("null");
        final File f=value instanceof File ? (File) value : new File(directory,toStrg(value));
        try {

            final File parent=file(f.getParent());
            final String fn=f.getName();
            SB.setLength(0);
            SB
                .append(Protein.strapFile(parent,fn,Protein.mGAPS).exists() ? 'g':'.')
                .append(Protein.strapFile(parent,fn,Protein.mDNA).exists() ? 'n':'.')
                .append(Protein.strapFile(parent,fn,Protein.mTRANS).exists() ? '3':'.')
                .append(Protein.strapFile(parent,fn,Protein.mANNO).exists() ? 's':'.')
                .append("  ")
                .append(fn);
            final boolean isDir=f.isDirectory(),isExist=f.exists();
            if (!isDir && fn.indexOf(' ')>=0) SB.insert(0,"error: blanks not allowed   ");
            if (StrapAlign.getInstance()!=null && !isExist) SB.insert(0,"missing:  ");
            // flags
            ImageIcon ic=iicon(fn); if (ic==null) ic=iicon(IC_BLANK);
            if (isDir) { ic=iicon(IC_DIRECTORY);  SB.setLength(0);SB.append(fn);}
            LABEL.t(SB).fg( C(isSelected ? COLOR_SELECTED : isEnabled(f) ? 0 : 0x888888)).i(ic);
        } catch(Exception e) { LABEL.t("error value="+value); }
        return LABEL;
    }
    public static boolean isEnabled(File f) {

        if (f==null || !f.exists() || f.isDirectory()) return false;
        return StrapProtein.getProteinWithName(f.getName(),null)==null;
    }
    private double scale=1;
    public void keyPressed(KeyEvent kev){
        final char kchar=kev.getKeyChar();
        switch(kchar) {
        case '+':
        case '-':
            if (kchar=='-') scale/=1.1; else scale*=1.1;
            enlargeFont(LABEL,scale);
            ChDelay.afterMS(EDT,ChDelay.CONTENTS_CHANGED,refList,1,null);
        }
    }
   public void keyReleased(KeyEvent e){}
   public void keyTyped(KeyEvent e){}

}
