package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;

import java.io.File;
import java.util.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyAdapter;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static charite.christo.strap.StrapAlign.drawMessage;
import static java.awt.event.KeyEvent.*;
/**HELP

      Alignment gaps are introduced and removed with the keyboard.
      Changes to the amino acid sequence, however, are conducted with an external
      editor. (<i>ITEM:ProteinPopup#ACTION_EDIT</i>).

    <div class="floatR">
      <table border="1" >
        <caption> Cursor Movements</caption>
        <tr><th>Arrow keys      </th><td>Cursor navigation       </td></tr>
        <tr><th>CTRL arrow keys </th><td>move to beginning or end</td></tr>
        <tr><th>ALT + arrow keys</th><td>move to next gap        </td></tr>
        <tr><th>HOME            </th><td>First  row              </td></tr>
        <tr><th> END            </th><td>Last row                </td></tr>
        <tr><th>SHIFT HOME      </th><td>First column            </td></tr>
        <tr><th>SHIFT END       </th><td>Last column             </td></tr>
      </table>
    </div>

    <div class="floatR">
      <table border=1>
        <caption> Movement of the view-port</caption>
        <tr><th>PAGE-UP / PAGE-DOWN</th><td>Scroll up and down</td></tr>
        <tr><th>SHIFT PAGE-UP      </th><td>Scroll left       </td></tr>
      </table>
    </div>

    <div class="floatR">
      <table border=1>
        <caption> Deleting gaps</caption>
        <tr><th>DELETE              </th><td>Delete gap right from or under cursor      </td></tr>
        <tr><th>BACKSPACE           </th><td>DELETE gap left from  cursor               </td></tr>
        <tr><th>CTRL DELETE         </th><td>Delete next gap right from the cursor      </td></tr>
        <tr><th>CTRL  BACKSPACE     </th><td>Delete next gap left  from  cursor         </td></tr>
        <tr><th>CTRL SHIFT DELETE   </th><td>Delete entire white space  under cursor    </td></tr>
        <tr><th>CTRL SHIFT BACKSPACE</th><td>Delete entire white space  left from cursor</td></tr>
      </table>
    </div>

    <div class="floatR" >
      <table  border=1>
        <caption>Inserting gaps</caption>
        <tr><th>SPACE       </th><td>Insert gap under cursor                                     </td></tr>
        <tr><th>INSERT      </th><td>Insert gaps until next residue in above row is reached. Effectively it copies the gaps from the line above. </td></tr>
        <tr><th>CTRL  INSERT</th><td> Remove gaps until  previous residue in above row is reached</td></tr>
        <tr><th>SHIFT INSERT</th><td> Insert gaps until  next residue in below row is reached    </td></tr>
      </table>
    </div>

    <div class="floatR">
      <table border=1>
        <caption>Perform an operation n times</caption>
        <tr><th>4  2 SPACE </th><td>Insert  42 gaps</td></tr>
        <tr><th>4  2 DELETE</th><td>Delete  42 gaps</td></tr>
      </table>
    </div>

    <div class="floatR">
      <table border=1>
        <caption>Moving a sequence blocks:  A group of consecutive residues that are not interrupted by gaps is moved left or right.</caption>
        <tr><th>&gt;</th><td>Move continuous group of residues right</td></tr>
        <tr><th>&lt;</th><td>Move continuous group of residues left </td></tr>
      </table>
    </div>
    <div class="floatR">
      <table border=1>
        <caption>Window</caption>
        <tr><th>CTRL N</th><td>  New alignment panel</td></tr>
        <tr><th>CTRL W</th><td>Close alignment panel</td></tr>
      </table>
    </div>

    <div class="floatR">
      <table border=1>
        <caption>Miscellaneous</caption>
        <tr><th>CTRL  K</th><td>Close protein                    </td></tr>
        <tr><th>CTRL  *</th><td>Display letters in better quality</td></tr>
        <tr><th>U      </th><td>Upper Case                       </td></tr>
        <tr><th>L      </th><td>Lower Case                       </td></tr>
      </table>
    </div>

    <div class="floatR">
      <table border=1>
        <caption>Font Size</caption>
        <tr><th>CTRL "+"</th><td>Zoom in </td></tr>
        <tr><th>CTRL "-"</th><td>Zoom out</td></tr>
      </table>
    </div>

    <div class="floatR"><table border=1>
        <caption>Goto position</caption>
        <tr><th>4 2 i</th><td>Move cursor to residue index 42</td></tr>
        <tr><th>4 r  </th><td>Move cursor to 4th row         </td></tr>
        <tr><th>42 c </th><td>Move cursor to column 42       </td></tr>
        <tr><th>42 n </th><td>Move cursor pdb-number 42      </td></tr>
      </table>
    </div>

    <div class="clearall"></div>
    <br>The mouse actions follow general conventions:
    <ol class="clearall">
      <li>
        Sequence alignment
        <ul>
          <li>left-click sets the cursor.</li>
          <li>middle-click sets the focus without changing the cursor.</li>
          <li>right-click opens a context menu either for the alignment pane or for a residue selection.</li>
          <li>Dragging creates a mouse selection.</li>
          <li>Dragging over more than one sequence creates a rectangular region.
            Residue selections and annotations within the rectangle are selected.
            SHIFT for union-set and CTRL for cut-set similar to the program gimp or the MS-Window desktop. </li>
          <li>ALT + Dragging scrolls two-dimensionally. Under Unix/Linux also hold SHIFT</li>
        </ul>
      </li>

      <li>
        Row-header
        <ul>
          <li>Dragging up/down changes the order of proteins.</li>
          <li>CTRL left-click selects or deselects the protein.</li>
          <li>right-click opens a context menu for the protein.</li>
        </ul>
      </li>

      <li>
        Scroll-bar or alignment pane
        <ul>
          <li>Wheel scrolls.</li>
          <li>SHIFT +  Wheel scrolls vertically</li>
          <li>CTRL + Wheel zooms.</li>
        </ul>
      </li>
    </ol>

    <span class="clearall"></span>
    <div  class="floatR" >
      <table  border=1>
        <caption>Sequence groups</caption>
        <tr><th>G&nbsp;x</th><td>Define all currently selected proteins as group "x".                              </td></tr>
        <tr><th>g&nbsp;x</th><td>Load proteins of sequence group "x" if not already loaded. Select these proteins. </td></tr>
        <tr><th>h&nbsp;x</th><td>Unselect and hide all proteins of sequence group "x".                             </td></tr>
      </table>
    </div>
    <b>Sequence Groups:</b><br>
    Sequences can be grouped. Groups are designated by a digit or letter.
    The names of all proteins of a group are listed in a file in ./annotations/sequenceGroups/.

<i>SEE_CLASS:StrapView</i>
<i>SEE_CLASS:Gaps2Columns</i>
@author Christoph Gille
*/
public class StrapKeyStroke extends KeyAdapter {
    private final StrapView view;
    public StrapKeyStroke(StrapView v) { view=v;}
    private int multiStroke,shiftStart;
    private boolean isShift;
    private char action;
    private final StrapEvent EVENT=new StrapEvent(this,StrapEvent.ALIGNMENT_CHANGED);
    @Override public void keyPressed(KeyEvent e) {
        if (!view.showsSequence()) return;
        final char ch=e.getKeyChar();
        final int kcode=keyCode(e);
        final boolean shift=isShift(e), ctrl=isCtrl(e);
        final StrapAlign align=StrapAlign.getInstance();
        if (ctrl) setNextProcessHasLogPanel(System.currentTimeMillis());
        if (kcode==VK_SHIFT || kcode==VK_CONTROL) return;
        final boolean isDigit=!ctrl && !shift && '0'<=ch && ch<='9';
        final File f;
        if ((action|32)=='g' || action=='h') mkParentDrs(f=file(DIR_ANNOTATIONS+"/sequenceGroups/"+ch)); else f=null;
        if (ch=='#') {
            drawMessage(ANSI_W_ON_B+"This key is not supported any more. Instead select the proteins to be worked on simultaneously.");
            return;
        }
        if (action=='0' && !isDigit) drawMessage("");
         if (action=='G') {
            final StrapProtein pp[]=align.getSelectedProteins();
            final String s=joinAsStrg(pp," ");
            wrte(f,s);
            drawMessage(ANSI_GREEN+"Defining group \""+ch+"\" with "+pp.length+" proteins");
            action=0;
        } else if (action=='g' || action=='h') {
            final StrapProtein ppAll[]=align.getProteins();
            final ByteArray ba=readBytes(f);
            StrapProtein pp[]=null;
            if (!('a'<=ch && ch<='z' || 'A'<=ch && ch<='Z' || isDigit)) {
                drawMessage(ANSI_W_ON_R+"canceled ");
            } else {
                UniqueList<StrapProtein> v=null;
                if (ba!=null) {
                    final ChTokenizer t=new ChTokenizer();
                    t.setText(ba.getBytes(), ba.getBegin(),ba.getEnd());
                    if (action=='g') align.loadTheProteinsInList(ba.newString(),StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
                    while(true) {
                        final String s=t.nextAsString();
                        if (s==null) break;
                        final StrapProtein p=StrapProtein.getProteinWithName(s,ppAll);
                        if (p!=null) (v==null ? v=new UniqueList(StrapProtein.class) : v).add(p);
                    }
                    pp=v.asArray();
                } else {
                    final String m0="Error: No such sequence group \""+ch+"\".";
                    drawMessage(ANSI_W_ON_R+m0);
                    error(m0+"<br> The file <br>"+f.getName()+" in "+f.getParent()+"<br>does not exist.");
                }
            }
            if (action=='g') {
                if (pp!=null) {
                    adAll(pp,  StrapAlign.getSelectedObjectsV());
                    new StrapEvent(this,StrapEvent.OBJECTS_SELECTED).setParameter(StrapProtein.class).run();
                    drawMessage(ANSI_GREEN+"Selected "+pp.length+" sequences of group \""+ch+"\"");
                    align.setIsInAlignment(true,pp);
                } else { drawMessage(ANSI_W_ON_R+"No protein selected."); }
            }
            if (action=='h' && pp!=null) {
                align.setIsInAlignment(false,pp);
                drawMessage(ANSI_GREEN+pp.length+" proteins hidden");
            }
            action=0;
        }  else if (isDigit) {
            drawMessage(ANSI_W_ON_B+"Apply next keystroke  "+ (multiStroke=multiStroke*10+ch-'0')+" times");
            action='0';
        } else {
            if (isDigit) {
                drawMessage(ANSI_W_ON_B+"number prefix "+multiStroke+" (  e.g. type spacebar to enlarge gap by "
                            +multiStroke+", type i to set cursor to residue index "+multiStroke+")");
                multiStroke=ch-'0';
                action='0';
            }
            if (ch=='g') {
                action=ch;
                drawMessage(ANSI_W_ON_B+"Loading and selecting a group of proteins. Now type the letter designating the group!");
            } else if (ch=='h') {
                action=ch;
                drawMessage(ANSI_W_ON_B+"Hiding sequences in group. Now type the letter for the group!");
            } else if (ch=='G') {
                final int n=align.getSelectedProteins().length;
                if (n==0) {
                    drawMessage(ANSI_W_ON_R+"Before defining a sequence group, you must select proteins first!");
                } else {
                    action=ch;
                    drawMessage(ANSI_W_ON_B+"Defining sequence group for "+n+" proteins. Now type the letter designating the group!");
                }
            } else if (ch<'0' || ch>'9') {
                action=0;
                if (keyPressed(e,kcode,ch, ctrl, shift, isAlt(e))) {
                    e.consume();
                    align.setChanged();
                    EVENT.run();
                    view.scrollCursorToVisible();
                }
                multiStroke=0;
            }
        }
    }
    private final static int BL='B'+'L', BR='B'+'R';
    private boolean keyPressed(KeyEvent ev, int kcode,char kchar, boolean ctrl, boolean shift, boolean alt) {
        boolean isChanged=false;
        final int times=multiStroke>1 ? multiStroke : 1;
        final StrapAlign align=StrapAlign.getInstance();
        final StrapProtein p=view.getProteinAtCursor();
        align.setAlignmentPanelWithFocus(view);
        //CURSOR MOVEMENT
        if (cursor(kcode,shift,ctrl,alt,times)) { ev.consume(); return false; }
        // EDITING
        final int col=view.getColumnAtCursor(), row=view.getRowAtCursor();
        final StrapProtein pp[];
        {
            final StrapProtein ppSel[]=align.getSelectedProteins();
            final StrapProtein _pp[]=view.getProteinsInRow(view.getRowAtCursor());
            pp= (_pp.length>0 && cntains(_pp[0],ppSel)) ? ppSel : _pp;
        }
        if (pp.length==0) return false;
        switch (kchar) {
        case ' ':
            isChanged=
                ctrl ? insertDelete(BL,pp,col,times) :
                shift ? insertDelete(BR,pp,col,times) :
                insertDelete('L',pp,col,times);
                break;
        case '>':
            isChanged=insertDelete(BR,pp,col,-times);
            align.setChanged();
            if (isChanged) insertDelete(BL,pp,view.getColumnAtCursor(),times);
            break;
        case '<':
            isChanged|=insertDelete(BL,pp,col,-times);
            align.setChanged();
            if (isChanged) insertDelete(BR,pp,view.getColumnAtCursor(),times);
            break;
        case 'u':
        case 'l': isChanged|=!ctrl;break;
        case '*': setAntiAlias('*'); break;
        }
        switch (kcode) {
        case VK_F1: align.allMenus(true,true,null); break;
        case VK_ADD:
        case VK_PLUS: if (ctrl) view.setFont("",2,false); break;
        case VK_MINUS: if (ctrl) view.setFont("",-2,false); break;
        case VK_DELETE:
            isChanged=
                ctrl&&!shift ? insertDelete(BR,pp,col,-times) :
                ctrl&&shift ? deleteTotal('R',pp,col) :
                insertDelete('R',pp,col,-times);
            break;
        case VK_BACK_SPACE:
            isChanged=
                ctrl&&!shift ? insertDelete(BL,pp,col,-times) :
                ctrl&&shift ? deleteTotal('L',pp,col) :
                insertDelete('L',pp,col,-times);
            break;
        case VK_INSERT:
            final StrapProtein p2=view.getProtein(shift ? row+1:row-1);
            if (p2==null) break;
            isChanged= ctrl?
                leftAlign(pp,col,p,p2):
                rightAlign(pp,col,p,p2);
            break;
        case VK_W: if (ctrl && !shift) align.closeAlignmentPanel(view); break;
        default:
        }
        return isChanged;
    }
    private boolean cursor(int kcode,boolean shift,boolean ctrl,boolean alt, int times) {
        final int row=view.getRowAtCursor(), col=view.getColumnAtCursor();
        int ias=view.getIndexOfAminoAcidAtCursor(),iRow=row;
        boolean r=false;
        final StrapProtein p=view.getProteinAtCursor();
        if (p==null) return false;
        if (shift && !this.isShift)  shiftStart=col;
        this.isShift=shift;
        final int nR=p.countResidues();
        if (!ctrl) {
            if ((kcode==VK_U || kcode==VK_L) && p!=null && p.countNucleotides()==0) {
                for(int i=mini(nR,ias+times); --i>=ias;) {
                    p.setResidueTypeToUpperOrLower(i, kcode==VK_U);
                }
                ias+=times;
                r=true;
            }
        }
        final int num=times;
        if (!ctrl)
            switch (kcode) {
            case VK_LEFT: r=true; ias-=num; break;
            case VK_RIGHT: r=true; ias+=num; break;
            case VK_DOWN: r=true; iRow+=num; break;
            case VK_UP:  r=true; iRow-=num; break;
            case VK_PAGE_UP:  view.scrollRel('v',-num,true); break;
            case VK_PAGE_DOWN: view.scrollRel('v',num,true); break;
            case VK_END:  r=true; iRow=MAX_INT; break;
            case VK_HOME: r=true; iRow=0; break;
            }
        if (!ctrl && multiStroke>0) {
            boolean c=false;
            switch(kcode) {
            case VK_I: view.setCursor(false, p,num-1+p.getFirstResidueIndexOffset()); c=true; break;
            case VK_N: view.setCursor(false, p,p.residueNumberAndChain2residueIdx(num,(char)0,(char)0));  c=true; break;
            case VK_C: view.setCursor(true,p,num-1);  c=true; break;
            case VK_R: view.setCursor(true,view.getProtein(num-1),col);  c=true; break;
            }
            if (c) view.scrollCursorToVisible();
        }
        boolean toEnd=false, toBegin=false;
        if (ctrl)
            switch (kcode) {
            case VK_PAGE_UP:  view.scrollRel('h',num*10,true); break;
            case VK_PAGE_DOWN: view.scrollRel('h',-num*10,true); break;
            case VK_END: r=toEnd=true; break;
            case VK_HOME: r=toBegin=true; break;
            case VK_LEFT: r=toBegin=true; break;
            case VK_RIGHT: r=toEnd=true;  break;
            case VK_DOWN: r=true; iRow=MAX_INT; break;
            case VK_UP:  r=true; iRow=0; break;
            default:
            }
        if (toEnd) ias=MAX_INT;
        if (toBegin) ias=0;

        final int resCol[]=p.getResidueColumn();
        if (!ctrl && alt && resCol!=null && (kcode==VK_LEFT || kcode==VK_RIGHT)) {
            final int d=(kcode==VK_RIGHT ? 1 : -1);
            ias+=d;
            while(ias>0 && ias<resCol.length-1) {
                final int diff=resCol[ias+d]-resCol[ias];
                if (diff!=1 && diff!=-1) break;
                ias+= d;
                r=true;
            }
        }
        if (!r) return r;
        if (ias<0) ias=0;
        if (iRow==row) view.setCursor(false, view.getProtein(iRow),ias);
        else view.setCursor(true,view.getProtein(maxi(0,iRow)), col);
        view.scrollCursorToVisible();
        if (r && shift) {
            final int c=view.getColumnAtCursor();
            view.mouseSelection().set(view.getProteinAtCursor(), shiftStart, toBegin?0 : toEnd?MAX_INT : c);
        }
        return r;
    }
    /* ---  The following Methods insert or delete a gap in various ways --- */
    private final static boolean deleteTotal(int op,StrapProtein[] pp,int col) {
        final int offset=op=='R' ? 1 : 0;
        int gapMin=MAX_INT;
        final int iAa[]=column2idx('R',pp,col,op=='R');
        if (iAa==null) return false;
        for(int iP=0;iP<pp.length;iP++) {
            final StrapProtein p=pp[iP];
            if (p==null) continue;
            int gap=p.getResidueGap(iAa[iP]+offset);
            if (gap>=0) gapMin=mini(gapMin,gap);
        }
        for(int iP=0;iP<pp.length;iP++) {
            final StrapProtein p=pp[iP];
            if (p==null) continue;
            final int iA=iAa[iP]+offset;
            final int g=p.getResidueGap(iA);
            if (g>=0) p.setResidueGap(iA,maxi(0,g-gapMin));
        }
        return true;
    }

    private final static int[] column2idx(int op,StrapProtein[] prot, final int col,boolean thisOrPrev) {
        final int iAa[]=new int[prot.length];
        final int protectN=StrapView.getProtectFromColumn('N');
        for(int iP=0;iP<prot.length;iP++) {
            final StrapProtein p=prot[iP];
            if (p==null) continue;
            final int gap[]=p.getResidueGap();
            int ia=thisOrPrev ? p.column2thisOrPreviousIndex(col) : p.column2nextIndex(col);
            final int nResidues=p.countResidues();
            while (op==BL && ia>0 && gap[ia]==0) ia--;
            while (op==BR && ia+1<nResidues-1 && gap[ia+1]==0) ia++;
            if (ia>=nResidues) ia=-1;
            if (op==BR && protectN>0 && col<protectN && p.getResidueColumn(ia)>=protectN) {
                ia=p.column2thisOrPreviousIndex(protectN-1);
            }
            if (ia<0) return null;
            iAa[iP]=ia;
        }
        return iAa;
    }
    private final static boolean insertDelete(int op, StrapProtein[] pp,int col, int num) {
        assertEDT();
        final StrapAlign align=StrapAlign.getInstance();
        final int n2w[]=align.gap2col().narrow2wideColumn();
        final int countColumns=align.gap2col().countColumns();
        final int iA[]=column2idx(op,pp,col,false);
        final int protectW=StrapView.getProtectFromColumn('W');
        final int protectN=StrapView.getProtectFromColumn('N');
        final int n;
        final boolean delRight=op=='R' || op==BR;
        /* Are there positions before protectN */
        boolean protect=false;
        if (protectW>0) {
            for(int iP=pp.length; --iP>=0;) {
                protect=protect || pp[iP]!=null && pp[iP].getResidueColumn(iA[iP])<protectN;
            }
        }
        /* What is the max number that can be inserted/deleted */
        if (num>0 && protect && protectN<countColumns) {
            int max=MAX_INT;
            for(int iP=0;iP<pp.length;iP++) {
                if (pp[iP]==null) continue;
                final int i1=iA[iP], i2=pp[iP].column2thisOrPreviousIndex(protectN-1);
                final int c1=pp[iP].getResidueColumn(i1);
                final int c2=pp[iP].getResidueColumn(i2);
                if (0<=c1 && i1<=i2 && c1<=c2 && c2<mini(n2w.length,protectN)) {
                    final int g=protectW-n2w[c1] -(i2-i1)-1;
                    if (g<max)max=g;
                }
            }
            n=mini(num,max);
        } else if (num<0) {
            int max=MAX_INT;
            for(int iP=0;iP<pp.length;iP++) {
                if (pp[iP]!=null) {
                    max=mini(max, pp[iP].getResidueGap(iA[iP]+(delRight?1:0)));
                }
            }
            n=-mini(-num,max);
        } else n=num;
        if (iA==null && n!=0) return false;
        final int[][] gaps=new int[pp.length][];
        /* Do insertions/deletions */
        for(int iP=0;iP<pp.length;iP++) {
            final StrapProtein p=pp[iP];
            final int nCol=p.getMaxColumn();
            final int nRes=p.countResidues();

            final int gg[]=gaps[iP]=p.getResidueGap();
            final int i1=iA[iP];
            final int iChange= delRight ?  i1+1 : i1;
            if (protect && p.getResidueColumn(iChange)>=protectN) continue;
            if (i1>=sze(gg)) continue;
            gg[iChange]=maxi(0,n+gg[iChange]);
            if (protect && /*(op!=BR && op!=BL) &&*/ protectN<nCol && protectN>p.getResidueColumn(i1)) {
                final int i2=p.column2thisOrPreviousIndex(protectN-1);
                if (0<=i2 && i2+1<mini(nRes,gg.length, n2w.length)) {
                    if (n>0) {
                        int gapBias=n;
                        final int c2=p.getResidueColumn(i2);
                        if (0<=c2 && c2<n2w.length) {
                            final int space=protectW-n2w[c2]-n;
                            for(int i=i2+2; --i>=i1 && gapBias>0;) {
                                final int g0=gg[i];
                                gg[i]=maxi(0,gg[i]- (i==i2+1?mini(space,gapBias):gapBias) );
                                gapBias-=g0-gg[i];
                            }
                        }
                    } else  gg[i2+1]-=n;
                }
            }
        }
        for(int iP=pp.length; --iP>=0;)  pp[iP].setResidueGap(gaps[iP]);
        return true;
    }
    // ---
    private final boolean rightAlign(StrapProtein prot[], int pos, StrapProtein p1, StrapProtein p2) {
        assertEDT();
        final int
            ia1=p1.column2nextIndex(pos),
            ia2=p2.column2nextIndex(pos),
            h1=p1.getResidueColumn(ia1),
            h2=p2.getResidueColumn(ia2);
        if (h1<pos || h2<pos) return false;
        if (h2>h1) return insertDelete('L',prot,p1.getResidueColumn(ia1),p2.sumUpGaps(ia2)-p1.sumUpGaps(ia1));
        else {
            final int nResidues2=p2.countResidues();
            int ia=ia2;
            while( ia<nResidues2-1 && p2.getResidueGap(ia+1)==0) ia++;
            view.setCursor(true,p2, p2.getResidueColumn(ia)+1);
        }
        return true;
    }
    // ---
    private final boolean leftAlign(StrapProtein[] prot, int pos, StrapProtein p1, StrapProtein p2) {
        assertEDT();
        final int
            ia1=p1.column2nextIndex(pos),
            ia2=p2.column2nextIndex(pos),
            h1=p1.getResidueColumn(ia1),
            h2=p2.getResidueColumn(ia2);
        if (h1<pos || h2<pos || ia2<1) return false;
        if (h1!=h2) {
            if (ia1>p1.countResidues()-2) return false;
            final int count=p1.sumUpGaps(ia1)-p2.sumUpGaps(ia2);
            for(int i=0;i<count;i++) {
                if (!insertDelete(BL,prot,p1.getResidueColumn(ia1),-1)||
                    !insertDelete('L',prot,p1.getResidueColumn(ia1+1),1)) return true;
            }
            return true;
        } else {
            int ia=ia2;
            while( ia>0 && p2.getResidueGap(ia)==0) ia--;
            if (p2.getResidueGap(ia)==0) return false;
            view.setCursor(true,p2, p2.getResidueColumn(ia)-1);
        }
        return true;
    }

}
