package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.ResidueSelection;
import java.io.*;
import java.util.*;
import javax.swing.*;
import org.biojava.bio.seq.*;
import org.biojava.bio.gui.sequence.*;
import org.biojava.bio.symbol.*;
import org.biojava.utils.*;
import org.biojava.bio.*;
import static java.lang.System.*;

public class StrapProtein2BiojavaSequence implements Sequence, org.biojava.bio.symbol.SymbolList{
				private String urn;
				public StrapProtein2BiojavaSequence(StrapProtein p) {
								String seqString="a";
								seqString=p.getGappedSequenceAsStringUC().replace(' ','-').replaceAll("[^ACDEFGHIKLMNPQRSTVWYacdefghiklmnpqrstvwy-]","*");
								try {
												sequence=ProteinTools.createGappedProteinSequence(seqString,p.getName());
							} catch(Exception e){ out.println("Caught in StrapProtein2BiojavaSequence:"); out.println(e);}
								try{ urn=p.getFile().toURL().toString(); } catch(Exception e){}
								annotationMap=new HashMap();
								if (p.getCompound()!=null) annotationMap.put("compound",p.getCompound());
								if (p.getOrganism()!=null) annotationMap.put("organism",p.getOrganism());
								if (p.getEC()!=null) annotationMap.put("ec_code",p.getEC());

								ResidueSelection ss[]=p.getAllResidueSelections();
								for(int i=0;i<ss.length;i++) {
												try{
												createFeature(new StrapResidueAnnotation2BiojavaFeature(ss[i]).getStrandedFeature());
												}catch(Exception e){out.println("caught in StrapProtein2BiojavaSequence 2:"); out.println(e);}
								}
				}
				private Annotation annotation;
				private final Map annotationMap;
				private GappedSequence sequence;
				public GappedSequence sequence() { return sequence;}
				public Annotation getAnnotation() {
								if (annotation==null) {
								annotation=new AbstractAnnotation(annotationMap){
																public boolean propertiesAllocated() { return true;}
																public Map getProperties() { return annotationMap;}
												};
								}
								return annotation;
				}
				public boolean isUnchanging(ChangeType ct){return sequence.isUnchanging(ct);}
				public void removeChangeListener(ChangeListener cl, ChangeType ct){
								sequence.removeChangeListener(cl,ct);
				}
				public void removeChangeListener(ChangeListener cl){
								sequence.removeChangeListener(cl);
				}
				public void addChangeListener(ChangeListener cl, ChangeType ct){ sequence.addChangeListener(cl,ct);}
				public void addChangeListener(ChangeListener cl){sequence.addChangeListener(cl);}
				public FeatureFilter getSchema(){ return sequence.getSchema();}
				public boolean containsFeature(Feature f){ return sequence.containsFeature(f);}
				public void removeFeature(Feature f) throws BioException, ChangeVetoException{
								sequence.removeFeature(f);
				}
				public Feature createFeature(Feature.Template ft) throws ChangeVetoException, BioException{
								return sequence.createFeature(ft);
				}
				public FeatureHolder filter(FeatureFilter ft){ return sequence.filter(ft);}
				public FeatureHolder filter(FeatureFilter ft, boolean b){return sequence.filter(ft);}
				public Iterator features(){
								return sequence.iterator();}
				public int countFeatures(){
								return sequence.countFeatures();
    }
				public void edit(Edit ed) throws ChangeVetoException, IllegalAlphabetException, IndexOutOfBoundsException{
								sequence.edit(ed);
				}
				public String subStr(int from, int to) throws IndexOutOfBoundsException{
								return sequence.subStr(from,to);
				}
				public String seqString(){return sequence.seqString();}
				public SymbolList subList(int from, int to) throws IndexOutOfBoundsException{
								return sequence.subList(from,to);
				}
				public Iterator iterator(){return sequence.iterator();}
    public List toList(){return sequence.toList();}
				public Symbol symbolAt(int idx) throws IndexOutOfBoundsException{return sequence.symbolAt(idx);}
				public int length(){return sequence.length();}
				public Alphabet getAlphabet(){ return sequence.getAlphabet();}
				//java charite.christo.strap.bioJava.StrapProtein2BiojavaSequence
				public String getName() { return sequence.getName();}
				public String getURN() { return urn;}

}
/*
 SequencePanel seqPanel=new SequencePanel();
	seqPanel.setRange(new RangeLocation(1,seq.length()+1));

in getResidueColumn()
								boolean isNotTrimmed=false;
								StrapAlign a=getStrapAlign();if (a!=null) isNotTrimmed=a.isNotTrimmed();
*/
