package charite.christo.strap;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import java.util.*;
import org.biojava.bio.seq.*;
import org.biojava.bio.symbol.*;
import org.biojava.bio.*;
public class StrapResidueAnnotation2BiojavaFeature  {
				private Location  location;
				private	StrandedFeature.Template strandedFeature;
				public StrandedFeature.Template getStrandedFeature(){ return strandedFeature;}
    private final	HashMap annotationMap=new HashMap();
				public StrapResidueAnnotation2BiojavaFeature(ResidueSelection s) {
								Location l=null;
        final boolean selectedAA[]=s.getSelectedAminoacids();
								final StrapProtein p=(StrapProtein)s.getProtein();
								final int residueColumn[]=p.getResidueColumn();
        if (selectedAA!=null) {
            final Iterator it=boolean2blockIterator(selectedAA, s.getSelectedAminoacidsOffset(),residueColumn,p.countResidues());
            while(it.hasNext()) {
                final Location lNext=(Location)it.next();
                if (l==null) l=lNext;
                else l=LocationTools.union(l,lNext);
            }
        }
								location=l;
								final Annotation annotation=new AbstractAnnotation(annotationMap){
																@Override public boolean propertiesAllocated() { return true;}
																@Override public Map getProperties() { return annotationMap;}
												};
								if (s instanceof ResidueAnnotation) {
												final ResidueAnnotation a=(ResidueAnnotation)s;
            final ResidueAnnotation.Entry[] ee=a.getEntries();
												for(int i=0;i<ee.length;i++) {
																annotationMap.put(ee[i].getKey(),ee[i].getValue());
            }
								}
								strandedFeature=new StrandedFeature.Template();
								strandedFeature.annotation=annotation;
								strandedFeature.location=location;
								strandedFeature.strand=StrandedFeature.POSITIVE;
								strandedFeature.type="";
				}
				private static Iterator boolean2blockIterator(boolean bb[],int selOffset, int[] residueColumn,int countResidues){
								final List l=new ArrayList();
								if (bb!=null && countResidues>0 && (residueColumn==null || residueColumn.length>0)) {
            for(int i=0; i<bb.length && i<countResidues-selOffset; i++) {
																if (!bb[i]) continue;
                int j=i;
                while(j<bb.length && bb[j]) j++;
                final int posI,posJ;
                if (residueColumn!=null) {
                    posI= residueColumn[Math.max(0,Math.min(residueColumn.length,i+selOffset))];
                    posJ= residueColumn[Math.max(0,Math.min(residueColumn.length,j+selOffset))];
                } else {
                    posI= Math.max(0,Math.min(countResidues,i+selOffset));
                    posJ= Math.max(0,Math.min(countResidues,j+selOffset));
                }
                l.add(new RangeLocation(posI+1, posJ));
                i=j;
            }
        }
								return l.iterator();
				}
}
