package charite.christo.strap;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.strap.interfaces.*;
import javax.swing.*;
import java.awt.event.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP
<h2>What is LaTeX - mini tutorial</h2>
WIKI:LaTeX is a widely applied  scientific type setting program.
It takes a text-file as input and creates a PDF-document (or PS).
The text-file contains LaTeX-commands which are preceded by a backslash.
When a '%' sign is in the text all characters right from this sign are ignored.
Thus comments are preceded by a  "%".
For convenience STRAP prepares  some deactivated lines which  can be activated by removing the "%".
<br>
<br>
The following shows how "hellow world" is created with LaTeX:
<ul>
  <li>First step: Type the following into a  text file
    named test.tex and save it as plain text: (!text-file not word-file)
<pre class="data"> \documentclass[pdftex,a4paper]{letter}
 \begin{document}
 hello world
 \end{document}</pre>
</li>
  <li>Second step:  Open your terminal shell. Run the following command
<pre class="terminal">
pdflatex test
</pre>
  When everything goes right, a file test.pdf is generated.
      </li>
  <li>final step: view test.pdf with ACROBAT</li>
</ul>
*/
class TexshadeGraph extends Box implements Disposable,ActionListener,IsEnabled {
    private final Object instanceVoR[]={null};
    private final ChCombo comboClass;
    private final String where;
    private ProteinCombo comboProtein;
    private ProteinList listProteins;
    private ChButton butListProteins;
    private final ChCombo comboStyle, comboColor, comboSpectrum;
    private final ChButton toggle;
    private final ChTextField tfMin, tfMax;
    /* <<<  <<< */
    /* ---------------------------------------- */
    /* >>> Constructor >>> */
   TexshadeGraph(String where,Class interfaceClass) {
       super(BoxLayout.Y_AXIS);
        this.where=where;
        this.interfaceClass=interfaceClass;
        final String save=Texshade.SAVE+where+" ";
        final boolean isBottom="bottom"==where && interfaceClass!=ValueOfResidue.class;
        final String ttMiMa="By giving a max and min value you can scale  the plot<br>Keep field blank to take entire range of values";
        tfMin=new ChTextField("auto").tt(ttMiMa).saveInFile(save+"tfMin");
        tfMax=new ChTextField("auto").tt(ttMiMa).saveInFile(save+"tfMax");
        comboStyle=new ChCombo("bar","color").li(this).s(isBottom?1:0).save(TexshadeGraph.class,"style_"+where);
        comboColor=new ChCombo("Blue","Red","Green","Brown","Black","Yellow","Orange","Pink").save(TexshadeGraph.class,"solor_"+where);
        comboSpectrum=new ChCombo("ColdHot","BlueRed","GreenRed").save(TexshadeGraph.class,"spectrum_"+where);
        toggle=toggl(null,ChButton.SHOW_HIDE).li(this).s(isBottom).save(TexshadeGraph.class,"enabled_"+where);
        comboClass=StrapAlign.classChoice(interfaceClass).li(this).classRenderer(interfaceClass).save(TexshadeGraph.class,"class_"+where);
        if (interfaceClass==ValueOfResidue.class) {
            comboProtein=new ProteinCombo(StrapAlign.getInstance(),0);
            pcp(KEY_ENABLED, this, comboProtein.li(this));
        }
        add(hB(toggle,"Where=",where,comboStyle,comboColor,comboSpectrum," min=",tfMin," max=",tfMax),"#");
        add(hB(comboProtein,butListProteins,comboClass, ChButton.actionSharedCtrl(instanceVoR),smallHelpBut(comboClass)),"#");
        enableDisable();
        replaceInstance();
        replaceProteins();
    }
    public void dispose() {
        try { ((Disposable) instanceVoR[0]).dispose(); } catch(Exception e){}
    }
    /* <<< Constructor <<< */
    /* ---------------------------------------- */
    /* >>> Replace >>> */
    private void replaceInstance() {
        try { ((Disposable)instanceVoR[0]).dispose();} catch(Exception e){}
        instanceVoR[0]=HotswapUtil.instance(comboClass,  interfaceClass, true);
        replaceProteins();
    }
    private void replaceProteins() {
        try{
            ((ValueOfResidue)instanceVoR[0]).setProtein(comboProtein.getStrapProtein());
        }catch(Exception e){}
        try{
            ((ValueOfAlignPosition)instanceVoR[0]).setProteins(listProteins.getSelectedProteins());
        }catch(Exception e){}
    }
   public final boolean isEnabled(Object p) {
       final Object o=instanceVoR[0];
       return p==null ? false : o instanceof IsEnabled ? ((IsEnabled)o).isEnabled(o) : true;
    }
    private Class interfaceClass;
    private void enableDisable() {
        final boolean b=toggle.isSelected();
        setEnabledIncludingChildren(this,b);
        toggle.setEnabled(true);
        if (comboProtein!=null) comboProtein.setEnabled(b);
        if (butListProteins!=null) butListProteins.setEnabled(b);
        if (b) {
            final boolean isBar=comboStyle.i()==0;
            comboColor.setEnabled(isBar);
            comboSpectrum.setEnabled(!isBar);
            comboSpectrum.revalidate();
        }
    }
    protected StringBuffer makeTex(StringBuffer sb, final int colFrom, final int colTo) {
        final String errorPrefix="% TexshadeGraph "+where+" "+shrtClasNam(interfaceClass);
        final StrapProtein pp[]=Texshade.proteins();
        if (!comboClass.isEnabled() ) return sb;
        if (pp==null) return sb.append(errorPrefix).append(" pp=null\n");
        final Object color=(comboColor.isEnabled() ? comboColor : comboSpectrum).getSelectedItem();
        double min=atof(tfMin,0), max=atof(tfMax,0);
        final Object vor=instanceVoR[0];
        if (vor==null) return sb.append(errorPrefix).append(" could not make  instance of ").append(comboClass).append("\n");
        final double[] values;
        int valuesFrom=0, valuesTo=0;
        String sRange=null,protNum=null;
        boolean[] takeValue=null;
        if (interfaceClass==ValueOfResidue.class) {
            final StrapProtein pVoR=comboProtein.getStrapProtein();
            if ( pVoR==null) return sb.append(errorPrefix+" p=null\n");
            ((ValueOfResidue)vor).setProtein(pVoR);
            valuesFrom=pVoR.column2nextIndex(colFrom);
            valuesTo=pVoR.column2thisOrPreviousIndex(colTo);
            values=((ValueOfResidue)vor).getValues();
            sRange=(valuesFrom+1)+".."+(valuesTo+1);
            protNum=String.valueOf(idxOf(pVoR,pp)+1);
        } else {
            final StrapProtein[] ppVoAP=listProteins!=null ? listProteins.getSelectedProteins(): Texshade.proteins();
            if (ppVoAP==null) return sb.append(errorPrefix+" ppVoAP=null\n");
            else {
                final byte gappedSeq[][]=new byte[ppVoAP.length][];
                for(int iP=ppVoAP.length; --iP>=0;) gappedSeq[iP]=ppVoAP[iP].getGappedSequences();
                ((ValueOfAlignPosition)vor).setProteins(ppVoAP);
                values=((ValueOfAlignPosition)vor).getValues();
                if (values!=null) {
                    valuesFrom=0;
                    valuesTo=values.length;
                    takeValue=new boolean[valuesTo+1];
                    int count=0;
                    for(int iC=colFrom; iC<=colTo && iC<values.length; iC++) {
                        boolean isGap=true;
                        for(int iP=ppVoAP.length; --iP>=0;) {
                            final byte c=gappedSeq[iP].length>iC ? gappedSeq[iP][iC] : 0;
                            if ('a'<=c && c<='z' || 'A'<=c && c<='Z') {
                                isGap=false;
                                break;
                            }
                        }
                        if (!isGap) { count++; takeValue[iC]=true;}
                    }
                    sRange="1.."+count;
                    protNum="consensus";
                }
            }
        }
        if (values==null) return sb.append(errorPrefix).append(" noValues \n");
        final StringBuffer sbData=new StringBuffer(999);
        boolean minAuto=Double.isNaN(min), maxAuto=Double.isNaN(max);
        if (minAuto) min=Double.MAX_VALUE;
        if (maxAuto) max=Double.MIN_VALUE;
        for(boolean write:new boolean[]{false,true}) {
            for(int i=valuesFrom; i<=valuesTo && i<values.length; i++) {
                if (takeValue!=null && (takeValue.length<=i || !takeValue[i])) continue;
                if (write) {
                    final double v=(1000*(values[i]-min)/(max-min));
                    if (Double.isNaN(v)) sbData.append("NaN\n");
                    else sbData.append((int)v).append("\n");
                } else {
                    if (minAuto && min>values[i]) min=values[i];
                    if (maxAuto && max<values[i]) max=values[i];
                }
            }
            if (min==max || Double.isNaN(min) || Double.isNaN(min)) return sb.append(errorPrefix+" min="+min+" max="+max+"\n");
        }
        final String fileName=shrtClasNam(interfaceClass)+"_"+where+".dat";
        wrte(file(Texshade.DIR+fileName),sbData);
        return sb.append("\\feature{"+where+"}{"+protNum+"}{"+sRange+"}{"+comboStyle+"[0,1000]:"+fileName+"["+color+"]}{}\n");
    }
    /* <<< make Tex <<< */
    /* ---------------------------------------- */
    /* >>> ActionListener  >>> */
    public void actionPerformed(ActionEvent ev) {
        final Object q=ev.getSource();
        if (q==comboProtein || q==listProteins) { replaceProteins();}
        if (q==comboClass) replaceInstance();
        if (q==butListProteins) {
            if (listProteins==null) {
                listProteins=new ProteinList(StrapAlign.getInstance(),0);
                listProteins.li(TexshadeGraph.this);
                listProteins.selectAll(0);
            }
            ChFrame.frame("",listProteins.scrollPane(),0).shw(0);
        }
        enableDisable();
    }
}
