package charite.christo.strap;
import charite.christo.*;
import charite.christo.protein.*;
import charite.christo.strap.interfaces.*;
import charite.christo.strap.extensions.*;
import charite.christo.interfaces.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.ref.*;
import java.util.*;
import java.net.*;
import java.io.*;
import static java.lang.System.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
import static java.awt.event.MouseEvent.*;
public class Tutorials implements  ChRunnable, ChProcessEvent {
    private Tutorials(){}
    private static ChEventAdapter li;
    private static ChEventAdapter li() { if (li==null) li=new ChEventAdapter(instance()); return li;}
    private static Tutorials inst;
    private static Tutorials instance() {
        if (inst==null) {
            inst=new Tutorials();
            HtmlDoc.setCreateComponentHook(inst);
            HtmlDoc.setButtonForClass(inst);
        }
        return inst;
    }

    private static Object li(Object o) {
        if (o instanceof AbstractButton) {
            final AbstractButton b=(AbstractButton)o;
            b.removeActionListener(li());
            b.removeMouseListener(li());
            b.addActionListener(li());
            b.addMouseListener(li());
        }
        if (o instanceof Icon) o= new JLabel(((Icon)o));
        return o;
    }

    /* --- Show which Menu --- */
    public final static ChButton TOG_openContainingMenus=toggl("Simulate menubar for menu-items in tutorials").s(true);
    private static Object objectMouseEntered;

    public AWTEvent processEvent(JComponent component, AWTEvent ev) {
      final Object q=ev.getSource();
      final int id=ev.getID();
      final StrapAlign align=StrapAlign.getInstance();
      if (id==MOUSE_ENTERED) objectMouseEntered=q;
      if (id==MOUSE_EXITED) objectMouseEntered=null;
      final String cmd=actionCommand(ev);
      if (cmd!=null) {
          StrapAlign.errorMsg("");
          if (cmd=="REPLACE_PYMOL_SCRIPT") {
              final String fn="PymolMutagenesis.py";
              final File fDest=file(fn);
              if (!fDest.exists()) cpy(rscAsStream(_CCP,fn),fDest);
              final Protein pp[]=align.getProteins();
              for(int iP=pp.length;--iP>=0;) {
                  for(ProteinViewer v:  pp[iP].getProteinViewers(Pymol.class)) v.interpret("run "+fn+"\n",(String)null,0L);
              }
          }
          if (cmd=="REPLACE_PYMOL") {
              final StrapProtein pp[]=align.getSelectedProteins();
              if (pp==null||pp.length!=1) { StrapAlign.errorMsg("Select exactly one protein which is shown in Pymol"); return null; }
              final ProteinViewer pymols[]=pp[0].getProteinViewers(Pymol.class);
              for(ProteinViewer pm : pymols) for(String s: readLines(STRAPOUT+"/replaceResidues")) pm.interpret(s,(String)null,0L);
              if (pymols.length==0)  StrapAlign.errorMsg("No Pymol process connected with protein<br> "+pp[0]);
          }
          if (cmd=="COPY_PROTEINS") {
              final StringTokenizer st=new StringTokenizer(toStrg(gcp("COPY_PROTEINS",q)));
              final UniqueList<URL> v=new UniqueList(URL.class),vGif=new UniqueList(URL.class);
              final StringBuffer sbProteinNames=new StringBuffer();
              while(st.hasMoreTokens()) {
                  final String t=st.nextToken();
                  if (t.endsWith(".gif"))  vGif.add(url(URL_STRAP_DATAFILES+"/"+t));
                  else { v.add(url(URL_STRAP_DATAFILES+"/"+t+".gz")); sbProteinNames.append(t).append(' ');}
              }
              InteractiveDownload.downloadFilesAndUnzip(v.asArray(),dirWorking());
              InteractiveDownload.downloadFilesAndUnzip(vGif.asArray(),file(DIR_ANNOTATIONS));
              align.loadTheProteinsInList(sbProteinNames, StrapAlign.OPTION_PROCESS_LOADED_PROTS|StrapAlign.OPTION_EVENT_PROTEINS_ADDED);
          }
          if (TOG_openContainingMenus.isSelected() && !UserProfile.isWebMode())
              try {
                  final AbstractButton b=(AbstractButton)ev.getSource();
                  if (UserProfile.isHidden(b)) {
                      error("The corresponding menu item is hidden in the menu according to your user profile.<br>"+
                            "This menu item will be shown if you check the check-boxes in the user profile.<br>"+
                            "The user profile can be changed  in the option menu");
                  } else if (b==objectMouseEntered)  openMenus(getEquivalentMenuButton(b,null));
              } catch(Exception e) {}
          if (chrAt(0,cmd)=='@') {
              final String[] txt=readLines(rscAsStream(_CCS,cmd.substring(1)));
              if (sze(txt)<6) {
                  if (ChMsg.yesNo("Tutorials are not included in this Web-version<br>Launch full Strap-application?:")) visitURL(URL_STRAP_JNLP, 0);
                  return null;
              }

              final StringBuffer sb=new StringBuffer(100*1000);
              join(txt,"\n",sb);
              for (String p : new String[]{_CC, _CCP, _CCS, _CCSE, "charite.christo.interfaces.", "charite.christo.strap.interfaces."}) sb.append("<i>PACKAGE:").append(p).append("</i>\n");

              if (!equls("<html>", sb,0)) {
                  sb.insert(0,"</h1>");
                  sb.insert(0, ((AbstractButton)q).getText());
                  sb.insert(0,"<h1>");
              }
              if (isCtrl(ev)) new ChFrame("").ad(new JScrollPane(new ChTextArea(sb))).shw(0);
              else {
                  final ChTextViewer tv=new ChTextViewer(sb);
                  //tv.clazz(Tutorials.class.getName());
                  final JComponent pan=tv.getPanel();
                  final JComponent tp=tv.getTextComponent();
                  StrapAlign.newDropTarget(tp,false);
                  pcp(ACTION_DATABASE_CLICKED,"Load",tp);
                  addActLi(StrapAlign.li(),tp);
                  UIupdateList.add(tp,UIupdateList.SELECTED_OBJECTS);
                  TabItemTipIcon.set(TabItemTipIcon.tab(q),"","" ,TabItemTipIcon.icn(q),  pan);
                  pcp("NO_DUPLICATES",_CCS+cmd,pan);
                  pcp(ChTabPane.KEY_SORT,"0T",pan);
                  align.addDialog(pan);
                  TabItemTipIcon.set(delSfx(".html",cmd),null,null,null,this);
              }
          }
      }
      return ev;
    }

    private static void openMenus(AbstractButton mi) {
        if (mi==null) return;
        pcp(KEY_BACKGROUND,mi.getBackground(),mi);
        mi.setBackground(Color.CYAN);
        ChDelay.afterMS(EDT,ChDelay.RESTORE_BACKGROUND,mi,5555,null);
        int delay=333;
        boolean inMenubar=false;
        final Component aa[]=getAncestors(mi);
        for(Component c:aa) if (c instanceof JMenuBar) {inMenubar=true; break;}
        for(Component c : aa) {
            if (!inMenubar && c instanceof JPopupMenu) {
                ((JPopupMenu)c).show(StrapAlign.getInstance().getFrame(),7,7);
                break;
            }
            if (c instanceof JMenu) ChDelay.afterMS(EDT,ChDelay.DOCLICK,c,delay+=99, null);
        }
    }
    // ++++++++++++++++++++++++++++++++++++++++
    public static ChButton b(String tutorial) {
        tutorial=tutorial.intern();
        final String item=
            tutorial=="BLAST_PDB" ? "Identifying protein structures for a given AA sequence" :
            tutorial=="INTRO" ? "Introduction" :
            tutorial=="ANNOTATIONS" ? "Annotated residue selections" :
            tutorial=="MUTATIONS" ? "View mutations in 3D" :
            tutorial=="ALIG_ALIGNMENTS" ? "Join two sequence alignments" :
            tutorial=="COMBINE_1D_3D" ? "Mixing sequence and structure" :
            tutorial=="TEXSHADE" ? "Highlighting Residues in Printable PDF-Output" :
            tutorial=="WOBBLEBASE" ? "Comparing nucleotide and amino acid sequence alignments" :
            tutorial=="SUPERPOSITION" ? "Superposition of proteins" :
            tutorial=="copy_DNA" ? "Copy DNA or other ligands from one Structure to another" :
            tutorial=="WIZARD_DIFFICULT" ? "Sequences that are difficult to align" :
            tutorial=="DnD" ? "Drag-and-Drop" :
            tutorial=="Test" ? "Test" :
            null,
            tab=
            tutorial=="BLAST_PDB" ? "3D" :
            tutorial=="INTRO" ? "intro" :
            tutorial=="ANNOTATIONS" ? "anno" :
            tutorial=="MUTATIONS" ? "SNP" :
            tutorial=="ALIG_ALIGNMENTS" ? "ali" :
            tutorial=="COMBINE_1D_3D" ? "1D_3D" :
            tutorial=="TEXSHADE" ? "PDF" :
            tutorial=="WOBBLEBASE" ? "nt/aa" :
            tutorial=="SUPERPOSITION" ? "superpose" :
            tutorial=="WIZARD_BLAST" ? "blast" :
            tutorial=="WIZARD_MAPPING" ? "SNP" :
            tutorial=="WIZARD_MODELING" ? "model" :
            tutorial=="WIZARD_DIFFICULT" ? "tricky" :
            tutorial;
        if (item==null && debug(RED_ERROR+"Tutorials ")) debug(tutorial+"\n");
        //final Object i=tutorial.startsWith("WIZARD") ? null : IC_TEACHING;
        final Object i=null;
        final ChButton b=new ChButton("@Tutorial_"+tutorial+".html").t(item!=null ? item:"?"+tutorial).li(li()).i(i);
        TabItemTipIcon.set(tab,"","",i,b);
        return b;
    }

    public static JComponent bExampleFiles(String id) {
        final String
            PROTEA_3D=
            "hs_EscherichiaColi.pdb a1_SaccharomycesCerevisiae.pdb  b1_SaccharomycesCerevisiae.pdb "+
            "a1_SaccharomycesCerevisiae.pdb.gif b1_SaccharomycesCerevisiae.pdb.gif hs_EscherichiaColi.pdb.gif ",
            PROTEA_HS_A2="hs_BacillusSubtilis.swiss hs_EscherichiaColi.pdb "+
            "hs_HelicobacterPylori.swiss hs_SalmonellaTyphi.swiss a2_ArabidopsisThaliana.swiss "+
            "a2_CaenorhabditisElegans.swiss a2_CarassiusAuratus.swiss a2_DrosophilaMelanogaster.swiss "+
            "a2_HomoSapiens.swiss a2_MusMusculus.swiss a2_RattusNorvegicus.swiss "+
            "a2_SaccharomycesCerevisiae.dssp a2_XenopusLaevis.swiss ",
            t="Get sample files",
            l=
            "MUT".equals(id) ? "1alm_2mys.ent  " : // betaMyosinM57965.genbank
            "INTRO".equals(id) ? PROTEA_3D :
            "13".equals(id) ? PROTEA_3D+PROTEA_HS_A2 :
            "AA".equals(id) ? PROTEA_HS_A2 :
            null;

        if (l!=null) {
            final ChButton b=new ChButton("COPY_PROTEINS").t(t).li(li());
            pcp("COPY_PROTEINS",l,b);
            return b;
        } else { assert false; return new JLabel(id); }
    }

    public Object run(String id,Object arg) {
        if (id==HtmlDoc.ID_LAST_COMPONENT) {
            JComponent last=(JComponent)arg;
            noInsets(last);
            if (last instanceof AbstractButton) {
                li((AbstractButton)last);
            }
        }

        if (id==HtmlDoc.ID_BUTTON_FOR_CLASS) {
            final Object oo[]=(Object[])arg;
            final Class c=(Class)oo[0];
            if (c==null) oo[0]=new JButton("ERROR ");
            else {
                final String cn=c.getName();
                li(oo[0]=StrapAlign.b(CLASS_DialogCopyAnnotations.equals(cn) ? cn : c));
            }
        }
        return null;
    }

}
