package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.blast.*;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import static java.lang.System.*;
/**
   This class is extended by Blaster classes that call
   Web blast services e.g. at http://www.ebi.ac.uk.
   Advantage over local blast installation: nothing needs to be installed.
   Disadvantage: it is much slower than a local BLAST installation.
   @author Christoph Gille
*/
public abstract class AbstractBlasterHTTP extends AbstractBlaster implements NeedsInternet {
    @Override public Container getControlPanel() {
        if (controlPanel==null) {
            controlPanel=ChUtils.newCNSEW(
                 log().tools().scrollPane(),
                 TabItemTipIcon.homePage(this),
                 ChUtils.pnl(butViewXml(),butViewTxt()),
                 null,null
                 );
        }
        return controlPanel;
    }
    @Override public String toString(){ return " BLAST at: "+TabItemTipIcon.homePage(this);}

}
