package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;
/**HELP
All identical residues of  aligned protein sequences are determined.
*/
public class ConsensusSequence implements StrapExtension {
    public void run() {
        final StrapProtein pp[]=((StrapAlign)align).getSelectedProteins();
        if (pp==null) return;
        final StringBuffer  sb=new StringBuffer("# selected Proteins: ").append(pp.length).append("\n");
        for(StrapProtein p:pp) sb.append(p.getName()).append("\n");
        for(int pos=0;;pos++) {
            boolean consensus=true;
            byte consAA=0;
            boolean finished=true;
            for(StrapProtein p:pp) {
                if (p.getMaxColumn()>=pos) finished=false;
                final int col=p.column2index(pos);
                if (col==-1) { consensus=false; break; }
                final byte aa= p.getResidueType(col);
                if (consAA==0) consAA=aa;
                if (aa!=consAA) { consensus=false; break; }
            }
            sb.append(consensus ? (char) consAA : '.');
            if (finished) break;
        }
        new ChTextViewer(sb).title("consensus sequence").shw(0);
    }
    private ProteinAlignment align;
    public final void handleEvent(StrapEvent ev) {
        if (align==null) { 
            align=ev.getProteinAlignment(); 
            align.removeListener(this);
        }
    }
}
