package charite.christo.strap.extensions;
import charite.christo.interfaces.*;
import charite.christo.*;
import charite.christo.protein.*;
import java.io.File;
import static charite.christo.ChUtils.*;
/**HELP
   Mafft  <i>HOME_PAGE:MultipleAlignerMafft</i>  is an  alignment program published in PUBMED:15661851
*/
public class MultipleAlignerMafft extends charite.christo.strap.AbstractSuperposition implements SequenceAlignerSorting  {
    @Override public Superimpose3D.Result computeResult(byte[][] seqs, Protein[] proteinsNotNeeded) {
        final String
            n="mafft-6.717-without-extensions",
            instScript=
            "cd "+n+"/core\n"+
            "make;\n"+
            "cp ../scripts/mafft ../../"+n+".exe\n",
            srcUrls[]={"http://align.bmr.kyushu-u.ac.jp/mafft/software/"+n+"-src.tgz"}; /* WATCH_URL */

            final AbstractExecutable e=new AbstractExecutable(n);
            setExecutable(e, srcUrls, instScript, (String[])null);
            if (!Insecure.EXEC_ALLOWED) return null;
            final File dirTmp=dirTemp(), fileOut=file(dirTmp,"output.msf");

            e.exec()
                .setCommandLineV("sh",e.fileExecutable(),mfaInFile(seqs))
                .dir(dirTmp).setOptions(ChExec.STDOUT | ChExec.STDERR | ChExec.LOG | ChExec.CYGWIN_DLL)
                .addToEnvironement("MAFFT_BINARIES="+file(e.dirBinaries()+"/"+n+"/core"))
                .run();

            return parse(e.exec().getStdoutAsByteArray(), null, Superimpose3D.PARSE_SCORE|Superimpose3D.PARSE_MSA_START_S);
    }

}
