package charite.christo.strap.extensions;
import static charite.christo.ChUtils.*;
import charite.christo.protein.*;
import charite.christo.*;
import charite.christo.strap.*;
import charite.christo.interfaces.*;
import charite.christo.strap.interfaces.*;
import java.io.File;
/**HELP

HOME: <i>HOME:MultipleAlignerMuscle</i>
<br>
Windows (cygwin):
Building the program fails
<br>
Publication: PUBMED:15318951
<br>
<b>MS_Windows:</b> To build the package successfully please change the file intmath.cpp:
Move the definition of the method log2(double) to the top and rename it e.g. to Log2 (upper case).
*/
// intmath.cpp: log2(double) => Log2(double)

public final class MultipleAlignerMuscle extends AbstractSuperposition implements SequenceAlignerSorting {
    private final static String PARAMERS[][]={
        {"-maxiters","Maximum number of iterations (integer, default 16)"},
        {"-maxhours","Maximum time to iterate in hours (default no limit)"},
        {"-maxmb","Maximum memory to allocate in Mb (default 80% of RAM)"}
    };
    public MultipleAlignerMuscle() {
        getPrgParas().defineGUI(PARAMERS, PrgParas.OPTION_FURTHER_PARAMETERS);
    }

    @Override public Superimpose3D.Result computeResult(byte[][] seqs, Protein[] proteinsNotNeeded) {
        final String
            n="muscle_40",
            patch=
            "# This patch is necessary for cygwin \n"+
            "F=$(echo muscle*/intmath.cpp)\n"+
            "mv $F $F.orig\n"+
            "sed 's/logs/Log2/g' $F.orig > $F\n",
            instScript="C_PLUS_PLUS_COMPILER *.cpp -o "+n+".exe",
            srcUrls[]={"http://www.drive5.com/muscle/downloads3.7/muscle3.7_src.tar.gz"}; /* WATCH_URL */;
        final AbstractExecutable e=new AbstractExecutable(n);
        setExecutable(e, srcUrls, instScript,(String[])null);
        if (!Insecure.EXEC_ALLOWED) return null;
        final File dirTmp=dirTemp(), fileOut=file(dirTmp,"output.fa");
        e.exec()
            .setCommandLineV(e.fileExecutable(), getPrgParas().asStringArray(PrgParas.OPTION_EQUALS_SIGN), "-in", mfaInFile(seqs), "-out", fileOut)
            .dir(dirTmp)
            .setOptions(ChExec.STDOUT | ChExec.STDERR | ChExec.CYGWIN_DLL)
            .run();
        return parse(readBytes(fileOut), null, Superimpose3D.PARSE_SCORE|Superimpose3D.PARSE_MSA_START_S);    }
}
