package charite.christo.strap.extensions;
import charite.christo.interfaces.*;
import java.awt.Container;
import java.io.File;
import static charite.christo.ChUtils.*;

/**
<b>Hompages:</b> http://www.phylosoft.org/atv/
http://www.phylogenomics.us/atv/
<b>Publication:</b> PUBMED:11301314
<b>License:</b> GNU Library or Lesser General Public License (LGPL)

Author Christian Zmasek

*/
// cmzmasek@yahoo.com
public class PhylogeneticTreeATV  implements PhylogeneticTree, HasControlPanel {
    private String names[];
    private byte[][] alignment;
    public void setNamesIconsAndGappedSequences(String[] names, javax.swing.ImageIcon icons[], byte[][] aa ){
        this.names=names;
        this.alignment=aa;
    }
    private MultipleAlignerClustalW clustalW;
    public Container getControlPanel() { return getCtrlPanel(clustalW);}

    public void drawTree(){

        final File
            fPh=(this.clustalW=new MultipleAlignerClustalW()).computePhFile(alignment, PhylogeneticTreeATVPROXY.getTreeType()),
            fPh2=file(fPh+"2");
        //putln("PhylogeneticTreeATV fPh=",fPh);
        final String[] names=this.names;
        if (sze(names)==0) { error("PhylogeneticTree: At least 3 proteins are required"); return; }
        final StringBuffer sb=new StringBuffer().append(readStrg(fPh));
        for(int i=names.length; --i>=0;) {
            final String n=PhylogeneticTreeATVPROXY.showExtensions() ?  names[i] : withoutDotSuffix(names[i]);
            rplcSb(0L,"s"+i+":",n+":",sb);
        }
        wrte(fPh2,sb);
        if (sze(fPh)==0) {
            error("PhylogeneticTreeATV: Could not compute ph-file");
            final Container ctrl=getCtrlPanel(clustalW);
            if(ctrl!=null)  charite.christo.ChFrame.frame("PhylogeneticTreeATV",ctrl,0).shw(0);
            return;
        }
        delayedRestoreLAF(2222);
        org.forester.atv.ATV.main(new String[]{fPh2.toString()});
    }
}
