package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import javax.swing.*;
import java.awt.*;
import java.io.*;
import static charite.christo.ChUtils.*;
/**HELP

Forester/ATV takes a multiple sequence alignment and displays a phylogenetic tree.
<br>
<b>Author:</b>  by Christian Zmasek.
<br>
<b>Home:</b> http://sourceforge.net/projects/forester-atv/ and http://www.phylogenomics.us/atv/
<br>
<b>Publication:</b> PUBMED:11301314
<br>
<b>License:</b> LGPL
*/
public class PhylogeneticTreeATVPROXY extends AbstractProxy implements PhylogeneticTree,HasSharedControlPanel {
    public final static String FRAME_TITLE="ATV 4.00 ALPHA 4 (03/01/2007) [input.ph2]";
    @Override public String getRequiredJars() { return " forester_400a4.jar "; }

    public void setNamesIconsAndGappedSequences(String[] nn, javax.swing.ImageIcon icons[], byte[][] aa ){
        final PhylogeneticTree pt=((PhylogeneticTree)proxyObject());
        if (pt!=null) {
            ((PhylogeneticTree)proxyObject()).setNamesIconsAndGappedSequences(nn,null,aa);
        }
    }
    public void drawTree() {
        final PhylogeneticTree pt=((PhylogeneticTree)proxyObject());
        if (pt!=null) pt.drawTree();
        return;
    }

    private static AbstractButton cbExtension;
    public static boolean showExtensions() { return cbExtension!=null ? cbExtension.isSelected() : false;}
    private static ChCombo comboTree;
    public static String getTreeType() { return comboTree!=null ? comboTree.toString() : "nj";}
    private static Container controlPanel;
    @Override public Container getSharedControlPanel() {
        if (controlPanel==null) {
            cbExtension=cbox("show file extension");
            comboTree=new ChCombo("nj","phylip","dist", "nexus");
            controlPanel=vBpnl(cbExtension,pnl("output tree ",comboTree));
        }
        return controlPanel;
    }
}
/*
  cmzmasek@yahoo.com
*/

