package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
/**HELP
   <b>Web:</b> <i>HOME_PAGE:PhylogeneticTree_TreeTop</i>
   <br>
   <b>Publication:</b> PUBMED:7578577
   @author Christoph Gille
*/
public class PhylogeneticTree_TreeTop implements PhylogeneticTree {

    private String names[];
    private byte[][] alignment;
    public void setNamesIconsAndGappedSequences(String names[], ImageIcon[] ii,  byte alignment[][] ) {this.names=names; this.alignment=alignment;  }

    public void drawTree() {
        final String[] nn=this.names;
        final byte[][] aa=this.alignment;
        if (nn==null||aa==null) return;
         int maxLen=0;
         for(String n:nn) {
             if (maxLen<n.length()) maxLen=n.length();
         }
         final StringBuffer sb=new StringBuffer(9999);
         if (!ChMsg.yesNo("The data is send to the Tree-Top page. The result will appear in Browser")) return;
         sb.append("http://www.genebee.msu.ru/cgi-bin/nph-ptree.pl??"+
                   "HOM=Yes&"+
                   "SCALE=Random&"+
                   "ALG=Both Cluster and Topological&"+
                   "START=1&"+
                   "END=99999&"+
                   "GAP=1&"+
                   "WIDTH=800&"+
                   "HEIGHT=600&"+
                   "MMFACTOR_C=8&"+
                   "MMFACTOR_T=8&"+
                   "TREETYPE=PHYLIP&"+
                   "PICTURE=SLANT&"+
                   "BOOTSRAP=NO&"+
                   "ALIGN=");
         for(int i=0; i<nn.length && i<aa.length; i++) {
             sb.append(nn[i]);
             for(int j=nn[i].length(); j<maxLen+1;j++) sb.append(' ');
             for(byte c : aa[i]) sb.append((char)c);
             sb.append('\n');
         }

         visitURL(sb, 0);
      }
}
