package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import java.awt.Container;
import java.lang.ref.*;
import static charite.christo.ChConstants.*;
import static charite.christo.ChUtils.*;
import static java.lang.System.*;
/**HELP
Web site: <i>HOME_PAGE:Toppred</i>
<br>
Publication: PUBMED:7704669
<br>
Authors: von Heijne, Claros, Deveaud and Schuerer
<br>
<i>SEE_CLASS:TransmembraneHelix_TOPPRED</i>
*/
public class ResidueHydrophobicity_TOPPRED implements ValueOfResidue,StrapListener,HasNativeExec, HasModiCount {
    static {
        TabItemTipIcon.set("hydro","hydrophobicity profile with TOPPRED",
                           "The hydrophobicity is calculated locally with the program TOPPRED",
                           iicon(IC_UMBRELLA),ResidueHydrophobicity_TOPPRED.class);
    }
    private Protein protein;
    public boolean setProtein(Protein p) {  if (protein!=p) values=null; protein=p; return true; }
    public Protein getProtein() { return protein;}
    private double[] values;
    public void handleEvent(StrapEvent ev){
        if ( (ev.getType()&StrapEvent.FLAG_RESIDUE_TYPES_CHANGED)!=0) {
            final StrapAlign align=(StrapAlign)ev.getProteinAlignment();
            align.dispatchLater(StrapEvent.VALUE_OF_RESIDUE_CHANGED,111);
        }
    }

    private String lastSequence;
    public int getModificationCount() { return modiCount;}
    private int modiCount;

    public double[] getValues() {
        if (protein==null) return null;
        final String seq=protein.getResidueTypeAsStringUC();
        if (values==null || seq!=lastSequence) {
            modiCount++;
            putln("Toppred compute");
            lastSequence=seq;
            toppred.setSequence(protein.getName().replaceAll("[^0-9A-Za-z]","_"),seq);
            toppred.compute();
            values=toppred.getHydrophobicity();
        }
        return values;
    }

    private final Toppred toppred=new Toppred();
    public AbstractExecutable getNativeExec() { return toppred;}

}
