package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.strap.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;
import charite.christo.strap.interfaces.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

The solvent accessibility of a protein is included when
a protein is loaded from a <i>DSSP_Parser</i>dssp-file.

*/
public class ResidueSolventAccessibility implements ValueOfResidue, IsEnabled, HasModiCount {
    private Protein protein;
    public boolean setProtein(Protein p) { if (protein!=p) values=null; protein=p; return true; }
    public Protein getProtein() { return protein;}
    private double[] values;
    public int getModificationCount() { return modiCount;}
    private int modiCount;

    public double[]  getValues() {
        final Protein p=this.protein;       
        final float[] ac=p!=null ? p.getResidueSolventAccessibility() : null;
        if (ac==null) return null;
        final int n=p.countResidues();
        final int mc=p.getModificationCount(ProteinModiCount.MC_SOLVENT_ACCESSIBILITY);
        if (values==null || modiCount!=mc) {
            modiCount=mc;
            double[] vv=redim(values,n,99);
            for(int i=n; --i>=0; ) vv[i]= i<ac.length ? ac[i] : Double.NaN;
            values=vv;
        }
        return values;
    }
    public boolean isEnabled(Object p) {
        return p instanceof Protein &&   ((Protein)p).getResidueSolventAccessibility()!=null;
    }
}
