package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.io.File;
import static java.lang.System.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP

<b>Publication:</b>: PMID:17392328 PMID:17094224
*/
public class SubcellularLocationSherLoc  implements PredictSubcellularLocation {

    public void setOrganism(int organism){}
    // @Override public File fileExecutable() { return file(dirBinaries()+"/SherLoc/python/sherloc_prediction.py");}

    private boolean parseOutput(ByteArray ba) {
        if (ba==null) return false;
        final int ends[]=ba.getLineEnds();
        final byte bb[]=ba.getBytes();
        if (ends.length<3) return false;
        final int from=ends[1], end=ends[2];
        Prediction[] pp=Prediction.text2prediction(bb,from,end);
        for(Prediction p : pp) {
            int pos=p.getTextPosition();
            while(pos<end && (bb[pos]<'0' || bb[pos]>'9')) pos++;
            if (pos<end) p.setScore((int)(100*atof(bb,pos)));
        }
        this.predictions=pp;
        return true;
    }

    public Prediction[] getCompartments() {
        if (predictions==null) {
            final AbstractExecutable e=new AbstractExecutable();
            e.setName("sherloc");
            final File dirBin=e.dirBinaries();
            final String
                sDir=Microsoft.toCygwinPath(dirBin+"/SherLoc"),
                svmDir=Microsoft.toCygwinPath(dirBin+"/libsvm-2.85/"),
                S="> s.sed\n",
                instScript=
                "test -d SherLoc/python_orig || mv SherLoc/python SherLoc/python_orig \n"+
                "mkdir SherLoc/python \n"+
                "echo 's|cmd = \"blastall|return result  #   cmd = \"blastall|1' "+S+
                "echo 's|/share/usr/blum/SherLoc|"+sDir+"|g' >"+S+
                "echo 's|/nfs/wsi/bs/share/opt/bin/python|/usr/bin/python|1'  >"+S+
                "echo 's|/share/usr/blum/libsvm-2.85|"+svmDir+"|g' >"+S+
                "for i in "+sDir+"/python_orig/*; do \n"+
                "  cat $i | sed -f s.sed > "+sDir+"/python/${i##*/} \n"+
                "done \n"+
                "cd libsvm-2.85; make; cd .. \n"+
                "cd SherLoc/cpp; make; cd ../.. \n";

            e.setSourcePackageURLs(URL_STRAP_SRC+"libsvm-2.85.tar.gz"+" "+URL_STRAP_SRC+"sherloc.zip.gz");
            e.setSourceInstallationScript(instScript);

            final File
                dirTmp=e.dirTemp(),
                f=file(dirTmp+"/s.fasta"),
                fileExe=file(dirBin+"/SherLoc/python/sherloc_prediction.py");
            StringBuffer sb=new StringBuffer(sequence.length+99);
            sb.append(">s\n");
            appnd(sequence,0,99999,sb);
            wrte(f,sb.append("\n"));
            final ChExec ex=e.exec();
            ex.setCommandLineV( isWindows() ?"CYGWINSH": null, "python", fileExe, f, "animal");
            ex.setOptions(ChExec.STDOUT|ChExec.STDERR|ChExec.LOG).run();
            final ByteArray ba=ex.getStdoutAsByteArray();
            parseOutput(ba);
        }
        return predictions;
    }

    private byte sequence[];
    private Prediction[] predictions;
    public void setResidueType(byte[] aa) { sequence=aa;}

}

/*
auf blast kann man auch verzichten. man verliert dadurch ein paar features.
das tool entspricht dann im wesentlichen unserer vorgangerversion MultiLoc.

phone  +49-7071-29--70462

room    torsten.blum@uni-tuebingen.de
http://www-bs2.informatik.uni-tuebingen.de/services/blum/SherLoc/
libsvm-2.85.tar.gz
sherloc.tar.gz

python python/sherloc_prediction.py test.fasta animal

*/
