package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.andrean.*;
import static charite.christo.ChUtils.*;

public class SuperimposeGoede implements Superimpose3D {
    private Protein proteinM,proteinR;

    public void setMobileProtein(Protein p){proteinM=p;}
    public void setReferenceProtein(Protein p){proteinR=p;};
    public Protein getMobileProtein(){return proteinM;}
    public Protein getReferenceProtein(){return proteinR;}
    private Result result;
    public Result getResult() { return result;}
    public void compute(){
        if (proteinR==null || proteinM==null) return;
        final Overlay ov5 = new Overlay();
        final Area ar0=new Area(), ar1=new Area();
        final double[][] aarray0=andreanArray(proteinM);
        final double[][] aarray1=andreanArray(proteinR);
        ar0.nr=1;
        ar0.first_atom=0;
        final int num0=ar0.nr_atoms=aarray0.length;
        ar0.nr_inner_atoms=0;
        ar1.nr=2;
        ar1.first_atom=0;
        final int num1=ar1.nr_atoms=aarray1.length;
        ar1.nr_inner_atoms=0;
        if (num0<4) { error("You tried to superimpose only "+num0+" atoms \nof protein "+ proteinM+"\n"); return;}
        if (num1<4) { error("You tried to superimpose only "+num1+" atoms \nof protein "+ proteinR+"\n"); return;}
        final double maxmsr=4.0;
        new SpOverlay().vergleiche_areas(
                                         ar1, aarray1,
                                         ar0, aarray0,
                                         null, null, maxmsr,new int[1],new double[1],ov5);
        result=new Result();
        final double tr[]=ov5.translation, r[][]=ov5.matrix;
        // Andrean Goede: first translation, then rotation. here: vice versa
        final Matrix3D m3d=new Matrix3D().setRotation(r);
        m3d.setTranslation(
                           -r[0][0]*tr[0] - r[0][1]*tr[1]  - r[0][2]*tr[2],
                           -r[1][0]*tr[0] - r[1][1]*tr[1]  - r[1][2]*tr[2],
                           -r[2][0]*tr[0] - r[2][1]*tr[1]  - r[2][2]*tr[2]
                           );
        result.setMatrix(m3d);

    }
    private static double[][] andreanArray(Protein p) {
        // copy my big array
        final int n=p.countResidues();
        final float cAl[]=p.getResidueCalpha(null);
        double[][] aarray=null;
        for(int l=0;l<2;l++) { // 0=count 1=copy
            int aaa=0;
            for(int i=0;i<n;i++) {
                    final int i3=3*i;
                    if (l==1) {
                        final double d[]=aarray[aaa];
                        d[0]=cAl[i3]; d[1]=cAl[i3+1]; d[2]=cAl[i3+2];}
                    aaa++;
            }
            if (l==0) aarray=new double[aaa][3];
        }
        return aarray;
    }
    public void setOptions(long optionFlags) {}
    public long getOptions() {return 0L; }

}
