package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
/**HELP

The C-alpha positions of two proteins are superimposed.  The
connectivity and the order of atoms and the type of amino acids are
not used for the superposition.
<br>
<b>Author:</b> Andrean Goede
<br>
<b>Ported from Pascal:</b>  Matthias Dunckel.

*/
public final class SuperimposeGoedePROXY extends AbstractProxy implements Superimpose3D{

    @Override public String getRequiredJars() { return "andreanOVL.jar.pack.gz";}
    public void setMobileProtein(Protein p){ Superimpose3D s=su(); if (s!=null) s.setMobileProtein(p);}
    public void setReferenceProtein(Protein p){Superimpose3D s=su(); if (s!=null) s.setReferenceProtein(p);}
    public Protein getMobileProtein(){Superimpose3D s=su(); return s!=null ?  s.getMobileProtein() : null;}
    public Protein getReferenceProtein(){Superimpose3D s=su(); return s!=null ?  s.getReferenceProtein() : null;}
    public Result getResult() { Superimpose3D s=su(); return s!=null ?  s.getResult() : null;}
    public void compute(){  Superimpose3D s=su(); if (s!=null) s.compute();}
    public Superimpose3D su() { return (Superimpose3D)proxyObject();}
    public void setOptions(long optionFlags) {}
    public long getOptions() {return 0L; }

}
