package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import static charite.christo.ChUtils.*;
import static java.lang.System.*;
/**HELP
   <b>GangstaPlus*</b>
   <br><b>Authors:</b> Aysam Guerler,  Bjoern Kolbeck,  Connie Wang, Patrick May, Thomas Steinke, Tobais Schmidt-Goenner, Group Leader:  Ernst-Walter Knapp
   <br><b>Publication:</b> PUBMED:18583523  PUBMED:17118190
   @author Christoph Gille
*/
public class Superimpose_GangstaPlus extends AbstractSuperposition implements HasScore, Superimpose3D {
    //@Override public void setOptions(long flags) {}
    {
        //  put ~/Desktop/gplus.zip -o /var/www/bioinf/strap/SourcePackages/gangstaPlus2.zip

    }

    @Override public Result computeResult(byte[][] ssNotNeeded, Protein[] proteins) {
        final String
            n="gangstaPlus2",
            instScript="c++ -O gplus.cpp -o "+n+".exe\n";
        final AbstractExecutable e=new AbstractExecutable(n);

        setExecutable(e,(String[])null,instScript, (String[])null);
        if (!Insecure.EXEC_ALLOWED) return null;

        final long writeOpts=ProteinWriter.PDB|ProteinWriter.ATOM_LINES|ProteinWriter.SIDE_CHAIN_ATOMS;

        final File fR=pdbFile(proteins[0], 0, (boolean[])null,writeOpts), fM=pdbFile(proteins[1], 1, (boolean[])null, writeOpts);
        final String mob=fM.getName(), ref=fR.getName();
        if (e.isStopped()) return null;
        e.exec().setCommandLineV( e.fileExecutable(), mob ,ref).dir(dirTemp()).setOptions(ChExec.STDOUT|ChExec.STDERR|ChExec.CYGWIN_DLL).run();
        final ByteArray txt=e.exec().getStdoutAsByteArray();
        return parse(txt,  new Result(), PARSE_MATRIX|PARSE_SCORE);
    }
    public static Result superimpose(Protein pM,Protein pR) {
        Result r=pM.hashTMalign().get(pR);
        if (r==null) {
            Superimpose_TM_align s=new Superimpose_TM_align();
            s.setMobileProtein(pM);
            s.setReferenceProtein(pR);
            CanBeStopped.vALIGNMENTS.add(s);
            s.compute();
            CanBeStopped.vALIGNMENTS.remove(s);
            r=s.getResult();
            pM.hashTMalign().put(pR,r);
        }
        return r;
    }

   /*
     aysam.guerler@googlemail.com
   */
}
