package charite.christo.strap.extensions;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
import charite.christo.*;
import charite.christo.strap.*;
import java.io.*;
import static charite.christo.ChUtils.*;
import static charite.christo.ChConstants.*;
/**HELP
Home: <i>HOME_PAGE:PairAlignerNeoBioPROXY</i>
<br>
Depending on the settings it produces local or global sequence alignments.
<br>
Written in Java
*/
public final class Superimpose_LajollaProtein extends AbstractSuperposition implements HasScore, Superimpose3D {
    @Override public Result computeResult(byte[][] ssNotNeeded, Protein[] proteins) {
        final String res;
        final File dir=dirTemp();
        if ((getOptions()&Superimpose_LajollaProteinPROXY.OPTION_PROTEIN)!=0) {
            final long writeOpts=ProteinWriter.ATOM_LINES|ProteinWriter.MET_INSTEAD_OF_MSE|ProteinWriter.PDB|ProteinWriter.SIDE_CHAIN_ATOMS;
            final File fR=pdbFile(proteins[0], 0, (boolean[])null,writeOpts), fM=pdbFile(proteins[1], 1, (boolean[])null, writeOpts);
            res=ra.lajolla.transformation.protein.ProteinMatchRunner.executeProteinSearchForSTRAP(fR.toString(), fM.toString(),10);
        } else {
            for(int iP=2; --iP>=0;) {
                int size=0;
                HeteroCompound h=null;
                final Protein p=proteins[iP];
                for(HeteroCompound h0 : p.getDnaAndRnaAndHeteros()) {
                    if (h0.isDNA()) continue;
                    if (h==null || size<h0.countAtoms()) size=(h=h0).countAtoms();
                }
                final ByteArray ba=new ByteArray(999);
                if (h==null) {
                    putln(ANSI_RED+"Error Superimpose_Lajolla "+ANSI_RESET+" No RNA in ",p);
                }
                h.toText(0L, (Matrix3D)null, ba);
                final File f=file(dir, iP==0 ? "m.pdb" : "r.pdb");
                wrte(f,ba);
            }
            res=null;
        }

        return parse(new ByteArray(res), null, PARSE_MATRIX|PARSE_SCORE);
    }
}
