package charite.christo.strap.extensions;
import charite.christo.*;
import charite.christo.interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import static charite.christo.ChUtils.*;
/**HELP
   Web site: <i>HOME_PAGE:TransmembraneHelix_TMPRED</i>
   <br>
   Author:  K Hofmann and  W Stoffel

   @author Christoph Gille
*/
public class TransmembraneHelix_TMPRED extends AbstractPredictionFromAminoacidSequence implements TransmembraneHelix_Predictor,HasControlPanel,HasSharedControlPanel,NeedsInternet {
    /* --- Control panels --- */
    private static ChTextField tfMin=new ChTextField("17").cols(6,true,true),tfMax=new ChTextField("33").cols(6,true,true);
    private static Container staticControlPanel;
    public Container getSharedControlPanel() {
        if (staticControlPanel==null) {
            staticControlPanel=
                vB(
                   hB("minimal helix lenght [14..26]",tfMin.ct(Integer.class),"#"),
                   hB("maximal helix lenght [23..41]",tfMax.ct(Integer.class),"#")
                   );
        }
        return staticControlPanel;
    }
    /* --- Computation --- */
    @Override public char[] compute(String sequ) {
        if (sequ==null) return null;
        final int n=sequ.length();
        final char pred[]=new char[n];
        final ByteArray data=getResultText(sequ, "http://www.ch.embnet.org/cgi-bin/TMPRED_form_parser",new Object[][]{
                                           {"outmode","ascii"},
                                           {"min",tfMin},
                                           {"max",tfMin},
                                           {"comm","title"},
                                           {"format","plain_text"},
                                           {"seq",sequ},
            }, false);
        if (data==null) return null;
        for(String line:splitLnes(0L,data)){
            if (line.indexOf(" ( ")<0)continue;
            final StringTokenizer st=new StringTokenizer(line);
            if (st.countTokens()<4) continue;
            final int from=atoi(st.nextToken());
            st.nextToken();
            st.nextToken();
            final int to=atoi(st.nextToken());
            if (from>0 && to<=n)
                for(int i=from-1; i<to; i++)
                    pred[i]='H';
        }
        return pred;
    }
}
