import charite.christo.interfaces.*;
import charite.christo.strap.interfaces.*;
import charite.christo.strap.*;
import charite.christo.protein.*;
import charite.christo.*;
import java.util.*;

/**
			@author Christoph Gille
 */
public class AlignmentWriterExample implements AlignmentWriter {

				private StrapProtein proteins[];
				private int firstColumn, lastColumn=Integer.MAX_VALUE, resPerLine=50;
				public void setProteins(StrapProtein... pp) { proteins=pp;}
				public void setNames(String[] names) { }
    public void setColumnRange(int first, int last){ firstColumn=first; lastColumn=last; }
    public void setCharForGapAndTerminalBlanks(char gap,char blankN, char blankC) {}
    public void setResiduesPerLine(int n) { resPerLine=n;}
    public String getFileExtension() { return "fasta";}
				public String toString() { return " toString method of Example_AlignmentWriter";}

    public void getText(long options, StringBuffer sb){
        final boolean showGaps= (options&NO_GAPS)==0;
        final StrapProtein pp[]=this.proteins;
        for(int iP=0;iP<pp.length;iP++) {
            final StrapProtein  p=pp[iP];
            if (sb!=null) sb.append('>').append(p).append('\n');
            final byte[] res=p.getGappedSequence();
            final int from=firstColumn, to=Math.min(Math.min(p.getMaxColumn(),res.length-1),lastColumn);
            int count=0;
            for(int i=from; i<to;i++) {
                final byte c=res[i];
                final boolean letter='A'<=c && c<='Z' || 'A'<=c && c<='Z';
                sb.append(letter ? (char)c : '-');
                if (++count % resPerLine ==0 && i!=to-1) sb.append('\n');
            }
            sb.append('\n');
        }
    }
}
