import charite.christo.*;
import charite.christo.interfaces.*;
import charite.christo.strap.*;
import charite.christo.strap.interfaces.*;
import charite.christo.protein.*;
import java.awt.*;
import javax.swing.*;
/**
  This class demonstrates automatic selections in Strap.
		It implements StrapListener in order to take action when the residue types change
*/
public class ResidueSelectionExample implements ResidueSelection,HasControlPanel,HasSharedControlPanel,StrapListener  {
    {
        final String
            tip="This class demonstrates how residues <br>can be selected automatically",
            tab="Ala",
            item="Selecting all alanins";
        TabItemTipIcon.set(tab,item,tip,ChConstants.IC_HAPPY,this);
    }

    private final StrapEvent event=new StrapEvent(this,StrapEvent.RESIDUE_SELECTION_CHANGED);
    public final void handleEvent(StrapEvent ev) {
        final int type=ev.getType();
        if ( (type&StrapEvent.FLAG_RESIDUE_TYPES_CHANGED)!=0)
            event.run();
    }

    private Protein p;
    public Protein getProtein() { return p;}
    public boolean setProtein(Protein prot) {p=prot; return true;}
    public void setSelectedAminoacids(boolean bb[],int offset) {}
    public int getSelectedAminoacidsOffset() { return 0;}
    public boolean[] getSelectedAminoacids() {
        if (p==null) return null;
        final byte[] aa=p.getResidueType();
        final int n=p.countResidues();
        final boolean bb[]=new boolean[n];
        for(int i=0;i<n;i++) bb[i] =  (aa[i]=='a' || aa[i]=='A');
        Protein.incrementModificationCount(ProteinModiCount.MC_RESIDUE_SELECTIONS, p);
        return bb;
    }
    public Container getControlPanel() {return new JLabel("here could be a panel with GUI controls <br>which is not necessary in this simple example");	}

    public Container getSharedControlPanel() {
        return new JLabel("Here you can add GUI-controls valid for all instances");
    }
    public String toString() { return " toString method of example ResidueSelectionExample";}
}
