package charite.christo.strap.interfaces;
import static charite.christo.ChUtils.*;
import charite.christo.interfaces.*;
import charite.christo.protein.*;
/**
   Plugin that returns a numeric value for  the protein or NaN.
   It is used for bar charts.
   It should notify changes by  dispatching  events of type
   <i>JAVADOC:StrapEvent#VALUE_OF_PROTEIN_CHANGED</i>
   and dispatching it with  <i>JAVADOC:StrapEvent#run()</i>.
*/
public interface ValueOfProtein extends  HasProtein, HasModiCount {
    double  getValue();
    /**
       When it is time consuming then do the calculation in the compute method.
       Non time intensive calculations can be performed in getValue() directly.
    */
    void compute();
   boolean setProtein(Protein p);


}
