package charite.christo.strap.interfaces;
import charite.christo.strap.*;
import charite.christo.protein.*;
import charite.christo.interfaces.*;
public interface ValueOfResidue extends HasProtein, HasModiCount {
    /**
       Plugin that returns a numeric value for each amino acid of the protein or null.
       These are plotted in the alignment pane.
       It should notify changes by  dispatching  a <i>JAVADOC:StrapEvent</i> of type
       <i>JAVADOC:StrapEvent#VALUE_OF_RESIDUE_CHANGED</i>
    */
    double[] getValues();
    boolean setProtein(Protein p);
    
    /**
       Increment value when new values are computed.
    */
}
